/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[0] = x9;
  return 0;
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return pattern34 (x3); /* [-1, 3] */
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern109 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCUNSmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern113 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern113 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1))
    return -1;
  return 0;
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 4;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern177 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return pattern180 (x1); /* [-1, 1] */
}

int
pattern186 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      return pattern194 (x5); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern192 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_IFmode)
      || GET_MODE (x1) != E_IFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  return pattern218 (x1); /* [-1, 1] */
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern232 (x3, 
i1); /* [-1, 0] */
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern193 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern193 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern243 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern243 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern243 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern243 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern243 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern243 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern243 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern243 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern243 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern243 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern244 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern244 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern245 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern245 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern245 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern245 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern245 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern245 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern245 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern245 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern245 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern245 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern282 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !rs6000_tls_symbol_ref (operands[2], i1))
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!scratch_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern329 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern336 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern352 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern352 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!base_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[2], E_QImode)
          || !fusion_gpr_mem_load (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!base_reg_operand (operands[2], E_HImode)
          || !fusion_gpr_mem_load (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!base_reg_operand (operands[2], E_SImode)
          || !fusion_gpr_mem_load (operands[3], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!base_reg_operand (operands[2], E_DImode)
          || !fusion_gpr_mem_load (operands[3], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern397 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern397 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern398 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern398 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern398 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern398 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern398 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern398 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern398 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern398 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern398 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern398 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern413 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], E_DFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_DFmode))
    return -1;
  x10 = XEXP (x5, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern437 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_XOmode
      || !fpr_reg_operand (operands[0], E_XOmode)
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern443 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern450 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || !memory_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern478 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !immediate_operand (operands[2], i1)
      || !immediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], E_V2DImode)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern508 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern521 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern538 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      return pattern547 (x1, 
SIGN_EXTEND); /* [-1, 0] */

    case ZERO_EXTEND:
      if (pattern547 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern558 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern577 (x8, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern577 (x8, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern600 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1)
      || !memory_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_DFmode
              || !cc_reg_operand (operands[0], E_CCFPmode)
              || !vsx_register_operand (operands[1], E_DFmode)
              || !vsx_register_operand (operands[2], E_DFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode)
              || !
#line 5305 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1680; /* *xscmpexpdp */

        case 151:
          if (!cc_reg_operand (operands[0], E_CCFPmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 5339 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1681; /* *xscmpexpqp */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 5339 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1682; /* *xscmpexpqp */

            default:
              return -1;
            }

        case 152:
          x7 = XEXP (x2, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !u7bit_cint_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_SFmode:
              if (!vsx_register_operand (operands[1], E_SFmode)
                  || !
#line 5452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (SFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1683; /* *xststdc_sf */

            case E_DFmode:
              if (!vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (DFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1684; /* *xststdc_df */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 5452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (KFmode) || TARGET_FLOAT128_HW)) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1685; /* *xststdc_kf */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 5452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (TFmode) || TARGET_FLOAT128_HW)) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1686; /* *xststdc_tf */

            default:
              return -1;
            }

        case 430:
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 368 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2463; /* *dfp_sgnfcnc_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 368 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2464; /* *dfp_sgnfcnc_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 342:
          switch (pattern569 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2337; /* *bcdadd_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2339; /* *bcdadd_test_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern569 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2338; /* *bcdsub_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2340; /* *bcdsub_test_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x3, 1) != 343
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!zero_constant (operands[2], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TImode:
          if (!register_operand (operands[1], E_V1TImode)
              || !
#line 4737 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2353; /* *bcdinvalid_v1ti */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 4737 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2354; /* *bcdinvalid_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LT:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern330 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 4257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 252; /* *lt0_sidi */

                case 1:
                  return 254; /* *lt0_sisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern330 (x2, 
E_DImode))
                {
                case 0:
                  if (!
#line 4257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 253; /* *lt0_didi */

                case 1:
                  if (!
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 255; /* *lt0_disi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
                return -1;
              return 1236; /* vector_ltv4sf */

            case 1:
              if (!
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
                return -1;
              return 1243; /* vector_ltv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNORDERED:
      switch (pattern11 (x2))
        {
        case 0:
          if (!
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1252; /* vector_unorderedv4sf */

        case 1:
          if (!
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1256; /* vector_unorderedv2df */

        default:
          return -1;
        }

    case EQ:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && 
#line 2159 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1381; /* vsx_eqv4sf */
          if (!altivec_register_operand (operands[0], E_V4SFmode)
              || !altivec_register_operand (operands[1], E_V4SFmode)
              || !altivec_register_operand (operands[2], E_V4SFmode)
              || !
#line 674 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1865; /* *altivec_eqv4sf */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2159 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1382; /* vsx_eqv2df */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 626 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1850; /* altivec_eqv1ti */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1851; /* altivec_eqv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1852; /* altivec_eqv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1853; /* altivec_eqv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1854; /* altivec_eqv2di */

        default:
          return -1;
        }

    case GT:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && 
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1383; /* vsx_gtv4sf */
          if (!altivec_register_operand (operands[0], E_V4SFmode)
              || !altivec_register_operand (operands[1], E_V4SFmode)
              || !altivec_register_operand (operands[2], E_V4SFmode)
              || !
#line 682 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1866; /* *altivec_gtv4sf */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1384; /* vsx_gtv2df */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1855; /* *altivec_gtv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1856; /* *altivec_gtv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1857; /* *altivec_gtv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1858; /* *altivec_gtv2di */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 650 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1859; /* *altivec_gtv1ti */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1860; /* *altivec_gtuv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1861; /* *altivec_gtuv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1862; /* *altivec_gtuv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1863; /* *altivec_gtuv2di */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 666 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1864; /* *altivec_gtuv1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !scc_comparison_operator (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (cc_reg_operand (operands[2], E_CCmode)
              && 
#line 5599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return 361; /* setbc_cc_si */
          break;

        case E_CCUNSmode:
          if (cc_reg_operand (operands[2], E_CCUNSmode)
              && 
#line 5599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return 363; /* setbc_ccuns_si */
          break;

        default:
          break;
        }
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      return 886; /* setsi_cc */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !scc_comparison_operator (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (cc_reg_operand (operands[2], E_CCmode)
              && (
#line 5599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return 362; /* setbc_cc_di */
          break;

        case E_CCUNSmode:
          if (cc_reg_operand (operands[2], E_CCUNSmode)
              && (
#line 5599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return 364; /* setbc_ccuns_di */
          break;

        default:
          break;
        }
      if (!cc_reg_operand (operands[2], E_VOIDmode)
          || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 887; /* setdi_cc */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern287 (
E_SImode))
        {
        case 0:
          if (!
#line 5608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 365; /* *setbcr_cc_si */

        case 1:
          if (!
#line 5608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 367; /* *setbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern287 (
E_DImode))
        {
        case 0:
          if (!(
#line 5608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 366; /* *setbcr_cc_di */

        case 1:
          if (!(
#line 5608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 368; /* *setbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 894; /* lesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 914; /* lesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 904; /* ledisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 924; /* ledidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V4SFmode) != 0
          || !
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return -1;
      return 1237; /* vector_lev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V2DFmode) != 0
          || !
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return -1;
      return 1244; /* vector_lev2df */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      switch (XINT (x3, 1))
        {
        case 14:
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern430 (x2, 
E_SImode) != 0
                  || !(
#line 10607 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 752; /* *tls_gd_low32 */

            case E_DImode:
              if (pattern430 (x2, 
E_DImode) != 0
                  || !(
#line 10607 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 753; /* *tls_gd_low64 */

            default:
              return -1;
            }

        case 23:
          switch (pattern289 (x2))
            {
            case 0:
              if (!(
#line 10720 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 772; /* *tls_got_dtprel_low32 */

            case 1:
              if (!(
#line 10720 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 773; /* *tls_got_dtprel_low64 */

            default:
              return -1;
            }

        case 27:
          switch (pattern289 (x2))
            {
            case 0:
              if (!(
#line 10800 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 786; /* *tls_got_tprel_low32 */

            case 1:
              if (!(
#line 10800 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 787; /* *tls_got_tprel_low64 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (XINT (x3, 1) != 15)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern379 (x2, 
E_SImode) != 0
              || !(
#line 10652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 760; /* *tls_ld_low32 */

        case E_DImode:
          if (pattern379 (x2, 
E_DImode) != 0
              || !(
#line 10652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 761; /* *tls_ld_low64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != REG
          || REGNO (x3) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 124; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 125; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          if (pattern290 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 38; /* *macchw */

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 42; /* *machhw */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern290 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1318 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 40; /* *macchwu */

            case LSHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1388 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 44; /* *machhwu */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern291 (x2, 
SIGN_EXTEND) != 0
              || !
#line 1417 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 46; /* *maclhw */

        case ZERO_EXTEND:
          if (pattern291 (x2, 
ZERO_EXTEND) != 0
              || !
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 48; /* *maclhwu */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern431 (x2, 
E_SImode) != 0
                  || !
#line 3265 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD))
                return -1;
              return 181; /* maddldsi4 */

            case E_DImode:
              if (pattern431 (x2, 
E_DImode) != 0
                  || !(
#line 3265 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 182; /* maddlddi4 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V8HImode)
                  || !
#line 1144 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 1957; /* fmav8hi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 98)
            {
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern491 (x2, 
E_SImode) == 0)
                    {
                      *pnum_clobbers = 1;
                      return 88; /* *addsi3_carry_in_internal */
                    }
                  break;

                case E_DImode:
                  if (pattern491 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    {
                      *pnum_clobbers = 1;
                      return 89; /* *adddi3_carry_in_internal */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x1, 0);
              operands[3] = x5;
              if (altivec_register_operand (operands[3], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && GET_MODE (x3) == E_V2DImode)
                {
                  x7 = XEXP (x3, 1);
                  operands[1] = x7;
                  if (altivec_register_operand (operands[1], E_V2DImode))
                    {
                      operands[2] = x4;
                      if (altivec_register_operand (operands[2], E_V2DImode)
                          && 
#line 3049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        {
                          *pnum_clobbers = 1;
                          return 3341; /* *fuse_vaddudm_vaddudm */
                        }
                    }
                }
            }
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern507 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 90; /* *addsi3_carry_in_internal2 */

                case E_DImode:
                  if (pattern507 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 91; /* *adddi3_carry_in_internal2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x4, 0) != -1L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern508 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 94; /* addsi3_carry_in_m1 */

                case E_DImode:
                  if (pattern508 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 95; /* adddi3_carry_in_m1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern492 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 118; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern492 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 119; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern432 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 120; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern432 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 121; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern459 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 122; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern459 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 123; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ASHIFT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
            return -1;
          return 262; /* *rotlsi3_insert_3_plus */

        case 1:
          if (!(
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 264; /* *rotldi3_insert_3_plus */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x13 = XVECEXP (x10, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (pattern4 (x2) != 0
          || !
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1635; /* vsx_reduc_plus_v2df */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 102
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!vfloat_operand (operands[1], E_V4SFmode)
          || !
#line 4949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1638; /* vsx_reduc_plus_v4sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 100 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2489; /* crypto_vsbox_v16qi */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 100 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2490; /* crypto_vsbox_v2di */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      switch (pattern340 (x3, 
E_V1TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1665; /* xsxsigqp_kf_v1ti */

        case 1:
          if (!(
#line 5219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1666; /* xsxsigqp_tf_v1ti */

        default:
          return -1;
        }

    case E_TImode:
      switch (pattern340 (x3, 
E_TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1667; /* xsxsigqp_kf_ti */

        case 1:
          if (!(
#line 5219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1668; /* xsxsigqp_tf_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_1_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2491; /* crypto_vshasigmaw */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2492; /* crypto_vshasigmad */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 11:
      switch (pattern129 (x1))
        {
        case 0:
          if (!(
#line 177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 3; /* load_macho_picbase_si */

        case 1:
          if (!(
#line 177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 4; /* load_macho_picbase_di */

        default:
          return -1;
        }

    case 12:
      switch (pattern129 (x1))
        {
        case 0:
          if (!(
#line 193 "../../gcc-15.0.1-20250313/gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 5; /* reload_macho_picbase_si */

        case 1:
          if (!(
#line 193 "../../gcc-15.0.1-20250313/gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 6; /* reload_macho_picbase_di */

        default:
          return -1;
        }

    case 90:
      if (pattern130 (x1) != 0
          || !
#line 2556 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_64BIT))
        return -1;
      return 143; /* cfuged */

    case 91:
      if (pattern130 (x1) != 0
          || !
#line 2565 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 144; /* cntlzdm */

    case 92:
      if (pattern130 (x1) != 0
          || !
#line 2574 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 145; /* cnttzdm */

    case 93:
      if (pattern131 (x1) != 0
          || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 146; /* pdepd */

    case 94:
      if (pattern131 (x1) != 0
          || !
#line 2592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 147; /* pextd */

    case 51:
      return recog_60 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 5535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 349; /* fmaxsf3 */

        case 1:
          if (!
#line 5535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 351; /* fmaxdf3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 5535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 350; /* fminsf3 */

        case 1:
          if (!
#line 5535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 352; /* fmindf3 */

        default:
          return -1;
        }

    case 4:
      return recog_59 (x1, insn, pnum_clobbers);

    case 59:
      return recog_42 (x1, insn, pnum_clobbers);

    case 63:
      return recog_32 (x1, insn, pnum_clobbers);

    case 14:
      return recog_37 (x1, insn, pnum_clobbers);

    case 20:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 762; /* tls_dtprel_32 */

        case 1:
          if (!(
#line 10660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 763; /* tls_dtprel_64 */

        default:
          return -1;
        }

    case 21:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10672 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 764; /* tls_dtprel_ha_32 */

        case 1:
          if (!(
#line 10672 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 765; /* tls_dtprel_ha_64 */

        default:
          return -1;
        }

    case 22:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10680 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 766; /* tls_dtprel_lo_32 */

        case 1:
          if (!(
#line 10680 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 767; /* tls_dtprel_lo_64 */

        default:
          return -1;
        }

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 768; /* tls_got_dtprel_32 */

        case 1:
          if (!(
#line 10688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 769; /* tls_got_dtprel_64 */

        default:
          return -1;
        }

    case 24:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 774; /* tls_tprel_32 */

        case 1:
          if (!(
#line 10728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 775; /* tls_tprel_64 */

        default:
          return -1;
        }

    case 25:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10740 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 776; /* tls_tprel_ha_32 */

        case 1:
          if (!(
#line 10740 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 777; /* tls_tprel_ha_64 */

        default:
          return -1;
        }

    case 26:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10748 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 778; /* tls_tprel_lo_32 */

        case 1:
          if (!(
#line 10748 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 779; /* tls_tprel_lo_64 */

        default:
          return -1;
        }

    case 27:
      return recog_38 (x1, insn, pnum_clobbers);

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 788; /* tls_tls_pcrel_32 */

        case 1:
          if (!(
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 789; /* tls_tls_pcrel_64 */

        default:
          return -1;
        }

    case 28:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 10816 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 790; /* tls_tls_32 */

        case 1:
          if (!(
#line 10816 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 791; /* tls_tls_64 */

        default:
          return -1;
        }

    case 18:
      return recog_58 (x1, insn, pnum_clobbers);

    case 70:
      return recog_50 (x1, insn, pnum_clobbers);

    case 71:
      return recog_41 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1183; /* addkf3_odd */

        case 1:
          if (!(
#line 15489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1184; /* addtf3_odd */

        default:
          return -1;
        }

    case 79:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15500 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1185; /* subkf3_odd */

        case 1:
          if (!(
#line 15500 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1186; /* subtf3_odd */

        default:
          return -1;
        }

    case 80:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1187; /* mulkf3_odd */

        case 1:
          if (!(
#line 15511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1188; /* multf3_odd */

        default:
          return -1;
        }

    case 81:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 15522 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1189; /* divkf3_odd */

        case 1:
          if (!(
#line 15522 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1190; /* divtf3_odd */

        default:
          return -1;
        }

    case 75:
      if (pattern136 (x1) != 0
          || !
#line 15691 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1207; /* *cmprb_internal */

    case 76:
      if (pattern136 (x1) != 0
          || !
#line 15778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1210; /* *cmprb2_internal */

    case 77:
      return recog_57 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1340; /* vsx_mul_v2di */

    case 130:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1343; /* vsx_div_v2di */

    case 131:
      if (pattern137 (x1, 
E_V2DImode) != 0
          || !
#line 1830 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1344; /* vsx_udiv_v2di */

    case 132:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1345; /* vsx_div_v1ti */

    case 133:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1346; /* vsx_udiv_v1ti */

    case 134:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1347; /* vsx_dives_v1ti */

    case 135:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1914 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1348; /* vsx_diveu_v1ti */

    case 136:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1349; /* vsx_mods_v1ti */

    case 137:
      if (pattern137 (x1, 
E_V1TImode) != 0
          || !
#line 1932 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1350; /* vsx_modu_v1ti */

    case 121:
      return recog_40 (x1, insn, pnum_clobbers);

    case 104:
      return recog_56 (x1, insn, pnum_clobbers);

    case 188:
      return recog_35 (x1, insn, pnum_clobbers);

    case 144:
      return recog_55 (x1, insn, pnum_clobbers);

    case 145:
      return recog_33 (x1, insn, pnum_clobbers);

    case 128:
      return recog_45 (x1, insn, pnum_clobbers);

    case 129:
      return recog_44 (x1, insn, pnum_clobbers);

    case 149:
      return recog_34 (x1, insn, pnum_clobbers);

    case 148:
      return recog_48 (x1, insn, pnum_clobbers);

    case 157:
      return recog_54 (x1, insn, pnum_clobbers);

    case 158:
      return recog_43 (x1, insn, pnum_clobbers);

    case 177:
      if (pattern138 (x1, 
E_V16QImode) != 0
          || !
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1706; /* vcmpnezb */

    case 179:
      if (pattern138 (x1, 
E_V8HImode) != 0
          || !
#line 5923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1709; /* vcmpnezh */

    case 181:
      if (pattern138 (x1, 
E_V4SImode) != 0
          || !
#line 5943 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1711; /* vcmpnezw */

    case 182:
      return recog_53 (x1, insn, pnum_clobbers);

    case 200:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 6497 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1758; /* dives_v2di */

        case 1:
          if (!
#line 6497 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1759; /* dives_v4si */

        default:
          return -1;
        }

    case 201:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 6507 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1760; /* diveu_v2di */

        case 1:
          if (!
#line 6507 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1761; /* diveu_v4si */

        default:
          return -1;
        }

    case 218:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1824; /* altivec_vaddcuw */

    case 248:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1836; /* altivec_vsubcuw */

    case 219:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 600 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1843; /* uavgv4si3_ceil */

        case 1:
          if (!
#line 600 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1844; /* uavgv8hi3_ceil */

        case 2:
          if (!
#line 600 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1845; /* uavgv16qi3_ceil */

        default:
          return -1;
        }

    case 220:
      switch (pattern142 (x1))
        {
        case 0:
          if (!
#line 609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1846; /* avgv4si3_ceil */

        case 1:
          if (!
#line 609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1847; /* avgv8hi3_ceil */

        case 2:
          if (!
#line 609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1848; /* avgv16qi3_ceil */

        default:
          return -1;
        }

    case 209:
      if (pattern143 (x1, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 618 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1849; /* altivec_vcmpbfp */

    case 331:
      switch (pattern144 (x1))
        {
        case 0:
          if (!
#line 1535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1980; /* p8_vmrgew_v4sf_direct */

        case 1:
          if (!
#line 1535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1981; /* p8_vmrgew_v4si_direct */

        default:
          return -1;
        }

    case 332:
      switch (pattern144 (x1))
        {
        case 0:
          if (!
#line 1544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1982; /* p8_vmrgow_v4sf_direct */

        case 1:
          if (!
#line 1544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1983; /* p8_vmrgow_v4si_direct */

        default:
          return -1;
        }

    case 221:
      if (pattern145 (x1) != 0
          || !
#line 1761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1984; /* altivec_vmuleub */

    case 229:
      if (pattern145 (x1) != 0
          || !
#line 1770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1985; /* altivec_vmuloub */

    case 222:
      if (pattern145 (x1) != 0
          || !
#line 1779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1986; /* altivec_vmulesb */

    case 230:
      if (pattern145 (x1) != 0
          || !
#line 1788 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1987; /* altivec_vmulosb */

    case 223:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1988; /* altivec_vmuleuh */

    case 231:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1989; /* altivec_vmulouh */

    case 224:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1990; /* altivec_vmulesh */

    case 232:
      if (pattern143 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1991; /* altivec_vmulosh */

    case 225:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1992; /* altivec_vmuleuw */

    case 227:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1842 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1993; /* altivec_vmuleud */

    case 233:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1994; /* altivec_vmulouw */

    case 235:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1860 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1995; /* altivec_vmuloud */

    case 226:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1996; /* altivec_vmulesw */

    case 228:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1997; /* altivec_vmulesd */

    case 234:
      if (pattern143 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1998; /* altivec_vmulosw */

    case 236:
      if (pattern143 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1999; /* altivec_vmulosd */

    case 237:
      if (pattern143 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 1906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2000; /* altivec_vpkpx */

    case 238:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2001; /* altivec_vpksdss */

        case 1:
          if (!
#line 1920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2002; /* altivec_vpkswss */

        case 2:
          if (!
#line 1920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2003; /* altivec_vpkshss */

        default:
          return -1;
        }

    case 239:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1934 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2004; /* altivec_vpksdus */

        case 1:
          if (!
#line 1934 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2005; /* altivec_vpkswus */

        case 2:
          if (!
#line 1934 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2006; /* altivec_vpkshus */

        default:
          return -1;
        }

    case 240:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1948 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2007; /* altivec_vpkudus */

        case 1:
          if (!
#line 1948 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2008; /* altivec_vpkuwus */

        case 2:
          if (!
#line 1948 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2009; /* altivec_vpkuhus */

        default:
          return -1;
        }

    case 241:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1962 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2010; /* altivec_vpkudum */

        case 1:
          if (!
#line 1962 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2011; /* altivec_vpkuwum */

        case 2:
          if (!
#line 1962 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2012; /* altivec_vpkuhum */

        default:
          return -1;
        }

    case 242:
      switch (pattern147 (x1))
        {
        case 0:
          if (!
#line 1976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2013; /* altivec_vpkudum_direct */

        case 1:
          if (!
#line 1976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2014; /* altivec_vpkuwum_direct */

        case 2:
          if (!
#line 1976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2015; /* altivec_vpkuhum_direct */

        default:
          return -1;
        }

    case 347:
      return recog_49 (x1, insn, pnum_clobbers);

    case 244:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2079 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2027; /* altivec_vsl */

    case 245:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2088 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2028; /* altivec_vslo */

    case 309:
      if (pattern148 (x1, 
E_V16QImode) != 0
          || !
#line 2097 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2029; /* vslv */

    case 310:
      if (pattern148 (x1, 
E_V16QImode) != 0
          || !
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2030; /* vsrv */

    case 246:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2166 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2048; /* altivec_vsr */

    case 247:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 2175 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2049; /* altivec_vsro */

    case 330:
      return recog_36 (x1, insn, pnum_clobbers);

    case 257:
      if (pattern149 (x1) != 0
          || !
#line 2598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2108; /* altivec_vcfux */

    case 258:
      if (pattern149 (x1) != 0
          || !
#line 2607 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2109; /* altivec_vcfsx */

    case 334:
      if (pattern140 (x1, 
E_V1TImode) != 0
          || !
#line 4442 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2323; /* altivec_vaddcuq */

    case 337:
      if (pattern140 (x1, 
E_V1TImode) != 0
          || !
#line 4459 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2325; /* altivec_vsubcuq */

    case 340:
      return recog_47 (x1, insn, pnum_clobbers);

    case 341:
      if (pattern148 (x1, 
E_V2DImode) != 0
          || !
#line 4529 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2332; /* altivec_vbpermd */

    case 348:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4636 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2345; /* vcfuged */

    case 349:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4645 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2346; /* vclzdm */

    case 350:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4654 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2347; /* vctzdm */

    case 352:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4663 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2348; /* vpdepd */

    case 353:
      if (pattern138 (x1, 
E_V2DImode) != 0
          || !
#line 4672 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2349; /* vpextd */

    case 354:
      if (pattern150 (x1) != 0
          || !
#line 4690 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2351; /* vclrlb */

    case 355:
      if (pattern150 (x1) != 0
          || !
#line 4704 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2352; /* vclrrb */

    case 361:
      return recog_52 (x1, insn, pnum_clobbers);

    case 362:
      return recog_51 (x1, insn, pnum_clobbers);

    case 416:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2365; /* mma_xvi4ger8 */

    case 418:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2366; /* mma_xvi8ger4 */

    case 412:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2367; /* mma_xvi16ger2 */

    case 414:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2368; /* mma_xvi16ger2s */

    case 397:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2369; /* mma_xvf16ger2 */

    case 392:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2370; /* mma_xvbf16ger2 */

    case 402:
      if (pattern151 (x1, 
E_V16QImode) != 0
          || !
#line 530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2371; /* mma_xvf32ger */

    case 407:
      if (pattern151 (x1, 
E_OOmode) != 0
          || !
#line 549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2389; /* mma_xvf64ger */

    case 425:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_0_to_3_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern382 (x2))
        {
        case 0:
          if (!
#line 284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2454; /* dfp_ddedpd_dd */

        case 1:
          if (!
#line 284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2455; /* dfp_ddedpd_td */

        default:
          return -1;
        }

    case 426:
      return recog_39 (x1, insn, pnum_clobbers);

    case 427:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern382 (x2))
        {
        case 0:
          if (!
#line 335 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2461; /* dfp_diex_dd */

        case 1:
          if (!
#line 335 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2462; /* dfp_diex_td */

        default:
          return -1;
        }

    case 429:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2465; /* dfp_dscli_dd */

        case 1:
          if (!
#line 385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2466; /* dfp_dscli_td */

        default:
          return -1;
        }

    case 431:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 395 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2467; /* dfp_dscri_dd */

        case 1:
          if (!
#line 395 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2468; /* dfp_dscri_td */

        default:
          return -1;
        }

    case 433:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2473; /* crypto_vcipher_v16qi */

        case 1:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2477; /* crypto_vcipher_v2di */

        default:
          return -1;
        }

    case 434:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2474; /* crypto_vncipher_v16qi */

        case 1:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2478; /* crypto_vncipher_v2di */

        default:
          return -1;
        }

    case 435:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2475; /* crypto_vcipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2479; /* crypto_vcipherlast_v2di */

        default:
          return -1;
        }

    case 436:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2476; /* crypto_vncipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2480; /* crypto_vncipherlast_v2di */

        default:
          return -1;
        }

    case 440:
      return recog_46 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 11:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 6526 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 461; /* rs6000_mffscrn */

            case CONST_INT:
              if (!const_0_to_3_operand (operands[1], E_SImode)
                  || !
#line 6534 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 462; /* rs6000_mffscrni */

            default:
              return -1;
            }

        case 6:
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern216 (x2))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && 
#line 14589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
                {
                  *pnum_clobbers = 2;
                  return 1061; /* rs6000_get_timebase_ppc32 */
                }
              if (!
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 1063; /* rs6000_mftb_di */

            case 1:
              return 1062; /* rs6000_mftb_si */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14645 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1064; /* rs6000_mffsl_hw */

        case 9:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1065; /* rs6000_mffs */

        case 7:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 15638 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 1205; /* darnsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 15638 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 1206; /* darndi */

            default:
              return -1;
            }

        case 95:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!simple_offsettable_mem_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!int_reg_operand (operands[1], E_DImode)
              || !
#line 15845 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
            return -1;
          return 1212; /* hashst */

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!int_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode)
                  || !
#line 273 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1224; /* load_lockedqi */

            case E_HImode:
              if (!int_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode)
                  || !
#line 274 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1225; /* load_lockedhi */

            case E_SImode:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!memory_operand (operands[1], E_SImode))
                    return -1;
                  return 1226; /* load_lockedsi */

                case E_QImode:
                  if (!memory_operand (operands[1], E_QImode)
                      || !
#line 290 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1228; /* load_lockedqi_si */

                case E_HImode:
                  if (!memory_operand (operands[1], E_HImode)
                      || !
#line 290 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1229; /* load_lockedhi_si */

                default:
                  return -1;
                }

            case E_DImode:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 276 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1227; /* load_lockeddi */

            case E_PTImode:
              if (!quad_int_reg_operand (operands[0], E_PTImode)
                  || GET_MODE (x2) != E_PTImode
                  || !indexed_or_indirect_operand (operands[1], E_TImode)
                  || !
#line 334 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])
   && quad_int_reg_operand (operands[0], PTImode)))
                return -1;
              return 1230; /* load_lockedpti */

            default:
              return -1;
            }

        case 22:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 109
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V4SImode)
              || !
#line 2938 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2159; /* altivec_mtvscr */

        case 23:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 109
              || GET_MODE (x4) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_V8HImode)
              || !
#line 2945 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2160; /* altivec_mfvscr */

        case 27:
          if (GET_MODE (x2) != E_XOmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!fpr_reg_operand (operands[0], E_XOmode)
              || !
#line 521 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2364; /* mma_xxsetaccz */

        case 38:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!u10bit_cint_operand (operands[1], E_VOIDmode))
            return -1;
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 272 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2505; /* htm_mfspr_si */

            case 1:
              if (!(
#line 272 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2506; /* htm_mfspr_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x2, 1))
        {
        case 19:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern377 (x2, 
E_SImode) != 0
                  || !(
#line 11390 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 813; /* *pltseq_plt16_lo_si */

            case E_DImode:
              if (pattern377 (x2, 
E_DImode) != 0
                  || !(
#line 11390 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 814; /* *pltseq_plt16_lo_di */

            default:
              return -1;
            }

        case 20:
          switch (pattern337 (x2))
            {
            case 0:
              if (!(
#line 11413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 817; /* *pltseq_plt_pcrelsi */

            case 1:
              if (!(
#line 11413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 818; /* *pltseq_plt_pcreldi */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern378 (x2, 
E_SImode) != 0
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 870; /* probe_stack_rangesi */

            case E_DImode:
              if (pattern378 (x2, 
E_DImode) != 0
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 871; /* probe_stack_rangedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern29 (x1) != 0
          || !
#line 455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)))
        return -1;
      return 2360; /* *mma_assemble_acc */

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 5278 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return 330; /* *truncdfsf2_fpr */
      if (pnum_clobbers == NULL
          || !vsx_register_operand (operands[0], E_SFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1129; /* trunckfsf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1130; /* trunctfsf2_hw */

        default:
          return -1;
        }

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_IFmode:
              if (gpc_reg_operand (operands[1], E_IFmode))
                {
                  if ((
#line 8978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 615; /* truncifdf2_internal1 */
                  if ((
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 617; /* truncifdf2_internal2 */
                }
              break;

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode))
                {
                  if ((
#line 8978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 616; /* trunctfdf2_internal1 */
                  if ((
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 618; /* trunctfdf2_internal2 */
                }
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15244 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1127; /* trunckfdf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15244 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1128; /* trunctfdf2_hw */

        default:
          return -1;
        }

    case E_SDmode:
      if (!gpc_reg_operand (operands[0], E_SDmode)
          || GET_MODE (x3) != E_SDmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DDmode:
          if (!gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 80 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2426; /* truncddsd2 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2435; /* trunctdsd2 */

        default:
          return -1;
        }

    case E_DDmode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 154 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      *pnum_clobbers = 1;
      return 2434; /* trunctddd2 */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 87:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_SFmode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_V4SFmode)
          || !
#line 7832 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      return 569; /* movsi_from_sf */

    case 86:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_SFmode))
        {
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (input_operand (operands[1], E_SImode)
              && 
#line 8385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
            return 586; /* movsf_from_si */
        }
      x6 = XVECEXP (x3, 0, 0);
      if (!lowpart_subreg_operator (x6, E_SImode))
        return -1;
      switch (pattern495 (x6))
        {
        case 0:
          if (!
#line 8452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
            return -1;
          return 587; /* movsf_from_si2_ashiftrt */

        case 1:
          if (!
#line 8452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
            return -1;
          return 588; /* movsf_from_si2_lshiftrt */

        default:
          return -1;
        }

    case 30:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !(
#line 9049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return -1;
          return 619; /* fix_trunc_helperif */

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !(
#line 9049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
            return -1;
          return 620; /* fix_trunc_helpertf */

        default:
          return -1;
        }

    case 61:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern468 (x3, 
E_DImode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 649; /* reload_fpr_from_gprdi */

        case E_DFmode:
          if (pattern468 (x3, 
E_DFmode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 650; /* reload_fpr_from_gprdf */

        case E_DDmode:
          if (pattern468 (x3, 
E_DDmode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 651; /* reload_fpr_from_gprdd */

        case E_TImode:
          if (pattern468 (x3, 
E_TImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 663; /* reload_vsx_from_gprti */

        case E_V16QImode:
          if (pattern468 (x3, 
E_V16QImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 664; /* reload_vsx_from_gprv16qi */

        case E_V8HImode:
          if (pattern468 (x3, 
E_V8HImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 665; /* reload_vsx_from_gprv8hi */

        case E_V4SImode:
          if (pattern468 (x3, 
E_V4SImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 666; /* reload_vsx_from_gprv4si */

        case E_V4SFmode:
          if (pattern468 (x3, 
E_V4SFmode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 667; /* reload_vsx_from_gprv4sf */

        case E_V2DImode:
          if (pattern468 (x3, 
E_V2DImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 668; /* reload_vsx_from_gprv2di */

        case E_V2DFmode:
          if (pattern468 (x3, 
E_V2DFmode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 669; /* reload_vsx_from_gprv2df */

        case E_V1TImode:
          if (pattern468 (x3, 
E_V1TImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 670; /* reload_vsx_from_gprv1ti */

        case E_KFmode:
          if (pattern468 (x3, 
E_KFmode, 
E_IFmode) != 0
              || !(
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 671; /* reload_vsx_from_gprkf */

        case E_TFmode:
          if (pattern468 (x3, 
E_TFmode, 
E_IFmode) != 0
              || !(
#line 9634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 672; /* reload_vsx_from_gprtf */

        case E_SFmode:
          if (pattern468 (x3, 
E_SFmode, 
E_DImode) != 0
              || !
#line 9688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 674; /* reload_vsx_from_gprsf */

        default:
          return -1;
        }

    case 64:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern469 (x3, 
E_TImode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 685; /* reload_gpr_from_vsxti */

        case E_V16QImode:
          if (pattern469 (x3, 
E_V16QImode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 686; /* reload_gpr_from_vsxv16qi */

        case E_V8HImode:
          if (pattern469 (x3, 
E_V8HImode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 687; /* reload_gpr_from_vsxv8hi */

        case E_V4SImode:
          if (pattern469 (x3, 
E_V4SImode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 688; /* reload_gpr_from_vsxv4si */

        case E_V4SFmode:
          if (pattern469 (x3, 
E_V4SFmode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 689; /* reload_gpr_from_vsxv4sf */

        case E_V2DImode:
          if (pattern469 (x3, 
E_V2DImode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 690; /* reload_gpr_from_vsxv2di */

        case E_V2DFmode:
          if (pattern469 (x3, 
E_V2DFmode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 691; /* reload_gpr_from_vsxv2df */

        case E_V1TImode:
          if (pattern469 (x3, 
E_V1TImode) != 0
              || !
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 692; /* reload_gpr_from_vsxv1ti */

        case E_KFmode:
          if (pattern469 (x3, 
E_KFmode) != 0
              || !(
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 693; /* reload_gpr_from_vsxkf */

        case E_TFmode:
          if (pattern469 (x3, 
E_TFmode) != 0
              || !(
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 694; /* reload_gpr_from_vsxtf */

        case E_SFmode:
          if (pattern468 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 9752 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 695; /* reload_gpr_from_vsxsf */

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x3, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern296 (x1, 
2, 
USE))
        {
        case 0:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x4, 0);
          if (GET_MODE (x7) != E_SImode
              || !
#line 11097 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && TARGET_32BIT))
            return -1;
          return 794; /* load_toc_aix_si */

        case 1:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x4, 0);
          if (GET_MODE (x7) != E_DImode
              || !
#line 11115 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && TARGET_64BIT))
            return -1;
          return 795; /* load_toc_aix_di */

        default:
          return -1;
        }

    case 34:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern496 (x3, 
E_SImode) != 0
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 872; /* stack_protect_setsi */

        case E_DImode:
          if (pattern496 (x3, 
E_DImode) != 0
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 873; /* stack_protect_setdi */

        default:
          return -1;
        }

    case 101:
      if (GET_MODE (x3) != E_CCmode
          || pattern186 (x1, 
SET, 
E_CCmode) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x6))
        {
        case EQ:
          switch (pattern514 (x1, 
EQ))
            {
            case 0:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2190 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1387; /* *vsx_eq_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2893 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2155; /* *altivec_vcmpeqfp_p */

            case 1:
              x8 = XEXP (x4, 1);
              if (pattern584 (x8) != 0
                  || !
#line 2190 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1388; /* *vsx_eq_v2df_p */

            case 2:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V4SImode) != 0
                  || !
#line 2809 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2140; /* altivec_vcmpequw_p */

            case 3:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V8HImode) != 0
                  || !
#line 2809 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2141; /* altivec_vcmpequh_p */

            case 4:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V16QImode) != 0
                  || !
#line 2809 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2142; /* altivec_vcmpequb_p */

            case 5:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V2DImode) != 0
                  || !
#line 2809 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2143; /* altivec_vcmpequd_p */

            case 6:
              if (!altivec_register_operand (operands[1], E_V1TImode)
                  || !altivec_register_operand (operands[2], E_V1TImode)
                  || !altivec_register_operand (operands[0], E_V1TImode))
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V1TImode
                  || !
#line 2821 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2144; /* altivec_vcmpequt_p */

            default:
              return -1;
            }

        case GT:
          switch (pattern514 (x1, 
GT))
            {
            case 0:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1389; /* *vsx_gt_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2156; /* *altivec_vcmpgtfp_p */

            case 1:
              x8 = XEXP (x4, 1);
              if (pattern584 (x8) != 0
                  || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1390; /* *vsx_gt_v2df_p */

            case 2:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V4SImode) != 0
                  || !
#line 2845 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2145; /* *altivec_vcmpgtsw_p */

            case 3:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V8HImode) != 0
                  || !
#line 2845 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2146; /* *altivec_vcmpgtsh_p */

            case 4:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V16QImode) != 0
                  || !
#line 2845 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2147; /* *altivec_vcmpgtsb_p */

            case 5:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V2DImode) != 0
                  || !
#line 2845 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2148; /* *altivec_vcmpgtsd_p */

            case 6:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V1TImode) != 0
                  || !
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2149; /* *altivec_vcmpgtst_p */

            default:
              return -1;
            }

        case GE:
          if (pattern515 (x1, 
GE) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2255 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1392; /* *vsx_ge_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2917 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2157; /* *altivec_vcmpgefp_p */

            case E_V2DFmode:
              x8 = XEXP (x4, 1);
              if (pattern584 (x8) != 0
                  || !
#line 2255 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1393; /* *vsx_ge_v2df_p */

            default:
              return -1;
            }

        case NE:
          if (pattern515 (x1, 
NE) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              x8 = XEXP (x4, 1);
              if (pattern586 (x8, 
E_V16QImode) != 0
                  || !
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1695; /* *vsx_ne_v16qi_p */

            case E_V8HImode:
              x8 = XEXP (x4, 1);
              if (pattern586 (x8, 
E_V8HImode) != 0
                  || !
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1696; /* *vsx_ne_v8hi_p */

            case E_V4SImode:
              x8 = XEXP (x4, 1);
              if (pattern586 (x8, 
E_V4SImode) != 0
                  || !
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1697; /* *vsx_ne_v4si_p */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 103)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 103)
            return -1;
          x9 = XVECEXP (x6, 0, 0);
          operands[1] = x9;
          x10 = XVECEXP (x6, 0, 1);
          operands[2] = x10;
          x11 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XVECEXP (x8, 0, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_V4SImode:
              if (pattern594 (x8, 
E_V4SImode) != 0
                  || !
#line 5532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1698; /* *vector_nez_v4si_p */

            case E_V8HImode:
              if (pattern594 (x8, 
E_V8HImode) != 0
                  || !
#line 5532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1699; /* *vector_nez_v8hi_p */

            case E_V16QImode:
              if (pattern594 (x8, 
E_V16QImode) != 0
                  || !
#line 5532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1700; /* *vector_nez_v16qi_p */

            default:
              return -1;
            }

        case GTU:
          if (pattern515 (x1, 
GTU) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V4SImode) != 0
                  || !
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2150; /* *altivec_vcmpgtuw_p */

            case E_V8HImode:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V8HImode) != 0
                  || !
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2151; /* *altivec_vcmpgtuh_p */

            case E_V16QImode:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V16QImode) != 0
                  || !
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2152; /* *altivec_vcmpgtub_p */

            case E_V2DImode:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V2DImode) != 0
                  || !
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2153; /* *altivec_vcmpgtud_p */

            case E_V1TImode:
              x8 = XEXP (x4, 1);
              if (pattern585 (x8, 
E_V1TImode) != 0
                  || !
#line 2881 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2154; /* *altivec_vcmpgtut_p */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 356:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 937 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1922; /* vstrir_p_direct_v8hi */

        case 1:
          if (!
#line 937 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1923; /* vstrir_p_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1926; /* vstril_p_direct_v8hi */

        case 1:
          if (!
#line 989 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1927; /* vstril_p_direct_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 12:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6542 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
            return -1;
          return 463; /* rs6000_mffscdrn */

        case 2:
          if (GET_MODE (x3) != E_CCmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!memory_operand (operands[1], E_QImode)
                  || !int_reg_operand (operands[2], E_QImode)
                  || !
#line 273 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1231; /* store_conditionalqi */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !int_reg_operand (operands[2], E_HImode)
                  || !
#line 274 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1232; /* store_conditionalhi */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !int_reg_operand (operands[2], E_SImode))
                return -1;
              return 1233; /* store_conditionalsi */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !int_reg_operand (operands[2], E_DImode)
                  || !
#line 276 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1234; /* store_conditionaldi */

            case E_PTImode:
              if (!indexed_or_indirect_operand (operands[1], E_PTImode)
                  || !quad_int_reg_operand (operands[2], E_PTImode)
                  || !
#line 398 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI && quad_int_reg_operand (operands[2], PTImode)))
                return -1;
              return 1235; /* store_conditionalpti */

            default:
              return -1;
            }

        case 28:
          if (pattern255 (x1) != 0
              || !base_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[2])
              || !
#line 73 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2493; /* *tabort */

        case 31:
          if (pattern256 (x1) != 0
              || !
#line 144 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2498; /* *tbegin */

        case 32:
          if (pattern257 (x1) != 0
              || !
#line 163 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2499; /* *tcheck */

        case 33:
          if (pattern256 (x1) != 0
              || !
#line 184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2500; /* *tend */

        case 34:
          if (pattern257 (x1) != 0
              || !
#line 203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2501; /* *trechkpt */

        case 35:
          if (pattern255 (x1) != 0
              || !gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[2])
              || !
#line 224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2502; /* *treclaim */

        case 36:
          if (pattern256 (x1) != 0
              || !
#line 245 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2503; /* *tsr */

        case 37:
          if (pattern257 (x1) != 0
              || !
#line 264 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2504; /* *ttest */

        default:
          return -1;
        }

    case 3:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern197 (x5, 
441, 
1) != 0)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[0] = x4;
      if (!u5bit_cint_operand (operands[0], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[1] = x10;
      x11 = XVECEXP (x3, 0, 2);
      operands[2] = x11;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x9 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 29:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 98 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2494; /* *tabortwc */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[2], E_DImode)
                  || !(
#line 98 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2495; /* *tabortdc */

            default:
              return -1;
            }

        case 30:
          if (!s5bit_cint_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !
#line 123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2496; /* *tabortwci */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !(
#line 123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2497; /* *tabortdci */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
    case GE:
    case GT:
      operands[1] = x4;
      if (fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern300 (x1))
            {
            case 0:
              if (
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 381; /* *movsfsfcc_p9 */
              break;

            case 1:
              if (
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 383; /* *movsfdfcc_p9 */
              break;

            case 2:
              if (
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 382; /* *movdfsfcc_p9 */
              break;

            case 3:
              if (
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 384; /* *movdfdfcc_p9 */
              break;

            case 4:
              if ((
#line 5770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 393; /* *movkfcc_p10 */
              break;

            case 5:
              if ((
#line 5770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 394; /* *movtfcc_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern254 (x1, 
EQ))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 2;
          return 990; /* bdz_si */

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 992; /* bdz_di */

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      if (invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern300 (x1))
            {
            case 0:
              if (
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 385; /* *movsfsfcc_invert_p9 */
              break;

            case 1:
              if (
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 387; /* *movsfdfcc_invert_p9 */
              break;

            case 2:
              if (
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 386; /* *movdfsfcc_invert_p9 */
              break;

            case 3:
              if (
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 388; /* *movdfdfcc_invert_p9 */
              break;

            case 4:
              if ((
#line 5802 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 395; /* *movkfcc_invert_p10 */
              break;

            case 5:
              if ((
#line 5802 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 396; /* *movtfcc_invert_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern254 (x1, 
NE))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 2;
          return 991; /* bdnz_si */

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 993; /* bdnz_di */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (!branch_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC
          || pattern415 (x1) != 0)
        return -1;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x11, 0);
      operands[2] = x12;
      x13 = XEXP (x4, 0);
      switch (GET_CODE (x13))
        {
        case EQ:
          switch (pattern588 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 994; /* bdztf_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 996; /* bdztf_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern588 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 995; /* bdnztf_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 997; /* bdnztf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case UNSIGNED_FLOAT:
          if (pattern200 (x1, 
USE, 
E_DFmode) != 0
              || pattern411 (x1) != 0
              || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)))
            return -1;
          return 416; /* *floatunssidf2_internal */

        case FIX:
          if (pattern200 (x1, 
CLOBBER, 
E_SImode) != 0)
            return -1;
          switch (pattern412 (x1))
            {
            case 0:
              if (!(
#line 9097 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 621; /* *fix_truncifsi2_internal */

            case 1:
              if (!(
#line 9097 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 622; /* *fix_trunctfsi2_internal */

            default:
              return -1;
            }

        case CALL:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || pattern258 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 1);
          x15 = XVECEXP (x14, 0, 0);
          operands[5] = x15;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (pattern600 (x1, 
E_SImode) != 0
                  || !(
#line 11749 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 841; /* *call_value_indirect_aixsi */

            case E_DImode:
              if (pattern600 (x1, 
E_DImode) != 0
                  || !(
#line 11749 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 842; /* *call_value_indirect_aixdi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != AND)
            return -1;
          x16 = XEXP (x5, 1);
          if (!branch_comparison_operator (x16, E_VOIDmode))
            return -1;
          operands[3] = x16;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern116 (x1) != 0)
            return -1;
          x18 = XEXP (x16, 0);
          operands[4] = x18;
          if (!cc_reg_operand (operands[4], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          x19 = XEXP (x8, 0);
          operands[0] = x19;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[5] = x12;
          x13 = XVECEXP (x1, 0, 3);
          x20 = XEXP (x13, 0);
          operands[6] = x20;
          if (!scratch_operand (operands[6], E_CCmode))
            return -1;
          x21 = XEXP (x2, 0);
          operands[7] = x21;
          if (!scratch_operand (operands[7], E_CCEQmode))
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              switch (pattern604 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 994; /* bdztf_si */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 996; /* bdztf_di */

                default:
                  return -1;
                }

            case NE:
              switch (pattern604 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 995; /* bdnztf_si */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 997; /* bdnztf_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode
          || pattern258 (x1) != 0)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      operands[3] = x12;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XVECEXP (x14, 0, 0);
      operands[4] = x15;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern595 (x1, 
E_SImode) != 0
              || !(
#line 11728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 839; /* *call_indirect_aixsi */

        case E_DImode:
          if (pattern595 (x1, 
E_DImode) != 0
              || !(
#line 11728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 840; /* *call_indirect_aixdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          switch (pattern179 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && (
#line 3705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_70 (insn, operands);
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 3785 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3794 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_74 (insn, operands);
              if (!(
#line 3859 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3864 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_80 (insn, operands);

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && ((
#line 3705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_71 (insn, operands);
              if (!const_int_operand (operands[2], E_DImode))
                return NULL;
              if (((
#line 3785 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3794 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_75 (insn, operands);
              if (!((
#line 3859 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3864 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != AND)
            return NULL;
          switch (pattern183 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && (
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_72 (insn, operands);
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3823 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_76 (insn, operands);
              if (!(
#line 3882 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_82 (insn, operands);

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && ((
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_73 (insn, operands);
              if (!const_int_operand (operands[2], E_DImode))
                return NULL;
              if (((
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3823 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_77 (insn, operands);
              if (!((
#line 3882 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      switch (pattern513 (x1))
        {
        case 0:
          if (!(
#line 4198 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && 
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_101 (insn, operands);

        case 1:
          if (!((
#line 4198 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_102 (insn, operands);

        case 2:
          if (!(
#line 4230 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && 
#line 4238 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_103 (insn, operands);

        case 3:
          if (!((
#line 4230 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4238 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_200 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_204 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return NULL;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_508 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_514 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_202 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_206 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return NULL;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_510 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_516 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern478 ())
            {
            case 0:
              if ((
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_212 (insn, operands);
              break;

            case 1:
              if ((
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_218 (insn, operands);
              break;

            case 2:
              if (((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_512 (insn, operands);
              break;

            case 3:
              if (((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_518 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return NULL;
      switch (pattern477 (
E_DImode))
        {
        case 0:
          if (!(
#line 6467 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 1:
          if (!(
#line 6467 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_220 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern263 (x2))
        {
        case 0:
          return gen_split_85 (insn, operands);

        case 1:
          if (!
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (!const_int_operand (x5, E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern206 (x2, 
E_SImode) != 0
                  || !
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return NULL;
              return gen_split_110 (insn, operands);

            case E_DImode:
              if (pattern206 (x2, 
E_DImode) != 0
                  || !(
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_113 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          operands[3] = x5;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern545 (x2, 
E_SImode) != 0
                  || !
#line 4422 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
                return NULL;
              return gen_split_115 (insn, operands);

            case E_DImode:
              if (pattern545 (x2, 
E_DImode) != 0
                  || !(
#line 4422 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_116 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          operands[2] = x5;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern432 (x2, 
E_DImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4504 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_121 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4504 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_122 (insn, operands);

                case E_SImode:
                  if (!memory_operand (operands[3], E_SImode)
                      || !
#line 4504 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 32))
                    return NULL;
                  return gen_split_123 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              if (pattern432 (x2, 
E_SImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_127 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_128 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ASHIFT)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern546 (x2, 
E_SImode) != 0
              || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_DImode:
          if (pattern546 (x2, 
E_DImode) != 0
              || !(
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_118 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_prefixed_constant (operands[1], E_SFmode)
          && 
#line 8750 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_310 (insn, operands);
      break;

    case E_DFmode:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_prefixed_constant (operands[1], E_DFmode)
          && 
#line 8750 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_311 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if (((
#line 8807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8812 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_312 (insn, operands);
          if (((
#line 8843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8850 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_316 (insn, operands);
          if (((
#line 8861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 8865 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_319 (insn, operands);
          if ((
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TFmode)
       || int_reg_operand (operands[1], TFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TFmode)
           && !vsx_register_operand (operands[1], TFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_364 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_540 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_585 (insn, operands);
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode))
        {
          if ((
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_589 (insn, operands);
          if ((
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_593 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_TFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_TFmode)
          && (
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_701 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_TFmode)
          && (
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_711 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_TFmode)
          || !(
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return NULL;
      return gen_split_721 (insn, operands);

    case E_IFmode:
      if (!nonimmediate_operand (operands[0], E_IFmode)
          || !input_operand (operands[1], E_IFmode))
        return NULL;
      if (((
#line 8807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8812 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_313 (insn, operands);
      if (((
#line 8843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8850 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_317 (insn, operands);
      if (!((
#line 8861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8865 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_320 (insn, operands);

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !input_operand (operands[1], E_TDmode))
        return NULL;
      if (((
#line 8807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8812 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_314 (insn, operands);
      if ((
#line 8826 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 8830 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_315 (insn, operands);
      if (((
#line 8843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8850 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_318 (insn, operands);
      if (!((
#line 8861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8865 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_321 (insn, operands);

    case E_TImode:
      return split_12 (x1, insn);

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V16QImode)
       || int_reg_operand (operands[1], V16QImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V16QImode)
           && !vsx_register_operand (operands[1], V16QImode)))))
            return gen_split_356 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_531 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V16QImode)
          && indexed_or_indirect_operand (operands[1], E_V16QImode)
          && (
#line 601 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_569 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V16QImode)
          && vsx_register_operand (operands[1], E_V16QImode))
        {
          if (
#line 901 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_580 (insn, operands);
          if (
#line 959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_581 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V16QImode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_694 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V16QImode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_704 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V16QImode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_714 (insn, operands);

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V8HImode)
       || int_reg_operand (operands[1], V8HImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V8HImode)
           && !vsx_register_operand (operands[1], V8HImode)))))
            return gen_split_357 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_532 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V8HImode)
          && indexed_or_indirect_operand (operands[1], E_V8HImode)
          && (
#line 547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_568 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V8HImode)
          || !vsx_register_operand (operands[1], E_V8HImode))
        return NULL;
      if (
#line 816 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_578 (insn, operands);
      if (!
#line 866 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_579 (insn, operands);

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SImode)
       || int_reg_operand (operands[1], V4SImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SImode)
           && !vsx_register_operand (operands[1], V4SImode)))))
            return gen_split_358 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_533 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SImode)
          && indexed_or_indirect_operand (operands[1], E_V4SImode)
          && (
#line 497 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_567 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V4SImode)
          || !vsx_register_operand (operands[1], E_V4SImode))
        return NULL;
      if (
#line 741 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_575 (insn, operands);
      if (!
#line 787 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_577 (insn, operands);

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SFmode)
       || int_reg_operand (operands[1], V4SFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SFmode)
           && !vsx_register_operand (operands[1], V4SFmode)))))
            return gen_split_359 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_535 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && indexed_or_indirect_operand (operands[1], E_V4SFmode)
          && (
#line 497 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_566 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode))
        {
          if (
#line 741 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_574 (insn, operands);
          if (
#line 787 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_576 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V4SFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V4SFmode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_695 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SFmode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_705 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SFmode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_715 (insn, operands);

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DImode)
       || int_reg_operand (operands[1], V2DImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DImode)
           && !vsx_register_operand (operands[1], V2DImode)))))
            return gen_split_360 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_534 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DImode)
          && indexed_or_indirect_operand (operands[1], E_V2DImode)
          && (
#line 449 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_565 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V2DImode)
          || !vsx_register_operand (operands[1], E_V2DImode))
        return NULL;
      if (
#line 671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_571 (insn, operands);
      if (!
#line 715 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_573 (insn, operands);

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DFmode)
       || int_reg_operand (operands[1], V2DFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DFmode)
           && !vsx_register_operand (operands[1], V2DFmode)))))
            return gen_split_361 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_536 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DFmode)
          && indexed_or_indirect_operand (operands[1], E_V2DFmode)
          && (
#line 449 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_564 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
          && vsx_register_operand (operands[1], E_V2DFmode))
        {
          if (
#line 671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_570 (insn, operands);
          if (
#line 715 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_572 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V2DFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V2DFmode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_696 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DFmode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_706 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DFmode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_716 (insn, operands);

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V1TImode)
       || int_reg_operand (operands[1], V1TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V1TImode)
           && !vsx_register_operand (operands[1], V1TImode)))))
            return gen_split_362 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_537 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return gen_split_587 (insn, operands);
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode))
        {
          if (
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_591 (insn, operands);
          if (
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_595 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V1TImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V1TImode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_698 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V1TImode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_708 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V1TImode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_718 (insn, operands);

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 9660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], KFmode)
       || int_reg_operand (operands[1], KFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], KFmode)
           && !vsx_register_operand (operands[1], KFmode)))) && 
#line 560 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_363 (insn, operands);
          if (
#line 171 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_539 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_584 (insn, operands);
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode))
        {
          if ((
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_588 (insn, operands);
          if ((
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_592 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_KFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_KFmode)
          && (
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_700 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_KFmode)
          && (
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_710 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_KFmode)
          || !(
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return NULL;
      return gen_split_720 (insn, operands);

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode)
          && 
#line 9856 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return gen_split_378 (insn, operands);
      if (int_reg_operand (operands[0], E_DImode)
          && const_int_operand (operands[1], E_DImode))
        {
          if (
#line 9957 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && num_insns_constant (operands[1], DImode) > 1
   && !IN_RANGE (INTVAL (operands[1]), -0x80000000, 0xffffffff)
   && rs6000_is_valid_and_mask (operands[1], DImode)))
            return gen_split_381 (insn, operands);
          if (
#line 9975 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[1], DImode) > 1))
            return gen_split_382 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_DImode)
          || !s5bit_cint_operand (operands[1], E_DImode)
          || !
#line 9987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && reload_completed))
        return NULL;
      return gen_split_383 (insn, operands);

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !input_operand (operands[1], E_DFmode)
          || !
#line 9856 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_379 (insn, operands);

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !input_operand (operands[1], E_DDmode)
          || !
#line 9856 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_380 (insn, operands);

    case E_PTImode:
      if (!nonimmediate_operand (operands[0], E_PTImode)
          || !input_operand (operands[1], E_PTImode)
          || !
#line 10090 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return NULL;
      return gen_split_391 (insn, operands);

    case E_OOmode:
      if (!nonimmediate_operand (operands[0], E_OOmode)
          || !input_operand (operands[1], E_OOmode)
          || !(
#line 298 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))) && 
#line 305 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
( reload_completed
   && (!MEM_P (operands[0]) && !MEM_P (operands[1])))))
        return NULL;
      return gen_split_738 (insn, operands);

    case E_XOmode:
      if (!nonimmediate_operand (operands[0], E_XOmode)
          || !input_operand (operands[1], E_XOmode)
          || !(
#line 345 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))) && 
#line 352 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_739 (insn, operands);

    default:
      return NULL;
    }
}
