/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) != 0L
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      return pattern9 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern11 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern11 (x3); /* [-1, 1] */
}

int
pattern24 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern39 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern39 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern60 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern60 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern61 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern61 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern61 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern61 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern61 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern61 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern61 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern61 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern61 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern61 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x5) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[2], E_DImode))
                return -1;
              return 0;

            case E_DImode:
              return 1;

            default:
              return -1;
            }

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x5) != E_DFmode
              || !scratch_operand (operands[2], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              return 2;

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_KFmode:
          res = pattern71 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern71 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          res = pattern73 (x5, 
E_SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_DFmode:
          res = pattern73 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case VEC_SELECT:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 16; /* [16, 27] */
      return -1;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return pattern109 (); /* [-1, 1] */
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return pattern111 (x1); /* [-1, 3] */
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[0]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern132 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern132 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!c32bit_cint_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!altivec_register_operand (operands[2], E_V8HImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[3], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!altivec_register_operand (operands[2], E_V4SImode))
            return -1;
          return 4;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[3], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DImode:
          if (!altivec_register_operand (operands[2], E_V2DImode))
            return -1;
          return 6;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 0;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 1;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[0], E_SImode))
                    return -1;
                  return 2;

                case E_DImode:
                  if (!scratch_operand (operands[0], E_DImode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 4;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 5;

            case E_HImode:
              res = pattern187 (
E_HImode);
              if (res >= 0)
                return res + 6; /* [6, 7] */
              return -1;

            case E_QImode:
              res = pattern187 (
E_QImode);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_CCmode:
              if (!cc_reg_operand (operands[2], E_CCmode)
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_m1_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 10;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_m1_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            case E_CCUNSmode:
              if (!cc_reg_operand (operands[2], E_CCUNSmode)
                  || GET_MODE (x3) != E_CCUNSmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_0_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 12;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_0_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 13;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 14;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              res = pattern188 (x9);
              if (res >= 0)
                return res + 15; /* [15, 16] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 17;

            case E_HImode:
              res = pattern189 (x9, 
E_HImode);
              if (res >= 0)
                return res + 18; /* [18, 19] */
              return -1;

            case E_QImode:
              res = pattern189 (x9, 
E_QImode);
              if (res >= 0)
                return res + 20; /* [20, 21] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (!gpc_reg_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_SImode
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x5, 1);
  operands[4] = x9;
  x10 = XEXP (x5, 2);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[6] = x11;
  if (!scratch_operand (operands[6], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern298 (x5, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern298 (x5, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_KFmode:
      if (pattern299 (x5, 
E_KFmode) != 0)
        return -1;
      return 4;

    case E_TFmode:
      if (pattern299 (x5, 
E_TFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern316 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || pattern374 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern382 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !gpc_reg_operand (operands[2], E_DDmode))
        return -1;
      return 0;

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !gpc_reg_operand (operands[2], E_TDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern394 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern393 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern393 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern413 (x1) != 0)
    return -1;
  return 0;
}

int
pattern429 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern427 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern427 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern428 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern428 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern428 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern428 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern428 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern428 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern428 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern428 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern428 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern428 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern448 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern455 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern461 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern476 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern485 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern488 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern500 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!memory_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!memory_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!memory_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!memory_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!memory_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!memory_operand (operands[0], E_KFmode)
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!memory_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern527 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern534 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V16QImode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern537 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern549 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern569 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern583 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode)
          || !scratch_operand (operands[0], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || !scratch_operand (operands[0], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1)
      || !memory_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern603 (x9, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern603 (x9, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case AND:
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!
#line 3906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 2;
      return 223; /* *branch_anddi3_dot */

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[0] = x11;
      if (!
#line 7954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 572; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (branch_comparison_operator (operands[0], E_VOIDmode))
    {
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (fpmask_comparison_operator (operands[1], E_CCFPmode))
    {
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != PC
      || !branch_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[0] = x9;
  return 966; /* *cbranch */
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !gpc_reg_operand (operands[1], E_SImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_SImode)
                  && 
#line 3642 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 1;
                  return 199; /* andsi3_imm */
                }
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3773 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], SImode)))
                return 211; /* andsi3_mask */
              if (!
#line 3840 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 217; /* *andsi3_2insn */

            case E_DImode:
              if (!gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_DImode)
                  && (
#line 3642 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 1;
                  return 200; /* anddi3_imm */
                }
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3773 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 212; /* anddi3_mask */
              if (!(
#line 3840 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 218; /* *anddi3_2insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern369 (x2, 
E_TImode) != 0)
                return -1;
              return 507; /* *andti3_internal */

            case E_PTImode:
              if (pattern369 (x2, 
E_PTImode) != 0)
                return -1;
              return 508; /* *andpti3_internal */

            case E_V16QImode:
              if (pattern369 (x2, 
E_V16QImode) != 0
                  || !
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 509; /* *andv16qi3_internal */

            case E_V8HImode:
              if (pattern369 (x2, 
E_V8HImode) != 0
                  || !
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 510; /* *andv8hi3_internal */

            case E_V4SImode:
              if (pattern369 (x2, 
E_V4SImode) != 0
                  || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 511; /* *andv4si3_internal */

            case E_V4SFmode:
              if (pattern369 (x2, 
E_V4SFmode) != 0
                  || !
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 512; /* *andv4sf3_internal */

            case E_V2DImode:
              if (pattern369 (x2, 
E_V2DImode) != 0
                  || !
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 513; /* *andv2di3_internal */

            case E_V2DFmode:
              if (pattern369 (x2, 
E_V2DFmode) != 0
                  || !
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 514; /* *andv2df3_internal */

            case E_V1TImode:
              if (pattern369 (x2, 
E_V1TImode) != 0
                  || !
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 515; /* *andv1ti3_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern457 (x2, 
E_SImode) != 0
              || !
#line 4182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 246; /* *rotlsi3_mask */

        case E_DImode:
          if (pattern457 (x2, 
E_DImode) != 0
              || !(
#line 4182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 247; /* *rotldi3_mask */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != -16L)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (pattern261 (x2))
            {
            case 0:
              if (!(
#line 9532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 641; /* *vec_reload_and_plus_si */

            case 1:
              if (!(
#line 9532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 642; /* *vec_reload_and_plus_di */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          switch (pattern42 (x2))
            {
            case 0:
              if (!
#line 511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2547; /* *fuse_add_and */

            case 1:
              if (!(
#line 511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2548; /* *fuse_add_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_16 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_15 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern64 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 421 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2537; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2538; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2729; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2730; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2731; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2732; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2733; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2734; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2735; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2736; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2737; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2738; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2557; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2558; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2809; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2810; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2811; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2812; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2813; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2814; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2815; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2816; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2817; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2818; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2543; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2544; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2759; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2760; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2761; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2762; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2763; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2764; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2765; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2766; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2767; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2768; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2563; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2564; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2839; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2840; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2841; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2842; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2843; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2844; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2845; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2846; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2847; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2848; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2541; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2542; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2749; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2750; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2751; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2752; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2753; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2754; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2755; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2756; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2757; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2758; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2561; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2562; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2829; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2830; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2831; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2832; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2833; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2834; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2835; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2836; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2837; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2838; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern65 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2545; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2546; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2769; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2770; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2771; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2772; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2773; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2774; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2775; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2776; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2777; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2778; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2565; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2566; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2849; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2850; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2851; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2852; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2853; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2854; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2855; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2856; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2857; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2858; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 529 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2549; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2550; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !
#line 9556 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 643; /* p8_fmrgow_di */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9556 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 644; /* p8_fmrgow_df */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !
#line 9556 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 645; /* p8_fmrgow_dd */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2024; /* altivec_vrldnm */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2025; /* altivec_vrlwnm */

    case E_V1TImode:
      if (pattern132 (x3, 
E_V1TImode) != 0
          || !
#line 2069 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2026; /* altivec_vrlqnm_inst */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_SFmode)
      || !
#line 3232 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
    return -1;
  return 1463; /* vsx_concat_v2sf */
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1753; /* vec_expand_v16qi */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1754; /* vec_expand_v8hi */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1755; /* vec_expand_v4si */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1756; /* vec_expand_v2di */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1757; /* vec_expand_v1ti */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (nonimmediate_operand (operands[0], E_SFmode))
    {
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (input_operand (operands[1], E_SImode)
          && 
#line 8385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
        {
          *pnum_clobbers = 1;
          return 586; /* movsf_from_si */
        }
    }
  if (!gpc_reg_operand (operands[0], E_SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  if (!lowpart_subreg_operator (x4, E_SImode))
    return -1;
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 587; /* movsf_from_si2_ashiftrt */

    case LSHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 588; /* movsf_from_si2_lshiftrt */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2065 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1370; /* *vsx_tsqrtdf2_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2065 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1371; /* *vsx_tsqrtv4sf2_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2065 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1372; /* *vsx_tsqrtv2df2_internal */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1428; /* vsx_xscvdpspn */

    case E_SFmode:
      if (!vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2471 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1430; /* vsx_xscvdpspn_scalar */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern378 (x3, 
E_V4SImode) != 0
          || !
#line 6700 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1780; /* xxblend_v4si */

    case E_V8HImode:
      if (pattern378 (x3, 
E_V8HImode) != 0
          || !
#line 6700 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1781; /* xxblend_v8hi */

    case E_V16QImode:
      if (pattern378 (x3, 
E_V16QImode) != 0
          || !
#line 6700 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1782; /* xxblend_v16qi */

    case E_V4SFmode:
      if (pattern378 (x3, 
E_V4SFmode) != 0
          || !
#line 6700 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1783; /* xxblend_v4sf */

    case E_V2DFmode:
      if (pattern378 (x3, 
E_V2DFmode) != 0
          || !
#line 6700 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1784; /* xxblend_v2df */

    case E_V2DImode:
      if (pattern435 (x3) != 0
          || !
#line 6700 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1785; /* xxblend_v2di */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 82:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern461 (x2, 
E_KFmode) != 0
                  || !(
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1193; /* fmakf4_odd */

            case E_TFmode:
              if (pattern461 (x2, 
E_TFmode) != 0
                  || !(
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1194; /* fmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern462 (x2, 
E_KFmode) != 0
                  || !(
#line 15557 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1195; /* *fmskf4_odd */

            case E_TFmode:
              if (pattern462 (x2, 
E_TFmode) != 0
                  || !(
#line 15557 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1196; /* *fmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 194:
      switch (pattern163 (x1))
        {
        case 0:
          if (!
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1537; /* vextractlv16qi_internal */

        case 1:
          if (!
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1538; /* vextractlv8hi_internal */

        case 2:
          if (!
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1539; /* vextractlv4si_internal */

        case 3:
          if (!
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1540; /* vextractlv2di_internal */

        default:
          return -1;
        }

    case 195:
      switch (pattern163 (x1))
        {
        case 0:
          if (!
#line 4271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1541; /* vextractrv16qi_internal */

        case 1:
          if (!
#line 4271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1542; /* vextractrv8hi_internal */

        case 2:
          if (!
#line 4271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1543; /* vextractrv4si_internal */

        case 3:
          if (!
#line 4271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1544; /* vextractrv2di_internal */

        default:
          return -1;
        }

    case 196:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1545; /* vinsertvl_internal_v16qi */

        case 1:
          if (!
#line 4352 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1553; /* vinsertgl_internal_v16qi */

        case 2:
          if (!
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1546; /* vinsertvl_internal_v8hi */

        case 3:
          if (!
#line 4352 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1554; /* vinsertgl_internal_v8hi */

        case 4:
          if (!
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1547; /* vinsertvl_internal_v4si */

        case 5:
          if (!
#line 4352 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1555; /* vinsertgl_internal_v4si */

        case 6:
          if (!
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1548; /* vinsertvl_internal_v2di */

        case 7:
          if (!
#line 4352 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1556; /* vinsertgl_internal_v2di */

        default:
          return -1;
        }

    case 197:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 4325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1549; /* vinsertvr_internal_v16qi */

        case 1:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1557; /* vinsertgr_internal_v16qi */

        case 2:
          if (!
#line 4325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1550; /* vinsertvr_internal_v8hi */

        case 3:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1558; /* vinsertgr_internal_v8hi */

        case 4:
          if (!
#line 4325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1551; /* vinsertvr_internal_v4si */

        case 5:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1559; /* vinsertgr_internal_v4si */

        case 6:
          if (!
#line 4325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1552; /* vinsertvr_internal_v2di */

        case 7:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1560; /* vinsertgr_internal_v2di */

        default:
          return -1;
        }

    case 198:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern463 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1561; /* vreplace_elt_v4si_inst */

        case E_V4SFmode:
          if (pattern463 (x2, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1562; /* vreplace_elt_v4sf_inst */

        case E_V2DImode:
          if (pattern463 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1563; /* vreplace_elt_v2di_inst */

        case E_V2DFmode:
          if (pattern463 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1564; /* vreplace_elt_v2df_inst */

        default:
          return -1;
        }

    case 199:
      return recog_101 (x1, insn, pnum_clobbers);

    case 123:
      return recog_96 (x1, insn, pnum_clobbers);

    case 126:
      return recog_98 (x1, insn, pnum_clobbers);

    case 160:
      if (pattern165 (x1) != 0
          || !
#line 5738 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1701; /* *lxvl */

    case 161:
      if (pattern165 (x1) != 0
          || !
#line 5748 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1702; /* lxvll */

    case 165:
      if (pattern166 (x1) != 0
          || !
#line 5777 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1703; /* stxvll */

    case 164:
      if (pattern166 (x1) != 0
          || !
#line 5834 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1704; /* *stxvl */

    case 183:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode)
          || !
#line 6073 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1731; /* *insert4b_internal */

    case 206:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!u1bit_cint_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!s32bit_cint_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6659 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1778; /* xxsplti32dx_v4si_inst */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 6688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1779; /* xxsplti32dx_v4sf_inst */

        default:
          return -1;
        }

    case 207:
      return recog_100 (x1, insn, pnum_clobbers);

    case 202:
      if (pattern167 (x1, 
E_V2DImode) != 0
          || !
#line 6788 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1788; /* vmsumcud */

    case 263:
      return recog_95 (x1, insn, pnum_clobbers);

    case 358:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1910; /* vsldb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1912; /* vsldb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1914; /* vsldb_v4si */

        case 3:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1916; /* vsldb_v2di */

        case 4:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1918; /* vsldb_v1ti */

        default:
          return -1;
        }

    case 359:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1911; /* vsrdb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1913; /* vsrdb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1915; /* vsrdb_v4si */

        case 3:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1917; /* vsrdb_v2di */

        case 4:
          if (!
#line 885 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1919; /* vsrdb_v1ti */

        default:
          return -1;
        }

    case 210:
      switch (pattern169 (x1))
        {
        case 0:
          if (!
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1929; /* altivec_vmsumuhm */

        case 1:
          if (!
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1930; /* altivec_vmsumubm */

        default:
          return -1;
        }

    case 211:
      if (pattern167 (x1, 
E_V2DImode) != 0
          || !
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1931; /* altivec_vmsumudm */

    case 212:
      switch (pattern169 (x1))
        {
        case 0:
          if (!
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1932; /* altivec_vmsummhm */

        case 1:
          if (!
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1933; /* altivec_vmsummbm */

        default:
          return -1;
        }

    case 213:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1934; /* altivec_vmsumshm */

    case 346:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern435 (x2) != 0
              || !
#line 2008 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2021; /* altivec_vrldmi */

        case E_V4SImode:
          if (pattern378 (x2, 
E_V4SImode) != 0
              || !
#line 2008 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2022; /* altivec_vrlwmi */

        case E_V1TImode:
          if (pattern132 (x2, 
E_V1TImode) != 0
              || !vsx_register_operand (operands[3], E_V1TImode)
              || !
#line 2036 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2023; /* altivec_vrlqmi_inst */

        default:
          return -1;
        }

    case 253:
      return recog_97 (x1, insn, pnum_clobbers);

    case 255:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2085; /* *altivec_vperm_v4si_uns_internal */

        case 1:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2086; /* *altivec_vperm_v8hi_uns_internal */

        case 2:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2087; /* *altivec_vperm_v16qi_uns_internal */

        case 3:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2088; /* *altivec_vperm_v4sf_uns_internal */

        case 4:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2089; /* *altivec_vperm_v2df_uns_internal */

        case 5:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2090; /* *altivec_vperm_v2di_uns_internal */

        case 6:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2091; /* *altivec_vperm_v1ti_uns_internal */

        case 7:
          if (!
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2092; /* *altivec_vperm_ti_uns_internal */

        case 8:
          if (!(
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2093; /* *altivec_vperm_kf_uns_internal */

        case 9:
          if (!(
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2094; /* *altivec_vperm_tf_uns_internal */

        default:
          return -1;
        }

    case 254:
      return recog_104 (x1, insn, pnum_clobbers);

    case 321:
      if (pattern171 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 3837 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2291; /* vperm_v8hiv4si */

    case 322:
      if (pattern171 (x1, 
E_V8HImode, 
E_V16QImode) != 0
          || !
#line 3850 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2292; /* vperm_v16qiv8hi */

    case 335:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4469 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2326; /* altivec_vaddeuqm */

    case 336:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4479 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2327; /* altivec_vaddecuq */

    case 338:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2328; /* altivec_vsubeuqm */

    case 339:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4499 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2329; /* altivec_vsubecuq */

    case 342:
      switch (pattern172 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2333; /* bcdadd_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2335; /* bcdadd_v16qi */

        default:
          return -1;
        }

    case 343:
      switch (pattern172 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2334; /* bcdsub_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2336; /* bcdsub_v16qi */

        default:
          return -1;
        }

    case 345:
      if (pnum_clobbers == NULL
          || pattern148 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode)
          || !
#line 4763 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      *pnum_clobbers = 1;
      return 2355; /* bcdshift_v16qi */

    case 417:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2372; /* mma_xvi4ger8pp */

    case 419:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2373; /* mma_xvi8ger4pp */

    case 420:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2374; /* mma_xvi8ger4spp */

    case 413:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2375; /* mma_xvi16ger2pp */

    case 415:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2376; /* mma_xvi16ger2spp */

    case 401:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2377; /* mma_xvf16ger2pp */

    case 400:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2378; /* mma_xvf16ger2pn */

    case 399:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2379; /* mma_xvf16ger2np */

    case 398:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2380; /* mma_xvf16ger2nn */

    case 396:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2381; /* mma_xvbf16ger2pp */

    case 395:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2382; /* mma_xvbf16ger2pn */

    case 394:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2383; /* mma_xvbf16ger2np */

    case 393:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2384; /* mma_xvbf16ger2nn */

    case 406:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2385; /* mma_xvf32gerpp */

    case 405:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2386; /* mma_xvf32gerpn */

    case 404:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2387; /* mma_xvf32gernp */

    case 403:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2388; /* mma_xvf32gernn */

    case 411:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2390; /* mma_xvf64gerpp */

    case 410:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2391; /* mma_xvf64gerpn */

    case 409:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2392; /* mma_xvf64gernp */

    case 408:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2393; /* mma_xvf64gernn */

    case 432:
      return recog_103 (x1, insn, pnum_clobbers);

    case 439:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern378 (x2, 
E_V16QImode) != 0
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2485; /* crypto_vpermxor_v16qi */

        case E_V8HImode:
          if (pattern378 (x2, 
E_V8HImode) != 0
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2486; /* crypto_vpermxor_v8hi */

        case E_V4SImode:
          if (pattern378 (x2, 
E_V4SImode) != 0
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2487; /* crypto_vpermxor_v4si */

        case E_V2DImode:
          if (pattern435 (x2) != 0
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2488; /* crypto_vpermxor_v2di */

        default:
          return -1;
        }

    case 438:
      return recog_102 (x1, insn, pnum_clobbers);

    case 445:
      return recog_99 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!gpc_reg_operand (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x9 = XEXP (x6, 0);
              if (!gpc_reg_operand (x9, E_SImode))
                return -1;
              switch (GET_CODE (x7))
                {
                case SIGN_EXTEND:
                  operands[2] = x9;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!gpc_reg_operand (operands[1], E_HImode)
                      || !
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 50; /* *nmacchw */

                case ASHIFTRT:
                  x11 = XEXP (x7, 1);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x9;
                  x10 = XEXP (x7, 0);
                  operands[2] = x10;
                  if (!gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 1513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 52; /* *nmachhw */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x7) != SIGN_EXTEND)
                return -1;
              x9 = XEXP (x6, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              if (!gpc_reg_operand (operands[2], E_HImode)
                  || !
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 54; /* *nmaclhw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern209 (x2, 
E_SImode) != 0)
                return -1;
              return 102; /* *subfsi3 */

            case E_DImode:
              if (pattern209 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 103; /* *subfdi3 */

            case E_SFmode:
              if (pattern210 (x2, 
E_SFmode) != 0
                  || !
#line 5079 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 314; /* *subsf3_fpr */

            case E_DFmode:
              if (pattern210 (x2, 
E_DFmode) != 0
                  || !
#line 5079 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* *subdf3_fpr */

            case E_KFmode:
              if (pattern211 (x2, 
E_KFmode) != 0
                  || !(
#line 15030 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1095; /* subkf3 */

            case E_TFmode:
              if (pattern211 (x2, 
E_TFmode) != 0
                  || !(
#line 15030 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1096; /* subtf3 */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              operands[1] = x3;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode))
                {
                  operands[2] = x4;
                  if (vsx_register_operand (operands[2], E_V4SFmode)
                      && 
#line 1710 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                    return 1336; /* *vsx_subv4sf3 */
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode))
                return -1;
              operands[2] = x4;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1835; /* *altivec_subv4sf3 */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode)
                return -1;
              operands[1] = x3;
              if (!vsx_register_operand (operands[1], E_V2DFmode))
                return -1;
              operands[2] = x4;
              if (!vsx_register_operand (operands[2], E_V2DFmode)
                  || !
#line 1710 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1337; /* *vsx_subv2df3 */

            case E_V4SImode:
              if (pattern212 (x2, 
E_V4SImode) != 0
                  || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1831; /* subv4si3 */

            case E_V8HImode:
              if (pattern212 (x2, 
E_V8HImode) != 0
                  || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1832; /* subv8hi3 */

            case E_V16QImode:
              if (pattern212 (x2, 
E_V16QImode) != 0
                  || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1833; /* subv16qi3 */

            case E_V2DImode:
              if (pattern212 (x2, 
E_V2DImode) != 0
                  || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1834; /* subv2di3 */

            case E_V1TImode:
              if (pattern212 (x2, 
E_V1TImode) != 0
                  || !
#line 4450 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
                return -1;
              return 2324; /* subv1ti3 */

            case E_DDmode:
              if (pattern210 (x2, 
E_DDmode) != 0
                  || !
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2438; /* subdd3 */

            case E_TDmode:
              if (pattern210 (x2, 
E_TDmode) != 0
                  || !
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2439; /* subtd3 */

            default:
              return -1;
            }

        case EQ:
          switch (pattern40 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 940; /* *minus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 941; /* *minus_eq_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern40 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 942; /* *minus_ne_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 943; /* *minus_ne_di */

            default:
              return -1;
            }

        case AND:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern321 (x2))
                {
                case 0:
                  if (!
#line 1807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2691; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2692; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern323 (x2))
                {
                case 0:
                  if (!
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2695; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2696; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case NOT:
              switch (pattern323 (x2))
                {
                case 0:
                  if (!
#line 1825 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2693; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2694; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern321 (x2))
                {
                case 0:
                  if (!
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2697; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2698; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern324 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 108; /* subfsi3_imm */

        case E_DImode:
          if (pattern324 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* subfdi3_imm */

        default:
          return -1;
        }

    case UMAX:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UMIN)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x12 = XEXP (x3, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern419 (x2, 
E_V4SImode) != 0
              || !
#line 4384 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2305; /* uabdv4si3 */

        case E_V8HImode:
          if (pattern419 (x2, 
E_V8HImode) != 0
              || !
#line 4384 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2306; /* uabdv8hi3 */

        case E_V16QImode:
          if (pattern419 (x2, 
E_V16QImode) != 0
              || !
#line 4384 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2307; /* uabdv16qi3 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2683; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2684; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2687; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2688; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern46 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2685; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2686; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2689; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2690; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = recog_26 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (x2))
    {
    case NE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL)
            {
              switch (pattern331 (x2))
                {
                case 0:
                  if (reg_or_short_operand (operands[2], E_SImode)
                      && 
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                    {
                      *pnum_clobbers = 3;
                      return 889; /* nesisi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_SImode)
                      && (
#line 12993 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 3;
                      return 930; /* *nesi3 */
                    }
                  break;

                case 1:
                  if ((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 909; /* nesidi2_isel */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DImode:
          if (pnum_clobbers != NULL)
            {
              switch (pattern332 (x2))
                {
                case 0:
                  if (reg_or_short_operand (operands[2], E_SImode)
                      && (
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 899; /* nedisi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_SImode)
                      && (
#line 13248 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 945; /* *nesi3_extdi */
                    }
                  break;

                case 1:
                  if (reg_or_short_operand (operands[2], E_DImode)
                      && (
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 3;
                      return 919; /* nedidi2_isel */
                    }
                  if (scc_eq_operand (operands[2], E_DImode)
                      && (
#line 12993 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 3;
                      return 931; /* *nedi3 */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern10 (x2, 
E_V4SFmode) == 0
              && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return 1238; /* vector_nev4sf */
          break;

        case E_V2DFmode:
          if (pattern10 (x2, 
E_V2DFmode) == 0
              && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return 1245; /* vector_nev2df */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 947; /* *nesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 951; /* *nedi_cc */

        default:
          return -1;
        }

    case LE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 955; /* *lesi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 961; /* *ledi_cc */

        default:
          return -1;
        }

    case LEU:
      switch (pattern128 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 895; /* leusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 915; /* leusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 905; /* leudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 925; /* leudidi2_isel */

        default:
          return -1;
        }

    case GE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 956; /* *gesi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 962; /* *gedi_cc */

        default:
          return -1;
        }

    case GEU:
      switch (pattern128 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 897; /* geusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 917; /* geusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 907; /* geudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 927; /* geudidi2_isel */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern12 (x2))
        {
        case 0:
          if (!
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 946; /* *orderedsi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 950; /* *ordereddi_cc */

        case 2:
          if (!
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1253; /* vector_orderedv4sf */

        case 3:
          if (!
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1257; /* vector_orderedv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern527 (x6, 
E_SImode) != 0
                  || !
#line 403 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2535; /* *fuse_eqv_and */

            case E_DImode:
              if (pattern527 (x6, 
E_DImode) != 0
                  || !(
#line 403 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2536; /* *fuse_eqv_and */

            case E_V4SImode:
              if (pattern528 (x6, 
E_V4SImode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2719; /* *fuse_veqv_vand */

            case E_V8HImode:
              if (pattern528 (x6, 
E_V8HImode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2720; /* *fuse_veqv_vand */

            case E_V16QImode:
              if (pattern528 (x6, 
E_V16QImode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2721; /* *fuse_veqv_vand */

            case E_V4SFmode:
              if (pattern528 (x6, 
E_V4SFmode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2722; /* *fuse_veqv_vand */

            case E_V2DFmode:
              if (pattern528 (x6, 
E_V2DFmode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2723; /* *fuse_veqv_vand */

            case E_V2DImode:
              if (pattern528 (x6, 
E_V2DImode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2724; /* *fuse_veqv_vand */

            case E_V1TImode:
              if (pattern528 (x6, 
E_V1TImode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2725; /* *fuse_veqv_vand */

            case E_TImode:
              if (pattern528 (x6, 
E_TImode) != 0
                  || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2726; /* *fuse_veqv_vand */

            case E_KFmode:
              if (pattern528 (x6, 
E_KFmode) != 0
                  || !(
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2727; /* *fuse_veqv_vand */

            case E_TFmode:
              if (pattern528 (x6, 
E_TFmode) != 0
                  || !(
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2728; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern393 (x6, 
E_SImode) != 0
                  || !
#line 583 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2555; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern393 (x6, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2556; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern395 (x6, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2799; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern395 (x6, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2800; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern395 (x6, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2801; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern395 (x6, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2802; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern395 (x6, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2803; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern395 (x6, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2804; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern395 (x6, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2805; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern395 (x6, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2806; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern395 (x6, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2807; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern395 (x6, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2808; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern403 (x6))
        {
        case 0:
          if (!
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2603; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2604; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3019; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3020; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3021; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3022; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3023; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3024; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3025; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3026; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3027; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3028; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2605; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2606; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3029; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3030; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3031; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3032; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3033; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3034; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3035; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3036; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3037; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3038; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2611; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2612; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3059; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3060; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3061; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3062; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3063; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3064; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3065; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3066; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3067; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3068; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern406 (x6))
        {
        case 0:
          if (!
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2607; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2608; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3039; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3040; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3041; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3042; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3043; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3044; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3045; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3046; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3047; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3048; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern407 (x6))
        {
        case 0:
          if (!
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2609; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2610; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3049; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3050; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3051; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3052; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3053; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3054; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3055; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3056; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3057; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3058; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2615; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2616; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3079; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3080; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3081; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3082; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3083; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3084; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3085; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3086; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3087; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3088; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2613; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2614; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3069; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3070; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3071; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3072; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3073; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3074; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3075; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3076; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3077; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3078; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2619; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2620; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2621; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2622; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (XINT (x4, 1) != 87
              || GET_MODE (x4) != E_SImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_V4SFmode)
              || !
#line 7892 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))))
            return -1;
          return 570; /* *movdi_from_sf_zero_ext */

        case 3:
          if (XINT (x4, 1) != 445)
            return -1;
          switch (pattern409 (x1))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3351; /* *pcrel_opt_ldsi_udi_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3355; /* *pcrel_opt_ldhi_udi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !(
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3357; /* *pcrel_opt_ldqi_udi_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  return 3353; /* *pcrel_opt_ldhi_usi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  return 3356; /* *pcrel_opt_ldqi_usi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      if (pattern198 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          switch (pattern552 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 10372 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 716; /* *movhi_update2 */

            case 1:
              if (!(
#line 10372 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 718; /* *movhi_update2 */

            case 2:
              if (!(
#line 10439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 728; /* *movqi_update2 */

            case 3:
              if (!(
#line 10439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 730; /* *movqi_update2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern552 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 10372 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 717; /* *movhi_update2 */

            case 1:
              if (!(
#line 10372 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 719; /* *movhi_update2 */

            case 2:
              if (!(
#line 10439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 729; /* *movqi_update2 */

            case 3:
              if (!(
#line 10439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (((((
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 731; /* *movqi_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (vsx_register_operand (operands[1], E_V4SImode)
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x4) == E_SImode)
        {
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (const_int_operand (operands[2], E_QImode))
            {
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (scratch_operand (operands[3], E_V4SImode)
                  && 
#line 3957 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                return 1515; /* *mfvsrwz */
            }
        }
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      switch (pattern499 (x1))
        {
        case 0:
          if (!
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1519; /* *vsx_extract_v16qi_di_p9 */

        case 1:
          if (!
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1520; /* *vsx_extract_v8hi_di_p9 */

        case 2:
          if (!
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1521; /* *vsx_extract_v4si_di_p9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      return recog_168 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_173 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_175 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_178 (x1, insn, pnum_clobbers);

    case NEG:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case SET:
              switch (pattern353 (x1, 
EQ))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 114; /* *subfsi3_imm_carry_0 */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 115; /* *subfdi3_imm_carry_0 */

                default:
                  return -1;
                }

            case CLOBBER:
              switch (pattern302 (x1))
                {
                case 0:
                  if (!(
#line 9299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 625; /* ieee_128bit_vsx_negkf2 */

                case 1:
                  if (!(
#line 9299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 626; /* ieee_128bit_vsx_negtf2 */

                default:
                  return -1;
                }

            case USE:
              switch (pattern303 (x1))
                {
                case 0:
                  if (!(
#line 9318 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 627; /* *ieee_128bit_vsx_negkf2_internal */

                case 1:
                  if (!(
#line 9318 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 628; /* *ieee_128bit_vsx_negtf2_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ABS:
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case CLOBBER:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!scratch_operand (operands[2], E_V16QImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern475 (x3, 
E_KFmode) != 0
                      || !(
#line 9357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 633; /* *ieee_128bit_vsx_nabskf2 */

                case E_TFmode:
                  if (pattern475 (x3, 
E_TFmode) != 0
                      || !(
#line 9357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 634; /* *ieee_128bit_vsx_nabstf2 */

                default:
                  return -1;
                }

            case USE:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_V16QImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern475 (x3, 
E_KFmode) != 0
                      || !(
#line 9378 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return -1;
                  return 635; /* *ieee_128bit_vsx_nabskf2_internal */

                case E_TFmode:
                  if (pattern475 (x3, 
E_TFmode) != 0
                      || !(
#line 9378 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return -1;
                  return 636; /* *ieee_128bit_vsx_nabstf2_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_172 (x1, insn, pnum_clobbers);

    case BSWAP:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!gpc_reg_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 157; /* bswaphi2_reg */

        case E_DImode:
          if (!reg_or_mem_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !reg_or_mem_operand (operands[1], E_DImode)
              || !
#line 2978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && (REG_P (operands[0]) || REG_P (operands[1]))))
            return -1;
          return 164; /* bswapdi2_32bit */

        default:
          return -1;
        }

    case DIV:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern476 (x1, 
E_SImode) != 0)
            return -1;
          return 192; /* divsi3_sra */

        case E_DImode:
          if (pattern476 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 193; /* divdi3_sra */

        default:
          return -1;
        }

    case AND:
      return recog_170 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_169 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          if (!reg_or_cint_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 98)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern497 (x1, 
E_SImode) != 0)
                return -1;
              return 299; /* ashrsi3 */

            case E_DImode:
              if (pattern497 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 300; /* ashrdi3 */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case VEC_DUPLICATE:
          switch (pattern87 (x1))
            {
            case 0:
              if (!(
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              return 2051; /* *altivec_v4si_ashiftrt_const */

            case 1:
              if (!(
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              return 2054; /* *altivec_v2di_ashiftrt_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ASHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern253 (x6, 
E_SImode, 
98) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          if (!reg_or_cint_operand (operands[2], E_SImode)
              || !
#line 4906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 301; /* *ashrsi3_64 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case SYMBOL_REF:
          if (GET_CODE (x5) == MEM)
            {
              res = recog_164 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x5;
          if (!input_operand (operands[1], E_DImode)
              || pattern265 (x1, 
E_TImode, 
E_DImode, 
98) != 0
              || !
#line 5133 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10))
            return -1;
          return 1657; /* extendditi2 */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 3
              || XINT (x5, 1) != 445)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          switch (pattern409 (x1))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3350; /* *pcrel_opt_ldsi_di_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 3354; /* *pcrel_opt_ldhi_di_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x5) != E_HImode
                  || !d_form_memory (operands[1], E_HImode)
                  || !
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3352; /* *pcrel_opt_ldhi_si_gpr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_180 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_179 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 5976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
            return -1;
          return 411; /* floatunssisf2_lfiwzx */

        case 1:
          if (!
#line 7129 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
            return -1;
          return 506; /* *floatunsdisf2_mem */

        case 2:
          if (!
#line 5976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
            return -1;
          return 412; /* floatunssidf2_lfiwzx */

        case 3:
          if (!
#line 7004 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
            return -1;
          return 501; /* *floatunsdidf2_mem */

        case 4:
          if (!(
#line 15394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1169; /* floatuns_kfsi2_hw */

        case 5:
          if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1171; /* floatunsqikf2 */

        case 6:
          if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1172; /* floatunshikf2 */

        case 7:
          if (!(
#line 15394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1170; /* floatuns_tfsi2_hw */

        case 8:
          if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1173; /* floatunsqitf2 */

        case 9:
          if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1174; /* floatunshitf2 */

        case 10:
          if (!
#line 6016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
            return -1;
          return 413; /* floatunssisf2_lfiwzx_mem */

        case 11:
          if (!
#line 6016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
            return -1;
          return 414; /* floatunssidf2_lfiwzx_mem */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SImode)
              && 
#line 4437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return 1570; /* *vsx_extract_si_unsfloat_df */
          if (!const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_SImode)
              || !
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          return 1600; /* *vsx_ext_SI_ufl_df */

        case 13:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          return 1592; /* *vsx_ext_QI_ufl_df */

        case 14:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          return 1596; /* *vsx_ext_HI_ufl_df */

        case 15:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          return 1591; /* *vsx_ext_QI_ufl_sf */

        case 16:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          return 1595; /* *vsx_ext_HI_ufl_sf */

        case 17:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          return 1599; /* *vsx_ext_SI_ufl_sf */

        case 18:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1593; /* *vsx_ext_QI_ufl_kf */

        case 19:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1597; /* *vsx_ext_HI_ufl_kf */

        case 20:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1601; /* *vsx_ext_SI_ufl_kf */

        case 21:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1594; /* *vsx_ext_QI_ufl_tf */

        case 22:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1598; /* *vsx_ext_HI_ufl_tf */

        case 23:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1602; /* *vsx_ext_SI_ufl_tf */

        default:
          return -1;
        }

    case FIX:
      return recog_184 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_183 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_176 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_177 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_DFmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          switch (pattern357 (x1))
            {
            case 0:
              if (!(
#line 8912 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 611; /* extenddfif2_fprs */

            case 1:
              if (!(
#line 8912 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 612; /* extenddftf2_fprs */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 3
              || XINT (x5, 1) != 445
              || GET_MODE (x5) != E_SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !vsx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          operands[1] = x11;
          if (!d_form_memory (operands[1], E_SFmode))
            return -1;
          x12 = XVECEXP (x5, 0, 1);
          operands[2] = x12;
          if (!vsx_register_operand (operands[2], E_DImode))
            return -1;
          x13 = XVECEXP (x5, 0, 2);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[4] = x8;
          if (!base_reg_operand (operands[4], E_DImode)
              || !
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3361; /* *pcrel_opt_ldsf_df */

        default:
          return -1;
        }

    case ABS:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          switch (pattern302 (x1))
            {
            case 0:
              if (!(
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 629; /* ieee_128bit_vsx_abskf2 */

            case 1:
              if (!(
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 630; /* ieee_128bit_vsx_abstf2 */

            default:
              return -1;
            }

        case USE:
          switch (pattern303 (x1))
            {
            case 0:
              if (!(
#line 9346 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 631; /* *ieee_128bit_vsx_abskf2_internal */

            case 1:
              if (!(
#line 9346 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 632; /* *ieee_128bit_vsx_abstf2_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          if (REGNO (x4) != 96
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 2)
            return -1;
          operands[0] = x3;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x14 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x14, operands[0])
              || !
#line 11151 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4
   && (flag_pic == 2 || (flag_pic && TARGET_SECURE_PLT))))
            return -1;
          return 797; /* load_toc_v4_PIC_1_normal */

        case SUBREG:
        case MEM:
          operands[0] = x4;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          operands[1] = x3;
          x8 = XEXP (x6, 0);
          switch (pattern315 (x8))
            {
            case 0:
              if (!
#line 3458 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])))
                return -1;
              return 1487; /* vsx_stxvd2x4_le_const_v4sf */

            case 1:
              if (!
#line 3458 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])))
                return -1;
              return 1488; /* vsx_stxvd2x4_le_const_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      return recog_182 (x1, insn, pnum_clobbers);

    case COPYSIGN:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_KFmode:
          if (pattern448 (x3, 
E_KFmode) != 0
              || !(
#line 15113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1105; /* copysignkf3_soft */

        case E_TFmode:
          if (pattern448 (x3, 
E_TFmode) != 0
              || !(
#line 15113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1106; /* copysigntf3_soft */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!vsx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (pattern451 ())
            {
            case 0:
              if (!(
#line 15257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1129; /* trunckfsf2_hw */

            case 1:
              if (!(
#line 15257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1130; /* trunctfsf2_hw */

            default:
              return -1;
            }

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !scratch_operand (operands[2], E_TDmode)
              || !
#line 154 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2434; /* trunctddd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_174 (x1, insn, pnum_clobbers);

    case SMIN:
      if (pattern83 (x1) != 0
          || !
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1636; /* vsx_reduc_smin_v2df */

    case SMAX:
      if (pattern83 (x1) != 0
          || !
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1637; /* vsx_reduc_smax_v2df */

    case US_PLUS:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1825; /* altivec_vadduws */

        case 1:
          if (!
#line 537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1826; /* altivec_vadduhs */

        case 2:
          if (!
#line 537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1827; /* altivec_vaddubs */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1828; /* altivec_vaddsws */

        case 1:
          if (!
#line 546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1829; /* altivec_vaddshs */

        case 2:
          if (!
#line 546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1830; /* altivec_vaddsbs */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 581 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1837; /* altivec_vsubuws */

        case 1:
          if (!
#line 581 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1838; /* altivec_vsubuhs */

        case 2:
          if (!
#line 581 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1839; /* altivec_vsububs */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1840; /* altivec_vsubsws */

        case 1:
          if (!
#line 590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1841; /* altivec_vsubshs */

        case 2:
          if (!
#line 590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1842; /* altivec_vsubsbs */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern88 (x1))
        {
        case 0:
          if (!(
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          return 2050; /* *altivec_v4si_ashift_const */

        case 1:
          if (!(
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          return 2053; /* *altivec_v2di_ashift_const */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern88 (x1))
        {
        case 0:
          if (!(
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          return 2052; /* *altivec_v4si_lshiftrt_const */

        case 1:
          if (!(
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          return 2055; /* *altivec_v2di_lshiftrt_const */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_181 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_171 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_VECTOR:
    case VEC_DUPLICATE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (gpc_reg_operand (operands[0], E_SImode)
              && const_int_operand (operands[1], E_SImode)
              && 
#line 8013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(num_insns_constant (operands[1], SImode) > 1))
            return gen_split_295 (insn, operands);
          if (altivec_register_operand (operands[0], E_SImode)
              && xxspltib_constant_split (operands[1], E_SImode)
              && 
#line 10009 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_386 (insn, operands);
          break;

        case E_DImode:
          if (altivec_register_operand (operands[0], E_DImode)
              && xxspltib_constant_split (operands[1], E_DImode)
              && 
#line 8026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_296 (insn, operands);
          if (gpc_reg_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 9838 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
            return gen_split_377 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_int_operand (operands[1], E_DFmode)
              && 
#line 8483 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_304 (insn, operands);
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_int_operand (operands[1], E_DDmode)
              && 
#line 8483 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_305 (insn, operands);
          break;

        case E_QImode:
          if (altivec_register_operand (operands[0], E_QImode)
              && xxspltib_constant_split (operands[1], E_QImode)
              && 
#line 10009 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_384 (insn, operands);
          break;

        case E_HImode:
          if (altivec_register_operand (operands[0], E_HImode)
              && xxspltib_constant_split (operands[1], E_HImode)
              && 
#line 10009 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_385 (insn, operands);
          break;

        case E_PTImode:
          if (int_reg_operand (operands[0], E_PTImode)
              && const_scalar_int_operand (operands[1], E_PTImode)
              && 
#line 10063 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (PTImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
            return gen_split_389 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) == VEC_DUPLICATE
          && GET_MODE (x3) == E_V4SFmode
          && vsx_register_operand (operands[0], E_V4SFmode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (splat_input_operand (operands[1], E_SFmode)
              && (
#line 4832 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 4837 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed && vsx_register_operand (operands[1], SFmode))))
            return gen_split_676 (insn, operands);
        }
      break;

    case CONST_DOUBLE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (gpc_reg_operand (operands[0], E_SFmode)
              && const_double_operand (operands[1], E_SFmode)
              && 
#line 8216 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_299 (insn, operands);
          break;

        case E_SDmode:
          if (gpc_reg_operand (operands[0], E_SDmode)
              && const_double_operand (operands[1], E_SDmode)
              && 
#line 8216 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_300 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_double_operand (operands[1], E_DFmode))
            {
              if (
#line 8503 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_306 (insn, operands);
              if (
#line 8525 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_308 (insn, operands);
            }
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_double_operand (operands[1], E_DDmode))
            {
              if (
#line 8503 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_307 (insn, operands);
              if (
#line 8525 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_309 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  res = split_13 (x1, insn);
  if (res != NULL_RTX)
    return res;
  if (vsx_register_operand (operands[0], E_V1TImode)
      && GET_CODE (x3) == SUBREG
      && known_eq (SUBREG_BYTE (x3), 0)
      && GET_MODE (x3) == E_V1TImode)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (int_reg_operand (operands[1], E_TImode)
          && 
#line 6769 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && !reload_completed))
        return gen_split_690 (insn, operands);
    }
  operands[1] = x3;
  if (vsx_register_operand (operands[1], E_V1TImode)
      && gpc_reg_operand (operands[0], E_V1TImode)
      && 
#line 6796 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(reload_completed
   && TARGET_DIRECT_MOVE_64BIT
   && int_reg_operand (operands[0], V1TImode)
   && vsx_register_operand (operands[1], V1TImode)))
    return gen_split_691 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[0], E_DImode)
          || !xxspltib_constant_split (operands[1], E_DImode)
          || !
#line 10009 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_387 (insn, operands);

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V8HImode)
          && (
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_596 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V8HImode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_693 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V8HImode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_703 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V8HImode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_713 (insn, operands);

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V4SImode)
          && (
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_597 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V4SImode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_692 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SImode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_702 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SImode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_712 (insn, operands);

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V2DImode)
          && (
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_598 (insn, operands);
      if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
          && (
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_599 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V2DImode)
          && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_697 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DImode)
          && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_707 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DImode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_717 (insn, operands);

    default:
      return NULL;
    }
}
