/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vfloat_operand (operands[1], i1)
      || !vfloat_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[11]))
    {
    case E_SImode:
      if (!scratch_operand (operands[11], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[11], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 26
      || GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!mma_assemble_input_operand (operands[3], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!mma_assemble_input_operand (operands[4], E_V16QImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      return pattern44 (x3); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern42 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case NOT:
          return pattern52 (x3); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern58 (x3);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern63 (x3);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern70 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 282
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 109
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern84 (x8, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern84 (x8, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern84 (x8, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!offsettable_mem_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern110 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern110 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern120 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern120 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 96)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !immediate_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !immediate_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 1L
          || !vfloat_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!vfloat_operand (operands[1], E_V2DFmode))
        return -1;
      x13 = XEXP (x9, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x4, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 102
          || GET_MODE (x5) != E_V4SFmode)
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 3L
          || !vfloat_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x14 = XEXP (x4, 1);
      operands[1] = x14;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern204 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return pattern203 (x1, 
i1); /* [-1, 3] */
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern220 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern220 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 356
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x7) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x7) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 441
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!cc_reg_operand (operands[1], E_CCmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern260 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern260 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern273 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern273 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern273 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern273 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern273 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern273 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern273 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern273 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern273 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern273 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern288 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern288 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !immediate_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !immediate_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !symbol_ref_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !symbol_ref_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern347 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_add_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern59 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern59 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern59 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern59 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern59 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern59 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern59 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern59 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern59 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern400 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern400 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern401 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern401 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern401 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern401 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern401 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern401 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern401 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern401 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern401 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern401 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern435 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_V2DImode))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern33 (x2); /* [-1, 1] */
}

int
pattern446 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern483 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1)
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern502 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[3], i1)
      || !vsx_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern523 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern523 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern524 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern524 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern524 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern524 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern524 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern524 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern524 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern524 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern524 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern524 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern554 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern553 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern553 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!symbol_ref_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !short_cint_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern581 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x9) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x9) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  x12 = XEXP (x9, 1);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x4, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern487 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 357; /* *isel_reversed_cc_si */

        case 1:
          if (!
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 359; /* *isel_reversed_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern487 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 358; /* *isel_reversed_cc_di */

        case 1:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 360; /* *isel_reversed_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 2);
  operands[5] = x7;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern505 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 381; /* *movsfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 383; /* *movsfdfcc_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern505 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 382; /* *movdfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 384; /* *movdfdfcc_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern506 (x3, 
E_KFmode) != 0
              || !(
#line 5770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 393; /* *movkfcc_p10 */

        case E_TFmode:
          if (pattern506 (x3, 
E_TFmode) != 0
              || !(
#line 5770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 394; /* *movtfcc_p10 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!all_ones_constant (operands[4], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !zero_constant (operands[5], E_V2DImode))
        return -1;
      if (vsx_register_operand (operands[0], E_V2DImode))
        {
          switch (pattern504 ())
            {
            case 0:
              if (
#line 5732 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 389; /* *fpmasksf */
              break;

            case 1:
              if (
#line 5732 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 390; /* *fpmaskdf */
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[2], E_KFmode)
              || !altivec_register_operand (operands[3], E_KFmode)
              || !(
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 397; /* *fpmaskkf */

        case E_TFmode:
          if (!altivec_register_operand (operands[2], E_TFmode)
              || !altivec_register_operand (operands[3], E_TFmode)
              || !(
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 398; /* *fpmasktf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x10 = XEXP (x5, 0);
      operands[5] = x10;
      x11 = XEXP (x5, 1);
      operands[6] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern560 (x2, 
E_SImode) != 0
              || !
#line 4281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
            return -1;
          return 256; /* *rotlsi3_insert */

        case E_DImode:
          if (pattern560 (x2, 
E_DImode) != 0
              || !(
#line 4281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 257; /* *rotldi3_insert */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              switch (GET_CODE (x10))
                {
                case ASHIFT:
                case ROTATE:
                case LSHIFTRT:
                  operands[4] = x10;
                  operands[5] = x4;
                  operands[6] = x9;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  x13 = XEXP (x10, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XEXP (x5, 1);
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern574 (x2, 
E_SImode) != 0
                          || !
#line 4299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
                        return -1;
                      return 258; /* *rotlsi3_insert_2 */

                    case E_DImode:
                      if (pattern574 (x2, 
E_DImode) != 0
                          || !(
#line 4299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 259; /* *rotldi3_insert_2 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (!gpc_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x2) != E_SImode
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x4;
                      if (!gpc_reg_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x9;
                      if (!const_int_operand (operands[2], E_SImode)
                          || GET_MODE (x5) != E_SImode)
                        return -1;
                      operands[3] = x10;
                      if (!gpc_reg_operand (operands[3], E_SImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[4] = x11;
                      if (!const_int_operand (operands[4], E_SImode)
                          || !
#line 4375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 267; /* *rotlsi3_insert_5 */

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x2) != E_DImode
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (x4, E_DImode)
                          || !const_int_operand (x9, E_DImode))
                        return -1;
                      operands[2] = x9;
                      operands[1] = x4;
                      if (GET_MODE (x5) == E_DImode)
                        {
                          operands[3] = x10;
                          if (gpc_reg_operand (operands[3], E_DImode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[4] = x11;
                              if (const_int_operand (operands[4], E_DImode)
                                  && 
#line 4389 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                                return 268; /* *rotldi3_insert_6 */
                            }
                        }
                      operands[4] = x9;
                      operands[3] = x4;
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      operands[1] = x10;
                      if (!gpc_reg_operand (operands[1], E_DImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[2] = x11;
                      if (!const_int_operand (operands[2], E_DImode)
                          || !
#line 4404 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 269; /* *rotldi3_insert_7 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern219 (x2))
                {
                case 0:
                  if (!
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 260; /* rotlsi3_insert_3 */

                case 1:
                  if (!(
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 261; /* rotldi3_insert_3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (GET_MODE (x5) != E_SImode
                  || !gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!gpc_reg_operand (operands[3], E_SImode))
                return -1;
              operands[4] = x9;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x5, 0);
              operands[1] = x10;
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 4365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32))
                return -1;
              return 266; /* *rotlsi3_insert_4 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              if (GET_CODE (x10) != NOT)
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern488 (x2, 
E_V4SImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V4SImode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1888; /* altivec_vselv4si3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V4SImode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return -1;
                  return 1898; /* altivec_vselv4si4 */

                case E_V8HImode:
                  if (pattern488 (x2, 
E_V8HImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V8HImode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1889; /* altivec_vselv8hi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V8HImode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return -1;
                  return 1899; /* altivec_vselv8hi4 */

                case E_V16QImode:
                  if (pattern488 (x2, 
E_V16QImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V16QImode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1890; /* altivec_vselv16qi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V16QImode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return -1;
                  return 1900; /* altivec_vselv16qi4 */

                case E_V4SFmode:
                  if (pattern488 (x2, 
E_V4SFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V4SFmode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1891; /* altivec_vselv4sf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V4SFmode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return -1;
                  return 1901; /* altivec_vselv4sf4 */

                case E_V2DFmode:
                  if (pattern488 (x2, 
E_V2DFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V2DFmode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1892; /* altivec_vselv2df3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V2DFmode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return -1;
                  return 1902; /* altivec_vselv2df4 */

                case E_V2DImode:
                  if (pattern488 (x2, 
E_V2DImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V2DImode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1893; /* altivec_vselv2di3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V2DImode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return -1;
                  return 1903; /* altivec_vselv2di4 */

                case E_V1TImode:
                  if (pattern488 (x2, 
E_V1TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_V1TImode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1894; /* altivec_vselv1ti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_V1TImode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1904; /* altivec_vselv1ti4 */

                case E_TImode:
                  if (pattern488 (x2, 
E_TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_TImode) == 0
                      && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1895; /* altivec_vselti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_TImode) != 0
                      || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return -1;
                  return 1905; /* altivec_vselti4 */

                case E_KFmode:
                  if (pattern488 (x2, 
E_KFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_KFmode) == 0
                      && (
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1896; /* altivec_vselkf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_KFmode) != 0
                      || !(
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 1906; /* altivec_vselkf4 */

                case E_TFmode:
                  if (pattern488 (x2, 
E_TFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern579 (x5, 
E_TFmode) == 0
                      && (
#line 735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1897; /* altivec_vseltf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern579 (x5, 
E_TFmode) != 0
                      || !(
#line 751 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 1907; /* altivec_vseltf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              switch (pattern371 (x2))
                {
                case 0:
                  if (!
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2623; /* *fuse_and_or */

                case 1:
                  if (!(
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2624; /* *fuse_and_or */

                case 2:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3099; /* *fuse_vand_vor */

                case 3:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3100; /* *fuse_vand_vor */

                case 4:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3101; /* *fuse_vand_vor */

                case 5:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3102; /* *fuse_vand_vor */

                case 6:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3103; /* *fuse_vand_vor */

                case 7:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3104; /* *fuse_vand_vor */

                case 8:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3105; /* *fuse_vand_vor */

                case 9:
                  if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3106; /* *fuse_vand_vor */

                case 10:
                  if (!(
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3107; /* *fuse_vand_vor */

                case 11:
                  if (!(
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3108; /* *fuse_vand_vor */

                default:
                  return -1;
                }

            case NOT:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              operands[0] = x4;
              operands[1] = x9;
              switch (pattern62 (x2))
                {
                case 0:
                  if (!
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2643; /* *fuse_and_orc */

                case 1:
                  if (!(
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2644; /* *fuse_and_orc */

                case 2:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3179; /* *fuse_vand_vorc */

                case 3:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3180; /* *fuse_vand_vorc */

                case 4:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3181; /* *fuse_vand_vorc */

                case 5:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3182; /* *fuse_vand_vorc */

                case 6:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3183; /* *fuse_vand_vorc */

                case 7:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3184; /* *fuse_vand_vorc */

                case 8:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3185; /* *fuse_vand_vorc */

                case 9:
                  if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3186; /* *fuse_vand_vorc */

                case 10:
                  if (!(
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3187; /* *fuse_vand_vorc */

                case 11:
                  if (!(
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3188; /* *fuse_vand_vorc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V2DFmode)
          && 
#line 3658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1503; /* vsx_extract_v2df_var */
        }
      if (!memory_operand (operands[1], E_V2DFmode)
          || !
#line 3675 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1505; /* *vsx_extract_v2df_var_load */

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SFmode)
          && 
#line 3745 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1510; /* vsx_extract_v4sf_var */
        }
      if (!memory_operand (operands[1], E_V4SFmode)
          || !
#line 3762 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1511; /* *vsx_extract_v4sf_var_load */

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode)
          && 
#line 4185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1531; /* vsx_extract_v16qi_var */
        }
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1534; /* *vsx_extract_v16qi_var_load */

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode)
          && 
#line 4185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1532; /* vsx_extract_v8hi_var */
        }
      if (!memory_operand (operands[1], E_V8HImode)
          || !
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1535; /* *vsx_extract_v8hi_var_load */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !vsx_register_operand (operands[2], E_DFmode)
          || !
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1351; /* *vsx_tdivdf3_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !vsx_register_operand (operands[2], E_V4SFmode)
          || !
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1352; /* *vsx_tdivv4sf3_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !vsx_register_operand (operands[2], E_V2DFmode)
          || !
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1353; /* *vsx_tdivv2df3_internal */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0
          || !
#line 80 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2481; /* crypto_vpmsumb */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 80 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2482; /* crypto_vpmsumh */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 80 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2483; /* crypto_vpmsumw */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 80 "../../gcc-15.0.1-20250313/gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2484; /* crypto_vpmsumd */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_12_operand (operands[2], E_QImode)
      || !
#line 6041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
    return -1;
  return 1730; /* extract4b */
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!got_no_const_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode)
      || !
#line 7696 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1))
    return -1;
  return 567; /* *movsi_got_internal */
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 2362 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1419; /* vsx_xscvdpsp */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2400 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1422; /* vsx_xvcvdpsp */

        case E_SFmode:
          if (!vsx_register_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1427; /* vsx_xscvdpsp_scalar */

        default:
          return -1;
        }

    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2409 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1423; /* vsx_xscvspdp */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2418 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1424; /* vsx_xscvspdp_scalar2 */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 3242 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2286; /* altivec_stvehx */

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 3242 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2287; /* altivec_stvebx */

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3249 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2288; /* *altivec_stvesfx */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6587 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1775; /* xxspltiw_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6607 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1776; /* xxspltiw_v4sf_inst */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9564 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 646; /* p8_mtvsrwz */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 647; /* p8_mtvsrwz_v16qisi2 */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2074; /* altivec_vperm_v4si_direct */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2075; /* altivec_vperm_v8hi_direct */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2076; /* altivec_vperm_v16qi_direct */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2084; /* altivec_vperm_v8hiv16qi */

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2077; /* altivec_vperm_v4sf_direct */

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2078; /* altivec_vperm_v2df_direct */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2079; /* altivec_vperm_v2di_direct */

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2080; /* altivec_vperm_v1ti_direct */

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0
          || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2081; /* altivec_vperm_ti_direct */

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0
          || !(
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 2082; /* altivec_vperm_kf_direct */

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0
          || !(
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 2083; /* altivec_vperm_tf_direct */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          switch (pattern439 (x2, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2199; /* altivec_lvx_v16qi_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2200; /* altivec_lvx_v16qi_2op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern439 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2203; /* altivec_lvx_v2df_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2204; /* altivec_lvx_v2df_2op_di */

            default:
              return -1;
            }

        case E_KFmode:
          switch (pattern439 (x2, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 2209; /* altivec_lvx_kf_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 2210; /* altivec_lvx_kf_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          switch (pattern384 (x2, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2217; /* altivec_lvx_v16qi_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2218; /* altivec_lvx_v16qi_1op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern384 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2221; /* altivec_lvx_v2df_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2222; /* altivec_lvx_v2df_1op_di */

            default:
              return -1;
            }

        case E_KFmode:
          switch (pattern384 (x2, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 2227; /* altivec_lvx_kf_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 2228; /* altivec_lvx_kf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      res = recog_115 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case HIGH:
      res = recog_116 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && input_operand (operands[1], E_SImode)
          && 
#line 7743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], SImode)
   || gpc_reg_operand (operands[1], SImode)))
        return 568; /* *movsi_internal1 */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 8116 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], QImode)
   || gpc_reg_operand (operands[1], QImode)))
        return 576; /* *movqi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 8116 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], HImode)
   || gpc_reg_operand (operands[1], HImode)))
        return 577; /* *movhi_internal */
      break;

    case E_CCmode:
      if (nonimmediate_operand (operands[0], E_CCmode)
          && general_operand (operands[1], E_CCmode)
          && 
#line 8165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCmode)
   || register_operand (operands[1], CCmode)))
        return 578; /* *movcc_cc */
      break;

    case E_CCUNSmode:
      if (nonimmediate_operand (operands[0], E_CCUNSmode)
          && general_operand (operands[1], E_CCUNSmode)
          && 
#line 8165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCUNSmode)
   || register_operand (operands[1], CCUNSmode)))
        return 579; /* *movcc_ccuns */
      break;

    case E_CCEQmode:
      if (nonimmediate_operand (operands[0], E_CCEQmode)
          && general_operand (operands[1], E_CCEQmode)
          && 
#line 8165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCEQmode)
   || register_operand (operands[1], CCEQmode)))
        return 580; /* *movcc_cceq */
      break;

    case E_CCFPmode:
      if (nonimmediate_operand (operands[0], E_CCFPmode)
          && general_operand (operands[1], E_CCFPmode)
          && 
#line 8165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCFPmode)
   || register_operand (operands[1], CCFPmode)))
        return 581; /* *movcc_ccfp */
      break;

    case E_V4SFmode:
      if (pnum_clobbers != NULL
          && memory_operand (operands[0], E_V4SFmode)
          && immediate_operand (operands[1], E_V4SFmode)
          && 
#line 3458 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1487; /* vsx_stxvd2x4_le_const_v4sf */
        }
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode)
          && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
        return 1792; /* *altivec_movv4sf */
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V4SFmode))
    {
    case 0:
      if ((
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2246; /* altivec_stvx_v4sf_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2247; /* altivec_stvx_v4sf_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2264; /* altivec_stvx_v4sf_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2265; /* altivec_stvx_v4sf_1op_di */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case HIGH:
      if (GET_MODE (x2) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) == UNSPEC
          && GET_MODE (x4) == E_SImode)
        {
          switch (XVECLEN (x4, 0))
            {
            case 2:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              x6 = XVECEXP (x4, 0, 1);
              operands[2] = x6;
              switch (XINT (x4, 1))
                {
                case 14:
                  if (rs6000_tls_symbol_ref (operands[1], E_SImode)
                      && gpc_reg_operand (operands[2], E_SImode)
                      && (
#line 10598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 750; /* *tls_gd_high32 */
                  break;

                case 23:
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && rs6000_tls_symbol_ref (operands[2], E_SImode)
                      && (
#line 10711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 770; /* *tls_got_dtprel_high32 */
                  break;

                case 27:
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && rs6000_tls_symbol_ref (operands[2], E_SImode)
                      && (
#line 10791 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 784; /* *tls_got_tprel_high32 */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (XINT (x4, 1) == 15)
                {
                  x5 = XVECEXP (x4, 0, 0);
                  operands[1] = x5;
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && (
#line 10644 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 758; /* *tls_ld_high32 */
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x4;
      if (!
#line 11351 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && !TARGET_64BIT && !flag_pic))
        return -1;
      return 807; /* elf_high */

    case MEM:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MINUS
              || GET_MODE (x8) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[3] = x11;
          if (!immediate_operand (operands[3], E_SImode)
              || !
#line 11219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
            return -1;
          return 799; /* load_toc_v4_PIC_2 */

        case AND:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          switch (pattern34 (x4))
            {
            case 0:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2201; /* altivec_lvx_v4sf_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2202; /* altivec_lvx_v4sf_2op_di */

            case 2:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2219; /* altivec_lvx_v4sf_1op_si */

            case 3:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2220; /* altivec_lvx_v4sf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_108 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (pattern69 ())
    {
    case 0:
      if ((
#line 11337 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 805; /* *tocrefsi */
      break;

    case 1:
      if ((
#line 11337 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 806; /* *tocrefdi */
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 3:
          switch (XINT (x2, 1))
            {
            case 88:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (GET_MODE (x2) != E_SImode
                      || !gpc_reg_operand (operands[1], E_SImode)
                      || !symbol_ref_operand (operands[2], E_SImode))
                    return -1;
                  if (memory_operand (operands[0], E_SImode)
                      && (
#line 11367 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 809; /* *pltseq_tocsave_si */
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 11402 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 815; /* *pltseq_mtctr_si */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !symbol_ref_operand (operands[2], E_DImode))
                    return -1;
                  if (memory_operand (operands[0], E_DImode)
                      && (
#line 11367 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 810; /* *pltseq_tocsave_di */
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 11402 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 816; /* *pltseq_mtctr_di */

                default:
                  return -1;
                }

            case 89:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              switch (pattern337 (x2))
                {
                case 0:
                  if (!(
#line 11379 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 811; /* *pltseq_plt16_ha_si */

                case 1:
                  if (!(
#line 11379 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 812; /* *pltseq_plt16_ha_di */

                default:
                  return -1;
                }

            case 17:
              if (pattern222 (x2, 
E_CCmode, 
102) != 0)
                return -1;
              x5 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 103
                  || GET_MODE (x5) != E_CCmode)
                return -1;
              x6 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 104
                  || GET_MODE (x6) != E_CCmode
                  || !gpc_reg_operand (operands[0], E_SImode))
                return -1;
              return 1002; /* prologue_movesi_from_cr */

            case 445:
              if (pnum_clobbers == NULL)
                return -1;
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              if (!int_reg_operand (operands[2], E_DImode))
                return -1;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!int_reg_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !d_form_memory (operands[1], E_SImode)
                      || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3346; /* *pcrel_opt_ldsi_gpr */

                case E_DImode:
                  if (!int_reg_operand (operands[0], E_DImode)
                      || GET_MODE (x2) != E_DImode
                      || !d_form_memory (operands[1], E_DImode)
                      || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3347; /* *pcrel_opt_lddi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          return recog_109 (x1, insn, pnum_clobbers);

        case 2:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (XINT (x2, 1))
            {
            case 49:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern381 (x2, 
E_SImode) != 0
                      || !(
#line 14443 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1051; /* bpermd_si */

                case E_DImode:
                  if (pattern381 (x2, 
E_DImode) != 0
                      || !(
#line 14443 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1052; /* bpermd_di */

                default:
                  return -1;
                }

            case 65:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 14821 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 1072; /* addg6s */

            case 68:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern141 (x2, 
E_SImode) != 0
                      || !
#line 14852 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                    return -1;
                  return 1075; /* dive_si */

                case E_DImode:
                  if (pattern141 (x2, 
E_DImode) != 0
                      || !(
#line 14852 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 1077; /* dive_di */

                default:
                  return -1;
                }

            case 69:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern141 (x2, 
E_SImode) != 0
                      || !
#line 14852 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                    return -1;
                  return 1076; /* diveu_si */

                case E_DImode:
                  if (pattern141 (x2, 
E_DImode) != 0
                      || !(
#line 14852 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 1078; /* diveu_di */

                default:
                  return -1;
                }

            case 70:
              if (GET_MODE (x2) != E_DImode
                  || !const_0_to_1_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_TDmode))
                {
                  if ((
#line 14881 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                    return 1081; /* unpacktd_dm */
                  if ((
#line 14904 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                    return 1084; /* unpacktd_nodm */
                }
              if (!register_operand (operands[0], E_DImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1TImode:
                  if (!register_operand (operands[1], E_V1TImode)
                      || !
#line 14991 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1089; /* unpackv1ti */

                case E_KFmode:
                  if (!register_operand (operands[1], E_KFmode)
                      || !
#line 14991 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)))
                    return -1;
                  return 1090; /* unpackkf */

                default:
                  return -1;
                }

            case 144:
              if (GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !gpc_reg_operand (operands[1], E_V2DImode)
                  || !gpc_reg_operand (operands[2], E_V2DImode)
                  || !
#line 3646 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1502; /* vsx_vslo_v2di */

            case 145:
              if (pnum_clobbers == NULL
                  || !gpc_reg_operand (operands[2], E_DImode))
                return -1;
              switch (pattern216 (x2))
                {
                case 0:
                  if (gpc_reg_operand (operands[1], E_V2DImode)
                      && 
#line 3658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    {
                      *pnum_clobbers = 2;
                      return 1504; /* vsx_extract_v2di_var */
                    }
                  if (!memory_operand (operands[1], E_V2DImode)
                      || !
#line 3675 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1506; /* *vsx_extract_v2di_var_load */

                case 1:
                  if (gpc_reg_operand (operands[1], E_V4SImode)
                      && 
#line 4185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    {
                      *pnum_clobbers = 2;
                      return 1533; /* vsx_extract_v4si_var */
                    }
                  if (!memory_operand (operands[1], E_V4SImode)
                      || !
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1536; /* *vsx_extract_v4si_var_load */

                default:
                  return -1;
                }

            case 170:
              if (pattern341 (x2, 
E_V16QImode) != 0
                  || !
#line 5974 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1724; /* vextublx */

            case 173:
              if (pattern341 (x2, 
E_V16QImode) != 0
                  || !
#line 5985 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1725; /* vextubrx */

            case 171:
              if (pattern341 (x2, 
E_V8HImode) != 0
                  || !
#line 5996 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1726; /* vextuhlx */

            case 174:
              if (pattern341 (x2, 
E_V8HImode) != 0
                  || !
#line 6007 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1727; /* vextuhrx */

            case 172:
              if (pattern341 (x2, 
E_V4SImode) != 0
                  || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1728; /* vextuwlx */

            case 175:
              if (pattern341 (x2, 
E_V4SImode) != 0
                  || !
#line 6029 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1729; /* vextuwrx */

            case 191:
              if (GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !const_0_to_1_operand (operands[2], E_QImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (!altivec_register_operand (operands[1], E_V16QImode)
                      || !
#line 6472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1744; /* vec_cntmb_v16qi */

                case E_V8HImode:
                  if (!altivec_register_operand (operands[1], E_V8HImode)
                      || !
#line 6472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1745; /* vec_cntmb_v8hi */

                case E_V4SImode:
                  if (!altivec_register_operand (operands[1], E_V4SImode)
                      || !
#line 6472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1746; /* vec_cntmb_v4si */

                case E_V2DImode:
                  if (!altivec_register_operand (operands[1], E_V2DImode)
                      || !
#line 6472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1747; /* vec_cntmb_v2di */

                default:
                  return -1;
                }

            case 351:
              if (GET_MODE (x2) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !altivec_register_operand (operands[1], E_V2DImode)
                  || !u3bit_cint_operand (operands[2], E_QImode)
                  || !
#line 4681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2350; /* vgnb */

            case 444:
              if (GET_MODE (x2) != E_DImode
                  || !base_reg_operand (operands[0], E_DImode)
                  || !pcrel_external_address (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3343; /* pcrel_opt_ld_addr_same_reg */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case EQ:
          switch (pattern175 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 936; /* *plus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 937; /* *plus_eq_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern175 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 938; /* *plus_ne_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 939; /* *plus_ne_di */

            default:
              return -1;
            }

        case AND:
          switch (pattern45 (x1))
            {
            case 0:
              if (!
#line 1663 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2675; /* *fuse_and_add */

            case 1:
              if (!(
#line 1663 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2676; /* *fuse_and_add */

            case 2:
              if (!
#line 1699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2679; /* *fuse_nor_add */

            case 3:
              if (!(
#line 1699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2680; /* *fuse_nor_add */

            default:
              return -1;
            }

        case IOR:
          switch (pattern46 (x1))
            {
            case 0:
              if (!
#line 1681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2677; /* *fuse_nand_add */

            case 1:
              if (!(
#line 1681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2678; /* *fuse_nand_add */

            case 2:
              if (!
#line 1717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2681; /* *fuse_or_add */

            case 3:
              if (!(
#line 1717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2682; /* *fuse_or_add */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern122 (x1))
            {
            case 0:
              if (!
#line 3031 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3339; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3340; /* *fuse_add_add */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (!gpc_reg_operand (x6, E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              operands[2] = x6;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 56; /* *mulchw */

            case ASHIFTRT:
              x9 = XEXP (x7, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              operands[1] = x6;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 60; /* *mulhhw */

            default:
              return -1;
            }

        case 32L:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ASHIFTRT)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          switch (pattern294 (x3))
            {
            case 0:
              if (!
#line 6556 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1770; /* smulv2di3_highpart */

            case 1:
              if (!
#line 6556 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1771; /* smulv4si3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (!gpc_reg_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          operands[2] = x6;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_HImode)
              || !
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 58; /* *mulchwu */

        case LSHIFTRT:
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          operands[1] = x6;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 1664 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 62; /* *mulhhwu */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern47 (x3, 
SIGN_EXTEND) != 0
          || !
#line 1690 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 64; /* *mullhw */

    case ZERO_EXTEND:
      if (pattern47 (x3, 
ZERO_EXTEND) != 0
          || !
#line 1716 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 66; /* *mullhwu */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern266 (x3, 
E_SImode) != 0)
            return -1;
          return 165; /* mulsi3 */

        case E_DImode:
          if (pattern266 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 166; /* muldi3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5097 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 316; /* *mulsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5097 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 317; /* *muldf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15040 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1097; /* mulkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15040 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1098; /* multf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1338; /* *vsx_mulv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1339; /* *vsx_mulv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6577 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1774; /* mulv2di3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 803 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1909; /* mulv4si3_p8 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 193 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2440; /* muldd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 193 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2441; /* multd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 5018 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 306; /* *abssf2_fpr */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 5018 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 307; /* *absdf2_fpr */

    case E_KFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_KFmode)
          && GET_MODE (x3) == E_KFmode
          && register_operand (operands[1], E_KFmode)
          && (
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        {
          *pnum_clobbers = 1;
          return 629; /* ieee_128bit_vsx_abskf2 */
        }
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1109; /* abskf2_hw */

    case E_TFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_TFmode)
          && GET_MODE (x3) == E_TFmode
          && register_operand (operands[1], E_TFmode)
          && (
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        {
          *pnum_clobbers = 1;
          return 630; /* ieee_128bit_vsx_abstf2 */
        }
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1110; /* abstf2_hw */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 1991 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1358; /* *vsx_absv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 1991 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1359; /* *vsx_absv2df2 */

    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode)
          || !
#line 94 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2428; /* absdd2 */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 118 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2431; /* abstd2 */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          return 190; /* *divsi3 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 191; /* *divdi3 */

        case E_TImode:
          if (pattern1 (x3, 
E_TImode) != 0
              || !
#line 3441 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 198; /* divti3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 318; /* *divsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 319; /* *divdf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15050 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1099; /* divkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15050 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1100; /* divtf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1773 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1341; /* *vsx_divv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1773 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1342; /* *vsx_divv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6516 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1762; /* divv2di3 */

        case E_V4SImode:
          if (pattern2 (x3, 
E_V4SImode) != 0
              || !
#line 6516 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1763; /* divv4si3 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2442; /* divdd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2443; /* divtd3 */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern328 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 192; /* divsi3_sra */

        case E_DImode:
          if (pattern328 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 193; /* divdi3_sra */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) == SET)
    {
      res = recog_158 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      if (XWINT (x6, 0) != -1L
          || GET_CODE (x4) != SET)
        return -1;
      switch (pattern353 (x1, 
NE))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 84; /* *addsi3_imm_carry_m1 */

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 85; /* *adddi3_imm_carry_m1 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x6) != 98
          || GET_CODE (x4) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern516 (x1, 
E_SImode) != 0)
            return -1;
          return 92; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern516 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 93; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!cc_reg_operand (operands[1], E_CCmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 13540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 981; /* indirect_jumpsi_nospec */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 13540 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 982; /* indirect_jumpdi_nospec */

            default:
              return -1;
            }

        case USE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 13647 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 983; /* tablejumpsi_insn_normal */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 13647 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 984; /* tablejumpdi_insn_normal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) == SET)
        {
          res = recog_165 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x5, 1))
        {
        case 279:
          switch (pattern500 ())
            {
            case 0:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2231; /* altivec_stvx_v4si_internal */

            case 1:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2232; /* altivec_stvx_v8hi_internal */

            case 2:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2233; /* altivec_stvx_v16qi_internal */

            case 3:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2234; /* altivec_stvx_v4sf_internal */

            case 4:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2235; /* altivec_stvx_v2df_internal */

            case 5:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2236; /* altivec_stvx_v2di_internal */

            case 6:
              if (!
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2237; /* altivec_stvx_v1ti_internal */

            case 7:
              if (!(
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2238; /* altivec_stvx_kf_internal */

            case 8:
              if (!(
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2239; /* altivec_stvx_tf_internal */

            default:
              return -1;
            }

        case 280:
          switch (pattern500 ())
            {
            case 0:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2276; /* altivec_stvxl_v4si */

            case 1:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2277; /* altivec_stvxl_v8hi */

            case 2:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2278; /* altivec_stvxl_v16qi */

            case 3:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2279; /* altivec_stvxl_v4sf */

            case 4:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2280; /* altivec_stvxl_v2df */

            case 5:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2281; /* altivec_stvxl_v2di */

            case 6:
              if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2282; /* altivec_stvxl_v1ti */

            case 7:
              if (!(
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2283; /* altivec_stvxl_kf */

            case 8:
              if (!(
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2284; /* altivec_stvxl_tf */

            default:
              return -1;
            }

        case 305:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4280 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2297; /* altivec_stvlx */

        case 306:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4289 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2298; /* altivec_stvlxl */

        case 307:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2299; /* altivec_stvrx */

        case 308:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4307 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2300; /* altivec_stvrxl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_157 (x1, insn, pnum_clobbers);

    case 1:
      return recog_156 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 123:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !gpc_reg_operand (operands[0], E_V4SFmode))
            return -1;
          switch (pattern470 (x1))
            {
            case 0:
              if (!
#line 4616 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1606; /* vsx_set_v4sf_p9 */

            case 1:
              if (!
#line 4652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1607; /* *vsx_set_v4sf_p9_zero */

            case 2:
              if (!
#line 4712 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
                return -1;
              return 1609; /* *vsx_insert_extract_v4sf_p9_2 */

            default:
              return -1;
            }

        case 214:
          if (pattern349 (x1, 
E_V4SImode) != 0
              || !
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1935; /* altivec_vmsumuhs */

        case 215:
          if (pattern349 (x1, 
E_V4SImode) != 0
              || !
#line 1063 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1936; /* altivec_vmsumshs */

        case 216:
          if (pattern349 (x1, 
E_V8HImode) != 0
              || !
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1955; /* altivec_vmhaddshs */

        case 217:
          if (pattern349 (x1, 
E_V8HImode) != 0
              || !
#line 1135 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1956; /* altivec_vmhraddshs */

        case 342:
          switch (pattern351 (x1, 
342))
            {
            case 0:
              if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2333; /* bcdadd_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2335; /* bcdadd_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2341; /* *bcdadd_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2343; /* *bcdadd_test2_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern351 (x1, 
343))
            {
            case 0:
              if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2334; /* bcdsub_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2336; /* bcdsub_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2342; /* *bcdsub_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2344; /* *bcdsub_test2_v16qi */

            default:
              return -1;
            }

        case 345:
          if (GET_MODE (x3) != E_V16QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern253 (x6, 
E_CCFPmode, 
106) != 0
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode)
              || !
#line 4763 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2355; /* bcdshift_v16qi */

        case 445:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern540 (x3, 
E_QImode) != 0
                  || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3344; /* *pcrel_opt_ldqi_gpr */

            case E_HImode:
              if (pattern540 (x3, 
E_HImode) != 0
                  || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3345; /* *pcrel_opt_ldhi_gpr */

            case E_SImode:
              if (pattern540 (x3, 
E_SImode) != 0
                  || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3346; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode))
                return -1;
              if (int_reg_operand (operands[0], E_DImode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3347; /* *pcrel_opt_lddi_gpr */
              if (!vsx_register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3358; /* *pcrel_opt_lddi_vsx */

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode
                  || !d_form_memory (operands[1], E_SFmode))
                return -1;
              if (int_reg_operand (operands[0], E_SFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3348; /* *pcrel_opt_ldsf_gpr */
              if (!vsx_register_operand (operands[0], E_SFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3360; /* *pcrel_opt_ldsf_vsx */

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode
                  || !d_form_memory (operands[1], E_DFmode))
                return -1;
              if (int_reg_operand (operands[0], E_DFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3349; /* *pcrel_opt_lddf_gpr */
              if (!vsx_register_operand (operands[0], E_DFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3359; /* *pcrel_opt_lddf_vsx */

            case E_TImode:
              if (pattern541 (x3, 
E_TImode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3362; /* *pcrel_opt_ldti */

            case E_KFmode:
              if (pattern541 (x3, 
E_KFmode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3363; /* *pcrel_opt_ldkf */

            case E_V1TImode:
              if (pattern541 (x3, 
E_V1TImode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3364; /* *pcrel_opt_ldv1ti */

            case E_V2DImode:
              if (pattern541 (x3, 
E_V2DImode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3365; /* *pcrel_opt_ldv2di */

            case E_V4SImode:
              if (pattern541 (x3, 
E_V4SImode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3366; /* *pcrel_opt_ldv4si */

            case E_V8HImode:
              if (pattern541 (x3, 
E_V8HImode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3367; /* *pcrel_opt_ldv8hi */

            case E_V16QImode:
              if (pattern541 (x3, 
E_V16QImode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3368; /* *pcrel_opt_ldv16qi */

            case E_V2DFmode:
              if (pattern541 (x3, 
E_V2DFmode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3369; /* *pcrel_opt_ldv2df */

            case E_V4SFmode:
              if (pattern541 (x3, 
E_V4SFmode) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3370; /* *pcrel_opt_ldv4sf */

            case E_TFmode:
              if (pattern541 (x3, 
E_TFmode) != 0
                  || !(
#line 256 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
                return -1;
              return 3371; /* *pcrel_opt_ldtf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_159 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      switch (pattern296 (x1, 
98, 
CLOBBER))
        {
        case 0:
          if (pattern517 (x1, 
E_SImode) != 0)
            return -1;
          return 124; /* subfsi3_carry_in_xx */

        case 1:
          if (pattern517 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 125; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case PLUS:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          res = recog_160 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x7;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              res = recog_161 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x7;
          if (pattern297 (x1) == 0)
            {
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[2] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern562 (x1, 
E_SImode) == 0)
                        return 90; /* *addsi3_carry_in_internal2 */
                      break;

                    case E_DImode:
                      if (pattern562 (x1, 
E_DImode) == 0
                          && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                        return 91; /* *adddi3_carry_in_internal2 */
                      break;

                    default:
                      break;
                    }
                  break;

                case CONST_INT:
                  if (XWINT (x5, 0) == -1L)
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern563 (x1, 
E_SImode) == 0)
                            return 94; /* addsi3_carry_in_m1 */
                          break;

                        case E_DImode:
                          if (pattern563 (x1, 
E_DImode) == 0
                              && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                            return 95; /* adddi3_carry_in_m1 */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x7;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          switch (pattern250 (x1))
            {
            case 0:
              if (!
#line 3031 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3339; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 3340; /* *fuse_add_add */

            default:
              return -1;
            }

        case NOT:
          if (pattern297 (x1) != 0)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern550 (x1, 
E_SImode) != 0)
                return -1;
              return 118; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern550 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 119; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 98)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern518 (x1, 
E_SImode) != 0)
            return -1;
          return 120; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern518 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 121; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern542 (x1, 
E_SImode) != 0)
            return -1;
          return 122; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern542 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 123; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V2DFmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!vfloat_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || pattern82 (x1) != 0
          || !
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1635; /* vsx_reduc_plus_v2df */

    case AND:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 1663 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2675; /* *fuse_and_add */

        case 1:
          if (!(
#line 1663 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2676; /* *fuse_and_add */

        case 2:
          if (!
#line 1699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2679; /* *fuse_nor_add */

        case 3:
          if (!(
#line 1699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2680; /* *fuse_nor_add */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x1))
        {
        case 0:
          if (!
#line 1681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2677; /* *fuse_nand_add */

        case 1:
          if (!(
#line 1681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2678; /* *fuse_nand_add */

        case 2:
          if (!
#line 1717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2681; /* *fuse_or_add */

        case 3:
          if (!(
#line 1717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2682; /* *fuse_or_add */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      res = recog_166 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_167 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (XINT (x4, 1))
    {
    case 278:
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !
#line 3096 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2173; /* altivec_lvewx */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !
#line 3096 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2174; /* altivec_lvehx */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !
#line 3096 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2175; /* altivec_lvebx */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !
#line 3105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2176; /* *altivec_lvesfx */

        default:
          return -1;
        }

    case 282:
      switch (pattern450 ())
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2177; /* altivec_lvxl_v4si */

        case 1:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2178; /* altivec_lvxl_v8hi */

        case 2:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2179; /* altivec_lvxl_v16qi */

        case 3:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2180; /* altivec_lvxl_v4sf */

        case 4:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2181; /* altivec_lvxl_v2df */

        case 5:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2182; /* altivec_lvxl_v2di */

        case 6:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2183; /* altivec_lvxl_v1ti */

        case 7:
          if (!(
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2184; /* altivec_lvxl_kf */

        case 8:
          if (!(
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2185; /* altivec_lvxl_tf */

        default:
          return -1;
        }

    case 284:
      switch (pattern450 ())
        {
        case 0:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2186; /* altivec_lvx_v4si_internal */

        case 1:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2187; /* altivec_lvx_v8hi_internal */

        case 2:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2188; /* altivec_lvx_v16qi_internal */

        case 3:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2189; /* altivec_lvx_v4sf_internal */

        case 4:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2190; /* altivec_lvx_v2df_internal */

        case 5:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2191; /* altivec_lvx_v2di_internal */

        case 6:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2192; /* altivec_lvx_v1ti_internal */

        case 7:
          if (!(
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2193; /* altivec_lvx_kf_internal */

        case 8:
          if (!(
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2194; /* altivec_lvx_tf_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_187 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_CODE (operands[0]))
        {
        case SYMBOL_REF:
          x8 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x8))
            {
            case CLOBBER:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96
                  || !immediate_operand (operands[2], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (GET_MODE (x9) != E_SImode)
                    return -1;
                  if (current_file_function_operand (operands[0], E_SImode)
                      && (
#line 11491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 819; /* *call_localsi */
                  if (!symbol_ref_operand (operands[0], E_SImode))
                    return -1;
                  if ((
#line 11567 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 825; /* *call_nonlocal_sysvsi */
                  if (!(
#line 11688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 835; /* *call_nonlocal_aixsi */

                case E_DImode:
                  if (GET_MODE (x9) != E_DImode)
                    return -1;
                  if (current_file_function_operand (operands[0], E_DImode)
                      && (
#line 11491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 820; /* *call_localdi */
                  if (!symbol_ref_operand (operands[0], E_DImode))
                    return -1;
                  if ((
#line 11567 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 826; /* *call_nonlocal_sysvdi */
                  if (!(
#line 11688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 836; /* *call_nonlocal_aixdi */

                default:
                  return -1;
                }

            case USE:
              if (pnum_clobbers == NULL
                  || !immediate_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[0], E_SImode)
                      || !(
#line 11588 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 827; /* *call_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[0], E_DImode)
                      || !(
#line 11588 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 828; /* *call_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (current_file_function_operand (operands[0], E_SImode)
                      && immediate_operand (operands[2], E_SImode)
                      && (
#line 11930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 851; /* *sibcall_localsi */
                  if (!symbol_ref_operand (operands[0], E_SImode)
                      || !immediate_operand (operands[2], E_VOIDmode)
                      || !(
#line 11995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 857; /* *sibcall_nonlocal_sysvsi */

                case E_DImode:
                  if (current_file_function_operand (operands[0], E_DImode)
                      && immediate_operand (operands[2], E_SImode)
                      && (
#line 11930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 852; /* *sibcall_localdi */
                  if (!symbol_ref_operand (operands[0], E_DImode)
                      || !immediate_operand (operands[2], E_VOIDmode)
                      || !(
#line 11995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 858; /* *sibcall_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
        case REG:
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x8))
            {
            case CLOBBER:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[0], E_SImode)
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  if ((
#line 11539 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 823; /* *call_indirect_nonlocal_sysvsi */
                  if (!(
#line 11786 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 845; /* *call_indirect_pcrelsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[0], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  if ((
#line 11539 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 824; /* *call_indirect_nonlocal_sysvdi */
                  if (!(
#line 11786 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 846; /* *call_indirect_pcreldi */

                default:
                  return -1;
                }

            case SET:
              if (pattern501 (x8, pnum_clobbers) != 0)
                return -1;
              x10 = XEXP (x8, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[3] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern589 (x8, 
E_SImode) != 0
                      || !(
#line 11770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 843; /* *call_indirect_elfv2si */

                case E_DImode:
                  if (pattern589 (x8, 
E_DImode) != 0
                      || !(
#line 11770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 844; /* *call_indirect_elfv2di */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[0], E_SImode)
                      || !(
#line 11967 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 855; /* *sibcall_indirect_nonlocal_sysvsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[0], E_DImode)
                      || !(
#line 11967 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 856; /* *sibcall_indirect_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return NULL;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern533 (x3, 
E_V2DFmode, 
E_DFmode))
            {
            case 0:
              if (!((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_605 (insn, operands);

            case 1:
              if (!((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_606 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          switch (pattern533 (x3, 
E_V2DImode, 
E_DImode))
            {
            case 0:
              if (!((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_607 (insn, operands);

            case 1:
              if (!((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_608 (insn, operands);

            default:
              return NULL;
            }

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && (
#line 3692 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 3694 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return gen_split_613 (insn, operands);
          if (!register_operand (operands[0], E_SFmode))
            return NULL;
          switch (pattern557 ())
            {
            case 0:
              if (!((
#line 3725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_614 (insn, operands);

            case 1:
              if (!((
#line 3725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_615 (insn, operands);

            default:
              return NULL;
            }

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          if (int_reg_operand (operands[0], E_QImode)
              && altivec_register_operand (operands[1], E_V16QImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_618 (insn, operands);
          if (!const_0_to_15_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_QImode)
              && gpc_reg_operand (operands[1], E_V16QImode)
              && scratch_operand (operands[3], E_V16QImode)
              && (
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_628 (insn, operands);
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_630 (insn, operands);

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return NULL;
          if (int_reg_operand (operands[0], E_HImode)
              && altivec_register_operand (operands[1], E_V8HImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_619 (insn, operands);
          if (!const_0_to_7_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_HImode)
              && gpc_reg_operand (operands[1], E_V8HImode)
              && scratch_operand (operands[3], E_V8HImode)
              && (
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_629 (insn, operands);
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_631 (insn, operands);

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          if (int_reg_operand (operands[0], E_SImode)
              && altivec_register_operand (operands[1], E_V4SImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_620 (insn, operands);
          if (!const_0_to_3_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SImode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && scratch_operand (operands[3], E_V4SImode)
              && (
#line 4081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 4083 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( INTVAL (operands[2]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
            return gen_split_627 (insn, operands);
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_632 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_683 (insn, operands);

    case SMIN:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_684 (insn, operands);

    case SMAX:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_685 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          return split_2 (x1, insn);

        case BSWAP:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              switch (GET_CODE (operands[0]))
                {
                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (!gpc_reg_operand (operands[0], E_HImode)
                          || GET_MODE (x3) != E_HImode
                          || !gpc_reg_operand (operands[1], E_HImode)
                          || !scratch_operand (operands[2], E_SImode)
                          || !
#line 2677 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], HImode)))
                        return NULL;
                      return gen_split_50 (insn, operands);

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (operands[1], E_DImode)
                          || !
#line 3086 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                        return NULL;
                      return gen_split_57 (insn, operands);

                    default:
                      return NULL;
                    }

                case MEM:
                  if (!indexed_or_indirect_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 3038 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                    return NULL;
                  return gen_split_56 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              if (!indexed_or_indirect_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 2986 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                return NULL;
              return gen_split_55 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern355 (x1))
                {
                case 0:
                  if (!(
#line 4472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)) && 
#line 4475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_119 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_120 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (pattern252 (x3) != 0)
                return NULL;
              switch (pattern526 (x1))
                {
                case 0:
                  if (!(
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8) && 
#line 4530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_124 (insn, operands);

                case 1:
                  if (!(
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16) && 
#line 4530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case 2:
                  if (!(
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32) && 
#line 4530 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_126 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x8 = XEXP (x3, 1);
          operands[4] = x8;
          x9 = XEXP (x3, 2);
          operands[5] = x9;
          x7 = XEXP (x4, 0);
          operands[6] = x7;
          if (!scratch_operand (operands[6], E_V2DImode))
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case EQ:
            case GE:
            case GT:
              if (!fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern532 (x3))
                {
                case 0:
                  if (!(
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case 1:
                  if (!(
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case 2:
                  if (!(
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case 3:
                  if (!(
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case 4:
                  if (!((
#line 5770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5772 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_169 (insn, operands);

                case 5:
                  if (!((
#line 5770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5772 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
            case UNLE:
            case UNLT:
              if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern532 (x3))
                {
                case 0:
                  if (!(
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case 1:
                  if (!(
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_167 (insn, operands);

                case 2:
                  if (!(
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_166 (insn, operands);

                case 3:
                  if (!(
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_168 (insn, operands);

                case 4:
                  if (!((
#line 5802 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5804 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                case 5:
                  if (!((
#line 5802 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5804 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT:
          return split_5 (x1, insn);

        case UNSIGNED_FLOAT:
          switch (pattern79 (x1))
            {
            case 0:
              if (!(
#line 5976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 5978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_181 (insn, operands);

            case 1:
              if (!(
#line 7129 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS) && 
#line 7131 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_229 (insn, operands);

            case 2:
              if (!(
#line 5976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 5978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_182 (insn, operands);

            case 3:
              if (!(
#line 7004 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))) && 
#line 7006 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_226 (insn, operands);

            case 4:
              if (!((
#line 15394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_525 (insn, operands);

            case 5:
              if (!((
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_527 (insn, operands);

            case 6:
              if (!((
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_528 (insn, operands);

            case 7:
              if (!((
#line 15394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_526 (insn, operands);

            case 8:
              if (!((
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_529 (insn, operands);

            case 9:
              if (!((
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_530 (insn, operands);

            case 10:
              if (!(
#line 6016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 11:
              if (!(
#line 6016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_184 (insn, operands);

            case 12:
              if (const_0_to_3_operand (operands[2], E_QImode)
                  && scratch_operand (operands[3], E_V4SImode)
                  && (
#line 4437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
                return gen_split_640 (insn, operands);
              if (!const_int_operand (operands[2], E_QImode)
                  || !scratch_operand (operands[3], E_SImode)
                  || !(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_670 (insn, operands);

            case 13:
              if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_662 (insn, operands);

            case 14:
              if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_666 (insn, operands);

            case 15:
              if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_661 (insn, operands);

            case 16:
              if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_665 (insn, operands);

            case 17:
              if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_669 (insn, operands);

            case 18:
              if (!((
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_663 (insn, operands);

            case 19:
              if (!((
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_667 (insn, operands);

            case 20:
              if (!((
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_671 (insn, operands);

            case 21:
              if (!((
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_664 (insn, operands);

            case 22:
              if (!((
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_668 (insn, operands);

            case 23:
              if (!((
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_672 (insn, operands);

            default:
              return NULL;
            }

        case FIX:
          switch (pattern80 (x1))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SImode))
                {
                  switch (pattern477 (
E_DImode))
                    {
                    case 0:
                      if ((
#line 6326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_195 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_196 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_SImode))
                return NULL;
              switch (pattern478 ())
                {
                case 0:
                  if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_511 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_517 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              if (gpc_reg_operand (operands[0], E_QImode))
                {
                  switch (pattern477 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_199 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_203 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_QImode))
                return NULL;
              switch (pattern479 (
E_QImode))
                {
                case 0:
                  if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_507 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_513 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              if (gpc_reg_operand (operands[0], E_HImode))
                {
                  switch (pattern477 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_201 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_205 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_HImode))
                return NULL;
              switch (pattern479 (
E_HImode))
                {
                case 0:
                  if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_509 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_515 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSIGNED_FIX:
          return split_6 (x1, insn);

        case UNSPEC:
          return split_3 (x1, insn);

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 87
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x10 = XVECEXP (x6, 0, 0);
              operands[1] = x10;
              if (!input_operand (operands[1], E_SFmode))
                return NULL;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!scratch_operand (operands[2], E_V4SFmode)
                  || !(
#line 7892 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))) && 
#line 7903 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed
   && register_operand (operands[0], DImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
                return NULL;
              return gen_split_292 (insn, operands);

            case VEC_SELECT:
              x11 = XEXP (x6, 1);
              if (GET_CODE (x11) != PARALLEL
                  || XVECLEN (x11, 0) != 1)
                return NULL;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (pattern499 (x1))
                {
                case 0:
                  if (!(
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_621 (insn, operands);

                case 1:
                  if (!(
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_622 (insn, operands);

                case 2:
                  if (!(
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_623 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT_EXTEND:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DFmode))
            return NULL;
          switch (pattern357 (x1))
            {
            case 0:
              if (!((
#line 8912 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_322 (insn, operands);

            case 1:
              if (!((
#line 8912 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_323 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_V16QImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern301 (x3))
                {
                case 0:
                  if (!((
#line 9299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9301 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!((
#line 9299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9301 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_331 (insn, operands);

                default:
                  return NULL;
                }

            case ABS:
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern475 (x3, 
E_KFmode) != 0
                      || !((
#line 9357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9359 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                case E_TFmode:
                  if (pattern475 (x3, 
E_TFmode) != 0
                      || !((
#line 9357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9359 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_335 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ABS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          switch (pattern302 (x1))
            {
            case 0:
              if (!((
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_332 (insn, operands);

            case 1:
              if (!((
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_333 (insn, operands);

            default:
              return NULL;
            }

        case FLOAT_TRUNCATE:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!vsx_register_operand (operands[0], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern451 ())
            {
            case 0:
              if (!((
#line 15257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15259 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_505 (insn, operands);

            case 1:
              if (!((
#line 15257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15259 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_506 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          switch (pattern315 (x7))
            {
            case 0:
              if (!(
#line 3458 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_603 (insn, operands);

            case 1:
              if (!(
#line 3458 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_604 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          return split_4 (x1, insn);

        case PLUS:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_677 (insn, operands);

        case SMIN:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_678 (insn, operands);

        case SMAX:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_679 (insn, operands);

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_TImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER
              || pattern259 (x1, 
E_TImode, 
E_DImode, 
98) != 0)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!input_operand (operands[1], E_DImode)
              || !(
#line 5133 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10) && 
#line 5135 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        case ASHIFT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_732 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_735 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_733 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_736 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_734 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_737 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x13 = XVECEXP (x2, 0, 0);
      operands[0] = x13;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (pattern356 ())
        {
        case 0:
          if (!(
#line 14320 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return NULL;
          return gen_split_490 (insn, operands);

        case 1:
          if (!(
#line 14320 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_491 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
