/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != FLOAT
      || GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!gpc_reg_operand (operands[0], E_DFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x4, 0);
  operands[2] = x11;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[3] = x12;
  if (!gpc_reg_operand (operands[3], E_DFmode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!offsettable_mem_operand (operands[4], E_DFmode))
    return -1;
  x14 = XEXP (x7, 0);
  operands[5] = x14;
  if (!gpc_reg_operand (operands[5], E_DFmode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[6] = x15;
  if (!gpc_reg_operand (operands[6], E_SImode))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      return pattern33 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
      operands[1] = x2;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern42 (x3); /* [-1, 1] */

    case NOT:
      res = pattern44 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_DFmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_DFmode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || pattern82 (x1) != 0)
    return -1;
  return 0;
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || pattern104 (
E_SImode) != 0)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (pattern104 (
E_DImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern104 (
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  return 0;
}

int
pattern128 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return pattern127 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      res = pattern127 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode)
          || !altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode)
          || !altivec_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode)
          || !altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!altivec_register_operand (operands[1], E_V2DImode)
          || !altivec_register_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern174 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern174 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  if (!cc_reg_operand (operands[3], E_CCmode))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern191 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern191 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern203 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern202 (x1, 
i1); /* [-1, 3] */
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 445)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  return pattern236 (x1); /* [-1, 23] */
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern232 (x4, 
i1); /* [-1, 0] */
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return pattern237 (x6); /* [-1, 23] */

    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          res = pattern242 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        case NOT:
          res = pattern246 (x6);
          if (res >= 0)
            return res + 48; /* [48, 71] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 3)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 96)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_logical_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern266 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern274 (x1); /* [-1, 11] */

    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          res = pattern277 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        case NOT:
          res = pattern280 (x1);
          if (res >= 0)
            return res + 24; /* [24, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern322 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern333 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern349 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], E_V8HImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1)
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern394 (x4, 
i1); /* [-1, 0] */
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern417 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !rs6000_tls_symbol_ref (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern419 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !zero_fp_constant (operands[4], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !zero_fp_constant (operands[4], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || GET_MODE (x4) != E_SImode)
    return -1;
  x11 = XEXP (x5, 0);
  if (!gpc_reg_operand (x11, E_SImode))
    return -1;
  x12 = XEXP (x4, 1);
  if (GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x8, 1);
  if (GET_MODE (x14) != E_SImode)
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_zero_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[4], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[4], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern467 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern466 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_DImode:
      if (pattern466 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern479 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !scratch_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !scratch_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !scratch_operand (operands[2], i1))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], i1))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern504 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!vsx_register_operand (operands[2], E_SFmode)
          || !vsx_register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!vsx_register_operand (operands[2], E_DFmode)
          || !vsx_register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern520 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern528 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern535 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_15_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !int_reg_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || pattern374 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern552 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          return pattern551 (x7, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_QImode:
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern571 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern571 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern584 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V2DFmode)
      || !vsx_register_operand (operands[2], E_V2DFmode)
      || !vsx_register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  return 0;
}

int
pattern591 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[0], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern601 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x6, 0);
  if (!gpc_reg_operand (x13, E_SImode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern326 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5618 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 369; /* *setnbc_cc_si */

        case 1:
          if (!
#line 5618 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 371; /* *setnbc_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern326 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5618 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 370; /* *setnbc_cc_di */

        case 1:
          if (!(
#line 5618 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 372; /* *setnbc_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      res = recog_10 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_CODE (x3))
    {
    case GE:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern426 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 377; /* *fselsfsf4 */

            case 1:
              if (!
#line 5652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 379; /* *fselsfdf4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern426 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 378; /* *fseldfsf4 */

            case 1:
              if (!
#line 5652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 380; /* *fseldfdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x8 = XEXP (x2, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern505 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 385; /* *movsfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 387; /* *movsfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern505 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 386; /* *movdfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 388; /* *movdfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern506 (x2, 
E_KFmode) != 0
              || !(
#line 5802 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 395; /* *movkfcc_invert_p10 */

        case E_TFmode:
          if (pattern506 (x2, 
E_TFmode) != 0
              || !(
#line 5802 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 396; /* *movtfcc_invert_p10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern489 (x2, 
E_V4SImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1868; /* altivec_vselv4si */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                return -1;
              return 1878; /* altivec_vselv4si2 */

            case E_V8HImode:
              if (pattern489 (x2, 
E_V8HImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V8HImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1869; /* altivec_vselv8hi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                return -1;
              return 1879; /* altivec_vselv8hi2 */

            case E_V16QImode:
              if (pattern489 (x2, 
E_V16QImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V16QImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1870; /* altivec_vselv16qi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V16QImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                return -1;
              return 1880; /* altivec_vselv16qi2 */

            case E_V4SFmode:
              if (pattern489 (x2, 
E_V4SFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1871; /* altivec_vselv4sf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                return -1;
              return 1881; /* altivec_vselv4sf2 */

            case E_V2DFmode:
              if (pattern489 (x2, 
E_V2DFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1872; /* altivec_vselv2df */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                return -1;
              return 1882; /* altivec_vselv2df2 */

            case E_V2DImode:
              if (pattern489 (x2, 
E_V2DImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1873; /* altivec_vselv2di */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                return -1;
              return 1883; /* altivec_vselv2di2 */

            case E_V1TImode:
              if (pattern489 (x2, 
E_V1TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V1TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1874; /* altivec_vselv1ti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V1TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                return -1;
              return 1884; /* altivec_vselv1ti2 */

            case E_TImode:
              if (pattern489 (x2, 
E_TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1875; /* altivec_vselti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                return -1;
              return 1885; /* altivec_vselti2 */

            case E_KFmode:
              if (pattern489 (x2, 
E_KFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_KFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1876; /* altivec_vselkf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_KFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 1886; /* altivec_vselkf2 */

            case E_TFmode:
              if (pattern489 (x2, 
E_TFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1877; /* altivec_vseltf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 1887; /* altivec_vseltf2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern53 (x2, 
E_SImode) != 0
                  || !
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2625; /* *fuse_andc_or */

            case E_DImode:
              if (pattern53 (x2, 
E_DImode) != 0
                  || !(
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2626; /* *fuse_andc_or */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3109; /* *fuse_vandc_vor */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3110; /* *fuse_vandc_vor */

            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3111; /* *fuse_vandc_vor */

            case E_V4SFmode:
              if (pattern54 (x2, 
E_V4SFmode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3112; /* *fuse_vandc_vor */

            case E_V2DFmode:
              if (pattern54 (x2, 
E_V2DFmode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3113; /* *fuse_vandc_vor */

            case E_V2DImode:
              if (pattern54 (x2, 
E_V2DImode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3114; /* *fuse_vandc_vor */

            case E_V1TImode:
              if (pattern54 (x2, 
E_V1TImode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3115; /* *fuse_vandc_vor */

            case E_TImode:
              if (pattern54 (x2, 
E_TImode) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3116; /* *fuse_vandc_vor */

            case E_KFmode:
              if (pattern54 (x2, 
E_KFmode) != 0
                  || !(
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3117; /* *fuse_vandc_vor */

            case E_TFmode:
              if (pattern54 (x2, 
E_TFmode) != 0
                  || !(
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3118; /* *fuse_vandc_vor */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (pattern57 (x2))
            {
            case 0:
              if (!
#line 1393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2645; /* *fuse_andc_orc */

            case 1:
              if (!(
#line 1393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2646; /* *fuse_andc_orc */

            case 2:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3189; /* *fuse_vandc_vorc */

            case 3:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3190; /* *fuse_vandc_vorc */

            case 4:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3191; /* *fuse_vandc_vorc */

            case 5:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3192; /* *fuse_vandc_vorc */

            case 6:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3193; /* *fuse_vandc_vorc */

            case 7:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3194; /* *fuse_vandc_vorc */

            case 8:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3195; /* *fuse_vandc_vorc */

            case 9:
              if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3196; /* *fuse_vandc_vorc */

            case 10:
              if (!(
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3197; /* *fuse_vandc_vorc */

            case 11:
              if (!(
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3198; /* *fuse_vandc_vorc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (pattern52 (x2))
        {
        case 0:
          if (!
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2631; /* *fuse_nor_or */

        case 1:
          if (!(
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2632; /* *fuse_nor_or */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3139; /* *fuse_vnor_vor */

        case 3:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3140; /* *fuse_vnor_vor */

        case 4:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3141; /* *fuse_vnor_vor */

        case 5:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3142; /* *fuse_vnor_vor */

        case 6:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3143; /* *fuse_vnor_vor */

        case 7:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3144; /* *fuse_vnor_vor */

        case 8:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3145; /* *fuse_vnor_vor */

        case 9:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3146; /* *fuse_vnor_vor */

        case 10:
          if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3147; /* *fuse_vnor_vor */

        case 11:
          if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3148; /* *fuse_vnor_vor */

        case 12:
          if (!
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2651; /* *fuse_nor_orc */

        case 13:
          if (!(
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2652; /* *fuse_nor_orc */

        case 14:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3219; /* *fuse_vnor_vorc */

        case 15:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3220; /* *fuse_vnor_vorc */

        case 16:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3221; /* *fuse_vnor_vorc */

        case 17:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3222; /* *fuse_vnor_vorc */

        case 18:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3223; /* *fuse_vnor_vorc */

        case 19:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3224; /* *fuse_vnor_vorc */

        case 20:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3225; /* *fuse_vnor_vorc */

        case 21:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3226; /* *fuse_vnor_vorc */

        case 22:
          if (!(
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3227; /* *fuse_vnor_vorc */

        case 23:
          if (!(
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3228; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 653; /* p8_xxpermdi_ti */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 654; /* p8_xxpermdi_v16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 655; /* p8_xxpermdi_v8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 656; /* p8_xxpermdi_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 657; /* p8_xxpermdi_v4sf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 658; /* p8_xxpermdi_v2di */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 659; /* p8_xxpermdi_v2df */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 660; /* p8_xxpermdi_v1ti */

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !(
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 661; /* p8_xxpermdi_kf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !(
#line 9624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 662; /* p8_xxpermdi_tf */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !rs6000_tls_symbol_ref (operands[1], E_SImode)
              || !(
#line 10566 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 746; /* *tls_gd_pcrel32 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !rs6000_tls_symbol_ref (operands[1], E_DImode)
              || !(
#line 10566 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 747; /* *tls_gd_pcrel64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern417 (x3, 
E_SImode) != 0
              || !(
#line 10575 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 748; /* *tls_gd32 */

        case E_DImode:
          if (pattern417 (x3, 
E_DImode) != 0
              || !(
#line 10575 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 749; /* *tls_gd64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u7bit_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1693; /* xvtstdcsp */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1694; /* xvtstdcdp */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      switch (pattern460 (
E_DImode))
        {
        case 0:
          if (!
#line 5261 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1676; /* xsiexpdp_si */

        case 1:
          if (!(
#line 5261 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1677; /* xsiexpdp_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern460 (
E_DFmode))
        {
        case 0:
          if (!
#line 5271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1678; /* xsiexpdpf_si */

        case 1:
          if (!(
#line 5271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1679; /* xsiexpdpf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6820 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 479; /* btruncsf2 */

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 6820 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return 480; /* btruncdf2 */
      if (!vsx_register_operand (operands[0], E_DFmode)
          || !vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1412; /* *vsx_b2truncdf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15467 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1179; /* btrunckf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15467 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1180; /* btrunctf2 */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1413; /* *vsx_b2truncv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1414; /* *vsx_b2truncv2df2 */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!input_operand (operands[1], E_SFmode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || !
#line 7832 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      *pnum_clobbers = 1;
      return 569; /* movsi_from_sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x4) != E_SFmode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 7938 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      return 571; /* *movsi_from_df */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1191; /* sqrtkf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15532 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1192; /* sqrttf2_odd */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15593 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1201; /* trunckfdf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15593 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1202; /* trunctfdf2_odd */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_3_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_DDmode:
          if (pattern381 (x3, 
E_DDmode) != 0
              || !
#line 406 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2469; /* dfp_dqua_dd */

        case E_TDmode:
          if (pattern381 (x3, 
E_TDmode) != 0
              || !
#line 406 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2470; /* dfp_dqua_td */

        default:
          return -1;
        }

    case CONST_INT:
      if (!s5bit_cint_operand (operands[1], E_SImode))
        return -1;
      switch (pattern382 (x3))
        {
        case 0:
          if (!
#line 417 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2471; /* dfp_dquai_dd */

        case 1:
          if (!
#line 417 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2472; /* dfp_dquai_td */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_105 (x1, insn, pnum_clobbers);

    case 1:
      return recog_106 (x1, insn, pnum_clobbers);

    case 3:
      return recog_107 (x1, insn, pnum_clobbers);

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (XINT (x2, 1))
        {
        case 208:
          if (pattern436 (x2, 
E_V16QImode) != 0
              || !u3bit_cint_operand (operands[4], E_QImode)
              || !
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1786; /* xxpermx_inst */

        case 203:
          if (pattern436 (x2, 
E_V2DImode) != 0
              || !u8bit_cint_operand (operands[4], E_QImode)
              || !
#line 6759 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1787; /* xxeval */

        case 373:
          if (pattern437 (x2, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[4], E_SImode)
              || !
#line 624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2410; /* mma_pmxvf32ger */

        case 378:
          if (pattern437 (x2, 
E_OOmode) != 0
              || !const_0_to_3_operand (operands[4], E_SImode)
              || !
#line 649 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2415; /* mma_pmxvf64ger */

        default:
          return -1;
        }

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      switch (XINT (x2, 1))
        {
        case 387:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !u8bit_cint_operand (operands[5], E_SImode)
              || !
#line 571 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2394; /* mma_pmxvi4ger8 */

        case 383:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2396; /* mma_pmxvi16ger2 */

        case 385:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2397; /* mma_pmxvi16ger2s */

        case 368:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2398; /* mma_pmxvf16ger2 */

        case 363:
          if (pattern534 () != 0
              || !
#line 598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2399; /* mma_pmxvbf16ger2 */

        case 377:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2411; /* mma_pmxvf32gerpp */

        case 376:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2412; /* mma_pmxvf32gerpn */

        case 375:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2413; /* mma_pmxvf32gernp */

        case 374:
          if (pattern535 () != 0
              || !
#line 637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2414; /* mma_pmxvf32gernn */

        case 382:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2416; /* mma_pmxvf64gerpp */

        case 381:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2417; /* mma_pmxvf64gerpn */

        case 380:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2418; /* mma_pmxvf64gernp */

        case 379:
          if (pattern536 () != 0
              || !
#line 662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2419; /* mma_pmxvf64gernn */

        case 389:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !const_0_to_15_operand (operands[5], E_SImode)
              || !
#line 675 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2420; /* mma_pmxvi8ger4 */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_0_to_15_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      switch (XINT (x2, 1))
        {
        case 388:
          if (!u8bit_cint_operand (operands[6], E_SImode)
              || !
#line 585 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2395; /* mma_pmxvi4ger8pp */

        case 384:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2400; /* mma_pmxvi16ger2pp */

        case 386:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2401; /* mma_pmxvi16ger2spp */

        case 372:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2402; /* mma_pmxvf16ger2pp */

        case 371:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2403; /* mma_pmxvf16ger2pn */

        case 370:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2404; /* mma_pmxvf16ger2np */

        case 369:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2405; /* mma_pmxvf16ger2nn */

        case 367:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2406; /* mma_pmxvbf16ger2pp */

        case 366:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2407; /* mma_pmxvbf16ger2pn */

        case 365:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2408; /* mma_pmxvbf16ger2np */

        case 364:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2409; /* mma_pmxvbf16ger2nn */

        case 390:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2421; /* mma_pmxvi8ger4pp */

        case 391:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2422; /* mma_pmxvi8ger4spp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (pattern30 (x2))
    {
    case 0:
      switch (GET_MODE (x2))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2242; /* altivec_stvx_v8hi_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2243; /* altivec_stvx_v8hi_2op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2250; /* altivec_stvx_v2di_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2251; /* altivec_stvx_v2di_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (x2))
        {
        case E_V8HImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2260; /* altivec_stvx_v8hi_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2261; /* altivec_stvx_v8hi_1op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2268; /* altivec_stvx_v2di_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2269; /* altivec_stvx_v2di_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DImode)
              && memory_operand (operands[1], E_V2DImode)
              && 
#line 1393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1319; /* vsx_ld_elemrev_v2di */
          if (memory_operand (operands[0], E_V2DImode)
              && vsx_register_operand (operands[1], E_V2DImode))
            {
              if (
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
                return 1328; /* vsx_st_elemrev_v2di */
              if (
#line 1625 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
                return 1331; /* *vsx_st_elemrev_v2di_internal */
            }
          if (vsx_register_operand (operands[0], E_V2DImode))
            {
              if (vsx_register_operand (operands[1], E_V2DImode))
                {
                  if (
#line 3280 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode)))
                    return 1465; /* *vsx_xxpermdi2_le_v2di */
                  if (
#line 3333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1471; /* xxswapd_v2di */
                }
              if (memory_operand (operands[1], E_V2DImode)
                  && 
#line 3391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
                return 1478; /* *vsx_lxvd2x2_le_v2di */
            }
          if (!memory_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 3440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1484; /* *vsx_stxvd2x2_le_v2di */

        case E_V2DFmode:
          if (GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 1413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1321; /* vsx_ld_elemrev_v2df */
          if (memory_operand (operands[0], E_V2DFmode)
              && vsx_register_operand (operands[1], E_V2DFmode)
              && 
#line 1554 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1327; /* vsx_st_elemrev_v2df */
          if (vsx_register_operand (operands[0], E_V2DFmode))
            {
              if (vsx_register_operand (operands[1], E_V2DFmode))
                {
                  if (
#line 3280 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode)))
                    return 1464; /* *vsx_xxpermdi2_le_v2df */
                  if (
#line 3333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1470; /* xxswapd_v2df */
                }
              if (memory_operand (operands[1], E_V2DFmode)
                  && 
#line 3391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
                return 1477; /* *vsx_lxvd2x2_le_v2df */
            }
          if (!memory_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3440 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
            return -1;
          return 1483; /* *vsx_stxvd2x2_le_v2df */

        default:
          return -1;
        }

    case 1:
      return recog_122 (x1, insn, pnum_clobbers);

    case 4:
      if (pattern226 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 3L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 2L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 1L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode)
                  && memory_operand (operands[1], E_V4SImode)
                  && 
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return 1322; /* vsx_ld_elemrev_v4si */
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 1583 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1330; /* vsx_st_elemrev_v4si */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && memory_operand (operands[1], E_V4SFmode)
                  && 
#line 1433 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return 1323; /* vsx_ld_elemrev_v4sf */
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1329; /* vsx_st_elemrev_v4sf */

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 3L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 1L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode))
                {
                  if (vsx_register_operand (operands[1], E_V4SFmode)
                      && 
#line 3322 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1468; /* xxswapd_v4sf */
                  if (memory_operand (operands[1], E_V4SFmode)
                      && 
#line 3401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                    return 1479; /* *vsx_lxvd2x4_le_v4sf */
                }
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 3450 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                return -1;
              return 1485; /* *vsx_stxvd2x4_le_v4sf */

            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode))
                {
                  if (vsx_register_operand (operands[1], E_V4SImode)
                      && 
#line 3322 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1469; /* xxswapd_v4si */
                  if (memory_operand (operands[1], E_V4SImode)
                      && 
#line 3401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                    return 1480; /* *vsx_lxvd2x4_le_v4si */
                }
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 3450 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                return -1;
              return 1486; /* *vsx_stxvd2x4_le_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 8:
      if (pattern225 (x4) != 0
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 7L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 6L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 5L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 4L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 3L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 2L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 1L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode)
              && memory_operand (operands[1], E_V8HImode)
              && 
#line 1479 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1324; /* *vsx_ld_elemrev_v8hi_internal */
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1332; /* *vsx_st_elemrev_v8hi_internal */

        case 4L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 5L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 7L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 0L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 2L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 3L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode))
            {
              if (vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 3310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1467; /* xxswapd_v8hi */
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 3413 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
                return 1481; /* *vsx_lxvd2x8_le_V8HI */
            }
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 3489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1489; /* *vsx_stxvd2x8_le_V8HI */

        default:
          return -1;
        }

    case 16:
      if (pattern224 (x4) != 0
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 15L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 14L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 13L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 12L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 11L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 10L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 8L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 7L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 6L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 5L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 4L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 3L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 2L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 1L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode)
              && memory_operand (operands[1], E_V16QImode)
              && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1325; /* vsx_ld_elemrev_v16qi_internal */
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 1690 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1333; /* *vsx_st_elemrev_v16qi_internal */

        case 8L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 9L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 10L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 11L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 13L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 14L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 15L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 0L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 1L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 2L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 3L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 4L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 5L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 6L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 7L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode))
            {
              if (vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1466; /* xxswapd_v16qi */
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 3429 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
                return 1482; /* *vsx_lxvd2x16_le_V16QI */
            }
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 3505 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1490; /* *vsx_stxvd2x16_le_V16QI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
                    {
                      *pnum_clobbers = 1;
                      return 411; /* floatunssisf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7118 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    return 505; /* floatunsdisf2_fcfidus */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7129 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    {
                      *pnum_clobbers = 1;
                      return 506; /* *floatunsdisf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_SFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 421; /* *floatunsqisf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 422; /* *floatunshisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 412; /* floatunssidf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6994 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDU))
                    return 500; /* *floatunsdidf2_fcfidu */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7004 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
                    {
                      *pnum_clobbers = 1;
                      return 501; /* *floatunsdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_DFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 423; /* *floatunsqidf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 424; /* *floatunshidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 493; /* floatunstikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1167; /* floatuns_kfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1169; /* floatuns_kfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1171; /* floatunsqikf2 */

            case 3:
              if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1172; /* floatunshikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 494; /* floatunstitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1168; /* floatuns_tfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1170; /* floatuns_tfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1173; /* floatunsqitf2 */

            case 3:
              if (!(
#line 15414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1174; /* floatunshitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1398; /* vsx_floatunsv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1433; /* vsx_xvcvuxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1399; /* vsx_floatunsv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1435; /* vsx_xvcvuxddp */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern66 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 6016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 413; /* floatunssisf2_lfiwzx_mem */

        case 1:
          if (!
#line 6016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 414; /* floatunssidf2_lfiwzx_mem */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6744 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 471; /* *roundu32sf2_fprs */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6744 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 472; /* *roundu32df2_fprs */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern68 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1445; /* vsx_xvcvuxwdp_be */

        case 1:
          if (!
#line 2640 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1447; /* vsx_xvcvuxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1570; /* *vsx_extract_si_unsfloat_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1600; /* *vsx_ext_SI_ufl_df */

        case 3:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1592; /* *vsx_ext_QI_ufl_df */

        case 4:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1596; /* *vsx_ext_HI_ufl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1572; /* *vsx_extract_si_unsfloat_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1599; /* *vsx_ext_SI_ufl_sf */

        case 6:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1591; /* *vsx_ext_QI_ufl_sf */

        case 7:
          if (!
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1595; /* *vsx_ext_HI_ufl_sf */

        case 8:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1574; /* *vsx_extract_si_unsfloat_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1576; /* *vsx_extract_si_unsfloat_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1601; /* *vsx_ext_SI_ufl_kf */

        case 10:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1593; /* *vsx_ext_QI_ufl_kf */

        case 11:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1597; /* *vsx_ext_HI_ufl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1578; /* *vsx_extract_si_unsfloat_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1602; /* *vsx_ext_SI_ufl_tf */

        case 13:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1594; /* *vsx_ext_QI_ufl_tf */

        case 14:
          if (!(
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1598; /* *vsx_ext_HI_ufl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 22; /* extendqisi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode))
                return -1;
              return 28; /* *extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode)
                  || !
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 23; /* extendqidi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode)
                  || !
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 29; /* *extendhidi2 */

            case E_SImode:
              if (!lwa_operand (operands[1], E_SImode)
                  || !
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 34; /* extendsidi2 */

            default:
              return -1;
            }

        case E_TImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_DImode)
              || !
#line 5133 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10))
            return -1;
          *pnum_clobbers = 1;
          return 1657; /* extendditi2 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern38 (x3) != 0
          || !
#line 2388 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 126; /* *subfsi3_carry_in_xx_64 */

    case ASHIFTRT:
      if (pnum_clobbers == NULL
          || pattern36 (x3) != 0
          || !
#line 4906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *ashrsi3_64 */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 3)
        return -1;
      switch (pattern208 (x4))
        {
        case 0:
          if (!int_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!d_form_memory (operands[1], E_SImode)
                  || !(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3350; /* *pcrel_opt_ldsi_di_gpr */

            case E_HImode:
              if (!d_form_memory (operands[1], E_HImode)
                  || !(
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3354; /* *pcrel_opt_ldhi_di_gpr */

            default:
              return -1;
            }

        case 1:
          if (!int_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !d_form_memory (operands[1], E_HImode)
              || !
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          *pnum_clobbers = 1;
          return 3352; /* *pcrel_opt_ldhi_si_gpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern37 (x3, 
E_SImode, 
32, 
E_DImode) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 179; /* smulsi3_highpart_64 */

        case ZERO_EXTEND:
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 180; /* umulsi3_highpart_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_TImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1315; /* vsx_stxvrbx */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1316; /* vsx_stxvrhx */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1317; /* vsx_stxvrwx */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1318; /* vsx_stxvrdx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern403 (x6))
        {
        case 0:
          if (!
#line 835 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2583; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2584; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2939; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2940; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2941; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2942; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2943; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2944; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2945; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2946; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2947; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2948; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2585; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2586; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2949; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2950; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2951; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2952; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2953; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2954; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2955; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2956; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2957; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2958; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2591; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2592; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2979; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2980; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2981; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2982; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2983; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2984; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2985; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2986; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2987; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2988; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern406 (x6))
        {
        case 0:
          if (!
#line 871 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2587; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2588; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2959; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2960; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2961; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2962; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2963; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2964; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2965; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2966; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2967; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2968; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern407 (x6))
        {
        case 0:
          if (!
#line 889 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2589; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2590; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2969; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2970; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2971; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2972; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2973; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2974; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2975; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2976; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2977; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2978; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2595; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2596; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2999; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3000; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3001; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3002; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3003; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3004; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3005; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3006; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3007; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3008; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2593; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2594; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2989; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2990; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2991; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2992; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2993; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2994; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2995; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2996; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2997; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2998; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern393 (x6, 
E_SImode) != 0
                  || !
#line 961 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2597; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern393 (x6, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2598; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern395 (x6, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3009; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern395 (x6, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3010; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern395 (x6, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3011; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern395 (x6, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3012; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern395 (x6, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3013; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern395 (x6, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3014; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern395 (x6, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3015; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern395 (x6, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3016; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern395 (x6, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3017; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern395 (x6, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3018; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern527 (x6, 
E_SImode) != 0
                  || !
#line 1231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2627; /* *fuse_eqv_or */

            case E_DImode:
              if (pattern527 (x6, 
E_DImode) != 0
                  || !(
#line 1231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2628; /* *fuse_eqv_or */

            case E_V4SImode:
              if (pattern528 (x6, 
E_V4SImode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3119; /* *fuse_veqv_vor */

            case E_V8HImode:
              if (pattern528 (x6, 
E_V8HImode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3120; /* *fuse_veqv_vor */

            case E_V16QImode:
              if (pattern528 (x6, 
E_V16QImode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3121; /* *fuse_veqv_vor */

            case E_V4SFmode:
              if (pattern528 (x6, 
E_V4SFmode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3122; /* *fuse_veqv_vor */

            case E_V2DFmode:
              if (pattern528 (x6, 
E_V2DFmode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3123; /* *fuse_veqv_vor */

            case E_V2DImode:
              if (pattern528 (x6, 
E_V2DImode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3124; /* *fuse_veqv_vor */

            case E_V1TImode:
              if (pattern528 (x6, 
E_V1TImode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3125; /* *fuse_veqv_vor */

            case E_TImode:
              if (pattern528 (x6, 
E_TImode) != 0
                  || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3126; /* *fuse_veqv_vor */

            case E_KFmode:
              if (pattern528 (x6, 
E_KFmode) != 0
                  || !(
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3127; /* *fuse_veqv_vor */

            case E_TFmode:
              if (pattern528 (x6, 
E_TFmode) != 0
                  || !(
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3128; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 979 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2599; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2600; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern408 (x6))
        {
        case 0:
          if (!
#line 997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2601; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2602; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern519 (x1, 
E_SImode) != 0)
                    return -1;
                  return 108; /* subfsi3_imm */

                case E_DImode:
                  if (pattern519 (x1, 
E_DImode) != 0
                      || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 109; /* subfdi3_imm */

                default:
                  return -1;
                }

            case SET:
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != LEU)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x9, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern564 (x1, 
E_SImode) != 0
                      || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 112; /* subfsi3_carry */

                case E_DImode:
                  if (pattern564 (x1, 
E_DImode) != 0
                      || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 113; /* subfdi3_carry */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              switch (pattern472 (x3))
                {
                case 0:
                  if (!
#line 1807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2691; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2692; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern474 (x3))
                {
                case 0:
                  if (!
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2695; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2696; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case NOT:
              switch (pattern474 (x3))
                {
                case 0:
                  if (!
#line 1825 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2693; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2694; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern472 (x3))
                {
                case 0:
                  if (!
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2697; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2698; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2683; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2684; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2687; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2688; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2685; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2686; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2689; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2690; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  if (pnum_clobbers != NULL)
    {
      switch (pattern199 (x1))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (current_file_function_operand (operands[1], E_SImode)
                  && (
#line 11512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                {
                  *pnum_clobbers = 1;
                  return 821; /* *call_value_localsi */
                }
              if (symbol_ref_operand (operands[1], E_SImode)
                  && unspec_tls (operands[2], E_SImode))
                {
                  if ((
#line 11637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 831; /* *call_value_nonlocal_sysvsi */
                    }
                  if ((
#line 11705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 837; /* *call_value_nonlocal_aixsi */
                    }
                }
              break;

            case E_DImode:
              if (current_file_function_operand (operands[1], E_DImode)
                  && (
#line 11512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 822; /* *call_value_localdi */
                }
              if (symbol_ref_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 832; /* *call_value_nonlocal_sysvdi */
                    }
                  if ((
#line 11705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 838; /* *call_value_nonlocal_aixdi */
                    }
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (indirect_call_operand (operands[1], E_SImode)
                  && unspec_tls (operands[2], E_SImode))
                {
                  if ((
#line 11609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 829; /* *call_value_indirect_nonlocal_sysvsi */
                    }
                  if ((
#line 11823 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 849; /* *call_value_indirect_pcrelsi */
                    }
                }
              break;

            case E_DImode:
              if (indirect_call_operand (operands[1], E_DImode)
                  && unspec_tls (operands[2], E_DImode))
                {
                  if ((
#line 11609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 830; /* *call_value_indirect_nonlocal_sysvdi */
                    }
                  if ((
#line 11823 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 850; /* *call_value_indirect_pcreldi */
                    }
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SIMPLE_RETURN)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!call_operand (operands[1], E_SImode)
          || !(
#line 12080 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 865; /* *sibcall_value_aixsi */

    case E_DImode:
      if (!call_operand (operands[1], E_DImode)
          || !(
#line 12080 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 866; /* *sibcall_value_aixdi */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case FLOAT:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern305 (x1))
            {
            case 0:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 417; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 418; /* *floathisf2_internal */

            case 2:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 419; /* *floatqidf2_internal */

            case 3:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 420; /* *floathidf2_internal */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM)
            return -1;
          switch (pattern199 (x1))
            {
            case 0:
              if (pattern483 (x1, 
96, 
USE) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              x8 = XEXP (x5, 0);
              operands[4] = x8;
              if (!register_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x9 = XEXP (x6, 0);
                  if (GET_MODE (x9) != E_SImode
                      || !(
#line 11662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 833; /* *call_value_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x9 = XEXP (x6, 0);
                  if (GET_MODE (x9) != E_DImode
                      || !(
#line 11662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 834; /* *call_value_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case 1:
              switch (pattern484 (x1, pnum_clobbers))
                {
                case 0:
                  x5 = XVECEXP (x1, 0, 2);
                  x8 = XEXP (x5, 0);
                  operands[4] = x8;
                  x6 = XVECEXP (x1, 0, 3);
                  x10 = XEXP (x6, 1);
                  x11 = XVECEXP (x10, 0, 0);
                  operands[5] = x11;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SImode:
                      if (pattern596 (x6, 
E_SImode) != 0
                          || !(
#line 11749 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 841; /* *call_value_indirect_aixsi */

                    case E_DImode:
                      if (pattern596 (x6, 
E_DImode) != 0
                          || !(
#line 11749 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 842; /* *call_value_indirect_aixdi */

                    default:
                      return -1;
                    }

                case 1:
                  x5 = XVECEXP (x1, 0, 2);
                  x12 = XEXP (x5, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  operands[4] = x13;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SImode:
                      if (pattern597 (x1, 
E_SImode) != 0
                          || !(
#line 11806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      return 847; /* *call_value_indirect_elfv2si */

                    case E_DImode:
                      if (pattern597 (x1, 
E_DImode) != 0
                          || !(
#line 11806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      return 848; /* *call_value_indirect_elfv2di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 888; /* eqsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 908; /* eqsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 898; /* eqdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 918; /* eqdidi2_isel */

            default:
              return -1;
            }

        case NE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          x8 = XEXP (x5, 0);
          operands[4] = x8;
          x9 = XEXP (x6, 0);
          operands[5] = x9;
          switch (pattern529 (x3))
            {
            case 0:
              if (
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return 889; /* nesisi2_isel */
              break;

            case 1:
              if ((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 909; /* nesidi2_isel */
              break;

            case 2:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && scratch_operand (operands[5], E_CCmode)
                  && (
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 899; /* nedisi2_isel */
              if (scc_eq_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && scratch_operand (operands[4], E_SImode)
                  && scratch_operand (operands[5], E_DImode)
                  && (
#line 13248 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 945; /* *nesi3_extdi */
              break;

            case 3:
              if ((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 919; /* nedidi2_isel */
              break;

            default:
              break;
            }
          if (GET_CODE (x9) != REG)
            return -1;
          switch (pattern531 (x1))
            {
            case 0:
              if (!(
#line 12993 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 930; /* *nesi3 */

            case 1:
              if (!(
#line 12993 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 931; /* *nedi3 */

            default:
              return -1;
            }

        case LT:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 890; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 910; /* ltsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 900; /* ltdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 920; /* ltdidi2_isel */

            default:
              return -1;
            }

        case LTU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 891; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 911; /* ltusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 901; /* ltudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 921; /* ltudidi2_isel */

            default:
              return -1;
            }

        case GT:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 892; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 912; /* gtsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 902; /* gtdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 922; /* gtdidi2_isel */

            default:
              return -1;
            }

        case GTU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 893; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 913; /* gtusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 903; /* gtudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 923; /* gtudidi2_isel */

            default:
              return -1;
            }

        case LE:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 894; /* lesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 914; /* lesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 904; /* ledisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 924; /* ledidi2_isel */

            default:
              return -1;
            }

        case LEU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 895; /* leusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 915; /* leusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 905; /* leudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 925; /* leudidi2_isel */

            default:
              return -1;
            }

        case GE:
          switch (pattern112 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 896; /* gesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 916; /* gesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 906; /* gedisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 926; /* gedidi2_isel */

            default:
              return -1;
            }

        case GEU:
          switch (pattern115 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 897; /* geusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 917; /* geusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 907; /* geudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 927; /* geudidi2_isel */

            default:
              return -1;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern308 (x1))
            {
            case 0:
              if (!(
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 932; /* *neg_eq_si */

            case 1:
              if (!(
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 933; /* *neg_eq_di */

            case 2:
              if (!(
#line 13058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 934; /* *neg_ne_si */

            case 3:
              if (!(
#line 13058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 935; /* *neg_ne_di */

            default:
              return -1;
            }

        case PLUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern311 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 936; /* *plus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 937; /* *plus_eq_di */

            case 2:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 938; /* *plus_ne_si */

            case 3:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 939; /* *plus_ne_di */

            default:
              return -1;
            }

        case MINUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern314 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 940; /* *minus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 941; /* *minus_eq_di */

            case 2:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 942; /* *minus_ne_si */

            case 3:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 943; /* *minus_ne_di */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pattern116 (x1) != 0)
            return -1;
          x15 = XEXP (x3, 1);
          x17 = XEXP (x15, 0);
          operands[0] = x17;
          x4 = XVECEXP (x1, 0, 1);
          x16 = XEXP (x4, 0);
          operands[2] = x16;
          x5 = XVECEXP (x1, 0, 2);
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              switch (pattern578 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 990; /* bdz_si */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 992; /* bdz_di */

                default:
                  return -1;
                }

            case NE:
              switch (pattern578 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 991; /* bdnz_si */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 993; /* bdnz_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x18 = XVECEXP (x15, 0, 0);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern482 (x1))
            {
            case 0:
              if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1644; /* *vsx_reduc_plus_v4sf_scalar */

            case 1:
              if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1645; /* *vsx_reduc_smin_v4sf_scalar */

            case 2:
              if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1646; /* *vsx_reduc_smax_v4sf_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != MEM)
        return -1;
      switch (pattern117 (x1))
        {
        case 0:
          if (pattern483 (x1, 
96, 
USE) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!symbol_ref_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x9 = XEXP (x6, 0);
              if (GET_MODE (x9) != E_SImode
                  || !(
#line 11588 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 827; /* *call_nonlocal_sysv_securesi */

            case E_DImode:
              if (!symbol_ref_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x9 = XEXP (x6, 0);
              if (GET_MODE (x9) != E_DImode
                  || !(
#line 11588 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 828; /* *call_nonlocal_sysv_securedi */

            default:
              return -1;
            }

        case 1:
          switch (pattern484 (x1, pnum_clobbers))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              x6 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x6, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[4] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern591 (x6, 
E_SImode) != 0
                      || !(
#line 11728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 839; /* *call_indirect_aixsi */

                case E_DImode:
                  if (pattern591 (x6, 
E_DImode) != 0
                      || !(
#line 11728 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 840; /* *call_indirect_aixdi */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x5, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[3] = x13;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern592 (x1, 
E_SImode) != 0
                      || !(
#line 11770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 843; /* *call_indirect_elfv2si */

                case E_DImode:
                  if (pattern592 (x1, 
E_DImode) != 0
                      || !(
#line 11770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 844; /* *call_indirect_elfv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case MEM:
          operands[1] = x4;
          if (!indexed_or_indirect_operand (operands[1], E_HImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!altivec_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
                return NULL;
              return gen_split_15 (insn, operands);

            case E_DImode:
              if (!altivec_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (vsx_register_operand (operands[1], E_SImode)
              && int_reg_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && (
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && reload_completed) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return gen_split_21 (insn, operands);
          if (!altivec_register_operand (operands[1], E_SImode)
              || !altivec_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && !TARGET_P9_VECTOR && reload_completed))
            return NULL;
          return gen_split_22 (insn, operands);

        case PLUS:
          if (pattern38 (x2) != 0
              || !(
#line 2388 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 2390 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(1)))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2708 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], SImode)))
        return NULL;
      return gen_split_51 (insn, operands);

    case ASHIFT:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != SIGN_EXTEND
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_mem_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!u6bit_cint_operand (operands[2], E_DImode)
          || !(
#line 4707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && MEM_P (operands[1]))))
        return NULL;
      return gen_split_137 (insn, operands);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_VOIDmode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!gpc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 4984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 4984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !
#line 4984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V4SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !
#line 4984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V2DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !reg_or_mem_operand (operands[1], E_SFmode)
              || !(
#line 5241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)) && 
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && REG_P (operands[1]) && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_IFmode:
          switch (pattern205 (x2))
            {
            case 0:
              if (!((
#line 8930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8932 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_324 (insn, operands);

            case 1:
              if (!(
#line 9461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9464 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            default:
              return NULL;
            }

        case E_TFmode:
          if (GET_MODE (x2) != E_TFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern316 ())
                {
                case 0:
                  if (((
#line 8930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8932 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_325 (insn, operands);
                  break;

                case 1:
                  if ((
#line 9448 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_336 (insn, operands);
                  break;

                case 2:
                  if ((
#line 9448 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_337 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !(
#line 15211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_503 (insn, operands);

        case E_KFmode:
          if (GET_MODE (x2) != E_KFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9464 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_339 (insn, operands);
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !(
#line 15227 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_504 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_157 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_158 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      return split_16 (x1, insn);

    case NOT:
      return split_17 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
    case VEC_DUPLICATE:
      return split_15 (x1, insn);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_DFmode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !((
#line 8978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_326 (insn, operands);

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !((
#line 8978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_327 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case PLUS:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XEXP (x2, 1);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern359 (x2, 
E_SImode) == 0)
                    return gen_split_33 (insn, operands);
                  break;

                case E_DImode:
                  if (pattern359 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return gen_split_34 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) == ASHIFT)
                {
                  switch (pattern219 (x2))
                    {
                    case 0:
                      if ((
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_105 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_107 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case ASHIFT:
              switch (pattern207 (x2))
                {
                case 0:
                  if (
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                    return gen_split_109 (insn, operands);
                  break;

                case 1:
                  if ((
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return gen_split_112 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case UNSPEC:
          res = split_14 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern69 ())
        {
        case 0:
          if (((
#line 11337 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 11340 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_400 (insn, operands);
          break;

        case 1:
          if (((
#line 11337 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 11340 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_401 (insn, operands);
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 70
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_TDmode))
        return NULL;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return NULL;
      if (((
#line 14881 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14883 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_495 (insn, operands);
      if (!((
#line 14904 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_498 (insn, operands);

    case ORDERED:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_464 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_468 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_558 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_562 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_465 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_469 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_543 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_550 (insn, operands);

        default:
          return NULL;
        }

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_466 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_470 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_547 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_554 (insn, operands);

        default:
          return NULL;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_467 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_471 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_545 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_552 (insn, operands);

        default:
          return NULL;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_472 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_478 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_555 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_559 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_473 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_479 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_542 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_549 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!cc_reg_operand (operands[1], E_CCFPmode))
        return NULL;
      switch (pattern9 (x2))
        {
        case 0:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_474 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_480 (insn, operands);

        default:
          return NULL;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_475 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_481 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_546 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_553 (insn, operands);

        default:
          return NULL;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_476 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_482 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_544 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_551 (insn, operands);

        default:
          return NULL;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_477 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_483 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_556 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_560 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !(
#line 13342 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13344 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_484 (insn, operands);

    case COMPARE:
      if (GET_MODE (x2) != E_CCEQmode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!branch_comparison_operator (x4, E_VOIDmode))
        return NULL;
      operands[1] = x4;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 1);
      if (!branch_comparison_operator (x6, E_VOIDmode))
        return NULL;
      operands[3] = x6;
      x10 = XEXP (x6, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      x11 = XEXP (x6, 0);
      operands[4] = x11;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return NULL;
      return gen_split_485 (insn, operands);

    case LT:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_541 (insn, operands);

        case 1:
          if (!(
#line 606 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_548 (insn, operands);

        default:
          return NULL;
        }

    case UNORDERED:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_557 (insn, operands);

        case 1:
          if (!(
#line 653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_561 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ROTATE)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern215 (x2))
        {
        case 0:
          if (!(
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_582 (insn, operands);

        case 1:
          if (!(
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_583 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 4
          || pattern29 (x1) != 0
          || !(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)) && 
#line 458 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_742 (insn, operands);

    default:
      return NULL;
    }
}
