/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          return 0;

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          return 1;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0)
            return -1;
          return 2;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0)
            return -1;
          return 3;

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0)
            return -1;
          return 6;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) != 0)
            return -1;
          return 7;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern4 (x3) != 0)
        return -1;
      return 10;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 102
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x6, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!cc_reg_operand (operands[1], i1))
    return -1;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  return pattern63 (x3); /* [-1, 23] */
}

int
pattern69 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !small_toc_ref (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !small_toc_ref (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[2], E_DImode))
    return -1;
  return pattern70 (); /* [-1, 2] */
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SFmode:
      res = pattern74 (x3, 
E_SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_KFmode:
      res = pattern74 (x3, 
E_KFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_TFmode:
      res = pattern74 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern104 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XVECEXP (x4, 0, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[3] = x10;
  x11 = XEXP (x6, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern106 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern106 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern106 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      return pattern134 (x3, 
E_KFmode); /* [-1, 0] */

    case E_TFmode:
      if (pattern134 (x3, 
E_TFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern141 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 6;

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0)
        return -1;
      return 7;

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      return pattern179 (x1); /* [-1, 1] */

    case SET:
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      res = pattern183 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern192 (x5); /* [-1, 1] */

    case NOT:
      res = pattern194 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !gpc_reg_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !gpc_reg_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != i1)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern201 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern201 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern234 (x3, 
i1); /* [-1, 0] */
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern238 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern238 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern239 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern239 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern239 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern239 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern239 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern239 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern239 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern239 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern239 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern239 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern240 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern240 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern241 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern241 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern241 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern241 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern241 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern241 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern241 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern241 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern241 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern241 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern280 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern277 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern274 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 98)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern304 (x4, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern304 (x4, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern320 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_IFmode)
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_TFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern367 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              return pattern385 (
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern385 (
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern386 (
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern386 (
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern387 (x5, 
E_SImode) != 0)
                    return -1;
                  return 4;

                case E_DImode:
                  if (pattern387 (x5, 
E_DImode) != 0)
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern388 (x5, 
E_SImode) != 0)
                    return -1;
                  return 6;

                case E_DImode:
                  if (pattern388 (x5, 
E_DImode) != 0)
                    return -1;
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 0);
          operands[2] = x11;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern389 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 8;

                case E_DImode:
                  if (pattern389 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern390 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 10;

                case E_DImode:
                  if (pattern390 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern449 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (XWINT (x13, 0) != 1L
      || pattern413 (x1) != 0)
    return -1;
  return 0;
}

int
pattern465 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern473 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern473 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern484 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 3)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2)
        return -1;
      return 0;

    case SET:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 3)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 2)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 96)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    case E_V4SImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V16QImode:
      return 4;

    case E_V2DImode:
      return 5;

    case E_V1TImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern529 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !scratch_operand (operands[3], E_SImode)
          || !scratch_operand (operands[4], E_SImode)
          || !scratch_operand (operands[5], E_CCmode))
        return -1;
      return pattern109 (); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !reg_or_short_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !scratch_operand (operands[4], E_DImode)
              || !scratch_operand (operands[5], E_CCmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern547 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern559 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !memory_operand (operands[3], E_SImode))
            return -1;
          return 0;

        case E_DFmode:
          if (!gpc_reg_operand (operands[2], E_DFmode)
              || !memory_operand (operands[3], E_DFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !memory_operand (operands[3], E_DImode))
            return -1;
          return 2;

        case E_DFmode:
          if (!gpc_reg_operand (operands[2], E_DFmode)
              || !memory_operand (operands[3], E_DFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern594 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern599 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x11 = XEXP (x4, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x5, 0);
  operands[2] = x13;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x8, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern327 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 373; /* *setnbcr_cc_si */

        case 1:
          if (!
#line 5627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 375; /* *setnbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern327 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 374; /* *setnbcr_cc_di */

        case 1:
          if (!(
#line 5627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 376; /* *setnbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!cc_reg_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  switch (GET_CODE (x8))
    {
    case RETURN:
      if (!
#line 13383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 968; /* *creturn */

    case SIMPLE_RETURN:
      return 969; /* *creturn */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern63 (x3))
        {
        case 0:
          if (!
#line 367 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2531; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2532; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2699; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2700; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2701; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2702; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2703; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2704; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2705; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2706; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2707; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2708; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2551; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2552; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2779; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2780; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2781; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2782; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2783; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2784; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2785; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2786; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2787; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2788; /* *fuse_vand_vandc */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern58 (x3))
            {
            case 0:
              if (!
#line 385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2533; /* *fuse_andc_and */

            case 1:
              if (!(
#line 385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2534; /* *fuse_andc_and */

            case 2:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2709; /* *fuse_vandc_vand */

            case 3:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2710; /* *fuse_vandc_vand */

            case 4:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2711; /* *fuse_vandc_vand */

            case 5:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2712; /* *fuse_vandc_vand */

            case 6:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2713; /* *fuse_vandc_vand */

            case 7:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2714; /* *fuse_vandc_vand */

            case 8:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2715; /* *fuse_vandc_vand */

            case 9:
              if (!
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2716; /* *fuse_vandc_vand */

            case 10:
              if (!(
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2717; /* *fuse_vandc_vand */

            case 11:
              if (!(
#line 1897 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2718; /* *fuse_vandc_vand */

            case 12:
              if (!
#line 565 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2553; /* *fuse_andc_andc */

            case 13:
              if (!(
#line 565 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2554; /* *fuse_andc_andc */

            case 14:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2789; /* *fuse_vandc_vandc */

            case 15:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2790; /* *fuse_vandc_vandc */

            case 16:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2791; /* *fuse_vandc_vandc */

            case 17:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2792; /* *fuse_vandc_vandc */

            case 18:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2793; /* *fuse_vandc_vandc */

            case 19:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2794; /* *fuse_vandc_vandc */

            case 20:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2795; /* *fuse_vandc_vandc */

            case 21:
              if (!
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2796; /* *fuse_vandc_vandc */

            case 22:
              if (!(
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2797; /* *fuse_vandc_vandc */

            case 23:
              if (!(
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2798; /* *fuse_vandc_vandc */

            default:
              return -1;
            }

        case NOT:
          switch (pattern52 (x3))
            {
            case 0:
              if (!
#line 439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2539; /* *fuse_nor_and */

            case 1:
              if (!(
#line 439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2540; /* *fuse_nor_and */

            case 2:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2739; /* *fuse_vnor_vand */

            case 3:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2740; /* *fuse_vnor_vand */

            case 4:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2741; /* *fuse_vnor_vand */

            case 5:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2742; /* *fuse_vnor_vand */

            case 6:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2743; /* *fuse_vnor_vand */

            case 7:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2744; /* *fuse_vnor_vand */

            case 8:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2745; /* *fuse_vnor_vand */

            case 9:
              if (!
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2746; /* *fuse_vnor_vand */

            case 10:
              if (!(
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2747; /* *fuse_vnor_vand */

            case 11:
              if (!(
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2748; /* *fuse_vnor_vand */

            case 12:
              if (!
#line 619 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2559; /* *fuse_nor_andc */

            case 13:
              if (!(
#line 619 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2560; /* *fuse_nor_andc */

            case 14:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2819; /* *fuse_vnor_vandc */

            case 15:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2820; /* *fuse_vnor_vandc */

            case 16:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2821; /* *fuse_vnor_vandc */

            case 17:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2822; /* *fuse_vnor_vandc */

            case 18:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2823; /* *fuse_vnor_vandc */

            case 19:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2824; /* *fuse_vnor_vandc */

            case 20:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2825; /* *fuse_vnor_vandc */

            case 21:
              if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2826; /* *fuse_vnor_vandc */

            case 22:
              if (!(
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2827; /* *fuse_vnor_vandc */

            case 23:
              if (!(
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2828; /* *fuse_vnor_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 896; /* gesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 916; /* gesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 906; /* gedisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 926; /* gedidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2175 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1385; /* *vsx_gev4sf */
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || !altivec_register_operand (operands[1], E_V4SFmode)
          || !altivec_register_operand (operands[2], E_V4SFmode)
          || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1867; /* *altivec_gev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern2 (x2, 
E_V2DFmode) != 0
          || !
#line 2175 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1386; /* *vsx_gev2df */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 13)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern490 (x3, 
E_SImode) != 0
              || !(
#line 169 "../../gcc-15.0.1-20250313/gcc/config/rs6000/darwin.md"
(DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 1; /* macho_correct_pic_si */

        case E_DImode:
          if (pattern490 (x3, 
E_DImode) != 0
              || !(
#line 169 "../../gcc-15.0.1-20250313/gcc/config/rs6000/darwin.md"
(DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 2; /* macho_correct_pic_di */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern380 (x3, 
E_SImode) == 0)
            return 68; /* *addsi3 */
          break;

        case E_DImode:
          if (pattern380 (x3, 
E_DImode) == 0
              && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 69; /* *adddi3 */
          break;

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) == 0
              && 
#line 5061 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return 312; /* *addsf3_fpr */
          break;

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) == 0
              && 
#line 5061 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return 313; /* *adddf3_fpr */
          break;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) == 0
              && (
#line 15020 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 1093; /* addkf3 */
          break;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) == 0
              && (
#line 15020 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 1094; /* addtf3 */
          break;

        case E_V4SFmode:
          if (GET_MODE (x3) == E_V4SFmode)
            {
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && 
#line 1702 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1334; /* *vsx_addv4sf3 */
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return 1823; /* *altivec_addv4sf3 */
            }
          break;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) == 0
              && 
#line 1702 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1335; /* *vsx_addv2df3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 1819; /* addv4si3 */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 1820; /* addv8hi3 */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 1821; /* addv16qi3 */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 1822; /* addv2di3 */
          break;

        case E_V1TImode:
          if (pattern3 (x3, 
E_V1TImode) == 0
              && 
#line 4433 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
            return 2322; /* addv1ti3 */
          break;

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) == 0
              && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return 2436; /* adddd3 */
          break;

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) == 0
              && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return 2437; /* addtd3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern458 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 92; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern458 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 93; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    case HIGH:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != CONST)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!symbol_ref_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!symbol_ref_operand (operands[3], E_SImode)
          || !
#line 11231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic))
        return -1;
      return 800; /* load_toc_v4_PIC_3b */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode)
          || !
#line 3360 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1473; /* xxgenpcvm_v16qi_internal */

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode)
          || !
#line 3360 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1474; /* xxgenpcvm_v8hi_internal */

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[1], E_V4SImode)
          || !
#line 3360 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1475; /* xxgenpcvm_v4si_internal */

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[1], E_V2DImode)
          || !
#line 3360 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1476; /* xxgenpcvm_v2di_internal */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !rs6000_tls_symbol_ref (operands[1], E_SImode)
              || !(
#line 10756 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 780; /* *tls_got_tprel_pcrel_32 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !rs6000_tls_symbol_ref (operands[1], E_DImode)
              || !(
#line 10756 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 781; /* *tls_got_tprel_pcrel_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern221 (x3))
        {
        case 0:
          if (!(
#line 10768 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 782; /* tls_got_tprel_32 */

        case 1:
          if (!(
#line 10768 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 783; /* tls_got_tprel_64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 4510 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2330; /* altivec_vbpermq */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2331; /* altivec_vbpermq2 */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_OOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_OOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode)
      || !
#line 383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
    return -1;
  return 2358; /* *vsx_assemble_pair */
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode)
      || !
#line 15834 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC && TARGET_64BIT))
    return -1;
  return 1211; /* *cmpeqb_internal */
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!u6bit_cint_operand (operands[1], E_QImode)
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 6455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1738; /* vec_mtvsrbmi */

    case REG:
    case SUBREG:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1739; /* vec_mtvsr_v16qi */

        case E_V8HImode:
          if (!altivec_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1740; /* vec_mtvsr_v8hi */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1741; /* vec_mtvsr_v4si */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1742; /* vec_mtvsr_v2di */

        case E_V1TImode:
          if (!altivec_register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1743; /* vec_mtvsr_v1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9580 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 648; /* p8_mtvsrd_v16qidi2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9614 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 652; /* p8_mtvsrd_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !
#line 9679 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 673; /* p8_mtvsrd_sf */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1429; /* vsx_xscvspdpn */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2480 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1431; /* vsx_xscvspdpn_directmove */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 5200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1659; /* xsxexpqp_kf_v2di */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 5200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1661; /* xsxexpqp_tf_v2di */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!u5bit_cint_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern132 (x3, 
E_V16QImode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode)))
        return -1;
      return 1625; /* vsx_xxsldwi_v16qi */

    case E_V8HImode:
      if (pattern132 (x3, 
E_V8HImode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode)))
        return -1;
      return 1626; /* vsx_xxsldwi_v8hi */

    case E_V4SImode:
      if (pattern132 (x3, 
E_V4SImode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1627; /* vsx_xxsldwi_v4si */

    case E_V2DImode:
      if (pattern132 (x3, 
E_V2DImode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1628; /* vsx_xxsldwi_v2di */

    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1629; /* vsx_xxsldwi_v4sf */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
        return -1;
      return 1630; /* vsx_xxsldwi_v2df */

    case E_V1TImode:
      if (pattern132 (x3, 
E_V1TImode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V1TImode)))
        return -1;
      return 1631; /* vsx_xxsldwi_v1ti */

    case E_TImode:
      if (pattern132 (x3, 
E_TImode) != 0
          || !
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TImode)))
        return -1;
      return 1632; /* vsx_xxsldwi_ti */

    case E_KFmode:
      if (pattern132 (x3, 
E_KFmode) != 0
          || !(
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (KFmode)) && 
#line 58 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1633; /* vsx_xxsldwi_kf */

    case E_TFmode:
      if (pattern132 (x3, 
E_TFmode) != 0
          || !(
#line 4907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TFmode)) && 
#line 59 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1634; /* vsx_xxsldwi_tf */

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case MULT:
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case SIGN_EXTEND:
              switch (pattern467 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 3200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(SImode == SImode && TARGET_POWERPC64)))
                    return -1;
                  return 171; /* *smulsi3_highpart */

                case 1:
                  if (!(
#line 3200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(DImode == SImode && TARGET_POWERPC64)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 173; /* *smuldi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern467 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 3200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(SImode == SImode && TARGET_POWERPC64)))
                    return -1;
                  return 172; /* *umulsi3_highpart */

                case 1:
                  if (!(
#line 3200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(DImode == SImode && TARGET_POWERPC64)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 174; /* *umuldi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_TImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT
              || GET_MODE (x5) != E_TImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (pattern548 (x4))
            {
            case 0:
              if (!
#line 3314 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 183; /* madddi4_highpart */

            case 1:
              if (!
#line 3314 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 184; /* umadddi4_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_DImode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      switch (pattern509 (x4, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!
#line 3213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && !TARGET_POWERPC64))
            return -1;
          return 175; /* smulsi3_highpart_le */

        case 1:
          if (!
#line 3213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && !TARGET_POWERPC64))
            return -1;
          return 176; /* umulsi3_highpart_le */

        default:
          return -1;
        }

    case 8:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_TImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case MULT:
          switch (pattern509 (x4, 
E_DImode, 
E_TImode))
            {
            case 0:
              if (!
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 177; /* smuldi3_highpart_le */

            case 1:
              if (!
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 178; /* umuldi3_highpart_le */

            default:
              return -1;
            }

        case PLUS:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT
              || GET_MODE (x5) != E_TImode)
            return -1;
          switch (pattern548 (x4))
            {
            case 0:
              if (!
#line 3326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && !BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 185; /* madddi4_highpart_le */

            case 1:
              if (!
#line 3326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && !BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 186; /* umadddi4_highpart_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          switch (XINT (x4, 1))
            {
            case 14:
              if (GET_MODE (x4) != E_DImode
                  || !rs6000_tls_symbol_ref (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[2], E_DImode)
                  || !(
#line 10598 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 751; /* *tls_gd_high64 */

            case 23:
              if (GET_MODE (x4) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode)
                  || !rs6000_tls_symbol_ref (operands[2], E_DImode)
                  || !(
#line 10711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 771; /* *tls_got_dtprel_high64 */

            case 27:
              if (GET_MODE (x4) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode)
                  || !rs6000_tls_symbol_ref (operands[2], E_DImode)
                  || !(
#line 10791 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 785; /* *tls_got_tprel_high64 */

            case 47:
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !
#line 11286 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
                return -1;
              return 802; /* *largetoc_high */

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 15
              || GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 10644 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 759; /* *tls_ld_high64 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 47)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (!add_cint_operand (operands[3], E_DImode)
          || !
#line 11306 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
        return -1;
      return 803; /* *largetoc_high_plus */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DImode)
              && 
#line 4787 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
            return 1611; /* vsx_splat_v2di_reg */
          if (!memory_operand (operands[1], E_DImode)
              || !
#line 4797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
            return -1;
          return 1613; /* vsx_splat_v2di_mem */

        case E_V4SImode:
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !splat_input_operand (operands[1], E_SImode)
              || !
#line 4806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1614; /* vsx_splat_v4si */

        default:
          return -1;
        }

    case TRUNCATE:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 4820 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1615; /* vsx_splat_v4si_di */

        case E_V8HImode:
          if (!altivec_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || GET_MODE (x3) != E_HImode
              || !altivec_register_operand (operands[1], E_DImode)
              || !
#line 4880 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1622; /* vsx_vsplth_di */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SImode)
              && vsx_register_operand (operands[1], E_V4SImode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
            return 1618; /* vsx_xxspltw_v4si */
          if (!register_operand (operands[0], E_V4SImode)
              || !register_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2067; /* *altivec_vspltw_internal */

        case E_V8HImode:
          if (pattern438 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 2372 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2065; /* *altivec_vsplth_internal */

        default:
          return -1;
        }

    case CONST_INT:
      operands[1] = x3;
      if (!s5bit_cint_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !
#line 2461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2070; /* altivec_vspltisw */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !
#line 2461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2071; /* altivec_vspltish */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 127; /* negsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 128; /* negdi2 */

        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5044 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 310; /* *negsf2_fpr */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 5044 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 311; /* *negdf2_fpr */

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x3) != E_IFmode
              || !gpc_reg_operand (operands[1], E_IFmode)
              || !(
#line 9205 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return -1;
          return 623; /* negif2_internal */

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9205 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
            return 624; /* negtf2_internal */
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_TFmode)
              && register_operand (operands[1], E_TFmode)
              && (
#line 9299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            {
              *pnum_clobbers = 1;
              return 626; /* ieee_128bit_vsx_negtf2 */
            }
          if (!altivec_register_operand (operands[0], E_TFmode)
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15122 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1108; /* negtf2_hw */

        case E_KFmode:
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_KFmode)
              && GET_MODE (x3) == E_KFmode
              && register_operand (operands[1], E_KFmode)
              && (
#line 9299 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            {
              *pnum_clobbers = 1;
              return 625; /* ieee_128bit_vsx_negkf2 */
            }
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15122 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1107; /* negkf2_hw */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1356; /* *vsx_negv4sf2 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1357; /* *vsx_negv2df2 */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !altivec_register_operand (operands[1], E_V4SImode)
              || !
#line 3731 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2289; /* *p9_negv4si2 */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !altivec_register_operand (operands[1], E_V2DImode)
              || !
#line 3731 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2290; /* *p9_negv2di2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 87 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2427; /* negdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 108 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2430; /* negtd2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern213 (x3, 
E_SFmode) != 0
              || !
#line 5029 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 308; /* *nabssf2_fpr */

        case E_DFmode:
          if (pattern213 (x3, 
E_DFmode) != 0
              || !
#line 5029 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 309; /* *nabsdf2_fpr */

        case E_KFmode:
          if (pnum_clobbers != NULL
              && pattern271 (x3, 
E_KFmode) == 0
              && (
#line 9357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            {
              *pnum_clobbers = 1;
              return 633; /* *ieee_128bit_vsx_nabskf2 */
            }
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || GET_MODE (x4) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15143 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1111; /* *nabskf2_hw */

        case E_TFmode:
          if (pnum_clobbers != NULL
              && pattern271 (x3, 
E_TFmode) == 0
              && (
#line 9357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            {
              *pnum_clobbers = 1;
              return 634; /* *ieee_128bit_vsx_nabstf2 */
            }
          if (!altivec_register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || GET_MODE (x4) != E_TFmode
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15143 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1112; /* *nabstf2_hw */

        case E_V4SFmode:
          if (pattern214 (x3, 
E_V4SFmode) != 0
              || !
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1360; /* vsx_nabsv4sf2 */

        case E_V2DFmode:
          if (pattern214 (x3, 
E_V2DFmode) != 0
              || !
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1361; /* vsx_nabsv2df2 */

        case E_DDmode:
          if (pattern213 (x3, 
E_DDmode) != 0
              || !
#line 101 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2429; /* *nabsdd2_fpr */

        case E_TDmode:
          if (pattern213 (x3, 
E_TDmode) != 0
              || !
#line 128 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2432; /* *nabstd2_fpr */

        default:
          return -1;
        }

    case EQ:
    case GT:
    case LT:
    case GTU:
    case LTU:
    case UNORDERED:
      operands[1] = x4;
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern121 (x3, 
EQ))
        {
        case 0:
          if (!(
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          *pnum_clobbers = 3;
          return 932; /* *neg_eq_si */

        case 1:
          if (!(
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 3;
          return 933; /* *neg_eq_di */

        default:
          return -1;
        }

    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      operands[1] = x4;
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern121 (x3, 
NE))
        {
        case 0:
          if (!(
#line 13058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          *pnum_clobbers = 3;
          return 934; /* *neg_ne_si */

        case 1:
          if (!(
#line 13058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 3;
          return 935; /* *neg_ne_di */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern364 (x3, 
E_SFmode) != 0
                  || !
#line 14538 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1057; /* *nfmasf4_fpr */

            case E_DFmode:
              if (pattern364 (x3, 
E_DFmode) != 0
                  || !
#line 14538 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1058; /* *nfmadf4_fpr */

            case E_KFmode:
              if (pattern365 (x3, 
E_KFmode) != 0
                  || !(
#line 15179 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1117; /* *nfmakf4_hw */

            case E_TFmode:
              if (pattern365 (x3, 
E_TFmode) != 0
                  || !(
#line 15179 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1118; /* *nfmatf4_hw */

            case E_V4SFmode:
              if (pattern366 (x3, 
E_V4SFmode) != 0
                  || !
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1377; /* *vsx_nfmav4sf4 */

            case E_V2DFmode:
              if (pattern366 (x3, 
E_V2DFmode) != 0
                  || !
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1378; /* *vsx_nfmav2df4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern367 (x3, 
E_SFmode) != 0
                  || !
#line 14565 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1059; /* *nfmssf4_fpr */

            case E_DFmode:
              if (pattern367 (x3, 
E_DFmode) != 0
                  || !
#line 14565 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1060; /* *nfmssf4_fpr */

            case E_KFmode:
              if (pattern368 (x3, 
E_KFmode) != 0
                  || !(
#line 15192 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1119; /* *nfmskf4_hw */

            case E_TFmode:
              if (pattern368 (x3, 
E_TFmode) != 0
                  || !(
#line 15192 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1120; /* *nfmstf4_hw */

            case E_V4SFmode:
              if (GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V4SFmode
                  || GET_MODE (x7) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[3], E_V4SFmode)
                  && 
#line 2134 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1379; /* *vsx_nfmsv4sf4 */
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[3], E_V4SFmode)
                  || !
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1928; /* *altivec_vnmsubfp */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_V2DFmode
                  || !vsx_register_operand (operands[1], E_V2DFmode)
                  || !vsx_register_operand (operands[2], E_V2DFmode)
                  || GET_MODE (x7) != E_V2DFmode
                  || !vsx_register_operand (operands[3], E_V2DFmode)
                  || !
#line 2148 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1380; /* *vsx_nfmsv2df4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 82)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern454 (x3, 
E_KFmode) != 0
                  || !(
#line 15570 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1197; /* *nfmakf4_odd */

            case E_TFmode:
              if (pattern454 (x3, 
E_TFmode) != 0
                  || !(
#line 15570 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1198; /* *nfmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x12 = XEXP (x11, 0);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern455 (x3, 
E_KFmode) != 0
                  || !(
#line 15584 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1199; /* *nfmskf4_odd */

            case E_TFmode:
              if (pattern455 (x3, 
E_TFmode) != 0
                  || !(
#line 15584 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1200; /* *nfmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_mem_operand (operands[1], E_QImode))
                return -1;
              return 7; /* zero_extendqisi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode))
                return -1;
              return 13; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_mem_operand (operands[1], E_QImode)
                  || !
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 8; /* zero_extendqidi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode)
                  || !
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 14; /* zero_extendhidi2 */

            case E_SImode:
              if (!reg_or_mem_operand (operands[1], E_SImode)
                  || !
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 19; /* zero_extendsidi2 */

            default:
              return -1;
            }

        case E_TImode:
          if (!vsx_register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!memory_operand (operands[1], E_QImode)
                  || !
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1311; /* vsx_lxvrbx */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1312; /* vsx_lxvrhx */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1313; /* vsx_lxvrwx */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1314; /* vsx_lxvrdx */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 2610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 150; /* *bswaphi2_extenddi */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !
#line 2610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 151; /* *bswapsi2_extenddi */

            default:
              return -1;
            }

        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !memory_operand (operands[1], E_HImode))
            return -1;
          return 152; /* *bswaphi2_extendsi */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern36 (x3) != 0
          || !
#line 4579 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 277; /* *rotlsi3_64 */

    case ASHIFT:
      if (pattern36 (x3) != 0
          || !
#line 4647 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 284; /* *ashlsi3_64 */

    case LSHIFTRT:
      if (pattern36 (x3) != 0
          || !
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 294; /* *lshrsi3_64 */

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          switch (XINT (x4, 1))
            {
            case 87:
              if (pnum_clobbers == NULL
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !input_operand (operands[1], E_SFmode)
                  || !
#line 7892 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *movdi_from_sf_zero_ext */

            case 168:
              switch (pattern363 ())
                {
                case 0:
                  if (!
#line 5954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1712; /* *vclzlsbb_zext_v16qi */

                case 1:
                  if (!
#line 5954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1714; /* *vclzlsbb_zext_v8hi */

                case 2:
                  if (!
#line 5954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1716; /* *vclzlsbb_zext_v4si */

                default:
                  return -1;
                }

            case 169:
              switch (pattern363 ())
                {
                case 0:
                  if (!
#line 5954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1713; /* *vctzlsbb_zext_v16qi */

                case 1:
                  if (!
#line 5954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1715; /* *vctzlsbb_zext_v8hi */

                case 2:
                  if (!
#line 5954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1717; /* *vctzlsbb_zext_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern208 (x4))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3351; /* *pcrel_opt_ldsi_udi_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3355; /* *pcrel_opt_ldhi_udi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !(
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3357; /* *pcrel_opt_ldqi_udi_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !
#line 185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3353; /* *pcrel_opt_ldhi_usi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3356; /* *pcrel_opt_ldqi_usi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (vsx_register_operand (operands[1], E_V4SImode)
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x4) == E_SImode)
        {
          x8 = XVECEXP (x7, 0, 0);
          operands[2] = x8;
          if (const_int_operand (operands[2], E_QImode)
              && 
#line 3957 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
            {
              *pnum_clobbers = 1;
              return 1515; /* *mfvsrwz */
            }
        }
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1519; /* *vsx_extract_v16qi_di_p9 */

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1520; /* *vsx_extract_v8hi_di_p9 */

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode)
              || !
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1521; /* *vsx_extract_v4si_di_p9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_HImode)
          && memory_operand (operands[1], E_HImode))
        return 153; /* bswaphi2_load */
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      if (memory_operand (operands[0], E_HImode))
        return 155; /* bswaphi2_store */
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 157; /* bswaphi2_reg */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SImode)
          && memory_operand (operands[1], E_SImode))
        return 154; /* bswapsi2_load */
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      if (memory_operand (operands[0], E_SImode))
        return 156; /* bswapsi2_store */
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 158; /* bswapsi2_reg */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DImode)
          && memory_operand (operands[1], E_DImode)
          && 
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX))
        return 159; /* bswapdi2_load */
      if (gpc_reg_operand (operands[1], E_DImode))
        {
          if (memory_operand (operands[0], E_DImode)
              && 
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX))
            return 160; /* bswapdi2_store */
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              if (
#line 2794 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR))
                return 161; /* bswapdi2_brd */
              if (pnum_clobbers != NULL
                  && 
#line 2806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                {
                  *pnum_clobbers = 2;
                  return 162; /* bswapdi2_reg */
                }
            }
        }
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_DImode)
          || !reg_or_mem_operand (operands[1], E_DImode))
        return -1;
      if (
#line 2816 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
        {
          *pnum_clobbers = 2;
          return 163; /* *bswapdi2_64bit */
        }
      if (!
#line 2978 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && (REG_P (operands[0]) || REG_P (operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 164; /* bswapdi2_32bit */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6154 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1732; /* p9_xxbrq_v1ti */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6174 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1733; /* p9_xxbrd_v2di */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1734; /* p9_xxbrw_v4si */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6254 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1735; /* p9_xxbrh_v8hi */

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern5 (x1, pnum_clobbers))
    {
    case 0:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_SFmode)
          && vsx_register_operand (operands[2], E_SFmode)
          && 
#line 5488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 337; /* *sminsf3_vsx */
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !gpc_reg_operand (operands[2], E_SFmode)
          || !
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 345; /* *sminsf3_fpr */

    case 1:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_register_operand (operands[1], E_DFmode)
          && vsx_register_operand (operands[2], E_DFmode)
          && 
#line 5488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 339; /* *smindf3_vsx */
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !gpc_reg_operand (operands[2], E_DFmode)
          || !
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 347; /* *smindf3_fpr */

    case 2:
      if (!(
#line 5502 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 341; /* sminkf3 */

    case 3:
      if (!(
#line 5502 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 343; /* smintf3 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1364; /* *vsx_sminv4sf3 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode)
          || !
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1954; /* *altivec_sminv4sf3 */

    case 5:
      if (!
#line 2016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1365; /* *vsx_sminv2df3 */

    case 6:
      if (!
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1950; /* sminv4si3 */

    case 7:
      if (!
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
        return -1;
      return 1951; /* sminv8hi3 */

    case 8:
      if (!
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
        return -1;
      return 1952; /* sminv16qi3 */

    case 9:
      if (!
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
        return -1;
      return 1953; /* sminv2di3 */

    case 10:
      if (!
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1636; /* vsx_reduc_smin_v2df */

    case 11:
      if (!
#line 4949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1639; /* vsx_reduc_smin_v4sf */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x6, 1);
      operands[4] = x13;
      if (!gpc_reg_operand (operands[4], E_SImode))
        return -1;
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern601 (x1, 
ASHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case SIGN_EXTEND:
              if (pattern606 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1274 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 37; /* *macchwc */

            case ASHIFTRT:
              if (pattern607 (x1, 
ASHIFTRT) != 0
                  || !
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 41; /* *machhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern601 (x1, 
LSHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case ZERO_EXTEND:
              if (pattern606 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 39; /* *macchwuc */

            case LSHIFTRT:
              if (pattern607 (x1, 
LSHIFTRT) != 0
                  || !
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 43; /* *machhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern602 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1406 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 45; /* *maclhwc */

        case ZERO_EXTEND:
          if (pattern602 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1435 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 47; /* *maclhwuc */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x7;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern202 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 70; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 71; /* *adddi3_dot */

            case 2:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 72; /* *addsi3_dot2 */

            case 3:
              if (!(
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 73; /* *adddi3_dot2 */

            default:
              return -1;
            }

        case CONST_INT:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PLUS)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x17 = XEXP (x9, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern582 (x9, 
E_SImode) != 0
                  || !
#line 1944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 76; /* *addsi3_imm_dot2 */

            case E_DImode:
              if (pattern582 (x9, 
E_DImode) != 0
                  || !(
#line 1944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 77; /* *adddi3_imm_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern178 (x1, 
ZERO_EXTEND))
        {
        case 0:
          return 9; /* *zero_extendqisi2_dot */

        case 1:
          return 15; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 10; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 16; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 20; /* *zero_extendsidi2_dot */

        case 5:
          return 11; /* *zero_extendqisi2_dot2 */

        case 6:
          return 17; /* *zero_extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 12; /* *zero_extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 18; /* *zero_extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 21; /* *zero_extendsidi2_dot2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern178 (x1, 
SIGN_EXTEND))
        {
        case 0:
          return 24; /* *extendqisi2_dot */

        case 1:
          return 30; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 25; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 31; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 35; /* *extendsidi2_dot */

        case 5:
          return 26; /* *extendqisi2_dot2 */

        case 6:
          return 32; /* *extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 27; /* *extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 33; /* *extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 36; /* *extendsidi2_dot2 */

        default:
          return -1;
        }

    case PLUS:
      return recog_155 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case MULT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != MINUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != MULT
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          operands[4] = x11;
          if (!gpc_reg_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x7, 1);
          if (GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x9, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          switch (GET_CODE (x12))
            {
            case ASHIFTRT:
              x18 = XEXP (x12, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || GET_CODE (x15) != ASHIFTRT)
                return -1;
              x19 = XEXP (x15, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x20 = XEXP (x12, 0);
              if (!gpc_reg_operand (x20, E_SImode))
                return -1;
              switch (GET_CODE (x13))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x16) != SIGN_EXTEND)
                    return -1;
                  operands[2] = x20;
                  x21 = XEXP (x13, 0);
                  operands[1] = x21;
                  if (!gpc_reg_operand (operands[1], E_HImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[2]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[1])
                      || !
#line 1466 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 49; /* *nmacchwc */

                case ASHIFTRT:
                  x24 = XEXP (x13, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                      || GET_CODE (x16) != ASHIFTRT)
                    return -1;
                  x25 = XEXP (x16, 1);
                  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x20;
                  x21 = XEXP (x13, 0);
                  operands[2] = x21;
                  if (!gpc_reg_operand (operands[2], E_SImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[1]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2])
                      || !
#line 1500 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 51; /* *nmachhwc */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_CODE (x15) != SIGN_EXTEND
                  || GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x20 = XEXP (x12, 0);
              operands[1] = x20;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x21 = XEXP (x13, 0);
              operands[2] = x21;
              if (!gpc_reg_operand (operands[2], E_HImode))
                return -1;
              x22 = XEXP (x15, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x16, 0);
              if (!rtx_equal_p (x23, operands[2])
                  || !
#line 1531 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 53; /* *nmaclhwc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          switch (pattern486 (x1))
            {
            case 0:
              if (!
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 104; /* *subfsi3_dot */

            case 1:
              if (!(
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 105; /* *subfdi3_dot */

            case 2:
              if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 106; /* *subfsi3_dot2 */

            case 3:
              if (!(
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 107; /* *subfdi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern440 (x1, 
ASHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (pattern598 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1560 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 55; /* *mulchwc */

            case ASHIFTRT:
              if (pattern599 (x1, 
ASHIFTRT) != 0
                  || !
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 59; /* *mulhhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern440 (x1, 
LSHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              if (pattern598 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 57; /* *mulchwuc */

            case LSHIFTRT:
              if (pattern599 (x1, 
LSHIFTRT) != 0
                  || !
#line 1652 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 61; /* *mulhhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern441 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1680 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 63; /* *mullhwc */

        case ZERO_EXTEND:
          if (pattern441 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1706 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 65; /* *mullhwuc */

        case REG:
        case SUBREG:
          switch (pattern203 (x1, 
MULT))
            {
            case 0:
              if (!
#line 3124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 167; /* *mulsi3_dot */

            case 1:
              if (!(
#line 3124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 168; /* *muldi3_dot */

            case 2:
              if (!
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 169; /* *mulsi3_dot2 */

            case 3:
              if (!(
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 170; /* *muldi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern181 (x1, 
NOT))
        {
        case 0:
          if (!
#line 2132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 98; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 99; /* *one_cmpldi2_dot */

        case 2:
          if (!
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 100; /* *one_cmplsi2_dot2 */

        case 3:
          if (!(
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 101; /* *one_cmpldi2_dot2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 129; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 130; /* *negdi2_dot */

        case 2:
          if (!
#line 2431 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 131; /* *negsi2_dot2 */

        case 3:
          if (!(
#line 2431 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 132; /* *negdi2_dot2 */

        default:
          return -1;
        }

    case DIV:
      if (pattern182 (x1, pnum_clobbers, 
DIV) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      x9 = XEXP (x8, 1);
      x17 = XEXP (x9, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x10 = XEXP (x9, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern575 (x9, 
E_SImode) != 0
              || !
#line 3420 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 196; /* *divsi3_sra_dot2 */

        case E_DImode:
          if (pattern575 (x9, 
E_DImode) != 0
              || !(
#line 3420 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 197; /* *divdi3_sra_dot2 */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      if (GET_CODE (x4) == AND)
        {
          res = recog_154 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[4] = x6;
      switch (pattern391 (x1))
        {
        case 0:
          if (!
#line 4016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 228; /* *boolsi3_dot */

        case 1:
          if (!(
#line 4016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 229; /* *booldi3_dot */

        case 2:
          if (!
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 230; /* *boolsi3_dot2 */

        case 3:
          if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 231; /* *booldi3_dot2 */

        case 4:
          if (!
#line 4071 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 234; /* *boolcsi3_dot */

        case 5:
          if (!(
#line 4071 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 235; /* *boolcdi3_dot */

        case 6:
          if (!
#line 4094 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 236; /* *boolcsi3_dot2 */

        case 7:
          if (!(
#line 4094 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 237; /* *boolcdi3_dot2 */

        case 8:
          if (!
#line 4126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 240; /* *boolccsi3_dot */

        case 9:
          if (!(
#line 4126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 241; /* *boolccdi3_dot */

        case 10:
          if (!
#line 4149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 242; /* *boolccsi3_dot2 */

        case 11:
          if (!(
#line 4149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 243; /* *boolccdi3_dot2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern184 (x1, 
ROTATE))
        {
        case 0:
          if (!
#line 4590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 278; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 279; /* *rotldi3_dot */

        case 2:
          if (!
#line 4615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 280; /* *rotlsi3_dot2 */

        case 3:
          if (!(
#line 4615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 281; /* *rotldi3_dot2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 285; /* *ashlsi3_dot */

        case 1:
          if (!(
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 286; /* *ashldi3_dot */

        case 2:
          if (!
#line 4683 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 287; /* *ashlsi3_dot2 */

        case 3:
          if (!(
#line 4683 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 288; /* *ashldi3_dot2 */

        case 4:
          if (!
#line 4732 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 290; /* ashdi3_extswsli_dot */

        case 5:
          if (!
#line 4782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 291; /* ashdi3_extswsli_dot2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern184 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 295; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 296; /* *lshrdi3_dot */

        case 2:
          if (!
#line 4872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 297; /* *lshrsi3_dot2 */

        case 3:
          if (!(
#line 4872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 298; /* *lshrdi3_dot2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern182 (x1, pnum_clobbers, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 4945 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 304; /* *ashrsi3_dot2 */

        case 1:
          if (!(
#line 4945 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 305; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (pattern442 (x1))
        {
        case 0:
          if (!
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 574; /* *movsi_internal2 */

        case 1:
          if (!
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 575; /* *movdi_internal2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern186 (x1, 
CLOBBER, 
E_CCFPmode) != 0
          || GET_MODE (x3) != E_CCFPmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!zero_constant (x5, E_V2DFmode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          x27 = XVECEXP (x4, 0, 1);
          operands[2] = x27;
          x28 = XVECEXP (x4, 0, 2);
          operands[3] = x28;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 342:
              switch (pattern583 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2337; /* *bcdadd_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2339; /* *bcdadd_test_v16qi */

                default:
                  return -1;
                }

            case 343:
              switch (pattern583 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2338; /* *bcdsub_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2340; /* *bcdsub_test_v16qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 343)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !
#line 4737 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2353; /* *bcdinvalid_v1ti */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[0], E_V16QImode)
                  || !
#line 4737 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2354; /* *bcdinvalid_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 28 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2509; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

        case 1:
          if (!
#line 112 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2513; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

        case 2:
          if (!
#line 239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2519; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 3:
          if (!(
#line 239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2520; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 4:
          if (!
#line 49 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2510; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

        case 5:
          if (!
#line 133 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2514; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

        case 6:
          if (!
#line 260 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2521; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 7:
          if (!(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2522; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 8:
          if (!
#line 323 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2527; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 9:
          if (!(
#line 323 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2528; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 10:
          if (!
#line 70 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2511; /* *ld_cmpdi_cr0_DI_DI_CC_none */

        case 11:
          if (!
#line 154 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2515; /* *lwz_cmpwi_cr0_SI_SI_CC_none */

        case 12:
          if (!
#line 91 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2512; /* *ld_cmpldi_cr0_DI_DI_CCUNS_none */

        case 13:
          if (!
#line 175 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2516; /* *lwz_cmpldi_cr0_SI_SI_CCUNS_none */

        case 14:
          if (!(
#line 196 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2517; /* *lwa_cmpdi_cr0_SI_EXTSI_CC_sign */

        case 15:
          if (!
#line 281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2523; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 16:
          if (!(
#line 281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2524; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 17:
          if (!(
#line 218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2518; /* *lwz_cmpldi_cr0_SI_EXTSI_CCUNS_zero */

        case 18:
          if (!
#line 302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2525; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 19:
          if (!(
#line 302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2526; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 20:
          if (!
#line 344 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2529; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        case 21:
          if (!(
#line 344 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2530; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 432; /* fixuns_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 436; /* fixuns_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 444; /* *fixuns_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 450; /* *fixuns_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1148; /* *fixuns_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1154; /* *fixuns_trunctfqi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 434; /* fixuns_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 438; /* fixuns_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 446; /* *fixuns_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 452; /* *fixuns_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1150; /* *fixuns_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1156; /* *fixuns_trunctfhi2_mem */

        default:
          return -1;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern478 ())
            {
            case 0:
              if (
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 448; /* *fixuns_truncsfsi2_mem */
              break;

            case 1:
              if (
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 454; /* *fixuns_truncdfsi2_mem */
              break;

            case 2:
              if ((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 1152; /* *fixuns_trunckfsi2_mem */
              break;

            case 3:
              if ((
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 1158; /* *fixuns_trunctfsi2_mem */
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      switch (pattern477 (
E_DImode))
        {
        case 0:
          if (!
#line 6467 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 455; /* fixuns_truncsfsi2_stfiwx */

        case 1:
          if (!
#line 6467 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 456; /* fixuns_truncdfsi2_stfiwx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 17:
          if (GET_MODE (x3) != E_SImode
              || !mfcr_operation (operands[0], E_VOIDmode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !cc_reg_operand (operands[2], E_CCmode)
              || !
#line 13945 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MFCRF))
            return -1;
          return 1001; /* *movesi_from_cr_one */

        case 18:
          if (GET_MODE (x3) != E_CCmode
              || !mtcrf_operation (operands[0], E_VOIDmode)
              || !cc_reg_operand (operands[1], E_CCmode)
              || !gpc_reg_operand (operands[2], E_SImode))
            return -1;
          return 1019; /* *movsi_to_cr */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x3;
      if (gpc_reg_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (memory_operand (operands[1], E_SImode))
            {
              if (crsave_operation (operands[0], E_VOIDmode))
                return 1003; /* *crsave */
              if (stmw_operation (operands[0], E_VOIDmode)
                  && 
#line 13984 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
                return 1004; /* *stmw */
            }
        }
      if (!memory_operand (operands[2], E_SImode)
          || !lmw_operation (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 14152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
        return -1;
      return 1021; /* *lmw */

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 1
          || !tie_operand (operands[0], E_VOIDmode))
        return -1;
      return 1017; /* stack_tie */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 21
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 108
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 108
          || GET_MODE (x4) != E_SImode
          || !vrsave_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 421 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1810; /* *set_vrsave_internal */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern178 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 886 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!
#line 940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_5 (insn, operands);

        case 2:
          if (!(
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_2 (insn, operands);

        case 3:
          if (!(
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_6 (insn, operands);

        case 4:
          if (!(
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_9 (insn, operands);

        case 5:
          if (!
#line 907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_3 (insn, operands);

        case 6:
          if (!
#line 961 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_7 (insn, operands);

        case 7:
          if (!(
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_4 (insn, operands);

        case 8:
          if (!(
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_8 (insn, operands);

        case 9:
          if (!(
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern178 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_11 (insn, operands);

        case 1:
          if (!
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 2:
          if (!(
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_12 (insn, operands);

        case 3:
          if (!(
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_18 (insn, operands);

        case 4:
          if (!(
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_23 (insn, operands);

        case 5:
          if (!
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_13 (insn, operands);

        case 6:
          if (!
#line 1145 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 7:
          if (!(
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_14 (insn, operands);

        case 8:
          if (!(
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1145 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_20 (insn, operands);

        case 9:
          if (!(
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1245 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern204 (x1, 
PLUS))
        {
        case 0:
          if (!(
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1876 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_25 (insn, operands);

        case 1:
          if (!((
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1876 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_26 (insn, operands);

        case 2:
          if (!(
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1900 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_27 (insn, operands);

        case 3:
          if (!((
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1900 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      switch (pattern181 (x1, 
NOT))
        {
        case 0:
          if (!(
#line 2132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2136 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_35 (insn, operands);

        case 1:
          if (!((
#line 2132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2136 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_36 (insn, operands);

        case 2:
          if (!(
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2157 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_37 (insn, operands);

        case 3:
          if (!((
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2157 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_38 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      switch (pattern486 (x1))
        {
        case 0:
          if (!(
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_39 (insn, operands);

        case 1:
          if (!((
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_40 (insn, operands);

        case 2:
          if (!(
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_41 (insn, operands);

        case 3:
          if (!((
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 1:
          if (!((
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2414 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_47 (insn, operands);

        case 2:
          if (!(
#line 2431 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2435 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_48 (insn, operands);

        case 3:
          if (!((
#line 2431 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2435 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_49 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      switch (pattern204 (x1, 
MULT))
        {
        case 0:
          if (!(
#line 3124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3128 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_58 (insn, operands);

        case 1:
          if (!((
#line 3124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3128 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_59 (insn, operands);

        case 2:
          if (!(
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_60 (insn, operands);

        case 3:
          if (!((
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_61 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      if (GET_CODE (x4) == AND)
        {
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      operands[4] = x6;
      switch (pattern391 (x1))
        {
        case 0:
          if (!(
#line 4016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4020 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_89 (insn, operands);

        case 1:
          if (!((
#line 4016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4020 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_90 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4043 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_91 (insn, operands);

        case 3:
          if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4043 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_92 (insn, operands);

        case 4:
          if (!(
#line 4071 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4075 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_93 (insn, operands);

        case 5:
          if (!((
#line 4071 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4075 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_94 (insn, operands);

        case 6:
          if (!(
#line 4094 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4098 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_95 (insn, operands);

        case 7:
          if (!((
#line 4094 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4098 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_96 (insn, operands);

        case 8:
          if (!(
#line 4126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4130 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_97 (insn, operands);

        case 9:
          if (!((
#line 4126 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4130 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_98 (insn, operands);

        case 10:
          if (!(
#line 4149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_99 (insn, operands);

        case 11:
          if (!((
#line 4149 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4153 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_100 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern184 (x1, 
ROTATE))
        {
        case 0:
          if (!(
#line 4590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4594 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_129 (insn, operands);

        case 1:
          if (!((
#line 4590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4594 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_130 (insn, operands);

        case 2:
          if (!(
#line 4615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4619 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_131 (insn, operands);

        case 3:
          if (!((
#line 4615 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4619 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_132 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern185 (x1))
        {
        case 0:
          if (!(
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 1:
          if (!((
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 2:
          if (!(
#line 4683 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4687 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 3:
          if (!((
#line 4683 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4687 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 4:
          if (!(
#line 4732 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4738 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 5:
          if (!(
#line 4782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_139 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern184 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!(
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 1:
          if (!((
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_141 (insn, operands);

        case 2:
          if (!(
#line 4872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4876 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!((
#line 4872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4876 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_143 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return NULL;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_not_cr0_operand (operands[2], E_CCmode))
        return NULL;
      switch (pattern442 (x1))
        {
        case 0:
          if (!(
#line 8088 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 1:
          if (!(
#line 8088 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_298 (insn, operands);

        default:
          return NULL;
        }

    case MEM:
      switch (pattern190 (x1))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 30 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_744 (insn, operands);

        case 1:
          if (!(
#line 112 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 114 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_748 (insn, operands);

        case 2:
          if (!(
#line 239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_754 (insn, operands);

        case 3:
          if (!((
#line 239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_755 (insn, operands);

        case 4:
          if (!(
#line 49 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_745 (insn, operands);

        case 5:
          if (!(
#line 133 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_749 (insn, operands);

        case 6:
          if (!(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_756 (insn, operands);

        case 7:
          if (!((
#line 260 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_757 (insn, operands);

        case 8:
          if (!(
#line 323 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_762 (insn, operands);

        case 9:
          if (!((
#line 323 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_763 (insn, operands);

        case 10:
          if (!(
#line 70 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 72 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_746 (insn, operands);

        case 11:
          if (!(
#line 154 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_750 (insn, operands);

        case 12:
          if (!(
#line 91 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 93 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_747 (insn, operands);

        case 13:
          if (!(
#line 175 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_751 (insn, operands);

        case 14:
          if (!((
#line 196 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_752 (insn, operands);

        case 15:
          if (!(
#line 281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_758 (insn, operands);

        case 16:
          if (!((
#line 281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_759 (insn, operands);

        case 17:
          if (!((
#line 218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_753 (insn, operands);

        case 18:
          if (!(
#line 302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_760 (insn, operands);

        case 19:
          if (!((
#line 302 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_761 (insn, operands);

        case 20:
          if (!(
#line 344 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_764 (insn, operands);

        case 21:
          if (!((
#line 344 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_765 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || !logical_const_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (!boolean_or_operator (x3, E_SImode))
    return NULL;
  operands[3] = x3;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!logical_const_operand (operands[2], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != COMPARE
      || GET_MODE (x8) != E_CCmode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[4] = x9;
  if (!cc_reg_operand (operands[4], E_CCmode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[5] = x10;
  if (!gpc_reg_operand (operands[5], E_SImode))
    return NULL;
  x11 = XEXP (x8, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != IF_THEN_ELSE)
    return NULL;
  x14 = XEXP (x13, 0);
  if (!equality_operator (x14, E_VOIDmode))
    return NULL;
  operands[6] = x14;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != PC)
    return NULL;
  x17 = XEXP (x13, 1);
  operands[7] = x17;
  x18 = XEXP (x13, 2);
  operands[8] = x18;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[4])
      || !
#line 12677 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[4])
   && REGNO (operands[0]) != REGNO (operands[5])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_13 (insn, operands);
}
