/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  return pattern6 (x3, 
E_V4SFmode); /* [-1, 1] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE
      || GET_MODE (x3) != E_CCFPmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  x16 = XEXP (x4, 0);
  operands[3] = x16;
  if (!scratch_operand (operands[3], E_DFmode))
    return -1;
  x17 = XEXP (x5, 0);
  operands[4] = x17;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  x18 = XEXP (x6, 0);
  operands[5] = x18;
  if (!scratch_operand (operands[5], E_DFmode))
    return -1;
  x19 = XEXP (x7, 0);
  operands[6] = x19;
  if (!scratch_operand (operands[6], E_DFmode))
    return -1;
  x20 = XEXP (x8, 0);
  operands[7] = x20;
  if (!scratch_operand (operands[7], E_DFmode))
    return -1;
  x21 = XEXP (x9, 0);
  operands[8] = x21;
  if (!scratch_operand (operands[8], E_DFmode))
    return -1;
  x22 = XEXP (x10, 0);
  operands[9] = x22;
  if (!scratch_operand (operands[9], E_DFmode))
    return -1;
  x23 = XEXP (x11, 0);
  operands[10] = x23;
  if (!scratch_operand (operands[10], E_DFmode))
    return -1;
  x24 = XEXP (x12, 0);
  operands[11] = x24;
  switch (GET_MODE (operands[1]))
    {
    case E_IFmode:
      return pattern17 (
E_IFmode); /* [-1, 1] */

    case E_TFmode:
      res = pattern17 (
E_TFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern53 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern53 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern54 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern54 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern54 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern54 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern54 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern54 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern54 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern54 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern54 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern54 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          return pattern77 (x5, 
E_SFmode); /* [-1, 1] */

        case E_DFmode:
          res = pattern77 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_KFmode:
          res = pattern78 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern78 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case VEC_SELECT:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          return pattern98 (x6, 
E_SFmode); /* [-1, 1] */

        case E_DFmode:
          res = pattern98 (x6, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      res = pattern99 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      res = pattern100 (x1);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return pattern114 (x1); /* [-1, 3] */
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern125 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern124 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern124 (x1, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern132 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern132 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern141 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode))
        return -1;
      return 0;

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!scratch_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_DImode:
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          res = pattern177 ();
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x10) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x10) != E_DImode)
            return -1;
          res = pattern177 ();
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !rs6000_tls_symbol_ref (operands[2], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[2] = x2;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern191 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern191 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern231 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern231 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern231 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern231 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern231 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern231 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern231 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern231 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern231 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern231 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern233 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern233 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern235 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern235 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern235 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern235 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern235 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern235 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern235 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern235 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern235 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern235 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern278 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern278 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern279 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern279 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern279 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern279 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern279 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern279 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern279 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern279 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern279 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern279 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern298 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[4], i1)
      || !vsx_register_operand (operands[5], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!vsx_register_operand (operands[2], E_SFmode)
          || !vsx_register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!vsx_register_operand (operands[2], E_DFmode)
          || !vsx_register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[5] = x11;
  x12 = XEXP (x6, 0);
  switch (GET_CODE (x12))
    {
    case EQ:
      return pattern310 (x1); /* [-1, 1] */

    case NE:
      res = pattern310 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern322 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern322 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern334 (int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_QImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_HImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern346 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern356 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !scratch_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !scratch_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !vsx_register_operand (operands[0], E_V2DImode)
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !symbol_ref_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern384 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern396 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern393 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern393 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern395 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern395 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern395 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern395 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern395 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern395 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern395 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern395 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern395 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern395 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DFmode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!gpc_reg_operand (operands[3], E_DFmode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!gpc_reg_operand (operands[4], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 4);
  x13 = XEXP (x12, 0);
  operands[5] = x13;
  if (!offsettable_mem_operand (operands[5], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_IFmode:
      if (!gpc_reg_operand (operands[1], E_IFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern433 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_1_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!register_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern441 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_SImode
      || GET_MODE (x4) != E_SImode)
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x9, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern460 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern469 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!vfloat_operand (operands[0], E_SFmode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V4SFmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V4SFmode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_V4SFmode))
    return -1;
  switch (GET_CODE (x5))
    {
    case PLUS:
      return pattern481 (x5); /* [-1, 0] */

    case SMIN:
      if (pattern481 (x5) != 0)
        return -1;
      return 1;

    case SMAX:
      if (pattern481 (x5) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[4], i1)
      || !vsx_register_operand (operands[5], i1))
    return -1;
  return pattern504 (); /* [-1, 1] */
}

int
pattern509 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x3) != SIGN_EXTEND)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], i1))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], i1))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_CODE (x3) != ZERO_EXTEND)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], i1))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], i1))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern526 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  x8 = XEXP (x7, 0);
  x9 = XVECEXP (x8, 0, 0);
  operands[3] = x9;
  if (!memory_operand (operands[3], E_SFmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_V4SFmode))
    return -1;
  switch (GET_MODE (x8))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern536 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_OOmode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern544 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern557 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], E_V4SFmode)
      || !const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern566 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!symbol_ref_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !short_cint_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern574 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern586 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern593 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern598 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XEXP (x7, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x12 = XEXP (x3, 0);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x4, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern325 (x2, 
E_SImode) != 0)
            return -1;
          return 244; /* *eqvsi3 */

        case E_DImode:
          if (pattern325 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 245; /* *eqvdi3 */

        case E_TImode:
          if (GET_MODE (x2) != E_TImode
              || GET_MODE (x3) != E_TImode)
            return -1;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))
            return 547; /* *eqvti3_internal1 */
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR))
            return -1;
          return 556; /* *eqvti3_internal2 */

        case E_PTImode:
          if (GET_MODE (x2) != E_PTImode
              || GET_MODE (x3) != E_PTImode)
            return -1;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))
            return 548; /* *eqvpti3_internal1 */
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR))
            return -1;
          return 557; /* *eqvpti3_internal2 */

        case E_V16QImode:
          if (pattern317 (x2, 
E_V16QImode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 549; /* *eqvv16qi3_internal1 */

        case E_V8HImode:
          if (pattern317 (x2, 
E_V8HImode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 550; /* *eqvv8hi3_internal1 */

        case E_V4SImode:
          if (pattern317 (x2, 
E_V4SImode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 551; /* *eqvv4si3_internal1 */

        case E_V4SFmode:
          if (pattern317 (x2, 
E_V4SFmode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 552; /* *eqvv4sf3_internal1 */

        case E_V2DImode:
          if (pattern317 (x2, 
E_V2DImode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 553; /* *eqvv2di3_internal1 */

        case E_V2DFmode:
          if (pattern317 (x2, 
E_V2DFmode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 554; /* *eqvv2df3_internal1 */

        case E_V1TImode:
          if (pattern317 (x2, 
E_V1TImode) != 0
              || !(
#line 7572 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 555; /* *eqvv1ti3_internal1 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern269 (x2))
            {
            case 0:
              if (!
#line 691 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2567; /* *fuse_and_eqv */

            case 1:
              if (!(
#line 691 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2568; /* *fuse_and_eqv */

            case 2:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2859; /* *fuse_vand_veqv */

            case 3:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2860; /* *fuse_vand_veqv */

            case 4:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2861; /* *fuse_vand_veqv */

            case 5:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2862; /* *fuse_vand_veqv */

            case 6:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2863; /* *fuse_vand_veqv */

            case 7:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2864; /* *fuse_vand_veqv */

            case 8:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2865; /* *fuse_vand_veqv */

            case 9:
              if (!
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2866; /* *fuse_vand_veqv */

            case 10:
              if (!(
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2867; /* *fuse_vand_veqv */

            case 11:
              if (!(
#line 2167 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2868; /* *fuse_vand_veqv */

            default:
              return -1;
            }

        case NOT:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              switch (pattern422 (x2))
                {
                case 0:
                  if (!
#line 709 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2569; /* *fuse_andc_eqv */

                case 1:
                  if (!(
#line 709 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2570; /* *fuse_andc_eqv */

                case 2:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2869; /* *fuse_vandc_veqv */

                case 3:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2870; /* *fuse_vandc_veqv */

                case 4:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2871; /* *fuse_vandc_veqv */

                case 5:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2872; /* *fuse_vandc_veqv */

                case 6:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2873; /* *fuse_vandc_veqv */

                case 7:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2874; /* *fuse_vandc_veqv */

                case 8:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2875; /* *fuse_vandc_veqv */

                case 9:
                  if (!
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2876; /* *fuse_vandc_veqv */

                case 10:
                  if (!(
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2877; /* *fuse_vandc_veqv */

                case 11:
                  if (!(
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2878; /* *fuse_vandc_veqv */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern425 (x2))
                {
                case 0:
                  if (!
#line 763 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2575; /* *fuse_nor_eqv */

                case 1:
                  if (!(
#line 763 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2576; /* *fuse_nor_eqv */

                case 2:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2899; /* *fuse_vnor_veqv */

                case 3:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2900; /* *fuse_vnor_veqv */

                case 4:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2901; /* *fuse_vnor_veqv */

                case 5:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2902; /* *fuse_vnor_veqv */

                case 6:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2903; /* *fuse_vnor_veqv */

                case 7:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2904; /* *fuse_vnor_veqv */

                case 8:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2905; /* *fuse_vnor_veqv */

                case 9:
                  if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2906; /* *fuse_vnor_veqv */

                case 10:
                  if (!(
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2907; /* *fuse_vnor_veqv */

                case 11:
                  if (!(
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2908; /* *fuse_vnor_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != XOR)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern452 (x2, 
E_SImode) != 0
              || !
#line 727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2571; /* *fuse_eqv_eqv */

        case E_DImode:
          if (pattern452 (x2, 
E_DImode) != 0
              || !(
#line 727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2572; /* *fuse_eqv_eqv */

        case E_V4SImode:
          if (pattern453 (x2, 
E_V4SImode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2879; /* *fuse_veqv_veqv */

        case E_V8HImode:
          if (pattern453 (x2, 
E_V8HImode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2880; /* *fuse_veqv_veqv */

        case E_V16QImode:
          if (pattern453 (x2, 
E_V16QImode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2881; /* *fuse_veqv_veqv */

        case E_V4SFmode:
          if (pattern453 (x2, 
E_V4SFmode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2882; /* *fuse_veqv_veqv */

        case E_V2DFmode:
          if (pattern453 (x2, 
E_V2DFmode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2883; /* *fuse_veqv_veqv */

        case E_V2DImode:
          if (pattern453 (x2, 
E_V2DImode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2884; /* *fuse_veqv_veqv */

        case E_V1TImode:
          if (pattern453 (x2, 
E_V1TImode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2885; /* *fuse_veqv_veqv */

        case E_TImode:
          if (pattern453 (x2, 
E_TImode) != 0
              || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2886; /* *fuse_veqv_veqv */

        case E_KFmode:
          if (pattern453 (x2, 
E_KFmode) != 0
              || !(
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2887; /* *fuse_veqv_veqv */

        case E_TFmode:
          if (pattern453 (x2, 
E_TFmode) != 0
              || !(
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2888; /* *fuse_veqv_veqv */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case NOT:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case NOT:
              switch (pattern425 (x2))
                {
                case 0:
                  if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2573; /* *fuse_nand_eqv */

                case 1:
                  if (!(
#line 745 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2574; /* *fuse_nand_eqv */

                case 2:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2889; /* *fuse_vnand_veqv */

                case 3:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2890; /* *fuse_vnand_veqv */

                case 4:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2891; /* *fuse_vnand_veqv */

                case 5:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2892; /* *fuse_vnand_veqv */

                case 6:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2893; /* *fuse_vnand_veqv */

                case 7:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2894; /* *fuse_vnand_veqv */

                case 8:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2895; /* *fuse_vnand_veqv */

                case 9:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2896; /* *fuse_vnand_veqv */

                case 10:
                  if (!(
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2897; /* *fuse_vnand_veqv */

                case 11:
                  if (!(
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2898; /* *fuse_vnand_veqv */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern422 (x2))
                {
                case 0:
                  if (!
#line 799 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2579; /* *fuse_orc_eqv */

                case 1:
                  if (!(
#line 799 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2580; /* *fuse_orc_eqv */

                case 2:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2919; /* *fuse_vorc_veqv */

                case 3:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2920; /* *fuse_vorc_veqv */

                case 4:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2921; /* *fuse_vorc_veqv */

                case 5:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2922; /* *fuse_vorc_veqv */

                case 6:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2923; /* *fuse_vorc_veqv */

                case 7:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2924; /* *fuse_vorc_veqv */

                case 8:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2925; /* *fuse_vorc_veqv */

                case 9:
                  if (!
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2926; /* *fuse_vorc_veqv */

                case 10:
                  if (!(
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2927; /* *fuse_vorc_veqv */

                case 11:
                  if (!(
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2928; /* *fuse_vorc_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern269 (x2))
            {
            case 0:
              if (!
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2577; /* *fuse_or_eqv */

            case 1:
              if (!(
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2578; /* *fuse_or_eqv */

            case 2:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2909; /* *fuse_vor_veqv */

            case 3:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2910; /* *fuse_vor_veqv */

            case 4:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2911; /* *fuse_vor_veqv */

            case 5:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2912; /* *fuse_vor_veqv */

            case 6:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2913; /* *fuse_vor_veqv */

            case 7:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2914; /* *fuse_vor_veqv */

            case 8:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2915; /* *fuse_vor_veqv */

            case 9:
              if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2916; /* *fuse_vor_veqv */

            case 10:
              if (!(
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2917; /* *fuse_vor_veqv */

            case 11:
              if (!(
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2918; /* *fuse_vor_veqv */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      switch (pattern269 (x2))
        {
        case 0:
          if (!
#line 817 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2581; /* *fuse_xor_eqv */

        case 1:
          if (!(
#line 817 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2582; /* *fuse_xor_eqv */

        case 2:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2929; /* *fuse_vxor_veqv */

        case 3:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2930; /* *fuse_vxor_veqv */

        case 4:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2931; /* *fuse_vxor_veqv */

        case 5:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2932; /* *fuse_vxor_veqv */

        case 6:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2933; /* *fuse_vxor_veqv */

        case 7:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2934; /* *fuse_vxor_veqv */

        case 8:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2935; /* *fuse_vxor_veqv */

        case 9:
          if (!
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2936; /* *fuse_vxor_veqv */

        case 10:
          if (!(
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2937; /* *fuse_vxor_veqv */

        case 11:
          if (!(
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2938; /* *fuse_vxor_veqv */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !
#line 2348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2064; /* altivec_vspltb_direct */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 2386 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2066; /* altivec_vsplth_direct */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_QImode)
          || !
#line 2424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2068; /* altivec_vspltw_direct */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_0_to_1_operand (operands[1], E_QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[2], E_DDmode)
          || !
#line 294 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      return 2456; /* dfp_denbcd_dd */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_TDmode:
          if (!gpc_reg_operand (operands[2], E_TDmode)
              || !
#line 294 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2457; /* dfp_denbcd_td */

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode)
              || !
#line 304 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2458; /* dfp_denbcd_v16qi_inst */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 4870 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1619; /* vsx_xxspltw_v4sf_direct */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 4870 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1620; /* vsx_xxspltw_v4si_direct */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!mma_disassemble_output_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (pattern434 ())
    {
    case 0:
      if (!
#line 415 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)))
        return -1;
      return 2359; /* *vsx_disassemble_pair */

    case 1:
      if (!
#line 489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)))
        return -1;
      return 2361; /* *mma_disassemble_acc */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_VOIDmode)
      || !
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(REG_P (operands[0])
   && CR_REGNO_P (REGNO (operands[0]))
   && CONST_INT_P (operands[2])
   && INTVAL (operands[2]) == 1 << (7 - (REGNO (operands[0]) - CR0_REGNO))))
    return -1;
  return 1020; /* *mtcrfsi */
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 5088 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1647; /* vsx_sign_extend_v2di_v1ti */

    case E_V4SImode:
      switch (pattern339 (x3, 
E_V4SImode))
        {
        case 0:
          if (!
#line 5099 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1648; /* vsx_sign_extend_v16qi_v4si */

        case 1:
          if (!
#line 5108 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1652; /* vsx_sign_extend_v8hi_v4si */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 5099 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1649; /* vsx_sign_extend_v16qi_v2di */

        case E_V8HImode:
          if (!vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 5108 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1653; /* vsx_sign_extend_v8hi_v2di */

        case E_V4SImode:
          if (!vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 5116 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1656; /* vsx_sign_extend_v4si_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (gpc_reg_operand (operands[1], E_KFmode)
          && (
#line 5356 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 331; /* signbitkf2_dm */
      if (!memory_operand (operands[1], E_KFmode)
          || !(
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 333; /* signbitkf2_dm_mem */

    case E_TFmode:
      if (gpc_reg_operand (operands[1], E_TFmode)
          && (
#line 5356 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 332; /* signbittf2_dm */
      if (!memory_operand (operands[1], E_TFmode)
          || !(
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 334; /* signbittf2_dm_mem */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6859 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 487; /* *xsrdpisf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6859 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 488; /* *xsrdpidf2 */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern338 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 6804 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POPCNTD))
            return -1;
          return 475; /* *lrintsfsi */

        case 1:
          if (!
#line 6804 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POPCNTD))
            return -1;
          return 476; /* *lrintdfsi */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern338 (x3, 
E_DImode))
        {
        case 0:
          if (!
#line 6812 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POPCNTD))
            return -1;
          return 477; /* lrintsfsi_di */

        case 1:
          if (!
#line 6812 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POPCNTD))
            return -1;
          return 478; /* lrintdfsi_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern170 (x1))
    {
    case 0:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2095; /* *altivec_vpermr_v4si_internal */

    case 1:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2096; /* *altivec_vpermr_v8hi_internal */

    case 2:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2097; /* *altivec_vpermr_v16qi_internal */

    case 3:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2098; /* *altivec_vpermr_v4sf_internal */

    case 4:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2099; /* *altivec_vpermr_v2df_internal */

    case 5:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2100; /* *altivec_vpermr_v2di_internal */

    case 6:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2101; /* *altivec_vpermr_v1ti_internal */

    case 7:
      if (!
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2102; /* *altivec_vpermr_ti_internal */

    case 8:
      if (!(
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 2103; /* *altivec_vpermr_kf_internal */

    case 9:
      if (!(
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 2104; /* *altivec_vpermr_tf_internal */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (pattern30 (x2))
    {
    case 0:
      switch (GET_MODE (x2))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2244; /* altivec_stvx_v16qi_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2245; /* altivec_stvx_v16qi_2op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2248; /* altivec_stvx_v2df_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2249; /* altivec_stvx_v2df_2op_di */

            default:
              return -1;
            }

        case E_KFmode:
          if (!register_operand (operands[0], E_KFmode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2254; /* altivec_stvx_kf_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2255; /* altivec_stvx_kf_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (x2))
        {
        case E_V16QImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2262; /* altivec_stvx_v16qi_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2263; /* altivec_stvx_v16qi_1op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2266; /* altivec_stvx_v2df_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2267; /* altivec_stvx_v2df_1op_di */

            default:
              return -1;
            }

        case E_KFmode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2272; /* altivec_stvx_kf_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2273; /* altivec_stvx_kf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[1] = x4;
      if (s8bit_cint_operand (operands[1], E_SImode)
          && vsx_register_operand (operands[0], E_V16QImode)
          && GET_MODE (x3) == E_V16QImode
          && 
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1283; /* xxspltib_v16qi */
      if (!s5bit_cint_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 2461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2072; /* altivec_vspltisb */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DFmode)
              && 
#line 4787 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return 1610; /* vsx_splat_v2df_reg */
          if (!memory_operand (operands[1], E_DFmode)
              || !
#line 4797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return -1;
          return 1612; /* vsx_splat_v2df_mem */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !splat_input_operand (operands[1], E_SFmode)
              || !
#line 4832 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1616; /* vsx_splat_v4sf */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
            return 1617; /* vsx_xxspltw_v4sf */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2448 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 2069; /* *altivec_vspltsf_internal */

        case E_V16QImode:
          if (pattern438 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2063; /* *altivec_vspltb_internal */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_QImode
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!altivec_register_operand (operands[1], E_DImode)
          || !
#line 4880 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 1621; /* vsx_vspltb_di */

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  if (XWINT (x4, 0) == 0L
      && vsx_register_operand (operands[0], E_V1TImode)
      && GET_MODE (x2) == E_V1TImode
      && memory_operand (operands[1], E_V1TImode)
      && 
#line 1402 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V1TImode) && !BYTES_BIG_ENDIAN))
    return 1320; /* vsx_ld_elemrev_v1ti */
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      if (const_0_to_1_operand (operands[2], E_QImode))
        {
          if (gpc_reg_operand (operands[0], E_DFmode)
              && gpc_reg_operand (operands[1], E_V2DFmode))
            {
              if (
#line 3573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
                return 1491; /* *vsx_extract_v2df_0 */
              if (
#line 3594 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 0)))
                return 1493; /* *vsx_extract_v2df_1 */
            }
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_DFmode)
              && memory_operand (operands[1], E_V2DFmode))
            {
              if ((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1495; /* *vsx_extract_si_v2df_load */
                }
              if ((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1496; /* *vsx_extract_di_v2df_load */
                }
            }
        }
      if (!memory_operand (operands[0], E_DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !vsx_scalar_64bit (operands[2], E_QImode)
          || !
#line 3631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
        return -1;
      return 1499; /* *vsx_extract_v2df_store */

    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      if (const_0_to_1_operand (operands[2], E_QImode))
        {
          if (gpc_reg_operand (operands[0], E_DImode)
              && gpc_reg_operand (operands[1], E_V2DImode))
            {
              if (
#line 3573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
                return 1492; /* *vsx_extract_v2di_0 */
              if (
#line 3594 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 0)))
                return 1494; /* *vsx_extract_v2di_1 */
            }
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_V2DImode))
            {
              if ((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1497; /* *vsx_extract_si_v2di_load */
                }
              if ((
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1498; /* *vsx_extract_di_v2di_load */
                }
            }
        }
      if (!memory_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !vsx_scalar_64bit (operands[2], E_QImode)
          || !
#line 3631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)))
        return -1;
      return 1500; /* *vsx_extract_v2di_store */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && u5bit_cint_operand (operands[2], E_QImode)
          && 
#line 3692 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        {
          *pnum_clobbers = 1;
          return 1507; /* vsx_extract_v4sf */
        }
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !const_0_to_3_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 3725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        {
          *pnum_clobbers = 1;
          return 1508; /* *vsx_extract_v4sf_si_load */
        }
      if (!(
#line 3725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1509; /* *vsx_extract_v4sf_di_load */

    case E_SImode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SImode))
        {
          if (const_0_to_3_operand (operands[2], E_QImode))
            {
              if (nonimmediate_operand (operands[0], E_SImode)
                  && 
#line 3932 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                {
                  *pnum_clobbers = 1;
                  return 1514; /* vsx_extract_v4si_w1 */
                }
              if (gpc_reg_operand (operands[0], E_SImode)
                  && 
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                {
                  *pnum_clobbers = 1;
                  return 1518; /* vsx_extract_v4si_p9 */
                }
            }
          if (memory_operand (operands[0], E_SImode)
              && const_int_operand (operands[2], E_QImode)
              && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 2;
              return 1524; /* *vsx_extract_v4si_store_p9 */
            }
          if (nonimmediate_operand (operands[0], E_SImode)
              && const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1525; /* *vsx_extract_v4si_w023 */
            }
        }
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_QImode)
          || !
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1530; /* *vsx_extract_v4si_load */

    case E_QImode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode))
        {
          if (gpc_reg_operand (operands[0], E_QImode)
              && const_0_to_15_operand (operands[2], E_QImode)
              && 
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 1;
              return 1516; /* vsx_extract_v16qi_p9 */
            }
          if (memory_operand (operands[0], E_QImode)
              && const_int_operand (operands[2], E_QImode)
              && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 2;
              return 1522; /* *vsx_extract_v16qi_store_p9 */
            }
          if (nonimmediate_operand (operands[0], E_QImode)
              && const_0_to_15_operand (operands[2], E_QImode)
              && 
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
            {
              *pnum_clobbers = 1;
              return 1526; /* *vsx_extract_v16qi_p8 */
            }
        }
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1528; /* *vsx_extract_v16qi_load */

    case E_HImode:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode))
        {
          if (gpc_reg_operand (operands[0], E_HImode)
              && const_0_to_7_operand (operands[2], E_QImode)
              && 
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 1;
              return 1517; /* vsx_extract_v8hi_p9 */
            }
          if (memory_operand (operands[0], E_HImode)
              && const_int_operand (operands[2], E_QImode)
              && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            {
              *pnum_clobbers = 2;
              return 1523; /* *vsx_extract_v8hi_store_p9 */
            }
          if (nonimmediate_operand (operands[0], E_HImode)
              && const_0_to_7_operand (operands[2], E_QImode)
              && 
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
            {
              *pnum_clobbers = 1;
              return 1527; /* *vsx_extract_v8hi_p8 */
            }
        }
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1529; /* *vsx_extract_v8hi_load */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 402; /* floatsisf2_lfiwax */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7037 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
                    return 502; /* floatdisf2_fcfids */
                  if (pnum_clobbers != NULL)
                    {
                      if (memory_operand (operands[1], E_DImode)
                          && 
#line 7048 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
                        {
                          *pnum_clobbers = 1;
                          return 503; /* *floatdisf2_mem */
                        }
                      if (gpc_reg_operand (operands[1], E_DImode)
                          && 
#line 7068 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS))
                        {
                          *pnum_clobbers = 1;
                          return 504; /* floatdisf2_internal1 */
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_SFmode))
            {
            case 0:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 417; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 418; /* *floathisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 403; /* floatsidf2_lfiwax */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6924 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT))
                    return 490; /* floatdidf2 */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 6975 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 499; /* *floatdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern333 (
E_DFmode))
            {
            case 0:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 419; /* *floatqidf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 420; /* *floathidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 491; /* floattikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15319 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1159; /* float_kfdi2_hw */

            case 1:
              if (!(
#line 15328 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1161; /* float_kfsi2_hw */

            case 2:
              if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1163; /* floatqikf2 */

            case 3:
              if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1164; /* floathikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 492; /* floattitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern334 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15319 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1160; /* float_tfdi2_hw */

            case 1:
              if (!(
#line 15328 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1162; /* float_tfsi2_hw */

            case 2:
              if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1165; /* floatqitf2 */

            case 3:
              if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1166; /* floathitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1396; /* vsx_floatv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1432; /* vsx_xvcvsxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1397; /* vsx_floatv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1434; /* vsx_xvcvsxddp */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP && TARGET_POPCNTD))
            return -1;
          return 2446; /* floatdidd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !
#line 224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2447; /* floatditd2 */

            case E_TImode:
              if (!gpc_reg_operand (operands[1], E_TImode)
                  || !
#line 232 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
                return -1;
              return 2448; /* floattitd2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern66 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 404; /* floatsisf2_lfiwax_mem */

        case 1:
          if (!
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 405; /* floatsidf2_lfiwax_mem */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern335 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 406; /* floatsisf2_lfiwax_qi_mem_zext */

            case 1:
              if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 407; /* floatsisf2_lfiwax_hi_mem_zext */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern335 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* floatsidf2_lfiwax_qi_mem_zext */

            case 1:
              if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* floatsidf2_lfiwax_hi_mem_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!
#line 6692 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND
   && flag_unsafe_math_optimizations && !flag_trapping_math && TARGET_FRIZ))
                return -1;
              return 468; /* *friz */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || !
#line 6711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 2;
              return 470; /* *round32df2_fprs */

            default:
              return -1;
            }

        case E_SFmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || GET_MODE (x4) != E_SImode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 469; /* *round32sf2_fprs */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x4) != E_V2DImode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_HARD_FLOAT
   && VECTOR_UNIT_VSX_P (V2DFmode) && flag_unsafe_math_optimizations
   && !flag_trapping_math && TARGET_FRIZ))
            return -1;
          return 1454; /* *vsx_float_fix_v2df2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern68 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1444; /* vsx_xvcvsxwdp_be */

        case 1:
          if (!
#line 2640 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1446; /* vsx_xvcvsxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1569; /* *vsx_extract_si_float_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1588; /* *vsx_ext_SI_fl_df */

        case 3:
          if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1580; /* *vsx_ext_QI_fl_df */

        case 4:
          if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1584; /* *vsx_ext_HI_fl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1571; /* *vsx_extract_si_float_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1587; /* *vsx_ext_SI_fl_sf */

        case 6:
          if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1579; /* *vsx_ext_QI_fl_sf */

        case 7:
          if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1583; /* *vsx_ext_HI_fl_sf */

        case 8:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1573; /* *vsx_extract_si_float_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1575; /* *vsx_extract_si_float_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1589; /* *vsx_ext_SI_fl_kf */

        case 10:
          if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1581; /* *vsx_ext_QI_fl_kf */

        case 11:
          if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1585; /* *vsx_ext_HI_fl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1577; /* *vsx_extract_si_float_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1590; /* *vsx_ext_SI_fl_tf */

        case 13:
          if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1582; /* *vsx_ext_QI_fl_tf */

        case 14:
          if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1586; /* *vsx_ext_HI_fl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 96; /* *one_cmplsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 97; /* *one_cmpldi2 */

        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x2) != E_TImode
              || !vlogical_operand (operands[1], E_TImode))
            return -1;
          return 558; /* one_cmplti2 */

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x2) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode))
            return -1;
          return 559; /* one_cmplpti2 */

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 560; /* one_cmplv16qi2 */

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 561; /* one_cmplv8hi2 */

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 562; /* one_cmplv4si2 */

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 563; /* one_cmplv4sf2 */

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 564; /* one_cmplv2di2 */

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 565; /* one_cmplv2df2 */

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 566; /* one_cmplv1ti2 */

        default:
          return -1;
        }

    case XOR:
      return recog_4 (x1, insn, pnum_clobbers);

    case EQ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern270 (x2, 
E_V16QImode) != 0
              || !
#line 5863 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1705; /* vcmpneb */

        case E_V8HImode:
          if (pattern270 (x2, 
E_V8HImode) != 0
              || !
#line 5913 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1708; /* vcmpneh */

        case E_V4SImode:
          if (pattern270 (x2, 
E_V4SImode) != 0
              || !
#line 5933 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1710; /* vcmpnew */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern5 (x1, pnum_clobbers))
    {
    case 0:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_SFmode)
          && vsx_register_operand (operands[2], E_SFmode)
          && 
#line 5488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 338; /* *smaxsf3_vsx */
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !gpc_reg_operand (operands[2], E_SFmode)
          || !
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 346; /* *smaxsf3_fpr */

    case 1:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_register_operand (operands[1], E_DFmode)
          && vsx_register_operand (operands[2], E_DFmode)
          && 
#line 5488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 340; /* *smaxdf3_vsx */
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !gpc_reg_operand (operands[2], E_DFmode)
          || !
#line 5515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 348; /* *smaxdf3_fpr */

    case 2:
      if (!(
#line 5502 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 342; /* smaxkf3 */

    case 3:
      if (!(
#line 5502 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 344; /* smaxtf3 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2008 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1362; /* vsx_smaxv4sf3 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode)
          || !
#line 1089 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1945; /* *altivec_smaxv4sf3 */

    case 5:
      if (!
#line 2008 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1363; /* vsx_smaxv2df3 */

    case 6:
      if (!
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1941; /* smaxv4si3 */

    case 7:
      if (!
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
        return -1;
      return 1942; /* smaxv8hi3 */

    case 8:
      if (!
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
        return -1;
      return 1943; /* smaxv16qi3 */

    case 9:
      if (!
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
        return -1;
      return 1944; /* smaxv2di3 */

    case 10:
      if (!
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1637; /* vsx_reduc_smax_v2df */

    case 11:
      if (!
#line 4949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1640; /* vsx_reduc_smax_v4sf */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (pattern580 (x7, 
E_SImode) != 0
          || !
#line 3756 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)))
        return -1;
      return 209; /* *andsi3_imm_dot_shifted */

    case E_DImode:
      if (pattern580 (x7, 
E_DImode) != 0
          || !(
#line 3756 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 210; /* *anddi3_imm_dot_shifted */

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!altivec_register_operand (operands[3], E_V2DImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V2DImode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  if (!altivec_register_operand (operands[1], E_V2DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!altivec_register_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_V2DImode)
      || !
#line 3049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
    return -1;
  return 3341; /* *fuse_vaddudm_vaddudm */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 82; /* *addsi3_imm_carry_0 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 83; /* *adddi3_imm_carry_0 */

        default:
          return -1;
        }

    case MEM:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x5, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x8))
            {
            case E_SImode:
              if (pattern581 (x5, 
E_SImode) != 0
                  || !(
#line 10257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 704; /* movdi_si_update */

            case E_DImode:
              if (pattern581 (x5, 
E_DImode) != 0)
                return -1;
              if ((
#line 10257 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 705; /* movdi_di_update */
              if (!
#line 10277 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 706; /* movdi_update_stack */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern572 (x1, 
E_SImode))
            {
            case 0:
              if ((
#line 10321 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 711; /* movsi_si_update */
              if (!
#line 10341 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 713; /* movsi_update_stack */

            case 1:
              if (!(
#line 10321 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 712; /* movsi_di_update */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern572 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 10406 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 724; /* *movhi_update4 */

            case 1:
              if (!(
#line 10406 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 725; /* *movhi_update4 */

            default:
              return -1;
            }

        case E_QImode:
          switch (pattern572 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 10455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 732; /* *movqi_update3 */

            case 1:
              if (!(
#line 10455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 733; /* *movqi_update3 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern572 (x1, 
E_SFmode))
            {
            case 0:
              if ((
#line 10488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 738; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 744; /* *movsf_update4 */

            case 1:
              if ((
#line 10488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 739; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 745; /* *movsf_update4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern572 (x1, 
E_DFmode))
            {
            case 0:
              if (!(
#line 10488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 740; /* *movdf_update2 */

            case 1:
              if (!(
#line 10488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 741; /* *movdf_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          switch (pattern410 (x5))
            {
            case 0:
              if (!
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2659; /* *fuse_and_xor */

            case 1:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2660; /* *fuse_and_xor */

            case 2:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3259; /* *fuse_vand_vxor */

            case 3:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3260; /* *fuse_vand_vxor */

            case 4:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3261; /* *fuse_vand_vxor */

            case 5:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3262; /* *fuse_vand_vxor */

            case 6:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3263; /* *fuse_vand_vxor */

            case 7:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3264; /* *fuse_vand_vxor */

            case 8:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3265; /* *fuse_vand_vxor */

            case 9:
              if (!
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3266; /* *fuse_vand_vxor */

            case 10:
              if (!(
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3267; /* *fuse_vand_vxor */

            case 11:
              if (!(
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3268; /* *fuse_vand_vxor */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern238 (x5, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2661; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern238 (x5, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2662; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern239 (x5, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3269; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern239 (x5, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3270; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern239 (x5, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3271; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern239 (x5, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3272; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern239 (x5, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3273; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern239 (x5, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3274; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern239 (x5, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3275; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern239 (x5, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3276; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern239 (x5, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3277; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3278; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern193 (x5, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2667; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern193 (x5, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2668; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern243 (x5, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3299; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern243 (x5, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3300; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern243 (x5, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3301; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern243 (x5, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3302; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern243 (x5, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3303; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern243 (x5, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3304; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern243 (x5, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3305; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern243 (x5, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3306; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern243 (x5, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3307; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern243 (x5, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3308; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != XOR)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x13 = XEXP (x9, 1);
      operands[1] = x13;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern527 (x5, 
E_SImode) != 0
              || !
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2663; /* *fuse_eqv_xor */

        case E_DImode:
          if (pattern527 (x5, 
E_DImode) != 0
              || !(
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2664; /* *fuse_eqv_xor */

        case E_V4SImode:
          if (pattern528 (x5, 
E_V4SImode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3279; /* *fuse_veqv_vxor */

        case E_V8HImode:
          if (pattern528 (x5, 
E_V8HImode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3280; /* *fuse_veqv_vxor */

        case E_V16QImode:
          if (pattern528 (x5, 
E_V16QImode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3281; /* *fuse_veqv_vxor */

        case E_V4SFmode:
          if (pattern528 (x5, 
E_V4SFmode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3282; /* *fuse_veqv_vxor */

        case E_V2DFmode:
          if (pattern528 (x5, 
E_V2DFmode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3283; /* *fuse_veqv_vxor */

        case E_V2DImode:
          if (pattern528 (x5, 
E_V2DImode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3284; /* *fuse_veqv_vxor */

        case E_V1TImode:
          if (pattern528 (x5, 
E_V1TImode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3285; /* *fuse_veqv_vxor */

        case E_TImode:
          if (pattern528 (x5, 
E_TImode) != 0
              || !
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3286; /* *fuse_veqv_vxor */

        case E_KFmode:
          if (pattern528 (x5, 
E_KFmode) != 0
              || !(
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3287; /* *fuse_veqv_vxor */

        case E_TFmode:
          if (pattern528 (x5, 
E_TFmode) != 0
              || !(
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3288; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern193 (x5, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2665; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern193 (x5, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2666; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern243 (x5, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3289; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern243 (x5, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3290; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern243 (x5, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3291; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern243 (x5, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3292; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern243 (x5, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3293; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern243 (x5, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3294; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern243 (x5, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3295; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern243 (x5, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3296; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern243 (x5, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3297; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern243 (x5, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3298; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern238 (x5, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2671; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern238 (x5, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2672; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern239 (x5, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3319; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern239 (x5, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3320; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern239 (x5, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3321; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern239 (x5, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3322; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern239 (x5, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3323; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern239 (x5, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3324; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern239 (x5, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3325; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern239 (x5, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3326; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern239 (x5, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3327; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3328; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern410 (x5))
            {
            case 0:
              if (!
#line 1609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2669; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2670; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3309; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3310; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3311; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3312; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3313; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3314; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3315; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3316; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3317; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3318; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      switch (pattern410 (x5))
        {
        case 0:
          if (!
#line 1645 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2673; /* *fuse_xor_xor */

        case 1:
          if (!(
#line 1645 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2674; /* *fuse_xor_xor */

        case 2:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3329; /* *fuse_vxor_vxor */

        case 3:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3330; /* *fuse_vxor_vxor */

        case 4:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3331; /* *fuse_vxor_vxor */

        case 5:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3332; /* *fuse_vxor_vxor */

        case 6:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3333; /* *fuse_vxor_vxor */

        case 7:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3334; /* *fuse_vxor_vxor */

        case 8:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3335; /* *fuse_vxor_vxor */

        case 9:
          if (!
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3336; /* *fuse_vxor_vxor */

        case 10:
          if (!(
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3337; /* *fuse_vxor_vxor */

        case 11:
          if (!(
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3338; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 1919 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 74; /* *addsi3_imm_dot */

        case 1:
          if (!(
#line 1919 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 75; /* *adddi3_imm_dot */

        case 2:
          if (!
#line 1944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 76; /* *addsi3_imm_dot2 */

        case 3:
          if (!(
#line 1944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 77; /* *adddi3_imm_dot2 */

        case 4:
          if (!(
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 110; /* subfsi3_carry_dot2 */

        case 5:
          if (!(
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 111; /* subfdi3_carry_dot2 */

        case 6:
          if (!
#line 3394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 194; /* *divsi3_sra_dot */

        case 7:
          if (!(
#line 3394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 195; /* *divdi3_sra_dot */

        case 8:
          if (!
#line 3420 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 196; /* *divsi3_sra_dot2 */

        case 9:
          if (!(
#line 3420 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 197; /* *divdi3_sra_dot2 */

        case 10:
          if (!
#line 3654 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 201; /* *andsi3_imm_dot */

        case 11:
          if (!(
#line 3654 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 202; /* *anddi3_imm_dot */

        case 12:
          if (!
#line 3681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 203; /* *andsi3_imm_dot2 */

        case 13:
          if (!(
#line 3681 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 204; /* *anddi3_imm_dot2 */

        case 14:
          if (!
#line 4918 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 302; /* *ashrsi3_dot */

        case 15:
          if (!(
#line 4918 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 303; /* *ashrdi3_dot */

        case 16:
          if (!
#line 4945 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 304; /* *ashrsi3_dot2 */

        case 17:
          if (!(
#line 4945 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 305; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (gpc_reg_operand (operands[1], E_DImode)
          && gpc_reg_operand (operands[0], E_DImode))
        {
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (scratch_operand (operands[2], E_DImode))
            {
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_DImode)
                  && 
#line 2806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                return 162; /* bswapdi2_reg */
            }
        }
      if (!reg_or_mem_operand (operands[1], E_DImode)
          || !reg_or_mem_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DImode)
          || !
#line 2816 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
        return -1;
      return 163; /* *bswapdi2_64bit */

    case IF_THEN_ELSE:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 3906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
            return -1;
          return 223; /* *branch_anddi3_dot */

        case 1:
          if (!
#line 7954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
            return -1;
          return 572; /* *rotate_on_cmpdi */

        case 2:
          if (!
#line 7954 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
            return -1;
          return 573; /* *rotate_on_cmpdi */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 421; /* *floatunsqisf2_internal */

        case 1:
          if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 422; /* *floatunshisf2_internal */

        case 2:
          if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 423; /* *floatunsqidf2_internal */

        case 3:
          if (!
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 424; /* *floatunshidf2_internal */

        case 4:
          if (!
#line 6744 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          return 471; /* *roundu32sf2_fprs */

        case 5:
          if (!
#line 6744 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          return 472; /* *roundu32df2_fprs */

        case 6:
          if (!
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1572; /* *vsx_extract_si_unsfloat_sf */

        case 7:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          return 1574; /* *vsx_extract_si_unsfloat_if */

        case 8:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1576; /* *vsx_extract_si_unsfloat_kf */

        case 9:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            return -1;
          return 1578; /* *vsx_extract_si_unsfloat_tf */

        default:
          return -1;
        }

    case FIX:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 6362 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 427; /* fix_truncsfsi2_internal */

        case 1:
          if (!
#line 6362 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 428; /* fix_truncdfsi2_internal */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern103 (x1))
        {
        case 0:
          if (!
#line 6711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          return 469; /* *round32sf2_fprs */

        case 1:
          if (!
#line 6711 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          return 470; /* *round32df2_fprs */

        case 2:
          if (!
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1571; /* *vsx_extract_si_float_sf */

        case 3:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          return 1573; /* *vsx_extract_si_float_if */

        case 4:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1575; /* *vsx_extract_si_float_kf */

        case 5:
          if (!(
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            return -1;
          return 1577; /* *vsx_extract_si_float_tf */

        default:
          return -1;
        }

    case CALL:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != MEM)
        return -1;
      switch (pattern199 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (GET_MODE (x9) != E_SImode)
                    return -1;
                  if (current_file_function_operand (operands[1], E_SImode)
                      && (
#line 11512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 821; /* *call_value_localsi */
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode))
                    return -1;
                  if ((
#line 11637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 831; /* *call_value_nonlocal_sysvsi */
                  if (!(
#line 11705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 837; /* *call_value_nonlocal_aixsi */

                case E_DImode:
                  if (GET_MODE (x9) != E_DImode)
                    return -1;
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 822; /* *call_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  if ((
#line 11637 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 832; /* *call_value_nonlocal_sysvdi */
                  if (!(
#line 11705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 838; /* *call_value_nonlocal_aixdi */

                default:
                  return -1;
                }

            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x9 = XEXP (x5, 0);
              operands[4] = x9;
              if (!register_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode)
                      || !(
#line 11662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 833; /* *call_value_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode)
                      || !(
#line 11662 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 834; /* *call_value_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (current_file_function_operand (operands[1], E_SImode)
                      && (
#line 11949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 853; /* *sibcall_value_localsi */
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !(
#line 12045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 861; /* *sibcall_value_nonlocal_sysvsi */

                case E_DImode:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 854; /* *sibcall_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !(
#line 12045 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 862; /* *sibcall_value_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode)
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  if ((
#line 11609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 829; /* *call_value_indirect_nonlocal_sysvsi */
                  if (!(
#line 11823 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 849; /* *call_value_indirect_pcrelsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  if ((
#line 11609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 830; /* *call_value_indirect_nonlocal_sysvdi */
                  if (!(
#line 11823 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 850; /* *call_value_indirect_pcreldi */

                default:
                  return -1;
                }

            case SET:
              if (pattern501 (x5, pnum_clobbers) != 0)
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[4] = x11;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pattern590 (x5, 
E_SImode) != 0
                      || !(
#line 11806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 847; /* *call_value_indirect_elfv2si */

                case E_DImode:
                  if (pattern590 (x5, 
E_DImode) != 0
                      || !(
#line 11806 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 848; /* *call_value_indirect_elfv2di */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[1], E_SImode)
                      || !(
#line 12016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 859; /* *sibcall_value_indirect_nonlocal_sysvsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !(
#line 12016 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 860; /* *sibcall_value_indirect_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      x13 = XVECEXP (x3, 0, 1);
      operands[2] = x13;
      switch (XINT (x3, 1))
        {
        case 35:
          if (GET_MODE (x3) != E_CCEQmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x14 = XEXP (x4, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !cc_reg_operand (operands[0], E_CCEQmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[4] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (pattern573 (
E_SImode) != 0
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 874; /* stack_protect_testsi */

            case E_DImode:
              if (pattern573 (
E_DImode) != 0
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 875; /* stack_protect_testdi */

            default:
              return -1;
            }

        case 145:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          switch (pattern480 (x1))
            {
            case 0:
              if (!
#line 3658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1503; /* vsx_extract_v2df_var */

            case 1:
              if (!
#line 3658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1504; /* vsx_extract_v2di_var */

            case 2:
              if (!
#line 3745 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1510; /* vsx_extract_v4sf_var */

            case 3:
              if (!
#line 4185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1531; /* vsx_extract_v16qi_var */

            case 4:
              if (!
#line 4185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1532; /* vsx_extract_v8hi_var */

            case 5:
              if (!
#line 4185 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1533; /* vsx_extract_v4si_var */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      switch (pattern105 (x1))
        {
        case 0:
          if (!
#line 12928 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
            return -1;
          return 928; /* *eqsi3 */

        case 1:
          if (!(
#line 12928 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 929; /* *eqdi3 */

        case 2:
          if (!(
#line 13220 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 944; /* *eqsi3_extdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[0] = x3;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x15 = XEXP (x8, 0);
      operands[1] = x15;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !(
#line 13656 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 985; /* tablejumpsi_insn_nospec */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 13656 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 986; /* tablejumpdi_insn_nospec */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 6
          || GET_MODE (x3) != E_DImode)
        return -1;
      x12 = XVECEXP (x3, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!scratch_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_CCmode)
          || !
#line 14589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
        return -1;
      return 1061; /* rs6000_get_timebase_ppc32 */

    case VEC_SELECT:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1522; /* *vsx_extract_v16qi_store_p9 */

        case 1:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1523; /* *vsx_extract_v8hi_store_p9 */

        case 2:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1524; /* *vsx_extract_v4si_store_p9 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1638; /* vsx_reduc_plus_v4sf */

    case SMIN:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1639; /* vsx_reduc_smin_v4sf */

    case SMAX:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1640; /* vsx_reduc_smax_v4sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_SDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_TDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_TDmode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DFmode)
          || !
#line 165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      return 2435; /* trunctdsd2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (XINT (x2, 1))
        {
        case 85:
          if (GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (gpc_reg_operand (operands[1], E_KFmode)
                  && ((
#line 5356 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5360 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], KFmode))))
                return gen_split_153 (insn, operands);
              if (!memory_operand (operands[1], E_KFmode)
                  || !((
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5377 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_155 (insn, operands);

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && ((
#line 5356 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5360 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], TFmode))))
                return gen_split_154 (insn, operands);
              if (!memory_operand (operands[1], E_TFmode)
                  || !((
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5377 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_156 (insn, operands);

            default:
              return NULL;
            }

        case 15:
          switch (pattern292 (x2))
            {
            case 0:
              if (!((
#line 10622 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_394 (insn, operands);

            case 1:
              if (!((
#line 10622 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10624 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || !got_no_const_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 7707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
    && flag_pic == 1
    && reload_completed))
            return NULL;
          return gen_split_290 (insn, operands);

        case 14:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern417 (x2, 
E_SImode) != 0
                  || !((
#line 10575 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_392 (insn, operands);

            case E_DImode:
              if (pattern417 (x2, 
E_DImode) != 0
                  || !((
#line 10575 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case 23:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern220 (x2, 
E_SImode) != 0
                  || !((
#line 10688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10690 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_396 (insn, operands);

            case E_DImode:
              if (pattern220 (x2, 
E_DImode) != 0
                  || !((
#line 10688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10690 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_397 (insn, operands);

            default:
              return NULL;
            }

        case 27:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern220 (x2, 
E_SImode) != 0
                  || !((
#line 10768 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_398 (insn, operands);

            case E_DImode:
              if (pattern220 (x2, 
E_DImode) != 0
                  || !((
#line 10768 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10770 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_399 (insn, operands);

            default:
              return NULL;
            }

        case 70:
          if (GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[0], E_DFmode))
            return NULL;
          switch (pattern433 ())
            {
            case 0:
              if (((
#line 14881 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14883 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_493 (insn, operands);
              if (!((
#line 14904 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_496 (insn, operands);

            case 1:
              if (((
#line 14881 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14883 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_494 (insn, operands);
              if (!((
#line 14904 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14906 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_497 (insn, operands);

            default:
              return NULL;
            }

        case 71:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_TFmode) != 0)
                return NULL;
              if (((
#line 14940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14942 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_499 (insn, operands);
              if (!((
#line 14964 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14966 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_502 (insn, operands);

            case E_IFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_IFmode) != 0
                  || !((
#line 14940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14942 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_500 (insn, operands);

            case E_TDmode:
              if (pattern146 (x2, 
E_DImode, 
E_TDmode) != 0
                  || !((
#line 14940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14942 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_501 (insn, operands);

            default:
              return NULL;
            }

        case 138:
          if (pattern360 (x2) != 0
              || !
#line 1730 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_600 (insn, operands);

        case 130:
          if (pattern360 (x2) != 0
              || !
#line 1785 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_601 (insn, operands);

        case 131:
          if (pattern360 (x2) != 0
              || !
#line 1832 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_602 (insn, operands);

        case 361:
          if (GET_MODE (x2) != E_OOmode
              || !vsx_register_operand (operands[0], E_OOmode)
              || !mma_assemble_input_operand (operands[1], E_V16QImode)
              || !mma_assemble_input_operand (operands[2], E_V16QImode)
              || !(
#line 383 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
( reload_completed)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 362:
          if (GET_MODE (x2) != E_V16QImode
              || !mma_disassemble_output_operand (operands[0], E_V16QImode))
            return NULL;
          switch (pattern434 ())
            {
            case 0:
              if (!(
#line 415 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)) && 
#line 418 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
( reload_completed)))
                return NULL;
              return gen_split_741 (insn, operands);

            case 1:
              if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)) && 
#line 492 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
( reload_completed)))
                return NULL;
              return gen_split_743 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 3:
      if (XINT (x2, 1) != 263)
        return NULL;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_722 (insn, operands);

        case 1:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_723 (insn, operands);

        case 2:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_724 (insn, operands);

        case 3:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_725 (insn, operands);

        case 4:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_726 (insn, operands);

        case 5:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_727 (insn, operands);

        case 6:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_728 (insn, operands);

        case 7:
          if (!(
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_729 (insn, operands);

        case 8:
          if (!((
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 9:
          if (!((
#line 391 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
