/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case VEC_SELECT:
      res = pattern7 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern2 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || pattern37 (x1, 
E_DImode, 
-1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern43 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern43 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern41 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern41 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern59 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern59 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern59 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern59 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern59 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern59 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern59 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern59 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern59 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern59 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_V2DFmode))
    return -1;
  x9 = XEXP (x4, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern87 (x1); /* [-1, 1] */
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case FIX:
      return pattern99 (x1); /* [-1, 1] */

    case VEC_SELECT:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 102
      || GET_MODE (x4) != E_V4SFmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!vfloat_operand (operands[0], E_V4SFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  if (!scratch_operand (operands[2], E_V4SFmode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern119 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = PATTERN (peep2_next_insn (1));
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x7, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern118 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern118 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern146 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern146 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern146 (x3, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern172 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern141 (x3, 
E_V1TImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern187 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern193 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern193 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], i1))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern234 (x4, 
i1); /* [-1, 0] */
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  return pattern236 (x4); /* [-1, 23] */
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 87)
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 441
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  operands[1] = x1;
  if (!any_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern267 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern267 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern268 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern268 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern268 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern268 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern268 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern268 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern268 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern268 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern268 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern268 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern287 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern299 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern308 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case EQ:
      return pattern307 (x1); /* [-1, 1] */

    case NE:
      res = pattern307 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[2] = x2;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !const_vector_each_byte_same (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !const_vector_each_byte_same (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !const_vector_each_byte_same (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !const_vector_each_byte_same (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!altivec_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !const_vector_each_byte_same (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !const_vector_each_byte_same (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!altivec_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !const_vector_each_byte_same (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_TImode:
      if (!altivec_register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !const_vector_each_byte_same (operands[1], E_TImode))
        return -1;
      return 7;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !const_vector_each_byte_same (operands[1], E_KFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !const_vector_each_byte_same (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern363 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !vlogical_operand (operands[2], i1)
      || !vlogical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern388 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern392 (x5, 
i1); /* [-1, 0] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern191 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern191 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern231 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern231 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern231 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern231 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern231 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern231 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern231 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern231 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern231 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern231 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern438 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern445 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern452 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern459 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern466 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern477 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern485 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern485 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern511 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !vsx_register_operand (operands[2], E_DImode)
      || !base_reg_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern551 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern556 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern564 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern573 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[3]))
    return -1;
  return 0;
}

int
pattern585 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern592 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (!cc_reg_operand (x5, E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      operands[3] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          if (logical_const_operand (operands[2], E_SImode))
            {
              if (
#line 3654 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 2;
                  return 201; /* *andsi3_imm_dot */
                }
              if (
#line 3705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 1;
                  return 205; /* *andsi3_imm_mask_dot */
                }
            }
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          if (
#line 3785 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
            {
              *pnum_clobbers = 1;
              return 213; /* *andsi3_mask_dot */
            }
          if (!
#line 3859 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
            return -1;
          *pnum_clobbers = 1;
          return 219; /* *andsi3_2insn_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          if (logical_const_operand (operands[2], E_DImode))
            {
              if ((
#line 3654 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 2;
                  return 202; /* *anddi3_imm_dot */
                }
              if ((
#line 3705 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 1;
                  return 206; /* *anddi3_imm_mask_dot */
                }
            }
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 3785 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pnum_clobbers = 1;
              return 214; /* *anddi3_mask_dot */
            }
          if (!(
#line 3859 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 220; /* *anddi3_2insn_dot */

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (GET_CODE (x6) == LSHIFTRT)
        {
          operands[3] = x5;
          x9 = XEXP (x6, 1);
          operands[4] = x9;
          if (const_int_operand (operands[4], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (x3))
                {
                case E_SImode:
                  if (GET_MODE (x6) == E_SImode
                      && gpc_reg_operand (operands[1], E_SImode)
                      && const_int_operand (operands[2], E_SImode)
                      && 
#line 3756 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)))
                    {
                      *pnum_clobbers = 1;
                      return 209; /* *andsi3_imm_dot_shifted */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x6) == E_DImode
                      && gpc_reg_operand (operands[1], E_DImode)
                      && const_int_operand (operands[2], E_DImode)
                      && (
#line 3756 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 1;
                      return 210; /* *anddi3_imm_dot_shifted */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      operands[5] = x5;
      operands[4] = x6;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!rotate_mask_operator (operands[4], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !const_int_operand (operands[3], E_SImode)
              || !
#line 4198 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          *pnum_clobbers = 1;
          return 248; /* *rotlsi3_mask_dot */

        case E_DImode:
          if (!rotate_mask_operator (operands[4], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || !(
#line 4198 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 249; /* *rotldi3_mask_dot */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
              operands[4] = x5;
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) != ASHIFT)
                return -1;
              x7 = XEXP (x1, 0);
              operands[0] = x7;
              operands[3] = x4;
              switch (pattern218 (x2))
                {
                case 0:
                  if (!
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 263; /* *rotlsi3_insert_3_xor */

                case 1:
                  if (!(
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 265; /* *rotldi3_insert_3_xor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              x7 = XEXP (x1, 0);
              operands[3] = x7;
              operands[0] = x4;
              x6 = XEXP (x2, 1);
              operands[2] = x6;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern41 (x2, 
E_SImode) != 0
                      || !
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2659; /* *fuse_and_xor */

                case E_DImode:
                  if (pattern41 (x2, 
E_DImode) != 0
                      || !(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2660; /* *fuse_and_xor */

                case E_V4SImode:
                  if (pattern59 (x2, 
E_V4SImode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3259; /* *fuse_vand_vxor */

                case E_V8HImode:
                  if (pattern59 (x2, 
E_V8HImode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3260; /* *fuse_vand_vxor */

                case E_V16QImode:
                  if (pattern59 (x2, 
E_V16QImode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3261; /* *fuse_vand_vxor */

                case E_V4SFmode:
                  if (pattern59 (x2, 
E_V4SFmode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3262; /* *fuse_vand_vxor */

                case E_V2DFmode:
                  if (pattern59 (x2, 
E_V2DFmode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3263; /* *fuse_vand_vxor */

                case E_V2DImode:
                  if (pattern59 (x2, 
E_V2DImode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3264; /* *fuse_vand_vxor */

                case E_V1TImode:
                  if (pattern59 (x2, 
E_V1TImode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3265; /* *fuse_vand_vxor */

                case E_TImode:
                  if (pattern59 (x2, 
E_TImode) != 0
                      || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3266; /* *fuse_vand_vxor */

                case E_KFmode:
                  if (pattern59 (x2, 
E_KFmode) != 0
                      || !(
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3267; /* *fuse_vand_vxor */

                case E_TFmode:
                  if (pattern59 (x2, 
E_TFmode) != 0
                      || !(
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3268; /* *fuse_vand_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern53 (x2, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2661; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern53 (x2, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2662; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern54 (x2, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3269; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern54 (x2, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3270; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern54 (x2, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3271; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern54 (x2, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3272; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern54 (x2, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3273; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern54 (x2, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3274; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern54 (x2, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3275; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern54 (x2, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3276; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern54 (x2, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3277; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern54 (x2, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3278; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x9 = XEXP (x5, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern43 (x2, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2667; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern43 (x2, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2668; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern49 (x2, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3299; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern49 (x2, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3300; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern49 (x2, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3301; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern49 (x2, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3302; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern49 (x2, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3303; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern49 (x2, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3304; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern49 (x2, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3305; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern49 (x2, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3306; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern49 (x2, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3307; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern49 (x2, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3308; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      switch (pattern429 (x2))
        {
        case 0:
          if (!
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2663; /* *fuse_eqv_xor */

        case 1:
          if (!(
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2664; /* *fuse_eqv_xor */

        case 2:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3279; /* *fuse_veqv_vxor */

        case 3:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3280; /* *fuse_veqv_vxor */

        case 4:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3281; /* *fuse_veqv_vxor */

        case 5:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3282; /* *fuse_veqv_vxor */

        case 6:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3283; /* *fuse_veqv_vxor */

        case 7:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3284; /* *fuse_veqv_vxor */

        case 8:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3285; /* *fuse_veqv_vxor */

        case 9:
          if (!
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3286; /* *fuse_veqv_vxor */

        case 10:
          if (!(
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3287; /* *fuse_veqv_vxor */

        case 11:
          if (!(
#line 2923 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3288; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NOT:
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case NOT:
              x9 = XEXP (x5, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern43 (x2, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2665; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern43 (x2, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2666; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern49 (x2, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3289; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern49 (x2, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3290; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern49 (x2, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3291; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern49 (x2, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3292; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern49 (x2, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3293; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern49 (x2, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3294; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern49 (x2, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3295; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern49 (x2, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3296; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern49 (x2, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3297; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern49 (x2, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3298; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern53 (x2, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2671; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern53 (x2, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2672; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern54 (x2, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3319; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern54 (x2, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3320; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern54 (x2, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3321; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern54 (x2, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3322; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern54 (x2, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3323; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern54 (x2, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3324; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern54 (x2, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3325; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern54 (x2, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3326; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern54 (x2, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3327; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern54 (x2, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3328; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern371 (x2))
            {
            case 0:
              if (!
#line 1609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2669; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2670; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3309; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3310; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3311; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3312; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3313; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3314; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3315; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3316; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3317; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3318; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern41 (x2, 
E_SImode) != 0
              || !
#line 1645 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2673; /* *fuse_xor_xor */

        case E_DImode:
          if (pattern41 (x2, 
E_DImode) != 0
              || !(
#line 1645 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2674; /* *fuse_xor_xor */

        case E_V4SImode:
          if (pattern59 (x2, 
E_V4SImode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3329; /* *fuse_vxor_vxor */

        case E_V8HImode:
          if (pattern59 (x2, 
E_V8HImode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3330; /* *fuse_vxor_vxor */

        case E_V16QImode:
          if (pattern59 (x2, 
E_V16QImode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3331; /* *fuse_vxor_vxor */

        case E_V4SFmode:
          if (pattern59 (x2, 
E_V4SFmode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *fuse_vxor_vxor */

        case E_V2DFmode:
          if (pattern59 (x2, 
E_V2DFmode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3333; /* *fuse_vxor_vxor */

        case E_V2DImode:
          if (pattern59 (x2, 
E_V2DImode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3334; /* *fuse_vxor_vxor */

        case E_V1TImode:
          if (pattern59 (x2, 
E_V1TImode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3335; /* *fuse_vxor_vxor */

        case E_TImode:
          if (pattern59 (x2, 
E_TImode) != 0
              || !
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *fuse_vxor_vxor */

        case E_KFmode:
          if (pattern59 (x2, 
E_KFmode) != 0
              || !(
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3337; /* *fuse_vxor_vxor */

        case E_TFmode:
          if (pattern59 (x2, 
E_TFmode) != 0
              || !(
#line 3013 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3338; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern154 (x1))
    {
    case 0:
      if (!
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FRES))
        return -1;
      return 322; /* fres */

    case 1:
      if (!
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FRE))
        return -1;
      return 323; /* fred */

    case 2:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 1977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1354; /* vsx_frev4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2659 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 2115; /* altivec_vrefp */

    case 3:
      if (!
#line 1977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1355; /* vsx_frev2df2 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L)
        return -1;
      switch (pattern9 (x3))
        {
        case 0:
          if (!(
#line 10614 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 754; /* *tls_ld_pcrel32 */

        case 1:
          if (!(
#line 10614 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 755; /* *tls_ld_pcrel64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern292 (x3))
        {
        case 0:
          if (!(
#line 10622 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 756; /* *tls_ld32 */

        case 1:
          if (!(
#line 10622 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 757; /* *tls_ld64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!int_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !d_form_memory (operands[1], E_QImode)
          || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3344; /* *pcrel_opt_ldqi_gpr */

    case E_HImode:
      if (!int_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !d_form_memory (operands[1], E_HImode)
          || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3345; /* *pcrel_opt_ldhi_gpr */

    case E_SFmode:
      if (!int_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !d_form_memory (operands[1], E_SFmode)
          || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3348; /* *pcrel_opt_ldsf_gpr */

    case E_DFmode:
      if (!int_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !d_form_memory (operands[1], E_DFmode)
          || !
#line 152 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3349; /* *pcrel_opt_lddf_gpr */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 868; /* probe_stack_si */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 869; /* probe_stack_di */

        default:
          return -1;
        }

    case 74:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern216 (x2))
        {
        case 0:
          if (!
#line 14396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 1048; /* load_split_stack_limit_di */

        case 1:
          if (!
#line 14405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_64BIT))
            return -1;
          return 1049; /* load_split_stack_limit_si */

        default:
          return -1;
        }

    case 73:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!base_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !fusion_addis_mem_combo_load (operands[1], E_SImode)
              || !
#line 14733 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
            return -1;
          return 1070; /* *fusion_gpr_load_si */

        case E_DImode:
          if (!base_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !fusion_addis_mem_combo_load (operands[1], E_DImode)
              || !(
#line 14733 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION) && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1071; /* *fusion_gpr_load_di */

        default:
          return -1;
        }

    case 66:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 14829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
        return -1;
      return 1073; /* cdtbcd */

    case 67:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 14837 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
        return -1;
      return 1074; /* cbcdtd */

    case 139:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          switch (pattern339 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 5099 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1650; /* vsx_sign_extend_v16qi_di */

            case 1:
              if (!
#line 5108 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1654; /* vsx_sign_extend_v8hi_di */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern339 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 5099 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1651; /* vsx_sign_extend_v16qi_si */

            case 1:
              if (!
#line 5108 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1655; /* vsx_sign_extend_v8hi_si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 146:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (altivec_register_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 5200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1660; /* xsxexpqp_kf_di */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 5200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1662; /* xsxexpqp_tf_di */
                  break;

                default:
                  break;
                }
            }
          if (!register_operand (operands[0], E_DImode)
              || !vsx_register_operand (operands[1], E_DFmode)
              || !(
#line 5209 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1664; /* xsxexpdp_di */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !vsx_register_operand (operands[1], E_DFmode)
              || !
#line 5209 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1663; /* xsxexpdp_si */

        default:
          return -1;
        }

    case 147:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 5228 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
        return -1;
      return 1669; /* xsxsigdp */

    case 168:
      switch (pattern223 (x2))
        {
        case 0:
          if (!
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1718; /* vclzlsbb_v16qi */

        case 1:
          if (!
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1720; /* vclzlsbb_v8hi */

        case 2:
          if (!
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1722; /* vclzlsbb_v4si */

        default:
          return -1;
        }

    case 169:
      switch (pattern223 (x2))
        {
        case 0:
          if (!
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1719; /* vctzlsbb_v16qi */

        case 1:
          if (!
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1721; /* vctzlsbb_v8hi */

        case 2:
          if (!
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1723; /* vctzlsbb_v4si */

        default:
          return -1;
        }

    case 193:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!altivec_register_operand (operands[1], E_V16QImode)
              || !
#line 6480 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1748; /* vec_extract_v16qi */

        case E_V8HImode:
          if (!altivec_register_operand (operands[1], E_V8HImode)
              || !
#line 6480 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1749; /* vec_extract_v8hi */

        case E_V4SImode:
          if (!altivec_register_operand (operands[1], E_V4SImode)
              || !
#line 6480 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1750; /* vec_extract_v4si */

        case E_V2DImode:
          if (!altivec_register_operand (operands[1], E_V2DImode)
              || !
#line 6480 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1751; /* vec_extract_v2di */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !
#line 6480 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1752; /* vec_extract_v1ti */

        default:
          return -1;
        }

    case 283:
      if (pattern222 (x2, 
E_SImode, 
108) != 0
          || !register_operand (operands[0], E_SImode)
          || !
#line 407 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1809; /* get_vrsave_internal */

    case 281:
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[0], E_SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4SImode)
          || !
#line 3242 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2285; /* altivec_stvewx */

    case 427:
      if (GET_MODE (x2) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_DDmode:
          if (!gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2459; /* dfp_dxex_dd */

        case E_TDmode:
          if (!gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 325 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2460; /* dfp_dxex_td */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          switch (pattern439 (x2, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2197; /* altivec_lvx_v8hi_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2198; /* altivec_lvx_v8hi_2op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern439 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2205; /* altivec_lvx_v2di_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2206; /* altivec_lvx_v2di_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          switch (pattern384 (x2, 
E_V8HImode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2215; /* altivec_lvx_v8hi_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2216; /* altivec_lvx_v8hi_1op_di */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern384 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2223; /* altivec_lvx_v2di_1op_si */

            case 1:
              if (!(
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2224; /* altivec_lvx_v2di_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 9; /* *zero_extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 15; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 10; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 16; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 20; /* *zero_extendsidi2_dot */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 24; /* *extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 30; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 25; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 31; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 35; /* *extendsidi2_dot */

        default:
          return -1;
        }

    case PLUS:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern418 (x3))
            {
            case 0:
              if (!
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 70; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 71; /* *adddi3_dot */

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !short_cint_operand (operands[2], E_SImode)
                  || !
#line 1919 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 2;
              return 74; /* *addsi3_imm_dot */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !short_cint_operand (operands[2], E_DImode)
                  || !(
#line 1919 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 75; /* *adddi3_imm_dot */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 98; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 99; /* *one_cmpldi2_dot */

        default:
          return -1;
        }

    case MINUS:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 104; /* *subfsi3_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 105; /* *subfdi3_dot */

        default:
          return -1;
        }

    case NEG:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 129; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 130; /* *negdi2_dot */

        default:
          return -1;
        }

    case MULT:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (pattern418 (x3))
        {
        case 0:
          if (!
#line 3124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 167; /* *mulsi3_dot */

        case 1:
          if (!(
#line 3124 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 168; /* *muldi3_dot */

        default:
          return -1;
        }

    case DIV:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !exact_log2_cint_operand (operands[2], E_SImode)
              || !
#line 3394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 194; /* *divsi3_sra_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !exact_log2_cint_operand (operands[2], E_DImode)
              || !(
#line 3394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 195; /* *divdi3_sra_dot */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      return recog_3 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 278; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 279; /* *rotldi3_dot */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern26 (x3))
            {
            case 0:
              if (!
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 285; /* *ashlsi3_dot */

            case 1:
              if (!(
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 286; /* *ashldi3_dot */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4732 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          *pnum_clobbers = 1;
          return 290; /* ashdi3_extswsli_dot */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 295; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 296; /* *lshrdi3_dot */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4918 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 302; /* *ashrsi3_dot */

        case 1:
          if (!(
#line 4918 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 303; /* *ashrdi3_dot */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!cc_reg_operand (operands[0], E_CCFPmode)
              || GET_MODE (x2) != E_CCFPmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!gpc_reg_operand (operands[1], E_SFmode)
                  || !gpc_reg_operand (operands[2], E_SFmode)
                  || !
#line 5221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 326; /* *cmpsf_fpr */

            case E_DFmode:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !gpc_reg_operand (operands[2], E_DFmode)
                  || !
#line 5221 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 327; /* *cmpdf_fpr */

            case E_IFmode:
              if (!gpc_reg_operand (operands[1], E_IFmode)
                  || !gpc_reg_operand (operands[2], E_IFmode))
                return -1;
              if ((
#line 12704 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 880; /* *cmpif_internal1 */
              if (pnum_clobbers == NULL)
                return -1;
              if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                {
                  *pnum_clobbers = 9;
                  return 882; /* *cmpif_internal2 */
                }
              if (!(
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return -1;
              *pnum_clobbers = 9;
              return 883; /* *cmpif_internal2 */

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && gpc_reg_operand (operands[2], E_TFmode))
                {
                  if ((
#line 12704 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 881; /* *cmptf_internal1 */
                  if (pnum_clobbers != NULL)
                    {
                      if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                        {
                          *pnum_clobbers = 9;
                          return 884; /* *cmptf_internal2 */
                        }
                      if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                        {
                          *pnum_clobbers = 9;
                          return 885; /* *cmptf_internal2 */
                        }
                    }
                }
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 15603 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1204; /* *cmptf_hw */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 15603 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1203; /* *cmpkf_hw */

            case E_DDmode:
              if (!gpc_reg_operand (operands[1], E_DDmode)
                  || !gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 209 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2444; /* *cmpdd_internal1 */

            case E_TDmode:
              if (!gpc_reg_operand (operands[1], E_TDmode)
                  || !gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 209 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2445; /* *cmptd_internal1 */

            default:
              return -1;
            }

        case E_CCmode:
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          switch (pattern319 (x2, 
E_CCmode))
            {
            case 0:
              return 876; /* *cmpsi_signed */

            case 1:
              if (!
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 877; /* *cmpdi_signed */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[0], E_CCUNSmode))
            return -1;
          switch (pattern127 (x2, 
E_CCUNSmode))
            {
            case 0:
              return 878; /* *cmpsi_unsigned */

            case 1:
              if (!
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 879; /* *cmpdi_unsigned */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNLE:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_reg_operand (operands[0], E_CCEQmode)
          || GET_MODE (x2) != E_CCEQmode)
        return -1;
      operands[1] = x3;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          x8 = XEXP (x2, 1);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (branch_positive_comparison_operator (operands[1], E_SImode))
                    return 973; /* cceq_rev_compare_si */
                  break;

                case E_DImode:
                  if (branch_positive_comparison_operator (operands[1], E_DImode)
                      && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return 974; /* cceq_rev_compare_di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      x8 = XEXP (x2, 1);
      if (!branch_comparison_operator (x8, E_VOIDmode))
        return -1;
      operands[3] = x8;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !branch_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[4] = x10;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      return 975; /* *rs6000.md:13454 */

    case UNSPEC:
      return recog_2 (x1, insn, pnum_clobbers);

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x2) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !
#line 28 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2509; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !
#line 112 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2513; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2519; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */
                }
              if (!(
#line 239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2520; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x2) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !
#line 49 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2510; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !
#line 133 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2514; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_0_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 260 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2521; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */
                }
              if (!(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2522; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

            case E_QImode:
              if (!non_update_memory_operand (operands[1], E_QImode)
                  || !const_0_to_1_operand (operands[3], E_QImode))
                return -1;
              if (
#line 323 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2527; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */
                }
              if (!(
#line 323 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2528; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
    case XOR:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern329 (
E_SImode) != 0)
            return -1;
          return 226; /* *boolsi3 */

        case E_DImode:
          if (pattern329 (
E_DImode) != 0
              || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 227; /* *booldi3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern372 (x4, 
E_SImode) != 0)
                return -1;
              return 232; /* *boolcsi3 */

            case E_DImode:
              if (pattern372 (x4, 
E_DImode) != 0
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 233; /* *boolcdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && 
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 525; /* *boolcti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !
#line 7488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 534; /* *boolcti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && 
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 526; /* *boolcpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !
#line 7488 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 535; /* *boolcpti3_internal2 */

            case E_V16QImode:
              if (pattern373 (x4, 
E_V16QImode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 527; /* *boolcv16qi3_internal1 */

            case E_V8HImode:
              if (pattern373 (x4, 
E_V8HImode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 528; /* *boolcv8hi3_internal1 */

            case E_V4SImode:
              if (pattern373 (x4, 
E_V4SImode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 529; /* *boolcv4si3_internal1 */

            case E_V4SFmode:
              if (pattern373 (x4, 
E_V4SFmode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 530; /* *boolcv4sf3_internal1 */

            case E_V2DImode:
              if (pattern373 (x4, 
E_V2DImode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 531; /* *boolcv2di3_internal1 */

            case E_V2DFmode:
              if (pattern373 (x4, 
E_V2DFmode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 532; /* *boolcv2df3_internal1 */

            case E_V1TImode:
              if (pattern373 (x4, 
E_V1TImode) != 0
                  || !(
#line 7451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 533; /* *boolcv1ti3_internal1 */

            default:
              return -1;
            }

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern375 (x2, 
E_SImode) != 0)
                return -1;
              return 238; /* *boolccsi3 */

            case E_DImode:
              if (pattern375 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 239; /* *boolccdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && 
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 536; /* *boolccti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !
#line 7549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 545; /* *boolccti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode
                  || GET_MODE (x5) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && 
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 537; /* *boolccpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !
#line 7549 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 546; /* *boolccpti3_internal2 */

            case E_V16QImode:
              if (pattern376 (x2, 
E_V16QImode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 538; /* *boolccv16qi3_internal1 */

            case E_V8HImode:
              if (pattern376 (x2, 
E_V8HImode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 539; /* *boolccv8hi3_internal1 */

            case E_V4SImode:
              if (pattern376 (x2, 
E_V4SImode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 540; /* *boolccv4si3_internal1 */

            case E_V4SFmode:
              if (pattern376 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 541; /* *boolccv4sf3_internal1 */

            case E_V2DImode:
              if (pattern376 (x2, 
E_V2DImode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 542; /* *boolccv2di3_internal1 */

            case E_V2DFmode:
              if (pattern376 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 543; /* *boolccv2df3_internal1 */

            case E_V1TImode:
              if (pattern376 (x2, 
E_V1TImode) != 0
                  || !(
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 544; /* *boolccv1ti3_internal1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern347 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1455; /* vsx_concat_v2df */

            case E_V2DImode:
              if (pattern347 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3132 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1456; /* vsx_concat_v2di */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern493 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3181 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1459; /* *vsx_concat_v2df_2 */

            case E_V2DImode:
              if (pattern493 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3181 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1460; /* *vsx_concat_v2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XVECEXP (x9, 0, 0);
      operands[2] = x11;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern494 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3158 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1457; /* *vsx_concat_v2df_1 */

            case E_V2DImode:
              if (pattern494 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3158 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1458; /* *vsx_concat_v2di_1 */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[4] = x8;
          if (!const_0_to_1_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern561 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3206 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1461; /* *vsx_concat_v2df_3 */

            case E_V2DImode:
              if (pattern561 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3206 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1462; /* *vsx_concat_v2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 44:
      if (GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern197 (x4, 
43, 
2) != 0)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 1730 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DLMZB))
        return -1;
      return 67; /* dlmzb */

    case 1:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 96
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[0] = x7;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 0);
      operands[1] = x12;
      x4 = XVECEXP (x1, 0, 1);
      if (!rtx_equal_p (x4, operands[1])
          || !
#line 11189 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
        return -1;
      return 798; /* load_toc_v4_PIC_1b_normal */

    case 35:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_CCEQmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 0);
      operands[4] = x9;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !scratch_operand (operands[4], E_SImode)
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 874; /* stack_protect_testsi */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !scratch_operand (operands[4], E_DImode)
              || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 875; /* stack_protect_testdi */

        default:
          return -1;
        }

    case 145:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern348 (x1))
        {
        case 0:
          if (!
#line 3675 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1505; /* *vsx_extract_v2df_var_load */

        case 1:
          if (!
#line 3675 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1506; /* *vsx_extract_v2di_var_load */

        case 2:
          if (!
#line 3762 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1511; /* *vsx_extract_v4sf_var_load */

        case 3:
          if (!
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1534; /* *vsx_extract_v16qi_var_load */

        case 4:
          if (!
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1535; /* *vsx_extract_v8hi_var_load */

        case 5:
          if (!
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1536; /* *vsx_extract_v4si_var_load */

        default:
          return -1;
        }

    case 177:
      if (pattern227 (x1, 
E_V16QImode, 
177) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XEXP (x4, 1);
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 5903 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1707; /* vcmpnezb_p */

    case 249:
      if (pattern228 (x1, 
E_V16QImode) != 0
          || !
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2058; /* altivec_vsum4ubs */

    case 250:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern295 (x4, 
E_SImode, 
282) != 0
          || pattern259 (x1, 
E_V4SImode, 
E_SImode, 
109) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2059; /* altivec_vsum4shs */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2060; /* altivec_vsum4sbs */

        default:
          return -1;
        }

    case 251:
      if (pattern228 (x1, 
E_V4SImode) != 0
          || !
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2061; /* altivec_vsum2sws_direct */

    case 333:
      if (pattern228 (x1, 
E_V4SImode) != 0
          || !
#line 2310 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2062; /* altivec_vsumsws_direct */

    case 259:
      if (pattern229 (x1) != 0
          || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2110; /* altivec_vctuxs */

    case 260:
      if (pattern229 (x1) != 0
          || !
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2111; /* altivec_vctsxs */

    case 209:
      if (pattern227 (x1, 
E_V4SFmode, 
209) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x5 = XEXP (x4, 1);
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 2930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode)))
        return -1;
      return 2158; /* altivec_vcmpbfp_p */

    case 442:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern295 (x4, 
E_DImode, 
443) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!base_reg_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!pcrel_external_address (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      if (!gpc_reg_operand (operands[3], E_DImode)
          || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && reg_or_subregno (operands[0]) != reg_or_subregno (operands[3])))
        return -1;
      return 3342; /* pcrel_opt_ld_addr */

    case 446:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!pcrel_external_address (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[3], E_QImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3372; /* *pcrel_opt_st_addrqi */

        case E_HImode:
          if (!gpc_reg_operand (operands[3], E_HImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3373; /* *pcrel_opt_st_addrhi */

        case E_SImode:
          if (!gpc_reg_operand (operands[3], E_SImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3374; /* *pcrel_opt_st_addrsi */

        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3375; /* *pcrel_opt_st_addrdi */

        case E_TImode:
          if (!gpc_reg_operand (operands[3], E_TImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3376; /* *pcrel_opt_st_addrti */

        case E_SFmode:
          if (!gpc_reg_operand (operands[3], E_SFmode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3377; /* *pcrel_opt_st_addrsf */

        case E_DFmode:
          if (!gpc_reg_operand (operands[3], E_DFmode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3378; /* *pcrel_opt_st_addrdf */

        case E_KFmode:
          if (!gpc_reg_operand (operands[3], E_KFmode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3379; /* *pcrel_opt_st_addrkf */

        case E_V1TImode:
          if (!gpc_reg_operand (operands[3], E_V1TImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3380; /* *pcrel_opt_st_addrv1ti */

        case E_V2DImode:
          if (!gpc_reg_operand (operands[3], E_V2DImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3381; /* *pcrel_opt_st_addrv2di */

        case E_V4SImode:
          if (!gpc_reg_operand (operands[3], E_V4SImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3382; /* *pcrel_opt_st_addrv4si */

        case E_V8HImode:
          if (!gpc_reg_operand (operands[3], E_V8HImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3383; /* *pcrel_opt_st_addrv8hi */

        case E_V16QImode:
          if (!gpc_reg_operand (operands[3], E_V16QImode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3384; /* *pcrel_opt_st_addrv16qi */

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[3], E_V2DFmode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3385; /* *pcrel_opt_st_addrv2df */

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[3], E_V4SFmode)
              || !
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3386; /* *pcrel_opt_st_addrv4sf */

        case E_TFmode:
          if (!gpc_reg_operand (operands[3], E_TFmode)
              || !(
#line 300 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 95 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
            return -1;
          return 3387; /* *pcrel_opt_st_addrtf */

        default:
          return -1;
        }

    case 447:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      if (!base_reg_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!d_form_memory (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !gpc_reg_operand (operands[1], E_QImode)
              || !
#line 313 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3388; /* *pcrel_opt_stqi */

        case E_HImode:
          if (!d_form_memory (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !gpc_reg_operand (operands[1], E_HImode)
              || !
#line 313 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3389; /* *pcrel_opt_sthi */

        case E_SImode:
          if (!d_form_memory (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 313 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3390; /* *pcrel_opt_stsi */

        case E_DImode:
          if (!d_form_memory (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT && TARGET_POWERPC64))
            return -1;
          return 3391; /* *pcrel_opt_stdi */

        case E_SFmode:
          if (!d_form_memory (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 349 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3392; /* *pcrel_opt_stsf */

        case E_DFmode:
          if (!d_form_memory (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 372 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (TARGET_POWERPC64 || vsx_register_operand (operands[1], DFmode))))
            return -1;
          return 3393; /* *pcrel_opt_stdf */

        case E_TImode:
          if (!d_form_memory (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !gpc_reg_operand (operands[1], E_TImode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3394; /* *pcrel_opt_stti */

        case E_KFmode:
          if (!d_form_memory (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || !gpc_reg_operand (operands[1], E_KFmode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3395; /* *pcrel_opt_stkf */

        case E_V1TImode:
          if (!d_form_memory (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !gpc_reg_operand (operands[1], E_V1TImode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3396; /* *pcrel_opt_stv1ti */

        case E_V2DImode:
          if (!d_form_memory (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !gpc_reg_operand (operands[1], E_V2DImode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3397; /* *pcrel_opt_stv2di */

        case E_V4SImode:
          if (!d_form_memory (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3398; /* *pcrel_opt_stv4si */

        case E_V8HImode:
          if (!d_form_memory (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !gpc_reg_operand (operands[1], E_V8HImode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3399; /* *pcrel_opt_stv8hi */

        case E_V16QImode:
          if (!d_form_memory (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !gpc_reg_operand (operands[1], E_V16QImode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3400; /* *pcrel_opt_stv16qi */

        case E_V2DFmode:
          if (!d_form_memory (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !gpc_reg_operand (operands[1], E_V2DFmode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3401; /* *pcrel_opt_stv2df */

        case E_V4SFmode:
          if (!d_form_memory (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !gpc_reg_operand (operands[1], E_V4SFmode)
              || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3402; /* *pcrel_opt_stv4sf */

        case E_TFmode:
          if (!d_form_memory (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !gpc_reg_operand (operands[1], E_TFmode)
              || !(
#line 396 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
            return -1;
          return 3403; /* *pcrel_opt_sttf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      if (vsx_register_operand (operands[1], E_V1TImode)
          && XWINT (x5, 0) == 0L
          && memory_operand (operands[0], E_V1TImode)
          && GET_MODE (x3) == E_V1TImode)
        {
          x9 = XEXP (x6, 0);
          if (rtx_equal_p (x9, operands[1])
              && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1326; /* vsx_st_elemrev_v1ti */
        }
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern533 (x3, 
E_V2DFmode, 
E_DFmode))
            {
            case 0:
              if (!(
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 1495; /* *vsx_extract_si_v2df_load */

            case 1:
              if (!(
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 1496; /* *vsx_extract_di_v2df_load */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern533 (x3, 
E_V2DImode, 
E_DImode))
            {
            case 0:
              if (!(
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 1497; /* *vsx_extract_si_v2di_load */

            case 1:
              if (!(
#line 3613 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 1498; /* *vsx_extract_di_v2di_load */

            default:
              return -1;
            }

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && 
#line 3692 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1507; /* vsx_extract_v4sf */
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          switch (pattern557 ())
            {
            case 0:
              if (!(
#line 3725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 1508; /* *vsx_extract_v4sf_si_load */

            case 1:
              if (!(
#line 3725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 1509; /* *vsx_extract_v4sf_di_load */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V4SImode)
              && const_0_to_3_operand (operands[2], E_QImode))
            {
              if (nonimmediate_operand (operands[0], E_SImode)
                  && scratch_operand (operands[3], E_V4SImode))
                {
                  if (
#line 3932 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                    return 1514; /* vsx_extract_v4si_w1 */
                  if (
#line 4081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT))
                    return 1525; /* *vsx_extract_v4si_w023 */
                }
              if (gpc_reg_operand (operands[0], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                return 1518; /* vsx_extract_v4si_p9 */
            }
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1530; /* *vsx_extract_v4si_load */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V16QImode)
              && const_0_to_15_operand (operands[2], E_QImode))
            {
              if (gpc_reg_operand (operands[0], E_QImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
                return 1516; /* vsx_extract_v16qi_p9 */
              if (nonimmediate_operand (operands[0], E_QImode)
                  && scratch_operand (operands[3], E_V16QImode)
                  && 
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
                return 1526; /* *vsx_extract_v16qi_p8 */
            }
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1528; /* *vsx_extract_v16qi_load */

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V8HImode)
              && const_0_to_7_operand (operands[2], E_QImode))
            {
              if (gpc_reg_operand (operands[0], E_HImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
                return 1517; /* vsx_extract_v8hi_p9 */
              if (nonimmediate_operand (operands[0], E_HImode)
                  && scratch_operand (operands[3], E_V8HImode)
                  && 
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
                return 1527; /* *vsx_extract_v8hi_p8 */
            }
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1529; /* *vsx_extract_v8hi_load */

        default:
          return -1;
        }

    case PLUS:
      if (pattern449 (x1) != 0
          || !
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1641; /* *vsx_reduc_plus_v2df_scalar */

    case SMIN:
      if (pattern449 (x1) != 0
          || !
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1642; /* *vsx_reduc_smin_v2df_scalar */

    case SMAX:
      if (pattern449 (x1) != 0
          || !
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1643; /* *vsx_reduc_smax_v2df_scalar */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()))
        return -1;
      return 402; /* floatsisf2_lfiwax */

    case 1:
      if (memory_operand (operands[1], E_DImode)
          && scratch_operand (operands[2], E_DImode)
          && 
#line 7048 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
        return 503; /* *floatdisf2_mem */
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[2], E_DFmode)
          || !
#line 7068 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS))
        return -1;
      return 504; /* floatdisf2_internal1 */

    case 2:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()))
        return -1;
      return 403; /* floatsidf2_lfiwax */

    case 3:
      if (!
#line 6975 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
        return -1;
      return 499; /* *floatdidf2_mem */

    case 4:
      if (!(
#line 15328 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1161; /* float_kfsi2_hw */

    case 5:
      if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1163; /* floatqikf2 */

    case 6:
      if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1164; /* floathikf2 */

    case 7:
      if (!(
#line 15328 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1162; /* float_tfsi2_hw */

    case 8:
      if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1165; /* floatqitf2 */

    case 9:
      if (!(
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1166; /* floathitf2 */

    case 10:
      if (!
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS))
        return -1;
      return 404; /* floatsisf2_lfiwax_mem */

    case 11:
      if (!
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID))
        return -1;
      return 405; /* floatsidf2_lfiwax_mem */

    case 12:
      if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 406; /* floatsisf2_lfiwax_qi_mem_zext */

    case 13:
      if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 407; /* floatsisf2_lfiwax_hi_mem_zext */

    case 14:
      if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 408; /* floatsidf2_lfiwax_qi_mem_zext */

    case 15:
      if (!
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 409; /* floatsidf2_lfiwax_hi_mem_zext */

    case 16:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && 
#line 4437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return 1569; /* *vsx_extract_si_float_df */
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1588; /* *vsx_ext_SI_fl_df */

    case 17:
      if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1580; /* *vsx_ext_QI_fl_df */

    case 18:
      if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1584; /* *vsx_ext_HI_fl_df */

    case 19:
      if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1579; /* *vsx_ext_QI_fl_sf */

    case 20:
      if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1583; /* *vsx_ext_HI_fl_sf */

    case 21:
      if (!
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1587; /* *vsx_ext_SI_fl_sf */

    case 22:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1581; /* *vsx_ext_QI_fl_kf */

    case 23:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1585; /* *vsx_ext_HI_fl_kf */

    case 24:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1589; /* *vsx_ext_SI_fl_kf */

    case 25:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1582; /* *vsx_ext_QI_fl_tf */

    case 26:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1586; /* *vsx_ext_HI_fl_tf */

    case 27:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1590; /* *vsx_ext_SI_fl_tf */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern80 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          switch (pattern477 (
E_DImode))
            {
            case 0:
              if (
#line 6326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 425; /* fix_truncsfsi2_stfiwx */
              break;

            case 1:
              if (
#line 6326 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 426; /* fix_truncdfsi2_stfiwx */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      switch (pattern478 ())
        {
        case 0:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 447; /* *fix_truncsfsi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 453; /* *fix_truncdfsi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1151; /* *fix_trunckfsi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1157; /* *fix_trunctfsi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 431; /* fix_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 435; /* fix_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 443; /* *fix_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 449; /* *fix_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1147; /* *fix_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1153; /* *fix_trunctfqi2_mem */

        default:
          return -1;
        }

    case 2:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 433; /* fix_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 437; /* fix_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 445; /* *fix_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 451; /* *fix_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1149; /* *fix_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1155; /* *fix_trunctfhi2_mem */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 96)
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1005; /* *save_gpregs_si_r11 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1022; /* *restore_gpregs_si_r11 */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1011; /* *save_fpregs_si_r11 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1006; /* *save_gpregs_di_r11 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1023; /* *restore_gpregs_di_r11 */

            case 3:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1012; /* *save_fpregs_di_r11 */

            default:
              return -1;
            }

        case 12:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1007; /* *save_gpregs_si_r12 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1024; /* *restore_gpregs_si_r12 */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1013; /* *save_fpregs_si_r12 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1008; /* *save_gpregs_di_r12 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1025; /* *restore_gpregs_di_r12 */

            case 3:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1014; /* *save_fpregs_di_r12 */

            default:
              return -1;
            }

        case 1:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1009; /* *save_gpregs_si_r1 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1026; /* *restore_gpregs_si_r1 */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1015; /* *save_fpregs_si_r1 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1010; /* *save_gpregs_di_r1 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1027; /* *restore_gpregs_di_r1 */

            case 3:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1016; /* *save_fpregs_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (pattern556 (x4))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1040; /* *return_and_restore_fpregs_aix_si_r11 */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1041; /* *return_and_restore_fpregs_aix_di_r11 */

            default:
              return -1;
            }

        case 1:
          switch (pattern556 (x4))
            {
            case 0:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1042; /* *return_and_restore_fpregs_aix_si_r1 */

            case 1:
              if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1043; /* *return_and_restore_fpregs_aix_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!(
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()) && 
#line 5882 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_173 (insn, operands);

    case 1:
      if (memory_operand (operands[1], E_DImode)
          && scratch_operand (operands[2], E_DImode)
          && (
#line 7048 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS) && 
#line 7050 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_227 (insn, operands);
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[2], E_DFmode)
          || !(
#line 7068 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS) && 
#line 7070 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_228 (insn, operands);

    case 2:
      if (!(
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()) && 
#line 5882 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_174 (insn, operands);

    case 3:
      if (!(
#line 6975 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID) && 
#line 6977 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_225 (insn, operands);

    case 4:
      if (!((
#line 15328 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15330 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_519 (insn, operands);

    case 5:
      if (!((
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15349 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_521 (insn, operands);

    case 6:
      if (!((
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15349 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_522 (insn, operands);

    case 7:
      if (!((
#line 15328 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15330 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_520 (insn, operands);

    case 8:
      if (!((
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15349 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_523 (insn, operands);

    case 9:
      if (!((
#line 15347 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15349 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_524 (insn, operands);

    case 10:
      if (!(
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS) && 
#line 5922 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_175 (insn, operands);

    case 11:
      if (!(
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID) && 
#line 5922 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_176 (insn, operands);

    case 12:
      if (!(
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_177 (insn, operands);

    case 13:
      if (!(
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_178 (insn, operands);

    case 14:
      if (!(
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_179 (insn, operands);

    case 15:
      if (!(
#line 5944 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_180 (insn, operands);

    case 16:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && (
#line 4437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_639 (insn, operands);
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_658 (insn, operands);

    case 17:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_650 (insn, operands);

    case 18:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_654 (insn, operands);

    case 19:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_649 (insn, operands);

    case 20:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_653 (insn, operands);

    case 21:
      if (!(
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_657 (insn, operands);

    case 22:
      if (!((
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_651 (insn, operands);

    case 23:
      if (!((
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_655 (insn, operands);

    case 24:
      if (!((
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_659 (insn, operands);

    case 25:
      if (!((
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_652 (insn, operands);

    case 26:
      if (!((
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_656 (insn, operands);

    case 27:
      if (!((
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_660 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case FLOAT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern305 (x1))
        {
        case 0:
          if (!(
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_187 (insn, operands);

        case 1:
          if (!(
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 2:
          if (!(
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 3:
          if (!(
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_190 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_406 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_426 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_416 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_436 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 0);
      operands[3] = x10;
      x11 = XEXP (x3, 0);
      operands[4] = x11;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      switch (pattern529 (x5))
        {
        case 0:
          if ((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_407 (insn, operands);
          break;

        case 1:
          if (((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_427 (insn, operands);
          break;

        case 2:
          if (reg_or_short_operand (operands[2], E_SImode)
              && scratch_operand (operands[3], E_DImode)
              && scratch_operand (operands[4], E_DImode)
              && scratch_operand (operands[5], E_CCmode)
              && ((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_417 (insn, operands);
          if (scc_eq_operand (operands[2], E_SImode)
              && scratch_operand (operands[3], E_SImode)
              && scratch_operand (operands[4], E_SImode)
              && scratch_operand (operands[5], E_DImode)
              && ((
#line 13248 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13250 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_463 (insn, operands);
          break;

        case 3:
          if (((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_437 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x12) != REG)
        return NULL;
      switch (pattern531 (x1))
        {
        case 0:
          if (!((
#line 12993 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 12995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_448 (insn, operands);

        case 1:
          if (!((
#line 12993 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 12995 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_449 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_408 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_428 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_418 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_438 (insn, operands);

        default:
          return NULL;
        }

    case LTU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern114 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_409 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_429 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_419 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_439 (insn, operands);

        default:
          return NULL;
        }

    case GT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_410 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_430 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_420 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_440 (insn, operands);

        default:
          return NULL;
        }

    case GTU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern114 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_411 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_431 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_421 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_441 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_412 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_432 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_422 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_442 (insn, operands);

        default:
          return NULL;
        }

    case LEU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern114 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_413 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_433 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_423 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_443 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_414 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_434 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_424 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_444 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern114 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_415 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_435 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_425 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_445 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern308 (x1))
        {
        case 0:
          if (!((
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 13028 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_450 (insn, operands);

        case 1:
          if (!((
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 13028 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_451 (insn, operands);

        case 2:
          if (!((
#line 13058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 13060 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_452 (insn, operands);

        case 3:
          if (!((
#line 13058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 13060 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_453 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern311 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_454 (insn, operands);

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_455 (insn, operands);

        case 2:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_456 (insn, operands);

        case 3:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_457 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern314 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_458 (insn, operands);

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_459 (insn, operands);

        case 2:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_460 (insn, operands);

        case 3:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_461 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x8 = XEXP (x5, 0);
      if (!comparison_operator (x8, E_VOIDmode))
        return NULL;
      operands[2] = x8;
      x13 = XEXP (x8, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern415 (x1) != 0)
        return NULL;
      x14 = XEXP (x8, 0);
      operands[1] = x14;
      x9 = XEXP (x5, 1);
      operands[5] = x9;
      x15 = XEXP (x5, 2);
      operands[6] = x15;
      x6 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x6, 0);
      operands[0] = x10;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_CCmode))
        return NULL;
      x12 = XEXP (x4, 0);
      operands[4] = x12;
      x16 = XEXP (x6, 1);
      x17 = XEXP (x16, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern593 (x16, 
E_SImode) != 0
              || !(
#line 13768 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return NULL;
          return gen_split_486 (insn, operands);

        case E_DImode:
          if (pattern593 (x16, 
E_DImode) != 0
              || !(
#line 13768 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_487 (insn, operands);

        default:
          return NULL;
        }

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return NULL;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return NULL;
      x18 = XVECEXP (x9, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern482 (x1))
        {
        case 0:
          if (!(
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_686 (insn, operands);

        case 1:
          if (!(
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_687 (insn, operands);

        case 2:
          if (!(
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_688 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
