/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 14;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 15;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 16;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 17;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 18;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 19;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 20;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 21;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 22;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 23;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 24;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 25;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 26;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 27;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 28;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 29;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 30;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 31;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 32;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 33;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 34;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 35;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 36;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 37;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 38;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 39;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 40;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 41;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 42;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 43;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 44;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 45;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 46;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern192 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern192 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern192 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern192 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern192 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern192 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern192 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern192 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern192 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern192 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern192 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern192 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern192 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern192 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern192 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern192 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern192 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern192 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern192 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern192 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern192 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern192 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern192 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern192 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern192 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern192 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern192 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern192 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern192 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern192 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern192 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern192 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern192 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern192 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern192 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern192 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern192 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern192 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern192 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern192 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern192 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern192 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern192 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern192 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern192 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern192 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern192 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern192 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern192 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern192 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern192 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern192 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern192 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern192 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern192 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern192 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern192 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern192 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern192 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern192 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern192 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern192 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern192 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern192 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern192 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern192 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern192 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern192 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern192 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern192 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern192 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern192 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern192 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern192 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern192 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern192 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern192 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern192 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern192 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern192 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern192 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern192 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern192 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern192 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern192 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern192 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern192 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern192 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern192 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern192 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern192 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern192 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern192 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern192 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern192 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern192 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern192 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern192 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern192 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern192 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern192 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern192 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern192 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern192 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern192 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern192 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern192 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern192 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern192 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern192 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern192 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern192 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern192 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern192 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern192 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern192 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern192 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern192 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern192 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern192 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern192 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern192 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern168 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern168 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern168 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern168 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern168 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern168 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern168 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern168 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern168 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern168 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern168 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern168 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern168 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern168 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern168 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern168 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern168 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern168 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern168 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern168 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern168 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern168 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern168 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern168 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern168 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern168 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern168 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern168 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern168 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern168 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern168 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern168 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern168 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern168 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern168 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern168 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern168 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern168 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern168 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern168 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern168 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern168 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern168 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern168 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern168 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern168 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern168 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern168 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_all_trues_mask_operand (operands[3], i2)
      || !vector_const_0_operand (operands[5], i1)
      || !vector_merge_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vector_all_trues_mask_operand (operands[4], i1)
      || !vector_const_0_operand (operands[9], i2)
      || !vector_merge_operand (operands[10], i2)
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x1, 2);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          return pattern248 (x2, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
            return -1;
          return 5;

        case E_V1HImode:
          if (pattern248 (x2, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
            return -1;
          return 6;

        case E_V2HImode:
          if (pattern248 (x2, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
            return -1;
          return 7;

        case E_V4HImode:
          if (pattern248 (x2, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
            return -1;
          return 8;

        case E_V8HImode:
          if (pattern248 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V16HImode:
          if (pattern248 (x2, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
            return -1;
          return 10;

        case E_V32HImode:
          if (pattern248 (x2, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
            return -1;
          return 11;

        case E_V64HImode:
          if (pattern248 (x2, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
            return -1;
          return 12;

        case E_V128HImode:
          if (pattern248 (x2, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
            return -1;
          return 13;

        case E_V256HImode:
          if (pattern248 (x2, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
            return -1;
          return 14;

        case E_V512HImode:
          if (pattern248 (x2, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
            return -1;
          return 15;

        case E_V1024HImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
            return -1;
          return 16;

        case E_V2048HImode:
          if (pattern248 (x2, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 22;

        case E_V1SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V1BImode
              || GET_MODE (x3) != E_V1SImode
              || GET_MODE (x4) != E_V1SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V1SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V1BImode
              || !vector_all_trues_mask_operand (operands[4], E_V1BImode)
              || !vector_const_0_operand (operands[9], E_V1SImode)
              || !vector_merge_operand (operands[10], E_V1SImode)
              || !register_operand (operands[1], E_V1BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V1SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V1BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V1HImode:
              if (!register_operand (operands[3], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[3], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V2BImode
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V2SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V2BImode
              || !vector_all_trues_mask_operand (operands[4], E_V2BImode)
              || !vector_const_0_operand (operands[9], E_V2SImode)
              || !vector_merge_operand (operands[10], E_V2SImode)
              || !register_operand (operands[1], E_V2BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V2SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2HImode:
              if (!register_operand (operands[3], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V4BImode
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V4BImode
              || !vector_all_trues_mask_operand (operands[4], E_V4BImode)
              || !vector_const_0_operand (operands[9], E_V4SImode)
              || !vector_merge_operand (operands[10], E_V4SImode)
              || !register_operand (operands[1], E_V4BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V8BImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V8SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V8BImode
              || !vector_all_trues_mask_operand (operands[4], E_V8BImode)
              || !vector_const_0_operand (operands[9], E_V8SImode)
              || !vector_merge_operand (operands[10], E_V8SImode)
              || !register_operand (operands[1], E_V8BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V8SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[3], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V16BImode
              || GET_MODE (x3) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V16SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V16BImode
              || !vector_all_trues_mask_operand (operands[4], E_V16BImode)
              || !vector_const_0_operand (operands[9], E_V16SImode)
              || !vector_merge_operand (operands[10], E_V16SImode)
              || !register_operand (operands[1], E_V16BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V16SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V16BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V16HImode:
              if (!register_operand (operands[3], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[3], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V32BImode
              || GET_MODE (x3) != E_V32SImode
              || GET_MODE (x4) != E_V32SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V32SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V32BImode
              || !vector_all_trues_mask_operand (operands[4], E_V32BImode)
              || !vector_const_0_operand (operands[9], E_V32SImode)
              || !vector_merge_operand (operands[10], E_V32SImode)
              || !register_operand (operands[1], E_V32BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V32SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V32BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V32HImode:
              if (!register_operand (operands[3], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[3], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V64BImode
              || GET_MODE (x3) != E_V64SImode
              || GET_MODE (x4) != E_V64SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V64SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V64BImode
              || !vector_all_trues_mask_operand (operands[4], E_V64BImode)
              || !vector_const_0_operand (operands[9], E_V64SImode)
              || !vector_merge_operand (operands[10], E_V64SImode)
              || !register_operand (operands[1], E_V64BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V64SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V64BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V64HImode:
              if (!register_operand (operands[3], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[3], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V128BImode
              || GET_MODE (x3) != E_V128SImode
              || GET_MODE (x4) != E_V128SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V128SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V128BImode
              || !vector_all_trues_mask_operand (operands[4], E_V128BImode)
              || !vector_const_0_operand (operands[9], E_V128SImode)
              || !vector_merge_operand (operands[10], E_V128SImode)
              || !register_operand (operands[1], E_V128BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V128SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V128BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V128HImode:
              if (!register_operand (operands[3], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[3], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V256BImode
              || GET_MODE (x3) != E_V256SImode
              || GET_MODE (x4) != E_V256SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V256SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V256BImode
              || !vector_all_trues_mask_operand (operands[4], E_V256BImode)
              || !vector_const_0_operand (operands[9], E_V256SImode)
              || !vector_merge_operand (operands[10], E_V256SImode)
              || !register_operand (operands[1], E_V256BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V256SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V256BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V256HImode:
              if (!register_operand (operands[3], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[3], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V512BImode
              || GET_MODE (x3) != E_V512SImode
              || GET_MODE (x4) != E_V512SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V512SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V512BImode
              || !vector_all_trues_mask_operand (operands[4], E_V512BImode)
              || !vector_const_0_operand (operands[9], E_V512SImode)
              || !vector_merge_operand (operands[10], E_V512SImode)
              || !register_operand (operands[1], E_V512BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V512SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V512BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V512HImode:
              if (!register_operand (operands[3], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[3], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1SImode)
      || GET_MODE (x1) != E_RVVM1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 0;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 0;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern339 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !fp_native_comparison (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[2], E_HFmode)
          || !register_operand (operands[3], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XEXP (x8, 0);
  return pattern341 (x13); /* [-1, 3] */
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern350 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern350 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern362 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern362 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern362 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern362 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern362 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern362 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern362 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != AND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != NOT
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x11 = XEXP (x7, 1);
  operands[2] = x11;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x9, 0);
  operands[3] = x12;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i2
      || XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_two_s12 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != AND
      || GET_MODE (x9) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x10 = XEXP (x9, 1);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x14 = XEXP (x9, 0);
  return pattern378 (x14); /* [-1, 1] */
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return 0;
}

int
pattern397 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  return pattern227 (x2); /* [-1, 1] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern414 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 4;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 7;

    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      return 8;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 9;

    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      return 10;

    case E_V128DImode:
      if (!register_operand (operands[1], E_V128DImode))
        return -1;
      return 11;

    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 12;

    case E_V512DImode:
      if (!register_operand (operands[1], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern464 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern475 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern475 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern475 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern475 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern475 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern475 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern475 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern475 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern475 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern475 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern475 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern475 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern475 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern475 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern504 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern504 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern504 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern504 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern504 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern504 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern504 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern504 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern504 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern504 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern504 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern504 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern504 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern504 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern504 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern504 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern504 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern504 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern578 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern593 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_neg_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern480 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern480 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern480 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern480 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern480 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!register_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[4], E_RVVM4HFmode)
          || !register_operand (operands[5], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM8SFmode:
      if (!register_operand (operands[4], E_RVVM8SFmode)
          || !register_operand (operands[5], E_RVVM8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[4], E_RVVM1HFmode)
          || !register_operand (operands[5], E_RVVM1HFmode))
        return -1;
      return 0;

    case E_RVVM2SFmode:
      if (!register_operand (operands[4], E_RVVM2SFmode)
          || !register_operand (operands[5], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM4DFmode:
      if (!register_operand (operands[4], E_RVVM4DFmode)
          || !register_operand (operands[5], E_RVVM4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[4], E_V1HFmode)
          || !register_operand (operands[5], E_V1HFmode))
        return -1;
      return 0;

    case E_V1SFmode:
      if (!register_operand (operands[4], E_V1SFmode)
          || !register_operand (operands[5], E_V1SFmode))
        return -1;
      return 1;

    case E_V1DFmode:
      if (!register_operand (operands[4], E_V1DFmode)
          || !register_operand (operands[5], E_V1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || !register_operand (operands[5], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || !register_operand (operands[5], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || !register_operand (operands[5], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || !register_operand (operands[5], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || !register_operand (operands[5], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || !register_operand (operands[5], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1024BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1024BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[4], E_V1024HFmode)
          || !register_operand (operands[5], E_V1024HFmode))
        return -1;
      return 0;

    case E_V1024SFmode:
      if (!register_operand (operands[4], E_V1024SFmode)
          || !register_operand (operands[5], E_V1024SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern628 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != SET)
        return -1;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != i1)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x21 = XEXP (x16, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 8
          || GET_MODE (x21) != i1)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != RETURN)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 1;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern674 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern681 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern690 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i4
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern698 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], E_DImode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern702 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern702 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern702 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern702 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern702 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern702 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVM8SImode
          || GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM8SImode
          || GET_MODE (x4) != E_RVVM8SImode
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode)
              || !register_operand (operands[4], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 7;

            case E_RVVM8QImode:
              if (!register_operand (operands[4], E_RVVM8QImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVM4SImode
          || GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM4SImode
          || GET_MODE (x4) != E_RVVM4SImode
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode)
              || !register_operand (operands[4], E_RVVM2HImode))
            return -1;
          return 9;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 10;

            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVM2SImode
          || GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM2SImode
          || GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode)
              || !register_operand (operands[4], E_RVVM1HImode))
            return -1;
          return 12;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 13;

            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVM1SImode
          || GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM1SImode
          || GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode)
              || !register_operand (operands[4], E_RVVMF2HImode))
            return -1;
          return 15;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVMF2QImode:
              if (!register_operand (operands[4], E_RVVMF2QImode))
                return -1;
              return 16;

            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern702 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVM8DImode:
      if (pattern702 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 19;

    case E_RVVM4DImode:
      if (pattern702 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 20;

    case E_RVVM2DImode:
      if (pattern702 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1DImode:
      if (pattern702 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_V1HImode:
      if (pattern702 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 23;

    case E_V2HImode:
      if (pattern702 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 24;

    case E_V4HImode:
      if (pattern702 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 25;

    case E_V8HImode:
      if (pattern702 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 26;

    case E_V16HImode:
      if (pattern702 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 27;

    case E_V32HImode:
      if (pattern702 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 28;

    case E_V64HImode:
      if (pattern702 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 29;

    case E_V128HImode:
      if (pattern702 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 30;

    case E_V256HImode:
      if (pattern702 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 31;

    case E_V512HImode:
      if (pattern702 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 32;

    case E_V1024HImode:
      if (pattern702 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 33;

    case E_V2048HImode:
      if (pattern702 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 34;

    case E_V1SImode:
      if (pattern702 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2SImode:
      if (pattern702 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4SImode:
      if (pattern702 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8SImode:
      if (pattern702 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16SImode:
      if (pattern702 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32SImode:
      if (pattern702 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64SImode:
      if (pattern702 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128SImode:
      if (pattern702 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256SImode:
      if (pattern702 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512SImode:
      if (pattern702 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024SImode:
      if (pattern702 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V1DImode:
      if (pattern702 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 46;

    case E_V2DImode:
      if (pattern702 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 47;

    case E_V4DImode:
      if (pattern702 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 48;

    case E_V8DImode:
      if (pattern702 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 49;

    case E_V16DImode:
      if (pattern702 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 50;

    case E_V32DImode:
      if (pattern702 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 51;

    case E_V64DImode:
      if (pattern702 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 52;

    case E_V128DImode:
      if (pattern702 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 53;

    case E_V256DImode:
      if (pattern702 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 54;

    case E_V512DImode:
      if (pattern702 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 55;

    default:
      return -1;
    }
}

int
pattern741 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern744 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  return 0;
}

int
pattern749 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x27, 1);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  return 0;
}

int
pattern756 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -24L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -28L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -48L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -56L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern764 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23)
        return -1;
      return 0;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21)
        return -1;
      return 1;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9
          || REGNO (x32) != 8
          || REGNO (x37) != 1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x42) != 10)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 10
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x46) != RETURN)
        return -1;
      x47 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x47) != USE)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 1
          || GET_MODE (x48) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x52, 1);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern794 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -44])
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  x63 = XEXP (x61, 1);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XVECEXP (x1, 0, 13);
  x67 = XEXP (x66, 0);
  if (GET_MODE (x67) != i1)
    return -1;
  x68 = XEXP (x66, 1);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x68, 0);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  x71 = XVECEXP (x1, 0, 14);
  x72 = XEXP (x71, 0);
  if (GET_MODE (x72) != i1)
    return -1;
  x73 = XVECEXP (x1, 0, 15);
  x74 = XEXP (x73, 0);
  if (GET_MODE (x74) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 869 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 9; /* *addsi3_extended2 */

    case MINUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 18; /* *subsi3_extended2 */

    case NEG:
      operands[2] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1102 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 22; /* *negsi2_extended2 */

    case MULT:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 29; /* *mulsi3_extended2 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 1967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_XTHEADMEMIDX))
            return -1;
          return 127; /* *extendsidi2_internal */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 130; /* *extendqidi2 */
          if (!(
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 544; /* *extendqidi2_bitmanip */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 133; /* *extendhidi2 */
          if (!(
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 547; /* *extendhidi2_bitmanip */

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 128; /* *extendqihi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 542; /* *extendqihi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 131; /* *extendhihi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 545; /* *extendhihi2_bitmanip */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 129; /* *extendqisi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 543; /* *extendqisi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 132; /* *extendhisi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 546; /* *extendhisi2_bitmanip */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 65 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 874; /* *extendhihi2_th_ext */
          if (!
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return -1;
          return 929; /* *th_memidx_extendhihi2 */

        case 1:
          if (
#line 76 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 877; /* *extendqihi2_th_ext */
          if (
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 926; /* *th_memidx_extendqihi2 */
          if (!
#line 628 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 937; /* *th_memidx_bb_extendqihi2 */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 65 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 875; /* *extendhisi2_th_ext */
          if (
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 930; /* *th_memidx_extendhisi2 */
          if (!
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 935; /* *th_memidx_bb_extendhisi2 */

        case 1:
          if (
#line 76 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 878; /* *extendqisi2_th_ext */
          if (
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 927; /* *th_memidx_extendqisi2 */
          if (!
#line 628 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 938; /* *th_memidx_bb_extendqisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 65 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 876; /* *extendhidi2_th_ext */
          if ((
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 931; /* *th_memidx_extendhidi2 */
          if (!(
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 936; /* *th_memidx_bb_extendhidi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 76 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 879; /* *extendqidi2_th_ext */
          if ((
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 928; /* *th_memidx_extendqidi2 */
          if (!(
#line 628 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 939; /* *th_memidx_bb_extendqidi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 482 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX))
            return -1;
          return 922; /* *th_memidx_extendsidi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || pattern333 (x3) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28261; /* *pred_extract_first_sextdirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28262; /* *pred_extract_first_sextdirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28263; /* *pred_extract_first_sextdirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28264; /* *pred_extract_first_sextdirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28265; /* *pred_extract_first_sextdirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28266; /* *pred_extract_first_sextdirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28267; /* *pred_extract_first_sextdirvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 28279; /* *pred_extract_first_sextdiv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 28280; /* *pred_extract_first_sextdiv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 28281; /* *pred_extract_first_sextdiv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 28282; /* *pred_extract_first_sextdiv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 28283; /* *pred_extract_first_sextdiv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 28284; /* *pred_extract_first_sextdiv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28285; /* *pred_extract_first_sextdiv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28286; /* *pred_extract_first_sextdiv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28287; /* *pred_extract_first_sextdiv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28288; /* *pred_extract_first_sextdiv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28289; /* *pred_extract_first_sextdiv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28290; /* *pred_extract_first_sextdiv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28291; /* *pred_extract_first_sextdiv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28268; /* *pred_extract_first_sextdirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28269; /* *pred_extract_first_sextdirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28270; /* *pred_extract_first_sextdirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28271; /* *pred_extract_first_sextdirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28272; /* *pred_extract_first_sextdirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28273; /* *pred_extract_first_sextdirvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 28292; /* *pred_extract_first_sextdiv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 28293; /* *pred_extract_first_sextdiv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 28294; /* *pred_extract_first_sextdiv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 28295; /* *pred_extract_first_sextdiv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 28296; /* *pred_extract_first_sextdiv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28297; /* *pred_extract_first_sextdiv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28298; /* *pred_extract_first_sextdiv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28299; /* *pred_extract_first_sextdiv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28300; /* *pred_extract_first_sextdiv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28301; /* *pred_extract_first_sextdiv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28302; /* *pred_extract_first_sextdiv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28303; /* *pred_extract_first_sextdiv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8SImode:
              if (!register_operand (operands[1], E_RVVM8SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28274; /* *pred_extract_first_sextdirvvm8si */

            case E_RVVM4SImode:
              if (!register_operand (operands[1], E_RVVM4SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28275; /* *pred_extract_first_sextdirvvm4si */

            case E_RVVM2SImode:
              if (!register_operand (operands[1], E_RVVM2SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28276; /* *pred_extract_first_sextdirvvm2si */

            case E_RVVM1SImode:
              if (!register_operand (operands[1], E_RVVM1SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28277; /* *pred_extract_first_sextdirvvm1si */

            case E_RVVMF2SImode:
              if (!register_operand (operands[1], E_RVVMF2SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28278; /* *pred_extract_first_sextdirvvmf2si */

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 28304; /* *pred_extract_first_sextdiv1si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 28305; /* *pred_extract_first_sextdiv2si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 28306; /* *pred_extract_first_sextdiv4si */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 28307; /* *pred_extract_first_sextdiv8si */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28308; /* *pred_extract_first_sextdiv16si */

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28309; /* *pred_extract_first_sextdiv32si */

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28310; /* *pred_extract_first_sextdiv64si */

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28311; /* *pred_extract_first_sextdiv128si */

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28312; /* *pred_extract_first_sextdiv256si */

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28313; /* *pred_extract_first_sextdiv512si */

            case E_V1024SImode:
              if (!register_operand (operands[1], E_V1024SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28314; /* *pred_extract_first_sextdiv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28315; /* *pred_extract_first_sextsirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28316; /* *pred_extract_first_sextsirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28317; /* *pred_extract_first_sextsirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28318; /* *pred_extract_first_sextsirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28319; /* *pred_extract_first_sextsirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28320; /* *pred_extract_first_sextsirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 559 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28321; /* *pred_extract_first_sextsirvvmf8qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28322; /* *pred_extract_first_sextsirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28323; /* *pred_extract_first_sextsirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28324; /* *pred_extract_first_sextsirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28325; /* *pred_extract_first_sextsirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28326; /* *pred_extract_first_sextsirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 85 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28327; /* *pred_extract_first_sextsirvvmf4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern149 (x2))
    {
    case 0:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30149; /* *dual_widen_suburvvm8hi */

    case 1:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30155; /* *dual_widen_suburvvm4hi */

    case 2:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30161; /* *dual_widen_suburvvm2hi */

    case 3:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30167; /* *dual_widen_suburvvm1hi */

    case 4:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30173; /* *dual_widen_suburvvmf2hi */

    case 5:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30179; /* *dual_widen_suburvvmf4hi */

    case 6:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30185; /* *dual_widen_suburvvm8si */

    case 7:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30191; /* *dual_widen_suburvvm4si */

    case 8:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30197; /* *dual_widen_suburvvm2si */

    case 9:
      if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30203; /* *dual_widen_suburvvm1si */

    case 10:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30209; /* *dual_widen_suburvvmf2si */

    case 11:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30215; /* *dual_widen_suburvvm8di */

    case 12:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30221; /* *dual_widen_suburvvm4di */

    case 13:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30227; /* *dual_widen_suburvvm2di */

    case 14:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30233; /* *dual_widen_suburvvm1di */

    case 15:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30239; /* *dual_widen_subuv1hi */

    case 16:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30245; /* *dual_widen_subuv2hi */

    case 17:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30251; /* *dual_widen_subuv4hi */

    case 18:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30257; /* *dual_widen_subuv8hi */

    case 19:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30263; /* *dual_widen_subuv16hi */

    case 20:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30269; /* *dual_widen_subuv32hi */

    case 21:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30275; /* *dual_widen_subuv64hi */

    case 22:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30281; /* *dual_widen_subuv128hi */

    case 23:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30287; /* *dual_widen_subuv256hi */

    case 24:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30293; /* *dual_widen_subuv512hi */

    case 25:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30299; /* *dual_widen_subuv1024hi */

    case 26:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30305; /* *dual_widen_subuv2048hi */

    case 27:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30311; /* *dual_widen_subuv1si */

    case 28:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30317; /* *dual_widen_subuv2si */

    case 29:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30323; /* *dual_widen_subuv4si */

    case 30:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30329; /* *dual_widen_subuv8si */

    case 31:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30335; /* *dual_widen_subuv16si */

    case 32:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30341; /* *dual_widen_subuv32si */

    case 33:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30347; /* *dual_widen_subuv64si */

    case 34:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30353; /* *dual_widen_subuv128si */

    case 35:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30359; /* *dual_widen_subuv256si */

    case 36:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30365; /* *dual_widen_subuv512si */

    case 37:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30371; /* *dual_widen_subuv1024si */

    case 38:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30377; /* *dual_widen_subuv1di */

    case 39:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30383; /* *dual_widen_subuv2di */

    case 40:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30389; /* *dual_widen_subuv4di */

    case 41:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30395; /* *dual_widen_subuv8di */

    case 42:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30401; /* *dual_widen_subuv16di */

    case 43:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30407; /* *dual_widen_subuv32di */

    case 44:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30413; /* *dual_widen_subuv64di */

    case 45:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30419; /* *dual_widen_subuv128di */

    case 46:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30425; /* *dual_widen_subuv256di */

    case 47:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30431; /* *dual_widen_subuv512di */

    case 48:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30531; /* *single_widen_first_suburvvm8hi */

    case 49:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30533; /* *single_widen_first_suburvvm4hi */

    case 50:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30535; /* *single_widen_first_suburvvm2hi */

    case 51:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30537; /* *single_widen_first_suburvvm1hi */

    case 52:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30539; /* *single_widen_first_suburvvmf2hi */

    case 53:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30541; /* *single_widen_first_suburvvmf4hi */

    case 54:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30543; /* *single_widen_first_suburvvm8si */

    case 55:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30545; /* *single_widen_first_suburvvm4si */

    case 56:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30547; /* *single_widen_first_suburvvm2si */

    case 57:
      if (!
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30549; /* *single_widen_first_suburvvm1si */

    case 58:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30551; /* *single_widen_first_suburvvmf2si */

    case 59:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30553; /* *single_widen_first_suburvvm8di */

    case 60:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30555; /* *single_widen_first_suburvvm4di */

    case 61:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30557; /* *single_widen_first_suburvvm2di */

    case 62:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30559; /* *single_widen_first_suburvvm1di */

    case 63:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30561; /* *single_widen_first_subuv1hi */

    case 64:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30563; /* *single_widen_first_subuv2hi */

    case 65:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30565; /* *single_widen_first_subuv4hi */

    case 66:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30567; /* *single_widen_first_subuv8hi */

    case 67:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30569; /* *single_widen_first_subuv16hi */

    case 68:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30571; /* *single_widen_first_subuv32hi */

    case 69:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30573; /* *single_widen_first_subuv64hi */

    case 70:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30575; /* *single_widen_first_subuv128hi */

    case 71:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30577; /* *single_widen_first_subuv256hi */

    case 72:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30579; /* *single_widen_first_subuv512hi */

    case 73:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30581; /* *single_widen_first_subuv1024hi */

    case 74:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30583; /* *single_widen_first_subuv2048hi */

    case 75:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30585; /* *single_widen_first_subuv1si */

    case 76:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30587; /* *single_widen_first_subuv2si */

    case 77:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30589; /* *single_widen_first_subuv4si */

    case 78:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30591; /* *single_widen_first_subuv8si */

    case 79:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30593; /* *single_widen_first_subuv16si */

    case 80:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30595; /* *single_widen_first_subuv32si */

    case 81:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30597; /* *single_widen_first_subuv64si */

    case 82:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30599; /* *single_widen_first_subuv128si */

    case 83:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30601; /* *single_widen_first_subuv256si */

    case 84:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30603; /* *single_widen_first_subuv512si */

    case 85:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30605; /* *single_widen_first_subuv1024si */

    case 86:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30607; /* *single_widen_first_subuv1di */

    case 87:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30609; /* *single_widen_first_subuv2di */

    case 88:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30611; /* *single_widen_first_subuv4di */

    case 89:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30613; /* *single_widen_first_subuv8di */

    case 90:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30615; /* *single_widen_first_subuv16di */

    case 91:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30617; /* *single_widen_first_subuv32di */

    case 92:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30619; /* *single_widen_first_subuv64di */

    case 93:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30621; /* *single_widen_first_subuv128di */

    case 94:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30623; /* *single_widen_first_subuv256di */

    case 95:
      if (!(
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30625; /* *single_widen_first_subuv512di */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern163 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32389; /* *vwsll_zext1_trunc_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32449; /* *vwsll_zext1_trunc_scalar_rvvm8si */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32390; /* *vwsll_zext1_trunc_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32450; /* *vwsll_zext1_trunc_scalar_rvvm4si */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32391; /* *vwsll_zext1_trunc_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32451; /* *vwsll_zext1_trunc_scalar_rvvm2si */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32392; /* *vwsll_zext1_trunc_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32452; /* *vwsll_zext1_trunc_scalar_rvvm1si */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32393; /* *vwsll_zext1_trunc_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32453; /* *vwsll_zext1_trunc_scalar_rvvmf2si */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32394; /* *vwsll_zext1_trunc_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32454; /* *vwsll_zext1_trunc_scalar_rvvm8di */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32395; /* *vwsll_zext1_trunc_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32455; /* *vwsll_zext1_trunc_scalar_rvvm4di */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32396; /* *vwsll_zext1_trunc_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32456; /* *vwsll_zext1_trunc_scalar_rvvm2di */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32397; /* *vwsll_zext1_trunc_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32457; /* *vwsll_zext1_trunc_scalar_rvvm1di */

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32398; /* *vwsll_zext1_trunc_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32458; /* *vwsll_zext1_trunc_scalar_v1si */

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32399; /* *vwsll_zext1_trunc_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32459; /* *vwsll_zext1_trunc_scalar_v2si */

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32400; /* *vwsll_zext1_trunc_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32460; /* *vwsll_zext1_trunc_scalar_v4si */

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32401; /* *vwsll_zext1_trunc_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32461; /* *vwsll_zext1_trunc_scalar_v8si */

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32402; /* *vwsll_zext1_trunc_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32462; /* *vwsll_zext1_trunc_scalar_v16si */

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32403; /* *vwsll_zext1_trunc_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32463; /* *vwsll_zext1_trunc_scalar_v32si */

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32404; /* *vwsll_zext1_trunc_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32464; /* *vwsll_zext1_trunc_scalar_v64si */

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32405; /* *vwsll_zext1_trunc_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32465; /* *vwsll_zext1_trunc_scalar_v128si */

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32406; /* *vwsll_zext1_trunc_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32466; /* *vwsll_zext1_trunc_scalar_v256si */

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32407; /* *vwsll_zext1_trunc_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32467; /* *vwsll_zext1_trunc_scalar_v512si */

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32408; /* *vwsll_zext1_trunc_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32468; /* *vwsll_zext1_trunc_scalar_v1024si */

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32409; /* *vwsll_zext1_trunc_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32469; /* *vwsll_zext1_trunc_scalar_v1di */

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32410; /* *vwsll_zext1_trunc_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32470; /* *vwsll_zext1_trunc_scalar_v2di */

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32411; /* *vwsll_zext1_trunc_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32471; /* *vwsll_zext1_trunc_scalar_v4di */

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32412; /* *vwsll_zext1_trunc_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32472; /* *vwsll_zext1_trunc_scalar_v8di */

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32413; /* *vwsll_zext1_trunc_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32473; /* *vwsll_zext1_trunc_scalar_v16di */

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32414; /* *vwsll_zext1_trunc_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32474; /* *vwsll_zext1_trunc_scalar_v32di */

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32415; /* *vwsll_zext1_trunc_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32475; /* *vwsll_zext1_trunc_scalar_v64di */

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32416; /* *vwsll_zext1_trunc_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32476; /* *vwsll_zext1_trunc_scalar_v128di */

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32417; /* *vwsll_zext1_trunc_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32477; /* *vwsll_zext1_trunc_scalar_v256di */

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32418; /* *vwsll_zext1_trunc_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32478; /* *vwsll_zext1_trunc_scalar_v512di */

    case 30:
      if (!
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32419; /* *vwsll_zext2_trunc_rvvm8si */

    case 31:
      if (!
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32420; /* *vwsll_zext2_trunc_rvvm4si */

    case 32:
      if (!
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32421; /* *vwsll_zext2_trunc_rvvm2si */

    case 33:
      if (!
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32422; /* *vwsll_zext2_trunc_rvvm1si */

    case 34:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32423; /* *vwsll_zext2_trunc_rvvmf2si */

    case 35:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32424; /* *vwsll_zext2_trunc_rvvm8di */

    case 36:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32425; /* *vwsll_zext2_trunc_rvvm4di */

    case 37:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32426; /* *vwsll_zext2_trunc_rvvm2di */

    case 38:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32427; /* *vwsll_zext2_trunc_rvvm1di */

    case 39:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32428; /* *vwsll_zext2_trunc_v1si */

    case 40:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32429; /* *vwsll_zext2_trunc_v2si */

    case 41:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32430; /* *vwsll_zext2_trunc_v4si */

    case 42:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32431; /* *vwsll_zext2_trunc_v8si */

    case 43:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32432; /* *vwsll_zext2_trunc_v16si */

    case 44:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32433; /* *vwsll_zext2_trunc_v32si */

    case 45:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32434; /* *vwsll_zext2_trunc_v64si */

    case 46:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32435; /* *vwsll_zext2_trunc_v128si */

    case 47:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32436; /* *vwsll_zext2_trunc_v256si */

    case 48:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32437; /* *vwsll_zext2_trunc_v512si */

    case 49:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32438; /* *vwsll_zext2_trunc_v1024si */

    case 50:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32439; /* *vwsll_zext2_trunc_v1di */

    case 51:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32440; /* *vwsll_zext2_trunc_v2di */

    case 52:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32441; /* *vwsll_zext2_trunc_v4di */

    case 53:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32442; /* *vwsll_zext2_trunc_v8di */

    case 54:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32443; /* *vwsll_zext2_trunc_v16di */

    case 55:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32444; /* *vwsll_zext2_trunc_v32di */

    case 56:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32445; /* *vwsll_zext2_trunc_v64di */

    case 57:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32446; /* *vwsll_zext2_trunc_v128di */

    case 58:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32447; /* *vwsll_zext2_trunc_v256di */

    case 59:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32448; /* *vwsll_zext2_trunc_v512di */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern241 (x3))
    {
    case 0:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27891; /* copysignrvvm8hf3 */

    case 1:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27892; /* copysignrvvm4hf3 */

    case 2:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27893; /* copysignrvvm2hf3 */

    case 3:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27894; /* copysignrvvm1hf3 */

    case 4:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27895; /* copysignrvvmf2hf3 */

    case 5:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27896; /* copysignrvvmf4hf3 */

    case 6:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27897; /* copysignrvvm8sf3 */

    case 7:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27898; /* copysignrvvm4sf3 */

    case 8:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27899; /* copysignrvvm2sf3 */

    case 9:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27900; /* copysignrvvm1sf3 */

    case 10:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27901; /* copysignrvvmf2sf3 */

    case 11:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27902; /* copysignrvvm8df3 */

    case 12:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27903; /* copysignrvvm4df3 */

    case 13:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27904; /* copysignrvvm2df3 */

    case 14:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27905; /* copysignrvvm1df3 */

    case 15:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27906; /* copysignv1hf3 */

    case 16:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27907; /* copysignv2hf3 */

    case 17:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27908; /* copysignv4hf3 */

    case 18:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27909; /* copysignv8hf3 */

    case 19:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27910; /* copysignv16hf3 */

    case 20:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27911; /* copysignv32hf3 */

    case 21:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27912; /* copysignv64hf3 */

    case 22:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27913; /* copysignv128hf3 */

    case 23:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27914; /* copysignv256hf3 */

    case 24:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27915; /* copysignv512hf3 */

    case 25:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27916; /* copysignv1024hf3 */

    case 26:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27917; /* copysignv2048hf3 */

    case 27:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27918; /* copysignv1sf3 */

    case 28:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27919; /* copysignv2sf3 */

    case 29:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27920; /* copysignv4sf3 */

    case 30:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27921; /* copysignv8sf3 */

    case 31:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27922; /* copysignv16sf3 */

    case 32:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27923; /* copysignv32sf3 */

    case 33:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27924; /* copysignv64sf3 */

    case 34:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27925; /* copysignv128sf3 */

    case 35:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27926; /* copysignv256sf3 */

    case 36:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27927; /* copysignv512sf3 */

    case 37:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27928; /* copysignv1024sf3 */

    case 38:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27929; /* copysignv1df3 */

    case 39:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27930; /* copysignv2df3 */

    case 40:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27931; /* copysignv4df3 */

    case 41:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27932; /* copysignv8df3 */

    case 42:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27933; /* copysignv16df3 */

    case 43:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27934; /* copysignv32df3 */

    case 44:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27935; /* copysignv64df3 */

    case 45:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27936; /* copysignv128df3 */

    case 46:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27937; /* copysignv256df3 */

    case 47:
      if (!(
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27938; /* copysignv512df3 */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern167 (x1))
    {
    case 0:
      if (!(
#line 3563 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 394; /* fle_quietsfsi4_zfa */

    case 1:
      if (!(
#line 3563 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 398; /* fle_quietdfsi4_zfa */

    case 2:
      if (!(
#line 3563 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 402; /* fle_quiethfsi4_zfa */

    case 3:
      if (!(
#line 3563 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 396; /* fle_quietsfdi4_zfa */

    case 4:
      if (!(
#line 3563 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 400; /* fle_quietdfdi4_zfa */

    case 5:
      if (!(
#line 3563 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 404; /* fle_quiethfdi4_zfa */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !(
#line 2333 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 257; /* rintsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 2333 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 258; /* rintdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 2333 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 259; /* rinthf2 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF8QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8695; /* pred_madcrvvmf8qi_scalar */

    case E_RVVMF4HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8701; /* pred_madcrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8706; /* pred_madcrvvmf2si_scalar */

    case E_RVVM1DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 3567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8800; /* *pred_madcrvvm1di_scalar */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V512QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8716; /* pred_madcv512qi_scalar */

    case E_V512HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8729; /* pred_madcv512hi_scalar */

    case E_V512SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8741; /* pred_madcv512si_scalar */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18676; /* pred_redxor_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18684; /* pred_redxor_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18692; /* pred_redxor_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18700; /* pred_redxor_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18804; /* pred_redxor_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18812; /* pred_redxor_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18820; /* pred_redxor_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18852; /* pred_redxor_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18860; /* pred_redxor_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18868; /* pred_redxor_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18876; /* pred_redxor_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18884; /* pred_redxor_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18892; /* pred_redxor_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18900; /* pred_redxor_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18908; /* pred_redxor_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18916; /* pred_redxor_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18924; /* pred_redxor_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18932; /* pred_redxor_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18940; /* pred_redxor_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18948; /* pred_redxor_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18708; /* pred_redxor_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18716; /* pred_redxor_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18724; /* pred_redxor_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18732; /* pred_redxor_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18828; /* pred_redxor_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18836; /* pred_redxor_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18956; /* pred_redxor_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18964; /* pred_redxor_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18972; /* pred_redxor_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18980; /* pred_redxor_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18988; /* pred_redxor_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18996; /* pred_redxor_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19004; /* pred_redxor_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19012; /* pred_redxor_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19020; /* pred_redxor_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19028; /* pred_redxor_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19036; /* pred_redxor_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19044; /* pred_redxor_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18740; /* pred_redxor_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18748; /* pred_redxor_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18756; /* pred_redxor_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18764; /* pred_redxor_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18844; /* pred_redxor_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19052; /* pred_redxor_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19060; /* pred_redxor_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19068; /* pred_redxor_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19076; /* pred_redxor_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19084; /* pred_redxor_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19092; /* pred_redxor_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19100; /* pred_redxor_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19108; /* pred_redxor_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19116; /* pred_redxor_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19124; /* pred_redxor_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19132; /* pred_redxor_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18772; /* pred_redxor_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18780; /* pred_redxor_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18788; /* pred_redxor_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18796; /* pred_redxor_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19140; /* pred_redxor_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19148; /* pred_redxor_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19156; /* pred_redxor_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19164; /* pred_redxor_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19172; /* pred_redxor_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19180; /* pred_redxor_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19188; /* pred_redxor_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19196; /* pred_redxor_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19204; /* pred_redxor_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19212; /* pred_redxor_vl0sv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18672; /* pred_redminu_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18680; /* pred_redminu_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18688; /* pred_redminu_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18696; /* pred_redminu_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18800; /* pred_redminu_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18808; /* pred_redminu_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18816; /* pred_redminu_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18848; /* pred_redminu_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18856; /* pred_redminu_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18864; /* pred_redminu_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18872; /* pred_redminu_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18880; /* pred_redminu_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18888; /* pred_redminu_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18896; /* pred_redminu_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18904; /* pred_redminu_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18912; /* pred_redminu_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18920; /* pred_redminu_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18928; /* pred_redminu_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18936; /* pred_redminu_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18944; /* pred_redminu_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18704; /* pred_redminu_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18712; /* pred_redminu_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18720; /* pred_redminu_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18728; /* pred_redminu_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18824; /* pred_redminu_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18832; /* pred_redminu_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18952; /* pred_redminu_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18960; /* pred_redminu_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18968; /* pred_redminu_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18976; /* pred_redminu_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18984; /* pred_redminu_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18992; /* pred_redminu_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19000; /* pred_redminu_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19008; /* pred_redminu_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19016; /* pred_redminu_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19024; /* pred_redminu_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19032; /* pred_redminu_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19040; /* pred_redminu_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18736; /* pred_redminu_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18744; /* pred_redminu_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18752; /* pred_redminu_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18760; /* pred_redminu_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18840; /* pred_redminu_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19048; /* pred_redminu_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19056; /* pred_redminu_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19064; /* pred_redminu_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19072; /* pred_redminu_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19080; /* pred_redminu_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19088; /* pred_redminu_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19096; /* pred_redminu_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19104; /* pred_redminu_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19112; /* pred_redminu_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19120; /* pred_redminu_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19128; /* pred_redminu_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18768; /* pred_redminu_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18776; /* pred_redminu_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18784; /* pred_redminu_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18792; /* pred_redminu_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19136; /* pred_redminu_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19144; /* pred_redminu_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19152; /* pred_redminu_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19160; /* pred_redminu_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19168; /* pred_redminu_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19176; /* pred_redminu_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19184; /* pred_redminu_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19192; /* pred_redminu_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19200; /* pred_redminu_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19208; /* pred_redminu_vl0sv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18125; /* pred_redsumrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18133; /* pred_redsumrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18141; /* pred_redsumrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18149; /* pred_redsumrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18253; /* pred_redsumrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18261; /* pred_redsumrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18269; /* pred_redsumrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18301; /* pred_redsumv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18309; /* pred_redsumv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18317; /* pred_redsumv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18325; /* pred_redsumv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18333; /* pred_redsumv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18341; /* pred_redsumv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18349; /* pred_redsumv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18357; /* pred_redsumv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18365; /* pred_redsumv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18373; /* pred_redsumv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18381; /* pred_redsumv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18389; /* pred_redsumv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18397; /* pred_redsumv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18157; /* pred_redsumrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18165; /* pred_redsumrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18173; /* pred_redsumrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18181; /* pred_redsumrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18277; /* pred_redsumrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18285; /* pred_redsumrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18405; /* pred_redsumv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18413; /* pred_redsumv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18421; /* pred_redsumv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18429; /* pred_redsumv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18437; /* pred_redsumv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18445; /* pred_redsumv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18453; /* pred_redsumv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18461; /* pred_redsumv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18469; /* pred_redsumv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18477; /* pred_redsumv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18485; /* pred_redsumv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18493; /* pred_redsumv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18189; /* pred_redsumrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18197; /* pred_redsumrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18205; /* pred_redsumrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18213; /* pred_redsumrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18293; /* pred_redsumrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18501; /* pred_redsumv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18509; /* pred_redsumv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18517; /* pred_redsumv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18525; /* pred_redsumv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18533; /* pred_redsumv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18541; /* pred_redsumv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18549; /* pred_redsumv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18557; /* pred_redsumv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18565; /* pred_redsumv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18573; /* pred_redsumv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18581; /* pred_redsumv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18221; /* pred_redsumrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18229; /* pred_redsumrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18237; /* pred_redsumrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18245; /* pred_redsumrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18589; /* pred_redsumv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18597; /* pred_redsumv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18605; /* pred_redsumv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18613; /* pred_redsumv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18621; /* pred_redsumv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18629; /* pred_redsumv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18637; /* pred_redsumv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18645; /* pred_redsumv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18653; /* pred_redsumv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18661; /* pred_redsumv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 6:
      return recog_84 (x1, insn, pnum_clobbers);

    case 8:
      x8 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 66
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 67
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 69
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[5] = x12;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x3, 0, 3);
      operands[7] = x14;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x15 = XVECEXP (x3, 0, 4);
      operands[8] = x15;
      if (!const_int_operand (operands[8], E_VOIDmode))
        return -1;
      switch (XINT (x4, 1))
        {
        case 145:
          return recog_83 (x1, insn, pnum_clobbers);

        case 146:
          return recog_82 (x1, insn, pnum_clobbers);

        case 147:
          return recog_81 (x1, insn, pnum_clobbers);

        case 148:
          return recog_80 (x1, insn, pnum_clobbers);

        case 167:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19813; /* pred_wredosumrvvm8hf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19815; /* pred_wredosumrvvm4hf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19817; /* pred_wredosumrvvm2hf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19819; /* pred_wredosumrvvm1hf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19821; /* pred_wredosumrvvmf2hf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19823; /* pred_wredosumrvvmf4hf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19835; /* pred_wredosumv1hf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19837; /* pred_wredosumv2hf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19839; /* pred_wredosumv4hf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19841; /* pred_wredosumv8hf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19843; /* pred_wredosumv16hf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19845; /* pred_wredosumv32hf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19847; /* pred_wredosumv64hf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19849; /* pred_wredosumv128hf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19851; /* pred_wredosumv256hf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19853; /* pred_wredosumv512hf */

                case 16:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19855; /* pred_wredosumv1024hf */

                case 17:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19857; /* pred_wredosumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19825; /* pred_wredosumrvvm8sf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19827; /* pred_wredosumrvvm4sf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19829; /* pred_wredosumrvvm2sf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19831; /* pred_wredosumrvvm1sf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19833; /* pred_wredosumrvvmf2sf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19859; /* pred_wredosumv1sf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19861; /* pred_wredosumv2sf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19863; /* pred_wredosumv4sf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19865; /* pred_wredosumv8sf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19867; /* pred_wredosumv16sf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19869; /* pred_wredosumv32sf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19871; /* pred_wredosumv64sf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19873; /* pred_wredosumv128sf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19875; /* pred_wredosumv256sf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19877; /* pred_wredosumv512sf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19879; /* pred_wredosumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 168:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19814; /* pred_wredusumrvvm8hf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19816; /* pred_wredusumrvvm4hf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19818; /* pred_wredusumrvvm2hf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19820; /* pred_wredusumrvvm1hf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19822; /* pred_wredusumrvvmf2hf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19824; /* pred_wredusumrvvmf4hf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19836; /* pred_wredusumv1hf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19838; /* pred_wredusumv2hf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19840; /* pred_wredusumv4hf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19842; /* pred_wredusumv8hf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19844; /* pred_wredusumv16hf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19846; /* pred_wredusumv32hf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19848; /* pred_wredusumv64hf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19850; /* pred_wredusumv128hf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19852; /* pred_wredusumv256hf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19854; /* pred_wredusumv512hf */

                case 16:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19856; /* pred_wredusumv1024hf */

                case 17:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19858; /* pred_wredusumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19826; /* pred_wredusumrvvm8sf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19828; /* pred_wredusumrvvm4sf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19830; /* pred_wredusumrvvm2sf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19832; /* pred_wredusumrvvm1sf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19834; /* pred_wredusumrvvmf2sf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19860; /* pred_wredusumv1sf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19862; /* pred_wredusumv2sf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19864; /* pred_wredusumv4sf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19866; /* pred_wredusumv8sf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19868; /* pred_wredusumv16sf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19870; /* pred_wredusumv32sf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19872; /* pred_wredusumv64sf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19874; /* pred_wredusumv128sf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19876; /* pred_wredusumv256sf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19878; /* pred_wredusumv512sf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19880; /* pred_wredusumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 169:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19881; /* pred_wredosum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19883; /* pred_wredosum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19885; /* pred_wredosum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19887; /* pred_wredosum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19889; /* pred_wredosum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19891; /* pred_wredosum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19903; /* pred_wredosum_vl0sv1hf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19905; /* pred_wredosum_vl0sv2hf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19907; /* pred_wredosum_vl0sv4hf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19909; /* pred_wredosum_vl0sv8hf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19911; /* pred_wredosum_vl0sv16hf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19913; /* pred_wredosum_vl0sv32hf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19915; /* pred_wredosum_vl0sv64hf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19917; /* pred_wredosum_vl0sv128hf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19919; /* pred_wredosum_vl0sv256hf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19921; /* pred_wredosum_vl0sv512hf */

                case 16:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19923; /* pred_wredosum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19925; /* pred_wredosum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19893; /* pred_wredosum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19895; /* pred_wredosum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19897; /* pred_wredosum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19899; /* pred_wredosum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19901; /* pred_wredosum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19927; /* pred_wredosum_vl0sv1sf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19929; /* pred_wredosum_vl0sv2sf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19931; /* pred_wredosum_vl0sv4sf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19933; /* pred_wredosum_vl0sv8sf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19935; /* pred_wredosum_vl0sv16sf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19937; /* pred_wredosum_vl0sv32sf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19939; /* pred_wredosum_vl0sv64sf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19941; /* pred_wredosum_vl0sv128sf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19943; /* pred_wredosum_vl0sv256sf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19945; /* pred_wredosum_vl0sv512sf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19947; /* pred_wredosum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 170:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19882; /* pred_wredusum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19884; /* pred_wredusum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19886; /* pred_wredusum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19888; /* pred_wredusum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19890; /* pred_wredusum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19892; /* pred_wredusum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19904; /* pred_wredusum_vl0sv1hf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19906; /* pred_wredusum_vl0sv2hf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19908; /* pred_wredusum_vl0sv4hf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19910; /* pred_wredusum_vl0sv8hf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19912; /* pred_wredusum_vl0sv16hf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19914; /* pred_wredusum_vl0sv32hf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19916; /* pred_wredusum_vl0sv64hf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19918; /* pred_wredusum_vl0sv128hf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19920; /* pred_wredusum_vl0sv256hf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19922; /* pred_wredusum_vl0sv512hf */

                case 16:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19924; /* pred_wredusum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19926; /* pred_wredusum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19894; /* pred_wredusum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19896; /* pred_wredusum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19898; /* pred_wredusum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19900; /* pred_wredusum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19902; /* pred_wredusum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19928; /* pred_wredusum_vl0sv1sf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19930; /* pred_wredusum_vl0sv2sf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19932; /* pred_wredusum_vl0sv4sf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19934; /* pred_wredusum_vl0sv8sf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19936; /* pred_wredusum_vl0sv16sf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19938; /* pred_wredusum_vl0sv32sf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19940; /* pred_wredusum_vl0sv64sf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19942; /* pred_wredusum_vl0sv128sf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19944; /* pred_wredusum_vl0sv256sf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19946; /* pred_wredusum_vl0sv512sf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19948; /* pred_wredusum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20487; /* pred_slide1uprvvm8hf */

    case 1:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20489; /* pred_slide1uprvvm4hf */

    case 2:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20491; /* pred_slide1uprvvm2hf */

    case 3:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20493; /* pred_slide1uprvvm1hf */

    case 4:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20495; /* pred_slide1uprvvmf2hf */

    case 5:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20497; /* pred_slide1uprvvmf4hf */

    case 6:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20499; /* pred_slide1uprvvm8sf */

    case 7:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20501; /* pred_slide1uprvvm4sf */

    case 8:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20503; /* pred_slide1uprvvm2sf */

    case 9:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20505; /* pred_slide1uprvvm1sf */

    case 10:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20507; /* pred_slide1uprvvmf2sf */

    case 11:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20509; /* pred_slide1uprvvm8df */

    case 12:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20511; /* pred_slide1uprvvm4df */

    case 13:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20513; /* pred_slide1uprvvm2df */

    case 14:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20515; /* pred_slide1uprvvm1df */

    case 15:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 20517; /* pred_slide1upv1hf */

    case 16:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 20519; /* pred_slide1upv2hf */

    case 17:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 20521; /* pred_slide1upv4hf */

    case 18:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 20523; /* pred_slide1upv8hf */

    case 19:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 20525; /* pred_slide1upv16hf */

    case 20:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20527; /* pred_slide1upv32hf */

    case 21:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20529; /* pred_slide1upv64hf */

    case 22:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20531; /* pred_slide1upv128hf */

    case 23:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20533; /* pred_slide1upv256hf */

    case 24:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20535; /* pred_slide1upv512hf */

    case 25:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20537; /* pred_slide1upv1024hf */

    case 26:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20539; /* pred_slide1upv2048hf */

    case 27:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20541; /* pred_slide1upv1sf */

    case 28:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20543; /* pred_slide1upv2sf */

    case 29:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20545; /* pred_slide1upv4sf */

    case 30:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20547; /* pred_slide1upv8sf */

    case 31:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20549; /* pred_slide1upv16sf */

    case 32:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20551; /* pred_slide1upv32sf */

    case 33:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20553; /* pred_slide1upv64sf */

    case 34:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20555; /* pred_slide1upv128sf */

    case 35:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20557; /* pred_slide1upv256sf */

    case 36:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20559; /* pred_slide1upv512sf */

    case 37:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20561; /* pred_slide1upv1024sf */

    case 38:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20563; /* pred_slide1upv1df */

    case 39:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20565; /* pred_slide1upv2df */

    case 40:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20567; /* pred_slide1upv4df */

    case 41:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20569; /* pred_slide1upv8df */

    case 42:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20571; /* pred_slide1upv16df */

    case 43:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20573; /* pred_slide1upv32df */

    case 44:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20575; /* pred_slide1upv64df */

    case 45:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20577; /* pred_slide1upv128df */

    case 46:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20579; /* pred_slide1upv256df */

    case 47:
      if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20581; /* pred_slide1upv512df */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 186:
      switch (pattern183 (x1, 
186))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2325; /* pred_indexed_store_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2331; /* pred_indexed_store_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2349; /* pred_indexed_store_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2337; /* pred_indexed_store_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2355; /* pred_indexed_store_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2373; /* pred_indexed_store_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2343; /* pred_indexed_store_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2361; /* pred_indexed_store_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2379; /* pred_indexed_store_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2397; /* pred_indexed_store_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2367; /* pred_indexed_store_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2385; /* pred_indexed_store_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2403; /* pred_indexed_store_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2391; /* pred_indexed_store_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2409; /* pred_indexed_store_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2415; /* pred_indexed_store_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2421; /* pred_indexed_store_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2427; /* pred_indexed_store_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2433; /* pred_indexed_store_widthbrvvmf2si */

        default:
          return -1;
        }

    case 188:
      switch (pattern183 (x1, 
188))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2326; /* pred_indexed_store_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2332; /* pred_indexed_store_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2350; /* pred_indexed_store_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2338; /* pred_indexed_store_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2356; /* pred_indexed_store_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2374; /* pred_indexed_store_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2344; /* pred_indexed_store_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2362; /* pred_indexed_store_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2380; /* pred_indexed_store_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2398; /* pred_indexed_store_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2368; /* pred_indexed_store_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2386; /* pred_indexed_store_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2404; /* pred_indexed_store_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2392; /* pred_indexed_store_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2410; /* pred_indexed_store_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2416; /* pred_indexed_store_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2422; /* pred_indexed_store_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2428; /* pred_indexed_store_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2434; /* pred_indexed_store_widthhrvvmf2si */

        default:
          return -1;
        }

    case 190:
      switch (pattern183 (x1, 
190))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2327; /* pred_indexed_store_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2333; /* pred_indexed_store_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2351; /* pred_indexed_store_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2339; /* pred_indexed_store_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2357; /* pred_indexed_store_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2375; /* pred_indexed_store_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2345; /* pred_indexed_store_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2363; /* pred_indexed_store_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2381; /* pred_indexed_store_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2399; /* pred_indexed_store_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2369; /* pred_indexed_store_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2387; /* pred_indexed_store_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2405; /* pred_indexed_store_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2393; /* pred_indexed_store_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2411; /* pred_indexed_store_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2417; /* pred_indexed_store_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2423; /* pred_indexed_store_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2429; /* pred_indexed_store_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2435; /* pred_indexed_store_widthwrvvmf2si */

        default:
          return -1;
        }

    case 192:
      switch (pattern183 (x1, 
192))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2328; /* pred_indexed_ustore_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2334; /* pred_indexed_ustore_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2352; /* pred_indexed_ustore_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2340; /* pred_indexed_ustore_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2358; /* pred_indexed_ustore_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2376; /* pred_indexed_ustore_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2346; /* pred_indexed_ustore_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2364; /* pred_indexed_ustore_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2382; /* pred_indexed_ustore_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2400; /* pred_indexed_ustore_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2370; /* pred_indexed_ustore_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2388; /* pred_indexed_ustore_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2406; /* pred_indexed_ustore_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2394; /* pred_indexed_ustore_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2412; /* pred_indexed_ustore_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2418; /* pred_indexed_ustore_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2424; /* pred_indexed_ustore_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2430; /* pred_indexed_ustore_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2436; /* pred_indexed_ustore_widthbrvvmf2si */

        default:
          return -1;
        }

    case 193:
      switch (pattern183 (x1, 
193))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2329; /* pred_indexed_ustore_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2335; /* pred_indexed_ustore_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2353; /* pred_indexed_ustore_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2341; /* pred_indexed_ustore_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2359; /* pred_indexed_ustore_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2377; /* pred_indexed_ustore_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2347; /* pred_indexed_ustore_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2365; /* pred_indexed_ustore_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2383; /* pred_indexed_ustore_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2401; /* pred_indexed_ustore_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2371; /* pred_indexed_ustore_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2389; /* pred_indexed_ustore_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2407; /* pred_indexed_ustore_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2395; /* pred_indexed_ustore_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2413; /* pred_indexed_ustore_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2419; /* pred_indexed_ustore_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2425; /* pred_indexed_ustore_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2431; /* pred_indexed_ustore_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2437; /* pred_indexed_ustore_widthhrvvmf2si */

        default:
          return -1;
        }

    case 194:
      switch (pattern183 (x1, 
194))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2330; /* pred_indexed_ustore_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2336; /* pred_indexed_ustore_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2354; /* pred_indexed_ustore_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2342; /* pred_indexed_ustore_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2360; /* pred_indexed_ustore_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2378; /* pred_indexed_ustore_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2348; /* pred_indexed_ustore_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2366; /* pred_indexed_ustore_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2384; /* pred_indexed_ustore_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2402; /* pred_indexed_ustore_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2372; /* pred_indexed_ustore_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2390; /* pred_indexed_ustore_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2408; /* pred_indexed_ustore_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2396; /* pred_indexed_ustore_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2414; /* pred_indexed_ustore_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2420; /* pred_indexed_ustore_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2426; /* pred_indexed_ustore_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2432; /* pred_indexed_ustore_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2438; /* pred_indexed_ustore_widthwrvvmf2si */

        default:
          return -1;
        }

    case 91:
      if (pattern184 (x1, 
67) != 0
          || !const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 1743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3644; /* vsetvl_vtype_change_only */

    case 96:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 93)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 66
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 67
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SCRATCH)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[4] = x12;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      return recog_93 (x1, insn, pnum_clobbers);

    case 97:
      return recog_97 (x1, insn, pnum_clobbers);

    case 98:
      return recog_96 (x1, insn, pnum_clobbers);

    case 128:
      return recog_100 (x1, insn, pnum_clobbers);

    case 129:
      return recog_99 (x1, insn, pnum_clobbers);

    case 130:
      return recog_101 (x1, insn, pnum_clobbers);

    case 131:
      return recog_102 (x1, insn, pnum_clobbers);

    case 132:
      return recog_103 (x1, insn, pnum_clobbers);

    case 133:
      switch (pattern197 (x1))
        {
        case 0:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20488; /* pred_slide1downrvvm8hf */

        case 1:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20490; /* pred_slide1downrvvm4hf */

        case 2:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20492; /* pred_slide1downrvvm2hf */

        case 3:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20494; /* pred_slide1downrvvm1hf */

        case 4:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20496; /* pred_slide1downrvvmf2hf */

        case 5:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20498; /* pred_slide1downrvvmf4hf */

        case 6:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20500; /* pred_slide1downrvvm8sf */

        case 7:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20502; /* pred_slide1downrvvm4sf */

        case 8:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20504; /* pred_slide1downrvvm2sf */

        case 9:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20506; /* pred_slide1downrvvm1sf */

        case 10:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20508; /* pred_slide1downrvvmf2sf */

        case 11:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20510; /* pred_slide1downrvvm8df */

        case 12:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20512; /* pred_slide1downrvvm4df */

        case 13:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20514; /* pred_slide1downrvvm2df */

        case 14:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20516; /* pred_slide1downrvvm1df */

        case 15:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20518; /* pred_slide1downv1hf */

        case 16:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20520; /* pred_slide1downv2hf */

        case 17:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20522; /* pred_slide1downv4hf */

        case 18:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20524; /* pred_slide1downv8hf */

        case 19:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20526; /* pred_slide1downv16hf */

        case 20:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20528; /* pred_slide1downv32hf */

        case 21:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20530; /* pred_slide1downv64hf */

        case 22:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20532; /* pred_slide1downv128hf */

        case 23:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20534; /* pred_slide1downv256hf */

        case 24:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20536; /* pred_slide1downv512hf */

        case 25:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20538; /* pred_slide1downv1024hf */

        case 26:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20540; /* pred_slide1downv2048hf */

        case 27:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20542; /* pred_slide1downv1sf */

        case 28:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20544; /* pred_slide1downv2sf */

        case 29:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20546; /* pred_slide1downv4sf */

        case 30:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20548; /* pred_slide1downv8sf */

        case 31:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20550; /* pred_slide1downv16sf */

        case 32:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20552; /* pred_slide1downv32sf */

        case 33:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20554; /* pred_slide1downv64sf */

        case 34:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20556; /* pred_slide1downv128sf */

        case 35:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20558; /* pred_slide1downv256sf */

        case 36:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20560; /* pred_slide1downv512sf */

        case 37:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20562; /* pred_slide1downv1024sf */

        case 38:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20564; /* pred_slide1downv1df */

        case 39:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20566; /* pred_slide1downv2df */

        case 40:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20568; /* pred_slide1downv4df */

        case 41:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20570; /* pred_slide1downv8df */

        case 42:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20572; /* pred_slide1downv16df */

        case 43:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20574; /* pred_slide1downv32df */

        case 44:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20576; /* pred_slide1downv64df */

        case 45:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20578; /* pred_slide1downv128df */

        case 46:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20580; /* pred_slide1downv256df */

        case 47:
          if (!(
#line 8218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20582; /* pred_slide1downv512df */

        default:
          return -1;
        }

    case 95:
      return recog_98 (x1, insn, pnum_clobbers);

    case 374:
      if (pattern198 (x1) != 0
          || !
#line 2566 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34084; /* riscv_cv_simd_cplxmul_r_si */

    case 375:
      if (pattern198 (x1) != 0
          || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34085; /* riscv_cv_simd_cplxmul_i_si */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HFmode)
      && reg_or_mem_operand (operands[1], E_V1024HFmode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3294; /* *movv1024hfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3295; /* *movv1024hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HFmode)
      || !register_operand (operands[1], E_V1024HFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3392; /* *movv1024hf_vls */
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512DImode)
      && reg_or_mem_operand (operands[1], E_V512DImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3282; /* *movv512disi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3283; /* *movv512didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512DImode)
      || !register_operand (operands[1], E_V512DImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3381; /* *movv512di_vls */
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SImode)
      && reg_or_mem_operand (operands[1], E_V512SImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3270; /* *movv512sisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3271; /* *movv512sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SImode)
      || !register_operand (operands[1], E_V512SImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3370; /* *movv512si_vls */
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3258; /* *movv1024hisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3259; /* *movv1024hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3359; /* *movv1024hi_vls */
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv4096qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3247; /* *movv4096qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3348; /* *movv4096qi_vls */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv64qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3235; /* *movv64qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3342; /* *movv64qi_vls */
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF16BImode)
      && register_operand (operands[1], E_RVVMF16BImode)
      && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2814; /* *movrvvmf16bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF16BImode))
    return -1;
  if ((
#line 1354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2852; /* *movrvvmf16bisi_lra */
    }
  if (!(
#line 1354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2853; /* *movrvvmf16bidi_lra */
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2HFmode)
      && register_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 2797; /* *movrvvmf2hf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2HFmode))
    return -1;
  if ((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2833; /* *movrvvmf2hfsi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2844; /* *movrvvmf2hfdi_lra */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4QImode)
      && register_operand (operands[1], E_RVVMF4QImode)
      && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return 2791; /* *movrvvmf4qi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4QImode))
    return -1;
  if ((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2827; /* *movrvvmf4qisi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2838; /* *movrvvmf4qidi_lra */
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2BImode)
      && reg_or_mem_operand (operands[1], E_V2BImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2BImode)
       || register_operand (operands[1], V2BImode))) && 
#line 4341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
    return 3228; /* *movv2bi */
  if (!register_operand (operands[0], E_V2BImode)
      || !register_operand (operands[1], E_V2BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
    return -1;
  return 3495; /* *movv2bi_vls */
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DFmode)
      && reg_or_mem_operand (operands[1], E_V1DFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DFmode)
       || register_operand (operands[1], V1DFmode))) && 
#line 4334 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3222; /* *movv1df */
  if (!register_operand (operands[0], E_V1DFmode)
      || !register_operand (operands[1], E_V1DFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3405; /* *movv1df_vls */
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3216; /* *movv16hf */
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3386; /* *movv16hf_vls */
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DImode)
      && reg_or_mem_operand (operands[1], E_V8DImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))) && 
#line 4322 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 3210; /* *movv8di */
  if (!register_operand (operands[0], E_V8DImode)
      || !register_operand (operands[1], E_V8DImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3375; /* *movv8di_vls */
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4316 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 3204; /* *movv4si */
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 3363; /* *movv4si_vls */
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 3197; /* *movv1hi */
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 3349; /* *movv1hi_vls */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3190; /* *movrvvm4x2qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3191; /* *movrvvm4x2qi_di */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3176; /* *movrvvm4x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3177; /* *movrvvm4x2sf_di */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3162; /* *movrvvm4x2si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3163; /* *movrvvm4x2si_di */
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3150; /* *movrvvm1x6qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3151; /* *movrvvm1x6qi_di */
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3136; /* *movrvvm2x3sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3137; /* *movrvvm2x3sf_di */
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3122; /* *movrvvm1x3hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3123; /* *movrvvm1x3hf_di */
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3108; /* *movrvvm1x3bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3109; /* *movrvvm1x3bf_di */
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3088; /* *movrvvm1x4hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3089; /* *movrvvm1x4hi_di */
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3072; /* *movrvvmf2x3qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3073; /* *movrvvmf2x3qi_di */
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3056; /* *movrvvm1x5sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3057; /* *movrvvm1x5sf_di */
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3040; /* *movrvvmf2x4hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3041; /* *movrvvmf2x4hf_di */
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3024; /* *movrvvmf2x3bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3025; /* *movrvvmf2x3bf_di */
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3008; /* *movrvvm1x5si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3009; /* *movrvvm1x5si_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2994; /* *movrvvmf2x5hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2995; /* *movrvvmf2x5hi_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2978; /* *movrvvmf4x4qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2979; /* *movrvvmf4x4qi_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2962; /* *movrvvm1x3df_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2963; /* *movrvvm1x3df_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2946; /* *movrvvmf2x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2947; /* *movrvvmf2x2sf_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2930; /* *movrvvmf4x8bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2931; /* *movrvvmf4x8bf_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2914; /* *movrvvm1x7di_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2915; /* *movrvvm1x7di_di */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2898; /* *movrvvmf2x6si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2899; /* *movrvvmf2x6si_di */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern328 (x2))
    {
    case 0:
      return 297; /* *ashrsi3 */

    case 1:
      if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 300; /* ashrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25494; /* ashrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25698; /* vashrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25497; /* ashrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25701; /* vashrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25500; /* ashrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25704; /* vashrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25503; /* ashrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25707; /* vashrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25506; /* ashrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25710; /* vashrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25509; /* ashrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25713; /* vashrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25512; /* ashrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25716; /* vashrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25515; /* ashrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25719; /* vashrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25518; /* ashrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25722; /* vashrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25521; /* ashrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25725; /* vashrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25524; /* ashrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25728; /* vashrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25527; /* ashrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25731; /* vashrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25530; /* ashrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25734; /* vashrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25533; /* ashrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25737; /* vashrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25536; /* ashrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25740; /* vashrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25539; /* ashrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25743; /* vashrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25542; /* ashrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25746; /* vashrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25545; /* ashrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25749; /* vashrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25548; /* ashrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25752; /* vashrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25551; /* ashrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25755; /* vashrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25554; /* ashrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25758; /* vashrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25557; /* ashrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25761; /* vashrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 25560; /* ashrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25764; /* vashrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 25563; /* ashrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25767; /* vashrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 25566; /* ashrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25770; /* vashrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 25569; /* ashrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25773; /* vashrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 25572; /* ashrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25776; /* vashrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 25575; /* ashrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25779; /* vashrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 25578; /* ashrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25782; /* vashrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 25581; /* ashrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25785; /* vashrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 25584; /* ashrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25788; /* vashrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 25587; /* ashrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25791; /* vashrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 25590; /* ashrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25794; /* vashrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 25593; /* ashrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25797; /* vashrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 25596; /* ashrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25800; /* vashrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 25599; /* ashrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25803; /* vashrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 25602; /* ashrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25806; /* vashrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 25605; /* ashrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25809; /* vashrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 25608; /* ashrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25812; /* vashrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 25611; /* ashrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25815; /* vashrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 25614; /* ashrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25818; /* vashrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 25617; /* ashrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25821; /* vashrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 25620; /* ashrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25824; /* vashrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 25623; /* ashrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25827; /* vashrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 25626; /* ashrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25830; /* vashrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 25629; /* ashrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25833; /* vashrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 25632; /* ashrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25836; /* vashrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 25635; /* ashrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25839; /* vashrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 25638; /* ashrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25842; /* vashrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 25641; /* ashrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25845; /* vashrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 25644; /* ashrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25848; /* vashrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 25647; /* ashrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25851; /* vashrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 25650; /* ashrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25854; /* vashrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 25653; /* ashrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25857; /* vashrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 25656; /* ashrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25860; /* vashrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 25659; /* ashrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25863; /* vashrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 25662; /* ashrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25866; /* vashrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 25665; /* ashrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25869; /* vashrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 25668; /* ashrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25872; /* vashrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 25671; /* ashrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25875; /* vashrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 25674; /* ashrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25878; /* vashrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 25677; /* ashrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25881; /* vashrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 25680; /* ashrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25884; /* vashrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 25683; /* ashrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25887; /* vashrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 25686; /* ashrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25890; /* vashrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 25689; /* ashrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25893; /* vashrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 25692; /* ashrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25896; /* vashrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 25695; /* ashrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25899; /* vashrv512di3 */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33508; /* pred_crypto_vvsm4rvsrvvm8si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33568; /* pred_crypto_vvsm4rvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33628; /* pred_crypto_vvsm4rvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33676; /* pred_crypto_vvsm4rvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33712; /* pred_crypto_vvsm4rvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33736; /* pred_crypto_vvsm4rvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33520; /* pred_crypto_vvsm4rvsrvvm4si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33580; /* pred_crypto_vvsm4rvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33640; /* pred_crypto_vvsm4rvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33688; /* pred_crypto_vvsm4rvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33724; /* pred_crypto_vvsm4rvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33532; /* pred_crypto_vvsm4rvsrvvm2si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33592; /* pred_crypto_vvsm4rvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33652; /* pred_crypto_vvsm4rvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33700; /* pred_crypto_vvsm4rvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33544; /* pred_crypto_vvsm4rvsrvvm1si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33604; /* pred_crypto_vvsm4rvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33664; /* pred_crypto_vvsm4rvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33556; /* pred_crypto_vvsm4rvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33616; /* pred_crypto_vvsm4rvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33505; /* pred_crypto_vvaesdmvsrvvm8si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33565; /* pred_crypto_vvaesdmvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33625; /* pred_crypto_vvaesdmvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33673; /* pred_crypto_vvaesdmvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33709; /* pred_crypto_vvaesdmvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33733; /* pred_crypto_vvaesdmvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33517; /* pred_crypto_vvaesdmvsrvvm4si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33577; /* pred_crypto_vvaesdmvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33637; /* pred_crypto_vvaesdmvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33685; /* pred_crypto_vvaesdmvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33721; /* pred_crypto_vvaesdmvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33529; /* pred_crypto_vvaesdmvsrvvm2si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33589; /* pred_crypto_vvaesdmvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33649; /* pred_crypto_vvaesdmvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33697; /* pred_crypto_vvaesdmvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33541; /* pred_crypto_vvaesdmvsrvvm1si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33601; /* pred_crypto_vvaesdmvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33661; /* pred_crypto_vvaesdmvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33553; /* pred_crypto_vvaesdmvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33613; /* pred_crypto_vvaesdmvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x7;
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      return recog_397 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      x12 = XEXP (x7, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          return recog_398 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern684 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4033; /* *pred_mergervvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern684 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4034; /* *pred_mergervvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern684 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4035; /* *pred_mergervvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern684 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4036; /* *pred_mergervvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern684 (x2, 
E_V1DImode, 
E_V1BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4037; /* *pred_mergev1di_extended_scalar */

            case E_V2DImode:
              if (pattern684 (x2, 
E_V2DImode, 
E_V2BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4038; /* *pred_mergev2di_extended_scalar */

            case E_V4DImode:
              if (pattern684 (x2, 
E_V4DImode, 
E_V4BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4039; /* *pred_mergev4di_extended_scalar */

            case E_V8DImode:
              if (pattern684 (x2, 
E_V8DImode, 
E_V8BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 4040; /* *pred_mergev8di_extended_scalar */

            case E_V16DImode:
              if (pattern684 (x2, 
E_V16DImode, 
E_V16BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 4041; /* *pred_mergev16di_extended_scalar */

            case E_V32DImode:
              if (pattern684 (x2, 
E_V32DImode, 
E_V32BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 4042; /* *pred_mergev32di_extended_scalar */

            case E_V64DImode:
              if (pattern684 (x2, 
E_V64DImode, 
E_V64BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 4043; /* *pred_mergev64di_extended_scalar */

            case E_V128DImode:
              if (pattern684 (x2, 
E_V128DImode, 
E_V128BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 4044; /* *pred_mergev128di_extended_scalar */

            case E_V256DImode:
              if (pattern684 (x2, 
E_V256DImode, 
E_V256BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 4045; /* *pred_mergev256di_extended_scalar */

            case E_V512DImode:
              if (pattern684 (x2, 
E_V512DImode, 
E_V512BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 4046; /* *pred_mergev512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28608; /* *cond_len_extendrvvm4qirvvm8hi */

        case 1:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28610; /* *cond_len_extendrvvm2qirvvm4hi */

        case 2:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28612; /* *cond_len_extendrvvm1qirvvm2hi */

        case 3:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28614; /* *cond_len_extendrvvmf2qirvvm1hi */

        case 4:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28616; /* *cond_len_extendrvvmf4qirvvmf2hi */

        case 5:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 28618; /* *cond_len_extendrvvmf8qirvvmf4hi */

        case 6:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28620; /* *cond_len_extendrvvm4hirvvm8si */

        case 7:
          if (!
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28704; /* *cond_len_extendrvvm2qirvvm8si */

        case 8:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28622; /* *cond_len_extendrvvm2hirvvm4si */

        case 9:
          if (!
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28706; /* *cond_len_extendrvvm1qirvvm4si */

        case 10:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28624; /* *cond_len_extendrvvm1hirvvm2si */

        case 11:
          if (!
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28708; /* *cond_len_extendrvvmf2qirvvm2si */

        case 12:
          if (!
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28626; /* *cond_len_extendrvvmf2hirvvm1si */

        case 13:
          if (!
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28710; /* *cond_len_extendrvvmf4qirvvm1si */

        case 14:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 28628; /* *cond_len_extendrvvmf4hirvvmf2si */

        case 15:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 28712; /* *cond_len_extendrvvmf8qirvvmf2si */

        case 16:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28630; /* *cond_len_extendrvvm4sirvvm8di */

        case 17:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28714; /* *cond_len_extendrvvm2hirvvm8di */

        case 18:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28764; /* *cond_len_extendrvvm1qirvvm8di */

        case 19:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28632; /* *cond_len_extendrvvm2sirvvm4di */

        case 20:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28716; /* *cond_len_extendrvvm1hirvvm4di */

        case 21:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28766; /* *cond_len_extendrvvmf2qirvvm4di */

        case 22:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28634; /* *cond_len_extendrvvm1sirvvm2di */

        case 23:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28718; /* *cond_len_extendrvvmf2hirvvm2di */

        case 24:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28768; /* *cond_len_extendrvvmf4qirvvm2di */

        case 25:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28636; /* *cond_len_extendrvvmf2sirvvm1di */

        case 26:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28720; /* *cond_len_extendrvvmf4hirvvm1di */

        case 27:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28770; /* *cond_len_extendrvvmf8qirvvm1di */

        case 28:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 28638; /* *cond_len_extendv1qiv1hi */

        case 29:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 28640; /* *cond_len_extendv2qiv2hi */

        case 30:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 28642; /* *cond_len_extendv4qiv4hi */

        case 31:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 28644; /* *cond_len_extendv8qiv8hi */

        case 32:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 28646; /* *cond_len_extendv16qiv16hi */

        case 33:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28648; /* *cond_len_extendv32qiv32hi */

        case 34:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28650; /* *cond_len_extendv64qiv64hi */

        case 35:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28652; /* *cond_len_extendv128qiv128hi */

        case 36:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28654; /* *cond_len_extendv256qiv256hi */

        case 37:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28656; /* *cond_len_extendv512qiv512hi */

        case 38:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28658; /* *cond_len_extendv1024qiv1024hi */

        case 39:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28660; /* *cond_len_extendv2048qiv2048hi */

        case 40:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28662; /* *cond_len_extendv1hiv1si */

        case 41:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28722; /* *cond_len_extendv1qiv1si */

        case 42:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28664; /* *cond_len_extendv2hiv2si */

        case 43:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28724; /* *cond_len_extendv2qiv2si */

        case 44:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28666; /* *cond_len_extendv4hiv4si */

        case 45:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28726; /* *cond_len_extendv4qiv4si */

        case 46:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28668; /* *cond_len_extendv8hiv8si */

        case 47:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28728; /* *cond_len_extendv8qiv8si */

        case 48:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28670; /* *cond_len_extendv16hiv16si */

        case 49:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28730; /* *cond_len_extendv16qiv16si */

        case 50:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28672; /* *cond_len_extendv32hiv32si */

        case 51:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28732; /* *cond_len_extendv32qiv32si */

        case 52:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28674; /* *cond_len_extendv64hiv64si */

        case 53:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28734; /* *cond_len_extendv64qiv64si */

        case 54:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28676; /* *cond_len_extendv128hiv128si */

        case 55:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28736; /* *cond_len_extendv128qiv128si */

        case 56:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28678; /* *cond_len_extendv256hiv256si */

        case 57:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28738; /* *cond_len_extendv256qiv256si */

        case 58:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28680; /* *cond_len_extendv512hiv512si */

        case 59:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28740; /* *cond_len_extendv512qiv512si */

        case 60:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28682; /* *cond_len_extendv1024hiv1024si */

        case 61:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28742; /* *cond_len_extendv1024qiv1024si */

        case 62:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28684; /* *cond_len_extendv1siv1di */

        case 63:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28744; /* *cond_len_extendv1hiv1di */

        case 64:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28772; /* *cond_len_extendv1qiv1di */

        case 65:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28686; /* *cond_len_extendv2siv2di */

        case 66:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28746; /* *cond_len_extendv2hiv2di */

        case 67:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28774; /* *cond_len_extendv2qiv2di */

        case 68:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28688; /* *cond_len_extendv4siv4di */

        case 69:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28748; /* *cond_len_extendv4hiv4di */

        case 70:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28776; /* *cond_len_extendv4qiv4di */

        case 71:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28690; /* *cond_len_extendv8siv8di */

        case 72:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28750; /* *cond_len_extendv8hiv8di */

        case 73:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28778; /* *cond_len_extendv8qiv8di */

        case 74:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28692; /* *cond_len_extendv16siv16di */

        case 75:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28752; /* *cond_len_extendv16hiv16di */

        case 76:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28780; /* *cond_len_extendv16qiv16di */

        case 77:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28694; /* *cond_len_extendv32siv32di */

        case 78:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28754; /* *cond_len_extendv32hiv32di */

        case 79:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28782; /* *cond_len_extendv32qiv32di */

        case 80:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28696; /* *cond_len_extendv64siv64di */

        case 81:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28756; /* *cond_len_extendv64hiv64di */

        case 82:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28784; /* *cond_len_extendv64qiv64di */

        case 83:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28698; /* *cond_len_extendv128siv128di */

        case 84:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28758; /* *cond_len_extendv128hiv128di */

        case 85:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28786; /* *cond_len_extendv128qiv128di */

        case 86:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28700; /* *cond_len_extendv256siv256di */

        case 87:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28760; /* *cond_len_extendv256hiv256di */

        case 88:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28788; /* *cond_len_extendv256qiv256di */

        case 89:
          if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28702; /* *cond_len_extendv512siv512di */

        case 90:
          if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28762; /* *cond_len_extendv512hiv512di */

        case 91:
          if (!(
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28790; /* *cond_len_extendv512qiv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_399 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      operands[4] = x4;
      operands[5] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[6] = x8;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      x10 = XEXP (x6, 2);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern470 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28870; /* *cond_len_extendrvvm4hfrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28871; /* *cond_len_extendrvvm2hfrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28872; /* *cond_len_extendrvvm1hfrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28873; /* *cond_len_extendrvvmf2hfrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 28874; /* *cond_len_extendrvvmf4hfrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28875; /* *cond_len_extendrvvm4sfrvvm8df */

        case E_RVVM4DFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28876; /* *cond_len_extendrvvm2sfrvvm4df */

        case E_RVVM2DFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28877; /* *cond_len_extendrvvm1sfrvvm2df */

        case E_RVVM1DFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28878; /* *cond_len_extendrvvmf2sfrvvm1df */

        case E_V1SFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28879; /* *cond_len_extendv1hfv1sf */

        case E_V2SFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28880; /* *cond_len_extendv2hfv2sf */

        case E_V4SFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28881; /* *cond_len_extendv4hfv4sf */

        case E_V8SFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28882; /* *cond_len_extendv8hfv8sf */

        case E_V16SFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28883; /* *cond_len_extendv16hfv16sf */

        case E_V32SFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28884; /* *cond_len_extendv32hfv32sf */

        case E_V64SFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28885; /* *cond_len_extendv64hfv64sf */

        case E_V128SFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28886; /* *cond_len_extendv128hfv128sf */

        case E_V256SFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28887; /* *cond_len_extendv256hfv256sf */

        case E_V512SFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28888; /* *cond_len_extendv512hfv512sf */

        case E_V1024SFmode:
          if (pattern470 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28889; /* *cond_len_extendv1024hfv1024sf */

        case E_V1DFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28890; /* *cond_len_extendv1sfv1df */

        case E_V2DFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28891; /* *cond_len_extendv2sfv2df */

        case E_V4DFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28892; /* *cond_len_extendv4sfv4df */

        case E_V8DFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28893; /* *cond_len_extendv8sfv8df */

        case E_V16DFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28894; /* *cond_len_extendv16sfv16df */

        case E_V32DFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28895; /* *cond_len_extendv32sfv32df */

        case E_V64DFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28896; /* *cond_len_extendv64sfv64df */

        case E_V128DFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28897; /* *cond_len_extendv128sfv128df */

        case E_V256DFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28898; /* *cond_len_extendv256sfv256df */

        case E_V512DFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28899; /* *cond_len_extendv512sfv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 4293; /* *pred_broadcastv64hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4415; /* *pred_broadcastv64hi_imm */
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 4287; /* *pred_broadcastv1hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 4409; /* *pred_broadcastv1hi_imm */
}

 int
recog_487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 4280; /* *pred_broadcastv64qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4402; /* *pred_broadcastv64qi_imm */
}

 int
recog_494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVM1DFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4273; /* *pred_broadcastrvvm1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1DFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4395; /* *pred_broadcastrvvm1df_imm */
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM4SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4266; /* *pred_broadcastrvvm4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4388; /* *pred_broadcastrvvm4sf_imm */
}

 int
recog_508 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
      && vector_const_0_operand (operands[3], E_RVVM8HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4259; /* *pred_broadcastrvvm8hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4381; /* *pred_broadcastrvvm8hf_imm */
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 20701; /* pred_gatherv64df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20823; /* pred_gatherv64df_scalar */
}

 int
recog_519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20697; /* pred_gatherv4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20819; /* pred_gatherv4df_scalar */
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 20693; /* pred_gatherv512sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20815; /* pred_gatherv512sf_scalar */
}

 int
recog_528 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 20688; /* pred_gatherv16sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20810; /* pred_gatherv16sf_scalar */
}

 int
recog_533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return 20683; /* pred_gatherv2048hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20805; /* pred_gatherv2048hf_scalar */
}

 int
recog_538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return 20678; /* pred_gatherv64hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20800; /* pred_gatherv64hf_scalar */
}

 int
recog_544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20672; /* pred_gatherv1hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20794; /* pred_gatherv1hf_scalar */
}

 int
recog_549 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 20667; /* pred_gatherv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20789; /* pred_gatherv32di_scalar */
}

 int
recog_554 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 20662; /* pred_gatherv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20784; /* pred_gatherv1di_scalar */
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 20657; /* pred_gatherv64si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20779; /* pred_gatherv64si_scalar */
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 20653; /* pred_gatherv4si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 20775; /* pred_gatherv4si_scalar */
}

 int
recog_568 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 20648; /* pred_gatherv512hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20770; /* pred_gatherv512hi_scalar */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 20643; /* pred_gatherv16hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 20765; /* pred_gatherv16hi_scalar */
}

 int
recog_579 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 20637; /* pred_gatherv2048qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20759; /* pred_gatherv2048qi_scalar */
}

 int
recog_584 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 20632; /* pred_gatherv64qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20754; /* pred_gatherv64qi_scalar */
}

 int
recog_588 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 20628; /* pred_gatherv4qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 20750; /* pred_gatherv4qi_scalar */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM4DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20623; /* pred_gatherrvvm4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20745; /* pred_gatherrvvm4df_scalar */
}

 int
recog_598 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern558 (x2))
    {
    case 0:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8089; /* pred_mulhsurvvm8qi */

    case 1:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8092; /* pred_mulhsurvvm4qi */

    case 2:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8095; /* pred_mulhsurvvm2qi */

    case 3:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8098; /* pred_mulhsurvvm1qi */

    case 4:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8101; /* pred_mulhsurvvmf2qi */

    case 5:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8104; /* pred_mulhsurvvmf4qi */

    case 6:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8107; /* pred_mulhsurvvmf8qi */

    case 7:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8110; /* pred_mulhsurvvm8hi */

    case 8:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8113; /* pred_mulhsurvvm4hi */

    case 9:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8116; /* pred_mulhsurvvm2hi */

    case 10:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8119; /* pred_mulhsurvvm1hi */

    case 11:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8122; /* pred_mulhsurvvmf2hi */

    case 12:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8125; /* pred_mulhsurvvmf4hi */

    case 13:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8128; /* pred_mulhsurvvm8si */

    case 14:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8131; /* pred_mulhsurvvm4si */

    case 15:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8134; /* pred_mulhsurvvm2si */

    case 16:
      if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8137; /* pred_mulhsurvvm1si */

    case 17:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8140; /* pred_mulhsurvvmf2si */

    case 18:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8143; /* pred_mulhsurvvm8di */

    case 19:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8146; /* pred_mulhsurvvm4di */

    case 20:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8149; /* pred_mulhsurvvm2di */

    case 21:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8152; /* pred_mulhsurvvm1di */

    case 22:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8155; /* pred_mulhsuv1qi */

    case 23:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8158; /* pred_mulhsuv2qi */

    case 24:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8161; /* pred_mulhsuv4qi */

    case 25:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8164; /* pred_mulhsuv8qi */

    case 26:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 514 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8167; /* pred_mulhsuv16qi */

    case 27:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8170; /* pred_mulhsuv32qi */

    case 28:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 516 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8173; /* pred_mulhsuv64qi */

    case 29:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8176; /* pred_mulhsuv128qi */

    case 30:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8179; /* pred_mulhsuv256qi */

    case 31:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8182; /* pred_mulhsuv512qi */

    case 32:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8185; /* pred_mulhsuv1024qi */

    case 33:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8188; /* pred_mulhsuv2048qi */

    case 34:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8191; /* pred_mulhsuv4096qi */

    case 35:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8194; /* pred_mulhsuv1hi */

    case 36:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8197; /* pred_mulhsuv2hi */

    case 37:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8200; /* pred_mulhsuv4hi */

    case 38:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8203; /* pred_mulhsuv8hi */

    case 39:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8206; /* pred_mulhsuv16hi */

    case 40:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8209; /* pred_mulhsuv32hi */

    case 41:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8212; /* pred_mulhsuv64hi */

    case 42:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8215; /* pred_mulhsuv128hi */

    case 43:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8218; /* pred_mulhsuv256hi */

    case 44:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8221; /* pred_mulhsuv512hi */

    case 45:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8224; /* pred_mulhsuv1024hi */

    case 46:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 534 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8227; /* pred_mulhsuv2048hi */

    case 47:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 535 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8230; /* pred_mulhsuv1si */

    case 48:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8233; /* pred_mulhsuv2si */

    case 49:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 537 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8236; /* pred_mulhsuv4si */

    case 50:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8239; /* pred_mulhsuv8si */

    case 51:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8242; /* pred_mulhsuv16si */

    case 52:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8245; /* pred_mulhsuv32si */

    case 53:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 541 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8248; /* pred_mulhsuv64si */

    case 54:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 542 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8251; /* pred_mulhsuv128si */

    case 55:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8254; /* pred_mulhsuv256si */

    case 56:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8257; /* pred_mulhsuv512si */

    case 57:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8260; /* pred_mulhsuv1024si */

    case 58:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 8263; /* pred_mulhsuv1di */

    case 59:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 8266; /* pred_mulhsuv2di */

    case 60:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 8269; /* pred_mulhsuv4di */

    case 61:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8272; /* pred_mulhsuv8di */

    case 62:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8275; /* pred_mulhsuv16di */

    case 63:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8278; /* pred_mulhsuv32di */

    case 64:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8281; /* pred_mulhsuv64di */

    case 65:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8284; /* pred_mulhsuv128di */

    case 66:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8287; /* pred_mulhsuv256di */

    case 67:
      if (!(
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8290; /* pred_mulhsuv512di */

    case 68:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8293; /* pred_mulhsurvvm8qi_scalar */

    case 69:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8296; /* pred_mulhsurvvm4qi_scalar */

    case 70:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8299; /* pred_mulhsurvvm2qi_scalar */

    case 71:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8302; /* pred_mulhsurvvm1qi_scalar */

    case 72:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8305; /* pred_mulhsurvvmf2qi_scalar */

    case 73:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8308; /* pred_mulhsurvvmf4qi_scalar */

    case 74:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8311; /* pred_mulhsurvvmf8qi_scalar */

    case 75:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8314; /* pred_mulhsurvvm8hi_scalar */

    case 76:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8317; /* pred_mulhsurvvm4hi_scalar */

    case 77:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8320; /* pred_mulhsurvvm2hi_scalar */

    case 78:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8323; /* pred_mulhsurvvm1hi_scalar */

    case 79:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8326; /* pred_mulhsurvvmf2hi_scalar */

    case 80:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8329; /* pred_mulhsurvvmf4hi_scalar */

    case 81:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8332; /* pred_mulhsurvvm8si_scalar */

    case 82:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8335; /* pred_mulhsurvvm4si_scalar */

    case 83:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8338; /* pred_mulhsurvvm2si_scalar */

    case 84:
      if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8341; /* pred_mulhsurvvm1si_scalar */

    case 85:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8344; /* pred_mulhsurvvmf2si_scalar */

    case 86:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8347; /* pred_mulhsuv1qi_scalar */

    case 87:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8350; /* pred_mulhsuv2qi_scalar */

    case 88:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8353; /* pred_mulhsuv4qi_scalar */

    case 89:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8356; /* pred_mulhsuv8qi_scalar */

    case 90:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8359; /* pred_mulhsuv16qi_scalar */

    case 91:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8362; /* pred_mulhsuv32qi_scalar */

    case 92:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8365; /* pred_mulhsuv64qi_scalar */

    case 93:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8368; /* pred_mulhsuv128qi_scalar */

    case 94:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8371; /* pred_mulhsuv256qi_scalar */

    case 95:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8374; /* pred_mulhsuv512qi_scalar */

    case 96:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8377; /* pred_mulhsuv1024qi_scalar */

    case 97:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8380; /* pred_mulhsuv2048qi_scalar */

    case 98:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8383; /* pred_mulhsuv4096qi_scalar */

    case 99:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8386; /* pred_mulhsuv1hi_scalar */

    case 100:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8389; /* pred_mulhsuv2hi_scalar */

    case 101:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8392; /* pred_mulhsuv4hi_scalar */

    case 102:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8395; /* pred_mulhsuv8hi_scalar */

    case 103:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8398; /* pred_mulhsuv16hi_scalar */

    case 104:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8401; /* pred_mulhsuv32hi_scalar */

    case 105:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8404; /* pred_mulhsuv64hi_scalar */

    case 106:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8407; /* pred_mulhsuv128hi_scalar */

    case 107:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8410; /* pred_mulhsuv256hi_scalar */

    case 108:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8413; /* pred_mulhsuv512hi_scalar */

    case 109:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8416; /* pred_mulhsuv1024hi_scalar */

    case 110:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8419; /* pred_mulhsuv2048hi_scalar */

    case 111:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8422; /* pred_mulhsuv1si_scalar */

    case 112:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8425; /* pred_mulhsuv2si_scalar */

    case 113:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8428; /* pred_mulhsuv4si_scalar */

    case 114:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8431; /* pred_mulhsuv8si_scalar */

    case 115:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8434; /* pred_mulhsuv16si_scalar */

    case 116:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8437; /* pred_mulhsuv32si_scalar */

    case 117:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8440; /* pred_mulhsuv64si_scalar */

    case 118:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8443; /* pred_mulhsuv128si_scalar */

    case 119:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8446; /* pred_mulhsuv256si_scalar */

    case 120:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8449; /* pred_mulhsuv512si_scalar */

    case 121:
      if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8452; /* pred_mulhsuv1024si_scalar */

    case 122:
      if (!(
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8455; /* *pred_mulhsurvvm8di_scalar */

    case 123:
      if (!(
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8458; /* *pred_mulhsurvvm4di_scalar */

    case 124:
      if (!(
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8461; /* *pred_mulhsurvvm2di_scalar */

    case 125:
      if (!(
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8464; /* *pred_mulhsurvvm1di_scalar */

    case 126:
      if (!(
#line 3171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8467; /* *pred_mulhsurvvm8di_extended_scalar */

    case 127:
      if (!(
#line 3171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8470; /* *pred_mulhsurvvm4di_extended_scalar */

    case 128:
      if (!(
#line 3171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8473; /* *pred_mulhsurvvm2di_extended_scalar */

    case 129:
      if (!(
#line 3171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8476; /* *pred_mulhsurvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_605 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern604 (x2))
    {
    case 0:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32945; /* pred_vbrevrvvm8qi */

    case 1:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32948; /* pred_vbrevrvvm4qi */

    case 2:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32951; /* pred_vbrevrvvm2qi */

    case 3:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32954; /* pred_vbrevrvvm1qi */

    case 4:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32957; /* pred_vbrevrvvm8hi */

    case 5:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32960; /* pred_vbrevrvvm4hi */

    case 6:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32963; /* pred_vbrevrvvm2hi */

    case 7:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32966; /* pred_vbrevrvvm1hi */

    case 8:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32969; /* pred_vbrevrvvm8si */

    case 9:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32972; /* pred_vbrevrvvm4si */

    case 10:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32975; /* pred_vbrevrvvm2si */

    case 11:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32978; /* pred_vbrevrvvm1si */

    case 12:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32981; /* pred_vbrevrvvm8di */

    case 13:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32984; /* pred_vbrevrvvm4di */

    case 14:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32987; /* pred_vbrevrvvm2di */

    case 15:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32990; /* pred_vbrevrvvm1di */

    case 16:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32993; /* pred_vbrevrvvmf2qi */

    case 17:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32996; /* pred_vbrevrvvmf4qi */

    case 18:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32999; /* pred_vbrevrvvmf8qi */

    case 19:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33002; /* pred_vbrevrvvmf2hi */

    case 20:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33005; /* pred_vbrevrvvmf4hi */

    case 21:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33008; /* pred_vbrevrvvmf2si */

    case 22:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 33011; /* pred_vbrevv1qi */

    case 23:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 33014; /* pred_vbrevv2qi */

    case 24:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 33017; /* pred_vbrevv4qi */

    case 25:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 33020; /* pred_vbrevv8qi */

    case 26:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 33023; /* pred_vbrevv16qi */

    case 27:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 33026; /* pred_vbrevv32qi */

    case 28:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33029; /* pred_vbrevv64qi */

    case 29:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33032; /* pred_vbrevv128qi */

    case 30:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33035; /* pred_vbrevv256qi */

    case 31:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33038; /* pred_vbrevv512qi */

    case 32:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33041; /* pred_vbrevv1024qi */

    case 33:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33044; /* pred_vbrevv2048qi */

    case 34:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33047; /* pred_vbrevv4096qi */

    case 35:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 33050; /* pred_vbrevv1hi */

    case 36:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 33053; /* pred_vbrevv2hi */

    case 37:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 33056; /* pred_vbrevv4hi */

    case 38:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 33059; /* pred_vbrevv8hi */

    case 39:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 33062; /* pred_vbrevv16hi */

    case 40:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33065; /* pred_vbrevv32hi */

    case 41:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33068; /* pred_vbrevv64hi */

    case 42:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33071; /* pred_vbrevv128hi */

    case 43:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33074; /* pred_vbrevv256hi */

    case 44:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33077; /* pred_vbrevv512hi */

    case 45:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33080; /* pred_vbrevv1024hi */

    case 46:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33083; /* pred_vbrevv2048hi */

    case 47:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33086; /* pred_vbrevv1si */

    case 48:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33089; /* pred_vbrevv2si */

    case 49:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33092; /* pred_vbrevv4si */

    case 50:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33095; /* pred_vbrevv8si */

    case 51:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33098; /* pred_vbrevv16si */

    case 52:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33101; /* pred_vbrevv32si */

    case 53:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33104; /* pred_vbrevv64si */

    case 54:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33107; /* pred_vbrevv128si */

    case 55:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33110; /* pred_vbrevv256si */

    case 56:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33113; /* pred_vbrevv512si */

    case 57:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33116; /* pred_vbrevv1024si */

    case 58:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33119; /* pred_vbrevv1di */

    case 59:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33122; /* pred_vbrevv2di */

    case 60:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33125; /* pred_vbrevv4di */

    case 61:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33128; /* pred_vbrevv8di */

    case 62:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33131; /* pred_vbrevv16di */

    case 63:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33134; /* pred_vbrevv32di */

    case 64:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33137; /* pred_vbrevv64di */

    case 65:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33140; /* pred_vbrevv128di */

    case 66:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33143; /* pred_vbrevv256di */

    case 67:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33146; /* pred_vbrevv512di */

    default:
      return -1;
    }
}

 int
recog_624 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13096; /* *pred_mul_plusrvvm1di_undef */
}

 int
recog_628 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13100; /* *pred_mul_plusrvvmf2hi_undef */
}

 int
recog_631 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 13103; /* *pred_mul_plusv1qi_undef */
}

 int
recog_635 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 13107; /* *pred_mul_plusv16qi_undef */
}

 int
recog_639 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13111; /* *pred_mul_plusv256qi_undef */
}

 int
recog_644 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 13116; /* *pred_mul_plusv1hi_undef */
}

 int
recog_649 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13121; /* *pred_mul_plusv32hi_undef */
}

 int
recog_654 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13126; /* *pred_mul_plusv1024hi_undef */
}

 int
recog_659 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13131; /* *pred_mul_plusv8si_undef */
}

 int
recog_664 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13136; /* *pred_mul_plusv256si_undef */
}

 int
recog_670 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13142; /* *pred_mul_plusv8di_undef */
}

 int
recog_676 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13148; /* *pred_mul_plusv512di_undef */
}

 int
recog_682 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_671 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13211; /* *pred_maddv16di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13279; /* *pred_maccv16di */
}

 int
recog_688 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_665 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13205; /* *pred_maddv512si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13273; /* *pred_maccv512si */
}

 int
recog_695 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_658 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13198; /* *pred_maddv4si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13266; /* *pred_maccv4si */
}

 int
recog_702 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_651 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13191; /* *pred_maddv128hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13259; /* *pred_maccv128hi */
}

 int
recog_710 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_643 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4096QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4096QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13183; /* *pred_maddv4096qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13251; /* *pred_maccv4096qi */
}

 int
recog_717 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13352; /* *pred_maddv512di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13420; /* *pred_maccv512di_scalar */
}

 int
recog_721 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13348; /* *pred_maddv32di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13416; /* *pred_maccv32di_scalar */
}

 int
recog_728 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13341; /* *pred_maddv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13409; /* *pred_maccv512si_scalar */
}

 int
recog_735 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13334; /* *pred_maddv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13402; /* *pred_maccv4si_scalar */
}

 int
recog_742 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13327; /* *pred_maddv128hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13395; /* *pred_maccv128hi_scalar */
}

 int
recog_749 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XEXP (x8, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      operands[3] = x13;
      x14 = XEXP (x11, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          switch (pattern703 (x2))
            {
            case 0:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13818; /* pred_widen_mul_plusurvvm8hi */

            case 1:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13820; /* pred_widen_mul_plusurvvm4hi */

            case 2:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13822; /* pred_widen_mul_plusurvvm2hi */

            case 3:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13824; /* pred_widen_mul_plusurvvm1hi */

            case 4:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13826; /* pred_widen_mul_plusurvvmf2hi */

            case 5:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13828; /* pred_widen_mul_plusurvvmf4hi */

            case 6:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13830; /* pred_widen_mul_plusurvvm8si */

            case 7:
              if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32548; /* pred_matrix_mul_plusurvvm8si_qoq */

            case 8:
              if (!
#line 113 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32564; /* pred_matrix_mul_plusurvvm8si_dod */

            case 9:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13832; /* pred_widen_mul_plusurvvm4si */

            case 10:
              if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32550; /* pred_matrix_mul_plusurvvm4si_qoq */

            case 11:
              if (!
#line 113 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32566; /* pred_matrix_mul_plusurvvm4si_dod */

            case 12:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13834; /* pred_widen_mul_plusurvvm2si */

            case 13:
              if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32552; /* pred_matrix_mul_plusurvvm2si_qoq */

            case 14:
              if (!
#line 113 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32568; /* pred_matrix_mul_plusurvvm2si_dod */

            case 15:
              if (!
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13836; /* pred_widen_mul_plusurvvm1si */

            case 16:
              if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32554; /* pred_matrix_mul_plusurvvm1si_qoq */

            case 17:
              if (!
#line 113 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32570; /* pred_matrix_mul_plusurvvm1si_dod */

            case 18:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13838; /* pred_widen_mul_plusurvvmf2si */

            case 19:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13840; /* pred_widen_mul_plusurvvm8di */

            case 20:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13842; /* pred_widen_mul_plusurvvm4di */

            case 21:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13844; /* pred_widen_mul_plusurvvm2di */

            case 22:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13846; /* pred_widen_mul_plusurvvm1di */

            case 23:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 13848; /* pred_widen_mul_plusuv1hi */

            case 24:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 13850; /* pred_widen_mul_plusuv2hi */

            case 25:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 13852; /* pred_widen_mul_plusuv4hi */

            case 26:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 13854; /* pred_widen_mul_plusuv8hi */

            case 27:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 13856; /* pred_widen_mul_plusuv16hi */

            case 28:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13858; /* pred_widen_mul_plusuv32hi */

            case 29:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13860; /* pred_widen_mul_plusuv64hi */

            case 30:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13862; /* pred_widen_mul_plusuv128hi */

            case 31:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13864; /* pred_widen_mul_plusuv256hi */

            case 32:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13866; /* pred_widen_mul_plusuv512hi */

            case 33:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13868; /* pred_widen_mul_plusuv1024hi */

            case 34:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13870; /* pred_widen_mul_plusuv2048hi */

            case 35:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 13872; /* pred_widen_mul_plusuv1si */

            case 36:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 13874; /* pred_widen_mul_plusuv2si */

            case 37:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 13876; /* pred_widen_mul_plusuv4si */

            case 38:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 13878; /* pred_widen_mul_plusuv8si */

            case 39:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13880; /* pred_widen_mul_plusuv16si */

            case 40:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13882; /* pred_widen_mul_plusuv32si */

            case 41:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13884; /* pred_widen_mul_plusuv64si */

            case 42:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13886; /* pred_widen_mul_plusuv128si */

            case 43:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13888; /* pred_widen_mul_plusuv256si */

            case 44:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13890; /* pred_widen_mul_plusuv512si */

            case 45:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13892; /* pred_widen_mul_plusuv1024si */

            case 46:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13894; /* pred_widen_mul_plusuv1di */

            case 47:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13896; /* pred_widen_mul_plusuv2di */

            case 48:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13898; /* pred_widen_mul_plusuv4di */

            case 49:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13900; /* pred_widen_mul_plusuv8di */

            case 50:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13902; /* pred_widen_mul_plusuv16di */

            case 51:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13904; /* pred_widen_mul_plusuv32di */

            case 52:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13906; /* pred_widen_mul_plusuv64di */

            case 53:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13908; /* pred_widen_mul_plusuv128di */

            case 54:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13910; /* pred_widen_mul_plusuv256di */

            case 55:
              if (!(
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13912; /* pred_widen_mul_plusuv512di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[4] = x15;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SImode:
              if (pattern731 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM4QImode:
                  if (!register_operand (operands[4], E_RVVM4QImode)
                      || !
#line 89 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32559; /* pred_matrix_mul_plususrvvm8si_qoq */

                case E_RVVM8QImode:
                  if (!register_operand (operands[4], E_RVVM8QImode)
                      || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32575; /* pred_matrix_mul_plususrvvm8si_dod */

                default:
                  return -1;
                }

            case E_RVVM4SImode:
              if (pattern731 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM2QImode:
                  if (!register_operand (operands[4], E_RVVM2QImode)
                      || !
#line 89 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32560; /* pred_matrix_mul_plususrvvm4si_qoq */

                case E_RVVM4QImode:
                  if (!register_operand (operands[4], E_RVVM4QImode)
                      || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32576; /* pred_matrix_mul_plususrvvm4si_dod */

                default:
                  return -1;
                }

            case E_RVVM2SImode:
              if (pattern731 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM1QImode:
                  if (!register_operand (operands[4], E_RVVM1QImode)
                      || !
#line 89 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32561; /* pred_matrix_mul_plususrvvm2si_qoq */

                case E_RVVM2QImode:
                  if (!register_operand (operands[4], E_RVVM2QImode)
                      || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32577; /* pred_matrix_mul_plususrvvm2si_dod */

                default:
                  return -1;
                }

            case E_RVVM1SImode:
              if (pattern731 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVMF2QImode:
                  if (!register_operand (operands[4], E_RVVMF2QImode)
                      || !
#line 89 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32562; /* pred_matrix_mul_plususrvvm1si_qoq */

                case E_RVVM1QImode:
                  if (!register_operand (operands[4], E_RVVM1QImode)
                      || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32578; /* pred_matrix_mul_plususrvvm1si_dod */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x16 = XEXP (x13, 0);
      operands[3] = x16;
      x14 = XEXP (x11, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          switch (pattern705 (x2))
            {
            case 0:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13914; /* pred_widen_mul_plusurvvm8hi_scalar */

            case 1:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13916; /* pred_widen_mul_plusurvvm4hi_scalar */

            case 2:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13918; /* pred_widen_mul_plusurvvm2hi_scalar */

            case 3:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13920; /* pred_widen_mul_plusurvvm1hi_scalar */

            case 4:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13922; /* pred_widen_mul_plusurvvmf2hi_scalar */

            case 5:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13924; /* pred_widen_mul_plusurvvmf4hi_scalar */

            case 6:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13926; /* pred_widen_mul_plusurvvm8si_scalar */

            case 7:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13928; /* pred_widen_mul_plusurvvm4si_scalar */

            case 8:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13930; /* pred_widen_mul_plusurvvm2si_scalar */

            case 9:
              if (!
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13932; /* pred_widen_mul_plusurvvm1si_scalar */

            case 10:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13934; /* pred_widen_mul_plusurvvmf2si_scalar */

            case 11:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13936; /* pred_widen_mul_plusurvvm8di_scalar */

            case 12:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13938; /* pred_widen_mul_plusurvvm4di_scalar */

            case 13:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13940; /* pred_widen_mul_plusurvvm2di_scalar */

            case 14:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13942; /* pred_widen_mul_plusurvvm1di_scalar */

            case 15:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 13944; /* pred_widen_mul_plusuv1hi_scalar */

            case 16:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 13946; /* pred_widen_mul_plusuv2hi_scalar */

            case 17:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 13948; /* pred_widen_mul_plusuv4hi_scalar */

            case 18:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 13950; /* pred_widen_mul_plusuv8hi_scalar */

            case 19:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 13952; /* pred_widen_mul_plusuv16hi_scalar */

            case 20:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13954; /* pred_widen_mul_plusuv32hi_scalar */

            case 21:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13956; /* pred_widen_mul_plusuv64hi_scalar */

            case 22:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13958; /* pred_widen_mul_plusuv128hi_scalar */

            case 23:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13960; /* pred_widen_mul_plusuv256hi_scalar */

            case 24:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13962; /* pred_widen_mul_plusuv512hi_scalar */

            case 25:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13964; /* pred_widen_mul_plusuv1024hi_scalar */

            case 26:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13966; /* pred_widen_mul_plusuv2048hi_scalar */

            case 27:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 13968; /* pred_widen_mul_plusuv1si_scalar */

            case 28:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 13970; /* pred_widen_mul_plusuv2si_scalar */

            case 29:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 13972; /* pred_widen_mul_plusuv4si_scalar */

            case 30:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 13974; /* pred_widen_mul_plusuv8si_scalar */

            case 31:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13976; /* pred_widen_mul_plusuv16si_scalar */

            case 32:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13978; /* pred_widen_mul_plusuv32si_scalar */

            case 33:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13980; /* pred_widen_mul_plusuv64si_scalar */

            case 34:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13982; /* pred_widen_mul_plusuv128si_scalar */

            case 35:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13984; /* pred_widen_mul_plusuv256si_scalar */

            case 36:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13986; /* pred_widen_mul_plusuv512si_scalar */

            case 37:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13988; /* pred_widen_mul_plusuv1024si_scalar */

            case 38:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13990; /* pred_widen_mul_plusuv1di_scalar */

            case 39:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13992; /* pred_widen_mul_plusuv2di_scalar */

            case 40:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13994; /* pred_widen_mul_plusuv4di_scalar */

            case 41:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13996; /* pred_widen_mul_plusuv8di_scalar */

            case 42:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13998; /* pred_widen_mul_plusuv16di_scalar */

            case 43:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14000; /* pred_widen_mul_plusuv32di_scalar */

            case 44:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14002; /* pred_widen_mul_plusuv64di_scalar */

            case 45:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14004; /* pred_widen_mul_plusuv128di_scalar */

            case 46:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14006; /* pred_widen_mul_plusuv256di_scalar */

            case 47:
              if (!(
#line 5909 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14008; /* pred_widen_mul_plusuv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern705 (x2))
            {
            case 0:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14105; /* pred_widen_mul_plususrvvm8hi_scalar */

            case 1:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14106; /* pred_widen_mul_plususrvvm4hi_scalar */

            case 2:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14107; /* pred_widen_mul_plususrvvm2hi_scalar */

            case 3:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14108; /* pred_widen_mul_plususrvvm1hi_scalar */

            case 4:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14109; /* pred_widen_mul_plususrvvmf2hi_scalar */

            case 5:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 14110; /* pred_widen_mul_plususrvvmf4hi_scalar */

            case 6:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14111; /* pred_widen_mul_plususrvvm8si_scalar */

            case 7:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14112; /* pred_widen_mul_plususrvvm4si_scalar */

            case 8:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14113; /* pred_widen_mul_plususrvvm2si_scalar */

            case 9:
              if (!
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14114; /* pred_widen_mul_plususrvvm1si_scalar */

            case 10:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 14115; /* pred_widen_mul_plususrvvmf2si_scalar */

            case 11:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14116; /* pred_widen_mul_plususrvvm8di_scalar */

            case 12:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14117; /* pred_widen_mul_plususrvvm4di_scalar */

            case 13:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14118; /* pred_widen_mul_plususrvvm2di_scalar */

            case 14:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14119; /* pred_widen_mul_plususrvvm1di_scalar */

            case 15:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 14120; /* pred_widen_mul_plususv1hi_scalar */

            case 16:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 14121; /* pred_widen_mul_plususv2hi_scalar */

            case 17:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 14122; /* pred_widen_mul_plususv4hi_scalar */

            case 18:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 14123; /* pred_widen_mul_plususv8hi_scalar */

            case 19:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 14124; /* pred_widen_mul_plususv16hi_scalar */

            case 20:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14125; /* pred_widen_mul_plususv32hi_scalar */

            case 21:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14126; /* pred_widen_mul_plususv64hi_scalar */

            case 22:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14127; /* pred_widen_mul_plususv128hi_scalar */

            case 23:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14128; /* pred_widen_mul_plususv256hi_scalar */

            case 24:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14129; /* pred_widen_mul_plususv512hi_scalar */

            case 25:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14130; /* pred_widen_mul_plususv1024hi_scalar */

            case 26:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14131; /* pred_widen_mul_plususv2048hi_scalar */

            case 27:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 14132; /* pred_widen_mul_plususv1si_scalar */

            case 28:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 14133; /* pred_widen_mul_plususv2si_scalar */

            case 29:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 14134; /* pred_widen_mul_plususv4si_scalar */

            case 30:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 14135; /* pred_widen_mul_plususv8si_scalar */

            case 31:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14136; /* pred_widen_mul_plususv16si_scalar */

            case 32:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14137; /* pred_widen_mul_plususv32si_scalar */

            case 33:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14138; /* pred_widen_mul_plususv64si_scalar */

            case 34:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14139; /* pred_widen_mul_plususv128si_scalar */

            case 35:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14140; /* pred_widen_mul_plususv256si_scalar */

            case 36:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14141; /* pred_widen_mul_plususv512si_scalar */

            case 37:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14142; /* pred_widen_mul_plususv1024si_scalar */

            case 38:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14143; /* pred_widen_mul_plususv1di_scalar */

            case 39:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14144; /* pred_widen_mul_plususv2di_scalar */

            case 40:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14145; /* pred_widen_mul_plususv4di_scalar */

            case 41:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14146; /* pred_widen_mul_plususv8di_scalar */

            case 42:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14147; /* pred_widen_mul_plususv16di_scalar */

            case 43:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14148; /* pred_widen_mul_plususv32di_scalar */

            case 44:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14149; /* pred_widen_mul_plususv64di_scalar */

            case 45:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14150; /* pred_widen_mul_plususv128di_scalar */

            case 46:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14151; /* pred_widen_mul_plususv256di_scalar */

            case 47:
              if (!(
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14152; /* pred_widen_mul_plususv512di_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_777 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V1024HImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13494; /* *pred_minus_mulv1024hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1024HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1024HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13562; /* *pred_nmsubv1024hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13630; /* *pred_nmsacv1024hi */
}

 int
recog_783 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V16HImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13488; /* *pred_minus_mulv16hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13556; /* *pred_nmsubv16hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13624; /* *pred_nmsacv16hi */
}

 int
recog_789 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2048QImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13482; /* *pred_minus_mulv2048qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2048QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2048QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13550; /* *pred_nmsubv2048qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13618; /* *pred_nmsacv2048qi */
}

 int
recog_797 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V8QImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 13474; /* *pred_minus_mulv8qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V8QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 13542; /* *pred_nmsubv8qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 13610; /* *pred_nmsacv8qi */
}

 int
recog_805 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13719; /* *pred_nmsubv256di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13787; /* *pred_nmsacv256di_scalar */
}

 int
recog_811 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13713; /* *pred_nmsubv4di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13781; /* *pred_nmsacv4di_scalar */
}

 int
recog_819 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13705; /* *pred_nmsubv32si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13773; /* *pred_nmsacv32si_scalar */
}

 int
recog_827 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13697; /* *pred_nmsubv512hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13765; /* *pred_nmsacv512hi_scalar */
}

 int
recog_835 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  x12 = XEXP (x11, 0);
  switch (GET_CODE (x12))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (pattern501 (x2))
        {
        case 0:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7343; /* pred_subrvvm8qi_scalar */

        case 1:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7348; /* pred_subrvvm4qi_scalar */

        case 2:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7353; /* pred_subrvvm2qi_scalar */

        case 3:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7358; /* pred_subrvvm1qi_scalar */

        case 4:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7363; /* pred_subrvvmf2qi_scalar */

        case 5:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7368; /* pred_subrvvmf4qi_scalar */

        case 6:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 7373; /* pred_subrvvmf8qi_scalar */

        case 7:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7378; /* pred_subrvvm8hi_scalar */

        case 8:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7383; /* pred_subrvvm4hi_scalar */

        case 9:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7388; /* pred_subrvvm2hi_scalar */

        case 10:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7393; /* pred_subrvvm1hi_scalar */

        case 11:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7398; /* pred_subrvvmf2hi_scalar */

        case 12:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 7403; /* pred_subrvvmf4hi_scalar */

        case 13:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7408; /* pred_subrvvm8si_scalar */

        case 14:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7413; /* pred_subrvvm4si_scalar */

        case 15:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7418; /* pred_subrvvm2si_scalar */

        case 16:
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7423; /* pred_subrvvm1si_scalar */

        case 17:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 7428; /* pred_subrvvmf2si_scalar */

        case 18:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 7433; /* pred_subv1qi_scalar */

        case 19:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 7438; /* pred_subv2qi_scalar */

        case 20:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 7443; /* pred_subv4qi_scalar */

        case 21:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 7448; /* pred_subv8qi_scalar */

        case 22:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 7453; /* pred_subv16qi_scalar */

        case 23:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 7458; /* pred_subv32qi_scalar */

        case 24:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7463; /* pred_subv64qi_scalar */

        case 25:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7468; /* pred_subv128qi_scalar */

        case 26:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7473; /* pred_subv256qi_scalar */

        case 27:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7478; /* pred_subv512qi_scalar */

        case 28:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7483; /* pred_subv1024qi_scalar */

        case 29:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7488; /* pred_subv2048qi_scalar */

        case 30:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7493; /* pred_subv4096qi_scalar */

        case 31:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 7498; /* pred_subv1hi_scalar */

        case 32:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 7503; /* pred_subv2hi_scalar */

        case 33:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 7508; /* pred_subv4hi_scalar */

        case 34:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 7513; /* pred_subv8hi_scalar */

        case 35:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 7518; /* pred_subv16hi_scalar */

        case 36:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7523; /* pred_subv32hi_scalar */

        case 37:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7528; /* pred_subv64hi_scalar */

        case 38:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7533; /* pred_subv128hi_scalar */

        case 39:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7538; /* pred_subv256hi_scalar */

        case 40:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7543; /* pred_subv512hi_scalar */

        case 41:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7548; /* pred_subv1024hi_scalar */

        case 42:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7553; /* pred_subv2048hi_scalar */

        case 43:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 7558; /* pred_subv1si_scalar */

        case 44:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 7563; /* pred_subv2si_scalar */

        case 45:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 7568; /* pred_subv4si_scalar */

        case 46:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 7573; /* pred_subv8si_scalar */

        case 47:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7578; /* pred_subv16si_scalar */

        case 48:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7583; /* pred_subv32si_scalar */

        case 49:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7588; /* pred_subv64si_scalar */

        case 50:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7593; /* pred_subv128si_scalar */

        case 51:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7598; /* pred_subv256si_scalar */

        case 52:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7603; /* pred_subv512si_scalar */

        case 53:
          if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7608; /* pred_subv1024si_scalar */

        case 54:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7919; /* *pred_subrvvm8di_scalar */

        case 55:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7924; /* *pred_subrvvm4di_scalar */

        case 56:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7929; /* *pred_subrvvm2di_scalar */

        case 57:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7934; /* *pred_subrvvm1di_scalar */

        case 58:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7939; /* *pred_subv1di_scalar */

        case 59:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7944; /* *pred_subv2di_scalar */

        case 60:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7949; /* *pred_subv4di_scalar */

        case 61:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7954; /* *pred_subv8di_scalar */

        case 62:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7959; /* *pred_subv16di_scalar */

        case 63:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7964; /* *pred_subv32di_scalar */

        case 64:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7969; /* *pred_subv64di_scalar */

        case 65:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7974; /* *pred_subv128di_scalar */

        case 66:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7979; /* *pred_subv256di_scalar */

        case 67:
          if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7984; /* *pred_subv512di_scalar */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_754 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern543 (x2, 
E_RVVM8HImode, 
E_HImode, 
E_RVVMF2BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10358; /* pred_single_widen_suburvvm8hi_extended_scalar */

        case E_RVVM4HImode:
          if (pattern543 (x2, 
E_RVVM4HImode, 
E_HImode, 
E_RVVMF4BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10360; /* pred_single_widen_suburvvm4hi_extended_scalar */

        case E_RVVM2HImode:
          if (pattern543 (x2, 
E_RVVM2HImode, 
E_HImode, 
E_RVVMF8BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10362; /* pred_single_widen_suburvvm2hi_extended_scalar */

        case E_RVVM1HImode:
          if (pattern543 (x2, 
E_RVVM1HImode, 
E_HImode, 
E_RVVMF16BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10364; /* pred_single_widen_suburvvm1hi_extended_scalar */

        case E_RVVMF2HImode:
          if (pattern543 (x2, 
E_RVVMF2HImode, 
E_HImode, 
E_RVVMF32BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10366; /* pred_single_widen_suburvvmf2hi_extended_scalar */

        case E_RVVMF4HImode:
          if (pattern543 (x2, 
E_RVVMF4HImode, 
E_HImode, 
E_RVVMF64BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10368; /* pred_single_widen_suburvvmf4hi_extended_scalar */

        case E_RVVM8SImode:
          if (pattern543 (x2, 
E_RVVM8SImode, 
E_SImode, 
E_RVVMF4BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10370; /* pred_single_widen_suburvvm8si_extended_scalar */

        case E_RVVM4SImode:
          if (pattern543 (x2, 
E_RVVM4SImode, 
E_SImode, 
E_RVVMF8BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10372; /* pred_single_widen_suburvvm4si_extended_scalar */

        case E_RVVM2SImode:
          if (pattern543 (x2, 
E_RVVM2SImode, 
E_SImode, 
E_RVVMF16BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10374; /* pred_single_widen_suburvvm2si_extended_scalar */

        case E_RVVM1SImode:
          if (pattern543 (x2, 
E_RVVM1SImode, 
E_SImode, 
E_RVVMF32BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10376; /* pred_single_widen_suburvvm1si_extended_scalar */

        case E_RVVMF2SImode:
          if (pattern543 (x2, 
E_RVVMF2SImode, 
E_SImode, 
E_RVVMF64BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10378; /* pred_single_widen_suburvvmf2si_extended_scalar */

        case E_RVVM8DImode:
          if (pattern543 (x2, 
E_RVVM8DImode, 
E_DImode, 
E_RVVMF8BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10380; /* pred_single_widen_suburvvm8di_extended_scalar */

        case E_RVVM4DImode:
          if (pattern543 (x2, 
E_RVVM4DImode, 
E_DImode, 
E_RVVMF16BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10382; /* pred_single_widen_suburvvm4di_extended_scalar */

        case E_RVVM2DImode:
          if (pattern543 (x2, 
E_RVVM2DImode, 
E_DImode, 
E_RVVMF32BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10384; /* pred_single_widen_suburvvm2di_extended_scalar */

        case E_RVVM1DImode:
          if (pattern543 (x2, 
E_RVVM1DImode, 
E_DImode, 
E_RVVMF64BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10386; /* pred_single_widen_suburvvm1di_extended_scalar */

        case E_V1HImode:
          if (pattern543 (x2, 
E_V1HImode, 
E_HImode, 
E_V1BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10388; /* pred_single_widen_subuv1hi_extended_scalar */

        case E_V2HImode:
          if (pattern543 (x2, 
E_V2HImode, 
E_HImode, 
E_V2BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10390; /* pred_single_widen_subuv2hi_extended_scalar */

        case E_V4HImode:
          if (pattern543 (x2, 
E_V4HImode, 
E_HImode, 
E_V4BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10392; /* pred_single_widen_subuv4hi_extended_scalar */

        case E_V8HImode:
          if (pattern543 (x2, 
E_V8HImode, 
E_HImode, 
E_V8BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10394; /* pred_single_widen_subuv8hi_extended_scalar */

        case E_V16HImode:
          if (pattern543 (x2, 
E_V16HImode, 
E_HImode, 
E_V16BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10396; /* pred_single_widen_subuv16hi_extended_scalar */

        case E_V32HImode:
          if (pattern543 (x2, 
E_V32HImode, 
E_HImode, 
E_V32BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10398; /* pred_single_widen_subuv32hi_extended_scalar */

        case E_V64HImode:
          if (pattern543 (x2, 
E_V64HImode, 
E_HImode, 
E_V64BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10400; /* pred_single_widen_subuv64hi_extended_scalar */

        case E_V128HImode:
          if (pattern543 (x2, 
E_V128HImode, 
E_HImode, 
E_V128BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10402; /* pred_single_widen_subuv128hi_extended_scalar */

        case E_V256HImode:
          if (pattern543 (x2, 
E_V256HImode, 
E_HImode, 
E_V256BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10404; /* pred_single_widen_subuv256hi_extended_scalar */

        case E_V512HImode:
          if (pattern543 (x2, 
E_V512HImode, 
E_HImode, 
E_V512BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10406; /* pred_single_widen_subuv512hi_extended_scalar */

        case E_V1024HImode:
          if (pattern543 (x2, 
E_V1024HImode, 
E_HImode, 
E_V1024BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10408; /* pred_single_widen_subuv1024hi_extended_scalar */

        case E_V2048HImode:
          if (pattern543 (x2, 
E_V2048HImode, 
E_HImode, 
E_V2048BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10410; /* pred_single_widen_subuv2048hi_extended_scalar */

        case E_V1SImode:
          if (pattern543 (x2, 
E_V1SImode, 
E_SImode, 
E_V1BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10412; /* pred_single_widen_subuv1si_extended_scalar */

        case E_V2SImode:
          if (pattern543 (x2, 
E_V2SImode, 
E_SImode, 
E_V2BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10414; /* pred_single_widen_subuv2si_extended_scalar */

        case E_V4SImode:
          if (pattern543 (x2, 
E_V4SImode, 
E_SImode, 
E_V4BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10416; /* pred_single_widen_subuv4si_extended_scalar */

        case E_V8SImode:
          if (pattern543 (x2, 
E_V8SImode, 
E_SImode, 
E_V8BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10418; /* pred_single_widen_subuv8si_extended_scalar */

        case E_V16SImode:
          if (pattern543 (x2, 
E_V16SImode, 
E_SImode, 
E_V16BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10420; /* pred_single_widen_subuv16si_extended_scalar */

        case E_V32SImode:
          if (pattern543 (x2, 
E_V32SImode, 
E_SImode, 
E_V32BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10422; /* pred_single_widen_subuv32si_extended_scalar */

        case E_V64SImode:
          if (pattern543 (x2, 
E_V64SImode, 
E_SImode, 
E_V64BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10424; /* pred_single_widen_subuv64si_extended_scalar */

        case E_V128SImode:
          if (pattern543 (x2, 
E_V128SImode, 
E_SImode, 
E_V128BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10426; /* pred_single_widen_subuv128si_extended_scalar */

        case E_V256SImode:
          if (pattern543 (x2, 
E_V256SImode, 
E_SImode, 
E_V256BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10428; /* pred_single_widen_subuv256si_extended_scalar */

        case E_V512SImode:
          if (pattern543 (x2, 
E_V512SImode, 
E_SImode, 
E_V512BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10430; /* pred_single_widen_subuv512si_extended_scalar */

        case E_V1024SImode:
          if (pattern543 (x2, 
E_V1024SImode, 
E_SImode, 
E_V1024BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10432; /* pred_single_widen_subuv1024si_extended_scalar */

        case E_V1DImode:
          if (pattern543 (x2, 
E_V1DImode, 
E_DImode, 
E_V1BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10434; /* pred_single_widen_subuv1di_extended_scalar */

        case E_V2DImode:
          if (pattern543 (x2, 
E_V2DImode, 
E_DImode, 
E_V2BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10436; /* pred_single_widen_subuv2di_extended_scalar */

        case E_V4DImode:
          if (pattern543 (x2, 
E_V4DImode, 
E_DImode, 
E_V4BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10438; /* pred_single_widen_subuv4di_extended_scalar */

        case E_V8DImode:
          if (pattern543 (x2, 
E_V8DImode, 
E_DImode, 
E_V8BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10440; /* pred_single_widen_subuv8di_extended_scalar */

        case E_V16DImode:
          if (pattern543 (x2, 
E_V16DImode, 
E_DImode, 
E_V16BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10442; /* pred_single_widen_subuv16di_extended_scalar */

        case E_V32DImode:
          if (pattern543 (x2, 
E_V32DImode, 
E_DImode, 
E_V32BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10444; /* pred_single_widen_subuv32di_extended_scalar */

        case E_V64DImode:
          if (pattern543 (x2, 
E_V64DImode, 
E_DImode, 
E_V64BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10446; /* pred_single_widen_subuv64di_extended_scalar */

        case E_V128DImode:
          if (pattern543 (x2, 
E_V128DImode, 
E_DImode, 
E_V128BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10448; /* pred_single_widen_subuv128di_extended_scalar */

        case E_V256DImode:
          if (pattern543 (x2, 
E_V256DImode, 
E_DImode, 
E_V256BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10450; /* pred_single_widen_subuv256di_extended_scalar */

        case E_V512DImode:
          if (pattern543 (x2, 
E_V512DImode, 
E_DImode, 
E_V512BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10452; /* pred_single_widen_subuv512di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_885 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern547 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10645; /* pred_narrow_ashrrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10741; /* pred_narrow_ashrrvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10647; /* pred_narrow_ashrrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10743; /* pred_narrow_ashrrvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10649; /* pred_narrow_ashrrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10745; /* pred_narrow_ashrrvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10651; /* pred_narrow_ashrrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10747; /* pred_narrow_ashrrvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10653; /* pred_narrow_ashrrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10749; /* pred_narrow_ashrrvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 10655; /* pred_narrow_ashrrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10751; /* pred_narrow_ashrrvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10657; /* pred_narrow_ashrrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10753; /* pred_narrow_ashrrvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10659; /* pred_narrow_ashrrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10755; /* pred_narrow_ashrrvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10661; /* pred_narrow_ashrrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10757; /* pred_narrow_ashrrvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10663; /* pred_narrow_ashrrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10759; /* pred_narrow_ashrrvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 10665; /* pred_narrow_ashrrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10761; /* pred_narrow_ashrrvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10667; /* pred_narrow_ashrrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10763; /* pred_narrow_ashrrvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10669; /* pred_narrow_ashrrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10765; /* pred_narrow_ashrrvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10671; /* pred_narrow_ashrrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10767; /* pred_narrow_ashrrvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10673; /* pred_narrow_ashrrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10769; /* pred_narrow_ashrrvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 10675; /* pred_narrow_ashrv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 10771; /* pred_narrow_ashrv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 10677; /* pred_narrow_ashrv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 10773; /* pred_narrow_ashrv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 10679; /* pred_narrow_ashrv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 10775; /* pred_narrow_ashrv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 10681; /* pred_narrow_ashrv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 10777; /* pred_narrow_ashrv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 10683; /* pred_narrow_ashrv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 10779; /* pred_narrow_ashrv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 10685; /* pred_narrow_ashrv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10781; /* pred_narrow_ashrv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 10687; /* pred_narrow_ashrv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10783; /* pred_narrow_ashrv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 10689; /* pred_narrow_ashrv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10785; /* pred_narrow_ashrv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 10691; /* pred_narrow_ashrv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10787; /* pred_narrow_ashrv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 10693; /* pred_narrow_ashrv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10789; /* pred_narrow_ashrv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 10695; /* pred_narrow_ashrv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10791; /* pred_narrow_ashrv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 10697; /* pred_narrow_ashrv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10793; /* pred_narrow_ashrv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 10699; /* pred_narrow_ashrv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 10795; /* pred_narrow_ashrv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 10701; /* pred_narrow_ashrv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 10797; /* pred_narrow_ashrv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 10703; /* pred_narrow_ashrv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 10799; /* pred_narrow_ashrv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 10705; /* pred_narrow_ashrv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 10801; /* pred_narrow_ashrv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 10707; /* pred_narrow_ashrv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10803; /* pred_narrow_ashrv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 10709; /* pred_narrow_ashrv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10805; /* pred_narrow_ashrv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 10711; /* pred_narrow_ashrv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10807; /* pred_narrow_ashrv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 10713; /* pred_narrow_ashrv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10809; /* pred_narrow_ashrv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 10715; /* pred_narrow_ashrv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10811; /* pred_narrow_ashrv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 10717; /* pred_narrow_ashrv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10813; /* pred_narrow_ashrv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 10719; /* pred_narrow_ashrv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10815; /* pred_narrow_ashrv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 10721; /* pred_narrow_ashrv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10817; /* pred_narrow_ashrv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 10723; /* pred_narrow_ashrv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10819; /* pred_narrow_ashrv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 10725; /* pred_narrow_ashrv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10821; /* pred_narrow_ashrv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 10727; /* pred_narrow_ashrv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10823; /* pred_narrow_ashrv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 10729; /* pred_narrow_ashrv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10825; /* pred_narrow_ashrv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 10731; /* pred_narrow_ashrv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10827; /* pred_narrow_ashrv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 10733; /* pred_narrow_ashrv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10829; /* pred_narrow_ashrv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 10735; /* pred_narrow_ashrv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10831; /* pred_narrow_ashrv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 10737; /* pred_narrow_ashrv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10833; /* pred_narrow_ashrv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 10739; /* pred_narrow_ashrv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10835; /* pred_narrow_ashrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_892 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[5] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[6] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[7] = x8;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern602 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVM1BImode)
          && vector_const_0_operand (operands[3], E_RVVM8QImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4231; /* *pred_broadcastrvvm8qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVM1BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8QImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4353; /* *pred_broadcastrvvm8qi_imm */

    case E_RVVM4QImode:
      if (pattern602 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
          && vector_const_0_operand (operands[3], E_RVVM4QImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4232; /* *pred_broadcastrvvm4qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4QImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4354; /* *pred_broadcastrvvm4qi_imm */

    case E_RVVM2QImode:
      if (pattern602 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM2QImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4233; /* *pred_broadcastrvvm2qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2QImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4355; /* *pred_broadcastrvvm2qi_imm */

    case E_RVVM1QImode:
      if (pattern602 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM1QImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4234; /* *pred_broadcastrvvm1qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1QImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4356; /* *pred_broadcastrvvm1qi_imm */

    case E_RVVM8HImode:
      if (pattern602 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
          && vector_const_0_operand (operands[3], E_RVVM8HImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4235; /* *pred_broadcastrvvm8hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8HImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4357; /* *pred_broadcastrvvm8hi_imm */

    case E_RVVM4HImode:
      if (pattern602 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM4HImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4236; /* *pred_broadcastrvvm4hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4HImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4358; /* *pred_broadcastrvvm4hi_imm */

    case E_RVVM2HImode:
      if (pattern602 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM2HImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4237; /* *pred_broadcastrvvm2hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2HImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4359; /* *pred_broadcastrvvm2hi_imm */

    case E_RVVM1HImode:
      if (pattern602 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM1HImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4238; /* *pred_broadcastrvvm1hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1HImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4360; /* *pred_broadcastrvvm1hi_imm */

    case E_RVVM8SImode:
      if (pattern602 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM8SImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4239; /* *pred_broadcastrvvm8si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8SImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4361; /* *pred_broadcastrvvm8si_imm */

    case E_RVVM4SImode:
      if (pattern602 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM4SImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4240; /* *pred_broadcastrvvm4si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4362; /* *pred_broadcastrvvm4si_imm */

    case E_RVVM2SImode:
      if (pattern602 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM2SImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4241; /* *pred_broadcastrvvm2si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2SImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4363; /* *pred_broadcastrvvm2si_imm */

    case E_RVVM1SImode:
      if (pattern602 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVM1SImode)
          && 
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4242; /* *pred_broadcastrvvm1si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1SImode)
          || !
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4364; /* *pred_broadcastrvvm1si_imm */

    case E_RVVM8DImode:
      if (pattern602 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM8DImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4243; /* *pred_broadcastrvvm8di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8DImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4365; /* *pred_broadcastrvvm8di_imm */

    case E_RVVM4DImode:
      if (pattern602 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM4DImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4244; /* *pred_broadcastrvvm4di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4DImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4366; /* *pred_broadcastrvvm4di_imm */

    case E_RVVM2DImode:
      if (pattern602 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVM2DImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4245; /* *pred_broadcastrvvm2di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2DImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4367; /* *pred_broadcastrvvm2di_imm */

    case E_RVVM1DImode:
      if (pattern602 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVM1DImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4246; /* *pred_broadcastrvvm1di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1DImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4368; /* *pred_broadcastrvvm1di_imm */

    case E_RVVMF2QImode:
      if (pattern602 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2QImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 4247; /* *pred_broadcastrvvmf2qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2QImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4369; /* *pred_broadcastrvvmf2qi_imm */

    case E_RVVMF4QImode:
      if (pattern602 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVMF4QImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 4248; /* *pred_broadcastrvvmf4qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4QImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4370; /* *pred_broadcastrvvmf4qi_imm */

    case E_RVVMF8QImode:
      if (pattern602 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF8QImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 4249; /* *pred_broadcastrvvmf8qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF8QImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4371; /* *pred_broadcastrvvmf8qi_imm */

    case E_RVVMF2HImode:
      if (pattern602 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2HImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 4250; /* *pred_broadcastrvvmf2hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2HImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4372; /* *pred_broadcastrvvmf2hi_imm */

    case E_RVVMF4HImode:
      if (pattern602 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF4HImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 4251; /* *pred_broadcastrvvmf4hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4HImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4373; /* *pred_broadcastrvvmf4hi_imm */

    case E_RVVMF2SImode:
      if (pattern602 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2SImode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 4252; /* *pred_broadcastrvvmf2si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2SImode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4374; /* *pred_broadcastrvvmf2si_imm */

    case E_RVVM8BFmode:
      if (pattern602 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
          && vector_const_0_operand (operands[3], E_RVVM8BFmode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4253; /* *pred_broadcastrvvm8bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8BFmode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4375; /* *pred_broadcastrvvm8bf_imm */

    case E_RVVM4BFmode:
      if (pattern602 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM4BFmode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4254; /* *pred_broadcastrvvm4bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4BFmode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4376; /* *pred_broadcastrvvm4bf_imm */

    case E_RVVM2BFmode:
      if (pattern602 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM2BFmode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4255; /* *pred_broadcastrvvm2bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2BFmode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4377; /* *pred_broadcastrvvm2bf_imm */

    case E_RVVM1BFmode:
      if (pattern602 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM1BFmode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4256; /* *pred_broadcastrvvm1bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1BFmode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4378; /* *pred_broadcastrvvm1bf_imm */

    case E_RVVMF2BFmode:
      if (pattern602 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2BFmode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4257; /* *pred_broadcastrvvmf2bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2BFmode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4379; /* *pred_broadcastrvvmf2bf_imm */

    case E_RVVMF4BFmode:
      if (pattern602 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF4BFmode)
          && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return 4258; /* *pred_broadcastrvvmf4bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4BFmode)
          || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4380; /* *pred_broadcastrvvmf4bf_imm */

    case E_RVVM8HFmode:
      return recog_508 (x1, insn, pnum_clobbers);

    case E_RVVM4HFmode:
      return recog_507 (x1, insn, pnum_clobbers);

    case E_RVVM2HFmode:
      return recog_506 (x1, insn, pnum_clobbers);

    case E_RVVM1HFmode:
      return recog_505 (x1, insn, pnum_clobbers);

    case E_RVVMF2HFmode:
      return recog_504 (x1, insn, pnum_clobbers);

    case E_RVVMF4HFmode:
      return recog_503 (x1, insn, pnum_clobbers);

    case E_RVVM8SFmode:
      return recog_502 (x1, insn, pnum_clobbers);

    case E_RVVM4SFmode:
      return recog_501 (x1, insn, pnum_clobbers);

    case E_RVVM2SFmode:
      return recog_500 (x1, insn, pnum_clobbers);

    case E_RVVM1SFmode:
      return recog_499 (x1, insn, pnum_clobbers);

    case E_RVVMF2SFmode:
      return recog_498 (x1, insn, pnum_clobbers);

    case E_RVVM8DFmode:
      return recog_497 (x1, insn, pnum_clobbers);

    case E_RVVM4DFmode:
      return recog_496 (x1, insn, pnum_clobbers);

    case E_RVVM2DFmode:
      return recog_495 (x1, insn, pnum_clobbers);

    case E_RVVM1DFmode:
      return recog_494 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_493 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_492 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_491 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_490 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_489 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_488 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_487 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_486 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_485 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_484 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_483 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_482 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_481 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_480 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_479 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_478 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_477 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_476 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_475 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_474 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_473 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_472 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_471 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_470 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_469 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_468 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_467 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_466 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_465 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_464 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_463 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_462 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_461 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_460 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_459 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_458 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_457 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_456 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_455 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_454 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_453 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_452 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_451 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_450 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_449 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_448 (x1, insn, pnum_clobbers);

    case E_V1HFmode:
      return recog_447 (x1, insn, pnum_clobbers);

    case E_V2HFmode:
      return recog_446 (x1, insn, pnum_clobbers);

    case E_V4HFmode:
      return recog_445 (x1, insn, pnum_clobbers);

    case E_V8HFmode:
      return recog_444 (x1, insn, pnum_clobbers);

    case E_V16HFmode:
      return recog_443 (x1, insn, pnum_clobbers);

    case E_V32HFmode:
      return recog_442 (x1, insn, pnum_clobbers);

    case E_V64HFmode:
      return recog_441 (x1, insn, pnum_clobbers);

    case E_V128HFmode:
      return recog_440 (x1, insn, pnum_clobbers);

    case E_V256HFmode:
      return recog_439 (x1, insn, pnum_clobbers);

    case E_V512HFmode:
      return recog_438 (x1, insn, pnum_clobbers);

    case E_V1024HFmode:
      return recog_437 (x1, insn, pnum_clobbers);

    case E_V2048HFmode:
      return recog_436 (x1, insn, pnum_clobbers);

    case E_V1SFmode:
      return recog_435 (x1, insn, pnum_clobbers);

    case E_V2SFmode:
      return recog_434 (x1, insn, pnum_clobbers);

    case E_V4SFmode:
      return recog_433 (x1, insn, pnum_clobbers);

    case E_V8SFmode:
      return recog_432 (x1, insn, pnum_clobbers);

    case E_V16SFmode:
      return recog_431 (x1, insn, pnum_clobbers);

    case E_V32SFmode:
      return recog_430 (x1, insn, pnum_clobbers);

    case E_V64SFmode:
      return recog_429 (x1, insn, pnum_clobbers);

    case E_V128SFmode:
      return recog_428 (x1, insn, pnum_clobbers);

    case E_V256SFmode:
      return recog_427 (x1, insn, pnum_clobbers);

    case E_V512SFmode:
      return recog_426 (x1, insn, pnum_clobbers);

    case E_V1024SFmode:
      return recog_425 (x1, insn, pnum_clobbers);

    case E_V1DFmode:
      return recog_424 (x1, insn, pnum_clobbers);

    case E_V2DFmode:
      return recog_423 (x1, insn, pnum_clobbers);

    case E_V4DFmode:
      return recog_422 (x1, insn, pnum_clobbers);

    case E_V8DFmode:
      return recog_421 (x1, insn, pnum_clobbers);

    case E_V16DFmode:
      return recog_420 (x1, insn, pnum_clobbers);

    case E_V32DFmode:
      return recog_419 (x1, insn, pnum_clobbers);

    case E_V64DFmode:
      return recog_418 (x1, insn, pnum_clobbers);

    case E_V128DFmode:
      return recog_417 (x1, insn, pnum_clobbers);

    case E_V256DFmode:
      return recog_416 (x1, insn, pnum_clobbers);

    case E_V512DFmode:
      return recog_415 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_897 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  switch (GET_CODE (x10))
    {
    case REG:
    case SUBREG:
      operands[3] = x10;
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5509; /* pred_mulrvvm8qi */

        case 1:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5526; /* pred_mulrvvm4qi */

        case 2:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5543; /* pred_mulrvvm2qi */

        case 3:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5560; /* pred_mulrvvm1qi */

        case 4:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5577; /* pred_mulrvvm8hi */

        case 5:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5594; /* pred_mulrvvm4hi */

        case 6:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5611; /* pred_mulrvvm2hi */

        case 7:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5628; /* pred_mulrvvm1hi */

        case 8:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5645; /* pred_mulrvvm8si */

        case 9:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5662; /* pred_mulrvvm4si */

        case 10:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5679; /* pred_mulrvvm2si */

        case 11:
          if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5696; /* pred_mulrvvm1si */

        case 12:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5713; /* pred_mulrvvm8di */

        case 13:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5730; /* pred_mulrvvm4di */

        case 14:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5747; /* pred_mulrvvm2di */

        case 15:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5764; /* pred_mulrvvm1di */

        case 16:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5781; /* pred_mulrvvmf2qi */

        case 17:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5798; /* pred_mulrvvmf4qi */

        case 18:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5815; /* pred_mulrvvmf8qi */

        case 19:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5832; /* pred_mulrvvmf2hi */

        case 20:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5849; /* pred_mulrvvmf4hi */

        case 21:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5866; /* pred_mulrvvmf2si */

        case 22:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 5883; /* pred_mulv1qi */

        case 23:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 5900; /* pred_mulv2qi */

        case 24:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 5917; /* pred_mulv4qi */

        case 25:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 5934; /* pred_mulv8qi */

        case 26:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 5951; /* pred_mulv16qi */

        case 27:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 5968; /* pred_mulv32qi */

        case 28:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 5985; /* pred_mulv64qi */

        case 29:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6002; /* pred_mulv128qi */

        case 30:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6019; /* pred_mulv256qi */

        case 31:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6036; /* pred_mulv512qi */

        case 32:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6053; /* pred_mulv1024qi */

        case 33:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6070; /* pred_mulv2048qi */

        case 34:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6087; /* pred_mulv4096qi */

        case 35:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 6104; /* pred_mulv1hi */

        case 36:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 6121; /* pred_mulv2hi */

        case 37:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 6138; /* pred_mulv4hi */

        case 38:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 6155; /* pred_mulv8hi */

        case 39:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 6172; /* pred_mulv16hi */

        case 40:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6189; /* pred_mulv32hi */

        case 41:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6206; /* pred_mulv64hi */

        case 42:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6223; /* pred_mulv128hi */

        case 43:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6240; /* pred_mulv256hi */

        case 44:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6257; /* pred_mulv512hi */

        case 45:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6274; /* pred_mulv1024hi */

        case 46:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6291; /* pred_mulv2048hi */

        case 47:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 6308; /* pred_mulv1si */

        case 48:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 6325; /* pred_mulv2si */

        case 49:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 6342; /* pred_mulv4si */

        case 50:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 6359; /* pred_mulv8si */

        case 51:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6376; /* pred_mulv16si */

        case 52:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6393; /* pred_mulv32si */

        case 53:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6410; /* pred_mulv64si */

        case 54:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6427; /* pred_mulv128si */

        case 55:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6444; /* pred_mulv256si */

        case 56:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6461; /* pred_mulv512si */

        case 57:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6478; /* pred_mulv1024si */

        case 58:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6495; /* pred_mulv1di */

        case 59:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6512; /* pred_mulv2di */

        case 60:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6529; /* pred_mulv4di */

        case 61:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6546; /* pred_mulv8di */

        case 62:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6563; /* pred_mulv16di */

        case 63:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6580; /* pred_mulv32di */

        case 64:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6597; /* pred_mulv64di */

        case 65:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6614; /* pred_mulv128di */

        case 66:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6631; /* pred_mulv256di */

        case 67:
          if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6648; /* pred_mulv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x11 = XEXP (x9, 1);
      operands[3] = x11;
      x12 = XEXP (x10, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6865; /* pred_mulrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6874; /* pred_mulrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6883; /* pred_mulrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6892; /* pred_mulrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6901; /* pred_mulrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6910; /* pred_mulrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6919; /* pred_mulrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6928; /* pred_mulrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6937; /* pred_mulrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6946; /* pred_mulrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6955; /* pred_mulrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6964; /* pred_mulrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6973; /* pred_mulrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6982; /* pred_mulrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6991; /* pred_mulrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7000; /* pred_mulrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7009; /* pred_mulrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 7018; /* pred_mulrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7027; /* pred_mulv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7036; /* pred_mulv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7045; /* pred_mulv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7054; /* pred_mulv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7063; /* pred_mulv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7072; /* pred_mulv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7081; /* pred_mulv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7090; /* pred_mulv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7099; /* pred_mulv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7108; /* pred_mulv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7117; /* pred_mulv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7126; /* pred_mulv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7135; /* pred_mulv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7144; /* pred_mulv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7153; /* pred_mulv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7162; /* pred_mulv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7171; /* pred_mulv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7180; /* pred_mulv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7189; /* pred_mulv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7198; /* pred_mulv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7207; /* pred_mulv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7216; /* pred_mulv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7225; /* pred_mulv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7234; /* pred_mulv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7243; /* pred_mulv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7252; /* pred_mulv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7261; /* pred_mulv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7270; /* pred_mulv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7279; /* pred_mulv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7288; /* pred_mulv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7297; /* pred_mulv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7306; /* pred_mulv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7315; /* pred_mulv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7324; /* pred_mulv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7333; /* pred_mulv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7342; /* pred_mulv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7675; /* *pred_mulrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7684; /* *pred_mulrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7693; /* *pred_mulrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7702; /* *pred_mulrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7711; /* *pred_mulv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7720; /* *pred_mulv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7729; /* *pred_mulv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7738; /* *pred_mulv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7747; /* *pred_mulv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7756; /* *pred_mulv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7765; /* *pred_mulv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7774; /* *pred_mulv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7783; /* *pred_mulv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7792; /* *pred_mulv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern491 (x2))
            {
            case 0:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7801; /* *pred_mulrvvm8di_extended_scalar */

            case 1:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7810; /* *pred_mulrvvm4di_extended_scalar */

            case 2:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7819; /* *pred_mulrvvm2di_extended_scalar */

            case 3:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7828; /* *pred_mulrvvm1di_extended_scalar */

            case 4:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7837; /* *pred_mulv1di_extended_scalar */

            case 5:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7846; /* *pred_mulv2di_extended_scalar */

            case 6:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7855; /* *pred_mulv4di_extended_scalar */

            case 7:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7864; /* *pred_mulv8di_extended_scalar */

            case 8:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7873; /* *pred_mulv16di_extended_scalar */

            case 9:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7882; /* *pred_mulv32di_extended_scalar */

            case 10:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7891; /* *pred_mulv64di_extended_scalar */

            case 11:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7900; /* *pred_mulv128di_extended_scalar */

            case 12:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7909; /* *pred_mulv256di_extended_scalar */

            case 13:
              if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7918; /* *pred_mulv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_881 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_882 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_907 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[3] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[4] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[5] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[6] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern606 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14430; /* pred_seriesrvvm8qi */

    case E_RVVM4QImode:
      if (pattern606 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14431; /* pred_seriesrvvm4qi */

    case E_RVVM2QImode:
      if (pattern606 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14432; /* pred_seriesrvvm2qi */

    case E_RVVM1QImode:
      if (pattern606 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14433; /* pred_seriesrvvm1qi */

    case E_RVVM8HImode:
      if (pattern606 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14434; /* pred_seriesrvvm8hi */

    case E_RVVM4HImode:
      if (pattern606 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14435; /* pred_seriesrvvm4hi */

    case E_RVVM2HImode:
      if (pattern606 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14436; /* pred_seriesrvvm2hi */

    case E_RVVM1HImode:
      if (pattern606 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14437; /* pred_seriesrvvm1hi */

    case E_RVVM8SImode:
      if (pattern606 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14438; /* pred_seriesrvvm8si */

    case E_RVVM4SImode:
      if (pattern606 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14439; /* pred_seriesrvvm4si */

    case E_RVVM2SImode:
      if (pattern606 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14440; /* pred_seriesrvvm2si */

    case E_RVVM1SImode:
      if (pattern606 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 14441; /* pred_seriesrvvm1si */

    case E_RVVM8DImode:
      if (pattern606 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14442; /* pred_seriesrvvm8di */

    case E_RVVM4DImode:
      if (pattern606 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14443; /* pred_seriesrvvm4di */

    case E_RVVM2DImode:
      if (pattern606 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14444; /* pred_seriesrvvm2di */

    case E_RVVM1DImode:
      if (pattern606 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14445; /* pred_seriesrvvm1di */

    case E_RVVMF2QImode:
      if (pattern606 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 14446; /* pred_seriesrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern606 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 14447; /* pred_seriesrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern606 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 14448; /* pred_seriesrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern606 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 14449; /* pred_seriesrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern606 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 14450; /* pred_seriesrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern606 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 14451; /* pred_seriesrvvmf2si */

    case E_V1QImode:
      if (pattern606 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 14452; /* pred_seriesv1qi */

    case E_V2QImode:
      if (pattern606 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 14453; /* pred_seriesv2qi */

    case E_V4QImode:
      if (pattern606 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 14454; /* pred_seriesv4qi */

    case E_V8QImode:
      if (pattern606 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 14455; /* pred_seriesv8qi */

    case E_V16QImode:
      if (pattern606 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 14456; /* pred_seriesv16qi */

    case E_V32QImode:
      if (pattern606 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 14457; /* pred_seriesv32qi */

    case E_V64QImode:
      if (pattern606 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14458; /* pred_seriesv64qi */

    case E_V128QImode:
      if (pattern606 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14459; /* pred_seriesv128qi */

    case E_V256QImode:
      if (pattern606 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14460; /* pred_seriesv256qi */

    case E_V512QImode:
      if (pattern606 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14461; /* pred_seriesv512qi */

    case E_V1024QImode:
      if (pattern606 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14462; /* pred_seriesv1024qi */

    case E_V2048QImode:
      if (pattern606 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14463; /* pred_seriesv2048qi */

    case E_V4096QImode:
      if (pattern606 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14464; /* pred_seriesv4096qi */

    case E_V1HImode:
      if (pattern606 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 14465; /* pred_seriesv1hi */

    case E_V2HImode:
      if (pattern606 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 14466; /* pred_seriesv2hi */

    case E_V4HImode:
      if (pattern606 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 14467; /* pred_seriesv4hi */

    case E_V8HImode:
      if (pattern606 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 14468; /* pred_seriesv8hi */

    case E_V16HImode:
      if (pattern606 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 14469; /* pred_seriesv16hi */

    case E_V32HImode:
      if (pattern606 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14470; /* pred_seriesv32hi */

    case E_V64HImode:
      if (pattern606 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14471; /* pred_seriesv64hi */

    case E_V128HImode:
      if (pattern606 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14472; /* pred_seriesv128hi */

    case E_V256HImode:
      if (pattern606 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14473; /* pred_seriesv256hi */

    case E_V512HImode:
      if (pattern606 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14474; /* pred_seriesv512hi */

    case E_V1024HImode:
      if (pattern606 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14475; /* pred_seriesv1024hi */

    case E_V2048HImode:
      if (pattern606 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14476; /* pred_seriesv2048hi */

    case E_V1SImode:
      if (pattern606 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 14477; /* pred_seriesv1si */

    case E_V2SImode:
      if (pattern606 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 14478; /* pred_seriesv2si */

    case E_V4SImode:
      if (pattern606 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 14479; /* pred_seriesv4si */

    case E_V8SImode:
      if (pattern606 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 14480; /* pred_seriesv8si */

    case E_V16SImode:
      if (pattern606 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14481; /* pred_seriesv16si */

    case E_V32SImode:
      if (pattern606 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14482; /* pred_seriesv32si */

    case E_V64SImode:
      if (pattern606 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14483; /* pred_seriesv64si */

    case E_V128SImode:
      if (pattern606 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14484; /* pred_seriesv128si */

    case E_V256SImode:
      if (pattern606 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14485; /* pred_seriesv256si */

    case E_V512SImode:
      if (pattern606 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14486; /* pred_seriesv512si */

    case E_V1024SImode:
      if (pattern606 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14487; /* pred_seriesv1024si */

    case E_V1DImode:
      if (pattern606 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14488; /* pred_seriesv1di */

    case E_V2DImode:
      if (pattern606 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14489; /* pred_seriesv2di */

    case E_V4DImode:
      if (pattern606 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 14490; /* pred_seriesv4di */

    case E_V8DImode:
      if (pattern606 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14491; /* pred_seriesv8di */

    case E_V16DImode:
      if (pattern606 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14492; /* pred_seriesv16di */

    case E_V32DImode:
      if (pattern606 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14493; /* pred_seriesv32di */

    case E_V64DImode:
      if (pattern606 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14494; /* pred_seriesv64di */

    case E_V128DImode:
      if (pattern606 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14495; /* pred_seriesv128di */

    case E_V256DImode:
      if (pattern606 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14496; /* pred_seriesv256di */

    case E_V512DImode:
      if (pattern606 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14497; /* pred_seriesv512di */

    default:
      return -1;
    }
}

 int
recog_914 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x8, 1);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern493 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32739; /* pred_vrotlrvvm8qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32783; /* pred_vrotlrvvm8qi_scalar */

    case E_RVVM4QImode:
      if (pattern493 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32741; /* pred_vrotlrvvm4qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32785; /* pred_vrotlrvvm4qi_scalar */

    case E_RVVM2QImode:
      if (pattern493 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32743; /* pred_vrotlrvvm2qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32787; /* pred_vrotlrvvm2qi_scalar */

    case E_RVVM1QImode:
      if (pattern493 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32745; /* pred_vrotlrvvm1qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32789; /* pred_vrotlrvvm1qi_scalar */

    case E_RVVM8HImode:
      if (pattern493 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32747; /* pred_vrotlrvvm8hi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32791; /* pred_vrotlrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern493 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32749; /* pred_vrotlrvvm4hi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32793; /* pred_vrotlrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern493 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32751; /* pred_vrotlrvvm2hi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32795; /* pred_vrotlrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern493 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32753; /* pred_vrotlrvvm1hi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32797; /* pred_vrotlrvvm1hi_scalar */

    case E_RVVM8SImode:
      if (pattern493 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32755; /* pred_vrotlrvvm8si */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32799; /* pred_vrotlrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern493 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32757; /* pred_vrotlrvvm4si */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32801; /* pred_vrotlrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern493 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32759; /* pred_vrotlrvvm2si */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32803; /* pred_vrotlrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern493 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return 32761; /* pred_vrotlrvvm1si */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32805; /* pred_vrotlrvvm1si_scalar */

    case E_RVVM8DImode:
      if (pattern493 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32763; /* pred_vrotlrvvm8di */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32807; /* pred_vrotlrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern493 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32765; /* pred_vrotlrvvm4di */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32809; /* pred_vrotlrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern493 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32767; /* pred_vrotlrvvm2di */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32811; /* pred_vrotlrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern493 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32769; /* pred_vrotlrvvm1di */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32813; /* pred_vrotlrvvm1di_scalar */

    case E_RVVMF2QImode:
      if (pattern493 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 32771; /* pred_vrotlrvvmf2qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32815; /* pred_vrotlrvvmf2qi_scalar */

    case E_RVVMF4QImode:
      if (pattern493 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 32773; /* pred_vrotlrvvmf4qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32817; /* pred_vrotlrvvmf4qi_scalar */

    case E_RVVMF8QImode:
      if (pattern493 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 32775; /* pred_vrotlrvvmf8qi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32819; /* pred_vrotlrvvmf8qi_scalar */

    case E_RVVMF2HImode:
      if (pattern493 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 32777; /* pred_vrotlrvvmf2hi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32821; /* pred_vrotlrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern493 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 32779; /* pred_vrotlrvvmf4hi */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32823; /* pred_vrotlrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      if (pattern493 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 32781; /* pred_vrotlrvvmf2si */
      if (!pmode_register_operand (operands[4], E_VOIDmode)
          || !(
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32825; /* pred_vrotlrvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_918 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      if (pattern606 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode)
              || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17783; /* pred_extendrvvm8sf */

        case E_RVVM4BFmode:
          if (!register_operand (operands[3], E_RVVM4BFmode)
              || !(
#line 74 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 21 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33767; /* pred_extend_bf16_to_rvvm8sf */

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (pattern606 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode)
              || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17784; /* pred_extendrvvm4sf */

        case E_RVVM2BFmode:
          if (!register_operand (operands[3], E_RVVM2BFmode)
              || !(
#line 74 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 22 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33768; /* pred_extend_bf16_to_rvvm4sf */

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (pattern606 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode)
              || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17785; /* pred_extendrvvm2sf */

        case E_RVVM1BFmode:
          if (!register_operand (operands[3], E_RVVM1BFmode)
              || !(
#line 74 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 23 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33769; /* pred_extend_bf16_to_rvvm2sf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (pattern606 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode)
              || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17786; /* pred_extendrvvm1sf */

        case E_RVVMF2BFmode:
          if (!register_operand (operands[3], E_RVVMF2BFmode)
              || !(
#line 74 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33770; /* pred_extend_bf16_to_rvvm1sf */

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (pattern606 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode)
              || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17787; /* pred_extendrvvmf2sf */

        case E_RVVMF4BFmode:
          if (!register_operand (operands[3], E_RVVMF4BFmode)
              || !(
#line 74 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 25 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 33771; /* pred_extend_bf16_to_rvvmf2sf */

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (pattern504 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17788; /* pred_extendrvvm8df */

    case E_RVVM4DFmode:
      if (pattern504 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17789; /* pred_extendrvvm4df */

    case E_RVVM2DFmode:
      if (pattern504 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17790; /* pred_extendrvvm2df */

    case E_RVVM1DFmode:
      if (pattern504 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17791; /* pred_extendrvvm1df */

    case E_V1SFmode:
      if (pattern504 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17792; /* pred_extendv1sf */

    case E_V2SFmode:
      if (pattern504 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17793; /* pred_extendv2sf */

    case E_V4SFmode:
      if (pattern504 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17794; /* pred_extendv4sf */

    case E_V8SFmode:
      if (pattern504 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17795; /* pred_extendv8sf */

    case E_V16SFmode:
      if (pattern504 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17796; /* pred_extendv16sf */

    case E_V32SFmode:
      if (pattern504 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17797; /* pred_extendv32sf */

    case E_V64SFmode:
      if (pattern504 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17798; /* pred_extendv64sf */

    case E_V128SFmode:
      if (pattern504 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17799; /* pred_extendv128sf */

    case E_V256SFmode:
      if (pattern504 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17800; /* pred_extendv256sf */

    case E_V512SFmode:
      if (pattern504 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17801; /* pred_extendv512sf */

    case E_V1024SFmode:
      if (pattern504 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17802; /* pred_extendv1024sf */

    case E_V1DFmode:
      if (pattern504 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17803; /* pred_extendv1df */

    case E_V2DFmode:
      if (pattern504 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17804; /* pred_extendv2df */

    case E_V4DFmode:
      if (pattern504 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17805; /* pred_extendv4df */

    case E_V8DFmode:
      if (pattern504 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17806; /* pred_extendv8df */

    case E_V16DFmode:
      if (pattern504 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17807; /* pred_extendv16df */

    case E_V32DFmode:
      if (pattern504 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17808; /* pred_extendv32df */

    case E_V64DFmode:
      if (pattern504 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17809; /* pred_extendv64df */

    case E_V128DFmode:
      if (pattern504 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17810; /* pred_extendv128df */

    case E_V256DFmode:
      if (pattern504 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17811; /* pred_extendv256df */

    case E_V512DFmode:
      if (pattern504 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17812; /* pred_extendv512df */

    default:
      return -1;
    }
}

 int
recog_925 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1253; /* *pred_mov_widthhrvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1259; /* *pred_mov_widthhrvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1265; /* *pred_mov_widthhrvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1271; /* *pred_mov_widthhrvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1277; /* *pred_mov_widthhrvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1283; /* *pred_mov_widthhrvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1289; /* *pred_mov_widthhrvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1295; /* *pred_mov_widthhrvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1301; /* *pred_mov_widthhrvvm8si */

    case 9:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1307; /* *pred_mov_widthhrvvm4si */

    case 10:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1313; /* *pred_mov_widthhrvvm2si */

    case 11:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1319; /* *pred_mov_widthhrvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1325; /* *pred_mov_widthhrvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1331; /* *pred_mov_widthhrvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1337; /* *pred_mov_widthhrvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1343; /* *pred_mov_widthhrvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1349; /* *pred_mov_widthhrvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1355; /* *pred_mov_widthhrvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1361; /* *pred_mov_widthhrvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1367; /* *pred_mov_widthhrvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1373; /* *pred_mov_widthhrvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1379; /* *pred_mov_widthhrvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1385; /* *pred_mov_widthhrvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1391; /* *pred_mov_widthhrvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1397; /* *pred_mov_widthhrvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1403; /* *pred_mov_widthhrvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1409; /* *pred_mov_widthhrvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1415; /* *pred_mov_widthhrvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1421; /* *pred_mov_widthhrvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1427; /* *pred_mov_widthhrvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1433; /* *pred_mov_widthhrvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1439; /* *pred_mov_widthhrvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1445; /* *pred_mov_widthhrvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1451; /* *pred_mov_widthhrvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1457; /* *pred_mov_widthhrvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1463; /* *pred_mov_widthhrvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1469; /* *pred_mov_widthhrvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1475; /* *pred_mov_widthhrvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1481; /* *pred_mov_widthhrvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1487; /* *pred_mov_widthhrvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1493; /* *pred_mov_widthhrvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1499; /* *pred_mov_widthhrvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1505; /* *pred_mov_widthhrvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1511; /* *pred_mov_widthhv1qi */

    case 44:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1517; /* *pred_mov_widthhv2qi */

    case 45:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1523; /* *pred_mov_widthhv4qi */

    case 46:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1529; /* *pred_mov_widthhv8qi */

    case 47:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1535; /* *pred_mov_widthhv16qi */

    case 48:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1541; /* *pred_mov_widthhv32qi */

    case 49:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1547; /* *pred_mov_widthhv64qi */

    case 50:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1553; /* *pred_mov_widthhv128qi */

    case 51:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1559; /* *pred_mov_widthhv256qi */

    case 52:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1565; /* *pred_mov_widthhv512qi */

    case 53:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1571; /* *pred_mov_widthhv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1577; /* *pred_mov_widthhv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1583; /* *pred_mov_widthhv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1589; /* *pred_mov_widthhv1hi */

    case 57:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1595; /* *pred_mov_widthhv2hi */

    case 58:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1601; /* *pred_mov_widthhv4hi */

    case 59:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1607; /* *pred_mov_widthhv8hi */

    case 60:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1613; /* *pred_mov_widthhv16hi */

    case 61:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1619; /* *pred_mov_widthhv32hi */

    case 62:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1625; /* *pred_mov_widthhv64hi */

    case 63:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1631; /* *pred_mov_widthhv128hi */

    case 64:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1637; /* *pred_mov_widthhv256hi */

    case 65:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1643; /* *pred_mov_widthhv512hi */

    case 66:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1649; /* *pred_mov_widthhv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1655; /* *pred_mov_widthhv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1661; /* *pred_mov_widthhv1si */

    case 69:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1667; /* *pred_mov_widthhv2si */

    case 70:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1673; /* *pred_mov_widthhv4si */

    case 71:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1679; /* *pred_mov_widthhv8si */

    case 72:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1685; /* *pred_mov_widthhv16si */

    case 73:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1691; /* *pred_mov_widthhv32si */

    case 74:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1697; /* *pred_mov_widthhv64si */

    case 75:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1703; /* *pred_mov_widthhv128si */

    case 76:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1709; /* *pred_mov_widthhv256si */

    case 77:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1715; /* *pred_mov_widthhv512si */

    case 78:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1721; /* *pred_mov_widthhv1024si */

    case 79:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1727; /* *pred_mov_widthhv1di */

    case 80:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1733; /* *pred_mov_widthhv2di */

    case 81:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1739; /* *pred_mov_widthhv4di */

    case 82:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1745; /* *pred_mov_widthhv8di */

    case 83:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1751; /* *pred_mov_widthhv16di */

    case 84:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1757; /* *pred_mov_widthhv32di */

    case 85:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1763; /* *pred_mov_widthhv64di */

    case 86:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1769; /* *pred_mov_widthhv128di */

    case 87:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1775; /* *pred_mov_widthhv256di */

    case 88:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1781; /* *pred_mov_widthhv512di */

    case 89:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1787; /* *pred_mov_widthhv1hf */

    case 90:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1793; /* *pred_mov_widthhv2hf */

    case 91:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1799; /* *pred_mov_widthhv4hf */

    case 92:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1805; /* *pred_mov_widthhv8hf */

    case 93:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1811; /* *pred_mov_widthhv16hf */

    case 94:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1817; /* *pred_mov_widthhv32hf */

    case 95:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1823; /* *pred_mov_widthhv64hf */

    case 96:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1829; /* *pred_mov_widthhv128hf */

    case 97:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1835; /* *pred_mov_widthhv256hf */

    case 98:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1841; /* *pred_mov_widthhv512hf */

    case 99:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1847; /* *pred_mov_widthhv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1853; /* *pred_mov_widthhv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1859; /* *pred_mov_widthhv1sf */

    case 102:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1865; /* *pred_mov_widthhv2sf */

    case 103:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1871; /* *pred_mov_widthhv4sf */

    case 104:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1877; /* *pred_mov_widthhv8sf */

    case 105:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1883; /* *pred_mov_widthhv16sf */

    case 106:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1889; /* *pred_mov_widthhv32sf */

    case 107:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1895; /* *pred_mov_widthhv64sf */

    case 108:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1901; /* *pred_mov_widthhv128sf */

    case 109:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1907; /* *pred_mov_widthhv256sf */

    case 110:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1913; /* *pred_mov_widthhv512sf */

    case 111:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1919; /* *pred_mov_widthhv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1925; /* *pred_mov_widthhv1df */

    case 113:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1931; /* *pred_mov_widthhv2df */

    case 114:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1937; /* *pred_mov_widthhv4df */

    case 115:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1943; /* *pred_mov_widthhv8df */

    case 116:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1949; /* *pred_mov_widthhv16df */

    case 117:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1955; /* *pred_mov_widthhv32df */

    case 118:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1961; /* *pred_mov_widthhv64df */

    case 119:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1967; /* *pred_mov_widthhv128df */

    case 120:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1973; /* *pred_mov_widthhv256df */

    case 121:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1979; /* *pred_mov_widthhv512df */

    default:
      return -1;
    }
}

 int
recog_937 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern724 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12236; /* pred_narrow_clipurvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12332; /* pred_narrow_clipurvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12238; /* pred_narrow_clipurvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12334; /* pred_narrow_clipurvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12240; /* pred_narrow_clipurvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12336; /* pred_narrow_clipurvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12242; /* pred_narrow_clipurvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12338; /* pred_narrow_clipurvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12244; /* pred_narrow_clipurvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12340; /* pred_narrow_clipurvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12246; /* pred_narrow_clipurvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12342; /* pred_narrow_clipurvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12248; /* pred_narrow_clipurvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12344; /* pred_narrow_clipurvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12250; /* pred_narrow_clipurvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12346; /* pred_narrow_clipurvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12252; /* pred_narrow_clipurvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12348; /* pred_narrow_clipurvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12254; /* pred_narrow_clipurvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12350; /* pred_narrow_clipurvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12256; /* pred_narrow_clipurvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12352; /* pred_narrow_clipurvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12258; /* pred_narrow_clipurvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12354; /* pred_narrow_clipurvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12260; /* pred_narrow_clipurvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12356; /* pred_narrow_clipurvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12262; /* pred_narrow_clipurvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12358; /* pred_narrow_clipurvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12264; /* pred_narrow_clipurvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12360; /* pred_narrow_clipurvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12266; /* pred_narrow_clipuv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12362; /* pred_narrow_clipuv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12268; /* pred_narrow_clipuv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12364; /* pred_narrow_clipuv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12270; /* pred_narrow_clipuv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12366; /* pred_narrow_clipuv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12272; /* pred_narrow_clipuv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12368; /* pred_narrow_clipuv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12274; /* pred_narrow_clipuv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12370; /* pred_narrow_clipuv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12276; /* pred_narrow_clipuv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12372; /* pred_narrow_clipuv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12278; /* pred_narrow_clipuv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12374; /* pred_narrow_clipuv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12280; /* pred_narrow_clipuv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12376; /* pred_narrow_clipuv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12282; /* pred_narrow_clipuv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12378; /* pred_narrow_clipuv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12284; /* pred_narrow_clipuv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12380; /* pred_narrow_clipuv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 12286; /* pred_narrow_clipuv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12382; /* pred_narrow_clipuv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 12288; /* pred_narrow_clipuv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12384; /* pred_narrow_clipuv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12290; /* pred_narrow_clipuv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12386; /* pred_narrow_clipuv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12292; /* pred_narrow_clipuv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12388; /* pred_narrow_clipuv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12294; /* pred_narrow_clipuv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12390; /* pred_narrow_clipuv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12296; /* pred_narrow_clipuv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12392; /* pred_narrow_clipuv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12298; /* pred_narrow_clipuv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12394; /* pred_narrow_clipuv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12300; /* pred_narrow_clipuv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12396; /* pred_narrow_clipuv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12302; /* pred_narrow_clipuv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12398; /* pred_narrow_clipuv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12304; /* pred_narrow_clipuv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12400; /* pred_narrow_clipuv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12306; /* pred_narrow_clipuv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12402; /* pred_narrow_clipuv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12308; /* pred_narrow_clipuv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12404; /* pred_narrow_clipuv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 12310; /* pred_narrow_clipuv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12406; /* pred_narrow_clipuv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 12312; /* pred_narrow_clipuv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12408; /* pred_narrow_clipuv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 12314; /* pred_narrow_clipuv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12410; /* pred_narrow_clipuv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12316; /* pred_narrow_clipuv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12412; /* pred_narrow_clipuv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12318; /* pred_narrow_clipuv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12414; /* pred_narrow_clipuv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12320; /* pred_narrow_clipuv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12416; /* pred_narrow_clipuv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12322; /* pred_narrow_clipuv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12418; /* pred_narrow_clipuv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12324; /* pred_narrow_clipuv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12420; /* pred_narrow_clipuv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12326; /* pred_narrow_clipuv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12422; /* pred_narrow_clipuv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12328; /* pred_narrow_clipuv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12424; /* pred_narrow_clipuv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12330; /* pred_narrow_clipuv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12426; /* pred_narrow_clipuv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_1050 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15744; /* *pred_mul_neg_addrvvmf4hf_undef */
}

 int
recog_1058 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15760; /* *pred_mul_neg_addrvvm2df_undef */
}

 int
recog_1066 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15776; /* *pred_mul_neg_addv64hf_undef */
}

 int
recog_1074 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15792; /* *pred_mul_neg_addv4sf_undef */
}

 int
recog_1082 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15808; /* *pred_mul_neg_addv1024sf_undef */
}

 int
recog_1090 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15824; /* *pred_mul_neg_addv128df_undef */
}

 int
recog_1100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1085 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15910; /* *pred_nmsubv4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16006; /* *pred_nmsacv4df */
}

 int
recog_1110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1075 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15890; /* *pred_nmsubv8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15986; /* *pred_nmsacv8sf */
}

 int
recog_1119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1066 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15872; /* *pred_nmsubv64hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15968; /* *pred_nmsacv64hf */
}

 int
recog_1129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1056 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15852; /* *pred_nmsubrvvm8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15948; /* *pred_nmsacrvvm8df */
}

 int
recog_1139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1046 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15832; /* *pred_nmsubrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15928; /* *pred_nmsacrvvm4hf */
}

 int
recog_1149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15265; /* *pred_mul_subrvvmf4hf_undef */
}

 int
recog_1157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15281; /* *pred_mul_subrvvm2df_undef */
}

 int
recog_1164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15295; /* *pred_mul_subv32hf_undef */
}

 int
recog_1171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15309; /* *pred_mul_subv1sf_undef */
}

 int
recog_1178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15323; /* *pred_mul_subv128sf_undef */
}

 int
recog_1185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15337; /* *pred_mul_subv8df_undef */
}

 int
recog_1192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1191 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15445; /* *pred_msubv512df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15541; /* *pred_msacv512df */
}

 int
recog_1199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1184 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15431; /* *pred_msubv4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15527; /* *pred_msacv4df */
}

 int
recog_1206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1177 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15417; /* *pred_msubv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15513; /* *pred_msacv64sf */
}

 int
recog_1213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1170 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15403; /* *pred_msubv2048hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15499; /* *pred_msacv2048hf */
}

 int
recog_1220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1163 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15389; /* *pred_msubv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15485; /* *pred_msacv16hf */
}

 int
recog_1227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1156 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15375; /* *pred_msubrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15471; /* *pred_msacrvvm4df */
}

 int
recog_1234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1149 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return 15361; /* *pred_msubrvvmf4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15457; /* *pred_msacrvvmf4hf */
}

 int
recog_1241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15737; /* *pred_mul_neg_subrvvm4hf_undef */
}

 int
recog_1248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15751; /* *pred_mul_neg_subrvvm2sf_undef */
}

 int
recog_1255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15765; /* *pred_mul_neg_subv1hf_undef */
}

 int
recog_1262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15779; /* *pred_mul_neg_subv128hf_undef */
}

 int
recog_1269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15793; /* *pred_mul_neg_subv4sf_undef */
}

 int
recog_1276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15807; /* *pred_mul_neg_subv512sf_undef */
}

 int
recog_1283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15821; /* *pred_mul_neg_subv32df_undef */
}

 int
recog_1290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1285 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15921; /* *pred_nmaddv128df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 16017; /* *pred_nmaccv128df */
}

 int
recog_1297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1278 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15907; /* *pred_nmaddv1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16003; /* *pred_nmaccv1df */
}

 int
recog_1304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1271 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15893; /* *pred_nmaddv16sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15989; /* *pred_nmaccv16sf */
}

 int
recog_1311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1264 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15879; /* *pred_nmaddv512hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15975; /* *pred_nmaccv512hf */
}

 int
recog_1318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1257 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15865; /* *pred_nmaddv4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15961; /* *pred_nmaccv4hf */
}

 int
recog_1326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1249 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15849; /* *pred_nmaddrvvm1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15945; /* *pred_nmaccrvvm1sf */
}

 int
recog_1334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1241 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15833; /* *pred_nmaddrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15929; /* *pred_nmaccrvvm4hf */
}

 int
recog_1342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x3, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          switch (pattern713 (x2))
            {
            case 0:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14498; /* pred_addrvvm8hf */

            case 1:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14502; /* pred_addrvvm4hf */

            case 2:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14506; /* pred_addrvvm2hf */

            case 3:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14510; /* pred_addrvvm1hf */

            case 4:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14514; /* pred_addrvvmf2hf */

            case 5:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14518; /* pred_addrvvmf4hf */

            case 6:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14522; /* pred_addrvvm8sf */

            case 7:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14526; /* pred_addrvvm4sf */

            case 8:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14530; /* pred_addrvvm2sf */

            case 9:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14534; /* pred_addrvvm1sf */

            case 10:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14538; /* pred_addrvvmf2sf */

            case 11:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14542; /* pred_addrvvm8df */

            case 12:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14546; /* pred_addrvvm4df */

            case 13:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14550; /* pred_addrvvm2df */

            case 14:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14554; /* pred_addrvvm1df */

            case 15:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14558; /* pred_addv1hf */

            case 16:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14562; /* pred_addv2hf */

            case 17:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14566; /* pred_addv4hf */

            case 18:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14570; /* pred_addv8hf */

            case 19:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14574; /* pred_addv16hf */

            case 20:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14578; /* pred_addv32hf */

            case 21:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14582; /* pred_addv64hf */

            case 22:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14586; /* pred_addv128hf */

            case 23:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14590; /* pred_addv256hf */

            case 24:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14594; /* pred_addv512hf */

            case 25:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14598; /* pred_addv1024hf */

            case 26:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14602; /* pred_addv2048hf */

            case 27:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14606; /* pred_addv1sf */

            case 28:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14610; /* pred_addv2sf */

            case 29:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14614; /* pred_addv4sf */

            case 30:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14618; /* pred_addv8sf */

            case 31:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14622; /* pred_addv16sf */

            case 32:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14626; /* pred_addv32sf */

            case 33:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14630; /* pred_addv64sf */

            case 34:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14634; /* pred_addv128sf */

            case 35:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14638; /* pred_addv256sf */

            case 36:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14642; /* pred_addv512sf */

            case 37:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14646; /* pred_addv1024sf */

            case 38:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14650; /* pred_addv1df */

            case 39:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14654; /* pred_addv2df */

            case 40:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14658; /* pred_addv4df */

            case 41:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14662; /* pred_addv8df */

            case 42:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14666; /* pred_addv16df */

            case 43:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14670; /* pred_addv32df */

            case 44:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14674; /* pred_addv64df */

            case 45:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14678; /* pred_addv128df */

            case 46:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14682; /* pred_addv256df */

            case 47:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14686; /* pred_addv512df */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_DUPLICATE)
            return -1;
          switch (pattern734 (x2))
            {
            case 0:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16643; /* pred_single_widen_addrvvm8sf_scalar */

            case 1:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16645; /* pred_single_widen_addrvvm4sf_scalar */

            case 2:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16647; /* pred_single_widen_addrvvm2sf_scalar */

            case 3:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16649; /* pred_single_widen_addrvvm1sf_scalar */

            case 4:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16651; /* pred_single_widen_addrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16653; /* pred_single_widen_addrvvm8df_scalar */

            case 6:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16655; /* pred_single_widen_addrvvm4df_scalar */

            case 7:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16657; /* pred_single_widen_addrvvm2df_scalar */

            case 8:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16659; /* pred_single_widen_addrvvm1df_scalar */

            case 9:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16661; /* pred_single_widen_addv1sf_scalar */

            case 10:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16663; /* pred_single_widen_addv2sf_scalar */

            case 11:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16665; /* pred_single_widen_addv4sf_scalar */

            case 12:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16667; /* pred_single_widen_addv8sf_scalar */

            case 13:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16669; /* pred_single_widen_addv16sf_scalar */

            case 14:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16671; /* pred_single_widen_addv32sf_scalar */

            case 15:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16673; /* pred_single_widen_addv64sf_scalar */

            case 16:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16675; /* pred_single_widen_addv128sf_scalar */

            case 17:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16677; /* pred_single_widen_addv256sf_scalar */

            case 18:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16679; /* pred_single_widen_addv512sf_scalar */

            case 19:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16681; /* pred_single_widen_addv1024sf_scalar */

            case 20:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16683; /* pred_single_widen_addv1df_scalar */

            case 21:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16685; /* pred_single_widen_addv2df_scalar */

            case 22:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16687; /* pred_single_widen_addv4df_scalar */

            case 23:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16689; /* pred_single_widen_addv8df_scalar */

            case 24:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16691; /* pred_single_widen_addv16df_scalar */

            case 25:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16693; /* pred_single_widen_addv32df_scalar */

            case 26:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16695; /* pred_single_widen_addv64df_scalar */

            case 27:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16697; /* pred_single_widen_addv128df_scalar */

            case 28:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16699; /* pred_single_widen_addv256df_scalar */

            case 29:
              if (!(
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16701; /* pred_single_widen_addv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern581 (x2))
        {
        case 0:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14882; /* pred_addrvvm8hf_scalar */

        case 1:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14884; /* pred_addrvvm4hf_scalar */

        case 2:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14886; /* pred_addrvvm2hf_scalar */

        case 3:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14888; /* pred_addrvvm1hf_scalar */

        case 4:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14890; /* pred_addrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14892; /* pred_addrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14894; /* pred_addrvvm8sf_scalar */

        case 7:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14896; /* pred_addrvvm4sf_scalar */

        case 8:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14898; /* pred_addrvvm2sf_scalar */

        case 9:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14900; /* pred_addrvvm1sf_scalar */

        case 10:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14902; /* pred_addrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14904; /* pred_addrvvm8df_scalar */

        case 12:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14906; /* pred_addrvvm4df_scalar */

        case 13:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14908; /* pred_addrvvm2df_scalar */

        case 14:
          if (!(
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14910; /* pred_addrvvm1df_scalar */

        default:
          return -1;
        }

    case MULT:
      return recog_1141 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_1142 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_1143 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || !vector_arith_operand (operands[4], E_RVVM4QImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12428; /* *pred_cmprvvm4qi_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || !vector_arith_operand (operands[4], E_RVVM8HImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12431; /* *pred_cmprvvm8hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || !vector_arith_operand (operands[4], E_RVVM2QImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12429; /* *pred_cmprvvm2qi_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || !vector_arith_operand (operands[4], E_RVVM4HImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12432; /* *pred_cmprvvm4hi_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || !vector_arith_operand (operands[4], E_RVVM8SImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12435; /* *pred_cmprvvm8si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode)
          || !vector_arith_operand (operands[4], E_RVVM1QImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12430; /* *pred_cmprvvm1qi_merge_tie_mask */

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode)
          || !vector_arith_operand (operands[4], E_RVVM2HImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12433; /* *pred_cmprvvm2hi_merge_tie_mask */

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode)
          || !vector_arith_operand (operands[4], E_RVVM4SImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12436; /* *pred_cmprvvm4si_merge_tie_mask */

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode)
          || !vector_arith_operand (operands[4], E_RVVM8DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12439; /* *pred_cmprvvm8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || !vector_arith_operand (operands[4], E_RVVM1HImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12434; /* *pred_cmprvvm1hi_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || !vector_arith_operand (operands[4], E_RVVM2SImode)
          || !
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12437; /* *pred_cmprvvm2si_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || !vector_arith_operand (operands[4], E_RVVM4DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12440; /* *pred_cmprvvm4di_merge_tie_mask */

    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || !vector_arith_operand (operands[4], E_RVVMF2QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12443; /* *pred_cmprvvmf2qi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || !vector_arith_operand (operands[4], E_RVVM1DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12442; /* *pred_cmprvvm1di_merge_tie_mask */

    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || !vector_arith_operand (operands[4], E_RVVMF8QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12445; /* *pred_cmprvvmf8qi_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || !vector_arith_operand (operands[4], E_RVVMF4HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12447; /* *pred_cmprvvmf4hi_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || !vector_arith_operand (operands[4], E_RVVMF2SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12448; /* *pred_cmprvvmf2si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || !vector_arith_operand (operands[4], E_V4QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12451; /* *pred_cmpv4qi_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || !vector_arith_operand (operands[4], E_V4HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12464; /* *pred_cmpv4hi_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || !vector_arith_operand (operands[4], E_V4SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12476; /* *pred_cmpv4si_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !vector_arith_operand (operands[4], E_V4DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12487; /* *pred_cmpv4di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || !vector_arith_operand (operands[4], E_V256QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12457; /* *pred_cmpv256qi_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || !vector_arith_operand (operands[4], E_V256HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12470; /* *pred_cmpv256hi_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || !vector_arith_operand (operands[4], E_V256SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12482; /* *pred_cmpv256si_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || !vector_arith_operand (operands[4], E_V256DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12493; /* *pred_cmpv256di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1360 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || !vector_arith_operand (operands[5], E_V128QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12524; /* *pred_cmpv128qi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12592; /* *pred_cmpv128qi_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || !vector_arith_operand (operands[5], E_V128HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12537; /* *pred_cmpv128hi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12605; /* *pred_cmpv128hi_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || !vector_arith_operand (operands[5], E_V128SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12549; /* *pred_cmpv128si */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12617; /* *pred_cmpv128si_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || !vector_arith_operand (operands[5], E_V128DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12560; /* *pred_cmpv128di */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12628; /* *pred_cmpv128di_narrow */

    default:
      return -1;
    }
}

 int
recog_1375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2QImode)
          || !
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12633; /* *pred_ltgervvm2qi_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4HImode)
          || !
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12636; /* *pred_ltgervvm4hi_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM8SImode)
          || !
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12639; /* *pred_ltgervvm8si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1QImode:
      if (!register_operand (operands[3], E_V1QImode)
          || !vector_neg_arith_operand (operands[4], E_V1QImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 12653; /* *pred_ltgev1qi_merge_tie_mask */

    case E_V1HImode:
      if (!register_operand (operands[3], E_V1HImode)
          || !vector_neg_arith_operand (operands[4], E_V1HImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12666; /* *pred_ltgev1hi_merge_tie_mask */

    case E_V1SImode:
      if (!register_operand (operands[3], E_V1SImode)
          || !vector_neg_arith_operand (operands[4], E_V1SImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12678; /* *pred_ltgev1si_merge_tie_mask */

    case E_V1DImode:
      if (!register_operand (operands[3], E_V1DImode)
          || !vector_neg_arith_operand (operands[4], E_V1DImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12689; /* *pred_ltgev1di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V64QImode:
      if (!register_operand (operands[3], E_V64QImode)
          || !vector_neg_arith_operand (operands[4], E_V64QImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12659; /* *pred_ltgev64qi_merge_tie_mask */

    case E_V64HImode:
      if (!register_operand (operands[3], E_V64HImode)
          || !vector_neg_arith_operand (operands[4], E_V64HImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12672; /* *pred_ltgev64hi_merge_tie_mask */

    case E_V64SImode:
      if (!register_operand (operands[3], E_V64SImode)
          || !vector_neg_arith_operand (operands[4], E_V64SImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12684; /* *pred_ltgev64si_merge_tie_mask */

    case E_V64DImode:
      if (!register_operand (operands[3], E_V64DImode)
          || !vector_neg_arith_operand (operands[4], E_V64DImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12695; /* *pred_ltgev64di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V256BImode))
    {
      res = recog_1388 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256QImode:
      if (!register_operand (operands[4], E_V256QImode)
          || !vector_neg_arith_operand (operands[5], E_V256QImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256QImode)) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 12729; /* *pred_ltgev256qi */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256QImode)) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12797; /* *pred_ltgev256qi_narrow */

    case E_V256HImode:
      if (!register_operand (operands[4], E_V256HImode)
          || !vector_neg_arith_operand (operands[5], E_V256HImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HImode)) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12742; /* *pred_ltgev256hi */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HImode)) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12810; /* *pred_ltgev256hi_narrow */

    case E_V256SImode:
      if (!register_operand (operands[4], E_V256SImode)
          || !vector_neg_arith_operand (operands[5], E_V256SImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SImode)) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12754; /* *pred_ltgev256si */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SImode)) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12822; /* *pred_ltgev256si_narrow */

    case E_V256DImode:
      if (!register_operand (operands[4], E_V256DImode)
          || !vector_neg_arith_operand (operands[5], E_V256DImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode)) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12765; /* *pred_ltgev256di */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode)) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12833; /* *pred_ltgev256di_narrow */

    default:
      return -1;
    }
}

 int
recog_1401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || GET_MODE (x9) != E_RVVM4QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12836; /* *pred_cmprvvm4qi_scalar_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || GET_MODE (x9) != E_RVVM8HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12842; /* *pred_cmprvvm8hi_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1407 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1QImode:
      if (!register_operand (operands[3], E_V1QImode)
          || GET_MODE (x9) != E_V1QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 12853; /* *pred_cmpv1qi_scalar_merge_tie_mask */

    case E_V1HImode:
      if (!register_operand (operands[3], E_V1HImode)
          || GET_MODE (x9) != E_V1HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12866; /* *pred_cmpv1hi_scalar_merge_tie_mask */

    case E_V1SImode:
      if (!register_operand (operands[3], E_V1SImode)
          || GET_MODE (x9) != E_V1SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12878; /* *pred_cmpv1si_scalar_merge_tie_mask */

    case E_V1DImode:
      if (!register_operand (operands[3], E_V1DImode)
          || GET_MODE (x9) != E_V1DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13001; /* *pred_cmpv1di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128QImode:
      if (!register_operand (operands[3], E_V128QImode)
          || GET_MODE (x9) != E_V128QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12860; /* *pred_cmpv128qi_scalar_merge_tie_mask */

    case E_V128HImode:
      if (!register_operand (operands[3], E_V128HImode)
          || GET_MODE (x9) != E_V128HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12873; /* *pred_cmpv128hi_scalar_merge_tie_mask */

    case E_V128SImode:
      if (!register_operand (operands[3], E_V128SImode)
          || GET_MODE (x9) != E_V128SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12885; /* *pred_cmpv128si_scalar_merge_tie_mask */

    case E_V128DImode:
      if (!register_operand (operands[3], E_V128DImode)
          || GET_MODE (x9) != E_V128DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 13008; /* *pred_cmpv128di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1414 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || GET_MODE (x9) != E_V128QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12914; /* *pred_cmpv128qi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12968; /* *pred_cmpv128qi_scalar_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || GET_MODE (x9) != E_V128HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12927; /* *pred_cmpv128hi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12981; /* *pred_cmpv128hi_scalar_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || GET_MODE (x9) != E_V128SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12939; /* *pred_cmpv128si_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12993; /* *pred_cmpv128si_scalar_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || GET_MODE (x9) != E_V128DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 13022; /* *pred_cmpv128di_scalar */
      if (!(
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 13036; /* *pred_cmpv128di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1428 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V1BImode))
    {
      res = recog_1407 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1QImode:
      if (!register_operand (operands[4], E_V1QImode)
          || GET_MODE (x9) != E_V1QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 12907; /* *pred_cmpv1qi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 12961; /* *pred_cmpv1qi_scalar_narrow */

    case E_V1HImode:
      if (!register_operand (operands[4], E_V1HImode)
          || GET_MODE (x9) != E_V1HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12920; /* *pred_cmpv1hi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12974; /* *pred_cmpv1hi_scalar_narrow */

    case E_V1SImode:
      if (!register_operand (operands[4], E_V1SImode)
          || GET_MODE (x9) != E_V1SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12932; /* *pred_cmpv1si_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12986; /* *pred_cmpv1si_scalar_narrow */

    case E_V1DImode:
      if (!register_operand (operands[4], E_V1DImode)
          || GET_MODE (x9) != E_V1DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 13015; /* *pred_cmpv1di_scalar */
      if (!(
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13029; /* *pred_cmpv1di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1438 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[3], E_V4HFmode)
          || !register_operand (operands[4], E_V4HFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17008; /* *pred_cmpv4hf_narrow_merge_tie_mask */

    case E_V4SFmode:
      if (!register_operand (operands[3], E_V4SFmode)
          || !register_operand (operands[4], E_V4SFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17020; /* *pred_cmpv4sf_narrow_merge_tie_mask */

    case E_V4DFmode:
      if (!register_operand (operands[3], E_V4DFmode)
          || !register_operand (operands[4], E_V4DFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17031; /* *pred_cmpv4df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[3], E_V128HFmode)
          || !register_operand (operands[4], E_V128HFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17013; /* *pred_cmpv128hf_narrow_merge_tie_mask */

    case E_V128SFmode:
      if (!register_operand (operands[3], E_V128SFmode)
          || !register_operand (operands[4], E_V128SFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17025; /* *pred_cmpv128sf_narrow_merge_tie_mask */

    case E_V128DFmode:
      if (!register_operand (operands[3], E_V128DFmode)
          || !register_operand (operands[4], E_V128DFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17036; /* *pred_cmpv128df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || GET_MODE (x9) != E_RVVM2HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17089; /* *pred_cmprvvm2hf_scalar_merge_tie_mask */

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode)
          || GET_MODE (x9) != E_RVVM4SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17094; /* *pred_cmprvvm4sf_scalar_merge_tie_mask */

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode)
          || GET_MODE (x9) != E_RVVM8DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17098; /* *pred_cmprvvm8df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[3], E_V2HFmode)
          || GET_MODE (x9) != E_V2HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17103; /* *pred_cmpv2hf_scalar_merge_tie_mask */

    case E_V2SFmode:
      if (!register_operand (operands[3], E_V2SFmode)
          || GET_MODE (x9) != E_V2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17115; /* *pred_cmpv2sf_scalar_merge_tie_mask */

    case E_V2DFmode:
      if (!register_operand (operands[3], E_V2DFmode)
          || GET_MODE (x9) != E_V2DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17126; /* *pred_cmpv2df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[3], E_V128HFmode)
          || GET_MODE (x9) != E_V128HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17109; /* *pred_cmpv128hf_scalar_merge_tie_mask */

    case E_V128SFmode:
      if (!register_operand (operands[3], E_V128SFmode)
          || GET_MODE (x9) != E_V128SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17121; /* *pred_cmpv128sf_scalar_merge_tie_mask */

    case E_V128DFmode:
      if (!register_operand (operands[3], E_V128DFmode)
          || GET_MODE (x9) != E_V128DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17132; /* *pred_cmpv128df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V256BImode))
    {
      res = recog_1460 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[4], E_V256HFmode)
          || GET_MODE (x9) != E_V256HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HFmode)) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 17158; /* *pred_cmpv256hf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HFmode)) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17206; /* *pred_cmpv256hf_scalar_narrow */

    case E_V256SFmode:
      if (!register_operand (operands[4], E_V256SFmode)
          || GET_MODE (x9) != E_V256SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SFmode)) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 17170; /* *pred_cmpv256sf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SFmode)) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17218; /* *pred_cmpv256sf_scalar_narrow */

    case E_V256DFmode:
      if (!register_operand (operands[4], E_V256DFmode)
          || GET_MODE (x9) != E_V256DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DFmode)) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 17181; /* *pred_cmpv256df_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DFmode)) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17229; /* *pred_cmpv256df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1472 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (pattern266 (x3) != 0
      || pattern415 (x3) != 0)
    return -1;
  switch (XINT (x3, 1))
    {
    case 174:
      return recog_927 (x1, insn, pnum_clobbers);

    case 175:
      return recog_926 (x1, insn, pnum_clobbers);

    case 176:
      return recog_925 (x1, insn, pnum_clobbers);

    case 177:
      return recog_924 (x1, insn, pnum_clobbers);

    case 178:
      return recog_923 (x1, insn, pnum_clobbers);

    case 179:
      return recog_922 (x1, insn, pnum_clobbers);

    case 180:
      switch (pattern476 (x2, 
180))
        {
        case 0:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2040; /* pred_strided_load_widthbrvvm8qi */

        case 1:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2046; /* pred_strided_load_widthbrvvm4qi */

        case 2:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2052; /* pred_strided_load_widthbrvvm2qi */

        case 3:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2058; /* pred_strided_load_widthbrvvm1qi */

        case 4:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2064; /* pred_strided_load_widthbrvvm8hi */

        case 5:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2070; /* pred_strided_load_widthbrvvm4hi */

        case 6:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2076; /* pred_strided_load_widthbrvvm2hi */

        case 7:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2082; /* pred_strided_load_widthbrvvm1hi */

        case 8:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2088; /* pred_strided_load_widthbrvvm8si */

        case 9:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2094; /* pred_strided_load_widthbrvvm4si */

        case 10:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2100; /* pred_strided_load_widthbrvvm2si */

        case 11:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2106; /* pred_strided_load_widthbrvvm1si */

        case 12:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2112; /* pred_strided_load_widthbrvvm8di */

        case 13:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2118; /* pred_strided_load_widthbrvvm4di */

        case 14:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2124; /* pred_strided_load_widthbrvvm2di */

        case 15:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2130; /* pred_strided_load_widthbrvvm1di */

        case 16:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2136; /* pred_strided_load_widthbrvvmf8qi */

        case 17:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2142; /* pred_strided_load_widthbrvvmf4hi */

        case 18:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2148; /* pred_strided_load_widthbrvvmf2si */

        default:
          return -1;
        }

    case 181:
      switch (pattern476 (x2, 
181))
        {
        case 0:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2041; /* pred_strided_load_widthburvvm8qi */

        case 1:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2047; /* pred_strided_load_widthburvvm4qi */

        case 2:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2053; /* pred_strided_load_widthburvvm2qi */

        case 3:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2059; /* pred_strided_load_widthburvvm1qi */

        case 4:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2065; /* pred_strided_load_widthburvvm8hi */

        case 5:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2071; /* pred_strided_load_widthburvvm4hi */

        case 6:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2077; /* pred_strided_load_widthburvvm2hi */

        case 7:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2083; /* pred_strided_load_widthburvvm1hi */

        case 8:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2089; /* pred_strided_load_widthburvvm8si */

        case 9:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2095; /* pred_strided_load_widthburvvm4si */

        case 10:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2101; /* pred_strided_load_widthburvvm2si */

        case 11:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2107; /* pred_strided_load_widthburvvm1si */

        case 12:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2113; /* pred_strided_load_widthburvvm8di */

        case 13:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2119; /* pred_strided_load_widthburvvm4di */

        case 14:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2125; /* pred_strided_load_widthburvvm2di */

        case 15:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2131; /* pred_strided_load_widthburvvm1di */

        case 16:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2137; /* pred_strided_load_widthburvvmf8qi */

        case 17:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2143; /* pred_strided_load_widthburvvmf4hi */

        case 18:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2149; /* pred_strided_load_widthburvvmf2si */

        default:
          return -1;
        }

    case 182:
      switch (pattern476 (x2, 
182))
        {
        case 0:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2042; /* pred_strided_load_widthhrvvm8qi */

        case 1:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2048; /* pred_strided_load_widthhrvvm4qi */

        case 2:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2054; /* pred_strided_load_widthhrvvm2qi */

        case 3:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2060; /* pred_strided_load_widthhrvvm1qi */

        case 4:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2066; /* pred_strided_load_widthhrvvm8hi */

        case 5:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2072; /* pred_strided_load_widthhrvvm4hi */

        case 6:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2078; /* pred_strided_load_widthhrvvm2hi */

        case 7:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2084; /* pred_strided_load_widthhrvvm1hi */

        case 8:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2090; /* pred_strided_load_widthhrvvm8si */

        case 9:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2096; /* pred_strided_load_widthhrvvm4si */

        case 10:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2102; /* pred_strided_load_widthhrvvm2si */

        case 11:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2108; /* pred_strided_load_widthhrvvm1si */

        case 12:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2114; /* pred_strided_load_widthhrvvm8di */

        case 13:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2120; /* pred_strided_load_widthhrvvm4di */

        case 14:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2126; /* pred_strided_load_widthhrvvm2di */

        case 15:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2132; /* pred_strided_load_widthhrvvm1di */

        case 16:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2138; /* pred_strided_load_widthhrvvmf8qi */

        case 17:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2144; /* pred_strided_load_widthhrvvmf4hi */

        case 18:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2150; /* pred_strided_load_widthhrvvmf2si */

        default:
          return -1;
        }

    case 183:
      switch (pattern476 (x2, 
183))
        {
        case 0:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2043; /* pred_strided_load_widthhurvvm8qi */

        case 1:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2049; /* pred_strided_load_widthhurvvm4qi */

        case 2:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2055; /* pred_strided_load_widthhurvvm2qi */

        case 3:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2061; /* pred_strided_load_widthhurvvm1qi */

        case 4:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2067; /* pred_strided_load_widthhurvvm8hi */

        case 5:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2073; /* pred_strided_load_widthhurvvm4hi */

        case 6:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2079; /* pred_strided_load_widthhurvvm2hi */

        case 7:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2085; /* pred_strided_load_widthhurvvm1hi */

        case 8:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2091; /* pred_strided_load_widthhurvvm8si */

        case 9:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2097; /* pred_strided_load_widthhurvvm4si */

        case 10:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2103; /* pred_strided_load_widthhurvvm2si */

        case 11:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2109; /* pred_strided_load_widthhurvvm1si */

        case 12:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2115; /* pred_strided_load_widthhurvvm8di */

        case 13:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2121; /* pred_strided_load_widthhurvvm4di */

        case 14:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2127; /* pred_strided_load_widthhurvvm2di */

        case 15:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2133; /* pred_strided_load_widthhurvvm1di */

        case 16:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2139; /* pred_strided_load_widthhurvvmf8qi */

        case 17:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2145; /* pred_strided_load_widthhurvvmf4hi */

        case 18:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2151; /* pred_strided_load_widthhurvvmf2si */

        default:
          return -1;
        }

    case 184:
      switch (pattern476 (x2, 
184))
        {
        case 0:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2044; /* pred_strided_load_widthwrvvm8qi */

        case 1:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2050; /* pred_strided_load_widthwrvvm4qi */

        case 2:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2056; /* pred_strided_load_widthwrvvm2qi */

        case 3:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2062; /* pred_strided_load_widthwrvvm1qi */

        case 4:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2068; /* pred_strided_load_widthwrvvm8hi */

        case 5:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2074; /* pred_strided_load_widthwrvvm4hi */

        case 6:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2080; /* pred_strided_load_widthwrvvm2hi */

        case 7:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2086; /* pred_strided_load_widthwrvvm1hi */

        case 8:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2092; /* pred_strided_load_widthwrvvm8si */

        case 9:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2098; /* pred_strided_load_widthwrvvm4si */

        case 10:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2104; /* pred_strided_load_widthwrvvm2si */

        case 11:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2110; /* pred_strided_load_widthwrvvm1si */

        case 12:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2116; /* pred_strided_load_widthwrvvm8di */

        case 13:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2122; /* pred_strided_load_widthwrvvm4di */

        case 14:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2128; /* pred_strided_load_widthwrvvm2di */

        case 15:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2134; /* pred_strided_load_widthwrvvm1di */

        case 16:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2140; /* pred_strided_load_widthwrvvmf8qi */

        case 17:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2146; /* pred_strided_load_widthwrvvmf4hi */

        case 18:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2152; /* pred_strided_load_widthwrvvmf2si */

        default:
          return -1;
        }

    case 185:
      switch (pattern476 (x2, 
185))
        {
        case 0:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2045; /* pred_strided_load_widthwurvvm8qi */

        case 1:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2051; /* pred_strided_load_widthwurvvm4qi */

        case 2:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2057; /* pred_strided_load_widthwurvvm2qi */

        case 3:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2063; /* pred_strided_load_widthwurvvm1qi */

        case 4:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2069; /* pred_strided_load_widthwurvvm8hi */

        case 5:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2075; /* pred_strided_load_widthwurvvm4hi */

        case 6:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2081; /* pred_strided_load_widthwurvvm2hi */

        case 7:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2087; /* pred_strided_load_widthwurvvm1hi */

        case 8:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2093; /* pred_strided_load_widthwurvvm8si */

        case 9:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2099; /* pred_strided_load_widthwurvvm4si */

        case 10:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2105; /* pred_strided_load_widthwurvvm2si */

        case 11:
          if (!
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2111; /* pred_strided_load_widthwurvvm1si */

        case 12:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2117; /* pred_strided_load_widthwurvvm8di */

        case 13:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2123; /* pred_strided_load_widthwurvvm4di */

        case 14:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2129; /* pred_strided_load_widthwurvvm2di */

        case 15:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2135; /* pred_strided_load_widthwurvvm1di */

        case 16:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2141; /* pred_strided_load_widthwurvvmf8qi */

        case 17:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2147; /* pred_strided_load_widthwurvvmf4hi */

        case 18:
          if (!(
#line 270 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2153; /* pred_strided_load_widthwurvvmf2si */

        default:
          return -1;
        }

    case 186:
      switch (pattern478 (x2, 
186))
        {
        case 0:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2211; /* pred_indexed_load_widthbrvvm8qi */

        case 1:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2217; /* pred_indexed_load_widthbrvvm4qi */

        case 2:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2223; /* pred_indexed_load_widthbrvvm2qi */

        case 3:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2229; /* pred_indexed_load_widthbrvvm1qi */

        case 4:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2235; /* pred_indexed_load_widthbrvvm8hi */

        case 5:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2241; /* pred_indexed_load_widthbrvvm4hi */

        case 6:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2247; /* pred_indexed_load_widthbrvvm2hi */

        case 7:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2253; /* pred_indexed_load_widthbrvvm1hi */

        case 8:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2259; /* pred_indexed_load_widthbrvvm8si */

        case 9:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2265; /* pred_indexed_load_widthbrvvm4si */

        case 10:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2271; /* pred_indexed_load_widthbrvvm2si */

        case 11:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2277; /* pred_indexed_load_widthbrvvm1si */

        case 12:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2283; /* pred_indexed_load_widthbrvvm8di */

        case 13:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2289; /* pred_indexed_load_widthbrvvm4di */

        case 14:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2295; /* pred_indexed_load_widthbrvvm2di */

        case 15:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2301; /* pred_indexed_load_widthbrvvm1di */

        case 16:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2307; /* pred_indexed_load_widthbrvvmf8qi */

        case 17:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2313; /* pred_indexed_load_widthbrvvmf4hi */

        case 18:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2319; /* pred_indexed_load_widthbrvvmf2si */

        default:
          return -1;
        }

    case 187:
      switch (pattern478 (x2, 
187))
        {
        case 0:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2212; /* pred_indexed_load_widthburvvm8qi */

        case 1:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2218; /* pred_indexed_load_widthburvvm4qi */

        case 2:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2224; /* pred_indexed_load_widthburvvm2qi */

        case 3:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2230; /* pred_indexed_load_widthburvvm1qi */

        case 4:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2236; /* pred_indexed_load_widthburvvm8hi */

        case 5:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2242; /* pred_indexed_load_widthburvvm4hi */

        case 6:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2248; /* pred_indexed_load_widthburvvm2hi */

        case 7:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2254; /* pred_indexed_load_widthburvvm1hi */

        case 8:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2260; /* pred_indexed_load_widthburvvm8si */

        case 9:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2266; /* pred_indexed_load_widthburvvm4si */

        case 10:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2272; /* pred_indexed_load_widthburvvm2si */

        case 11:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2278; /* pred_indexed_load_widthburvvm1si */

        case 12:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2284; /* pred_indexed_load_widthburvvm8di */

        case 13:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2290; /* pred_indexed_load_widthburvvm4di */

        case 14:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2296; /* pred_indexed_load_widthburvvm2di */

        case 15:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2302; /* pred_indexed_load_widthburvvm1di */

        case 16:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2308; /* pred_indexed_load_widthburvvmf8qi */

        case 17:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2314; /* pred_indexed_load_widthburvvmf4hi */

        case 18:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2320; /* pred_indexed_load_widthburvvmf2si */

        default:
          return -1;
        }

    case 188:
      switch (pattern478 (x2, 
188))
        {
        case 0:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2213; /* pred_indexed_load_widthhrvvm8qi */

        case 1:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2219; /* pred_indexed_load_widthhrvvm4qi */

        case 2:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2225; /* pred_indexed_load_widthhrvvm2qi */

        case 3:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2231; /* pred_indexed_load_widthhrvvm1qi */

        case 4:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2237; /* pred_indexed_load_widthhrvvm8hi */

        case 5:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2243; /* pred_indexed_load_widthhrvvm4hi */

        case 6:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2249; /* pred_indexed_load_widthhrvvm2hi */

        case 7:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2255; /* pred_indexed_load_widthhrvvm1hi */

        case 8:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2261; /* pred_indexed_load_widthhrvvm8si */

        case 9:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2267; /* pred_indexed_load_widthhrvvm4si */

        case 10:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2273; /* pred_indexed_load_widthhrvvm2si */

        case 11:
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2279; /* pred_indexed_load_widthhrvvm1si */

        case 12:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2285; /* pred_indexed_load_widthhrvvm8di */

        case 13:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2291; /* pred_indexed_load_widthhrvvm4di */

        case 14:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2297; /* pred_indexed_load_widthhrvvm2di */

        case 15:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2303; /* pred_indexed_load_widthhrvvm1di */

        case 16:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2309; /* pred_indexed_load_widthhrvvmf8qi */

        case 17:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2315; /* pred_indexed_load_widthhrvvmf4hi */

        case 18:
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2321; /* pred_indexed_load_widthhrvvmf2si */

        default:
          return -1;
        }

    case 189:
      return recog_930 (x1, insn, pnum_clobbers);

    case 190:
      return recog_929 (x1, insn, pnum_clobbers);

    case 191:
      return recog_928 (x1, insn, pnum_clobbers);

    case 93:
      return recog_921 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_104 (x1, insn, pnum_clobbers);

    case 1:
      return recog_106 (x1, insn, pnum_clobbers);

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 6:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern389 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return -1;
              return 262; /* tls_add_tp_lesi */

            case E_DImode:
              if (pattern389 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return -1;
              return 263; /* tls_add_tp_ledi */

            default:
              return -1;
            }

        case 10:
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern390 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return -1;
              return 270; /* auipcsi */

            case E_DImode:
              if (pattern390 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return -1;
              return 271; /* auipcdi */

            default:
              return -1;
            }

        case 51:
          if (pattern252 (x2) != 0
              || !
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKND && !TARGET_64BIT))
            return -1;
          return 683; /* riscv_aes32dsi */

        case 52:
          if (pattern252 (x2) != 0
              || !
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKND && !TARGET_64BIT))
            return -1;
          return 684; /* riscv_aes32dsmi */

        case 60:
          if (pattern252 (x2) != 0
              || !
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNE && !TARGET_64BIT))
            return -1;
          return 690; /* riscv_aes32esi */

        case 61:
          if (pattern252 (x2) != 0
              || !
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNE && !TARGET_64BIT))
            return -1;
          return 691; /* riscv_aes32esmi */

        case 78:
          if (pattern252 (x2) != 0
              || !
#line 499 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSED && !TARGET_64BIT))
            return -1;
          return 716; /* *riscv_sm4ed_si */

        case 79:
          if (pattern252 (x2) != 0
              || !
#line 499 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSED && !TARGET_64BIT))
            return -1;
          return 717; /* *riscv_sm4ks_si */

        case 104:
          return recog_86 (x1, insn, pnum_clobbers);

        case 105:
          return recog_88 (x1, insn, pnum_clobbers);

        case 142:
          return recog_87 (x1, insn, pnum_clobbers);

        case 136:
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 6
              || XINT (x4, 1) != 93
              || pattern361 (x4) != 0)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[3] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[4] = x8;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[5] = x9;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return -1;
          x10 = XVECEXP (x4, 0, 3);
          operands[6] = x10;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[1] = x6;
          return recog_85 (x1, insn, pnum_clobbers);

        case 234:
          if (pattern255 (x2) != 0
              || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33944; /* riscv_cv_simd_add_h_si */

        case 238:
          if (pattern255 (x2) != 0
              || !
#line 929 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33948; /* riscv_cv_simd_sub_h_si */

        case 298:
          if (pattern256 (x2) != 0
              || !
#line 1639 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34008; /* riscv_cv_simd_insert_h_si */

        case 299:
          if (pattern256 (x2) != 0
              || !
#line 1651 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34009; /* riscv_cv_simd_insert_b_si */

        case 312:
          if (pattern257 (x2) != 0
              || !
#line 1808 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34022; /* riscv_cv_simd_sdotup_h_si */

        case 313:
          if (pattern257 (x2) != 0
              || !
#line 1820 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34023; /* riscv_cv_simd_sdotup_b_si */

        case 314:
          if (pattern258 (x2, 
E_HImode) != 0
              || !
#line 1832 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34024; /* riscv_cv_simd_sdotup_sc_h_si */

        case 315:
          if (pattern258 (x2, 
E_QImode) != 0
              || !
#line 1846 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34025; /* riscv_cv_simd_sdotup_sc_b_si */

        case 316:
          if (pattern257 (x2) != 0
              || !
#line 1860 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34026; /* riscv_cv_simd_sdotusp_h_si */

        case 317:
          if (pattern257 (x2) != 0
              || !
#line 1872 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34027; /* riscv_cv_simd_sdotusp_b_si */

        case 318:
          if (pattern259 (x2, 
E_HImode) != 0
              || !
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34028; /* riscv_cv_simd_sdotusp_sc_h_si */

        case 319:
          if (pattern259 (x2, 
E_QImode) != 0
              || !
#line 1898 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34029; /* riscv_cv_simd_sdotusp_sc_b_si */

        case 320:
          if (pattern257 (x2) != 0
              || !
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34030; /* riscv_cv_simd_sdotsp_h_si */

        case 321:
          if (pattern257 (x2) != 0
              || !
#line 1924 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34031; /* riscv_cv_simd_sdotsp_b_si */

        case 322:
          if (pattern259 (x2, 
E_HImode) != 0
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34032; /* riscv_cv_simd_sdotsp_sc_h_si */

        case 323:
          if (pattern259 (x2, 
E_QImode) != 0
              || !
#line 1950 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34033; /* riscv_cv_simd_sdotsp_sc_b_si */

        case 328:
          if (pattern257 (x2) != 0
              || !
#line 2013 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34038; /* riscv_cv_simd_shuffle2_h_si */

        case 329:
          if (pattern257 (x2) != 0
              || !
#line 2025 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34039; /* riscv_cv_simd_shuffle2_b_si */

        case 332:
          if (pattern257 (x2) != 0
              || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34042; /* riscv_cv_simd_packhi_b_si */

        case 333:
          if (pattern257 (x2) != 0
              || !
#line 2071 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34043; /* riscv_cv_simd_packlo_b_si */

        case 377:
          if (pattern255 (x2) != 0
              || !
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 34087; /* riscv_cv_simd_subrotmj_si */

        default:
          return -1;
        }

    case 5:
      switch (XINT (x2, 1))
        {
        case 195:
          if (pattern181 (x2) != 0)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!vector_length_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          return recog_89 (x1, insn, pnum_clobbers);

        case 91:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern391 (x2))
            {
            case 0:
              if (!(
#line 1784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 3647; /* vsetvlsi_no_side_effects */

            case 1:
              if (!(
#line 1784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 3648; /* vsetvldi_no_side_effects */

            default:
              return -1;
            }

        case 96:
          return recog_92 (x1, insn, pnum_clobbers);

        case 145:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern335 (x2))
            {
            case 0:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28239; /* mask_len_fold_left_plus_rvvm8hf */

            case 1:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28240; /* mask_len_fold_left_plus_rvvm4hf */

            case 2:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28241; /* mask_len_fold_left_plus_rvvm2hf */

            case 3:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28242; /* mask_len_fold_left_plus_rvvm1hf */

            case 4:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28243; /* mask_len_fold_left_plus_rvvmf2hf */

            case 5:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 28244; /* mask_len_fold_left_plus_rvvmf4hf */

            case 6:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28245; /* mask_len_fold_left_plus_rvvm8sf */

            case 7:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28246; /* mask_len_fold_left_plus_rvvm4sf */

            case 8:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28247; /* mask_len_fold_left_plus_rvvm2sf */

            case 9:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28248; /* mask_len_fold_left_plus_rvvm1sf */

            case 10:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 28249; /* mask_len_fold_left_plus_rvvmf2sf */

            case 11:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28250; /* mask_len_fold_left_plus_rvvm8df */

            case 12:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28251; /* mask_len_fold_left_plus_rvvm4df */

            case 13:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28252; /* mask_len_fold_left_plus_rvvm2df */

            case 14:
              if (!(
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28253; /* mask_len_fold_left_plus_rvvm1df */

            case 15:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31280; /* *mask_len_fold_left_widen_plus_rvvm4hf */

            case 16:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31281; /* *mask_len_fold_left_widen_plus_rvvm2hf */

            case 17:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31282; /* *mask_len_fold_left_widen_plus_rvvm1hf */

            case 18:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31283; /* *mask_len_fold_left_widen_plus_rvvmf2hf */

            case 19:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31284; /* *mask_len_fold_left_widen_plus_rvvmf4hf */

            case 20:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 31289; /* *mask_len_fold_left_widen_plus_v1hf */

            case 21:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 31290; /* *mask_len_fold_left_widen_plus_v2hf */

            case 22:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 31291; /* *mask_len_fold_left_widen_plus_v4hf */

            case 23:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 31292; /* *mask_len_fold_left_widen_plus_v8hf */

            case 24:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 31293; /* *mask_len_fold_left_widen_plus_v16hf */

            case 25:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31294; /* *mask_len_fold_left_widen_plus_v32hf */

            case 26:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31295; /* *mask_len_fold_left_widen_plus_v64hf */

            case 27:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31296; /* *mask_len_fold_left_widen_plus_v128hf */

            case 28:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31297; /* *mask_len_fold_left_widen_plus_v256hf */

            case 29:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31298; /* *mask_len_fold_left_widen_plus_v512hf */

            case 30:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31299; /* *mask_len_fold_left_widen_plus_v1024hf */

            case 31:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31285; /* *mask_len_fold_left_widen_plus_rvvm4sf */

            case 32:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31286; /* *mask_len_fold_left_widen_plus_rvvm2sf */

            case 33:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31287; /* *mask_len_fold_left_widen_plus_rvvm1sf */

            case 34:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31288; /* *mask_len_fold_left_widen_plus_rvvmf2sf */

            case 35:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31300; /* *mask_len_fold_left_widen_plus_v1sf */

            case 36:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31301; /* *mask_len_fold_left_widen_plus_v2sf */

            case 37:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31302; /* *mask_len_fold_left_widen_plus_v4sf */

            case 38:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31303; /* *mask_len_fold_left_widen_plus_v8sf */

            case 39:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31304; /* *mask_len_fold_left_widen_plus_v16sf */

            case 40:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31305; /* *mask_len_fold_left_widen_plus_v32sf */

            case 41:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31306; /* *mask_len_fold_left_widen_plus_v64sf */

            case 42:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31307; /* *mask_len_fold_left_widen_plus_v128sf */

            case 43:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31308; /* *mask_len_fold_left_widen_plus_v256sf */

            case 44:
              if (!(
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31309; /* *mask_len_fold_left_widen_plus_v512sf */

            default:
              return -1;
            }

        case 171:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern363 (x2))
            {
            case 0:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28254; /* vcond_mask_len_rvvmf64bi */

            case 1:
              if (!
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()))
                return -1;
              return 28255; /* vcond_mask_len_rvvmf32bi */

            case 2:
              if (!
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()))
                return -1;
              return 28256; /* vcond_mask_len_rvvmf16bi */

            case 3:
              if (!
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()))
                return -1;
              return 28257; /* vcond_mask_len_rvvmf8bi */

            case 4:
              if (!
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()))
                return -1;
              return 28258; /* vcond_mask_len_rvvmf4bi */

            case 5:
              if (!
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()))
                return -1;
              return 28259; /* vcond_mask_len_rvvmf2bi */

            case 6:
              if (!
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()))
                return -1;
              return 28260; /* vcond_mask_len_rvvm1bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      return recog_105 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_109 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              switch (pattern230 (x3))
                {
                case 0:
                  if (!(
#line 2992 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 324; /* ior_shift_reversesi */

                case 1:
                  if (!(
#line 2992 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 327; /* ior_shift_reversedi */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern413 (x3, 
E_HImode, 
E_SImode) != 0
                      || !(
#line 116 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && INTVAL (operands[2]) == BITS_PER_WORD / 2) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 669; /* riscv_xpack_si_hi_2 */

                case E_DImode:
                  if (pattern413 (x3, 
E_SImode, 
E_DImode) != 0
                      || !(
#line 116 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && INTVAL (operands[2]) == BITS_PER_WORD / 2) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 670; /* riscv_xpack_di_si_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (pattern292 (x3))
            {
            case 0:
              if ((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 578; /* *bsetsi */
              break;

            case 1:
              if ((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 580; /* *bsetdi */
              break;

            default:
              break;
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern336 (x3))
            {
            case 0:
              if (!(
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 582; /* *bsetsi_mask */

            case 1:
              if (!(
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 584; /* *bsetdi_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern293 (x3, 
E_SImode) != 0
                  || !(
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 516; /* ior_notsi3 */

            case E_DImode:
              if (pattern293 (x3, 
E_DImode) != 0
                  || !(
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 518; /* ior_notdi3 */

            case E_RVVMF64BImode:
              if (pattern294 (x3, 
E_RVVMF64BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32106; /* *iornotrvvmf64bi */

            case E_RVVMF32BImode:
              if (pattern294 (x3, 
E_RVVMF32BImode) != 0
                  || !
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 32108; /* *iornotrvvmf32bi */

            case E_RVVMF16BImode:
              if (pattern294 (x3, 
E_RVVMF16BImode) != 0
                  || !
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 32110; /* *iornotrvvmf16bi */

            case E_RVVMF8BImode:
              if (pattern294 (x3, 
E_RVVMF8BImode) != 0
                  || !
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 32112; /* *iornotrvvmf8bi */

            case E_RVVMF4BImode:
              if (pattern294 (x3, 
E_RVVMF4BImode) != 0
                  || !
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 32114; /* *iornotrvvmf4bi */

            case E_RVVMF2BImode:
              if (pattern294 (x3, 
E_RVVMF2BImode) != 0
                  || !
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 32116; /* *iornotrvvmf2bi */

            case E_RVVM1BImode:
              if (pattern294 (x3, 
E_RVVM1BImode) != 0
                  || !
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 32118; /* *iornotrvvm1bi */

            case E_V1BImode:
              if (pattern294 (x3, 
E_V1BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
                return -1;
              return 32120; /* *iornotv1bi */

            case E_V2BImode:
              if (pattern294 (x3, 
E_V2BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
                return -1;
              return 32122; /* *iornotv2bi */

            case E_V4BImode:
              if (pattern294 (x3, 
E_V4BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
                return -1;
              return 32124; /* *iornotv4bi */

            case E_V8BImode:
              if (pattern294 (x3, 
E_V8BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
                return -1;
              return 32126; /* *iornotv8bi */

            case E_V16BImode:
              if (pattern294 (x3, 
E_V16BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
                return -1;
              return 32128; /* *iornotv16bi */

            case E_V32BImode:
              if (pattern294 (x3, 
E_V32BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
                return -1;
              return 32130; /* *iornotv32bi */

            case E_V64BImode:
              if (pattern294 (x3, 
E_V64BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 32132; /* *iornotv64bi */

            case E_V128BImode:
              if (pattern294 (x3, 
E_V128BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 32134; /* *iornotv128bi */

            case E_V256BImode:
              if (pattern294 (x3, 
E_V256BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 32136; /* *iornotv256bi */

            case E_V512BImode:
              if (pattern294 (x3, 
E_V512BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 32138; /* *iornotv512bi */

            case E_V1024BImode:
              if (pattern294 (x3, 
E_V1024BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 32140; /* *iornotv1024bi */

            case E_V2048BImode:
              if (pattern294 (x3, 
E_V2048BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 32142; /* *iornotv2048bi */

            case E_V4096BImode:
              if (pattern294 (x3, 
E_V4096BImode) != 0
                  || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 32144; /* *iornotv4096bi */

            default:
              return -1;
            }

        case CONST_INT:
          switch (pattern264 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 520; /* *ior_not_constsi */

            case 1:
              if (!(
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 522; /* *ior_not_constdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern199 (x3, pnum_clobbers))
        {
        case 0:
          if ((
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 595; /* *bitmanip.md:673 */
            }
          if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 599; /* *bitmanip.md:673 */

        case 1:
          if ((
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 603; /* *bitmanip.md:699 */
            }
          if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 607; /* *bitmanip.md:699 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern199 (x3, pnum_clobbers))
        {
        case 0:
          if ((
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 597; /* *bitmanip.md:673 */
            }
          if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 601; /* *bitmanip.md:673 */

        case 1:
          if ((
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 605; /* *bitmanip.md:699 */
            }
          if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 609; /* *bitmanip.md:699 */

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 65280L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern433 (x3, 
E_SImode) != 0
              || !(
#line 148 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 675; /* *riscv_packh_si_3 */

        case E_DImode:
          if (pattern433 (x3, 
E_DImode) != 0
              || !(
#line 148 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 676; /* *riscv_packh_di_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1498 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 1416 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 39; /* *umodsi3 */

    case 1:
      if (!
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 43; /* umoddi3 */

    case 2:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24554; /* umodrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24568; /* umodrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24582; /* umodrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24596; /* umodrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24610; /* umodrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24624; /* umodrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24638; /* umodrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24652; /* umodrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24666; /* umodrvvm8si3 */

    case 11:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24680; /* umodrvvm4si3 */

    case 12:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24694; /* umodrvvm2si3 */

    case 13:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24708; /* umodrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24722; /* umodrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24736; /* umodrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24750; /* umodrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24764; /* umodrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24778; /* umodrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24792; /* umodrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24806; /* umodrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24820; /* umodrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24834; /* umodrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24848; /* umodrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24862; /* umodv1qi3 */

    case 25:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24876; /* umodv2qi3 */

    case 26:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24890; /* umodv4qi3 */

    case 27:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24904; /* umodv8qi3 */

    case 28:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24918; /* umodv16qi3 */

    case 29:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24932; /* umodv32qi3 */

    case 30:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24946; /* umodv64qi3 */

    case 31:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24960; /* umodv128qi3 */

    case 32:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24974; /* umodv256qi3 */

    case 33:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24988; /* umodv512qi3 */

    case 34:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25002; /* umodv1024qi3 */

    case 35:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25016; /* umodv2048qi3 */

    case 36:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25030; /* umodv4096qi3 */

    case 37:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25044; /* umodv1hi3 */

    case 38:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25058; /* umodv2hi3 */

    case 39:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25072; /* umodv4hi3 */

    case 40:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25086; /* umodv8hi3 */

    case 41:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25100; /* umodv16hi3 */

    case 42:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25114; /* umodv32hi3 */

    case 43:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25128; /* umodv64hi3 */

    case 44:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25142; /* umodv128hi3 */

    case 45:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25156; /* umodv256hi3 */

    case 46:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25170; /* umodv512hi3 */

    case 47:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25184; /* umodv1024hi3 */

    case 48:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25198; /* umodv2048hi3 */

    case 49:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25212; /* umodv1si3 */

    case 50:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25226; /* umodv2si3 */

    case 51:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25240; /* umodv4si3 */

    case 52:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25254; /* umodv8si3 */

    case 53:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25268; /* umodv16si3 */

    case 54:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25282; /* umodv32si3 */

    case 55:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25296; /* umodv64si3 */

    case 56:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25310; /* umodv128si3 */

    case 57:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25324; /* umodv256si3 */

    case 58:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25338; /* umodv512si3 */

    case 59:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25352; /* umodv1024si3 */

    case 60:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25366; /* umodv1di3 */

    case 61:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25380; /* umodv2di3 */

    case 62:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25394; /* umodv4di3 */

    case 63:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25408; /* umodv8di3 */

    case 64:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25422; /* umodv16di3 */

    case 65:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25436; /* umodv32di3 */

    case 66:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25450; /* umodv64di3 */

    case 67:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25464; /* umodv128di3 */

    case 68:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25478; /* umodv256di3 */

    case 69:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25492; /* umodv512di3 */

    default:
      return -1;
    }
}

 int
recog_1507 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!(
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 51; /* sqrtsf2 */

    case 1:
      if (!(
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 52; /* sqrtdf2 */

    case 2:
      if (!(
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 53; /* sqrthf2 */

    case 3:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27131; /* sqrtrvvm8hf2 */

    case 4:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27132; /* sqrtrvvm4hf2 */

    case 5:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27133; /* sqrtrvvm2hf2 */

    case 6:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27134; /* sqrtrvvm1hf2 */

    case 7:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27135; /* sqrtrvvmf2hf2 */

    case 8:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27136; /* sqrtrvvmf4hf2 */

    case 9:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27137; /* sqrtrvvm8sf2 */

    case 10:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27138; /* sqrtrvvm4sf2 */

    case 11:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27139; /* sqrtrvvm2sf2 */

    case 12:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27140; /* sqrtrvvm1sf2 */

    case 13:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27141; /* sqrtrvvmf2sf2 */

    case 14:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27142; /* sqrtrvvm8df2 */

    case 15:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27143; /* sqrtrvvm4df2 */

    case 16:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27144; /* sqrtrvvm2df2 */

    case 17:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27145; /* sqrtrvvm1df2 */

    case 18:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27146; /* sqrtv1hf2 */

    case 19:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27147; /* sqrtv2hf2 */

    case 20:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27148; /* sqrtv4hf2 */

    case 21:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27149; /* sqrtv8hf2 */

    case 22:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27150; /* sqrtv16hf2 */

    case 23:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27151; /* sqrtv32hf2 */

    case 24:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27152; /* sqrtv64hf2 */

    case 25:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27153; /* sqrtv128hf2 */

    case 26:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27154; /* sqrtv256hf2 */

    case 27:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27155; /* sqrtv512hf2 */

    case 28:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27156; /* sqrtv1024hf2 */

    case 29:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27157; /* sqrtv2048hf2 */

    case 30:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27158; /* sqrtv1sf2 */

    case 31:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27159; /* sqrtv2sf2 */

    case 32:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27160; /* sqrtv4sf2 */

    case 33:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27161; /* sqrtv8sf2 */

    case 34:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27162; /* sqrtv16sf2 */

    case 35:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27163; /* sqrtv32sf2 */

    case 36:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27164; /* sqrtv64sf2 */

    case 37:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27165; /* sqrtv128sf2 */

    case 38:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27166; /* sqrtv256sf2 */

    case 39:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27167; /* sqrtv512sf2 */

    case 40:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27168; /* sqrtv1024sf2 */

    case 41:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27169; /* sqrtv1df2 */

    case 42:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27170; /* sqrtv2df2 */

    case 43:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27171; /* sqrtv4df2 */

    case 44:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27172; /* sqrtv8df2 */

    case 45:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27173; /* sqrtv16df2 */

    case 46:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27174; /* sqrtv32df2 */

    case 47:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27175; /* sqrtv64df2 */

    case 48:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27176; /* sqrtv128df2 */

    case 49:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27177; /* sqrtv256df2 */

    case 50:
      if (!(
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27178; /* sqrtv512df2 */

    default:
      return -1;
    }
}

 int
recog_1521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_MODE (x7))
    {
    case E_SImode:
      if (!
#line 3778 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(is_zicfilp_p ()))
        return -1;
      return 446; /* tablejump_cfisi */

    case E_DImode:
      if (!(
#line 3778 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(is_zicfilp_p ()) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 447; /* tablejump_cfidi */

    default:
      return -1;
    }
}

 int
recog_1522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (pattern330 (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 2)
    return -1;
  x8 = XEXP (x5, 1);
  operands[0] = x8;
  if (!stack_push_up_to_ra_operand (operands[0], E_VOIDmode))
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 1);
  switch (XWINT (x10, 0))
    {
    case -4L:
      if (pattern551 (x1, 
E_SImode) != 0
          || !(
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 33877; /* gpr_multi_push_up_to_ra_si */

    case -8L:
      if (pattern551 (x1, 
E_DImode) != 0
          || !(
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 33878; /* gpr_multi_push_up_to_ra_di */

    default:
      return -1;
    }
}

 int
recog_1524 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 9:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 10)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 5)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || !symbolic_operand (operands[0], E_SImode)
                  || GET_MODE (x6) != E_SImode
                  || !(
#line 2400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 268; /* tlsdescsi */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !symbolic_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || !(
#line 2400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 269; /* tlsdescdi */

            default:
              return -1;
            }

        case 41:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern422 (x3, 
E_SImode) != 0)
                return -1;
              return 475; /* stack_protect_set_si */

            case E_DImode:
              if (pattern422 (x3, 
E_DImode) != 0
                  || !
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 476; /* stack_protect_set_di */

            default:
              return -1;
            }

        case 90:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          if (
#line 28 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
            return 787; /* mem_thread_fence_rvwmo */
          if (!
#line 28 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
            return -1;
          return 796; /* mem_thread_fence_ztso */

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 42)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x9 = XVECEXP (x3, 0, 1);
      operands[2] = x9;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern423 (x3, 
E_SImode) != 0)
            return -1;
          return 477; /* stack_protect_test_si */

        case E_DImode:
          if (pattern423 (x3, 
E_DImode) != 0
              || !
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 478; /* stack_protect_test_di */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 91
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 66
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 4
          || XINT (x8, 1) != 91
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[0] = x7;
      x9 = XVECEXP (x3, 0, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x8, 0, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XVECEXP (x8, 0, 3);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x8, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      if (vector_length_operand (operands[0], E_SImode)
          && (
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return 3645; /* vsetvl_discard_resultsi */
      if (!vector_length_operand (operands[0], E_DImode)
          || !(
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 3646; /* vsetvl_discard_resultdi */

    default:
      return -1;
    }
}

 int
recog_1527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case IF_THEN_ELSE:
          if (pattern225 (x2) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x3, 0);
          x7 = XEXP (x6, 0);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          switch (pattern429 (x1))
            {
            case 0:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 345; /* *branchqi_shiftedarith_eq_shifted */
              break;

            case 1:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 353; /* *branchqi_shiftedarith_eq_shifted */
              break;

            case 2:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 347; /* *branchhi_shiftedarith_eq_shifted */
              break;

            case 3:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 355; /* *branchhi_shiftedarith_eq_shifted */
              break;

            case 4:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 349; /* *branchsi_shiftedarith_eq_shifted */
              break;

            case 5:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 357; /* *branchsi_shiftedarith_eq_shifted */
              break;

            case 6:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                return 351; /* *branchdi_shiftedarith_eq_shifted */
              break;

            case 7:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 359; /* *branchdi_shiftedarith_eq_shifted */
              break;

            case 8:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 346; /* *branchqi_shiftedarith_ne_shifted */
              break;

            case 9:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 354; /* *branchqi_shiftedarith_ne_shifted */
              break;

            case 10:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 348; /* *branchhi_shiftedarith_ne_shifted */
              break;

            case 11:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 356; /* *branchhi_shiftedarith_ne_shifted */
              break;

            case 12:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 350; /* *branchsi_shiftedarith_ne_shifted */
              break;

            case 13:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 358; /* *branchsi_shiftedarith_ne_shifted */
              break;

            case 14:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                return 352; /* *branchdi_shiftedarith_ne_shifted */
              break;

            case 15:
              if ((
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 360; /* *branchdi_shiftedarith_ne_shifted */
              break;

            default:
              break;
            }
          operands[1] = x6;
          switch (pattern431 (x1))
            {
            case 0:
              if (!(
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 651; /* *branchsi_mask_twobits_equals_singlebit */

            case 1:
              if (!(
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 652; /* *branchdi_mask_twobits_equals_singlebit */

            default:
              return -1;
            }

        case CALL:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode
              || pattern273 (x1) != 0)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x4 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x4, 0);
          x12 = XVECEXP (x11, 0, 0);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          return 457; /* call_value_internal */

        case SUBREG:
        case MEM:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          switch (pattern374 (x4))
            {
            case 0:
              switch (XINT (x13, 1))
                {
                case 82:
                  x5 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x14 = XEXP (x5, 0);
                  operands[4] = x14;
                  x15 = XVECEXP (x13, 0, 0);
                  switch (GET_CODE (x15))
                    {
                    case PLUS:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 752; /* lrsc_atomic_fetch_addsi */

                        case 1:
                          if (!(
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 756; /* lrsc_atomic_fetch_adddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 753; /* lrsc_atomic_fetch_orsi */

                        case 1:
                          if (!(
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 757; /* lrsc_atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 754; /* lrsc_atomic_fetch_xorsi */

                        case 1:
                          if (!(
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 758; /* lrsc_atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 755; /* lrsc_atomic_fetch_andsi */

                        case 1:
                          if (!(
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 759; /* lrsc_atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 86:
                  if (pnum_clobbers == NULL
                      || GET_MODE (x13) != E_SImode
                      || !register_operand (operands[0], E_SImode)
                      || !memory_operand (operands[1], E_SImode))
                    return -1;
                  x15 = XVECEXP (x13, 0, 0);
                  operands[2] = x15;
                  if (!reg_or_0_operand (operands[2], E_SImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 2);
                  operands[4] = x5;
                  if (!reg_or_0_operand (operands[4], E_SImode)
                      || !
#line 493 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 779; /* subword_atomic_exchange_strong */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              x16 = XVECEXP (x13, 0, 1);
              operands[3] = x16;
              x17 = XVECEXP (x13, 0, 2);
              operands[4] = x17;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x18 = XVECEXP (x13, 0, 3);
              operands[5] = x18;
              if (!const_int_operand (operands[5], E_SImode))
                return -1;
              x14 = XEXP (x5, 0);
              operands[6] = x14;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern552 (x13, 
E_SImode) != 0
                      || !
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZALRSC))
                    return -1;
                  return 780; /* zalrsc_atomic_cas_value_strongsi */

                case E_DImode:
                  if (pattern552 (x13, 
E_DImode) != 0
                      || !(
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 781; /* zalrsc_atomic_cas_value_strongdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 2
              || XINT (x3, 1) != 85)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x19 = XVECEXP (x3, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x3, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          x14 = XEXP (x5, 0);
          operands[4] = x14;
          x11 = XEXP (x4, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern462 (x3, 
E_SImode) != 0
                  || !
#line 410 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                return -1;
              return 775; /* lrsc_atomic_exchangesi */

            case E_DImode:
              if (pattern462 (x3, 
E_DImode) != 0
                  || !(
#line 410 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 776; /* lrsc_atomic_exchangedi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 5
              || XINT (x3, 1) != 91)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 3
              || XINT (x13, 1) != 91
              || GET_MODE (x13) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 66
              || GET_MODE (x11) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != UNSPEC
              || XVECLEN (x21, 0) != 4
              || XINT (x21, 1) != 91
              || GET_MODE (x21) != E_SImode)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 67
              || GET_MODE (x14) != E_SImode)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x19 = XVECEXP (x3, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x3, 0, 1);
          operands[2] = x20;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x22 = XVECEXP (x3, 0, 2);
          operands[3] = x22;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          operands[4] = x23;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          operands[5] = x24;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x15, operands[1]))
            return -1;
          x16 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x16, operands[2]))
            return -1;
          x17 = XVECEXP (x13, 0, 2);
          if (!rtx_equal_p (x17, operands[3]))
            return -1;
          x25 = XVECEXP (x21, 0, 0);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XVECEXP (x21, 0, 1);
          if (!rtx_equal_p (x26, operands[3]))
            return -1;
          x27 = XVECEXP (x21, 0, 2);
          if (!rtx_equal_p (x27, operands[4]))
            return -1;
          x28 = XVECEXP (x21, 0, 3);
          if (!rtx_equal_p (x28, operands[5]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vector_length_operand (operands[1], E_SImode)
                  || !(
#line 1725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 3642; /* vsetvlsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !vector_length_operand (operands[1], E_DImode)
                  || !(
#line 1725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 3643; /* vsetvldi */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG
              || pattern271 (x1, 
8) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != MEM)
            return -1;
          x29 = XEXP (x21, 0);
          if (GET_CODE (x29) != PLUS)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 2)
            return -1;
          x31 = XEXP (x29, 1);
          if (GET_CODE (x31) != CONST_INT)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 1)
            return -1;
          x10 = XEXP (x3, 1);
          operands[0] = x10;
          if (!stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x4, 1);
          x32 = XEXP (x13, 0);
          x33 = XEXP (x32, 1);
          switch (XWINT (x33, 0))
            {
            case -4L:
              if (XWINT (x31, 0) != -8L
                  || pattern695 (x1, 
E_SImode) != 0
                  || !(
#line 42 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33807; /* gpr_multi_pop_up_to_s0_si */

            case -8L:
              if (XWINT (x31, 0) != -16L
                  || pattern695 (x1, 
E_DImode) != 0
                  || !(
#line 42 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33808; /* gpr_multi_pop_up_to_s0_di */

            default:
              return -1;
            }

        case REG:
          if (pattern226 (x1, 
8) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern418 (x4, 
1) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != PLUS)
            return -1;
          x29 = XEXP (x21, 0);
          if (GET_CODE (x29) != REG
              || REGNO (x29) != 2)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 2)
            return -1;
          x34 = XEXP (x21, 1);
          operands[0] = x34;
          if (!stack_push_up_to_s0_operand (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x2, 0);
          x35 = XEXP (x9, 0);
          x36 = XEXP (x35, 1);
          switch (XWINT (x36, 0))
            {
            case -4L:
              x11 = XEXP (x4, 0);
              x37 = XEXP (x11, 0);
              x38 = XEXP (x37, 1);
              if (XWINT (x38, 0) != -8L
                  || pattern696 (x1, 
E_SImode) != 0
                  || !(
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33879; /* gpr_multi_push_up_to_s0_si */

            case -8L:
              x11 = XEXP (x4, 0);
              x37 = XEXP (x11, 0);
              x38 = XEXP (x37, 1);
              if (XWINT (x38, 0) != -16L
                  || pattern696 (x1, 
E_DImode) != 0
                  || !(
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33880; /* gpr_multi_push_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode
          || pattern273 (x1) != 0)
        return -1;
      x35 = XEXP (x9, 0);
      operands[0] = x35;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x4, 0);
      x12 = XVECEXP (x11, 0, 0);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      return 456; /* call_internal */

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x4, 0);
      operands[0] = x11;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      return 462; /* gpr_restore_return */

    default:
      return -1;
    }
}

 int
recog_1540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  if (pattern115 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (pattern432 (x1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 8);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || pattern759 (x2) != 0)
        return -1;
      x12 = XEXP (x3, 0);
      if (GET_CODE (x12) != REG)
        return -1;
      x13 = XEXP (x5, 1);
      operands[0] = x13;
      switch (pattern766 (x1))
        {
        case 0:
          switch (pattern773 (x1, 
E_SImode))
            {
            case 0:
              if (pattern795 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern800 (x1, 
E_SImode, 
SET, 
9) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 12);
              x15 = XEXP (x14, 1);
              if (pattern802 (x15) != 0)
                return -1;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 8
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x17 = XVECEXP (x1, 0, 13);
              if (pattern805 (x17) != 0
                  || !(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33827; /* gpr_multi_pop_up_to_s11_si */

            case 1:
              if (pattern795 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern801 (x1, 
E_SImode) != 0
                  || !(
#line 658 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33849; /* gpr_multi_popret_up_to_s9_si */

            case 2:
              if (!(
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33869; /* gpr_multi_popretz_up_to_s7_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern773 (x1, 
E_DImode))
            {
            case 0:
              if (pattern797 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern800 (x1, 
E_DImode, 
SET, 
9) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 12);
              x15 = XEXP (x14, 1);
              if (pattern803 (x15) != 0)
                return -1;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 8
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XVECEXP (x1, 0, 13);
              if (pattern806 (x17) != 0
                  || !(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33828; /* gpr_multi_pop_up_to_s11_di */

            case 1:
              if (pattern797 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern801 (x1, 
E_DImode) != 0
                  || !(
#line 658 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33850; /* gpr_multi_popret_up_to_s9_di */

            case 2:
              if (!(
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33870; /* gpr_multi_popretz_up_to_s7_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x5) != 27)
        return -1;
      x18 = XEXP (x4, 0);
      if (GET_CODE (x18) != MEM)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2)
        return -1;
      x21 = XEXP (x19, 1);
      if (GET_CODE (x21) != CONST_INT)
        return -1;
      x22 = XVECEXP (x1, 0, 1);
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 26)
        return -1;
      x24 = XEXP (x22, 0);
      if (GET_CODE (x24) != MEM)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != PLUS)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 2)
        return -1;
      x27 = XEXP (x25, 1);
      if (GET_CODE (x27) != CONST_INT)
        return -1;
      x28 = XVECEXP (x1, 0, 2);
      x29 = XEXP (x28, 1);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 25)
        return -1;
      x30 = XEXP (x28, 0);
      if (GET_CODE (x30) != MEM)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != PLUS)
        return -1;
      x32 = XEXP (x31, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 2)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != CONST_INT)
        return -1;
      x34 = XVECEXP (x1, 0, 3);
      x35 = XEXP (x34, 1);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 24)
        return -1;
      x36 = XEXP (x34, 0);
      if (GET_CODE (x36) != MEM)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != PLUS)
        return -1;
      x38 = XEXP (x37, 0);
      if (GET_CODE (x38) != REG
          || REGNO (x38) != 2)
        return -1;
      x39 = XEXP (x37, 1);
      if (GET_CODE (x39) != CONST_INT)
        return -1;
      x40 = XVECEXP (x1, 0, 4);
      x41 = XEXP (x40, 1);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 23)
        return -1;
      x42 = XEXP (x40, 0);
      if (GET_CODE (x42) != MEM)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != PLUS)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 2)
        return -1;
      x45 = XEXP (x43, 1);
      if (GET_CODE (x45) != CONST_INT)
        return -1;
      x46 = XVECEXP (x1, 0, 5);
      x47 = XEXP (x46, 1);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 22)
        return -1;
      x48 = XEXP (x46, 0);
      if (GET_CODE (x48) != MEM)
        return -1;
      x49 = XEXP (x48, 0);
      if (GET_CODE (x49) != PLUS)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 2)
        return -1;
      x51 = XEXP (x49, 1);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x1, 0, 6);
      x53 = XEXP (x52, 1);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 21)
        return -1;
      x54 = XEXP (x52, 0);
      if (GET_CODE (x54) != MEM)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != PLUS)
        return -1;
      x56 = XEXP (x55, 0);
      if (GET_CODE (x56) != REG
          || REGNO (x56) != 2)
        return -1;
      x57 = XEXP (x55, 1);
      if (GET_CODE (x57) != CONST_INT)
        return -1;
      x58 = XVECEXP (x1, 0, 7);
      x59 = XEXP (x58, 1);
      if (GET_CODE (x59) != REG
          || REGNO (x59) != 20)
        return -1;
      x60 = XEXP (x58, 0);
      if (GET_CODE (x60) != MEM)
        return -1;
      x61 = XEXP (x60, 0);
      if (GET_CODE (x61) != PLUS)
        return -1;
      x62 = XEXP (x61, 0);
      if (GET_CODE (x62) != REG
          || REGNO (x62) != 2)
        return -1;
      x63 = XEXP (x61, 1);
      if (GET_CODE (x63) != CONST_INT)
        return -1;
      x6 = XVECEXP (x1, 0, 8);
      if (pattern761 (x6, 
19) != 0
          || pattern762 (x2, 
18) != 0
          || pattern771 (x3, 
9) != 0)
        return -1;
      x64 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x64) != SET)
        return -1;
      x65 = XEXP (x64, 1);
      if (GET_CODE (x65) != REG
          || REGNO (x65) != 8)
        return -1;
      x66 = XEXP (x64, 0);
      if (GET_CODE (x66) != MEM)
        return -1;
      x67 = XEXP (x66, 0);
      if (GET_CODE (x67) != PLUS)
        return -1;
      x68 = XEXP (x67, 0);
      if (GET_CODE (x68) != REG
          || REGNO (x68) != 2)
        return -1;
      x69 = XEXP (x67, 1);
      if (GET_CODE (x69) != CONST_INT)
        return -1;
      x14 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x14) != SET)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 1)
        return -1;
      x16 = XEXP (x14, 0);
      if (GET_CODE (x16) != MEM)
        return -1;
      x70 = XEXP (x16, 0);
      if (GET_CODE (x70) != PLUS)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != REG
          || REGNO (x71) != 2)
        return -1;
      x72 = XEXP (x70, 1);
      if (GET_CODE (x72) != CONST_INT)
        return -1;
      x17 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x17) != SET)
        return -1;
      x73 = XEXP (x17, 1);
      if (GET_CODE (x73) != PLUS)
        return -1;
      x74 = XEXP (x73, 0);
      if (GET_CODE (x74) != REG
          || REGNO (x74) != 2)
        return -1;
      x75 = XEXP (x17, 0);
      if (GET_CODE (x75) != REG
          || REGNO (x75) != 2)
        return -1;
      x76 = XEXP (x73, 1);
      operands[0] = x76;
      if (!stack_push_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern776 (x1))
        {
        case 0:
          if (XWINT (x69, 0) != -48L
              || XWINT (x72, 0) != -52L
              || pattern793 (x1, 
E_SImode) != 0
              || !(
#line 1433 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33899; /* gpr_multi_push_up_to_s11_si */

        case 1:
          if (XWINT (x69, 0) != -96L
              || XWINT (x72, 0) != -104L
              || pattern793 (x1, 
E_DImode) != 0
              || !(
#line 1433 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33900; /* gpr_multi_push_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      if (pattern138 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9488 (insn, operands);

    case E_RVVM4HImode:
      if (pattern138 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9490 (insn, operands);

    case E_RVVM2HImode:
      if (pattern138 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9492 (insn, operands);

    case E_RVVM1HImode:
      if (pattern138 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9494 (insn, operands);

    case E_RVVMF2HImode:
      if (pattern138 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9496 (insn, operands);

    case E_RVVMF4HImode:
      if (pattern138 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9498 (insn, operands);

    case E_RVVM8SImode:
      if (pattern138 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9500 (insn, operands);

    case E_RVVM4SImode:
      if (pattern138 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9502 (insn, operands);

    case E_RVVM2SImode:
      if (pattern138 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9504 (insn, operands);

    case E_RVVM1SImode:
      if (pattern138 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
          || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9506 (insn, operands);

    case E_RVVMF2SImode:
      if (pattern138 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9508 (insn, operands);

    case E_RVVM8DImode:
      if (pattern138 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9510 (insn, operands);

    case E_RVVM4DImode:
      if (pattern138 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9512 (insn, operands);

    case E_RVVM2DImode:
      if (pattern138 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9514 (insn, operands);

    case E_RVVM1DImode:
      if (pattern138 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9516 (insn, operands);

    case E_V1HImode:
      if (pattern138 (x2, 
E_V1HImode, 
E_V1QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9518 (insn, operands);

    case E_V2HImode:
      if (pattern138 (x2, 
E_V2HImode, 
E_V2QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9520 (insn, operands);

    case E_V4HImode:
      if (pattern138 (x2, 
E_V4HImode, 
E_V4QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9522 (insn, operands);

    case E_V8HImode:
      if (pattern138 (x2, 
E_V8HImode, 
E_V8QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9524 (insn, operands);

    case E_V16HImode:
      if (pattern138 (x2, 
E_V16HImode, 
E_V16QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9526 (insn, operands);

    case E_V32HImode:
      if (pattern138 (x2, 
E_V32HImode, 
E_V32QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9528 (insn, operands);

    case E_V64HImode:
      if (pattern138 (x2, 
E_V64HImode, 
E_V64QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9530 (insn, operands);

    case E_V128HImode:
      if (pattern138 (x2, 
E_V128HImode, 
E_V128QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9532 (insn, operands);

    case E_V256HImode:
      if (pattern138 (x2, 
E_V256HImode, 
E_V256QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9534 (insn, operands);

    case E_V512HImode:
      if (pattern138 (x2, 
E_V512HImode, 
E_V512QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9536 (insn, operands);

    case E_V1024HImode:
      if (pattern138 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9538 (insn, operands);

    case E_V2048HImode:
      if (pattern138 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9540 (insn, operands);

    case E_V1SImode:
      if (pattern138 (x2, 
E_V1SImode, 
E_V1HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9542 (insn, operands);

    case E_V2SImode:
      if (pattern138 (x2, 
E_V2SImode, 
E_V2HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9544 (insn, operands);

    case E_V4SImode:
      if (pattern138 (x2, 
E_V4SImode, 
E_V4HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9546 (insn, operands);

    case E_V8SImode:
      if (pattern138 (x2, 
E_V8SImode, 
E_V8HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9548 (insn, operands);

    case E_V16SImode:
      if (pattern138 (x2, 
E_V16SImode, 
E_V16HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9550 (insn, operands);

    case E_V32SImode:
      if (pattern138 (x2, 
E_V32SImode, 
E_V32HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9552 (insn, operands);

    case E_V64SImode:
      if (pattern138 (x2, 
E_V64SImode, 
E_V64HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9554 (insn, operands);

    case E_V128SImode:
      if (pattern138 (x2, 
E_V128SImode, 
E_V128HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9556 (insn, operands);

    case E_V256SImode:
      if (pattern138 (x2, 
E_V256SImode, 
E_V256HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9558 (insn, operands);

    case E_V512SImode:
      if (pattern138 (x2, 
E_V512SImode, 
E_V512HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9560 (insn, operands);

    case E_V1024SImode:
      if (pattern138 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9562 (insn, operands);

    case E_V1DImode:
      if (pattern138 (x2, 
E_V1DImode, 
E_V1SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9564 (insn, operands);

    case E_V2DImode:
      if (pattern138 (x2, 
E_V2DImode, 
E_V2SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9566 (insn, operands);

    case E_V4DImode:
      if (pattern138 (x2, 
E_V4DImode, 
E_V4SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9568 (insn, operands);

    case E_V8DImode:
      if (pattern138 (x2, 
E_V8DImode, 
E_V8SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9570 (insn, operands);

    case E_V16DImode:
      if (pattern138 (x2, 
E_V16DImode, 
E_V16SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9572 (insn, operands);

    case E_V32DImode:
      if (pattern138 (x2, 
E_V32DImode, 
E_V32SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9574 (insn, operands);

    case E_V64DImode:
      if (pattern138 (x2, 
E_V64DImode, 
E_V64SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9576 (insn, operands);

    case E_V128DImode:
      if (pattern138 (x2, 
E_V128DImode, 
E_V128SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9578 (insn, operands);

    case E_V256DImode:
      if (pattern138 (x2, 
E_V256DImode, 
E_V256SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9580 (insn, operands);

    case E_V512DImode:
      if (pattern138 (x2, 
E_V512DImode, 
E_V512SImode) != 0
          || !((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9582 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          if ((
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX
   && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))) && 
#line 1883 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_5 (insn, operands);
          if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return NULL;
          return gen_split_188 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return NULL;
          if (((
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1909 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_7 (insn, operands);
          if (!((
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return NULL;
          return gen_split_190 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !nonimmediate_operand (operands[1], E_HImode))
        return NULL;
      if ((
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1909 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
        return gen_split_6 (insn, operands);
      if (!(
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
        return NULL;
      return gen_split_189 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4150 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4152 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4154 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4156 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4158 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4160 (insn, operands);

    case E_RVVM8SImode:
      switch (pattern296 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4162 (insn, operands);

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4246 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM4SImode:
      switch (pattern297 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4164 (insn, operands);

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4248 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM2SImode:
      switch (pattern298 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4166 (insn, operands);

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4250 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM1SImode:
      switch (pattern299 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4168 (insn, operands);

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4252 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVMF2SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4170 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4254 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM8DImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4172 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4256 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4306 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM4DImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4174 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4258 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4308 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM2DImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4176 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4260 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4310 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM1DImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4178 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4262 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4312 (insn, operands);

        default:
          return NULL;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4180 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4182 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4184 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4186 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4188 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4190 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4192 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4194 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4196 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4198 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4200 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4202 (insn, operands);

    case E_V1SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4204 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4264 (insn, operands);

        default:
          return NULL;
        }

    case E_V2SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4206 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4266 (insn, operands);

        default:
          return NULL;
        }

    case E_V4SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4208 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4268 (insn, operands);

        default:
          return NULL;
        }

    case E_V8SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4210 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4270 (insn, operands);

        default:
          return NULL;
        }

    case E_V16SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4212 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4272 (insn, operands);

        default:
          return NULL;
        }

    case E_V32SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4214 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4274 (insn, operands);

        default:
          return NULL;
        }

    case E_V64SImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4216 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4276 (insn, operands);

        default:
          return NULL;
        }

    case E_V128SImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4218 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4278 (insn, operands);

        default:
          return NULL;
        }

    case E_V256SImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4220 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4280 (insn, operands);

        default:
          return NULL;
        }

    case E_V512SImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4222 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4282 (insn, operands);

        default:
          return NULL;
        }

    case E_V1024SImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4224 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4284 (insn, operands);

        default:
          return NULL;
        }

    case E_V1DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4226 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4286 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4314 (insn, operands);

        default:
          return NULL;
        }

    case E_V2DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4228 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4288 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4316 (insn, operands);

        default:
          return NULL;
        }

    case E_V4DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4230 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4290 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4318 (insn, operands);

        default:
          return NULL;
        }

    case E_V8DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4232 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4292 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4320 (insn, operands);

        default:
          return NULL;
        }

    case E_V16DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4234 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4294 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4322 (insn, operands);

        default:
          return NULL;
        }

    case E_V32DImode:
      switch (pattern321 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4236 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4296 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4324 (insn, operands);

        default:
          return NULL;
        }

    case E_V64DImode:
      switch (pattern322 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4238 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4298 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4326 (insn, operands);

        default:
          return NULL;
        }

    case E_V128DImode:
      switch (pattern323 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4240 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4300 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4328 (insn, operands);

        default:
          return NULL;
        }

    case E_V256DImode:
      switch (pattern324 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4242 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4302 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4330 (insn, operands);

        default:
          return NULL;
        }

    case E_V512DImode:
      switch (pattern325 (x2))
        {
        case 0:
          if (!((
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4244 (insn, operands);

        case 1:
          if (!((
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4304 (insn, operands);

        case 2:
          if (!((
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4332 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_78 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32SImode)
      && reg_or_mem_operand (operands[1], E_V32SImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_274 (insn, operands);
  if (!register_operand (operands[0], E_V32SImode)
      || !register_operand (operands[1], E_V32SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2121 (insn, operands);
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32HImode)
      && reg_or_mem_operand (operands[1], E_V32HImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return gen_split_262 (insn, operands);
  if (!register_operand (operands[0], E_V32HImode)
      || !register_operand (operands[1], E_V32HImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2109 (insn, operands);
}

 rtx_insn *
split_92 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return gen_split_250 (insn, operands);
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2097 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF32BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF32BImode)
      && 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_238 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF32BImode)
      || !register_operand (operands[1], E_RVVMF32BImode)
      || !(
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1575 (insn, operands);
}

 rtx_insn *
split_106 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SImode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_215 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || !register_operand (operands[1], E_RVVMF2SImode)
      || !((
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1572 (insn, operands);
}

 rtx_insn *
split_113 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern276 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3540 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3744 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3543 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3747 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3546 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3750 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3549 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3753 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3552 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3756 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3555 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3759 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3558 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3762 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3561 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3765 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3564 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3768 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3567 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3771 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3570 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3774 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3573 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3777 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3576 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3780 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3579 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3783 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3582 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3786 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3585 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3789 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3588 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3792 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3591 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3795 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3594 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3798 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3597 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3801 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3600 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3804 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3603 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3807 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3606 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3810 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3609 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3813 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3612 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3816 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3615 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3819 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3618 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3822 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3621 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3825 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3624 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3828 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3627 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3831 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3630 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3834 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3633 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3837 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3636 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3840 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3639 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3843 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3642 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3846 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3645 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3849 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3648 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3852 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3651 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3855 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3654 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3858 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3657 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3861 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3660 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3864 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3663 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3867 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3666 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3870 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3669 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3873 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3672 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3876 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3675 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3879 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3678 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3882 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3681 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3885 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3684 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3888 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3687 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3891 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3690 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3894 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3693 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3897 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3696 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3900 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3699 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3903 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3702 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3906 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3705 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3909 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3708 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3912 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3711 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3915 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3714 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3918 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3717 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3921 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3720 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3924 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3723 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3927 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3726 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3930 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3729 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3933 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3732 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3936 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3735 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3939 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3738 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3942 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3741 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3945 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_121 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 93:
      return split_118 (x1, insn);

    case 140:
      switch (pattern241 (x2))
        {
        case 0:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5841 (insn, operands);

        case 1:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5843 (insn, operands);

        case 2:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5845 (insn, operands);

        case 3:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5847 (insn, operands);

        case 4:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5849 (insn, operands);

        case 5:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5851 (insn, operands);

        case 6:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5853 (insn, operands);

        case 7:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5855 (insn, operands);

        case 8:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5857 (insn, operands);

        case 9:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5859 (insn, operands);

        case 10:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5861 (insn, operands);

        case 11:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5863 (insn, operands);

        case 12:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5865 (insn, operands);

        case 13:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5867 (insn, operands);

        case 14:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5869 (insn, operands);

        case 15:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5871 (insn, operands);

        case 16:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5873 (insn, operands);

        case 17:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5875 (insn, operands);

        case 18:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5877 (insn, operands);

        case 19:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5879 (insn, operands);

        case 20:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5881 (insn, operands);

        case 21:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5883 (insn, operands);

        case 22:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5885 (insn, operands);

        case 23:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5887 (insn, operands);

        case 24:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5889 (insn, operands);

        case 25:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5891 (insn, operands);

        case 26:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5893 (insn, operands);

        case 27:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5895 (insn, operands);

        case 28:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5897 (insn, operands);

        case 29:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5899 (insn, operands);

        case 30:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5901 (insn, operands);

        case 31:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5903 (insn, operands);

        case 32:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5905 (insn, operands);

        case 33:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5907 (insn, operands);

        case 34:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5909 (insn, operands);

        case 35:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5911 (insn, operands);

        case 36:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5913 (insn, operands);

        case 37:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5915 (insn, operands);

        case 38:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5917 (insn, operands);

        case 39:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5919 (insn, operands);

        case 40:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5921 (insn, operands);

        case 41:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5923 (insn, operands);

        case 42:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5925 (insn, operands);

        case 43:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5927 (insn, operands);

        case 44:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5929 (insn, operands);

        case 45:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5931 (insn, operands);

        case 46:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5933 (insn, operands);

        case 47:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5935 (insn, operands);

        default:
          return NULL;
        }

    case 141:
      switch (pattern241 (x2))
        {
        case 0:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5842 (insn, operands);

        case 1:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5844 (insn, operands);

        case 2:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5846 (insn, operands);

        case 3:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5848 (insn, operands);

        case 4:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5850 (insn, operands);

        case 5:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5852 (insn, operands);

        case 6:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5854 (insn, operands);

        case 7:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5856 (insn, operands);

        case 8:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5858 (insn, operands);

        case 9:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5860 (insn, operands);

        case 10:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5862 (insn, operands);

        case 11:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5864 (insn, operands);

        case 12:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5866 (insn, operands);

        case 13:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5868 (insn, operands);

        case 14:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5870 (insn, operands);

        case 15:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5872 (insn, operands);

        case 16:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5874 (insn, operands);

        case 17:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5876 (insn, operands);

        case 18:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5878 (insn, operands);

        case 19:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5880 (insn, operands);

        case 20:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5882 (insn, operands);

        case 21:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5884 (insn, operands);

        case 22:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5886 (insn, operands);

        case 23:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5888 (insn, operands);

        case 24:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5890 (insn, operands);

        case 25:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5892 (insn, operands);

        case 26:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5894 (insn, operands);

        case 27:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5896 (insn, operands);

        case 28:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5898 (insn, operands);

        case 29:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5900 (insn, operands);

        case 30:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5902 (insn, operands);

        case 31:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5904 (insn, operands);

        case 32:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5906 (insn, operands);

        case 33:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5908 (insn, operands);

        case 34:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5910 (insn, operands);

        case 35:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5912 (insn, operands);

        case 36:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5914 (insn, operands);

        case 37:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5916 (insn, operands);

        case 38:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5918 (insn, operands);

        case 39:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5920 (insn, operands);

        case 40:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5922 (insn, operands);

        case 41:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5924 (insn, operands);

        case 42:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5926 (insn, operands);

        case 43:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5928 (insn, operands);

        case 44:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5930 (insn, operands);

        case 45:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5932 (insn, operands);

        case 46:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5934 (insn, operands);

        case 47:
          if (!((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5936 (insn, operands);

        default:
          return NULL;
        }

    case 123:
      switch (pattern241 (x2))
        {
        case 0:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5937 (insn, operands);

        case 1:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5938 (insn, operands);

        case 2:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5939 (insn, operands);

        case 3:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5940 (insn, operands);

        case 4:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5941 (insn, operands);

        case 5:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5942 (insn, operands);

        case 6:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5943 (insn, operands);

        case 7:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5944 (insn, operands);

        case 8:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5945 (insn, operands);

        case 9:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5946 (insn, operands);

        case 10:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5947 (insn, operands);

        case 11:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5948 (insn, operands);

        case 12:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5949 (insn, operands);

        case 13:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5950 (insn, operands);

        case 14:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5951 (insn, operands);

        case 15:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5952 (insn, operands);

        case 16:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5953 (insn, operands);

        case 17:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5954 (insn, operands);

        case 18:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5955 (insn, operands);

        case 19:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5956 (insn, operands);

        case 20:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5957 (insn, operands);

        case 21:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5958 (insn, operands);

        case 22:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5959 (insn, operands);

        case 23:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5960 (insn, operands);

        case 24:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5961 (insn, operands);

        case 25:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5962 (insn, operands);

        case 26:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5963 (insn, operands);

        case 27:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5964 (insn, operands);

        case 28:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5965 (insn, operands);

        case 29:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5966 (insn, operands);

        case 30:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5967 (insn, operands);

        case 31:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5968 (insn, operands);

        case 32:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5969 (insn, operands);

        case 33:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5970 (insn, operands);

        case 34:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5971 (insn, operands);

        case 35:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5972 (insn, operands);

        case 36:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5973 (insn, operands);

        case 37:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5974 (insn, operands);

        case 38:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5975 (insn, operands);

        case 39:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5976 (insn, operands);

        case 40:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5977 (insn, operands);

        case 41:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5978 (insn, operands);

        case 42:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5979 (insn, operands);

        case 43:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5980 (insn, operands);

        case 44:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5981 (insn, operands);

        case 45:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5982 (insn, operands);

        case 46:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5983 (insn, operands);

        case 47:
          if (!((
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5984 (insn, operands);

        default:
          return NULL;
        }

    case 145:
      return split_119 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_131 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8QImode)
        || register_operand (operands[3], RVVM8QImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_2309 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4QImode)
        || register_operand (operands[3], RVVM4QImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_2310 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2QImode)
        || register_operand (operands[3], RVVM2QImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_2311 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1QImode)
        || register_operand (operands[3], RVVM1QImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_2312 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HImode)
        || register_operand (operands[3], RVVM8HImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_2313 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HImode)
        || register_operand (operands[3], RVVM4HImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_2314 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HImode)
        || register_operand (operands[3], RVVM2HImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_2315 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HImode)
        || register_operand (operands[3], RVVM1HImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_2316 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SImode)
        || register_operand (operands[3], RVVM8SImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_2317 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SImode)
        || register_operand (operands[3], RVVM4SImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_2318 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SImode)
        || register_operand (operands[3], RVVM2SImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_2319 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SImode)
        || register_operand (operands[3], RVVM1SImode)))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_2320 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DImode)
        || register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_2321 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DImode)
        || register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_2322 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DImode)
        || register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_2323 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DImode)
        || register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_2324 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2QImode)
        || register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_2325 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4QImode)
        || register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_2326 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF8QImode)
        || register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_2327 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HImode)
        || register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_2328 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HImode)
        || register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_2329 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SImode)
        || register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_2330 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8BFmode)
        || register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_2331 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4BFmode)
        || register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_2332 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2BFmode)
        || register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_2333 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1BFmode)
        || register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_2334 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
        || register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_2335 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
        || register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_2336 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HFmode)
        || register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_2337 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HFmode)
        || register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_2338 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HFmode)
        || register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_2339 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HFmode)
        || register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_2340 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
        || register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_2341 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
        || register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_2342 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SFmode)
        || register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_2343 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SFmode)
        || register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_2344 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SFmode)
        || register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_2345 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SFmode)
        || register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_2346 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
        || register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_2347 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DFmode)
        || register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_2348 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DFmode)
        || register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_2349 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DFmode)
        || register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_2350 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DFmode)
        || register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_2351 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1QImode)
        || register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_2352 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2QImode)
        || register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_2353 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4QImode)
        || register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_2354 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8QImode)
        || register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_2355 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16QImode)
        || register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_2356 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32QImode)
        || register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_2357 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64QImode)
        || register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_2358 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128QImode)
        || register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_2359 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256QImode)
        || register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_2360 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512QImode)
        || register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_2361 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024QImode)
        || register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_2362 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048QImode)
        || register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_2363 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4096QImode)
        || register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_2364 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HImode)
        || register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_2365 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HImode)
        || register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_2366 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HImode)
        || register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_2367 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HImode)
        || register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_2368 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HImode)
        || register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_2369 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HImode)
        || register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_2370 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HImode)
        || register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_2371 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HImode)
        || register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_2372 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HImode)
        || register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_2373 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HImode)
        || register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_2374 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HImode)
        || register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_2375 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HImode)
        || register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_2376 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SImode)
        || register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_2377 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SImode)
        || register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_2378 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SImode)
        || register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_2379 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SImode)
        || register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_2380 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SImode)
        || register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_2381 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SImode)
        || register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_2382 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SImode)
        || register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_2383 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SImode)
        || register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_2384 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SImode)
        || register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_2385 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SImode)
        || register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_2386 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SImode)
        || register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_2387 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DImode)
        || register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_2388 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DImode)
        || register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_2389 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DImode)
        || register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_2390 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DImode)
        || register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_2391 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DImode)
        || register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_2392 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DImode)
        || register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_2393 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DImode)
        || register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_2394 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DImode)
        || register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_2395 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DImode)
        || register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_2396 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DImode)
        || register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_2397 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HFmode)
        || register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_2398 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HFmode)
        || register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_2399 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HFmode)
        || register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_2400 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HFmode)
        || register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_2401 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HFmode)
        || register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_2402 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HFmode)
        || register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_2403 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HFmode)
        || register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_2404 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HFmode)
        || register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_2405 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HFmode)
        || register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_2406 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HFmode)
        || register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_2407 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HFmode)
        || register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_2408 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HFmode)
        || register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_2409 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SFmode)
        || register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_2410 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SFmode)
        || register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_2411 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SFmode)
        || register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_2412 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SFmode)
        || register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_2413 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SFmode)
        || register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_2414 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SFmode)
        || register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_2415 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SFmode)
        || register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_2416 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SFmode)
        || register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_2417 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SFmode)
        || register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_2418 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SFmode)
        || register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_2419 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SFmode)
        || register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_2420 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DFmode)
        || register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_2421 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DFmode)
        || register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_2422 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DFmode)
        || register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_2423 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DFmode)
        || register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_2424 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DFmode)
        || register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_2425 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DFmode)
        || register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_2426 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DFmode)
        || register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_2427 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DFmode)
        || register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_2428 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DFmode)
        || register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_2429 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DFmode)
        || register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_2430 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_141 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern155 (x2))
    {
    case 0:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8137 (insn, operands);

    case 1:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8143 (insn, operands);

    case 2:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8149 (insn, operands);

    case 3:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8155 (insn, operands);

    case 4:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8161 (insn, operands);

    case 5:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8167 (insn, operands);

    case 6:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8173 (insn, operands);

    case 7:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8179 (insn, operands);

    case 8:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8185 (insn, operands);

    case 9:
      if (!(
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8191 (insn, operands);

    case 10:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8197 (insn, operands);

    case 11:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8203 (insn, operands);

    case 12:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8209 (insn, operands);

    case 13:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8215 (insn, operands);

    case 14:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8221 (insn, operands);

    case 15:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8227 (insn, operands);

    case 16:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8233 (insn, operands);

    case 17:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8239 (insn, operands);

    case 18:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8245 (insn, operands);

    case 19:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8251 (insn, operands);

    case 20:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8257 (insn, operands);

    case 21:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8263 (insn, operands);

    case 22:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8269 (insn, operands);

    case 23:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8275 (insn, operands);

    case 24:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8281 (insn, operands);

    case 25:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8287 (insn, operands);

    case 26:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8293 (insn, operands);

    case 27:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8299 (insn, operands);

    case 28:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8305 (insn, operands);

    case 29:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8311 (insn, operands);

    case 30:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8317 (insn, operands);

    case 31:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8323 (insn, operands);

    case 32:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8329 (insn, operands);

    case 33:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8335 (insn, operands);

    case 34:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8341 (insn, operands);

    case 35:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8347 (insn, operands);

    case 36:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8353 (insn, operands);

    case 37:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8359 (insn, operands);

    case 38:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8365 (insn, operands);

    case 39:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8371 (insn, operands);

    case 40:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8377 (insn, operands);

    case 41:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8383 (insn, operands);

    case 42:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8389 (insn, operands);

    case 43:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8395 (insn, operands);

    case 44:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8401 (insn, operands);

    case 45:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8407 (insn, operands);

    case 46:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8413 (insn, operands);

    case 47:
      if (!((
#line 610 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8419 (insn, operands);

    case 48:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8709 (insn, operands);

    case 49:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8711 (insn, operands);

    case 50:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8713 (insn, operands);

    case 51:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8715 (insn, operands);

    case 52:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8717 (insn, operands);

    case 53:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8719 (insn, operands);

    case 54:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8721 (insn, operands);

    case 55:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8723 (insn, operands);

    case 56:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8725 (insn, operands);

    case 57:
      if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8727 (insn, operands);

    case 58:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8729 (insn, operands);

    case 59:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8731 (insn, operands);

    case 60:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8733 (insn, operands);

    case 61:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8735 (insn, operands);

    case 62:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8737 (insn, operands);

    case 63:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8739 (insn, operands);

    case 64:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8741 (insn, operands);

    case 65:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8743 (insn, operands);

    case 66:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8745 (insn, operands);

    case 67:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8747 (insn, operands);

    case 68:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8749 (insn, operands);

    case 69:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8751 (insn, operands);

    case 70:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8753 (insn, operands);

    case 71:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8755 (insn, operands);

    case 72:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8757 (insn, operands);

    case 73:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8759 (insn, operands);

    case 74:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8761 (insn, operands);

    case 75:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8763 (insn, operands);

    case 76:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8765 (insn, operands);

    case 77:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8767 (insn, operands);

    case 78:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8769 (insn, operands);

    case 79:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8771 (insn, operands);

    case 80:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8773 (insn, operands);

    case 81:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8775 (insn, operands);

    case 82:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8777 (insn, operands);

    case 83:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8779 (insn, operands);

    case 84:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8781 (insn, operands);

    case 85:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8783 (insn, operands);

    case 86:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8785 (insn, operands);

    case 87:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8787 (insn, operands);

    case 88:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8789 (insn, operands);

    case 89:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8791 (insn, operands);

    case 90:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8793 (insn, operands);

    case 91:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8795 (insn, operands);

    case 92:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8797 (insn, operands);

    case 93:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8799 (insn, operands);

    case 94:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8801 (insn, operands);

    case 95:
      if (!((
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8803 (insn, operands);

    case 96:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8852 (insn, operands);

    case 97:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8853 (insn, operands);

    case 98:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8854 (insn, operands);

    case 99:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8855 (insn, operands);

    case 100:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8856 (insn, operands);

    case 101:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8857 (insn, operands);

    case 102:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8858 (insn, operands);

    case 103:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8859 (insn, operands);

    case 104:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8860 (insn, operands);

    case 105:
      if (!(
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8861 (insn, operands);

    case 106:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8862 (insn, operands);

    case 107:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8863 (insn, operands);

    case 108:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8864 (insn, operands);

    case 109:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8865 (insn, operands);

    case 110:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8866 (insn, operands);

    case 111:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8867 (insn, operands);

    case 112:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8868 (insn, operands);

    case 113:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8869 (insn, operands);

    case 114:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8870 (insn, operands);

    case 115:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8871 (insn, operands);

    case 116:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8872 (insn, operands);

    case 117:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8873 (insn, operands);

    case 118:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8874 (insn, operands);

    case 119:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8875 (insn, operands);

    case 120:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8876 (insn, operands);

    case 121:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8877 (insn, operands);

    case 122:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8878 (insn, operands);

    case 123:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8879 (insn, operands);

    case 124:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8880 (insn, operands);

    case 125:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8881 (insn, operands);

    case 126:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8882 (insn, operands);

    case 127:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8883 (insn, operands);

    case 128:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8884 (insn, operands);

    case 129:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8885 (insn, operands);

    case 130:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8886 (insn, operands);

    case 131:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8887 (insn, operands);

    case 132:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8888 (insn, operands);

    case 133:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8889 (insn, operands);

    case 134:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8890 (insn, operands);

    case 135:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8891 (insn, operands);

    case 136:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8892 (insn, operands);

    case 137:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8893 (insn, operands);

    case 138:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8894 (insn, operands);

    case 139:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8895 (insn, operands);

    case 140:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8896 (insn, operands);

    case 141:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8897 (insn, operands);

    case 142:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8898 (insn, operands);

    case 143:
      if (!((
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8899 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_150 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4538 (insn, operands);

    case 1:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4694 (insn, operands);

    case 2:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4540 (insn, operands);

    case 3:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4696 (insn, operands);

    case 4:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4886 (insn, operands);

    case 5:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4542 (insn, operands);

    case 6:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4698 (insn, operands);

    case 7:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4888 (insn, operands);

    case 8:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4544 (insn, operands);

    case 9:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4700 (insn, operands);

    case 10:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4890 (insn, operands);

    case 11:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4546 (insn, operands);

    case 12:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4702 (insn, operands);

    case 13:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4892 (insn, operands);

    case 14:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4548 (insn, operands);

    case 15:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4704 (insn, operands);

    case 16:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4894 (insn, operands);

    case 17:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4550 (insn, operands);

    case 18:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4706 (insn, operands);

    case 19:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4552 (insn, operands);

    case 20:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4708 (insn, operands);

    case 21:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4896 (insn, operands);

    case 22:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4554 (insn, operands);

    case 23:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4710 (insn, operands);

    case 24:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4898 (insn, operands);

    case 25:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4556 (insn, operands);

    case 26:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4712 (insn, operands);

    case 27:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4900 (insn, operands);

    case 28:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4558 (insn, operands);

    case 29:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4714 (insn, operands);

    case 30:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4902 (insn, operands);

    case 31:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4560 (insn, operands);

    case 32:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4716 (insn, operands);

    case 33:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4562 (insn, operands);

    case 34:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4718 (insn, operands);

    case 35:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4564 (insn, operands);

    case 36:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4720 (insn, operands);

    case 37:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4566 (insn, operands);

    case 38:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4722 (insn, operands);

    case 39:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4568 (insn, operands);

    case 40:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4724 (insn, operands);

    case 41:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4904 (insn, operands);

    case 42:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4570 (insn, operands);

    case 43:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4726 (insn, operands);

    case 44:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4906 (insn, operands);

    case 45:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4572 (insn, operands);

    case 46:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4728 (insn, operands);

    case 47:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4908 (insn, operands);

    case 48:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4574 (insn, operands);

    case 49:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4730 (insn, operands);

    case 50:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4910 (insn, operands);

    case 51:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4576 (insn, operands);

    case 52:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4732 (insn, operands);

    case 53:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4912 (insn, operands);

    case 54:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4578 (insn, operands);

    case 55:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4734 (insn, operands);

    case 56:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4914 (insn, operands);

    case 57:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4580 (insn, operands);

    case 58:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4736 (insn, operands);

    case 59:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4916 (insn, operands);

    case 60:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4582 (insn, operands);

    case 61:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4738 (insn, operands);

    case 62:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4918 (insn, operands);

    case 63:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4584 (insn, operands);

    case 64:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4740 (insn, operands);

    case 65:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4920 (insn, operands);

    case 66:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4586 (insn, operands);

    case 67:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4742 (insn, operands);

    case 68:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4922 (insn, operands);

    case 69:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4588 (insn, operands);

    case 70:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4744 (insn, operands);

    case 71:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4924 (insn, operands);

    case 72:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4590 (insn, operands);

    case 73:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4746 (insn, operands);

    case 74:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4592 (insn, operands);

    case 75:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4748 (insn, operands);

    case 76:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4926 (insn, operands);

    case 77:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4594 (insn, operands);

    case 78:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4750 (insn, operands);

    case 79:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4928 (insn, operands);

    case 80:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4596 (insn, operands);

    case 81:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4752 (insn, operands);

    case 82:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4930 (insn, operands);

    case 83:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4598 (insn, operands);

    case 84:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4754 (insn, operands);

    case 85:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4932 (insn, operands);

    case 86:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4600 (insn, operands);

    case 87:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4756 (insn, operands);

    case 88:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4934 (insn, operands);

    case 89:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4602 (insn, operands);

    case 90:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4758 (insn, operands);

    case 91:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4936 (insn, operands);

    case 92:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4604 (insn, operands);

    case 93:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4760 (insn, operands);

    case 94:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4938 (insn, operands);

    case 95:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4606 (insn, operands);

    case 96:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4762 (insn, operands);

    case 97:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4940 (insn, operands);

    case 98:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4608 (insn, operands);

    case 99:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4764 (insn, operands);

    case 100:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4942 (insn, operands);

    case 101:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4610 (insn, operands);

    case 102:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4766 (insn, operands);

    case 103:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4944 (insn, operands);

    case 104:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4612 (insn, operands);

    case 105:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4768 (insn, operands);

    case 106:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4614 (insn, operands);

    case 107:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4770 (insn, operands);

    case 108:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4616 (insn, operands);

    case 109:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4772 (insn, operands);

    case 110:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4618 (insn, operands);

    case 111:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4774 (insn, operands);

    case 112:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4620 (insn, operands);

    case 113:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4776 (insn, operands);

    case 114:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4622 (insn, operands);

    case 115:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4778 (insn, operands);

    case 116:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4624 (insn, operands);

    case 117:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4780 (insn, operands);

    case 118:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4626 (insn, operands);

    case 119:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4782 (insn, operands);

    case 120:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4628 (insn, operands);

    case 121:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4784 (insn, operands);

    case 122:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4630 (insn, operands);

    case 123:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4786 (insn, operands);

    case 124:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4632 (insn, operands);

    case 125:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4788 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_157 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2597 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2611 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2625 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2639 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2653 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2667 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2681 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2695 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2709 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2723 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2737 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2751 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2765 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2779 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2793 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2807 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2821 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2835 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2849 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2863 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2877 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2891 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2905 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2919 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2933 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2947 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2961 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2975 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2989 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3003 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3017 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3031 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3045 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3059 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3073 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3087 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3101 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3115 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3129 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3143 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3157 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3171 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3185 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3199 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3213 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3227 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3241 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3255 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3269 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3283 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3297 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3311 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3325 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3339 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3353 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3367 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3381 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3395 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3409 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3423 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3437 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3451 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3465 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3479 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3493 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3507 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3521 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3535 (insn, operands);

    case 68:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5556 (insn, operands);

    case 69:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5560 (insn, operands);

    case 70:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5564 (insn, operands);

    case 71:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5568 (insn, operands);

    case 72:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5572 (insn, operands);

    case 73:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5576 (insn, operands);

    case 74:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5580 (insn, operands);

    case 75:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5584 (insn, operands);

    case 76:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5588 (insn, operands);

    case 77:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5592 (insn, operands);

    case 78:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5596 (insn, operands);

    case 79:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5600 (insn, operands);

    case 80:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5604 (insn, operands);

    case 81:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5608 (insn, operands);

    case 82:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5612 (insn, operands);

    case 83:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5616 (insn, operands);

    case 84:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5620 (insn, operands);

    case 85:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5624 (insn, operands);

    case 86:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5628 (insn, operands);

    case 87:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5632 (insn, operands);

    case 88:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5636 (insn, operands);

    case 89:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5640 (insn, operands);

    case 90:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5644 (insn, operands);

    case 91:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5648 (insn, operands);

    case 92:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5652 (insn, operands);

    case 93:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5656 (insn, operands);

    case 94:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5660 (insn, operands);

    case 95:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5664 (insn, operands);

    case 96:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5668 (insn, operands);

    case 97:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5672 (insn, operands);

    case 98:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5676 (insn, operands);

    case 99:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5680 (insn, operands);

    case 100:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5684 (insn, operands);

    case 101:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5688 (insn, operands);

    case 102:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5692 (insn, operands);

    case 103:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5696 (insn, operands);

    case 104:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5700 (insn, operands);

    case 105:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5704 (insn, operands);

    case 106:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5708 (insn, operands);

    case 107:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5712 (insn, operands);

    case 108:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5716 (insn, operands);

    case 109:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5720 (insn, operands);

    case 110:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5724 (insn, operands);

    case 111:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5728 (insn, operands);

    case 112:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5732 (insn, operands);

    case 113:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5736 (insn, operands);

    case 114:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5740 (insn, operands);

    case 115:
      if (!((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5744 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_168 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2595 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2609 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2623 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2637 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2651 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2665 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2679 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2693 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2707 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2721 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2735 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2749 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2763 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2777 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2791 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2805 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2819 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2833 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2847 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2861 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2875 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2889 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2903 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2917 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2931 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2945 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2959 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2973 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2987 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3001 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3015 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3029 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3043 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3057 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3071 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3085 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3099 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3113 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3127 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3141 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3155 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3169 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3183 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3197 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3211 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3225 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3239 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3253 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3267 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3281 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3295 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3309 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3323 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3337 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3351 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3365 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3379 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3393 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3407 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3421 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3435 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3449 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3463 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3477 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3491 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3505 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3519 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3533 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_179 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern381 (x1))
    {
    case 0:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1617 (insn, operands);

    case 1:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1618 (insn, operands);

    case 2:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1619 (insn, operands);

    case 3:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1620 (insn, operands);

    case 4:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1621 (insn, operands);

    case 5:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1622 (insn, operands);

    case 6:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1623 (insn, operands);

    case 7:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1624 (insn, operands);

    case 8:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1625 (insn, operands);

    case 9:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case 10:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case 11:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1628 (insn, operands);

    case 12:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case 13:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case 14:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1631 (insn, operands);

    case 15:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case 16:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case 17:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1634 (insn, operands);

    case 18:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1635 (insn, operands);

    case 19:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1636 (insn, operands);

    case 20:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1637 (insn, operands);

    case 21:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1638 (insn, operands);

    case 22:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1639 (insn, operands);

    case 23:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1640 (insn, operands);

    case 24:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1641 (insn, operands);

    case 25:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1642 (insn, operands);

    case 26:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1643 (insn, operands);

    case 27:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1644 (insn, operands);

    case 28:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1645 (insn, operands);

    case 29:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1646 (insn, operands);

    case 30:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1647 (insn, operands);

    case 31:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1648 (insn, operands);

    case 32:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1649 (insn, operands);

    case 33:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1650 (insn, operands);

    case 34:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1651 (insn, operands);

    case 35:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1652 (insn, operands);

    case 36:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1653 (insn, operands);

    case 37:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1654 (insn, operands);

    case 38:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1655 (insn, operands);

    case 39:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1656 (insn, operands);

    case 40:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1657 (insn, operands);

    case 41:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1658 (insn, operands);

    case 42:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1659 (insn, operands);

    case 43:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1660 (insn, operands);

    case 44:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1661 (insn, operands);

    case 45:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1662 (insn, operands);

    case 46:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1663 (insn, operands);

    case 47:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1664 (insn, operands);

    case 48:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1665 (insn, operands);

    case 49:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1666 (insn, operands);

    case 50:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1667 (insn, operands);

    case 51:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1668 (insn, operands);

    case 52:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1669 (insn, operands);

    case 53:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1670 (insn, operands);

    case 54:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1671 (insn, operands);

    case 55:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1672 (insn, operands);

    case 56:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1673 (insn, operands);

    case 57:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1674 (insn, operands);

    case 58:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1675 (insn, operands);

    case 59:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1676 (insn, operands);

    case 60:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1677 (insn, operands);

    case 61:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1678 (insn, operands);

    case 62:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1679 (insn, operands);

    case 63:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1680 (insn, operands);

    case 64:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1681 (insn, operands);

    case 65:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1682 (insn, operands);

    case 66:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1683 (insn, operands);

    case 67:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1684 (insn, operands);

    case 68:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1685 (insn, operands);

    case 69:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1686 (insn, operands);

    case 70:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1687 (insn, operands);

    case 71:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1688 (insn, operands);

    case 72:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1689 (insn, operands);

    case 73:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1690 (insn, operands);

    case 74:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1691 (insn, operands);

    case 75:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1692 (insn, operands);

    case 76:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1693 (insn, operands);

    case 77:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1694 (insn, operands);

    case 78:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1695 (insn, operands);

    case 79:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1696 (insn, operands);

    case 80:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1697 (insn, operands);

    case 81:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1698 (insn, operands);

    case 82:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1699 (insn, operands);

    case 83:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1700 (insn, operands);

    case 84:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1701 (insn, operands);

    case 85:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1702 (insn, operands);

    case 86:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1703 (insn, operands);

    case 87:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1704 (insn, operands);

    case 88:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1705 (insn, operands);

    case 89:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1706 (insn, operands);

    case 90:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1707 (insn, operands);

    case 91:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1708 (insn, operands);

    case 92:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1709 (insn, operands);

    case 93:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1710 (insn, operands);

    case 94:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1711 (insn, operands);

    case 95:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1712 (insn, operands);

    case 96:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1713 (insn, operands);

    case 97:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1714 (insn, operands);

    case 98:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1715 (insn, operands);

    case 99:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1716 (insn, operands);

    case 100:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1717 (insn, operands);

    case 101:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1718 (insn, operands);

    case 102:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1719 (insn, operands);

    case 103:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1720 (insn, operands);

    case 104:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1721 (insn, operands);

    case 105:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1722 (insn, operands);

    case 106:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1723 (insn, operands);

    case 107:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1724 (insn, operands);

    case 108:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1725 (insn, operands);

    case 109:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1726 (insn, operands);

    case 110:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1727 (insn, operands);

    case 111:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1728 (insn, operands);

    case 112:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1729 (insn, operands);

    case 113:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1730 (insn, operands);

    case 114:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1731 (insn, operands);

    case 115:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1732 (insn, operands);

    case 116:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1733 (insn, operands);

    case 117:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1734 (insn, operands);

    case 118:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1735 (insn, operands);

    case 119:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1736 (insn, operands);

    case 120:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1737 (insn, operands);

    case 121:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1738 (insn, operands);

    case 122:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1739 (insn, operands);

    case 123:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1740 (insn, operands);

    case 124:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1741 (insn, operands);

    case 125:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1742 (insn, operands);

    case 126:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1743 (insn, operands);

    case 127:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1744 (insn, operands);

    case 128:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1745 (insn, operands);

    case 129:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1746 (insn, operands);

    case 130:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1747 (insn, operands);

    case 131:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1748 (insn, operands);

    case 132:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1749 (insn, operands);

    case 133:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1750 (insn, operands);

    case 134:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1751 (insn, operands);

    case 135:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1752 (insn, operands);

    case 136:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1753 (insn, operands);

    case 137:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1754 (insn, operands);

    case 138:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1755 (insn, operands);

    case 139:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1756 (insn, operands);

    case 140:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1757 (insn, operands);

    case 141:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1758 (insn, operands);

    case 142:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1759 (insn, operands);

    case 143:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1760 (insn, operands);

    case 144:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1761 (insn, operands);

    case 145:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1762 (insn, operands);

    case 146:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1763 (insn, operands);

    case 147:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1764 (insn, operands);

    case 148:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1765 (insn, operands);

    case 149:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1766 (insn, operands);

    case 150:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1767 (insn, operands);

    case 151:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1768 (insn, operands);

    case 152:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1769 (insn, operands);

    case 153:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1770 (insn, operands);

    case 154:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1771 (insn, operands);

    case 155:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1772 (insn, operands);

    case 156:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1773 (insn, operands);

    case 157:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1774 (insn, operands);

    case 158:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1775 (insn, operands);

    case 159:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1776 (insn, operands);

    case 160:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1777 (insn, operands);

    case 161:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1778 (insn, operands);

    case 162:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1779 (insn, operands);

    case 163:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1780 (insn, operands);

    case 164:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1781 (insn, operands);

    case 165:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1782 (insn, operands);

    case 166:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1783 (insn, operands);

    case 167:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1784 (insn, operands);

    case 168:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1785 (insn, operands);

    case 169:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1786 (insn, operands);

    case 170:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1787 (insn, operands);

    case 171:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1788 (insn, operands);

    case 172:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1789 (insn, operands);

    case 173:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1790 (insn, operands);

    case 174:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1791 (insn, operands);

    case 175:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1792 (insn, operands);

    case 176:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1793 (insn, operands);

    case 177:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1794 (insn, operands);

    case 178:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1795 (insn, operands);

    case 179:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1796 (insn, operands);

    case 180:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1797 (insn, operands);

    case 181:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1798 (insn, operands);

    case 182:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1799 (insn, operands);

    case 183:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1800 (insn, operands);

    case 184:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1801 (insn, operands);

    case 185:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1802 (insn, operands);

    case 186:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1803 (insn, operands);

    case 187:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1804 (insn, operands);

    case 188:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1805 (insn, operands);

    case 189:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1806 (insn, operands);

    case 190:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1807 (insn, operands);

    case 191:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1808 (insn, operands);

    case 192:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1809 (insn, operands);

    case 193:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1810 (insn, operands);

    case 194:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1811 (insn, operands);

    case 195:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1812 (insn, operands);

    case 196:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1813 (insn, operands);

    case 197:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1814 (insn, operands);

    case 198:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1815 (insn, operands);

    case 199:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1816 (insn, operands);

    case 200:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1817 (insn, operands);

    case 201:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1818 (insn, operands);

    case 202:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1819 (insn, operands);

    case 203:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1820 (insn, operands);

    case 204:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1821 (insn, operands);

    case 205:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1822 (insn, operands);

    case 206:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1823 (insn, operands);

    case 207:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1824 (insn, operands);

    case 208:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1825 (insn, operands);

    case 209:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1826 (insn, operands);

    case 210:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1827 (insn, operands);

    case 211:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1828 (insn, operands);

    case 212:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1829 (insn, operands);

    case 213:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1830 (insn, operands);

    case 214:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1831 (insn, operands);

    case 215:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1832 (insn, operands);

    case 216:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1833 (insn, operands);

    case 217:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1834 (insn, operands);

    case 218:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1835 (insn, operands);

    case 219:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1836 (insn, operands);

    case 220:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1837 (insn, operands);

    case 221:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1838 (insn, operands);

    case 222:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1839 (insn, operands);

    case 223:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1840 (insn, operands);

    case 224:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1841 (insn, operands);

    case 225:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1842 (insn, operands);

    case 226:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1843 (insn, operands);

    case 227:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1844 (insn, operands);

    case 228:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1845 (insn, operands);

    case 229:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1846 (insn, operands);

    case 230:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1847 (insn, operands);

    case 231:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1848 (insn, operands);

    case 232:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1849 (insn, operands);

    case 233:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1850 (insn, operands);

    case 234:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1851 (insn, operands);

    case 235:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1852 (insn, operands);

    case 236:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1853 (insn, operands);

    case 237:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1854 (insn, operands);

    case 238:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1855 (insn, operands);

    case 239:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1856 (insn, operands);

    case 240:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1857 (insn, operands);

    case 241:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1858 (insn, operands);

    case 242:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1859 (insn, operands);

    case 243:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1860 (insn, operands);

    case 244:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1861 (insn, operands);

    case 245:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1862 (insn, operands);

    case 246:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1863 (insn, operands);

    case 247:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1864 (insn, operands);

    case 248:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1865 (insn, operands);

    case 249:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1866 (insn, operands);

    case 250:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1867 (insn, operands);

    case 251:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1868 (insn, operands);

    case 252:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1869 (insn, operands);

    case 253:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1870 (insn, operands);

    case 254:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1871 (insn, operands);

    case 255:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1872 (insn, operands);

    case 256:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1873 (insn, operands);

    case 257:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1874 (insn, operands);

    case 258:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1875 (insn, operands);

    case 259:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1876 (insn, operands);

    case 260:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1877 (insn, operands);

    case 261:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1878 (insn, operands);

    case 262:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1879 (insn, operands);

    case 263:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1880 (insn, operands);

    case 264:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1881 (insn, operands);

    case 265:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1882 (insn, operands);

    case 266:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1883 (insn, operands);

    case 267:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1884 (insn, operands);

    case 268:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1885 (insn, operands);

    case 269:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1886 (insn, operands);

    case 270:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1887 (insn, operands);

    case 271:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1888 (insn, operands);

    case 272:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1889 (insn, operands);

    case 273:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1890 (insn, operands);

    case 274:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1891 (insn, operands);

    case 275:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1892 (insn, operands);

    case 276:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1893 (insn, operands);

    case 277:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1894 (insn, operands);

    case 278:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1895 (insn, operands);

    case 279:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1896 (insn, operands);

    case 280:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1897 (insn, operands);

    case 281:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1898 (insn, operands);

    case 282:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1899 (insn, operands);

    case 283:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1900 (insn, operands);

    case 284:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1901 (insn, operands);

    case 285:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1902 (insn, operands);

    case 286:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1903 (insn, operands);

    case 287:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1904 (insn, operands);

    case 288:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1905 (insn, operands);

    case 289:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 290:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1907 (insn, operands);

    case 291:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1908 (insn, operands);

    case 292:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1909 (insn, operands);

    case 293:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1910 (insn, operands);

    case 294:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1911 (insn, operands);

    case 295:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1912 (insn, operands);

    case 296:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 297:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1914 (insn, operands);

    case 298:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1915 (insn, operands);

    case 299:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1916 (insn, operands);

    case 300:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1917 (insn, operands);

    case 301:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1918 (insn, operands);

    case 302:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1919 (insn, operands);

    case 303:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 304:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1921 (insn, operands);

    case 305:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1922 (insn, operands);

    case 306:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1923 (insn, operands);

    case 307:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1924 (insn, operands);

    case 308:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1925 (insn, operands);

    case 309:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1926 (insn, operands);

    case 310:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 311:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1928 (insn, operands);

    case 312:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1929 (insn, operands);

    case 313:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1930 (insn, operands);

    case 314:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1931 (insn, operands);

    case 315:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1932 (insn, operands);

    case 316:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1933 (insn, operands);

    case 317:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1934 (insn, operands);

    case 318:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1935 (insn, operands);

    case 319:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1936 (insn, operands);

    case 320:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 321:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1938 (insn, operands);

    case 322:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1939 (insn, operands);

    case 323:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1940 (insn, operands);

    case 324:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 325:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1942 (insn, operands);

    case 326:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1943 (insn, operands);

    case 327:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1944 (insn, operands);

    case 328:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    case 329:
      if (!((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1946 (insn, operands);

    default:
      return NULL;
    }
}
