/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SCRATCH)
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[0] = x8;
  x9 = XVECEXP (x3, 0, 1);
  operands[4] = x9;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[5] = x10;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[1] = x11;
  if (!pmode_reg_or_0_operand (operands[1], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 2);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 3);
  operands[3] = x13;
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF8QImode:
          return pattern185 (
E_RVVMF8QImode); /* [-1, 63] */

        case E_RVVMF4HImode:
          res = pattern185 (
E_RVVMF4HImode);
          if (res >= 0)
            return res + 64; /* [64, 127] */
          return -1;

        case E_RVVMF2SImode:
          res = pattern185 (
E_RVVMF2SImode);
          if (res >= 0)
            return res + 128; /* [128, 191] */
          return -1;

        case E_RVVM1DImode:
          res = pattern185 (
E_RVVM1DImode);
          if (res >= 0)
            return res + 192; /* [192, 255] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4QImode:
          res = pattern186 (
E_RVVMF4QImode);
          if (res >= 0)
            return res + 256; /* [256, 311] */
          return -1;

        case E_RVVMF2HImode:
          res = pattern186 (
E_RVVMF2HImode);
          if (res >= 0)
            return res + 312; /* [312, 367] */
          return -1;

        case E_RVVM1SImode:
          res = pattern186 (
E_RVVM1SImode);
          if (res >= 0)
            return res + 368; /* [368, 423] */
          return -1;

        case E_RVVM2DImode:
          res = pattern186 (
E_RVVM2DImode);
          if (res >= 0)
            return res + 424; /* [424, 479] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2QImode:
          res = pattern187 (
E_RVVMF2QImode);
          if (res >= 0)
            return res + 480; /* [480, 523] */
          return -1;

        case E_RVVM1HImode:
          res = pattern187 (
E_RVVM1HImode);
          if (res >= 0)
            return res + 524; /* [524, 567] */
          return -1;

        case E_RVVM2SImode:
          res = pattern187 (
E_RVVM2SImode);
          if (res >= 0)
            return res + 568; /* [568, 611] */
          return -1;

        case E_RVVM4DImode:
          res = pattern187 (
E_RVVM4DImode);
          if (res >= 0)
            return res + 612; /* [612, 655] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1QImode:
          res = pattern188 (
E_RVVM1QImode);
          if (res >= 0)
            return res + 656; /* [656, 681] */
          return -1;

        case E_RVVM2HImode:
          res = pattern188 (
E_RVVM2HImode);
          if (res >= 0)
            return res + 682; /* [682, 707] */
          return -1;

        case E_RVVM4SImode:
          res = pattern188 (
E_RVVM4SImode);
          if (res >= 0)
            return res + 708; /* [708, 733] */
          return -1;

        case E_RVVM8DImode:
          res = pattern188 (
E_RVVM8DImode);
          if (res >= 0)
            return res + 734; /* [734, 759] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2QImode:
          res = pattern189 (
E_RVVM2QImode);
          if (res >= 0)
            return res + 760; /* [760, 771] */
          return -1;

        case E_RVVM4HImode:
          res = pattern189 (
E_RVVM4HImode);
          if (res >= 0)
            return res + 772; /* [772, 783] */
          return -1;

        case E_RVVM8SImode:
          res = pattern189 (
E_RVVM8SImode);
          if (res >= 0)
            return res + 784; /* [784, 795] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4QImode:
          res = pattern190 (
E_RVVM4QImode);
          if (res >= 0)
            return res + 796; /* [796, 800] */
          return -1;

        case E_RVVM8HImode:
          res = pattern190 (
E_RVVM8HImode);
          if (res >= 0)
            return res + 801; /* [801, 805] */
          return -1;

        default:
          return -1;
        }

    case E_RVVM1BImode:
      if (!vector_mask_operand (operands[0], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM8QImode)
          || !register_operand (operands[3], E_RVVM8QImode))
        return -1;
      return 806;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern217 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern217 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern217 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern217 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern217 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern217 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern217 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern217 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern217 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern217 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern217 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern217 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern217 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern217 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern217 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern217 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern217 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern217 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVM8DImode:
      if (pattern217 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 18;

    case E_RVVM4DImode:
      if (pattern217 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 19;

    case E_RVVM2DImode:
      if (pattern217 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 20;

    case E_RVVM1DImode:
      if (pattern217 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern217 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern217 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern217 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern217 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern217 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern217 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern217 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern217 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern217 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern217 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern217 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern217 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern217 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern217 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern217 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern217 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern217 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern217 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern217 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern217 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern217 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern217 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern217 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern217 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern217 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern217 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern217 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern217 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern217 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern217 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern217 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern217 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern217 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern217 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern217 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern217 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern217 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern217 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern217 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern217 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern217 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern217 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern217 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern217 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern217 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern217 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 91
      || GET_MODE (x3) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM8SFmode:
      if (!register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (!register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (!register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 4;

    case E_V1SFmode:
      if (!register_operand (operands[1], E_V1HFmode))
        return -1;
      return 5;

    case E_V2SFmode:
      if (!register_operand (operands[1], E_V2HFmode))
        return -1;
      return 6;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 7;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 9;

    case E_V32SFmode:
      if (!register_operand (operands[1], E_V32HFmode))
        return -1;
      return 10;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 11;

    case E_V128SFmode:
      if (!register_operand (operands[1], E_V128HFmode))
        return -1;
      return 12;

    case E_V256SFmode:
      if (!register_operand (operands[1], E_V256HFmode))
        return -1;
      return 13;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 14;

    case E_V1024SFmode:
      if (!register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 0;

    case E_RVVM4DFmode:
      if (!register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 2;

    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 3;

    case E_V1DFmode:
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      return 4;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V16DFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 8;

    case E_V32DFmode:
      if (!register_operand (operands[1], E_V32SFmode))
        return -1;
      return 9;

    case E_V64DFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 10;

    case E_V128DFmode:
      if (!register_operand (operands[1], E_V128SFmode))
        return -1;
      return 11;

    case E_V256DFmode:
      if (!register_operand (operands[1], E_V256SFmode))
        return -1;
      return 12;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[1], E_RVVM4QImode))
            return -1;
          return 0;

        case E_RVVM4HImode:
          if (!register_operand (operands[1], E_RVVM2QImode))
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (!register_operand (operands[1], E_RVVM1QImode))
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (!register_operand (operands[1], E_RVVMF2QImode))
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (!register_operand (operands[1], E_RVVMF4QImode))
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (!register_operand (operands[1], E_RVVMF8QImode))
            return -1;
          return 5;

        case E_V1HImode:
          if (!register_operand (operands[1], E_V1QImode))
            return -1;
          return 6;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2QImode))
            return -1;
          return 7;

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4QImode))
            return -1;
          return 8;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 9;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 10;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 11;

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 12;

        case E_V128HImode:
          if (!register_operand (operands[1], E_V128QImode))
            return -1;
          return 13;

        case E_V256HImode:
          if (!register_operand (operands[1], E_V256QImode))
            return -1;
          return 14;

        case E_V512HImode:
          if (!register_operand (operands[1], E_V512QImode))
            return -1;
          return 15;

        case E_V1024HImode:
          if (!register_operand (operands[1], E_V1024QImode))
            return -1;
          return 16;

        case E_V2048HImode:
          if (!register_operand (operands[1], E_V2048QImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[1], E_RVVM4HImode))
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (!register_operand (operands[1], E_RVVM2HImode))
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (!register_operand (operands[1], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (!register_operand (operands[1], E_RVVMF2HImode))
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (!register_operand (operands[1], E_RVVMF4HImode))
            return -1;
          return 22;

        case E_V1SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (!register_operand (operands[1], E_V1024HImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[1], E_RVVM4SImode))
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (!register_operand (operands[1], E_RVVM2SImode))
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (!register_operand (operands[1], E_RVVM1SImode))
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (!register_operand (operands[1], E_RVVMF2SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern254 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XEXP (x2, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1BImode:
          return 0;

        case E_RVVMF2BImode:
          return 1;

        case E_RVVMF4BImode:
          return 2;

        case E_RVVMF8BImode:
          return 3;

        case E_RVVMF16BImode:
          return 4;

        case E_RVVMF32BImode:
          return 5;

        case E_RVVMF64BImode:
          return 6;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x2, 1);
      operands[1] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1BImode:
              return 7;

            case E_RVVMF2BImode:
              return 8;

            case E_RVVMF4BImode:
              return 9;

            case E_RVVMF8BImode:
              return 10;

            case E_RVVMF16BImode:
              return 11;

            case E_RVVMF32BImode:
              return 12;

            case E_RVVMF64BImode:
              return 13;

            case E_V1BImode:
              return 14;

            case E_V2BImode:
              return 15;

            case E_V4BImode:
              return 16;

            case E_V8BImode:
              return 17;

            case E_V16BImode:
              return 18;

            case E_V32BImode:
              return 19;

            case E_V64BImode:
              return 20;

            case E_V128BImode:
              return 21;

            case E_V256BImode:
              return 22;

            case E_V512BImode:
              return 23;

            case E_V1024BImode:
              return 24;

            case E_V2048BImode:
              return 25;

            case E_V4096BImode:
              return 26;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF8BImode:
              if (pattern253 (x1, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
                return -1;
              return 27;

            case E_RVVMF16BImode:
              if (pattern253 (x1, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
                return -1;
              return 28;

            case E_RVVMF32BImode:
              if (pattern253 (x1, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
                return -1;
              return 29;

            case E_RVVMF64BImode:
              if (pattern253 (x1, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
                return -1;
              return 30;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern261 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern261 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (!const_int_operand (x4, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 93)
    return -1;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  return pattern121 (x1); /* [-1, 3] */
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 34
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 34
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case NOT:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern279 (x6); /* [-1, 1] */
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern334 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case NOT:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_SImode:
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_SImode:
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      return pattern346 (
E_RVVMF2QImode); /* [-1, 1] */

    case E_RVVMF4QImode:
      res = pattern346 (
E_RVVMF4QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern346 (
E_RVVMF8QImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern346 (
E_RVVMF2HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern346 (
E_RVVMF4HImode);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern346 (
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern346 (
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 12; /* [12, 13] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern346 (
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 14; /* [14, 15] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern346 (
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern346 (
E_RVVMF2SImode);
      if (res >= 0)
        return res + 18; /* [18, 19] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern346 (
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 20; /* [20, 21] */
      return -1;

    case E_RVVMF64BImode:
      res = pattern346 (
E_RVVMF64BImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVMF32BImode:
      res = pattern346 (
E_RVVMF32BImode);
      if (res >= 0)
        return res + 24; /* [24, 25] */
      return -1;

    case E_RVVMF16BImode:
      res = pattern346 (
E_RVVMF16BImode);
      if (res >= 0)
        return res + 26; /* [26, 27] */
      return -1;

    case E_RVVMF8BImode:
      res = pattern346 (
E_RVVMF8BImode);
      if (res >= 0)
        return res + 28; /* [28, 29] */
      return -1;

    case E_RVVMF4BImode:
      res = pattern346 (
E_RVVMF4BImode);
      if (res >= 0)
        return res + 30; /* [30, 31] */
      return -1;

    case E_RVVMF2BImode:
      res = pattern346 (
E_RVVMF2BImode);
      if (res >= 0)
        return res + 32; /* [32, 33] */
      return -1;

    case E_RVVM1BImode:
      res = pattern346 (
E_RVVM1BImode);
      if (res >= 0)
        return res + 34; /* [34, 35] */
      return -1;

    case E_V32QImode:
      res = pattern346 (
E_V32QImode);
      if (res >= 0)
        return res + 36; /* [36, 37] */
      return -1;

    case E_V64QImode:
      res = pattern346 (
E_V64QImode);
      if (res >= 0)
        return res + 38; /* [38, 39] */
      return -1;

    case E_V128QImode:
      res = pattern346 (
E_V128QImode);
      if (res >= 0)
        return res + 40; /* [40, 41] */
      return -1;

    case E_V256QImode:
      res = pattern346 (
E_V256QImode);
      if (res >= 0)
        return res + 42; /* [42, 43] */
      return -1;

    case E_V512QImode:
      res = pattern346 (
E_V512QImode);
      if (res >= 0)
        return res + 44; /* [44, 45] */
      return -1;

    case E_V1024QImode:
      res = pattern346 (
E_V1024QImode);
      if (res >= 0)
        return res + 46; /* [46, 47] */
      return -1;

    case E_V2048QImode:
      res = pattern346 (
E_V2048QImode);
      if (res >= 0)
        return res + 48; /* [48, 49] */
      return -1;

    case E_V4096QImode:
      res = pattern346 (
E_V4096QImode);
      if (res >= 0)
        return res + 50; /* [50, 51] */
      return -1;

    case E_V32HImode:
      res = pattern346 (
E_V32HImode);
      if (res >= 0)
        return res + 52; /* [52, 53] */
      return -1;

    case E_V64HImode:
      res = pattern346 (
E_V64HImode);
      if (res >= 0)
        return res + 54; /* [54, 55] */
      return -1;

    case E_V128HImode:
      res = pattern346 (
E_V128HImode);
      if (res >= 0)
        return res + 56; /* [56, 57] */
      return -1;

    case E_V256HImode:
      res = pattern346 (
E_V256HImode);
      if (res >= 0)
        return res + 58; /* [58, 59] */
      return -1;

    case E_V512HImode:
      res = pattern346 (
E_V512HImode);
      if (res >= 0)
        return res + 60; /* [60, 61] */
      return -1;

    case E_V1024HImode:
      res = pattern346 (
E_V1024HImode);
      if (res >= 0)
        return res + 62; /* [62, 63] */
      return -1;

    case E_V2048HImode:
      res = pattern346 (
E_V2048HImode);
      if (res >= 0)
        return res + 64; /* [64, 65] */
      return -1;

    case E_V32SImode:
      res = pattern346 (
E_V32SImode);
      if (res >= 0)
        return res + 66; /* [66, 67] */
      return -1;

    case E_V64SImode:
      res = pattern346 (
E_V64SImode);
      if (res >= 0)
        return res + 68; /* [68, 69] */
      return -1;

    case E_V128SImode:
      res = pattern346 (
E_V128SImode);
      if (res >= 0)
        return res + 70; /* [70, 71] */
      return -1;

    case E_V256SImode:
      res = pattern346 (
E_V256SImode);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V512SImode:
      res = pattern346 (
E_V512SImode);
      if (res >= 0)
        return res + 74; /* [74, 75] */
      return -1;

    case E_V1024SImode:
      res = pattern346 (
E_V1024SImode);
      if (res >= 0)
        return res + 76; /* [76, 77] */
      return -1;

    case E_V32DImode:
      res = pattern346 (
E_V32DImode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_V64DImode:
      res = pattern346 (
E_V64DImode);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    case E_V128DImode:
      res = pattern346 (
E_V128DImode);
      if (res >= 0)
        return res + 82; /* [82, 83] */
      return -1;

    case E_V256DImode:
      res = pattern346 (
E_V256DImode);
      if (res >= 0)
        return res + 84; /* [84, 85] */
      return -1;

    case E_V512DImode:
      res = pattern346 (
E_V512DImode);
      if (res >= 0)
        return res + 86; /* [86, 87] */
      return -1;

    case E_V32HFmode:
      res = pattern346 (
E_V32HFmode);
      if (res >= 0)
        return res + 88; /* [88, 89] */
      return -1;

    case E_V64HFmode:
      res = pattern346 (
E_V64HFmode);
      if (res >= 0)
        return res + 90; /* [90, 91] */
      return -1;

    case E_V128HFmode:
      res = pattern346 (
E_V128HFmode);
      if (res >= 0)
        return res + 92; /* [92, 93] */
      return -1;

    case E_V256HFmode:
      res = pattern346 (
E_V256HFmode);
      if (res >= 0)
        return res + 94; /* [94, 95] */
      return -1;

    case E_V512HFmode:
      res = pattern346 (
E_V512HFmode);
      if (res >= 0)
        return res + 96; /* [96, 97] */
      return -1;

    case E_V1024HFmode:
      res = pattern346 (
E_V1024HFmode);
      if (res >= 0)
        return res + 98; /* [98, 99] */
      return -1;

    case E_V2048HFmode:
      res = pattern346 (
E_V2048HFmode);
      if (res >= 0)
        return res + 100; /* [100, 101] */
      return -1;

    case E_V32SFmode:
      res = pattern346 (
E_V32SFmode);
      if (res >= 0)
        return res + 102; /* [102, 103] */
      return -1;

    case E_V64SFmode:
      res = pattern346 (
E_V64SFmode);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V128SFmode:
      res = pattern346 (
E_V128SFmode);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V256SFmode:
      res = pattern346 (
E_V256SFmode);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V512SFmode:
      res = pattern346 (
E_V512SFmode);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V1024SFmode:
      res = pattern346 (
E_V1024SFmode);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V32DFmode:
      res = pattern346 (
E_V32DFmode);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V64DFmode:
      res = pattern346 (
E_V64DFmode);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V128DFmode:
      res = pattern346 (
E_V128DFmode);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V256DFmode:
      res = pattern346 (
E_V256DFmode);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V512DFmode:
      res = pattern346 (
E_V512DFmode);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V32BImode:
      res = pattern346 (
E_V32BImode);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    case E_V64BImode:
      res = pattern346 (
E_V64BImode);
      if (res >= 0)
        return res + 126; /* [126, 127] */
      return -1;

    case E_V128BImode:
      res = pattern346 (
E_V128BImode);
      if (res >= 0)
        return res + 128; /* [128, 129] */
      return -1;

    case E_V256BImode:
      res = pattern346 (
E_V256BImode);
      if (res >= 0)
        return res + 130; /* [130, 131] */
      return -1;

    case E_V512BImode:
      res = pattern346 (
E_V512BImode);
      if (res >= 0)
        return res + 132; /* [132, 133] */
      return -1;

    case E_V1024BImode:
      res = pattern346 (
E_V1024BImode);
      if (res >= 0)
        return res + 134; /* [134, 135] */
      return -1;

    case E_V2048BImode:
      res = pattern346 (
E_V2048BImode);
      if (res >= 0)
        return res + 136; /* [136, 137] */
      return -1;

    case E_V4096BImode:
      res = pattern346 (
E_V4096BImode);
      if (res >= 0)
        return res + 138; /* [138, 139] */
      return -1;

    default:
      return -1;
    }
}

int
pattern412 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern416 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern420 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 1);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[6] = x14;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      return pattern430 (
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern430 (
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          return pattern440 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

        case E_RVVMF32BImode:
          if (pattern440 (x1, 
E_RVVMF32BImode) != 0)
            return -1;
          return 1;

        case E_RVVMF16BImode:
          if (pattern440 (x1, 
E_RVVMF16BImode) != 0)
            return -1;
          return 2;

        case E_RVVMF8BImode:
          if (pattern440 (x1, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4BImode:
          if (pattern440 (x1, 
E_RVVMF4BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF2BImode:
          if (pattern440 (x1, 
E_RVVMF2BImode) != 0)
            return -1;
          return 5;

        case E_RVVM1BImode:
          if (pattern440 (x1, 
E_RVVM1BImode) != 0)
            return -1;
          return 6;

        case E_V1BImode:
          if (pattern440 (x1, 
E_V1BImode) != 0)
            return -1;
          return 7;

        case E_V2BImode:
          if (pattern440 (x1, 
E_V2BImode) != 0)
            return -1;
          return 8;

        case E_V4BImode:
          if (pattern440 (x1, 
E_V4BImode) != 0)
            return -1;
          return 9;

        case E_V8BImode:
          if (pattern440 (x1, 
E_V8BImode) != 0)
            return -1;
          return 10;

        case E_V16BImode:
          if (pattern440 (x1, 
E_V16BImode) != 0)
            return -1;
          return 11;

        case E_V32BImode:
          if (pattern440 (x1, 
E_V32BImode) != 0)
            return -1;
          return 12;

        case E_V64BImode:
          if (pattern440 (x1, 
E_V64BImode) != 0)
            return -1;
          return 13;

        case E_V128BImode:
          if (pattern440 (x1, 
E_V128BImode) != 0)
            return -1;
          return 14;

        case E_V256BImode:
          if (pattern440 (x1, 
E_V256BImode) != 0)
            return -1;
          return 15;

        case E_V512BImode:
          if (pattern440 (x1, 
E_V512BImode) != 0)
            return -1;
          return 16;

        case E_V1024BImode:
          if (pattern440 (x1, 
E_V1024BImode) != 0)
            return -1;
          return 17;

        case E_V2048BImode:
          if (pattern440 (x1, 
E_V2048BImode) != 0)
            return -1;
          return 18;

        case E_V4096BImode:
          if (pattern440 (x1, 
E_V4096BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    case NOT:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern441 (x1, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF32BImode:
          if (pattern441 (x1, 
E_RVVMF32BImode) != 0)
            return -1;
          return 21;

        case E_RVVMF16BImode:
          if (pattern441 (x1, 
E_RVVMF16BImode) != 0)
            return -1;
          return 22;

        case E_RVVMF8BImode:
          if (pattern441 (x1, 
E_RVVMF8BImode) != 0)
            return -1;
          return 23;

        case E_RVVMF4BImode:
          if (pattern441 (x1, 
E_RVVMF4BImode) != 0)
            return -1;
          return 24;

        case E_RVVMF2BImode:
          if (pattern441 (x1, 
E_RVVMF2BImode) != 0)
            return -1;
          return 25;

        case E_RVVM1BImode:
          if (pattern441 (x1, 
E_RVVM1BImode) != 0)
            return -1;
          return 26;

        case E_V1BImode:
          if (pattern441 (x1, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2BImode:
          if (pattern441 (x1, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4BImode:
          if (pattern441 (x1, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8BImode:
          if (pattern441 (x1, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16BImode:
          if (pattern441 (x1, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32BImode:
          if (pattern441 (x1, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64BImode:
          if (pattern441 (x1, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128BImode:
          if (pattern441 (x1, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256BImode:
          if (pattern441 (x1, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512BImode:
          if (pattern441 (x1, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024BImode:
          if (pattern441 (x1, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V2048BImode:
          if (pattern441 (x1, 
E_V2048BImode) != 0)
            return -1;
          return 38;

        case E_V4096BImode:
          if (pattern441 (x1, 
E_V4096BImode) != 0)
            return -1;
          return 39;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern484 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern484 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern484 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern484 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern484 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern484 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern484 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern484 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    case E_V1BImode:
      if (pattern484 (x1, 
E_V1BImode) != 0)
        return -1;
      return 7;

    case E_V2BImode:
      if (pattern484 (x1, 
E_V2BImode) != 0)
        return -1;
      return 8;

    case E_V4BImode:
      if (pattern484 (x1, 
E_V4BImode) != 0)
        return -1;
      return 9;

    case E_V8BImode:
      if (pattern484 (x1, 
E_V8BImode) != 0)
        return -1;
      return 10;

    case E_V16BImode:
      if (pattern484 (x1, 
E_V16BImode) != 0)
        return -1;
      return 11;

    case E_V32BImode:
      if (pattern484 (x1, 
E_V32BImode) != 0)
        return -1;
      return 12;

    case E_V64BImode:
      if (pattern484 (x1, 
E_V64BImode) != 0)
        return -1;
      return 13;

    case E_V128BImode:
      if (pattern484 (x1, 
E_V128BImode) != 0)
        return -1;
      return 14;

    case E_V256BImode:
      if (pattern484 (x1, 
E_V256BImode) != 0)
        return -1;
      return 15;

    case E_V512BImode:
      if (pattern484 (x1, 
E_V512BImode) != 0)
        return -1;
      return 16;

    case E_V1024BImode:
      if (pattern484 (x1, 
E_V1024BImode) != 0)
        return -1;
      return 17;

    case E_V2048BImode:
      if (pattern484 (x1, 
E_V2048BImode) != 0)
        return -1;
      return 18;

    case E_V4096BImode:
      if (pattern484 (x1, 
E_V4096BImode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern493 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      x10 = XEXP (x8, 1);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern495 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern495 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern495 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern495 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern495 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern495 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern495 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern495 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern495 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern495 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern495 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern495 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern495 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern495 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern495 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern495 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern495 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern495 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern495 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern495 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern495 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern495 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_V1QImode:
          if (pattern495 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 22;

        case E_V2QImode:
          if (pattern495 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 23;

        case E_V4QImode:
          if (pattern495 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 24;

        case E_V8QImode:
          if (pattern495 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 25;

        case E_V16QImode:
          if (pattern495 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 26;

        case E_V32QImode:
          if (pattern495 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 27;

        case E_V64QImode:
          if (pattern495 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 28;

        case E_V128QImode:
          if (pattern495 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 29;

        case E_V256QImode:
          if (pattern495 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 30;

        case E_V512QImode:
          if (pattern495 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 31;

        case E_V1024QImode:
          if (pattern495 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 32;

        case E_V2048QImode:
          if (pattern495 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 33;

        case E_V4096QImode:
          if (pattern495 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 34;

        case E_V1HImode:
          if (pattern495 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 35;

        case E_V2HImode:
          if (pattern495 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 36;

        case E_V4HImode:
          if (pattern495 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 37;

        case E_V8HImode:
          if (pattern495 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 38;

        case E_V16HImode:
          if (pattern495 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 39;

        case E_V32HImode:
          if (pattern495 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 40;

        case E_V64HImode:
          if (pattern495 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 41;

        case E_V128HImode:
          if (pattern495 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 42;

        case E_V256HImode:
          if (pattern495 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 43;

        case E_V512HImode:
          if (pattern495 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 44;

        case E_V1024HImode:
          if (pattern495 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 45;

        case E_V2048HImode:
          if (pattern495 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 46;

        case E_V1SImode:
          if (pattern495 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 47;

        case E_V2SImode:
          if (pattern495 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 48;

        case E_V4SImode:
          if (pattern495 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 49;

        case E_V8SImode:
          if (pattern495 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 50;

        case E_V16SImode:
          if (pattern495 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 51;

        case E_V32SImode:
          if (pattern495 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 52;

        case E_V64SImode:
          if (pattern495 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 53;

        case E_V128SImode:
          if (pattern495 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 54;

        case E_V256SImode:
          if (pattern495 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 55;

        case E_V512SImode:
          if (pattern495 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 56;

        case E_V1024SImode:
          if (pattern495 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 57;

        case E_V1DImode:
          if (pattern495 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 58;

        case E_V2DImode:
          if (pattern495 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 59;

        case E_V4DImode:
          if (pattern495 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 60;

        case E_V8DImode:
          if (pattern495 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 61;

        case E_V16DImode:
          if (pattern495 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 62;

        case E_V32DImode:
          if (pattern495 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 63;

        case E_V64DImode:
          if (pattern495 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 64;

        case E_V128DImode:
          if (pattern495 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 65;

        case E_V256DImode:
          if (pattern495 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 66;

        case E_V512DImode:
          if (pattern495 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 67;

        case E_RVVM8HFmode:
          if (pattern495 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 68;

        case E_RVVM4HFmode:
          if (pattern495 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 69;

        case E_RVVM2HFmode:
          if (pattern495 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 70;

        case E_RVVM1HFmode:
          if (pattern495 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 71;

        case E_RVVMF2HFmode:
          if (pattern495 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 72;

        case E_RVVMF4HFmode:
          if (pattern495 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 73;

        case E_RVVM8SFmode:
          if (pattern495 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 74;

        case E_RVVM4SFmode:
          if (pattern495 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 75;

        case E_RVVM2SFmode:
          if (pattern495 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 76;

        case E_RVVM1SFmode:
          if (pattern495 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 77;

        case E_RVVMF2SFmode:
          if (pattern495 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 78;

        case E_RVVM8DFmode:
          if (pattern495 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 79;

        case E_RVVM4DFmode:
          if (pattern495 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 80;

        case E_RVVM2DFmode:
          if (pattern495 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 81;

        case E_RVVM1DFmode:
          if (pattern495 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 82;

        case E_V1HFmode:
          if (pattern495 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 83;

        case E_V2HFmode:
          if (pattern495 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 84;

        case E_V4HFmode:
          if (pattern495 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 85;

        case E_V8HFmode:
          if (pattern495 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 86;

        case E_V16HFmode:
          if (pattern495 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 87;

        case E_V32HFmode:
          if (pattern495 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 88;

        case E_V64HFmode:
          if (pattern495 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 89;

        case E_V128HFmode:
          if (pattern495 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 90;

        case E_V256HFmode:
          if (pattern495 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 91;

        case E_V512HFmode:
          if (pattern495 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 92;

        case E_V1024HFmode:
          if (pattern495 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 93;

        case E_V2048HFmode:
          if (pattern495 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 94;

        case E_V1SFmode:
          if (pattern495 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 95;

        case E_V2SFmode:
          if (pattern495 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 96;

        case E_V4SFmode:
          if (pattern495 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 97;

        case E_V8SFmode:
          if (pattern495 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 98;

        case E_V16SFmode:
          if (pattern495 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 99;

        case E_V32SFmode:
          if (pattern495 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 100;

        case E_V64SFmode:
          if (pattern495 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 101;

        case E_V128SFmode:
          if (pattern495 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 102;

        case E_V256SFmode:
          if (pattern495 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 103;

        case E_V512SFmode:
          if (pattern495 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 104;

        case E_V1024SFmode:
          if (pattern495 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 105;

        case E_V1DFmode:
          if (pattern495 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 106;

        case E_V2DFmode:
          if (pattern495 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 107;

        case E_V4DFmode:
          if (pattern495 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 108;

        case E_V8DFmode:
          if (pattern495 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 109;

        case E_V16DFmode:
          if (pattern495 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 110;

        case E_V32DFmode:
          if (pattern495 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 111;

        case E_V64DFmode:
          if (pattern495 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 112;

        case E_V128DFmode:
          if (pattern495 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 113;

        case E_V256DFmode:
          if (pattern495 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 114;

        case E_V512DFmode:
          if (pattern495 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 115;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[4] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0)
                return -1;
              return 116;

            case E_RVVM4QImode:
              if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
                return -1;
              return 117;

            case E_RVVM2QImode:
              if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
                return -1;
              return 118;

            case E_RVVM1QImode:
              if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
                return -1;
              return 119;

            case E_RVVMF2QImode:
              if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
                return -1;
              return 120;

            case E_RVVMF4QImode:
              if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
                return -1;
              return 121;

            case E_RVVMF8QImode:
              if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
                return -1;
              return 122;

            case E_RVVM8HImode:
              if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
                return -1;
              return 123;

            case E_RVVM4HImode:
              if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
                return -1;
              return 124;

            case E_RVVM2HImode:
              if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
                return -1;
              return 125;

            case E_RVVM1HImode:
              if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
                return -1;
              return 126;

            case E_RVVMF2HImode:
              if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
                return -1;
              return 127;

            case E_RVVMF4HImode:
              if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
                return -1;
              return 128;

            case E_RVVM8SImode:
              if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
                return -1;
              return 129;

            case E_RVVM4SImode:
              if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
                return -1;
              return 130;

            case E_RVVM2SImode:
              if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
                return -1;
              return 131;

            case E_RVVM1SImode:
              if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
                return -1;
              return 132;

            case E_RVVMF2SImode:
              if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
                return -1;
              return 133;

            case E_V1QImode:
              if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
                return -1;
              return 134;

            case E_V2QImode:
              if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
                return -1;
              return 135;

            case E_V4QImode:
              if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
                return -1;
              return 136;

            case E_V8QImode:
              if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
                return -1;
              return 137;

            case E_V16QImode:
              if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
                return -1;
              return 138;

            case E_V32QImode:
              if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
                return -1;
              return 139;

            case E_V64QImode:
              if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
                return -1;
              return 140;

            case E_V128QImode:
              if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
                return -1;
              return 141;

            case E_V256QImode:
              if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
                return -1;
              return 142;

            case E_V512QImode:
              if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
                return -1;
              return 143;

            case E_V1024QImode:
              if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
                return -1;
              return 144;

            case E_V2048QImode:
              if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
                return -1;
              return 145;

            case E_V4096QImode:
              if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
                return -1;
              return 146;

            case E_V1HImode:
              if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
                return -1;
              return 147;

            case E_V2HImode:
              if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
                return -1;
              return 148;

            case E_V4HImode:
              if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
                return -1;
              return 149;

            case E_V8HImode:
              if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
                return -1;
              return 150;

            case E_V16HImode:
              if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
                return -1;
              return 151;

            case E_V32HImode:
              if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
                return -1;
              return 152;

            case E_V64HImode:
              if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
                return -1;
              return 153;

            case E_V128HImode:
              if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
                return -1;
              return 154;

            case E_V256HImode:
              if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
                return -1;
              return 155;

            case E_V512HImode:
              if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
                return -1;
              return 156;

            case E_V1024HImode:
              if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
                return -1;
              return 157;

            case E_V2048HImode:
              if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
                return -1;
              return 158;

            case E_V1SImode:
              if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
                return -1;
              return 159;

            case E_V2SImode:
              if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
                return -1;
              return 160;

            case E_V4SImode:
              if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
                return -1;
              return 161;

            case E_V8SImode:
              if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
                return -1;
              return 162;

            case E_V16SImode:
              if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
                return -1;
              return 163;

            case E_V32SImode:
              if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
                return -1;
              return 164;

            case E_V64SImode:
              if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
                return -1;
              return 165;

            case E_V128SImode:
              if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
                return -1;
              return 166;

            case E_V256SImode:
              if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
                return -1;
              return 167;

            case E_V512SImode:
              if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
                return -1;
              return 168;

            case E_V1024SImode:
              if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
                return -1;
              return 169;

            case E_RVVM8DImode:
              if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
                return -1;
              return 170;

            case E_RVVM4DImode:
              if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
                return -1;
              return 171;

            case E_RVVM2DImode:
              if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
                return -1;
              return 172;

            case E_RVVM1DImode:
              if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
                return -1;
              return 173;

            case E_V1DImode:
              if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
                return -1;
              return 174;

            case E_V2DImode:
              if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
                return -1;
              return 175;

            case E_V4DImode:
              if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
                return -1;
              return 176;

            case E_V8DImode:
              if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
                return -1;
              return 177;

            case E_V16DImode:
              if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
                return -1;
              return 178;

            case E_V32DImode:
              if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
                return -1;
              return 179;

            case E_V64DImode:
              if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
                return -1;
              return 180;

            case E_V128DImode:
              if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
                return -1;
              return 181;

            case E_V256DImode:
              if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
                return -1;
              return 182;

            case E_V512DImode:
              if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
                return -1;
              return 183;

            case E_RVVM8HFmode:
              if (pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 184;

            case E_RVVM4HFmode:
              if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 185;

            case E_RVVM2HFmode:
              if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 186;

            case E_RVVM1HFmode:
              if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 187;

            case E_RVVMF2HFmode:
              if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 188;

            case E_RVVMF4HFmode:
              if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 189;

            case E_RVVM8SFmode:
              if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 190;

            case E_RVVM4SFmode:
              if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 191;

            case E_RVVM2SFmode:
              if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 192;

            case E_RVVM1SFmode:
              if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 193;

            case E_RVVMF2SFmode:
              if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 194;

            case E_RVVM8DFmode:
              if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 195;

            case E_RVVM4DFmode:
              if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 196;

            case E_RVVM2DFmode:
              if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 197;

            case E_RVVM1DFmode:
              if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 198;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern491 (x1);
          if (res >= 0)
            return res + 199; /* [199, 212] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern563 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          return pattern554 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode); /* [-1, 0] */

        case E_RVVM4DImode:
          if (pattern554 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2DImode:
          if (pattern554 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1DImode:
          if (pattern554 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x9 = XVECEXP (x7, 0, 1);
      operands[3] = x9;
      x10 = XEXP (x8, 0);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[4] = x10;
          if (!reg_or_0_operand (operands[4], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern556 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 4;

            case E_RVVM4DImode:
              if (pattern556 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 5;

            case E_RVVM2DImode:
              if (pattern556 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 6;

            case E_RVVM1DImode:
              if (pattern556 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern557 (x1);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern574 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[8] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern504 (x1, 
E_RVVM8HFmode, 
E_RVVM8HImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x8) != E_RVVM4HFmode
          || !vector_merge_operand (operands[2], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 1;

        case E_RVVM8SImode:
          if (!register_operand (operands[3], E_RVVM8SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x8) != E_RVVM2HFmode
          || !vector_merge_operand (operands[2], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 3;

        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x8) != E_RVVM1HFmode
          || !vector_merge_operand (operands[2], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x8) != E_RVVMF2HFmode
          || !vector_merge_operand (operands[2], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 7;

        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x8) != E_RVVMF4HFmode
          || !vector_merge_operand (operands[2], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (pattern504 (x1, 
E_RVVM8SFmode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x8) != E_RVVM4SFmode
          || !vector_merge_operand (operands[2], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 12;

        case E_RVVM8DImode:
          if (!register_operand (operands[3], E_RVVM8DImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x8) != E_RVVM2SFmode
          || !vector_merge_operand (operands[2], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 14;

        case E_RVVM4DImode:
          if (!register_operand (operands[3], E_RVVM4DImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x8) != E_RVVM1SFmode
          || !vector_merge_operand (operands[2], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 16;

        case E_RVVM2DImode:
          if (!register_operand (operands[3], E_RVVM2DImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x8) != E_RVVMF2SFmode
          || !vector_merge_operand (operands[2], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 18;

        case E_RVVM1DImode:
          if (!register_operand (operands[3], E_RVVM1DImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (pattern504 (x1, 
E_RVVM8DFmode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 20;

    case E_RVVM4DFmode:
      if (pattern504 (x1, 
E_RVVM4DFmode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 21;

    case E_RVVM2DFmode:
      if (pattern504 (x1, 
E_RVVM2DFmode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 22;

    case E_RVVM1DFmode:
      if (pattern504 (x1, 
E_RVVM1DFmode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 23;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x8) != E_V1HFmode
          || !vector_merge_operand (operands[2], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 24;

        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 25;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x8) != E_V2HFmode
          || !vector_merge_operand (operands[2], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 26;

        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x8) != E_V4HFmode
          || !vector_merge_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 28;

        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 29;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x8) != E_V8HFmode
          || !vector_merge_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 30;

        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 31;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x8) != E_V16HFmode
          || !vector_merge_operand (operands[2], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 32;

        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 33;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x8) != E_V32HFmode
          || !vector_merge_operand (operands[2], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 34;

        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 35;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x8) != E_V64HFmode
          || !vector_merge_operand (operands[2], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 36;

        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x8) != E_V128HFmode
          || !vector_merge_operand (operands[2], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 38;

        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 39;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x8) != E_V256HFmode
          || !vector_merge_operand (operands[2], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 40;

        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x8) != E_V512HFmode
          || !vector_merge_operand (operands[2], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 42;

        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x8) != E_V1024HFmode
          || !vector_merge_operand (operands[2], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 44;

        case E_V1024SImode:
          if (!register_operand (operands[3], E_V1024SImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (pattern504 (x1, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x8) != E_V1SFmode
          || !vector_merge_operand (operands[2], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 47;

        case E_V1DImode:
          if (!register_operand (operands[3], E_V1DImode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x8) != E_V2SFmode
          || !vector_merge_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 49;

        case E_V2DImode:
          if (!register_operand (operands[3], E_V2DImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x8) != E_V4SFmode
          || !vector_merge_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 51;

        case E_V4DImode:
          if (!register_operand (operands[3], E_V4DImode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x8) != E_V8SFmode
          || !vector_merge_operand (operands[2], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 53;

        case E_V8DImode:
          if (!register_operand (operands[3], E_V8DImode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x8) != E_V16SFmode
          || !vector_merge_operand (operands[2], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 55;

        case E_V16DImode:
          if (!register_operand (operands[3], E_V16DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x8) != E_V32SFmode
          || !vector_merge_operand (operands[2], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 57;

        case E_V32DImode:
          if (!register_operand (operands[3], E_V32DImode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x8) != E_V64SFmode
          || !vector_merge_operand (operands[2], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 59;

        case E_V64DImode:
          if (!register_operand (operands[3], E_V64DImode))
            return -1;
          return 60;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x8) != E_V128SFmode
          || !vector_merge_operand (operands[2], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 61;

        case E_V128DImode:
          if (!register_operand (operands[3], E_V128DImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x8) != E_V256SFmode
          || !vector_merge_operand (operands[2], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 63;

        case E_V256DImode:
          if (!register_operand (operands[3], E_V256DImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x8) != E_V512SFmode
          || !vector_merge_operand (operands[2], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 65;

        case E_V512DImode:
          if (!register_operand (operands[3], E_V512DImode))
            return -1;
          return 66;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (pattern504 (x1, 
E_V1024SFmode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 67;

    case E_V1DFmode:
      if (pattern504 (x1, 
E_V1DFmode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2DFmode:
      if (pattern504 (x1, 
E_V2DFmode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4DFmode:
      if (pattern504 (x1, 
E_V4DFmode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8DFmode:
      if (pattern504 (x1, 
E_V8DFmode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16DFmode:
      if (pattern504 (x1, 
E_V16DFmode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32DFmode:
      if (pattern504 (x1, 
E_V32DFmode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64DFmode:
      if (pattern504 (x1, 
E_V64DFmode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128DFmode:
      if (pattern504 (x1, 
E_V128DFmode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256DFmode:
      if (pattern504 (x1, 
E_V256DFmode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512DFmode:
      if (pattern504 (x1, 
E_V512DFmode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    default:
      return -1;
    }
}

int
pattern682 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 0;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      return 2;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      return 3;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      return 4;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      return 5;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 6;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 7;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 8;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      return 9;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      return 10;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      return 11;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      return 12;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      return 13;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      return 14;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern692 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], i3)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern705 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern704 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern704 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern704 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern704 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern704 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern704 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern704 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern704 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern704 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern704 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern704 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern704 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern704 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern704 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern704 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern704 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern704 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern704 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern704 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern704 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern704 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern704 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern704 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern704 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern704 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern704 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern704 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern704 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern704 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern704 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern704 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern704 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern704 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern704 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern704 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern704 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern704 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern704 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern704 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern704 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern704 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern704 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern704 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern704 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern704 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern704 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern704 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern704 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern730 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern733 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  return pattern725 (x4, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern735 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern736 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern739 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x17, 1);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  return 0;
}

int
pattern742 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19)
        return -1;
      x28 = XEXP (x26, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x27) != 18)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != SET)
        return -1;
      x33 = XEXP (x32, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 9
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != SET)
        return -1;
      x39 = XEXP (x38, 1);
      if (GET_CODE (x39) != MEM
          || GET_MODE (x39) != i1)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != PLUS
          || GET_MODE (x40) != i1)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 2
          || GET_MODE (x41) != i1)
        return -1;
      x42 = XEXP (x40, 1);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x43 = XEXP (x38, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 8
          || GET_MODE (x43) != i1)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != SET)
        return -1;
      x45 = XEXP (x44, 1);
      if (GET_CODE (x45) != MEM
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XEXP (x45, 0);
      if (GET_CODE (x46) != PLUS
          || GET_MODE (x46) != i1)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 2
          || GET_MODE (x47) != i1)
        return -1;
      x48 = XEXP (x46, 1);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != i1
          || !stack_pop_up_to_s6_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 20:
      if (REGNO (x12) != 19
          || REGNO (x17) != 18
          || REGNO (x22) != 9)
        return -1;
      x28 = XEXP (x26, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x27) != 8)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != SET)
        return -1;
      x33 = XEXP (x32, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 1
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != USE)
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != E_SImode
          || !stack_pop_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 18:
      if (REGNO (x12) != 9
          || REGNO (x17) != 8
          || REGNO (x22) != 1)
        return -1;
      x28 = XEXP (x26, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x27) != 10)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != USE)
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 10
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != USE)
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != E_SImode
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern767 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern779 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -32])
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  return pattern778 (x9); /* [-1, 0] */
}

int
pattern783 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1
      || !stack_pop_up_to_s9_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 27:
      if (REGNO (x12) != 26
          || REGNO (x17) != 25
          || REGNO (x22) != 24
          || REGNO (x27) != 23
          || REGNO (x32) != 22
          || REGNO (x37) != 21
          || REGNO (x42) != 20
          || REGNO (x47) != 19
          || REGNO (x52) != 18
          || REGNO (x57) != 9)
        return -1;
      return 0;

    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23
          || REGNO (x22) != 22
          || REGNO (x27) != 21
          || REGNO (x32) != 20
          || REGNO (x37) != 19
          || REGNO (x42) != 18
          || REGNO (x47) != 9
          || REGNO (x52) != 8
          || REGNO (x57) != 1)
        return -1;
      x63 = XEXP (x61, 1);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x62) != 10)
        return -1;
      x64 = XVECEXP (x1, 0, 13);
      if (pattern783 (x64, 
i1, 
10) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return recog_5 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31406; /* *dual_widen_fmasurvvm8hi */

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31407; /* *dual_widen_fmasurvvm4hi */

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31408; /* *dual_widen_fmasurvvm2hi */

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31409; /* *dual_widen_fmasurvvm1hi */

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31410; /* *dual_widen_fmasurvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 31411; /* *dual_widen_fmasurvvmf4hi */

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31412; /* *dual_widen_fmasurvvm8si */

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31413; /* *dual_widen_fmasurvvm4si */

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31414; /* *dual_widen_fmasurvvm2si */

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31415; /* *dual_widen_fmasurvvm1si */

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 31416; /* *dual_widen_fmasurvvmf2si */

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31417; /* *dual_widen_fmasurvvm8di */

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31418; /* *dual_widen_fmasurvvm4di */

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31419; /* *dual_widen_fmasurvvm2di */

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31420; /* *dual_widen_fmasurvvm1di */

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31421; /* *dual_widen_fmasuv1hi */

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31422; /* *dual_widen_fmasuv2hi */

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31423; /* *dual_widen_fmasuv4hi */

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31424; /* *dual_widen_fmasuv8hi */

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31425; /* *dual_widen_fmasuv16hi */

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31426; /* *dual_widen_fmasuv32hi */

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31427; /* *dual_widen_fmasuv64hi */

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31428; /* *dual_widen_fmasuv128hi */

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31429; /* *dual_widen_fmasuv256hi */

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31430; /* *dual_widen_fmasuv512hi */

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31431; /* *dual_widen_fmasuv1024hi */

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31432; /* *dual_widen_fmasuv2048hi */

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31433; /* *dual_widen_fmasuv1si */

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31434; /* *dual_widen_fmasuv2si */

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31435; /* *dual_widen_fmasuv4si */

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31436; /* *dual_widen_fmasuv8si */

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31437; /* *dual_widen_fmasuv16si */

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31438; /* *dual_widen_fmasuv32si */

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31439; /* *dual_widen_fmasuv64si */

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31440; /* *dual_widen_fmasuv128si */

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31441; /* *dual_widen_fmasuv256si */

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31442; /* *dual_widen_fmasuv512si */

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31443; /* *dual_widen_fmasuv1024si */

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31444; /* *dual_widen_fmasuv1di */

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31445; /* *dual_widen_fmasuv2di */

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31446; /* *dual_widen_fmasuv4di */

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31447; /* *dual_widen_fmasuv8di */

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31448; /* *dual_widen_fmasuv16di */

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31449; /* *dual_widen_fmasuv32di */

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31450; /* *dual_widen_fmasuv64di */

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31451; /* *dual_widen_fmasuv128di */

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31452; /* *dual_widen_fmasuv256di */

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31453; /* *dual_widen_fmasuv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern138 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31502; /* *single_widen_fmasrvvm8hi */

        case E_RVVM4HImode:
          if (pattern138 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31504; /* *single_widen_fmasrvvm4hi */

        case E_RVVM2HImode:
          if (pattern138 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31506; /* *single_widen_fmasrvvm2hi */

        case E_RVVM1HImode:
          if (pattern138 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31508; /* *single_widen_fmasrvvm1hi */

        case E_RVVMF2HImode:
          if (pattern138 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31510; /* *single_widen_fmasrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern138 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 31512; /* *single_widen_fmasrvvmf4hi */

        case E_RVVM8SImode:
          if (pattern138 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31514; /* *single_widen_fmasrvvm8si */

        case E_RVVM4SImode:
          if (pattern138 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31516; /* *single_widen_fmasrvvm4si */

        case E_RVVM2SImode:
          if (pattern138 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31518; /* *single_widen_fmasrvvm2si */

        case E_RVVM1SImode:
          if (pattern138 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31520; /* *single_widen_fmasrvvm1si */

        case E_RVVMF2SImode:
          if (pattern138 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 31522; /* *single_widen_fmasrvvmf2si */

        case E_RVVM8DImode:
          if (pattern138 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31524; /* *single_widen_fmasrvvm8di */

        case E_RVVM4DImode:
          if (pattern138 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31526; /* *single_widen_fmasrvvm4di */

        case E_RVVM2DImode:
          if (pattern138 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31528; /* *single_widen_fmasrvvm2di */

        case E_RVVM1DImode:
          if (pattern138 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31530; /* *single_widen_fmasrvvm1di */

        case E_V1HImode:
          if (pattern138 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31532; /* *single_widen_fmasv1hi */

        case E_V2HImode:
          if (pattern138 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31534; /* *single_widen_fmasv2hi */

        case E_V4HImode:
          if (pattern138 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31536; /* *single_widen_fmasv4hi */

        case E_V8HImode:
          if (pattern138 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31538; /* *single_widen_fmasv8hi */

        case E_V16HImode:
          if (pattern138 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31540; /* *single_widen_fmasv16hi */

        case E_V32HImode:
          if (pattern138 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31542; /* *single_widen_fmasv32hi */

        case E_V64HImode:
          if (pattern138 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31544; /* *single_widen_fmasv64hi */

        case E_V128HImode:
          if (pattern138 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31546; /* *single_widen_fmasv128hi */

        case E_V256HImode:
          if (pattern138 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31548; /* *single_widen_fmasv256hi */

        case E_V512HImode:
          if (pattern138 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31550; /* *single_widen_fmasv512hi */

        case E_V1024HImode:
          if (pattern138 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31552; /* *single_widen_fmasv1024hi */

        case E_V2048HImode:
          if (pattern138 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31554; /* *single_widen_fmasv2048hi */

        case E_V1SImode:
          if (pattern138 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31556; /* *single_widen_fmasv1si */

        case E_V2SImode:
          if (pattern138 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31558; /* *single_widen_fmasv2si */

        case E_V4SImode:
          if (pattern138 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31560; /* *single_widen_fmasv4si */

        case E_V8SImode:
          if (pattern138 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31562; /* *single_widen_fmasv8si */

        case E_V16SImode:
          if (pattern138 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31564; /* *single_widen_fmasv16si */

        case E_V32SImode:
          if (pattern138 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31566; /* *single_widen_fmasv32si */

        case E_V64SImode:
          if (pattern138 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31568; /* *single_widen_fmasv64si */

        case E_V128SImode:
          if (pattern138 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31570; /* *single_widen_fmasv128si */

        case E_V256SImode:
          if (pattern138 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31572; /* *single_widen_fmasv256si */

        case E_V512SImode:
          if (pattern138 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31574; /* *single_widen_fmasv512si */

        case E_V1024SImode:
          if (pattern138 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31576; /* *single_widen_fmasv1024si */

        case E_V1DImode:
          if (pattern138 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31578; /* *single_widen_fmasv1di */

        case E_V2DImode:
          if (pattern138 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31580; /* *single_widen_fmasv2di */

        case E_V4DImode:
          if (pattern138 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31582; /* *single_widen_fmasv4di */

        case E_V8DImode:
          if (pattern138 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31584; /* *single_widen_fmasv8di */

        case E_V16DImode:
          if (pattern138 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31586; /* *single_widen_fmasv16di */

        case E_V32DImode:
          if (pattern138 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31588; /* *single_widen_fmasv32di */

        case E_V64DImode:
          if (pattern138 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31590; /* *single_widen_fmasv64di */

        case E_V128DImode:
          if (pattern138 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31592; /* *single_widen_fmasv128di */

        case E_V256DImode:
          if (pattern138 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31594; /* *single_widen_fmasv256di */

        case E_V512DImode:
          if (pattern138 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !(
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31596; /* *single_widen_fmasv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      return recog_17 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_19 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30434; /* *single_widen_subsrvvm8hi */

        case 1:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30436; /* *single_widen_subsrvvm4hi */

        case 2:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30438; /* *single_widen_subsrvvm2hi */

        case 3:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30440; /* *single_widen_subsrvvm1hi */

        case 4:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30442; /* *single_widen_subsrvvmf2hi */

        case 5:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30444; /* *single_widen_subsrvvmf4hi */

        case 6:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30446; /* *single_widen_subsrvvm8si */

        case 7:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30448; /* *single_widen_subsrvvm4si */

        case 8:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30450; /* *single_widen_subsrvvm2si */

        case 9:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30452; /* *single_widen_subsrvvm1si */

        case 10:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30454; /* *single_widen_subsrvvmf2si */

        case 11:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30456; /* *single_widen_subsrvvm8di */

        case 12:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30458; /* *single_widen_subsrvvm4di */

        case 13:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30460; /* *single_widen_subsrvvm2di */

        case 14:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30462; /* *single_widen_subsrvvm1di */

        case 15:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30464; /* *single_widen_subsv1hi */

        case 16:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30466; /* *single_widen_subsv2hi */

        case 17:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30468; /* *single_widen_subsv4hi */

        case 18:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30470; /* *single_widen_subsv8hi */

        case 19:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30472; /* *single_widen_subsv16hi */

        case 20:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30474; /* *single_widen_subsv32hi */

        case 21:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30476; /* *single_widen_subsv64hi */

        case 22:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30478; /* *single_widen_subsv128hi */

        case 23:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30480; /* *single_widen_subsv256hi */

        case 24:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30482; /* *single_widen_subsv512hi */

        case 25:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30484; /* *single_widen_subsv1024hi */

        case 26:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30486; /* *single_widen_subsv2048hi */

        case 27:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30488; /* *single_widen_subsv1si */

        case 28:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30490; /* *single_widen_subsv2si */

        case 29:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30492; /* *single_widen_subsv4si */

        case 30:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30494; /* *single_widen_subsv8si */

        case 31:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30496; /* *single_widen_subsv16si */

        case 32:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30498; /* *single_widen_subsv32si */

        case 33:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30500; /* *single_widen_subsv64si */

        case 34:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30502; /* *single_widen_subsv128si */

        case 35:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30504; /* *single_widen_subsv256si */

        case 36:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30506; /* *single_widen_subsv512si */

        case 37:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30508; /* *single_widen_subsv1024si */

        case 38:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30510; /* *single_widen_subsv1di */

        case 39:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30512; /* *single_widen_subsv2di */

        case 40:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30514; /* *single_widen_subsv4di */

        case 41:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30516; /* *single_widen_subsv8di */

        case 42:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30518; /* *single_widen_subsv16di */

        case 43:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30520; /* *single_widen_subsv32di */

        case 44:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30522; /* *single_widen_subsv64di */

        case 45:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30524; /* *single_widen_subsv128di */

        case 46:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30526; /* *single_widen_subsv256di */

        case 47:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30528; /* *single_widen_subsv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30435; /* *single_widen_suburvvm8hi */

        case 1:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30437; /* *single_widen_suburvvm4hi */

        case 2:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30439; /* *single_widen_suburvvm2hi */

        case 3:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30441; /* *single_widen_suburvvm1hi */

        case 4:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30443; /* *single_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30445; /* *single_widen_suburvvmf4hi */

        case 6:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30447; /* *single_widen_suburvvm8si */

        case 7:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30449; /* *single_widen_suburvvm4si */

        case 8:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30451; /* *single_widen_suburvvm2si */

        case 9:
          if (!
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30453; /* *single_widen_suburvvm1si */

        case 10:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30455; /* *single_widen_suburvvmf2si */

        case 11:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30457; /* *single_widen_suburvvm8di */

        case 12:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30459; /* *single_widen_suburvvm4di */

        case 13:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30461; /* *single_widen_suburvvm2di */

        case 14:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30463; /* *single_widen_suburvvm1di */

        case 15:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30465; /* *single_widen_subuv1hi */

        case 16:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30467; /* *single_widen_subuv2hi */

        case 17:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30469; /* *single_widen_subuv4hi */

        case 18:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30471; /* *single_widen_subuv8hi */

        case 19:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30473; /* *single_widen_subuv16hi */

        case 20:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30475; /* *single_widen_subuv32hi */

        case 21:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30477; /* *single_widen_subuv64hi */

        case 22:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30479; /* *single_widen_subuv128hi */

        case 23:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30481; /* *single_widen_subuv256hi */

        case 24:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30483; /* *single_widen_subuv512hi */

        case 25:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30485; /* *single_widen_subuv1024hi */

        case 26:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30487; /* *single_widen_subuv2048hi */

        case 27:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30489; /* *single_widen_subuv1si */

        case 28:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30491; /* *single_widen_subuv2si */

        case 29:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30493; /* *single_widen_subuv4si */

        case 30:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30495; /* *single_widen_subuv8si */

        case 31:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30497; /* *single_widen_subuv16si */

        case 32:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30499; /* *single_widen_subuv32si */

        case 33:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30501; /* *single_widen_subuv64si */

        case 34:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30503; /* *single_widen_subuv128si */

        case 35:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30505; /* *single_widen_subuv256si */

        case 36:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30507; /* *single_widen_subuv512si */

        case 37:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30509; /* *single_widen_subuv1024si */

        case 38:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30511; /* *single_widen_subuv1di */

        case 39:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30513; /* *single_widen_subuv2di */

        case 40:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30515; /* *single_widen_subuv4di */

        case 41:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30517; /* *single_widen_subuv8di */

        case 42:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30519; /* *single_widen_subuv16di */

        case 43:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30521; /* *single_widen_subuv32di */

        case 44:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30523; /* *single_widen_subuv64di */

        case 45:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30525; /* *single_widen_subuv128di */

        case 46:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30527; /* *single_widen_subuv256di */

        case 47:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30529; /* *single_widen_subuv512di */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      switch (pattern240 (x2))
        {
        case 0:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31034; /* *single_widen_subrvvm8sf */

        case 1:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31035; /* *single_widen_subrvvm4sf */

        case 2:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31036; /* *single_widen_subrvvm2sf */

        case 3:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31037; /* *single_widen_subrvvm1sf */

        case 4:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31038; /* *single_widen_subrvvmf2sf */

        case 5:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31039; /* *single_widen_subrvvm8df */

        case 6:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31040; /* *single_widen_subrvvm4df */

        case 7:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31041; /* *single_widen_subrvvm2df */

        case 8:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31042; /* *single_widen_subrvvm1df */

        case 9:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31043; /* *single_widen_subv1sf */

        case 10:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31044; /* *single_widen_subv2sf */

        case 11:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31045; /* *single_widen_subv4sf */

        case 12:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31046; /* *single_widen_subv8sf */

        case 13:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31047; /* *single_widen_subv16sf */

        case 14:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31048; /* *single_widen_subv32sf */

        case 15:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31049; /* *single_widen_subv64sf */

        case 16:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31050; /* *single_widen_subv128sf */

        case 17:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31051; /* *single_widen_subv256sf */

        case 18:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31052; /* *single_widen_subv512sf */

        case 19:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31053; /* *single_widen_subv1024sf */

        case 20:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31054; /* *single_widen_subv1df */

        case 21:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31055; /* *single_widen_subv2df */

        case 22:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31056; /* *single_widen_subv4df */

        case 23:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31057; /* *single_widen_subv8df */

        case 24:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31058; /* *single_widen_subv16df */

        case 25:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31059; /* *single_widen_subv32df */

        case 26:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31060; /* *single_widen_subv64df */

        case 27:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31061; /* *single_widen_subv128df */

        case 28:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31062; /* *single_widen_subv256df */

        case 29:
          if (!(
#line 792 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31063; /* *single_widen_subv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (XWINT (x5, 0) != 0L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      switch (pattern444 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19949; /* *pred_extract_firstrvvm8qi */

        case 1:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19950; /* *pred_extract_firstrvvm4qi */

        case 2:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19951; /* *pred_extract_firstrvvm2qi */

        case 3:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19952; /* *pred_extract_firstrvvm1qi */

        case 4:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19965; /* *pred_extract_firstrvvmf2qi */

        case 5:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19966; /* *pred_extract_firstrvvmf4qi */

        case 6:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19967; /* *pred_extract_firstrvvmf8qi */

        case 7:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 19971; /* *pred_extract_firstv1qi */

        case 8:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 19972; /* *pred_extract_firstv2qi */

        case 9:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 19973; /* *pred_extract_firstv4qi */

        case 10:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 19974; /* *pred_extract_firstv8qi */

        case 11:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 19975; /* *pred_extract_firstv16qi */

        case 12:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 19976; /* *pred_extract_firstv32qi */

        case 13:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19977; /* *pred_extract_firstv64qi */

        case 14:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19978; /* *pred_extract_firstv128qi */

        case 15:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19979; /* *pred_extract_firstv256qi */

        case 16:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19980; /* *pred_extract_firstv512qi */

        case 17:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19981; /* *pred_extract_firstv1024qi */

        case 18:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19982; /* *pred_extract_firstv2048qi */

        case 19:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19983; /* *pred_extract_firstv4096qi */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern445 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19953; /* *pred_extract_firstrvvm8hi */

        case 1:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19954; /* *pred_extract_firstrvvm4hi */

        case 2:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19955; /* *pred_extract_firstrvvm2hi */

        case 3:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19956; /* *pred_extract_firstrvvm1hi */

        case 4:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19968; /* *pred_extract_firstrvvmf2hi */

        case 5:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19969; /* *pred_extract_firstrvvmf4hi */

        case 6:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 19984; /* *pred_extract_firstv1hi */

        case 7:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 19985; /* *pred_extract_firstv2hi */

        case 8:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 19986; /* *pred_extract_firstv4hi */

        case 9:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 19987; /* *pred_extract_firstv8hi */

        case 10:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 19988; /* *pred_extract_firstv16hi */

        case 11:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19989; /* *pred_extract_firstv32hi */

        case 12:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19990; /* *pred_extract_firstv64hi */

        case 13:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19991; /* *pred_extract_firstv128hi */

        case 14:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19992; /* *pred_extract_firstv256hi */

        case 15:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19993; /* *pred_extract_firstv512hi */

        case 16:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19994; /* *pred_extract_firstv1024hi */

        case 17:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19995; /* *pred_extract_firstv2048hi */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern446 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19957; /* *pred_extract_firstrvvm8si */

        case 1:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19958; /* *pred_extract_firstrvvm4si */

        case 2:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19959; /* *pred_extract_firstrvvm2si */

        case 3:
          if (!
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19960; /* *pred_extract_firstrvvm1si */

        case 4:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19970; /* *pred_extract_firstrvvmf2si */

        case 5:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19996; /* *pred_extract_firstv1si */

        case 6:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19997; /* *pred_extract_firstv2si */

        case 7:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19998; /* *pred_extract_firstv4si */

        case 8:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19999; /* *pred_extract_firstv8si */

        case 9:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20000; /* *pred_extract_firstv16si */

        case 10:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20001; /* *pred_extract_firstv32si */

        case 11:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20002; /* *pred_extract_firstv64si */

        case 12:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20003; /* *pred_extract_firstv128si */

        case 13:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20004; /* *pred_extract_firstv256si */

        case 14:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20005; /* *pred_extract_firstv512si */

        case 15:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20006; /* *pred_extract_firstv1024si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern447 (x2))
        {
        case 0:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19961; /* *pred_extract_firstrvvm8di */

        case 1:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19962; /* *pred_extract_firstrvvm4di */

        case 2:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19963; /* *pred_extract_firstrvvm2di */

        case 3:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19964; /* *pred_extract_firstrvvm1di */

        case 4:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20007; /* *pred_extract_firstv1di */

        case 5:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20008; /* *pred_extract_firstv2di */

        case 6:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20009; /* *pred_extract_firstv4di */

        case 7:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20010; /* *pred_extract_firstv8di */

        case 8:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20011; /* *pred_extract_firstv16di */

        case 9:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20012; /* *pred_extract_firstv32di */

        case 10:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20013; /* *pred_extract_firstv64di */

        case 11:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20014; /* *pred_extract_firstv128di */

        case 12:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20015; /* *pred_extract_firstv256di */

        case 13:
          if (!(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20016; /* *pred_extract_firstv512di */

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x2) != E_HFmode
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8HFmode:
          if (!register_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20031; /* *pred_extract_firstrvvm8hf */

        case E_RVVM4HFmode:
          if (!register_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20032; /* *pred_extract_firstrvvm4hf */

        case E_RVVM2HFmode:
          if (!register_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20033; /* *pred_extract_firstrvvm2hf */

        case E_RVVM1HFmode:
          if (!register_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20034; /* *pred_extract_firstrvvm1hf */

        case E_RVVMF2HFmode:
          if (!register_operand (operands[1], E_RVVMF2HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20035; /* *pred_extract_firstrvvmf2hf */

        case E_RVVMF4HFmode:
          if (!register_operand (operands[1], E_RVVMF4HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20036; /* *pred_extract_firstrvvmf4hf */

        case E_V1HFmode:
          if (!register_operand (operands[1], E_V1HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20046; /* *pred_extract_firstv1hf */

        case E_V2HFmode:
          if (!register_operand (operands[1], E_V2HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20047; /* *pred_extract_firstv2hf */

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20048; /* *pred_extract_firstv4hf */

        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20049; /* *pred_extract_firstv8hf */

        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20050; /* *pred_extract_firstv16hf */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20051; /* *pred_extract_firstv32hf */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20052; /* *pred_extract_firstv64hf */

        case E_V128HFmode:
          if (!register_operand (operands[1], E_V128HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20053; /* *pred_extract_firstv128hf */

        case E_V256HFmode:
          if (!register_operand (operands[1], E_V256HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20054; /* *pred_extract_firstv256hf */

        case E_V512HFmode:
          if (!register_operand (operands[1], E_V512HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20055; /* *pred_extract_firstv512hf */

        case E_V1024HFmode:
          if (!register_operand (operands[1], E_V1024HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20056; /* *pred_extract_firstv1024hf */

        case E_V2048HFmode:
          if (!register_operand (operands[1], E_V2048HFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20057; /* *pred_extract_firstv2048hf */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20037; /* *pred_extract_firstrvvm8sf */

        case E_RVVM4SFmode:
          if (!register_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20038; /* *pred_extract_firstrvvm4sf */

        case E_RVVM2SFmode:
          if (!register_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20039; /* *pred_extract_firstrvvm2sf */

        case E_RVVM1SFmode:
          if (!register_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20040; /* *pred_extract_firstrvvm1sf */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[1], E_RVVMF2SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20041; /* *pred_extract_firstrvvmf2sf */

        case E_V1SFmode:
          if (!register_operand (operands[1], E_V1SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20058; /* *pred_extract_firstv1sf */

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20059; /* *pred_extract_firstv2sf */

        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20060; /* *pred_extract_firstv4sf */

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20061; /* *pred_extract_firstv8sf */

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20062; /* *pred_extract_firstv16sf */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20063; /* *pred_extract_firstv32sf */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20064; /* *pred_extract_firstv64sf */

        case E_V128SFmode:
          if (!register_operand (operands[1], E_V128SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20065; /* *pred_extract_firstv128sf */

        case E_V256SFmode:
          if (!register_operand (operands[1], E_V256SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20066; /* *pred_extract_firstv256sf */

        case E_V512SFmode:
          if (!register_operand (operands[1], E_V512SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20067; /* *pred_extract_firstv512sf */

        case E_V1024SFmode:
          if (!register_operand (operands[1], E_V1024SFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20068; /* *pred_extract_firstv1024sf */

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20042; /* *pred_extract_firstrvvm8df */

        case E_RVVM4DFmode:
          if (!register_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20043; /* *pred_extract_firstrvvm4df */

        case E_RVVM2DFmode:
          if (!register_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20044; /* *pred_extract_firstrvvm2df */

        case E_RVVM1DFmode:
          if (!register_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20045; /* *pred_extract_firstrvvm1df */

        case E_V1DFmode:
          if (!register_operand (operands[1], E_V1DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20069; /* *pred_extract_firstv1df */

        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20070; /* *pred_extract_firstv2df */

        case E_V4DFmode:
          if (!register_operand (operands[1], E_V4DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20071; /* *pred_extract_firstv4df */

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20072; /* *pred_extract_firstv8df */

        case E_V16DFmode:
          if (!register_operand (operands[1], E_V16DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20073; /* *pred_extract_firstv16df */

        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20074; /* *pred_extract_firstv32df */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20075; /* *pred_extract_firstv64df */

        case E_V128DFmode:
          if (!register_operand (operands[1], E_V128DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20076; /* *pred_extract_firstv128df */

        case E_V256DFmode:
          if (!register_operand (operands[1], E_V256DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20077; /* *pred_extract_firstv256df */

        case E_V512DFmode:
          if (!register_operand (operands[1], E_V512DFmode)
              || !(
#line 8094 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20078; /* *pred_extract_firstv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !register_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_RVVMF8BImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x4))
    {
    case E_RVVM1QImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM1QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8692; /* pred_madcrvvm1qi_scalar */

    case E_RVVM2HImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM2HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8698; /* pred_madcrvvm2hi_scalar */

    case E_RVVM4SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM4SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8703; /* pred_madcrvvm4si_scalar */

    case E_RVVM8DImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 3567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8797; /* *pred_madcrvvm8di_scalar */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_V1024BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V1024QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8717; /* pred_madcv1024qi_scalar */

    case E_V1024HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8730; /* pred_madcv1024hi_scalar */

    case E_V1024SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8742; /* pred_madcv1024si_scalar */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18127; /* pred_redmaxrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18135; /* pred_redmaxrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18143; /* pred_redmaxrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18151; /* pred_redmaxrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18255; /* pred_redmaxrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18263; /* pred_redmaxrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18271; /* pred_redmaxrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18303; /* pred_redmaxv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18311; /* pred_redmaxv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18319; /* pred_redmaxv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18327; /* pred_redmaxv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18335; /* pred_redmaxv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18343; /* pred_redmaxv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18351; /* pred_redmaxv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18359; /* pred_redmaxv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18367; /* pred_redmaxv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18375; /* pred_redmaxv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18383; /* pred_redmaxv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18391; /* pred_redmaxv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18399; /* pred_redmaxv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18159; /* pred_redmaxrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18167; /* pred_redmaxrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18175; /* pred_redmaxrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18183; /* pred_redmaxrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18279; /* pred_redmaxrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18287; /* pred_redmaxrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18407; /* pred_redmaxv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18415; /* pred_redmaxv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18423; /* pred_redmaxv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18431; /* pred_redmaxv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18439; /* pred_redmaxv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18447; /* pred_redmaxv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18455; /* pred_redmaxv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18463; /* pred_redmaxv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18471; /* pred_redmaxv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18479; /* pred_redmaxv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18487; /* pred_redmaxv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18495; /* pred_redmaxv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18191; /* pred_redmaxrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18199; /* pred_redmaxrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18207; /* pred_redmaxrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18215; /* pred_redmaxrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18295; /* pred_redmaxrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18503; /* pred_redmaxv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18511; /* pred_redmaxv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18519; /* pred_redmaxv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18527; /* pred_redmaxv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18535; /* pred_redmaxv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18543; /* pred_redmaxv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18551; /* pred_redmaxv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18559; /* pred_redmaxv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18567; /* pred_redmaxv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18575; /* pred_redmaxv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18583; /* pred_redmaxv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18223; /* pred_redmaxrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18231; /* pred_redmaxrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18239; /* pred_redmaxrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18247; /* pred_redmaxrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18591; /* pred_redmaxv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18599; /* pred_redmaxv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18607; /* pred_redmaxv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18615; /* pred_redmaxv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18623; /* pred_redmaxv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18631; /* pred_redmaxv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18639; /* pred_redmaxv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18647; /* pred_redmaxv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18655; /* pred_redmaxv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18663; /* pred_redmaxv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19429; /* pred_redmaxrvvm8hf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19431; /* pred_redmaxrvvm4hf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19433; /* pred_redmaxrvvm2hf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19435; /* pred_redmaxrvvm1hf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19437; /* pred_redmaxrvvmf2hf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19439; /* pred_redmaxrvvmf4hf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19459; /* pred_redmaxv1hf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19461; /* pred_redmaxv2hf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19463; /* pred_redmaxv4hf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19465; /* pred_redmaxv8hf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19467; /* pred_redmaxv16hf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19469; /* pred_redmaxv32hf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19471; /* pred_redmaxv64hf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19473; /* pred_redmaxv128hf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19475; /* pred_redmaxv256hf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19477; /* pred_redmaxv512hf */

        case 16:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19479; /* pred_redmaxv1024hf */

        case 17:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19481; /* pred_redmaxv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19441; /* pred_redmaxrvvm8sf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19443; /* pred_redmaxrvvm4sf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19445; /* pred_redmaxrvvm2sf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19447; /* pred_redmaxrvvm1sf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19449; /* pred_redmaxrvvmf2sf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19483; /* pred_redmaxv1sf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19485; /* pred_redmaxv2sf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19487; /* pred_redmaxv4sf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19489; /* pred_redmaxv8sf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19491; /* pred_redmaxv16sf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19493; /* pred_redmaxv32sf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19495; /* pred_redmaxv64sf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19497; /* pred_redmaxv128sf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19499; /* pred_redmaxv256sf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19501; /* pred_redmaxv512sf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19503; /* pred_redmaxv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19451; /* pred_redmaxrvvm8df */

        case 1:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19453; /* pred_redmaxrvvm4df */

        case 2:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19455; /* pred_redmaxrvvm2df */

        case 3:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19457; /* pred_redmaxrvvm1df */

        case 4:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19505; /* pred_redmaxv1df */

        case 5:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19507; /* pred_redmaxv2df */

        case 6:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19509; /* pred_redmaxv4df */

        case 7:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19511; /* pred_redmaxv8df */

        case 8:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19513; /* pred_redmaxv16df */

        case 9:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19515; /* pred_redmaxv32df */

        case 10:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19517; /* pred_redmaxv64df */

        case 11:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19519; /* pred_redmaxv128df */

        case 12:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19521; /* pred_redmaxv256df */

        case 13:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19523; /* pred_redmaxv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18128; /* pred_redminurvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18136; /* pred_redminurvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18144; /* pred_redminurvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18152; /* pred_redminurvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18256; /* pred_redminurvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18264; /* pred_redminurvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18272; /* pred_redminurvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18304; /* pred_redminuv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18312; /* pred_redminuv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18320; /* pred_redminuv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18328; /* pred_redminuv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18336; /* pred_redminuv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18344; /* pred_redminuv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18352; /* pred_redminuv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18360; /* pred_redminuv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18368; /* pred_redminuv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18376; /* pred_redminuv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18384; /* pred_redminuv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18392; /* pred_redminuv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18400; /* pred_redminuv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18160; /* pred_redminurvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18168; /* pred_redminurvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18176; /* pred_redminurvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18184; /* pred_redminurvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18280; /* pred_redminurvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18288; /* pred_redminurvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18408; /* pred_redminuv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18416; /* pred_redminuv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18424; /* pred_redminuv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18432; /* pred_redminuv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18440; /* pred_redminuv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18448; /* pred_redminuv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18456; /* pred_redminuv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18464; /* pred_redminuv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18472; /* pred_redminuv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18480; /* pred_redminuv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18488; /* pred_redminuv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18496; /* pred_redminuv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18192; /* pred_redminurvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18200; /* pred_redminurvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18208; /* pred_redminurvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18216; /* pred_redminurvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18296; /* pred_redminurvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18504; /* pred_redminuv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18512; /* pred_redminuv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18520; /* pred_redminuv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18528; /* pred_redminuv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18536; /* pred_redminuv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18544; /* pred_redminuv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18552; /* pred_redminuv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18560; /* pred_redminuv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18568; /* pred_redminuv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18576; /* pred_redminuv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18584; /* pred_redminuv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18224; /* pred_redminurvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18232; /* pred_redminurvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18240; /* pred_redminurvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18248; /* pred_redminurvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18592; /* pred_redminuv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18600; /* pred_redminuv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18608; /* pred_redminuv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18616; /* pred_redminuv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18624; /* pred_redminuv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18632; /* pred_redminuv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18640; /* pred_redminuv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18648; /* pred_redminuv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18656; /* pred_redminuv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18664; /* pred_redminuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (pattern361 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[7] = x7;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  switch (XINT (x8, 1))
    {
    case 143:
      return recog_78 (x1, insn, pnum_clobbers);

    case 149:
      return recog_77 (x1, insn, pnum_clobbers);

    case 150:
      return recog_66 (x1, insn, pnum_clobbers);

    case 151:
      return recog_76 (x1, insn, pnum_clobbers);

    case 152:
      return recog_65 (x1, insn, pnum_clobbers);

    case 153:
      return recog_75 (x1, insn, pnum_clobbers);

    case 154:
      return recog_74 (x1, insn, pnum_clobbers);

    case 155:
      return recog_73 (x1, insn, pnum_clobbers);

    case 144:
      return recog_72 (x1, insn, pnum_clobbers);

    case 156:
      return recog_71 (x1, insn, pnum_clobbers);

    case 157:
      return recog_64 (x1, insn, pnum_clobbers);

    case 158:
      return recog_70 (x1, insn, pnum_clobbers);

    case 159:
      return recog_63 (x1, insn, pnum_clobbers);

    case 160:
      return recog_69 (x1, insn, pnum_clobbers);

    case 161:
      return recog_68 (x1, insn, pnum_clobbers);

    case 162:
      return recog_67 (x1, insn, pnum_clobbers);

    case 163:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19213; /* pred_wredsumrvvm8qi */

            case 1:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19215; /* pred_wredsumrvvm4qi */

            case 2:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19217; /* pred_wredsumrvvm2qi */

            case 3:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19219; /* pred_wredsumrvvm1qi */

            case 4:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19221; /* pred_wredsumrvvmf2qi */

            case 5:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19223; /* pred_wredsumrvvmf4qi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19225; /* pred_wredsumrvvmf8qi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19249; /* pred_wredsumv1qi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19251; /* pred_wredsumv2qi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19253; /* pred_wredsumv4qi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19255; /* pred_wredsumv8qi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19257; /* pred_wredsumv16qi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19259; /* pred_wredsumv32qi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19261; /* pred_wredsumv64qi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19263; /* pred_wredsumv128qi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19265; /* pred_wredsumv256qi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19267; /* pred_wredsumv512qi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19269; /* pred_wredsumv1024qi */

            case 18:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19271; /* pred_wredsumv2048qi */

            case 19:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19273; /* pred_wredsumv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19227; /* pred_wredsumrvvm8hi */

            case 1:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19229; /* pred_wredsumrvvm4hi */

            case 2:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19231; /* pred_wredsumrvvm2hi */

            case 3:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19233; /* pred_wredsumrvvm1hi */

            case 4:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19235; /* pred_wredsumrvvmf2hi */

            case 5:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19237; /* pred_wredsumrvvmf4hi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19275; /* pred_wredsumv1hi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19277; /* pred_wredsumv2hi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19279; /* pred_wredsumv4hi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19281; /* pred_wredsumv8hi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19283; /* pred_wredsumv16hi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19285; /* pred_wredsumv32hi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19287; /* pred_wredsumv64hi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19289; /* pred_wredsumv128hi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19291; /* pred_wredsumv256hi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19293; /* pred_wredsumv512hi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19295; /* pred_wredsumv1024hi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19297; /* pred_wredsumv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19239; /* pred_wredsumrvvm8si */

            case 1:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19241; /* pred_wredsumrvvm4si */

            case 2:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19243; /* pred_wredsumrvvm2si */

            case 3:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19245; /* pred_wredsumrvvm1si */

            case 4:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19247; /* pred_wredsumrvvmf2si */

            case 5:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19299; /* pred_wredsumv1si */

            case 6:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19301; /* pred_wredsumv2si */

            case 7:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19303; /* pred_wredsumv4si */

            case 8:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19305; /* pred_wredsumv8si */

            case 9:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19307; /* pred_wredsumv16si */

            case 10:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19309; /* pred_wredsumv32si */

            case 11:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19311; /* pred_wredsumv64si */

            case 12:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19313; /* pred_wredsumv128si */

            case 13:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19315; /* pred_wredsumv256si */

            case 14:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19317; /* pred_wredsumv512si */

            case 15:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19319; /* pred_wredsumv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 164:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19214; /* pred_wredsumurvvm8qi */

            case 1:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19216; /* pred_wredsumurvvm4qi */

            case 2:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19218; /* pred_wredsumurvvm2qi */

            case 3:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19220; /* pred_wredsumurvvm1qi */

            case 4:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19222; /* pred_wredsumurvvmf2qi */

            case 5:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19224; /* pred_wredsumurvvmf4qi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19226; /* pred_wredsumurvvmf8qi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19250; /* pred_wredsumuv1qi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19252; /* pred_wredsumuv2qi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19254; /* pred_wredsumuv4qi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19256; /* pred_wredsumuv8qi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19258; /* pred_wredsumuv16qi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19260; /* pred_wredsumuv32qi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19262; /* pred_wredsumuv64qi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19264; /* pred_wredsumuv128qi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19266; /* pred_wredsumuv256qi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19268; /* pred_wredsumuv512qi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19270; /* pred_wredsumuv1024qi */

            case 18:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19272; /* pred_wredsumuv2048qi */

            case 19:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19274; /* pred_wredsumuv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19228; /* pred_wredsumurvvm8hi */

            case 1:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19230; /* pred_wredsumurvvm4hi */

            case 2:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19232; /* pred_wredsumurvvm2hi */

            case 3:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19234; /* pred_wredsumurvvm1hi */

            case 4:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19236; /* pred_wredsumurvvmf2hi */

            case 5:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19238; /* pred_wredsumurvvmf4hi */

            case 6:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19276; /* pred_wredsumuv1hi */

            case 7:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19278; /* pred_wredsumuv2hi */

            case 8:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19280; /* pred_wredsumuv4hi */

            case 9:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19282; /* pred_wredsumuv8hi */

            case 10:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19284; /* pred_wredsumuv16hi */

            case 11:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19286; /* pred_wredsumuv32hi */

            case 12:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19288; /* pred_wredsumuv64hi */

            case 13:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19290; /* pred_wredsumuv128hi */

            case 14:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19292; /* pred_wredsumuv256hi */

            case 15:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19294; /* pred_wredsumuv512hi */

            case 16:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19296; /* pred_wredsumuv1024hi */

            case 17:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19298; /* pred_wredsumuv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19240; /* pred_wredsumurvvm8si */

            case 1:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19242; /* pred_wredsumurvvm4si */

            case 2:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19244; /* pred_wredsumurvvm2si */

            case 3:
              if (!
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19246; /* pred_wredsumurvvm1si */

            case 4:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19248; /* pred_wredsumurvvmf2si */

            case 5:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19300; /* pred_wredsumuv1si */

            case 6:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19302; /* pred_wredsumuv2si */

            case 7:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19304; /* pred_wredsumuv4si */

            case 8:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19306; /* pred_wredsumuv8si */

            case 9:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19308; /* pred_wredsumuv16si */

            case 10:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19310; /* pred_wredsumuv32si */

            case 11:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19312; /* pred_wredsumuv64si */

            case 12:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19314; /* pred_wredsumuv128si */

            case 13:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19316; /* pred_wredsumuv256si */

            case 14:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19318; /* pred_wredsumuv512si */

            case 15:
              if (!(
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19320; /* pred_wredsumuv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 165:
      return recog_79 (x1, insn, pnum_clobbers);

    case 166:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19322; /* pred_wredsumu_vl0srvvm8qi */

            case 1:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19324; /* pred_wredsumu_vl0srvvm4qi */

            case 2:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19326; /* pred_wredsumu_vl0srvvm2qi */

            case 3:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19328; /* pred_wredsumu_vl0srvvm1qi */

            case 4:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19330; /* pred_wredsumu_vl0srvvmf2qi */

            case 5:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19332; /* pred_wredsumu_vl0srvvmf4qi */

            case 6:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19334; /* pred_wredsumu_vl0srvvmf8qi */

            case 7:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19358; /* pred_wredsumu_vl0sv1qi */

            case 8:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19360; /* pred_wredsumu_vl0sv2qi */

            case 9:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19362; /* pred_wredsumu_vl0sv4qi */

            case 10:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19364; /* pred_wredsumu_vl0sv8qi */

            case 11:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19366; /* pred_wredsumu_vl0sv16qi */

            case 12:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19368; /* pred_wredsumu_vl0sv32qi */

            case 13:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19370; /* pred_wredsumu_vl0sv64qi */

            case 14:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19372; /* pred_wredsumu_vl0sv128qi */

            case 15:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19374; /* pred_wredsumu_vl0sv256qi */

            case 16:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19376; /* pred_wredsumu_vl0sv512qi */

            case 17:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19378; /* pred_wredsumu_vl0sv1024qi */

            case 18:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19380; /* pred_wredsumu_vl0sv2048qi */

            case 19:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19382; /* pred_wredsumu_vl0sv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19336; /* pred_wredsumu_vl0srvvm8hi */

            case 1:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19338; /* pred_wredsumu_vl0srvvm4hi */

            case 2:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19340; /* pred_wredsumu_vl0srvvm2hi */

            case 3:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19342; /* pred_wredsumu_vl0srvvm1hi */

            case 4:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19344; /* pred_wredsumu_vl0srvvmf2hi */

            case 5:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19346; /* pred_wredsumu_vl0srvvmf4hi */

            case 6:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19384; /* pred_wredsumu_vl0sv1hi */

            case 7:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19386; /* pred_wredsumu_vl0sv2hi */

            case 8:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19388; /* pred_wredsumu_vl0sv4hi */

            case 9:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19390; /* pred_wredsumu_vl0sv8hi */

            case 10:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19392; /* pred_wredsumu_vl0sv16hi */

            case 11:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19394; /* pred_wredsumu_vl0sv32hi */

            case 12:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19396; /* pred_wredsumu_vl0sv64hi */

            case 13:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19398; /* pred_wredsumu_vl0sv128hi */

            case 14:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19400; /* pred_wredsumu_vl0sv256hi */

            case 15:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19402; /* pred_wredsumu_vl0sv512hi */

            case 16:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19404; /* pred_wredsumu_vl0sv1024hi */

            case 17:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19406; /* pred_wredsumu_vl0sv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19348; /* pred_wredsumu_vl0srvvm8si */

            case 1:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19350; /* pred_wredsumu_vl0srvvm4si */

            case 2:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19352; /* pred_wredsumu_vl0srvvm2si */

            case 3:
              if (!
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19354; /* pred_wredsumu_vl0srvvm1si */

            case 4:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 19356; /* pred_wredsumu_vl0srvvmf2si */

            case 5:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19408; /* pred_wredsumu_vl0sv1si */

            case 6:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19410; /* pred_wredsumu_vl0sv2si */

            case 7:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19412; /* pred_wredsumu_vl0sv4si */

            case 8:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19414; /* pred_wredsumu_vl0sv8si */

            case 9:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19416; /* pred_wredsumu_vl0sv16si */

            case 10:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19418; /* pred_wredsumu_vl0sv32si */

            case 11:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19420; /* pred_wredsumu_vl0sv64si */

            case 12:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19422; /* pred_wredsumu_vl0sv128si */

            case 13:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19424; /* pred_wredsumu_vl0sv256si */

            case 14:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19426; /* pred_wredsumu_vl0sv512si */

            case 15:
              if (!(
#line 7846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19428; /* pred_wredsumu_vl0sv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern195 (x1))
    {
    case 0:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20323; /* pred_slide1uprvvm8qi */

    case 1:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20325; /* pred_slide1uprvvm4qi */

    case 2:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20327; /* pred_slide1uprvvm2qi */

    case 3:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20329; /* pred_slide1uprvvm1qi */

    case 4:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20331; /* pred_slide1uprvvmf2qi */

    case 5:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20333; /* pred_slide1uprvvmf4qi */

    case 6:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20335; /* pred_slide1uprvvmf8qi */

    case 7:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20337; /* pred_slide1uprvvm8hi */

    case 8:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20339; /* pred_slide1uprvvm4hi */

    case 9:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20341; /* pred_slide1uprvvm2hi */

    case 10:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20343; /* pred_slide1uprvvm1hi */

    case 11:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20345; /* pred_slide1uprvvmf2hi */

    case 12:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20347; /* pred_slide1uprvvmf4hi */

    case 13:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20349; /* pred_slide1uprvvm8si */

    case 14:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20351; /* pred_slide1uprvvm4si */

    case 15:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20353; /* pred_slide1uprvvm2si */

    case 16:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20355; /* pred_slide1uprvvm1si */

    case 17:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20357; /* pred_slide1uprvvmf2si */

    case 18:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20359; /* pred_slide1upv1qi */

    case 19:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20361; /* pred_slide1upv2qi */

    case 20:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20363; /* pred_slide1upv4qi */

    case 21:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20365; /* pred_slide1upv8qi */

    case 22:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20367; /* pred_slide1upv16qi */

    case 23:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 20369; /* pred_slide1upv32qi */

    case 24:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20371; /* pred_slide1upv64qi */

    case 25:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20373; /* pred_slide1upv128qi */

    case 26:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20375; /* pred_slide1upv256qi */

    case 27:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20377; /* pred_slide1upv512qi */

    case 28:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20379; /* pred_slide1upv1024qi */

    case 29:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20381; /* pred_slide1upv2048qi */

    case 30:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20383; /* pred_slide1upv4096qi */

    case 31:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20385; /* pred_slide1upv1hi */

    case 32:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20387; /* pred_slide1upv2hi */

    case 33:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20389; /* pred_slide1upv4hi */

    case 34:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20391; /* pred_slide1upv8hi */

    case 35:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20393; /* pred_slide1upv16hi */

    case 36:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20395; /* pred_slide1upv32hi */

    case 37:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20397; /* pred_slide1upv64hi */

    case 38:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20399; /* pred_slide1upv128hi */

    case 39:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20401; /* pred_slide1upv256hi */

    case 40:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20403; /* pred_slide1upv512hi */

    case 41:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20405; /* pred_slide1upv1024hi */

    case 42:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20407; /* pred_slide1upv2048hi */

    case 43:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20409; /* pred_slide1upv1si */

    case 44:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20411; /* pred_slide1upv2si */

    case 45:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20413; /* pred_slide1upv4si */

    case 46:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20415; /* pred_slide1upv8si */

    case 47:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20417; /* pred_slide1upv16si */

    case 48:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20419; /* pred_slide1upv32si */

    case 49:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20421; /* pred_slide1upv64si */

    case 50:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20423; /* pred_slide1upv128si */

    case 51:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20425; /* pred_slide1upv256si */

    case 52:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20427; /* pred_slide1upv512si */

    case 53:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20429; /* pred_slide1upv1024si */

    case 54:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20431; /* *pred_slide1uprvvm8di */

    case 55:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20433; /* *pred_slide1uprvvm4di */

    case 56:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20435; /* *pred_slide1uprvvm2di */

    case 57:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20437; /* *pred_slide1uprvvm1di */

    case 58:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20439; /* *pred_slide1upv1di */

    case 59:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20441; /* *pred_slide1upv2di */

    case 60:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20443; /* *pred_slide1upv4di */

    case 61:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20445; /* *pred_slide1upv8di */

    case 62:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20447; /* *pred_slide1upv16di */

    case 63:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20449; /* *pred_slide1upv32di */

    case 64:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20451; /* *pred_slide1upv64di */

    case 65:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20453; /* *pred_slide1upv128di */

    case 66:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20455; /* *pred_slide1upv256di */

    case 67:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20457; /* *pred_slide1upv512di */

    case 68:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20459; /* *pred_slide1uprvvm8di_extended */

    case 69:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20461; /* *pred_slide1uprvvm4di_extended */

    case 70:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20463; /* *pred_slide1uprvvm2di_extended */

    case 71:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20465; /* *pred_slide1uprvvm1di_extended */

    case 72:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20467; /* *pred_slide1upv1di_extended */

    case 73:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20469; /* *pred_slide1upv2di_extended */

    case 74:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20471; /* *pred_slide1upv4di_extended */

    case 75:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20473; /* *pred_slide1upv8di_extended */

    case 76:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20475; /* *pred_slide1upv16di_extended */

    case 77:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20477; /* *pred_slide1upv32di_extended */

    case 78:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20479; /* *pred_slide1upv64di_extended */

    case 79:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20481; /* *pred_slide1upv128di_extended */

    case 80:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20483; /* *pred_slide1upv256di_extended */

    case 81:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20485; /* *pred_slide1upv512di_extended */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 36:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          switch (pattern334 (x2, 
E_HFmode))
            {
            case 0:
              if (!(
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 142; /* *movhf_softfloat_boxing */

            case 1:
              if (!(
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 144; /* *movhf_softfloat_boxing */

            default:
              return -1;
            }

        case E_BFmode:
          switch (pattern334 (x2, 
E_BFmode))
            {
            case 0:
              if (!(
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 143; /* *movbf_softfloat_boxing */

            case 1:
              if (!(
#line 2077 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 145; /* *movbf_softfloat_boxing */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern177 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 2176 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 176; /* *lrintsfsi2 */

            case 1:
              if (!(
#line 2176 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 177; /* *lrintdfsi2 */

            case 2:
              if (!(
#line 2176 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 178; /* *lrinthfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern177 (x2, 
E_DImode))
            {
            case 0:
              if (!(
#line 2196 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 182; /* lrintsfdi2 */

            case 1:
              if (!(
#line 2196 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 183; /* lrintdfdi2 */

            case 2:
              if (!(
#line 2196 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 184; /* lrinthfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 17:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 185; /* *lroundsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 191; /* *lrounddfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 197; /* *lroundhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 221; /* lroundsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 227; /* lrounddfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 233; /* lroundhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 239; /* roundsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 245; /* rounddf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 251; /* roundhf_zfa2 */

        default:
          return -1;
        }

    case 18:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 186; /* *lfloorsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 192; /* *lfloordfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 198; /* *lfloorhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 222; /* lfloorsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 228; /* lfloordfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 234; /* lfloorhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 240; /* floorsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 246; /* floordf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 252; /* floorhf_zfa2 */

        default:
          return -1;
        }

    case 19:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 187; /* *lceilsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 193; /* *lceildfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 199; /* *lceilhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 223; /* lceilsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 229; /* lceildfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 235; /* lceilhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 241; /* ceilsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 247; /* ceildf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 253; /* ceilhf_zfa2 */

        default:
          return -1;
        }

    case 20:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 188; /* *lbtruncsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 194; /* *lbtruncdfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 200; /* *lbtrunchfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 224; /* lbtruncsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 230; /* lbtruncdfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 236; /* lbtrunchfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 242; /* btruncsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 248; /* btruncdf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 254; /* btrunchf_zfa2 */

        default:
          return -1;
        }

    case 21:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 189; /* *lroundevensfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 195; /* *lroundevendfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 201; /* *lroundevenhfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 225; /* lroundevensfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 231; /* lroundevendfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 237; /* lroundevenhfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 243; /* roundevensf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 249; /* roundevendf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 255; /* roundevenhf_zfa2 */

        default:
          return -1;
        }

    case 22:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 190; /* *lnearbyintsfsi2 */

        case 1:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 196; /* *lnearbyintdfsi2 */

        case 2:
          if (!(
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 202; /* *lnearbyinthfsi2 */

        case 3:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 226; /* lnearbyintsfdi2 */

        case 4:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 232; /* lnearbyintdfdi2 */

        case 5:
          if (!(
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 238; /* lnearbyinthfdi2 */

        case 6:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 244; /* nearbyintsf_zfa2 */

        case 7:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 250; /* nearbyintdf_zfa2 */

        case 8:
          if (!(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 256; /* nearbyinthf_zfa2 */

        default:
          return -1;
        }

    case 16:
      return recog_53 (x1, insn, pnum_clobbers);

    case 4:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 260; /* got_loadsi */

        case 1:
          if (!
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 261; /* got_loaddi */

        default:
          return -1;
        }

    case 8:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 264; /* got_load_tls_gdsi */

        case 1:
          if (!
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 265; /* got_load_tls_gddi */

        default:
          return -1;
        }

    case 7:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 266; /* got_load_tls_iesi */

        case 1:
          if (!
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 267; /* got_load_tls_iedi */

        default:
          return -1;
        }

    case 9:
      return recog_55 (x1, insn, pnum_clobbers);

    case 14:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 2699 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
        return -1;
      return 290; /* movsidf2_low_rv32 */

    case 15:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 2711 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
        return -1;
      return 291; /* movsidf2_high_rv32 */

    case 28:
      return recog_54 (x1, insn, pnum_clobbers);

    case 30:
      switch (pattern180 (x1))
        {
        case 0:
          if (
#line 465 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return 566; /* orcbsi2 */
          if (!(
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 889; /* th_tstnbzsi2 */

        case 1:
          if ((
#line 465 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 567; /* orcbdi2 */
          if (!(
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 890; /* th_tstnbzdi2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 78 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB))
            return -1;
          return 661; /* riscv_brev8_si */

        case 1:
          if (!(
#line 78 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 662; /* riscv_brev8_di */

        default:
          return -1;
        }

    case 44:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 86 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && !TARGET_64BIT))
        return -1;
      return 663; /* riscv_zip */

    case 45:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 94 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && !TARGET_64BIT))
        return -1;
      return 664; /* riscv_unzip */

    case 55:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 687; /* riscv_aes64im */

    case 62:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 694; /* *riscv_sha256sig0_si */

    case 63:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 695; /* *riscv_sha256sig1_si */

    case 64:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 696; /* *riscv_sha256sum0_si */

    case 65:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 697; /* *riscv_sha256sum1_si */

    case 66:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 419 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 708; /* riscv_sha512sig0 */

    case 69:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 427 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 709; /* riscv_sha512sig1 */

    case 72:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 435 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 710; /* riscv_sha512sum0 */

    case 74:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 443 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 711; /* riscv_sha512sum1 */

    case 76:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 456 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && !TARGET_64BIT))
        return -1;
      return 712; /* *riscv_sm3p0_si */

    case 77:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 456 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && !TARGET_64BIT))
        return -1;
      return 713; /* *riscv_sm3p1_si */

    case 37:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 897; /* th_fmv_x_w */

    case 38:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 898; /* th_fmv_x_hw */

    case 92:
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 0
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      return recog_50 (x1, insn, pnum_clobbers);

    case 94:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[1], E_SImode)
              || !(
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 2719; /* vlmax_avlsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const_int_operand (operands[1], E_DImode)
              || !(
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 2720; /* vlmax_avldi */

        default:
          return -1;
        }

    case 143:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      return recog_51 (x1, insn, pnum_clobbers);

    case 146:
      return recog_52 (x1, insn, pnum_clobbers);

    case 290:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34000; /* riscv_cv_simd_abs_h_si */

    case 291:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1564 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34001; /* riscv_cv_simd_abs_b_si */

    case 292:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34002; /* riscv_cv_simd_neg_h_si */

    case 293:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1582 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34003; /* riscv_cv_simd_neg_b_si */

    case 376:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2597 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34086; /* riscv_cv_simd_cplxconj_si */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      x2 = XEXP (x1, 1);
      switch (pattern295 (x2))
        {
        case 0:
          if (
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX
   && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))))
            return 121; /* *zero_extendsidi2_internal */
          if (!
#line 25 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA && !TARGET_XTHEADMEMIDX))
            return -1;
          return 508; /* *zero_extendsidi2_bitmanip */

        case 1:
          if ((
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 123; /* *zero_extendhidi2 */
          if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 541; /* *zero_extendhidi2_bitmanip */

        case 2:
          if (!(
#line 1934 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 126; /* *zero_extendqidi2_internal */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 122; /* *zero_extendhisi2 */
          if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 540; /* *zero_extendhisi2_bitmanip */

        case 1:
          if (!
#line 1934 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX))
            return -1;
          return 125; /* *zero_extendqisi2_internal */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !
#line 1934 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX))
        return -1;
      return 124; /* *zero_extendqihi2_internal */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26104; /* zero_extendrvvm4qirvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26106; /* zero_extendrvvm2qirvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26108; /* zero_extendrvvm1qirvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26110; /* zero_extendrvvmf2qirvvm1hi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26112; /* zero_extendrvvmf4qirvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 26114; /* zero_extendrvvmf8qirvvmf4hi2 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      switch (pattern296 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26116; /* zero_extendrvvm4hirvvm8si2 */

        case 1:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26200; /* zero_extendrvvm2qirvvm8si2 */

        default:
          return -1;
        }

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern297 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26118; /* zero_extendrvvm2hirvvm4si2 */

        case 1:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26202; /* zero_extendrvvm1qirvvm4si2 */

        default:
          return -1;
        }

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern298 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26120; /* zero_extendrvvm1hirvvm2si2 */

        case 1:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26204; /* zero_extendrvvmf2qirvvm2si2 */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern299 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26122; /* zero_extendrvvmf2hirvvm1si2 */

        case 1:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26206; /* zero_extendrvvmf4qirvvm1si2 */

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern300 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26124; /* zero_extendrvvmf4hirvvmf2si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26208; /* zero_extendrvvmf8qirvvmf2si2 */

        default:
          return -1;
        }

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      switch (pattern301 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26126; /* zero_extendrvvm4sirvvm8di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26210; /* zero_extendrvvm2hirvvm8di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26260; /* zero_extendrvvm1qirvvm8di2 */

        default:
          return -1;
        }

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26128; /* zero_extendrvvm2sirvvm4di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26212; /* zero_extendrvvm1hirvvm4di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26262; /* zero_extendrvvmf2qirvvm4di2 */

        default:
          return -1;
        }

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      switch (pattern303 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26130; /* zero_extendrvvm1sirvvm2di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26214; /* zero_extendrvvmf2hirvvm2di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26264; /* zero_extendrvvmf4qirvvm2di2 */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern304 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26132; /* zero_extendrvvmf2sirvvm1di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26216; /* zero_extendrvvmf4hirvvm1di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26266; /* zero_extendrvvmf8qirvvm1di2 */

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26134; /* zero_extendv1qiv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26136; /* zero_extendv2qiv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26138; /* zero_extendv4qiv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26140; /* zero_extendv8qiv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26142; /* zero_extendv16qiv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26144; /* zero_extendv32qiv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26146; /* zero_extendv64qiv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26148; /* zero_extendv128qiv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26150; /* zero_extendv256qiv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26152; /* zero_extendv512qiv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26154; /* zero_extendv1024qiv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26156; /* zero_extendv2048qiv2048hi2 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern305 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26158; /* zero_extendv1hiv1si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26218; /* zero_extendv1qiv1si2 */

        default:
          return -1;
        }

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26160; /* zero_extendv2hiv2si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26220; /* zero_extendv2qiv2si2 */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern307 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26162; /* zero_extendv4hiv4si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26222; /* zero_extendv4qiv4si2 */

        default:
          return -1;
        }

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      switch (pattern308 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26164; /* zero_extendv8hiv8si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26224; /* zero_extendv8qiv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      switch (pattern309 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26166; /* zero_extendv16hiv16si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26226; /* zero_extendv16qiv16si2 */

        default:
          return -1;
        }

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      switch (pattern310 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26168; /* zero_extendv32hiv32si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26228; /* zero_extendv32qiv32si2 */

        default:
          return -1;
        }

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      switch (pattern311 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26170; /* zero_extendv64hiv64si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26230; /* zero_extendv64qiv64si2 */

        default:
          return -1;
        }

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      switch (pattern312 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26172; /* zero_extendv128hiv128si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26232; /* zero_extendv128qiv128si2 */

        default:
          return -1;
        }

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      switch (pattern313 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26174; /* zero_extendv256hiv256si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26234; /* zero_extendv256qiv256si2 */

        default:
          return -1;
        }

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      switch (pattern314 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26176; /* zero_extendv512hiv512si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26236; /* zero_extendv512qiv512si2 */

        default:
          return -1;
        }

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      switch (pattern315 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26178; /* zero_extendv1024hiv1024si2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26238; /* zero_extendv1024qiv1024si2 */

        default:
          return -1;
        }

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern316 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26180; /* zero_extendv1siv1di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26240; /* zero_extendv1hiv1di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26268; /* zero_extendv1qiv1di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      switch (pattern317 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26182; /* zero_extendv2siv2di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26242; /* zero_extendv2hiv2di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26270; /* zero_extendv2qiv2di2 */

        default:
          return -1;
        }

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26184; /* zero_extendv4siv4di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26244; /* zero_extendv4hiv4di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26272; /* zero_extendv4qiv4di2 */

        default:
          return -1;
        }

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26186; /* zero_extendv8siv8di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26246; /* zero_extendv8hiv8di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26274; /* zero_extendv8qiv8di2 */

        default:
          return -1;
        }

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      switch (pattern320 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26188; /* zero_extendv16siv16di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26248; /* zero_extendv16hiv16di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26276; /* zero_extendv16qiv16di2 */

        default:
          return -1;
        }

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      switch (pattern321 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26190; /* zero_extendv32siv32di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26250; /* zero_extendv32hiv32di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26278; /* zero_extendv32qiv32di2 */

        default:
          return -1;
        }

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      switch (pattern322 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26192; /* zero_extendv64siv64di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26252; /* zero_extendv64hiv64di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26280; /* zero_extendv64qiv64di2 */

        default:
          return -1;
        }

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      switch (pattern323 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26194; /* zero_extendv128siv128di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26254; /* zero_extendv128hiv128di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26282; /* zero_extendv128qiv128di2 */

        default:
          return -1;
        }

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      switch (pattern324 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26196; /* zero_extendv256siv256di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26256; /* zero_extendv256hiv256di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26284; /* zero_extendv256qiv256di2 */

        default:
          return -1;
        }

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      switch (pattern325 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26198; /* zero_extendv512siv512di2 */

        case 1:
          if (!(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26258; /* zero_extendv512hiv512di2 */

        case 2:
          if (!(
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26286; /* zero_extendv512qiv512di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3104; /* *movrvvm4x2di_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3105; /* *movrvvm4x2di_di */
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3082; /* *movrvvmf2x8qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3083; /* *movrvvmf2x8qi_di */
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3066; /* *movrvvm2x3df_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3067; /* *movrvvm2x3df_di */
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3050; /* *movrvvm1x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3051; /* *movrvvm1x2sf_di */
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3034; /* *movrvvmf2x8bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3035; /* *movrvvmf2x8bf_di */
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3018; /* *movrvvm2x3di_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3019; /* *movrvvm2x3di_di */
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2996; /* *movrvvmf2x6hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2997; /* *movrvvmf2x6hi_di */
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x5QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x5QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2980; /* *movrvvmf4x5qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2981; /* *movrvvmf4x5qi_di */
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2964; /* *movrvvm1x4df_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2965; /* *movrvvm1x4df_di */
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2948; /* *movrvvmf2x3sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2949; /* *movrvvmf2x3sf_di */
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2932; /* *movrvvmf4x2hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2933; /* *movrvvmf4x2hf_di */
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2916; /* *movrvvm1x8di_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2917; /* *movrvvm1x8di_di */
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2900; /* *movrvvmf2x7si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2901; /* *movrvvmf2x7si_di */
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern205 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM4QImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32245; /* *vwsll_zext1_rvvm8hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32341; /* *vwsll_zext1_scalar_rvvm8hi */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM2QImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32246; /* *vwsll_zext1_rvvm4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32342; /* *vwsll_zext1_scalar_rvvm4hi */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM1QImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32247; /* *vwsll_zext1_rvvm2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32343; /* *vwsll_zext1_scalar_rvvm2hi */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVMF2QImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32248; /* *vwsll_zext1_rvvm1hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32344; /* *vwsll_zext1_scalar_rvvm1hi */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF4QImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32249; /* *vwsll_zext1_rvvmf2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32345; /* *vwsll_zext1_scalar_rvvmf2hi */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVMF8QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32250; /* *vwsll_zext1_rvvmf4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32346; /* *vwsll_zext1_scalar_rvvmf4hi */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4HImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32251; /* *vwsll_zext1_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32347; /* *vwsll_zext1_scalar_rvvm8si */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2HImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32252; /* *vwsll_zext1_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32348; /* *vwsll_zext1_scalar_rvvm4si */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1HImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32253; /* *vwsll_zext1_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32349; /* *vwsll_zext1_scalar_rvvm2si */

    case 9:
      if (vector_shift_operand (operands[2], E_RVVMF2HImode)
          && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32254; /* *vwsll_zext1_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32350; /* *vwsll_zext1_scalar_rvvm1si */

    case 10:
      if (vector_shift_operand (operands[2], E_RVVMF4HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32255; /* *vwsll_zext1_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32351; /* *vwsll_zext1_scalar_rvvmf2si */

    case 11:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32256; /* *vwsll_zext1_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32352; /* *vwsll_zext1_scalar_rvvm8di */

    case 12:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32257; /* *vwsll_zext1_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32353; /* *vwsll_zext1_scalar_rvvm4di */

    case 13:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32258; /* *vwsll_zext1_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32354; /* *vwsll_zext1_scalar_rvvm2di */

    case 14:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32259; /* *vwsll_zext1_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32355; /* *vwsll_zext1_scalar_rvvm1di */

    case 15:
      if (vector_shift_operand (operands[2], E_V1QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 32260; /* *vwsll_zext1_v1hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32356; /* *vwsll_zext1_scalar_v1hi */

    case 16:
      if (vector_shift_operand (operands[2], E_V2QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 32261; /* *vwsll_zext1_v2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32357; /* *vwsll_zext1_scalar_v2hi */

    case 17:
      if (vector_shift_operand (operands[2], E_V4QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 32262; /* *vwsll_zext1_v4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32358; /* *vwsll_zext1_scalar_v4hi */

    case 18:
      if (vector_shift_operand (operands[2], E_V8QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 32263; /* *vwsll_zext1_v8hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32359; /* *vwsll_zext1_scalar_v8hi */

    case 19:
      if (vector_shift_operand (operands[2], E_V16QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 32264; /* *vwsll_zext1_v16hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32360; /* *vwsll_zext1_scalar_v16hi */

    case 20:
      if (vector_shift_operand (operands[2], E_V32QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 32265; /* *vwsll_zext1_v32hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32361; /* *vwsll_zext1_scalar_v32hi */

    case 21:
      if (vector_shift_operand (operands[2], E_V64QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 32266; /* *vwsll_zext1_v64hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32362; /* *vwsll_zext1_scalar_v64hi */

    case 22:
      if (vector_shift_operand (operands[2], E_V128QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 32267; /* *vwsll_zext1_v128hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32363; /* *vwsll_zext1_scalar_v128hi */

    case 23:
      if (vector_shift_operand (operands[2], E_V256QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 32268; /* *vwsll_zext1_v256hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32364; /* *vwsll_zext1_scalar_v256hi */

    case 24:
      if (vector_shift_operand (operands[2], E_V512QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 32269; /* *vwsll_zext1_v512hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32365; /* *vwsll_zext1_scalar_v512hi */

    case 25:
      if (vector_shift_operand (operands[2], E_V1024QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 32270; /* *vwsll_zext1_v1024hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32366; /* *vwsll_zext1_scalar_v1024hi */

    case 26:
      if (vector_shift_operand (operands[2], E_V2048QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 32271; /* *vwsll_zext1_v2048hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32367; /* *vwsll_zext1_scalar_v2048hi */

    case 27:
      if (vector_shift_operand (operands[2], E_V1HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32272; /* *vwsll_zext1_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32368; /* *vwsll_zext1_scalar_v1si */

    case 28:
      if (vector_shift_operand (operands[2], E_V2HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32273; /* *vwsll_zext1_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32369; /* *vwsll_zext1_scalar_v2si */

    case 29:
      if (vector_shift_operand (operands[2], E_V4HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32274; /* *vwsll_zext1_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32370; /* *vwsll_zext1_scalar_v4si */

    case 30:
      if (vector_shift_operand (operands[2], E_V8HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32275; /* *vwsll_zext1_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32371; /* *vwsll_zext1_scalar_v8si */

    case 31:
      if (vector_shift_operand (operands[2], E_V16HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32276; /* *vwsll_zext1_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32372; /* *vwsll_zext1_scalar_v16si */

    case 32:
      if (vector_shift_operand (operands[2], E_V32HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32277; /* *vwsll_zext1_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32373; /* *vwsll_zext1_scalar_v32si */

    case 33:
      if (vector_shift_operand (operands[2], E_V64HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32278; /* *vwsll_zext1_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32374; /* *vwsll_zext1_scalar_v64si */

    case 34:
      if (vector_shift_operand (operands[2], E_V128HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32279; /* *vwsll_zext1_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32375; /* *vwsll_zext1_scalar_v128si */

    case 35:
      if (vector_shift_operand (operands[2], E_V256HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32280; /* *vwsll_zext1_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32376; /* *vwsll_zext1_scalar_v256si */

    case 36:
      if (vector_shift_operand (operands[2], E_V512HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32281; /* *vwsll_zext1_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32377; /* *vwsll_zext1_scalar_v512si */

    case 37:
      if (vector_shift_operand (operands[2], E_V1024HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32282; /* *vwsll_zext1_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32378; /* *vwsll_zext1_scalar_v1024si */

    case 38:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32283; /* *vwsll_zext1_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32379; /* *vwsll_zext1_scalar_v1di */

    case 39:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32284; /* *vwsll_zext1_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32380; /* *vwsll_zext1_scalar_v2di */

    case 40:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32285; /* *vwsll_zext1_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32381; /* *vwsll_zext1_scalar_v4di */

    case 41:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32286; /* *vwsll_zext1_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32382; /* *vwsll_zext1_scalar_v8di */

    case 42:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32287; /* *vwsll_zext1_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32383; /* *vwsll_zext1_scalar_v16di */

    case 43:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32288; /* *vwsll_zext1_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32384; /* *vwsll_zext1_scalar_v32di */

    case 44:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32289; /* *vwsll_zext1_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32385; /* *vwsll_zext1_scalar_v64di */

    case 45:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32290; /* *vwsll_zext1_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32386; /* *vwsll_zext1_scalar_v128di */

    case 46:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32291; /* *vwsll_zext1_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32387; /* *vwsll_zext1_scalar_v256di */

    case 47:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32292; /* *vwsll_zext1_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32388; /* *vwsll_zext1_scalar_v512di */

    case 48:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32293; /* *vwsll_zext2_rvvm8hi */

    case 49:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32294; /* *vwsll_zext2_rvvm4hi */

    case 50:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32295; /* *vwsll_zext2_rvvm2hi */

    case 51:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32296; /* *vwsll_zext2_rvvm1hi */

    case 52:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32297; /* *vwsll_zext2_rvvmf2hi */

    case 53:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32298; /* *vwsll_zext2_rvvmf4hi */

    case 54:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32299; /* *vwsll_zext2_rvvm8si */

    case 55:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32300; /* *vwsll_zext2_rvvm4si */

    case 56:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32301; /* *vwsll_zext2_rvvm2si */

    case 57:
      if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32302; /* *vwsll_zext2_rvvm1si */

    case 58:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32303; /* *vwsll_zext2_rvvmf2si */

    case 59:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32304; /* *vwsll_zext2_rvvm8di */

    case 60:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32305; /* *vwsll_zext2_rvvm4di */

    case 61:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32306; /* *vwsll_zext2_rvvm2di */

    case 62:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32307; /* *vwsll_zext2_rvvm1di */

    case 63:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32308; /* *vwsll_zext2_v1hi */

    case 64:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32309; /* *vwsll_zext2_v2hi */

    case 65:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32310; /* *vwsll_zext2_v4hi */

    case 66:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32311; /* *vwsll_zext2_v8hi */

    case 67:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32312; /* *vwsll_zext2_v16hi */

    case 68:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32313; /* *vwsll_zext2_v32hi */

    case 69:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32314; /* *vwsll_zext2_v64hi */

    case 70:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32315; /* *vwsll_zext2_v128hi */

    case 71:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32316; /* *vwsll_zext2_v256hi */

    case 72:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32317; /* *vwsll_zext2_v512hi */

    case 73:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32318; /* *vwsll_zext2_v1024hi */

    case 74:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32319; /* *vwsll_zext2_v2048hi */

    case 75:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32320; /* *vwsll_zext2_v1si */

    case 76:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32321; /* *vwsll_zext2_v2si */

    case 77:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32322; /* *vwsll_zext2_v4si */

    case 78:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32323; /* *vwsll_zext2_v8si */

    case 79:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32324; /* *vwsll_zext2_v16si */

    case 80:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32325; /* *vwsll_zext2_v32si */

    case 81:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32326; /* *vwsll_zext2_v64si */

    case 82:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32327; /* *vwsll_zext2_v128si */

    case 83:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32328; /* *vwsll_zext2_v256si */

    case 84:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32329; /* *vwsll_zext2_v512si */

    case 85:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32330; /* *vwsll_zext2_v1024si */

    case 86:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32331; /* *vwsll_zext2_v1di */

    case 87:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32332; /* *vwsll_zext2_v2di */

    case 88:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32333; /* *vwsll_zext2_v4di */

    case 89:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32334; /* *vwsll_zext2_v8di */

    case 90:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32335; /* *vwsll_zext2_v16di */

    case 91:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32336; /* *vwsll_zext2_v32di */

    case 92:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32337; /* *vwsll_zext2_v64di */

    case 93:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32338; /* *vwsll_zext2_v128di */

    case 94:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32339; /* *vwsll_zext2_v256di */

    case 95:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32340; /* *vwsll_zext2_v512di */

    default:
      return -1;
    }
}

 int
recog_404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33506; /* pred_crypto_vvaeszvsrvvm8si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33566; /* pred_crypto_vvaeszvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33626; /* pred_crypto_vvaeszvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33674; /* pred_crypto_vvaeszvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33710; /* pred_crypto_vvaeszvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33734; /* pred_crypto_vvaeszvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33518; /* pred_crypto_vvaeszvsrvvm4si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33578; /* pred_crypto_vvaeszvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33638; /* pred_crypto_vvaeszvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33686; /* pred_crypto_vvaeszvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33722; /* pred_crypto_vvaeszvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33530; /* pred_crypto_vvaeszvsrvvm2si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33590; /* pred_crypto_vvaeszvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33650; /* pred_crypto_vvaeszvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33698; /* pred_crypto_vvaeszvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33542; /* pred_crypto_vvaeszvsrvvm1si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33602; /* pred_crypto_vvaeszvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33662; /* pred_crypto_vvaeszvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33554; /* pred_crypto_vvaeszvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33614; /* pred_crypto_vvaeszvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_407 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (XINT (x7, 1))
    {
    case 201:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33377; /* pred_vghshrvvm8si */

        case E_RVVM4SImode:
          if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33381; /* pred_vghshrvvm4si */

        case E_RVVM2SImode:
          if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33385; /* pred_vghshrvvm2si */

        case E_RVVM1SImode:
          if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33389; /* pred_vghshrvvm1si */

        case E_RVVMF2SImode:
          if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33393; /* pred_vghshrvvmf2si */

        case E_RVVM8DImode:
          if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33397; /* pred_vghshrvvm8di */

        case E_RVVM4DImode:
          if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33401; /* pred_vghshrvvm4di */

        case E_RVVM2DImode:
          if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33405; /* pred_vghshrvvm2di */

        case E_RVVM1DImode:
          if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33409; /* pred_vghshrvvm1di */

        case E_V1SImode:
          if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33413; /* pred_vghshv1si */

        case E_V2SImode:
          if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33417; /* pred_vghshv2si */

        case E_V4SImode:
          if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33421; /* pred_vghshv4si */

        case E_V8SImode:
          if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33425; /* pred_vghshv8si */

        case E_V16SImode:
          if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33429; /* pred_vghshv16si */

        case E_V32SImode:
          if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33433; /* pred_vghshv32si */

        case E_V64SImode:
          if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33437; /* pred_vghshv64si */

        case E_V128SImode:
          if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33441; /* pred_vghshv128si */

        case E_V256SImode:
          if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33445; /* pred_vghshv256si */

        case E_V512SImode:
          if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33449; /* pred_vghshv512si */

        case E_V1024SImode:
          if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33453; /* pred_vghshv1024si */

        case E_V1DImode:
          if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33457; /* pred_vghshv1di */

        case E_V2DImode:
          if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33461; /* pred_vghshv2di */

        case E_V4DImode:
          if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33465; /* pred_vghshv4di */

        case E_V8DImode:
          if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33469; /* pred_vghshv8di */

        case E_V16DImode:
          if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33473; /* pred_vghshv16di */

        case E_V32DImode:
          if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33477; /* pred_vghshv32di */

        case E_V64DImode:
          if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33481; /* pred_vghshv64di */

        case E_V128DImode:
          if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33485; /* pred_vghshv128di */

        case E_V256DImode:
          if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33489; /* pred_vghshv256di */

        case E_V512DImode:
          if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33493; /* pred_vghshv512di */

        default:
          return -1;
        }

    case 220:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33378; /* pred_vsha2msrvvm8si */

        case E_RVVM4SImode:
          if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33382; /* pred_vsha2msrvvm4si */

        case E_RVVM2SImode:
          if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33386; /* pred_vsha2msrvvm2si */

        case E_RVVM1SImode:
          if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33390; /* pred_vsha2msrvvm1si */

        case E_RVVMF2SImode:
          if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33394; /* pred_vsha2msrvvmf2si */

        case E_RVVM8DImode:
          if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33398; /* pred_vsha2msrvvm8di */

        case E_RVVM4DImode:
          if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33402; /* pred_vsha2msrvvm4di */

        case E_RVVM2DImode:
          if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33406; /* pred_vsha2msrvvm2di */

        case E_RVVM1DImode:
          if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33410; /* pred_vsha2msrvvm1di */

        case E_V1SImode:
          if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33414; /* pred_vsha2msv1si */

        case E_V2SImode:
          if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33418; /* pred_vsha2msv2si */

        case E_V4SImode:
          if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33422; /* pred_vsha2msv4si */

        case E_V8SImode:
          if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33426; /* pred_vsha2msv8si */

        case E_V16SImode:
          if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33430; /* pred_vsha2msv16si */

        case E_V32SImode:
          if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33434; /* pred_vsha2msv32si */

        case E_V64SImode:
          if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33438; /* pred_vsha2msv64si */

        case E_V128SImode:
          if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33442; /* pred_vsha2msv128si */

        case E_V256SImode:
          if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33446; /* pred_vsha2msv256si */

        case E_V512SImode:
          if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33450; /* pred_vsha2msv512si */

        case E_V1024SImode:
          if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33454; /* pred_vsha2msv1024si */

        case E_V1DImode:
          if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33458; /* pred_vsha2msv1di */

        case E_V2DImode:
          if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33462; /* pred_vsha2msv2di */

        case E_V4DImode:
          if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33466; /* pred_vsha2msv4di */

        case E_V8DImode:
          if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33470; /* pred_vsha2msv8di */

        case E_V16DImode:
          if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33474; /* pred_vsha2msv16di */

        case E_V32DImode:
          if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33478; /* pred_vsha2msv32di */

        case E_V64DImode:
          if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33482; /* pred_vsha2msv64di */

        case E_V128DImode:
          if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33486; /* pred_vsha2msv128di */

        case E_V256DImode:
          if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33490; /* pred_vsha2msv256di */

        case E_V512DImode:
          if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33494; /* pred_vsha2msv512di */

        default:
          return -1;
        }

    case 221:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33379; /* pred_vsha2chrvvm8si */

        case E_RVVM4SImode:
          if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33383; /* pred_vsha2chrvvm4si */

        case E_RVVM2SImode:
          if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33387; /* pred_vsha2chrvvm2si */

        case E_RVVM1SImode:
          if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33391; /* pred_vsha2chrvvm1si */

        case E_RVVMF2SImode:
          if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33395; /* pred_vsha2chrvvmf2si */

        case E_RVVM8DImode:
          if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33399; /* pred_vsha2chrvvm8di */

        case E_RVVM4DImode:
          if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33403; /* pred_vsha2chrvvm4di */

        case E_RVVM2DImode:
          if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33407; /* pred_vsha2chrvvm2di */

        case E_RVVM1DImode:
          if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33411; /* pred_vsha2chrvvm1di */

        case E_V1SImode:
          if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33415; /* pred_vsha2chv1si */

        case E_V2SImode:
          if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33419; /* pred_vsha2chv2si */

        case E_V4SImode:
          if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33423; /* pred_vsha2chv4si */

        case E_V8SImode:
          if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33427; /* pred_vsha2chv8si */

        case E_V16SImode:
          if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33431; /* pred_vsha2chv16si */

        case E_V32SImode:
          if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33435; /* pred_vsha2chv32si */

        case E_V64SImode:
          if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33439; /* pred_vsha2chv64si */

        case E_V128SImode:
          if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33443; /* pred_vsha2chv128si */

        case E_V256SImode:
          if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33447; /* pred_vsha2chv256si */

        case E_V512SImode:
          if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33451; /* pred_vsha2chv512si */

        case E_V1024SImode:
          if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33455; /* pred_vsha2chv1024si */

        case E_V1DImode:
          if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33459; /* pred_vsha2chv1di */

        case E_V2DImode:
          if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33463; /* pred_vsha2chv2di */

        case E_V4DImode:
          if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33467; /* pred_vsha2chv4di */

        case E_V8DImode:
          if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33471; /* pred_vsha2chv8di */

        case E_V16DImode:
          if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33475; /* pred_vsha2chv16di */

        case E_V32DImode:
          if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33479; /* pred_vsha2chv32di */

        case E_V64DImode:
          if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33483; /* pred_vsha2chv64di */

        case E_V128DImode:
          if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33487; /* pred_vsha2chv128di */

        case E_V256DImode:
          if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33491; /* pred_vsha2chv256di */

        case E_V512DImode:
          if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33495; /* pred_vsha2chv512di */

        default:
          return -1;
        }

    case 222:
      return recog_406 (x1, insn, pnum_clobbers);

    case 219:
      switch (pattern600 (x2))
        {
        case 0:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33747; /* pred_viaeskf2rvvm8si_nomaskedoff_scalar */

        case 1:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33749; /* pred_viaeskf2rvvm4si_nomaskedoff_scalar */

        case 2:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33751; /* pred_viaeskf2rvvm2si_nomaskedoff_scalar */

        case 3:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33753; /* pred_viaeskf2rvvm1si_nomaskedoff_scalar */

        case 4:
          if (!(
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33755; /* pred_viaeskf2rvvmf2si_nomaskedoff_scalar */

        default:
          return -1;
        }

    case 228:
      switch (pattern600 (x2))
        {
        case 0:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33748; /* pred_vism3crvvm8si_nomaskedoff_scalar */

        case 1:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33750; /* pred_vism3crvvm4si_nomaskedoff_scalar */

        case 2:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33752; /* pred_vism3crvvm2si_nomaskedoff_scalar */

        case 3:
          if (!
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33754; /* pred_vism3crvvm1si_nomaskedoff_scalar */

        case 4:
          if (!(
#line 631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33756; /* pred_vism3crvvmf2si_nomaskedoff_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_422 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4DFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4345; /* *pred_broadcastv4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4DFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4467; /* *pred_broadcastv4df_imm */
}

 int
recog_426 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 4341; /* *pred_broadcastv512sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4463; /* *pred_broadcastv512sf_imm */
}

 int
recog_430 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 4337; /* *pred_broadcastv32sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4459; /* *pred_broadcastv32sf_imm */
}

 int
recog_435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4332; /* *pred_broadcastv1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4454; /* *pred_broadcastv1sf_imm */
}

 int
recog_439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return 4328; /* *pred_broadcastv256hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4450; /* *pred_broadcastv256hf_imm */
}

 int
recog_442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return 4325; /* *pred_broadcastv32hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4447; /* *pred_broadcastv32hf_imm */
}

 int
recog_447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4320; /* *pred_broadcastv1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4442; /* *pred_broadcastv1hf_imm */
}

 int
recog_451 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64DImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 4316; /* *pred_broadcastv64di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64DImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4438; /* *pred_broadcastv64di_imm */
}

 int
recog_456 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2DImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 4311; /* *pred_broadcastv2di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2DImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4433; /* *pred_broadcastv2di_imm */
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128SImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 4306; /* *pred_broadcastv128si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128SImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4428; /* *pred_broadcastv128si_imm */
}

 int
recog_466 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4SImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 4301; /* *pred_broadcastv4si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4SImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 4423; /* *pred_broadcastv4si_imm */
}

 int
recog_471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 4296; /* *pred_broadcastv512hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4418; /* *pred_broadcastv512hi_imm */
}

 int
recog_477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 4290; /* *pred_broadcastv8hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 4412; /* *pred_broadcastv8hi_imm */
}

 int
recog_484 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 4283; /* *pred_broadcastv512qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4405; /* *pred_broadcastv512qi_imm */
}

 int
recog_491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 4276; /* *pred_broadcastv4qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 4398; /* *pred_broadcastv4qi_imm */
}

 int
recog_498 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVMF2SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 4269; /* *pred_broadcastrvvmf2sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 4391; /* *pred_broadcastrvvmf2sf_imm */
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM1HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4262; /* *pred_broadcastrvvm1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4384; /* *pred_broadcastrvvm1hf_imm */
}

 int
recog_512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 20704; /* pred_gatherv512df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20826; /* pred_gatherv512df_scalar */
}

 int
recog_516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 20700; /* pred_gatherv32df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20822; /* pred_gatherv32df_scalar */
}

 int
recog_520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20696; /* pred_gatherv2df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20818; /* pred_gatherv2df_scalar */
}

 int
recog_525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 20691; /* pred_gatherv128sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20813; /* pred_gatherv128sf_scalar */
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20686; /* pred_gatherv4sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20808; /* pred_gatherv4sf_scalar */
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return 20681; /* pred_gatherv512hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20803; /* pred_gatherv512hf_scalar */
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20676; /* pred_gatherv16hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20798; /* pred_gatherv16hf_scalar */
}

 int
recog_545 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 20671; /* pred_gatherv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20793; /* pred_gatherv512di_scalar */
}

 int
recog_550 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 20666; /* pred_gatherv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20788; /* pred_gatherv16di_scalar */
}

 int
recog_555 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 20661; /* pred_gatherv1024si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20783; /* pred_gatherv1024si_scalar */
}

 int
recog_560 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 20656; /* pred_gatherv32si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20778; /* pred_gatherv32si_scalar */
}

 int
recog_565 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 20651; /* pred_gatherv1si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 20773; /* pred_gatherv1si_scalar */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 20646; /* pred_gatherv128hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20768; /* pred_gatherv128hi_scalar */
}

 int
recog_575 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 20641; /* pred_gatherv4hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 20763; /* pred_gatherv4hi_scalar */
}

 int
recog_580 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 20636; /* pred_gatherv1024qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20758; /* pred_gatherv1024qi_scalar */
}

 int
recog_585 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 20631; /* pred_gatherv32qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 20753; /* pred_gatherv32qi_scalar */
}

 int
recog_590 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 20626; /* pred_gatherv1qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 20748; /* pred_gatherv1qi_scalar */
}

 int
recog_595 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20827; /* pred_gatherei16rvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20828; /* pred_gatherei16rvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20829; /* pred_gatherei16rvvm1qi */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20830; /* pred_gatherei16rvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20831; /* pred_gatherei16rvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 402 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20832; /* pred_gatherei16rvvmf8qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20833; /* pred_gatherei16rvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20834; /* pred_gatherei16rvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20835; /* pred_gatherei16rvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20836; /* pred_gatherei16rvvm1hi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20837; /* pred_gatherei16rvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20838; /* pred_gatherei16rvvmf4hi */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM8HFmode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 406 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20839; /* pred_gatherei16rvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM4HFmode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 406 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20840; /* pred_gatherei16rvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM2HFmode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 406 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20841; /* pred_gatherei16rvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM1HFmode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20842; /* pred_gatherei16rvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF2HFmode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20843; /* pred_gatherei16rvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF4HFmode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20844; /* pred_gatherei16rvvmf4hf */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20845; /* pred_gatherei16rvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20846; /* pred_gatherei16rvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20847; /* pred_gatherei16rvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20848; /* pred_gatherei16rvvm1si */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 410 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20849; /* pred_gatherei16rvvmf2si */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM8SFmode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 412 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20850; /* pred_gatherei16rvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM4SFmode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 412 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20851; /* pred_gatherei16rvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM2SFmode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 412 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20852; /* pred_gatherei16rvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20853; /* pred_gatherei16rvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20854; /* pred_gatherei16rvvmf2sf */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM8DImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 415 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20855; /* pred_gatherei16rvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM4DImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 415 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20856; /* pred_gatherei16rvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM2DImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 416 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20857; /* pred_gatherei16rvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM1DImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 416 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20858; /* pred_gatherei16rvvm1di */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM8DFmode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20859; /* pred_gatherei16rvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM4DFmode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20860; /* pred_gatherei16rvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM2DFmode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 419 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20861; /* pred_gatherei16rvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_RVVM1DFmode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 419 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20862; /* pred_gatherei16rvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20863; /* pred_gatherei16v1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20864; /* pred_gatherei16v2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 423 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20865; /* pred_gatherei16v4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 424 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20866; /* pred_gatherei16v8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 425 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20867; /* pred_gatherei16v16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 426 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20868; /* pred_gatherei16v32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20869; /* pred_gatherei16v64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 428 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20870; /* pred_gatherei16v128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20871; /* pred_gatherei16v256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 430 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20872; /* pred_gatherei16v512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 431 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20873; /* pred_gatherei16v1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20874; /* pred_gatherei16v2048qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 433 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20875; /* pred_gatherei16v1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20876; /* pred_gatherei16v2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20877; /* pred_gatherei16v4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 436 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20878; /* pred_gatherei16v8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20879; /* pred_gatherei16v16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 438 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20880; /* pred_gatherei16v32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 439 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20881; /* pred_gatherei16v64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20882; /* pred_gatherei16v128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20883; /* pred_gatherei16v256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 442 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20884; /* pred_gatherei16v512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20885; /* pred_gatherei16v1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 444 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20886; /* pred_gatherei16v2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 445 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20887; /* pred_gatherei16v1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 446 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20888; /* pred_gatherei16v2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20889; /* pred_gatherei16v4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 448 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20890; /* pred_gatherei16v8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 449 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20891; /* pred_gatherei16v16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20892; /* pred_gatherei16v32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 451 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20893; /* pred_gatherei16v64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 452 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20894; /* pred_gatherei16v128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 453 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20895; /* pred_gatherei16v256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 454 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20896; /* pred_gatherei16v512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20897; /* pred_gatherei16v1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1DImode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 456 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20898; /* pred_gatherei16v1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2DImode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 457 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20899; /* pred_gatherei16v2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V4DImode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 458 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20900; /* pred_gatherei16v4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V8DImode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20901; /* pred_gatherei16v8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V16DImode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 460 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20902; /* pred_gatherei16v16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V32DImode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 461 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20903; /* pred_gatherei16v32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V64DImode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 462 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20904; /* pred_gatherei16v64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V128DImode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 463 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20905; /* pred_gatherei16v128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V256DImode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20906; /* pred_gatherei16v256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V512DImode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20907; /* pred_gatherei16v512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1HFmode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20908; /* pred_gatherei16v1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2HFmode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 467 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20909; /* pred_gatherei16v2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V4HFmode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 468 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20910; /* pred_gatherei16v4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V8HFmode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 469 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20911; /* pred_gatherei16v8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern554 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20912; /* pred_gatherei16v16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V32HFmode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20913; /* pred_gatherei16v32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V64HFmode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 472 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20914; /* pred_gatherei16v64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V128HFmode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 473 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20915; /* pred_gatherei16v128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V256HFmode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20916; /* pred_gatherei16v256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V512HFmode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20917; /* pred_gatherei16v512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1024HFmode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20918; /* pred_gatherei16v1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 477 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20919; /* pred_gatherei16v2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1SFmode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20920; /* pred_gatherei16v1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2SFmode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20921; /* pred_gatherei16v2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V4SFmode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20922; /* pred_gatherei16v4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V8SFmode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 481 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20923; /* pred_gatherei16v8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V16SFmode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 482 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20924; /* pred_gatherei16v16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V32SFmode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 483 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20925; /* pred_gatherei16v32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V64SFmode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20926; /* pred_gatherei16v64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V128SFmode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 485 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20927; /* pred_gatherei16v128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V256SFmode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20928; /* pred_gatherei16v256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V512SFmode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20929; /* pred_gatherei16v512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1024SFmode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20930; /* pred_gatherei16v1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V1DFmode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 489 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20931; /* pred_gatherei16v1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V2DFmode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20932; /* pred_gatherei16v2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V4DFmode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20933; /* pred_gatherei16v4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V8DFmode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 492 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20934; /* pred_gatherei16v8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V16DFmode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20935; /* pred_gatherei16v16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V32DFmode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 494 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20936; /* pred_gatherei16v32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V64DFmode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 495 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20937; /* pred_gatherei16v64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V128DFmode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20938; /* pred_gatherei16v128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V256DFmode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 497 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20939; /* pred_gatherei16v256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern688 (x2, 
E_V512DFmode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 498 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20940; /* pred_gatherei16v512df */

    default:
      return -1;
    }
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8QImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13081; /* *pred_mul_plusrvvm8qi_undef */
}

 int
recog_610 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4QImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13082; /* *pred_mul_plusrvvm4qi_undef */
}

 int
recog_611 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2QImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13083; /* *pred_mul_plusrvvm2qi_undef */
}

 int
recog_612 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1QImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13084; /* *pred_mul_plusrvvm1qi_undef */
}

 int
recog_613 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8HImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13085; /* *pred_mul_plusrvvm8hi_undef */
}

 int
recog_614 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4HImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13086; /* *pred_mul_plusrvvm4hi_undef */
}

 int
recog_615 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2HImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13087; /* *pred_mul_plusrvvm2hi_undef */
}

 int
recog_616 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1HImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13088; /* *pred_mul_plusrvvm1hi_undef */
}

 int
recog_617 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8SImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13089; /* *pred_mul_plusrvvm8si_undef */
}

 int
recog_619 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2SImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13091; /* *pred_mul_plusrvvm2si_undef */
}

 int
recog_621 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13093; /* *pred_mul_plusrvvm8di_undef */
}

 int
recog_625 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13097; /* *pred_mul_plusrvvmf2qi_undef */
}

 int
recog_629 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF4HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13101; /* *pred_mul_plusrvvmf4hi_undef */
}

 int
recog_633 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 13105; /* *pred_mul_plusv4qi_undef */
}

 int
recog_637 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13109; /* *pred_mul_plusv64qi_undef */
}

 int
recog_642 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2048QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2048QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2048QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13114; /* *pred_mul_plusv2048qi_undef */
}

 int
recog_647 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 13119; /* *pred_mul_plusv8hi_undef */
}

 int
recog_652 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13124; /* *pred_mul_plusv256hi_undef */
}

 int
recog_657 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13129; /* *pred_mul_plusv2si_undef */
}

 int
recog_662 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13134; /* *pred_mul_plusv64si_undef */
}

 int
recog_668 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13140; /* *pred_mul_plusv2di_undef */
}

 int
recog_674 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13146; /* *pred_mul_plusv128di_undef */
}

 int
recog_680 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_673 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13213; /* *pred_maddv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13281; /* *pred_maccv64di */
}

 int
recog_686 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_667 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13207; /* *pred_maddv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13275; /* *pred_maccv1di */
}

 int
recog_693 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_660 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13200; /* *pred_maddv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13268; /* *pred_maccv16si */
}

 int
recog_700 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_653 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13193; /* *pred_maddv512hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13261; /* *pred_maccv512hi */
}

 int
recog_707 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_646 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13186; /* *pred_maddv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13254; /* *pred_maccv4hi */
}

 int
recog_714 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_639 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13179; /* *pred_maddv256qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13247; /* *pred_maccv256qi */
}

 int
recog_722 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13347; /* *pred_maddv16di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13415; /* *pred_maccv16di_scalar */
}

 int
recog_729 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13340; /* *pred_maddv256si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13408; /* *pred_maccv256si_scalar */
}

 int
recog_736 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13333; /* *pred_maddv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13401; /* *pred_maccv2si_scalar */
}

 int
recog_743 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13326; /* *pred_maddv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13394; /* *pred_maccv64hi_scalar */
}

 int
recog_750 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      switch (pattern566 (x2))
        {
        case 0:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9302; /* pred_dual_widen_addurvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9308; /* pred_dual_widen_addurvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9314; /* pred_dual_widen_addurvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9320; /* pred_dual_widen_addurvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9326; /* pred_dual_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9332; /* pred_dual_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9338; /* pred_dual_widen_addurvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9344; /* pred_dual_widen_addurvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9350; /* pred_dual_widen_addurvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9356; /* pred_dual_widen_addurvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9362; /* pred_dual_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9368; /* pred_dual_widen_addurvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9374; /* pred_dual_widen_addurvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9380; /* pred_dual_widen_addurvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9386; /* pred_dual_widen_addurvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9392; /* pred_dual_widen_adduv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9398; /* pred_dual_widen_adduv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9404; /* pred_dual_widen_adduv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9410; /* pred_dual_widen_adduv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9416; /* pred_dual_widen_adduv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9422; /* pred_dual_widen_adduv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9428; /* pred_dual_widen_adduv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9434; /* pred_dual_widen_adduv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9440; /* pred_dual_widen_adduv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9446; /* pred_dual_widen_adduv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9452; /* pred_dual_widen_adduv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9458; /* pred_dual_widen_adduv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9464; /* pred_dual_widen_adduv1si */

        case 28:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9470; /* pred_dual_widen_adduv2si */

        case 29:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9476; /* pred_dual_widen_adduv4si */

        case 30:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9482; /* pred_dual_widen_adduv8si */

        case 31:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9488; /* pred_dual_widen_adduv16si */

        case 32:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9494; /* pred_dual_widen_adduv32si */

        case 33:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9500; /* pred_dual_widen_adduv64si */

        case 34:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9506; /* pred_dual_widen_adduv128si */

        case 35:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9512; /* pred_dual_widen_adduv256si */

        case 36:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9518; /* pred_dual_widen_adduv512si */

        case 37:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9524; /* pred_dual_widen_adduv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9530; /* pred_dual_widen_adduv1di */

        case 39:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9536; /* pred_dual_widen_adduv2di */

        case 40:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9542; /* pred_dual_widen_adduv4di */

        case 41:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9548; /* pred_dual_widen_adduv8di */

        case 42:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9554; /* pred_dual_widen_adduv16di */

        case 43:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9560; /* pred_dual_widen_adduv32di */

        case 44:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9566; /* pred_dual_widen_adduv64di */

        case 45:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9572; /* pred_dual_widen_adduv128di */

        case 46:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9578; /* pred_dual_widen_adduv256di */

        case 47:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9584; /* pred_dual_widen_adduv512di */

        case 48:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9590; /* pred_dual_widen_addurvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9596; /* pred_dual_widen_addurvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9602; /* pred_dual_widen_addurvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9608; /* pred_dual_widen_addurvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9614; /* pred_dual_widen_addurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9620; /* pred_dual_widen_addurvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9626; /* pred_dual_widen_addurvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9632; /* pred_dual_widen_addurvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9638; /* pred_dual_widen_addurvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9644; /* pred_dual_widen_addurvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9650; /* pred_dual_widen_addurvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9656; /* pred_dual_widen_addurvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9662; /* pred_dual_widen_addurvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9668; /* pred_dual_widen_addurvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9674; /* pred_dual_widen_addurvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9680; /* pred_dual_widen_adduv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9686; /* pred_dual_widen_adduv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9692; /* pred_dual_widen_adduv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9698; /* pred_dual_widen_adduv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9704; /* pred_dual_widen_adduv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9710; /* pred_dual_widen_adduv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9716; /* pred_dual_widen_adduv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9722; /* pred_dual_widen_adduv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9728; /* pred_dual_widen_adduv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9734; /* pred_dual_widen_adduv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9740; /* pred_dual_widen_adduv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9746; /* pred_dual_widen_adduv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9752; /* pred_dual_widen_adduv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9758; /* pred_dual_widen_adduv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9764; /* pred_dual_widen_adduv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9770; /* pred_dual_widen_adduv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9776; /* pred_dual_widen_adduv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9782; /* pred_dual_widen_adduv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9788; /* pred_dual_widen_adduv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9794; /* pred_dual_widen_adduv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9800; /* pred_dual_widen_adduv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9806; /* pred_dual_widen_adduv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9812; /* pred_dual_widen_adduv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9818; /* pred_dual_widen_adduv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9824; /* pred_dual_widen_adduv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9830; /* pred_dual_widen_adduv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9836; /* pred_dual_widen_adduv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9842; /* pred_dual_widen_adduv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9848; /* pred_dual_widen_adduv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9854; /* pred_dual_widen_adduv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9860; /* pred_dual_widen_adduv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9866; /* pred_dual_widen_adduv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9872; /* pred_dual_widen_adduv512di_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern567 (x2))
        {
        case 0:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9974; /* pred_single_widen_addurvvm8hi */

        case 1:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9976; /* pred_single_widen_addurvvm4hi */

        case 2:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9978; /* pred_single_widen_addurvvm2hi */

        case 3:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9980; /* pred_single_widen_addurvvm1hi */

        case 4:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9982; /* pred_single_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9984; /* pred_single_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9986; /* pred_single_widen_addurvvm8si */

        case 7:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9988; /* pred_single_widen_addurvvm4si */

        case 8:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9990; /* pred_single_widen_addurvvm2si */

        case 9:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9992; /* pred_single_widen_addurvvm1si */

        case 10:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9994; /* pred_single_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9996; /* pred_single_widen_addurvvm8di */

        case 12:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9998; /* pred_single_widen_addurvvm4di */

        case 13:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10000; /* pred_single_widen_addurvvm2di */

        case 14:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10002; /* pred_single_widen_addurvvm1di */

        case 15:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10004; /* pred_single_widen_adduv1hi */

        case 16:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10006; /* pred_single_widen_adduv2hi */

        case 17:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10008; /* pred_single_widen_adduv4hi */

        case 18:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10010; /* pred_single_widen_adduv8hi */

        case 19:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10012; /* pred_single_widen_adduv16hi */

        case 20:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10014; /* pred_single_widen_adduv32hi */

        case 21:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10016; /* pred_single_widen_adduv64hi */

        case 22:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10018; /* pred_single_widen_adduv128hi */

        case 23:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10020; /* pred_single_widen_adduv256hi */

        case 24:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10022; /* pred_single_widen_adduv512hi */

        case 25:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10024; /* pred_single_widen_adduv1024hi */

        case 26:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10026; /* pred_single_widen_adduv2048hi */

        case 27:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10028; /* pred_single_widen_adduv1si */

        case 28:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10030; /* pred_single_widen_adduv2si */

        case 29:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10032; /* pred_single_widen_adduv4si */

        case 30:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10034; /* pred_single_widen_adduv8si */

        case 31:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10036; /* pred_single_widen_adduv16si */

        case 32:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10038; /* pred_single_widen_adduv32si */

        case 33:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10040; /* pred_single_widen_adduv64si */

        case 34:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10042; /* pred_single_widen_adduv128si */

        case 35:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10044; /* pred_single_widen_adduv256si */

        case 36:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10046; /* pred_single_widen_adduv512si */

        case 37:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10048; /* pred_single_widen_adduv1024si */

        case 38:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10050; /* pred_single_widen_adduv1di */

        case 39:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10052; /* pred_single_widen_adduv2di */

        case 40:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10054; /* pred_single_widen_adduv4di */

        case 41:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10056; /* pred_single_widen_adduv8di */

        case 42:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10058; /* pred_single_widen_adduv16di */

        case 43:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10060; /* pred_single_widen_adduv32di */

        case 44:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10062; /* pred_single_widen_adduv64di */

        case 45:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10064; /* pred_single_widen_adduv128di */

        case 46:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10066; /* pred_single_widen_adduv256di */

        case 47:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10068; /* pred_single_widen_adduv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern569 (x2))
        {
        case 0:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10550; /* pred_zero_extendrvvm8hi */

        case 1:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10552; /* pred_zero_extendrvvm4hi */

        case 2:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10554; /* pred_zero_extendrvvm2hi */

        case 3:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10556; /* pred_zero_extendrvvm1hi */

        case 4:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10558; /* pred_zero_extendrvvmf2hi */

        case 5:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10560; /* pred_zero_extendrvvmf4hi */

        case 6:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10562; /* pred_zero_extendrvvm8si */

        case 7:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10564; /* pred_zero_extendrvvm4si */

        case 8:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10566; /* pred_zero_extendrvvm2si */

        case 9:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10568; /* pred_zero_extendrvvm1si */

        case 10:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10570; /* pred_zero_extendrvvmf2si */

        case 11:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10572; /* pred_zero_extendrvvm8di */

        case 12:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10574; /* pred_zero_extendrvvm4di */

        case 13:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10576; /* pred_zero_extendrvvm2di */

        case 14:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10578; /* pred_zero_extendrvvm1di */

        case 15:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10580; /* pred_zero_extendv1hi */

        case 16:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10582; /* pred_zero_extendv2hi */

        case 17:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10584; /* pred_zero_extendv4hi */

        case 18:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10586; /* pred_zero_extendv8hi */

        case 19:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10588; /* pred_zero_extendv16hi */

        case 20:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10590; /* pred_zero_extendv32hi */

        case 21:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10592; /* pred_zero_extendv64hi */

        case 22:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10594; /* pred_zero_extendv128hi */

        case 23:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10596; /* pred_zero_extendv256hi */

        case 24:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10598; /* pred_zero_extendv512hi */

        case 25:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10600; /* pred_zero_extendv1024hi */

        case 26:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10602; /* pred_zero_extendv2048hi */

        case 27:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10604; /* pred_zero_extendv1si */

        case 28:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10606; /* pred_zero_extendv2si */

        case 29:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10608; /* pred_zero_extendv4si */

        case 30:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10610; /* pred_zero_extendv8si */

        case 31:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10612; /* pred_zero_extendv16si */

        case 32:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10614; /* pred_zero_extendv32si */

        case 33:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10616; /* pred_zero_extendv64si */

        case 34:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10618; /* pred_zero_extendv128si */

        case 35:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10620; /* pred_zero_extendv256si */

        case 36:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10622; /* pred_zero_extendv512si */

        case 37:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10624; /* pred_zero_extendv1024si */

        case 38:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10626; /* pred_zero_extendv1di */

        case 39:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10628; /* pred_zero_extendv2di */

        case 40:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10630; /* pred_zero_extendv4di */

        case 41:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10632; /* pred_zero_extendv8di */

        case 42:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10634; /* pred_zero_extendv16di */

        case 43:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10636; /* pred_zero_extendv32di */

        case 44:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10638; /* pred_zero_extendv64di */

        case 45:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10640; /* pred_zero_extendv128di */

        case 46:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10642; /* pred_zero_extendv256di */

        case 47:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10644; /* pred_zero_extendv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_795 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V32QImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 13476; /* *pred_minus_mulv32qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 13544; /* *pred_nmsubv32qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 13612; /* *pred_nmsacv32qi */
}

 int
recog_803 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_RVVMF2HImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return 13468; /* *pred_minus_mulrvvmf2hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF2HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF2HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return 13536; /* *pred_nmsubrvvmf2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13604; /* *pred_nmsacrvvmf2hi */
}

 int
recog_812 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13712; /* *pred_nmsubv2di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13780; /* *pred_nmsacv2di_scalar */
}

 int
recog_820 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13704; /* *pred_nmsubv16si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13772; /* *pred_nmsacv16si_scalar */
}

 int
recog_828 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13696; /* *pred_nmsubv256hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13764; /* *pred_nmsacv256hi_scalar */
}

 int
recog_836 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 0);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern691 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5498; /* pred_subrvvm8qi */

    case E_RVVM4QImode:
      if (pattern691 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5515; /* pred_subrvvm4qi */

    case E_RVVM2QImode:
      if (pattern691 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5532; /* pred_subrvvm2qi */

    case E_RVVM1QImode:
      if (pattern691 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5549; /* pred_subrvvm1qi */

    case E_RVVM8HImode:
      if (pattern691 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5566; /* pred_subrvvm8hi */

    case E_RVVM4HImode:
      if (pattern691 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5583; /* pred_subrvvm4hi */

    case E_RVVM2HImode:
      if (pattern691 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5600; /* pred_subrvvm2hi */

    case E_RVVM1HImode:
      if (pattern691 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5617; /* pred_subrvvm1hi */

    case E_RVVM8SImode:
      if (pattern691 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5634; /* pred_subrvvm8si */

    case E_RVVM4SImode:
      if (pattern691 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5651; /* pred_subrvvm4si */

    case E_RVVM2SImode:
      if (pattern691 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5668; /* pred_subrvvm2si */

    case E_RVVM1SImode:
      if (pattern691 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5685; /* pred_subrvvm1si */

    case E_RVVM8DImode:
      if (pattern691 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5702; /* pred_subrvvm8di */

    case E_RVVM4DImode:
      if (pattern691 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5719; /* pred_subrvvm4di */

    case E_RVVM2DImode:
      if (pattern691 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5736; /* pred_subrvvm2di */

    case E_RVVM1DImode:
      if (pattern691 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5753; /* pred_subrvvm1di */

    case E_RVVMF2QImode:
      if (pattern691 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5770; /* pred_subrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern691 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5787; /* pred_subrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern691 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5804; /* pred_subrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern691 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5821; /* pred_subrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern691 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5838; /* pred_subrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern691 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5855; /* pred_subrvvmf2si */

    case E_V1QImode:
      if (pattern691 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5872; /* pred_subv1qi */

    case E_V2QImode:
      if (pattern691 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5889; /* pred_subv2qi */

    case E_V4QImode:
      if (pattern691 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5906; /* pred_subv4qi */

    case E_V8QImode:
      if (pattern691 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5923; /* pred_subv8qi */

    case E_V16QImode:
      if (pattern691 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5940; /* pred_subv16qi */

    case E_V32QImode:
      if (pattern691 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5957; /* pred_subv32qi */

    case E_V64QImode:
      if (pattern691 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5974; /* pred_subv64qi */

    case E_V128QImode:
      if (pattern691 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5991; /* pred_subv128qi */

    case E_V256QImode:
      if (pattern691 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6008; /* pred_subv256qi */

    case E_V512QImode:
      if (pattern691 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6025; /* pred_subv512qi */

    case E_V1024QImode:
      if (pattern691 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6042; /* pred_subv1024qi */

    case E_V2048QImode:
      if (pattern691 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6059; /* pred_subv2048qi */

    case E_V4096QImode:
      if (pattern691 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6076; /* pred_subv4096qi */

    case E_V1HImode:
      if (pattern691 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6093; /* pred_subv1hi */

    case E_V2HImode:
      if (pattern691 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6110; /* pred_subv2hi */

    case E_V4HImode:
      if (pattern691 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6127; /* pred_subv4hi */

    case E_V8HImode:
      if (pattern691 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6144; /* pred_subv8hi */

    case E_V16HImode:
      if (pattern691 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6161; /* pred_subv16hi */

    case E_V32HImode:
      if (pattern691 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6178; /* pred_subv32hi */

    case E_V64HImode:
      if (pattern691 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6195; /* pred_subv64hi */

    case E_V128HImode:
      if (pattern691 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6212; /* pred_subv128hi */

    case E_V256HImode:
      if (pattern691 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6229; /* pred_subv256hi */

    case E_V512HImode:
      if (pattern691 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6246; /* pred_subv512hi */

    case E_V1024HImode:
      if (pattern691 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6263; /* pred_subv1024hi */

    case E_V2048HImode:
      if (pattern691 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6280; /* pred_subv2048hi */

    case E_V1SImode:
      if (pattern691 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6297; /* pred_subv1si */

    case E_V2SImode:
      if (pattern691 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6314; /* pred_subv2si */

    case E_V4SImode:
      if (pattern691 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6331; /* pred_subv4si */

    case E_V8SImode:
      if (pattern691 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6348; /* pred_subv8si */

    case E_V16SImode:
      if (pattern691 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6365; /* pred_subv16si */

    case E_V32SImode:
      if (pattern691 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6382; /* pred_subv32si */

    case E_V64SImode:
      if (pattern691 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6399; /* pred_subv64si */

    case E_V128SImode:
      if (pattern691 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6416; /* pred_subv128si */

    case E_V256SImode:
      if (pattern691 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6433; /* pred_subv256si */

    case E_V512SImode:
      if (pattern691 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6450; /* pred_subv512si */

    case E_V1024SImode:
      if (pattern691 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6467; /* pred_subv1024si */

    case E_V1DImode:
      if (pattern691 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6484; /* pred_subv1di */

    case E_V2DImode:
      if (pattern691 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6501; /* pred_subv2di */

    case E_V4DImode:
      if (pattern691 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6518; /* pred_subv4di */

    case E_V8DImode:
      if (pattern691 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6535; /* pred_subv8di */

    case E_V16DImode:
      if (pattern691 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6552; /* pred_subv16di */

    case E_V32DImode:
      if (pattern691 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6569; /* pred_subv32di */

    case E_V64DImode:
      if (pattern691 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6586; /* pred_subv64di */

    case E_V128DImode:
      if (pattern691 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6603; /* pred_subv128di */

    case E_V256DImode:
      if (pattern691 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6620; /* pred_subv256di */

    case E_V512DImode:
      if (pattern691 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6637; /* pred_subv512di */

    default:
      return -1;
    }
}

 int
recog_841 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern692 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32589; /* pred_vandnrvvm8qi */

        case E_RVVM4QImode:
          if (pattern692 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32590; /* pred_vandnrvvm4qi */

        case E_RVVM2QImode:
          if (pattern692 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32591; /* pred_vandnrvvm2qi */

        case E_RVVM1QImode:
          if (pattern692 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32592; /* pred_vandnrvvm1qi */

        case E_RVVM8HImode:
          if (pattern692 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32593; /* pred_vandnrvvm8hi */

        case E_RVVM4HImode:
          if (pattern692 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32594; /* pred_vandnrvvm4hi */

        case E_RVVM2HImode:
          if (pattern692 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32595; /* pred_vandnrvvm2hi */

        case E_RVVM1HImode:
          if (pattern692 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32596; /* pred_vandnrvvm1hi */

        case E_RVVM8SImode:
          if (pattern692 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32597; /* pred_vandnrvvm8si */

        case E_RVVM4SImode:
          if (pattern692 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32598; /* pred_vandnrvvm4si */

        case E_RVVM2SImode:
          if (pattern692 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32599; /* pred_vandnrvvm2si */

        case E_RVVM1SImode:
          if (pattern692 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32600; /* pred_vandnrvvm1si */

        case E_RVVM8DImode:
          if (pattern692 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32601; /* pred_vandnrvvm8di */

        case E_RVVM4DImode:
          if (pattern692 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32602; /* pred_vandnrvvm4di */

        case E_RVVM2DImode:
          if (pattern692 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32603; /* pred_vandnrvvm2di */

        case E_RVVM1DImode:
          if (pattern692 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32604; /* pred_vandnrvvm1di */

        case E_RVVMF2QImode:
          if (pattern692 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32605; /* pred_vandnrvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern692 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32606; /* pred_vandnrvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern692 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32607; /* pred_vandnrvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern692 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32608; /* pred_vandnrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern692 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32609; /* pred_vandnrvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern692 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32610; /* pred_vandnrvvmf2si */

        case E_V1QImode:
          if (pattern692 (x2, 
E_V1QImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 32611; /* pred_vandnv1qi */

        case E_V2QImode:
          if (pattern692 (x2, 
E_V2QImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 32612; /* pred_vandnv2qi */

        case E_V4QImode:
          if (pattern692 (x2, 
E_V4QImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 32613; /* pred_vandnv4qi */

        case E_V8QImode:
          if (pattern692 (x2, 
E_V8QImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 32614; /* pred_vandnv8qi */

        case E_V16QImode:
          if (pattern692 (x2, 
E_V16QImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 32615; /* pred_vandnv16qi */

        case E_V32QImode:
          if (pattern692 (x2, 
E_V32QImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 32616; /* pred_vandnv32qi */

        case E_V64QImode:
          if (pattern692 (x2, 
E_V64QImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32617; /* pred_vandnv64qi */

        case E_V128QImode:
          if (pattern692 (x2, 
E_V128QImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32618; /* pred_vandnv128qi */

        case E_V256QImode:
          if (pattern692 (x2, 
E_V256QImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32619; /* pred_vandnv256qi */

        case E_V512QImode:
          if (pattern692 (x2, 
E_V512QImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32620; /* pred_vandnv512qi */

        case E_V1024QImode:
          if (pattern692 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32621; /* pred_vandnv1024qi */

        case E_V2048QImode:
          if (pattern692 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32622; /* pred_vandnv2048qi */

        case E_V4096QImode:
          if (pattern692 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32623; /* pred_vandnv4096qi */

        case E_V1HImode:
          if (pattern692 (x2, 
E_V1HImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 32624; /* pred_vandnv1hi */

        case E_V2HImode:
          if (pattern692 (x2, 
E_V2HImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 32625; /* pred_vandnv2hi */

        case E_V4HImode:
          if (pattern692 (x2, 
E_V4HImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 32626; /* pred_vandnv4hi */

        case E_V8HImode:
          if (pattern692 (x2, 
E_V8HImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 32627; /* pred_vandnv8hi */

        case E_V16HImode:
          if (pattern692 (x2, 
E_V16HImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 32628; /* pred_vandnv16hi */

        case E_V32HImode:
          if (pattern692 (x2, 
E_V32HImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32629; /* pred_vandnv32hi */

        case E_V64HImode:
          if (pattern692 (x2, 
E_V64HImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32630; /* pred_vandnv64hi */

        case E_V128HImode:
          if (pattern692 (x2, 
E_V128HImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32631; /* pred_vandnv128hi */

        case E_V256HImode:
          if (pattern692 (x2, 
E_V256HImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32632; /* pred_vandnv256hi */

        case E_V512HImode:
          if (pattern692 (x2, 
E_V512HImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32633; /* pred_vandnv512hi */

        case E_V1024HImode:
          if (pattern692 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32634; /* pred_vandnv1024hi */

        case E_V2048HImode:
          if (pattern692 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32635; /* pred_vandnv2048hi */

        case E_V1SImode:
          if (pattern692 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 32636; /* pred_vandnv1si */

        case E_V2SImode:
          if (pattern692 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 32637; /* pred_vandnv2si */

        case E_V4SImode:
          if (pattern692 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 32638; /* pred_vandnv4si */

        case E_V8SImode:
          if (pattern692 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 32639; /* pred_vandnv8si */

        case E_V16SImode:
          if (pattern692 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32640; /* pred_vandnv16si */

        case E_V32SImode:
          if (pattern692 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32641; /* pred_vandnv32si */

        case E_V64SImode:
          if (pattern692 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32642; /* pred_vandnv64si */

        case E_V128SImode:
          if (pattern692 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32643; /* pred_vandnv128si */

        case E_V256SImode:
          if (pattern692 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32644; /* pred_vandnv256si */

        case E_V512SImode:
          if (pattern692 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32645; /* pred_vandnv512si */

        case E_V1024SImode:
          if (pattern692 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32646; /* pred_vandnv1024si */

        case E_V1DImode:
          if (pattern692 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32647; /* pred_vandnv1di */

        case E_V2DImode:
          if (pattern692 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32648; /* pred_vandnv2di */

        case E_V4DImode:
          if (pattern692 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32649; /* pred_vandnv4di */

        case E_V8DImode:
          if (pattern692 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32650; /* pred_vandnv8di */

        case E_V16DImode:
          if (pattern692 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32651; /* pred_vandnv16di */

        case E_V32DImode:
          if (pattern692 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32652; /* pred_vandnv32di */

        case E_V64DImode:
          if (pattern692 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32653; /* pred_vandnv64di */

        case E_V128DImode:
          if (pattern692 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32654; /* pred_vandnv128di */

        case E_V256DImode:
          if (pattern692 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32655; /* pred_vandnv256di */

        case E_V512DImode:
          if (pattern692 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32656; /* pred_vandnv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_840 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_887 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern494 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM8QImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5504; /* pred_lshrrvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6655; /* pred_lshrrvvm8qi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5521; /* pred_lshrrvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6658; /* pred_lshrrvvm4qi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5538; /* pred_lshrrvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6661; /* pred_lshrrvvm2qi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5555; /* pred_lshrrvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6664; /* pred_lshrrvvm1qi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVM8HImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5572; /* pred_lshrrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6667; /* pred_lshrrvvm8hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5589; /* pred_lshrrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6670; /* pred_lshrrvvm4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5606; /* pred_lshrrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6673; /* pred_lshrrvvm2hi_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5623; /* pred_lshrrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6676; /* pred_lshrrvvm1hi_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM8SImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5640; /* pred_lshrrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6679; /* pred_lshrrvvm8si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5657; /* pred_lshrrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6682; /* pred_lshrrvvm4si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5674; /* pred_lshrrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6685; /* pred_lshrrvvm2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && 
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5691; /* pred_lshrrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6688; /* pred_lshrrvvm1si_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM8DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5708; /* pred_lshrrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6691; /* pred_lshrrvvm8di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM4DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5725; /* pred_lshrrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6694; /* pred_lshrrvvm4di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVM2DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5742; /* pred_lshrrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6697; /* pred_lshrrvvm2di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_RVVM1DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5759; /* pred_lshrrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6700; /* pred_lshrrvvm1di_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 5776; /* pred_lshrrvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 6703; /* pred_lshrrvvmf2qi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 5793; /* pred_lshrrvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 6706; /* pred_lshrrvvmf4qi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 5810; /* pred_lshrrvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 6709; /* pred_lshrrvvmf8qi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 5827; /* pred_lshrrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 6712; /* pred_lshrrvvmf2hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 5844; /* pred_lshrrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 6715; /* pred_lshrrvvmf4hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 5861; /* pred_lshrrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 6718; /* pred_lshrrvvmf2si_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 5878; /* pred_lshrv1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 6721; /* pred_lshrv1qi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 5895; /* pred_lshrv2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 6724; /* pred_lshrv2qi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 5912; /* pred_lshrv4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 6727; /* pred_lshrv4qi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 5929; /* pred_lshrv8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 6730; /* pred_lshrv8qi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 5946; /* pred_lshrv16qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 6733; /* pred_lshrv16qi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 5963; /* pred_lshrv32qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 6736; /* pred_lshrv32qi_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 5980; /* pred_lshrv64qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6739; /* pred_lshrv64qi_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 5997; /* pred_lshrv128qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6742; /* pred_lshrv128qi_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 6014; /* pred_lshrv256qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6745; /* pred_lshrv256qi_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 6031; /* pred_lshrv512qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6748; /* pred_lshrv512qi_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 6048; /* pred_lshrv1024qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6751; /* pred_lshrv1024qi_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 6065; /* pred_lshrv2048qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6754; /* pred_lshrv2048qi_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V4096QImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 6082; /* pred_lshrv4096qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6757; /* pred_lshrv4096qi_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 6099; /* pred_lshrv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6760; /* pred_lshrv1hi_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 6116; /* pred_lshrv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6763; /* pred_lshrv2hi_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 6133; /* pred_lshrv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6766; /* pred_lshrv4hi_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 6150; /* pred_lshrv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6769; /* pred_lshrv8hi_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 6167; /* pred_lshrv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6772; /* pred_lshrv16hi_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 6184; /* pred_lshrv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6775; /* pred_lshrv32hi_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 6201; /* pred_lshrv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6778; /* pred_lshrv64hi_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 6218; /* pred_lshrv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6781; /* pred_lshrv128hi_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 6235; /* pred_lshrv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6784; /* pred_lshrv256hi_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 6252; /* pred_lshrv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6787; /* pred_lshrv512hi_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 6269; /* pred_lshrv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6790; /* pred_lshrv1024hi_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V2048HImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 6286; /* pred_lshrv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6793; /* pred_lshrv2048hi_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 6303; /* pred_lshrv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6796; /* pred_lshrv1si_scalar */

    case 48:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 6320; /* pred_lshrv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6799; /* pred_lshrv2si_scalar */

    case 49:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 6337; /* pred_lshrv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6802; /* pred_lshrv4si_scalar */

    case 50:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 6354; /* pred_lshrv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6805; /* pred_lshrv8si_scalar */

    case 51:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 6371; /* pred_lshrv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6808; /* pred_lshrv16si_scalar */

    case 52:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 6388; /* pred_lshrv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6811; /* pred_lshrv32si_scalar */

    case 53:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 6405; /* pred_lshrv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6814; /* pred_lshrv64si_scalar */

    case 54:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 6422; /* pred_lshrv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6817; /* pred_lshrv128si_scalar */

    case 55:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 6439; /* pred_lshrv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6820; /* pred_lshrv256si_scalar */

    case 56:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 6456; /* pred_lshrv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6823; /* pred_lshrv512si_scalar */

    case 57:
      if (vector_shift_operand (operands[4], E_V1024SImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 6473; /* pred_lshrv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6826; /* pred_lshrv1024si_scalar */

    case 58:
      if (vector_shift_operand (operands[4], E_V1DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 6490; /* pred_lshrv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6829; /* pred_lshrv1di_scalar */

    case 59:
      if (vector_shift_operand (operands[4], E_V2DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 6507; /* pred_lshrv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6832; /* pred_lshrv2di_scalar */

    case 60:
      if (vector_shift_operand (operands[4], E_V4DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 6524; /* pred_lshrv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6835; /* pred_lshrv4di_scalar */

    case 61:
      if (vector_shift_operand (operands[4], E_V8DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 6541; /* pred_lshrv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6838; /* pred_lshrv8di_scalar */

    case 62:
      if (vector_shift_operand (operands[4], E_V16DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 6558; /* pred_lshrv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6841; /* pred_lshrv16di_scalar */

    case 63:
      if (vector_shift_operand (operands[4], E_V32DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 6575; /* pred_lshrv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6844; /* pred_lshrv32di_scalar */

    case 64:
      if (vector_shift_operand (operands[4], E_V64DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 6592; /* pred_lshrv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6847; /* pred_lshrv64di_scalar */

    case 65:
      if (vector_shift_operand (operands[4], E_V128DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 6609; /* pred_lshrv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6850; /* pred_lshrv128di_scalar */

    case 66:
      if (vector_shift_operand (operands[4], E_V256DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 6626; /* pred_lshrv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6853; /* pred_lshrv256di_scalar */

    case 67:
      if (vector_shift_operand (operands[4], E_V512DImode)
          && (
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 6643; /* pred_lshrv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6856; /* pred_lshrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_894 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 3:
      return recog_606 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 99:
          return recog_600 (x1, insn, pnum_clobbers);

        case 100:
          return recog_599 (x1, insn, pnum_clobbers);

        case 101:
          return recog_598 (x1, insn, pnum_clobbers);

        case 140:
          switch (pattern561 (x2))
            {
            case 0:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14786; /* pred_fmaxrvvm8hf */

            case 1:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14788; /* pred_fmaxrvvm4hf */

            case 2:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14790; /* pred_fmaxrvvm2hf */

            case 3:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14792; /* pred_fmaxrvvm1hf */

            case 4:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14794; /* pred_fmaxrvvmf2hf */

            case 5:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14796; /* pred_fmaxrvvmf4hf */

            case 6:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14798; /* pred_fmaxrvvm8sf */

            case 7:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14800; /* pred_fmaxrvvm4sf */

            case 8:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14802; /* pred_fmaxrvvm2sf */

            case 9:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14804; /* pred_fmaxrvvm1sf */

            case 10:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14806; /* pred_fmaxrvvmf2sf */

            case 11:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14808; /* pred_fmaxrvvm8df */

            case 12:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14810; /* pred_fmaxrvvm4df */

            case 13:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14812; /* pred_fmaxrvvm2df */

            case 14:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14814; /* pred_fmaxrvvm1df */

            case 15:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14816; /* pred_fmaxv1hf */

            case 16:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14818; /* pred_fmaxv2hf */

            case 17:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14820; /* pred_fmaxv4hf */

            case 18:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14822; /* pred_fmaxv8hf */

            case 19:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14824; /* pred_fmaxv16hf */

            case 20:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14826; /* pred_fmaxv32hf */

            case 21:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14828; /* pred_fmaxv64hf */

            case 22:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14830; /* pred_fmaxv128hf */

            case 23:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14832; /* pred_fmaxv256hf */

            case 24:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14834; /* pred_fmaxv512hf */

            case 25:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14836; /* pred_fmaxv1024hf */

            case 26:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14838; /* pred_fmaxv2048hf */

            case 27:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14840; /* pred_fmaxv1sf */

            case 28:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14842; /* pred_fmaxv2sf */

            case 29:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14844; /* pred_fmaxv4sf */

            case 30:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14846; /* pred_fmaxv8sf */

            case 31:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14848; /* pred_fmaxv16sf */

            case 32:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14850; /* pred_fmaxv32sf */

            case 33:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14852; /* pred_fmaxv64sf */

            case 34:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14854; /* pred_fmaxv128sf */

            case 35:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14856; /* pred_fmaxv256sf */

            case 36:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14858; /* pred_fmaxv512sf */

            case 37:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14860; /* pred_fmaxv1024sf */

            case 38:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14862; /* pred_fmaxv1df */

            case 39:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14864; /* pred_fmaxv2df */

            case 40:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14866; /* pred_fmaxv4df */

            case 41:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14868; /* pred_fmaxv8df */

            case 42:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14870; /* pred_fmaxv16df */

            case 43:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14872; /* pred_fmaxv32df */

            case 44:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14874; /* pred_fmaxv64df */

            case 45:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14876; /* pred_fmaxv128df */

            case 46:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14878; /* pred_fmaxv256df */

            case 47:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14880; /* pred_fmaxv512df */

            case 48:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14942; /* pred_fmaxrvvm8hf_scalar */

            case 49:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14944; /* pred_fmaxrvvm4hf_scalar */

            case 50:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14946; /* pred_fmaxrvvm2hf_scalar */

            case 51:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14948; /* pred_fmaxrvvm1hf_scalar */

            case 52:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14950; /* pred_fmaxrvvmf2hf_scalar */

            case 53:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14952; /* pred_fmaxrvvmf4hf_scalar */

            case 54:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14954; /* pred_fmaxrvvm8sf_scalar */

            case 55:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14956; /* pred_fmaxrvvm4sf_scalar */

            case 56:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14958; /* pred_fmaxrvvm2sf_scalar */

            case 57:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14960; /* pred_fmaxrvvm1sf_scalar */

            case 58:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14962; /* pred_fmaxrvvmf2sf_scalar */

            case 59:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14964; /* pred_fmaxrvvm8df_scalar */

            case 60:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14966; /* pred_fmaxrvvm4df_scalar */

            case 61:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14968; /* pred_fmaxrvvm2df_scalar */

            case 62:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14970; /* pred_fmaxrvvm1df_scalar */

            default:
              return -1;
            }

        case 141:
          switch (pattern561 (x2))
            {
            case 0:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14787; /* pred_fminrvvm8hf */

            case 1:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14789; /* pred_fminrvvm4hf */

            case 2:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14791; /* pred_fminrvvm2hf */

            case 3:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14793; /* pred_fminrvvm1hf */

            case 4:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14795; /* pred_fminrvvmf2hf */

            case 5:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14797; /* pred_fminrvvmf4hf */

            case 6:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14799; /* pred_fminrvvm8sf */

            case 7:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14801; /* pred_fminrvvm4sf */

            case 8:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14803; /* pred_fminrvvm2sf */

            case 9:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14805; /* pred_fminrvvm1sf */

            case 10:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14807; /* pred_fminrvvmf2sf */

            case 11:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14809; /* pred_fminrvvm8df */

            case 12:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14811; /* pred_fminrvvm4df */

            case 13:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14813; /* pred_fminrvvm2df */

            case 14:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14815; /* pred_fminrvvm1df */

            case 15:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14817; /* pred_fminv1hf */

            case 16:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14819; /* pred_fminv2hf */

            case 17:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14821; /* pred_fminv4hf */

            case 18:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14823; /* pred_fminv8hf */

            case 19:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14825; /* pred_fminv16hf */

            case 20:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14827; /* pred_fminv32hf */

            case 21:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14829; /* pred_fminv64hf */

            case 22:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14831; /* pred_fminv128hf */

            case 23:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14833; /* pred_fminv256hf */

            case 24:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14835; /* pred_fminv512hf */

            case 25:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14837; /* pred_fminv1024hf */

            case 26:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14839; /* pred_fminv2048hf */

            case 27:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14841; /* pred_fminv1sf */

            case 28:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14843; /* pred_fminv2sf */

            case 29:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14845; /* pred_fminv4sf */

            case 30:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14847; /* pred_fminv8sf */

            case 31:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14849; /* pred_fminv16sf */

            case 32:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14851; /* pred_fminv32sf */

            case 33:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14853; /* pred_fminv64sf */

            case 34:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14855; /* pred_fminv128sf */

            case 35:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14857; /* pred_fminv256sf */

            case 36:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14859; /* pred_fminv512sf */

            case 37:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14861; /* pred_fminv1024sf */

            case 38:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14863; /* pred_fminv1df */

            case 39:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14865; /* pred_fminv2df */

            case 40:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14867; /* pred_fminv4df */

            case 41:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14869; /* pred_fminv8df */

            case 42:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14871; /* pred_fminv16df */

            case 43:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14873; /* pred_fminv32df */

            case 44:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14875; /* pred_fminv64df */

            case 45:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14877; /* pred_fminv128df */

            case 46:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14879; /* pred_fminv256df */

            case 47:
              if (!(
#line 6245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14881; /* pred_fminv512df */

            case 48:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14943; /* pred_fminrvvm8hf_scalar */

            case 49:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14945; /* pred_fminrvvm4hf_scalar */

            case 50:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14947; /* pred_fminrvvm2hf_scalar */

            case 51:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14949; /* pred_fminrvvm1hf_scalar */

            case 52:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14951; /* pred_fminrvvmf2hf_scalar */

            case 53:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14953; /* pred_fminrvvmf4hf_scalar */

            case 54:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14955; /* pred_fminrvvm8sf_scalar */

            case 55:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14957; /* pred_fminrvvm4sf_scalar */

            case 56:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14959; /* pred_fminrvvm2sf_scalar */

            case 57:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14961; /* pred_fminrvvm1sf_scalar */

            case 58:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14963; /* pred_fminrvvmf2sf_scalar */

            case 59:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14965; /* pred_fminrvvm8df_scalar */

            case 60:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14967; /* pred_fminrvvm4df_scalar */

            case 61:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14969; /* pred_fminrvvm2df_scalar */

            case 62:
              if (!(
#line 6313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14971; /* pred_fminrvvm1df_scalar */

            default:
              return -1;
            }

        case 123:
          return recog_602 (x1, insn, pnum_clobbers);

        case 124:
          return recog_601 (x1, insn, pnum_clobbers);

        case 134:
          return recog_596 (x1, insn, pnum_clobbers);

        case 135:
          x5 = XEXP (x2, 0);
          x6 = XVECEXP (x5, 0, 1);
          operands[5] = x6;
          x7 = XVECEXP (x5, 0, 2);
          operands[6] = x7;
          x8 = XVECEXP (x5, 0, 3);
          operands[7] = x8;
          x9 = XVECEXP (x5, 0, 4);
          operands[8] = x9;
          x10 = XVECEXP (x4, 0, 0);
          operands[3] = x10;
          x11 = XVECEXP (x4, 0, 1);
          operands[4] = x11;
          return recog_595 (x1, insn, pnum_clobbers);

        case 95:
          return recog_597 (x1, insn, pnum_clobbers);

        case 172:
          switch (pattern564 (x2))
            {
            case 0:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32579; /* pred_sf_vfnrcliprvvm2qi_x_f_qf */

            case 1:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32581; /* pred_sf_vfnrcliprvvm1qi_x_f_qf */

            case 2:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32583; /* pred_sf_vfnrcliprvvmf2qi_x_f_qf */

            case 3:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32585; /* pred_sf_vfnrcliprvvmf4qi_x_f_qf */

            case 4:
              if (!(
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF) && 
#line 4857 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32587; /* pred_sf_vfnrcliprvvmf8qi_x_f_qf */

            default:
              return -1;
            }

        case 173:
          switch (pattern564 (x2))
            {
            case 0:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32580; /* pred_sf_vfnrclipurvvm2qi_x_f_qf */

            case 1:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32582; /* pred_sf_vfnrclipurvvm1qi_x_f_qf */

            case 2:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32584; /* pred_sf_vfnrclipurvvmf2qi_x_f_qf */

            case 3:
              if (!
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32586; /* pred_sf_vfnrclipurvvmf4qi_x_f_qf */

            case 4:
              if (!(
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF) && 
#line 4857 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32588; /* pred_sf_vfnrclipurvvmf8qi_x_f_qf */

            default:
              return -1;
            }

        case 199:
          switch (pattern565 (x2))
            {
            case 0:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33353; /* pred_vclmulrvvm8di */

            case 1:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33355; /* pred_vclmulrvvm4di */

            case 2:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33357; /* pred_vclmulrvvm2di */

            case 3:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33359; /* pred_vclmulrvvm1di */

            case 4:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33361; /* *pred_vclmulrvvm8di_scalar */

            case 5:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33363; /* *pred_vclmulrvvm4di_scalar */

            case 6:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33365; /* *pred_vclmulrvvm2di_scalar */

            case 7:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33367; /* *pred_vclmulrvvm1di_scalar */

            case 8:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33369; /* *pred_vclmulrvvm8di_extend_scalar */

            case 9:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33371; /* *pred_vclmulrvvm4di_extend_scalar */

            case 10:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33373; /* *pred_vclmulrvvm2di_extend_scalar */

            case 11:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33375; /* *pred_vclmulrvvm1di_extend_scalar */

            default:
              return -1;
            }

        case 200:
          switch (pattern565 (x2))
            {
            case 0:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33354; /* pred_vclmulhrvvm8di */

            case 1:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33356; /* pred_vclmulhrvvm4di */

            case 2:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33358; /* pred_vclmulhrvvm2di */

            case 3:
              if (!(
#line 382 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33360; /* pred_vclmulhrvvm1di */

            case 4:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33362; /* *pred_vclmulhrvvm8di_scalar */

            case 5:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33364; /* *pred_vclmulhrvvm4di_scalar */

            case 6:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33366; /* *pred_vclmulhrvvm2di_scalar */

            case 7:
              if (!(
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33368; /* *pred_vclmulhrvvm1di_scalar */

            case 8:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33370; /* *pred_vclmulhrvvm8di_extend_scalar */

            case 9:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33372; /* *pred_vclmulhrvvm4di_extend_scalar */

            case 10:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33374; /* *pred_vclmulhrvvm2di_extend_scalar */

            case 11:
              if (!(
#line 459 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33376; /* *pred_vclmulhrvvm1di_extend_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_607 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_906 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern492 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5501; /* pred_xorrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5518; /* pred_xorrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5535; /* pred_xorrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5552; /* pred_xorrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5569; /* pred_xorrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5586; /* pred_xorrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5603; /* pred_xorrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5620; /* pred_xorrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5637; /* pred_xorrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5654; /* pred_xorrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5671; /* pred_xorrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5688; /* pred_xorrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5705; /* pred_xorrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5722; /* pred_xorrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5739; /* pred_xorrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5756; /* pred_xorrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5773; /* pred_xorrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5790; /* pred_xorrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5807; /* pred_xorrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5824; /* pred_xorrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5841; /* pred_xorrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5858; /* pred_xorrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5875; /* pred_xorv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5892; /* pred_xorv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5909; /* pred_xorv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5926; /* pred_xorv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5943; /* pred_xorv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5960; /* pred_xorv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5977; /* pred_xorv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5994; /* pred_xorv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6011; /* pred_xorv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6028; /* pred_xorv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6045; /* pred_xorv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6062; /* pred_xorv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6079; /* pred_xorv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6096; /* pred_xorv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6113; /* pred_xorv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6130; /* pred_xorv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6147; /* pred_xorv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6164; /* pred_xorv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6181; /* pred_xorv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6198; /* pred_xorv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6215; /* pred_xorv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6232; /* pred_xorv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6249; /* pred_xorv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6266; /* pred_xorv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6283; /* pred_xorv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6300; /* pred_xorv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6317; /* pred_xorv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6334; /* pred_xorv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6351; /* pred_xorv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6368; /* pred_xorv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6385; /* pred_xorv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6402; /* pred_xorv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6419; /* pred_xorv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6436; /* pred_xorv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6453; /* pred_xorv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6470; /* pred_xorv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6487; /* pred_xorv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6504; /* pred_xorv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6521; /* pred_xorv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6538; /* pred_xorv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6555; /* pred_xorv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6572; /* pred_xorv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6589; /* pred_xorv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6606; /* pred_xorv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6623; /* pred_xorv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6640; /* pred_xorv512di */

    case 68:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6860; /* pred_xorrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6869; /* pred_xorrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6878; /* pred_xorrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6887; /* pred_xorrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6896; /* pred_xorrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6905; /* pred_xorrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6914; /* pred_xorrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6923; /* pred_xorrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6932; /* pred_xorrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6941; /* pred_xorrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6950; /* pred_xorrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6959; /* pred_xorrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6968; /* pred_xorrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6977; /* pred_xorrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6986; /* pred_xorrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6995; /* pred_xorrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7004; /* pred_xorrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7013; /* pred_xorrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7022; /* pred_xorv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7031; /* pred_xorv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7040; /* pred_xorv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7049; /* pred_xorv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7058; /* pred_xorv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7067; /* pred_xorv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7076; /* pred_xorv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7085; /* pred_xorv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7094; /* pred_xorv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7103; /* pred_xorv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7112; /* pred_xorv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7121; /* pred_xorv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7130; /* pred_xorv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7139; /* pred_xorv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7148; /* pred_xorv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7157; /* pred_xorv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7166; /* pred_xorv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7175; /* pred_xorv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7184; /* pred_xorv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7193; /* pred_xorv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7202; /* pred_xorv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7211; /* pred_xorv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7220; /* pred_xorv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7229; /* pred_xorv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7238; /* pred_xorv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7247; /* pred_xorv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7256; /* pred_xorv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7265; /* pred_xorv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7274; /* pred_xorv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7283; /* pred_xorv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7292; /* pred_xorv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7301; /* pred_xorv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7310; /* pred_xorv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7319; /* pred_xorv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7328; /* pred_xorv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7337; /* pred_xorv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7670; /* *pred_xorrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7679; /* *pred_xorrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7688; /* *pred_xorrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7697; /* *pred_xorrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7706; /* *pred_xorv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7715; /* *pred_xorv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7724; /* *pred_xorv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7733; /* *pred_xorv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7742; /* *pred_xorv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7751; /* *pred_xorv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7760; /* *pred_xorv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7769; /* *pred_xorv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7778; /* *pred_xorv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7787; /* *pred_xorv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7796; /* *pred_xorrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7805; /* *pred_xorrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7814; /* *pred_xorrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7823; /* *pred_xorrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7832; /* *pred_xorv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7841; /* *pred_xorv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7850; /* *pred_xorv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7859; /* *pred_xorv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7868; /* *pred_xorv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7877; /* *pred_xorv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7886; /* *pred_xorv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7895; /* *pred_xorv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7904; /* *pred_xorv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7913; /* *pred_xorv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_919 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      return recog_883 (x1, insn, pnum_clobbers);

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 123)
        return -1;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x5, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x5, 0, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[4] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HFmode:
              if (pattern711 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15128; /* pred_ncopysignrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern711 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15129; /* pred_ncopysignrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern711 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15130; /* pred_ncopysignrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern711 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15131; /* pred_ncopysignrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern711 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15132; /* pred_ncopysignrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern711 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15133; /* pred_ncopysignrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern711 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15134; /* pred_ncopysignrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern711 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15135; /* pred_ncopysignrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern711 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15136; /* pred_ncopysignrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern711 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15137; /* pred_ncopysignrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern711 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15138; /* pred_ncopysignrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern711 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15139; /* pred_ncopysignrvvm8df */

            case E_RVVM4DFmode:
              if (pattern711 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15140; /* pred_ncopysignrvvm4df */

            case E_RVVM2DFmode:
              if (pattern711 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15141; /* pred_ncopysignrvvm2df */

            case E_RVVM1DFmode:
              if (pattern711 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6404 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15142; /* pred_ncopysignrvvm1df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HFmode:
              if (pattern712 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15239; /* pred_ncopysignrvvm8hf_scalar */

            case E_RVVM4HFmode:
              if (pattern712 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15240; /* pred_ncopysignrvvm4hf_scalar */

            case E_RVVM2HFmode:
              if (pattern712 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15241; /* pred_ncopysignrvvm2hf_scalar */

            case E_RVVM1HFmode:
              if (pattern712 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15242; /* pred_ncopysignrvvm1hf_scalar */

            case E_RVVMF2HFmode:
              if (pattern712 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15243; /* pred_ncopysignrvvmf2hf_scalar */

            case E_RVVMF4HFmode:
              if (pattern712 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15244; /* pred_ncopysignrvvmf4hf_scalar */

            case E_RVVM8SFmode:
              if (pattern712 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15245; /* pred_ncopysignrvvm8sf_scalar */

            case E_RVVM4SFmode:
              if (pattern712 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15246; /* pred_ncopysignrvvm4sf_scalar */

            case E_RVVM2SFmode:
              if (pattern712 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15247; /* pred_ncopysignrvvm2sf_scalar */

            case E_RVVM1SFmode:
              if (pattern712 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15248; /* pred_ncopysignrvvm1sf_scalar */

            case E_RVVMF2SFmode:
              if (pattern712 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15249; /* pred_ncopysignrvvmf2sf_scalar */

            case E_RVVM8DFmode:
              if (pattern712 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15250; /* pred_ncopysignrvvm8df_scalar */

            case E_RVVM4DFmode:
              if (pattern712 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15251; /* pred_ncopysignrvvm4df_scalar */

            case E_RVVM2DFmode:
              if (pattern712 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15252; /* pred_ncopysignrvvm2df_scalar */

            case E_RVVM1DFmode:
              if (pattern712 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15253; /* pred_ncopysignrvvm1df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_924 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1254; /* *pred_mov_widthhurvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1260; /* *pred_mov_widthhurvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1266; /* *pred_mov_widthhurvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1272; /* *pred_mov_widthhurvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1278; /* *pred_mov_widthhurvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1284; /* *pred_mov_widthhurvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1290; /* *pred_mov_widthhurvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1296; /* *pred_mov_widthhurvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1302; /* *pred_mov_widthhurvvm8si */

    case 9:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1308; /* *pred_mov_widthhurvvm4si */

    case 10:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1314; /* *pred_mov_widthhurvvm2si */

    case 11:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1320; /* *pred_mov_widthhurvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1326; /* *pred_mov_widthhurvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1332; /* *pred_mov_widthhurvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1338; /* *pred_mov_widthhurvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1344; /* *pred_mov_widthhurvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1350; /* *pred_mov_widthhurvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1356; /* *pred_mov_widthhurvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1362; /* *pred_mov_widthhurvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1368; /* *pred_mov_widthhurvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1374; /* *pred_mov_widthhurvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1380; /* *pred_mov_widthhurvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1386; /* *pred_mov_widthhurvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1392; /* *pred_mov_widthhurvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1398; /* *pred_mov_widthhurvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1404; /* *pred_mov_widthhurvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1410; /* *pred_mov_widthhurvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1416; /* *pred_mov_widthhurvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1422; /* *pred_mov_widthhurvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1428; /* *pred_mov_widthhurvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1434; /* *pred_mov_widthhurvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1440; /* *pred_mov_widthhurvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1446; /* *pred_mov_widthhurvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1452; /* *pred_mov_widthhurvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1458; /* *pred_mov_widthhurvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1464; /* *pred_mov_widthhurvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1470; /* *pred_mov_widthhurvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1476; /* *pred_mov_widthhurvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1482; /* *pred_mov_widthhurvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1488; /* *pred_mov_widthhurvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1494; /* *pred_mov_widthhurvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1500; /* *pred_mov_widthhurvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1506; /* *pred_mov_widthhurvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1512; /* *pred_mov_widthhuv1qi */

    case 44:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1518; /* *pred_mov_widthhuv2qi */

    case 45:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1524; /* *pred_mov_widthhuv4qi */

    case 46:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1530; /* *pred_mov_widthhuv8qi */

    case 47:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1536; /* *pred_mov_widthhuv16qi */

    case 48:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1542; /* *pred_mov_widthhuv32qi */

    case 49:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1548; /* *pred_mov_widthhuv64qi */

    case 50:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1554; /* *pred_mov_widthhuv128qi */

    case 51:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1560; /* *pred_mov_widthhuv256qi */

    case 52:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1566; /* *pred_mov_widthhuv512qi */

    case 53:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1572; /* *pred_mov_widthhuv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1578; /* *pred_mov_widthhuv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1584; /* *pred_mov_widthhuv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1590; /* *pred_mov_widthhuv1hi */

    case 57:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1596; /* *pred_mov_widthhuv2hi */

    case 58:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1602; /* *pred_mov_widthhuv4hi */

    case 59:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1608; /* *pred_mov_widthhuv8hi */

    case 60:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1614; /* *pred_mov_widthhuv16hi */

    case 61:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1620; /* *pred_mov_widthhuv32hi */

    case 62:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1626; /* *pred_mov_widthhuv64hi */

    case 63:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1632; /* *pred_mov_widthhuv128hi */

    case 64:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1638; /* *pred_mov_widthhuv256hi */

    case 65:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1644; /* *pred_mov_widthhuv512hi */

    case 66:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1650; /* *pred_mov_widthhuv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1656; /* *pred_mov_widthhuv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1662; /* *pred_mov_widthhuv1si */

    case 69:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1668; /* *pred_mov_widthhuv2si */

    case 70:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1674; /* *pred_mov_widthhuv4si */

    case 71:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1680; /* *pred_mov_widthhuv8si */

    case 72:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1686; /* *pred_mov_widthhuv16si */

    case 73:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1692; /* *pred_mov_widthhuv32si */

    case 74:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1698; /* *pred_mov_widthhuv64si */

    case 75:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1704; /* *pred_mov_widthhuv128si */

    case 76:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1710; /* *pred_mov_widthhuv256si */

    case 77:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1716; /* *pred_mov_widthhuv512si */

    case 78:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1722; /* *pred_mov_widthhuv1024si */

    case 79:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1728; /* *pred_mov_widthhuv1di */

    case 80:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1734; /* *pred_mov_widthhuv2di */

    case 81:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1740; /* *pred_mov_widthhuv4di */

    case 82:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1746; /* *pred_mov_widthhuv8di */

    case 83:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1752; /* *pred_mov_widthhuv16di */

    case 84:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1758; /* *pred_mov_widthhuv32di */

    case 85:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1764; /* *pred_mov_widthhuv64di */

    case 86:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1770; /* *pred_mov_widthhuv128di */

    case 87:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1776; /* *pred_mov_widthhuv256di */

    case 88:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1782; /* *pred_mov_widthhuv512di */

    case 89:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1788; /* *pred_mov_widthhuv1hf */

    case 90:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1794; /* *pred_mov_widthhuv2hf */

    case 91:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1800; /* *pred_mov_widthhuv4hf */

    case 92:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1806; /* *pred_mov_widthhuv8hf */

    case 93:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1812; /* *pred_mov_widthhuv16hf */

    case 94:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1818; /* *pred_mov_widthhuv32hf */

    case 95:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1824; /* *pred_mov_widthhuv64hf */

    case 96:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1830; /* *pred_mov_widthhuv128hf */

    case 97:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1836; /* *pred_mov_widthhuv256hf */

    case 98:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1842; /* *pred_mov_widthhuv512hf */

    case 99:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1848; /* *pred_mov_widthhuv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1854; /* *pred_mov_widthhuv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1860; /* *pred_mov_widthhuv1sf */

    case 102:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1866; /* *pred_mov_widthhuv2sf */

    case 103:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1872; /* *pred_mov_widthhuv4sf */

    case 104:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1878; /* *pred_mov_widthhuv8sf */

    case 105:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1884; /* *pred_mov_widthhuv16sf */

    case 106:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1890; /* *pred_mov_widthhuv32sf */

    case 107:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1896; /* *pred_mov_widthhuv64sf */

    case 108:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1902; /* *pred_mov_widthhuv128sf */

    case 109:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1908; /* *pred_mov_widthhuv256sf */

    case 110:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1914; /* *pred_mov_widthhuv512sf */

    case 111:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1920; /* *pred_mov_widthhuv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1926; /* *pred_mov_widthhuv1df */

    case 113:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1932; /* *pred_mov_widthhuv2df */

    case 114:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1938; /* *pred_mov_widthhuv4df */

    case 115:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1944; /* *pred_mov_widthhuv8df */

    case 116:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1950; /* *pred_mov_widthhuv16df */

    case 117:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1956; /* *pred_mov_widthhuv32df */

    case 118:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1962; /* *pred_mov_widthhuv64df */

    case 119:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1968; /* *pred_mov_widthhuv128df */

    case 120:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1974; /* *pred_mov_widthhuv256df */

    case 121:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1980; /* *pred_mov_widthhuv512df */

    default:
      return -1;
    }
}

 int
recog_936 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern724 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12235; /* pred_narrow_cliprvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12331; /* pred_narrow_cliprvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12237; /* pred_narrow_cliprvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12333; /* pred_narrow_cliprvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12239; /* pred_narrow_cliprvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12335; /* pred_narrow_cliprvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12241; /* pred_narrow_cliprvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12337; /* pred_narrow_cliprvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12243; /* pred_narrow_cliprvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12339; /* pred_narrow_cliprvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12245; /* pred_narrow_cliprvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12341; /* pred_narrow_cliprvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12247; /* pred_narrow_cliprvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12343; /* pred_narrow_cliprvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12249; /* pred_narrow_cliprvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12345; /* pred_narrow_cliprvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12251; /* pred_narrow_cliprvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12347; /* pred_narrow_cliprvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12253; /* pred_narrow_cliprvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12349; /* pred_narrow_cliprvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12255; /* pred_narrow_cliprvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12351; /* pred_narrow_cliprvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12257; /* pred_narrow_cliprvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12353; /* pred_narrow_cliprvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12259; /* pred_narrow_cliprvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12355; /* pred_narrow_cliprvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12261; /* pred_narrow_cliprvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12357; /* pred_narrow_cliprvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12263; /* pred_narrow_cliprvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12359; /* pred_narrow_cliprvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12265; /* pred_narrow_clipv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12361; /* pred_narrow_clipv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12267; /* pred_narrow_clipv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12363; /* pred_narrow_clipv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12269; /* pred_narrow_clipv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12365; /* pred_narrow_clipv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12271; /* pred_narrow_clipv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12367; /* pred_narrow_clipv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12273; /* pred_narrow_clipv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12369; /* pred_narrow_clipv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12275; /* pred_narrow_clipv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12371; /* pred_narrow_clipv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12277; /* pred_narrow_clipv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12373; /* pred_narrow_clipv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12279; /* pred_narrow_clipv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12375; /* pred_narrow_clipv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12281; /* pred_narrow_clipv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12377; /* pred_narrow_clipv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12283; /* pred_narrow_clipv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12379; /* pred_narrow_clipv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 12285; /* pred_narrow_clipv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12381; /* pred_narrow_clipv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 12287; /* pred_narrow_clipv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12383; /* pred_narrow_clipv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12289; /* pred_narrow_clipv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12385; /* pred_narrow_clipv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12291; /* pred_narrow_clipv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12387; /* pred_narrow_clipv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12293; /* pred_narrow_clipv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12389; /* pred_narrow_clipv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12295; /* pred_narrow_clipv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12391; /* pred_narrow_clipv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12297; /* pred_narrow_clipv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12393; /* pred_narrow_clipv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12299; /* pred_narrow_clipv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12395; /* pred_narrow_clipv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12301; /* pred_narrow_clipv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12397; /* pred_narrow_clipv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12303; /* pred_narrow_clipv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12399; /* pred_narrow_clipv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12305; /* pred_narrow_clipv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12401; /* pred_narrow_clipv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12307; /* pred_narrow_clipv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12403; /* pred_narrow_clipv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 12309; /* pred_narrow_clipv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12405; /* pred_narrow_clipv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 12311; /* pred_narrow_clipv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12407; /* pred_narrow_clipv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 12313; /* pred_narrow_clipv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12409; /* pred_narrow_clipv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12315; /* pred_narrow_clipv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12411; /* pred_narrow_clipv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12317; /* pred_narrow_clipv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12413; /* pred_narrow_clipv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12319; /* pred_narrow_clipv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12415; /* pred_narrow_clipv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12321; /* pred_narrow_clipv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12417; /* pred_narrow_clipv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12323; /* pred_narrow_clipv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12419; /* pred_narrow_clipv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12325; /* pred_narrow_clipv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12421; /* pred_narrow_clipv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12327; /* pred_narrow_clipv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12423; /* pred_narrow_clipv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12329; /* pred_narrow_clipv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12425; /* pred_narrow_clipv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_1044 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_939 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15350; /* *pred_maddrvvm8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15446; /* *pred_maccrvvm8hf */
}

 int
recog_1052 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15748; /* *pred_mul_neg_addrvvm4sf_undef */
}

 int
recog_1060 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15764; /* *pred_mul_neg_addv1hf_undef */
}

 int
recog_1068 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15780; /* *pred_mul_neg_addv256hf_undef */
}

 int
recog_1076 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15796; /* *pred_mul_neg_addv16sf_undef */
}

 int
recog_1084 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15812; /* *pred_mul_neg_addv2df_undef */
}

 int
recog_1094 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1091 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15922; /* *pred_nmsubv256df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 16018; /* *pred_nmsacv256df */
}

 int
recog_1104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1081 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15902; /* *pred_nmsubv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15998; /* *pred_nmsacv512sf */
}

 int
recog_1114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1071 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15882; /* *pred_nmsubv2048hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15978; /* *pred_nmsacv2048hf */
}

 int
recog_1124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1061 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15862; /* *pred_nmsubv2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15958; /* *pred_nmsacv2hf */
}

 int
recog_1134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1051 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15842; /* *pred_nmsubrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15938; /* *pred_nmsacrvvm8sf */
}

 int
recog_1144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15255; /* *pred_mul_subrvvm8hf_undef */
}

 int
recog_1151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15269; /* *pred_mul_subrvvm4sf_undef */
}

 int
recog_1158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15283; /* *pred_mul_subrvvm1df_undef */
}

 int
recog_1165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15297; /* *pred_mul_subv64hf_undef */
}

 int
recog_1172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15311; /* *pred_mul_subv2sf_undef */
}

 int
recog_1179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15325; /* *pred_mul_subv256sf_undef */
}

 int
recog_1186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15339; /* *pred_mul_subv16df_undef */
}

 int
recog_1193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1190 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15443; /* *pred_msubv256df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15539; /* *pred_msacv256df */
}

 int
recog_1200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1183 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15429; /* *pred_msubv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15525; /* *pred_msacv2df */
}

 int
recog_1207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1176 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 15415; /* *pred_msubv32sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15511; /* *pred_msacv32sf */
}

 int
recog_1214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1169 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15401; /* *pred_msubv1024hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15497; /* *pred_msacv1024hf */
}

 int
recog_1221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1162 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15387; /* *pred_msubv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15483; /* *pred_msacv8hf */
}

 int
recog_1228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1155 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15373; /* *pred_msubrvvm8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15469; /* *pred_msacrvvm8df */
}

 int
recog_1235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1148 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15359; /* *pred_msubrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15455; /* *pred_msacrvvmf2hf */
}

 int
recog_1242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15739; /* *pred_mul_neg_subrvvm2hf_undef */
}

 int
recog_1249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15753; /* *pred_mul_neg_subrvvm1sf_undef */
}

 int
recog_1256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15767; /* *pred_mul_neg_subv2hf_undef */
}

 int
recog_1263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15781; /* *pred_mul_neg_subv256hf_undef */
}

 int
recog_1270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15795; /* *pred_mul_neg_subv8sf_undef */
}

 int
recog_1277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15809; /* *pred_mul_neg_subv1024sf_undef */
}

 int
recog_1284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15823; /* *pred_mul_neg_subv64df_undef */
}

 int
recog_1291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1284 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15919; /* *pred_nmaddv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 16015; /* *pred_nmaccv64df */
}

 int
recog_1298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1277 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15905; /* *pred_nmaddv1024sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16001; /* *pred_nmaccv1024sf */
}

 int
recog_1305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1270 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15891; /* *pred_nmaddv8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15987; /* *pred_nmaccv8sf */
}

 int
recog_1312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1263 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15877; /* *pred_nmaddv256hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15973; /* *pred_nmaccv256hf */
}

 int
recog_1319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1256 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15863; /* *pred_nmaddv2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15959; /* *pred_nmaccv2hf */
}

 int
recog_1327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1248 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15847; /* *pred_nmaddrvvm2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15943; /* *pred_nmaccrvvm2sf */
}

 int
recog_1335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1240 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15831; /* *pred_nmaddrvvm8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15927; /* *pred_nmaccrvvm8hf */
}

 int
recog_1343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[9] = x8;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[3] = x11;
      x12 = XEXP (x10, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          switch (pattern713 (x2))
            {
            case 0:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14501; /* pred_divrvvm8hf */

            case 1:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14505; /* pred_divrvvm4hf */

            case 2:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14509; /* pred_divrvvm2hf */

            case 3:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14513; /* pred_divrvvm1hf */

            case 4:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14517; /* pred_divrvvmf2hf */

            case 5:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14521; /* pred_divrvvmf4hf */

            case 6:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14525; /* pred_divrvvm8sf */

            case 7:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14529; /* pred_divrvvm4sf */

            case 8:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14533; /* pred_divrvvm2sf */

            case 9:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14537; /* pred_divrvvm1sf */

            case 10:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14541; /* pred_divrvvmf2sf */

            case 11:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14545; /* pred_divrvvm8df */

            case 12:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14549; /* pred_divrvvm4df */

            case 13:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14553; /* pred_divrvvm2df */

            case 14:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14557; /* pred_divrvvm1df */

            case 15:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14561; /* pred_divv1hf */

            case 16:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14565; /* pred_divv2hf */

            case 17:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14569; /* pred_divv4hf */

            case 18:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14573; /* pred_divv8hf */

            case 19:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14577; /* pred_divv16hf */

            case 20:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14581; /* pred_divv32hf */

            case 21:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14585; /* pred_divv64hf */

            case 22:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14589; /* pred_divv128hf */

            case 23:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14593; /* pred_divv256hf */

            case 24:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14597; /* pred_divv512hf */

            case 25:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14601; /* pred_divv1024hf */

            case 26:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14605; /* pred_divv2048hf */

            case 27:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14609; /* pred_divv1sf */

            case 28:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14613; /* pred_divv2sf */

            case 29:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14617; /* pred_divv4sf */

            case 30:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14621; /* pred_divv8sf */

            case 31:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14625; /* pred_divv16sf */

            case 32:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14629; /* pred_divv32sf */

            case 33:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14633; /* pred_divv64sf */

            case 34:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14637; /* pred_divv128sf */

            case 35:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14641; /* pred_divv256sf */

            case 36:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14645; /* pred_divv512sf */

            case 37:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14649; /* pred_divv1024sf */

            case 38:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14653; /* pred_divv1df */

            case 39:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14657; /* pred_divv2df */

            case 40:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14661; /* pred_divv4df */

            case 41:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14665; /* pred_divv8df */

            case 42:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14669; /* pred_divv16df */

            case 43:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14673; /* pred_divv32df */

            case 44:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14677; /* pred_divv64df */

            case 45:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14681; /* pred_divv128df */

            case 46:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14685; /* pred_divv256df */

            case 47:
              if (!(
#line 6202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14689; /* pred_divv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern728 (x2))
            {
            case 0:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14973; /* pred_divrvvm8hf_scalar */

            case 1:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14975; /* pred_divrvvm4hf_scalar */

            case 2:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14977; /* pred_divrvvm2hf_scalar */

            case 3:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14979; /* pred_divrvvm1hf_scalar */

            case 4:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14981; /* pred_divrvvmf2hf_scalar */

            case 5:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14983; /* pred_divrvvmf4hf_scalar */

            case 6:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14985; /* pred_divrvvm8sf_scalar */

            case 7:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14987; /* pred_divrvvm4sf_scalar */

            case 8:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14989; /* pred_divrvvm2sf_scalar */

            case 9:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14991; /* pred_divrvvm1sf_scalar */

            case 10:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14993; /* pred_divrvvmf2sf_scalar */

            case 11:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14995; /* pred_divrvvm8df_scalar */

            case 12:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14997; /* pred_divrvvm4df_scalar */

            case 13:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14999; /* pred_divrvvm2df_scalar */

            case 14:
              if (!(
#line 6336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15001; /* pred_divrvvm1df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern709 (x2))
        {
        case 0:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15003; /* pred_divrvvm8hf_reverse_scalar */

        case 1:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15005; /* pred_divrvvm4hf_reverse_scalar */

        case 2:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15007; /* pred_divrvvm2hf_reverse_scalar */

        case 3:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15009; /* pred_divrvvm1hf_reverse_scalar */

        case 4:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15011; /* pred_divrvvmf2hf_reverse_scalar */

        case 5:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 15013; /* pred_divrvvmf4hf_reverse_scalar */

        case 6:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15015; /* pred_divrvvm8sf_reverse_scalar */

        case 7:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15017; /* pred_divrvvm4sf_reverse_scalar */

        case 8:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15019; /* pred_divrvvm2sf_reverse_scalar */

        case 9:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15021; /* pred_divrvvm1sf_reverse_scalar */

        case 10:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 15023; /* pred_divrvvmf2sf_reverse_scalar */

        case 11:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15025; /* pred_divrvvm8df_reverse_scalar */

        case 12:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15027; /* pred_divrvvm4df_reverse_scalar */

        case 13:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15029; /* pred_divrvvm2df_reverse_scalar */

        case 14:
          if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15031; /* pred_divrvvm1df_reverse_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      return recog_1342 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_1341 (x1, insn, pnum_clobbers);

    case MINUS:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_1338 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          switch (pattern581 (x2))
            {
            case 0:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15002; /* pred_subrvvm8hf_reverse_scalar */

            case 1:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15004; /* pred_subrvvm4hf_reverse_scalar */

            case 2:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15006; /* pred_subrvvm2hf_reverse_scalar */

            case 3:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15008; /* pred_subrvvm1hf_reverse_scalar */

            case 4:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15010; /* pred_subrvvmf2hf_reverse_scalar */

            case 5:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15012; /* pred_subrvvmf4hf_reverse_scalar */

            case 6:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15014; /* pred_subrvvm8sf_reverse_scalar */

            case 7:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15016; /* pred_subrvvm4sf_reverse_scalar */

            case 8:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15018; /* pred_subrvvm2sf_reverse_scalar */

            case 9:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15020; /* pred_subrvvm1sf_reverse_scalar */

            case 10:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15022; /* pred_subrvvmf2sf_reverse_scalar */

            case 11:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15024; /* pred_subrvvm8df_reverse_scalar */

            case 12:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15026; /* pred_subrvvm4df_reverse_scalar */

            case 13:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15028; /* pred_subrvvm2df_reverse_scalar */

            case 14:
              if (!(
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15030; /* pred_subrvvm1df_reverse_scalar */

            default:
              return -1;
            }

        case MULT:
          return recog_1336 (x1, insn, pnum_clobbers);

        case NEG:
          return recog_1337 (x1, insn, pnum_clobbers);

        case FLOAT_EXTEND:
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != FLOAT_EXTEND)
            return -1;
          x6 = XEXP (x2, 0);
          x7 = XVECEXP (x6, 0, 1);
          operands[5] = x7;
          x8 = XVECEXP (x6, 0, 2);
          operands[6] = x8;
          x9 = XVECEXP (x6, 0, 3);
          operands[7] = x9;
          x10 = XVECEXP (x6, 0, 4);
          operands[8] = x10;
          x11 = XVECEXP (x6, 0, 5);
          operands[9] = x11;
          x12 = XEXP (x4, 0);
          operands[3] = x12;
          x13 = XEXP (x2, 2);
          operands[2] = x13;
          switch (pattern727 (x2))
            {
            case 0:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16404; /* pred_dual_widen_subrvvm8sf */

            case 1:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16407; /* pred_dual_widen_subrvvm4sf */

            case 2:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16410; /* pred_dual_widen_subrvvm2sf */

            case 3:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16413; /* pred_dual_widen_subrvvm1sf */

            case 4:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16416; /* pred_dual_widen_subrvvmf2sf */

            case 5:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16419; /* pred_dual_widen_subrvvm8df */

            case 6:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16422; /* pred_dual_widen_subrvvm4df */

            case 7:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16425; /* pred_dual_widen_subrvvm2df */

            case 8:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16428; /* pred_dual_widen_subrvvm1df */

            case 9:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16431; /* pred_dual_widen_subv1sf */

            case 10:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16434; /* pred_dual_widen_subv2sf */

            case 11:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16437; /* pred_dual_widen_subv4sf */

            case 12:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16440; /* pred_dual_widen_subv8sf */

            case 13:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16443; /* pred_dual_widen_subv16sf */

            case 14:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16446; /* pred_dual_widen_subv32sf */

            case 15:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16449; /* pred_dual_widen_subv64sf */

            case 16:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16452; /* pred_dual_widen_subv128sf */

            case 17:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16455; /* pred_dual_widen_subv256sf */

            case 18:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16458; /* pred_dual_widen_subv512sf */

            case 19:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16461; /* pred_dual_widen_subv1024sf */

            case 20:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16464; /* pred_dual_widen_subv1df */

            case 21:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16467; /* pred_dual_widen_subv2df */

            case 22:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16470; /* pred_dual_widen_subv4df */

            case 23:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16473; /* pred_dual_widen_subv8df */

            case 24:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16476; /* pred_dual_widen_subv16df */

            case 25:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16479; /* pred_dual_widen_subv32df */

            case 26:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16482; /* pred_dual_widen_subv64df */

            case 27:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16485; /* pred_dual_widen_subv128df */

            case 28:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16488; /* pred_dual_widen_subv256df */

            case 29:
              if (!(
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16491; /* pred_dual_widen_subv512df */

            case 30:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16494; /* pred_dual_widen_subrvvm8sf_scalar */

            case 31:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16497; /* pred_dual_widen_subrvvm4sf_scalar */

            case 32:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16500; /* pred_dual_widen_subrvvm2sf_scalar */

            case 33:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16503; /* pred_dual_widen_subrvvm1sf_scalar */

            case 34:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16506; /* pred_dual_widen_subrvvmf2sf_scalar */

            case 35:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16509; /* pred_dual_widen_subrvvm8df_scalar */

            case 36:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16512; /* pred_dual_widen_subrvvm4df_scalar */

            case 37:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16515; /* pred_dual_widen_subrvvm2df_scalar */

            case 38:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16518; /* pred_dual_widen_subrvvm1df_scalar */

            case 39:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16521; /* pred_dual_widen_subv1sf_scalar */

            case 40:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16524; /* pred_dual_widen_subv2sf_scalar */

            case 41:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16527; /* pred_dual_widen_subv4sf_scalar */

            case 42:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16530; /* pred_dual_widen_subv8sf_scalar */

            case 43:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16533; /* pred_dual_widen_subv16sf_scalar */

            case 44:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16536; /* pred_dual_widen_subv32sf_scalar */

            case 45:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16539; /* pred_dual_widen_subv64sf_scalar */

            case 46:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16542; /* pred_dual_widen_subv128sf_scalar */

            case 47:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16545; /* pred_dual_widen_subv256sf_scalar */

            case 48:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16548; /* pred_dual_widen_subv512sf_scalar */

            case 49:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16551; /* pred_dual_widen_subv1024sf_scalar */

            case 50:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16554; /* pred_dual_widen_subv1df_scalar */

            case 51:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16557; /* pred_dual_widen_subv2df_scalar */

            case 52:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16560; /* pred_dual_widen_subv4df_scalar */

            case 53:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16563; /* pred_dual_widen_subv8df_scalar */

            case 54:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16566; /* pred_dual_widen_subv16df_scalar */

            case 55:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16569; /* pred_dual_widen_subv32df_scalar */

            case 56:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16572; /* pred_dual_widen_subv64df_scalar */

            case 57:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16575; /* pred_dual_widen_subv128df_scalar */

            case 58:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16578; /* pred_dual_widen_subv256df_scalar */

            case 59:
              if (!(
#line 7065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16581; /* pred_dual_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      return recog_1343 (x1, insn, pnum_clobbers);

    case SQRT:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[8] = x11;
      switch (pattern575 (x2))
        {
        case 0:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16214; /* pred_sqrtrvvm8hf */

        case 1:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16215; /* pred_sqrtrvvm4hf */

        case 2:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16216; /* pred_sqrtrvvm2hf */

        case 3:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16217; /* pred_sqrtrvvm1hf */

        case 4:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16218; /* pred_sqrtrvvmf2hf */

        case 5:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16219; /* pred_sqrtrvvmf4hf */

        case 6:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16220; /* pred_sqrtrvvm8sf */

        case 7:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16221; /* pred_sqrtrvvm4sf */

        case 8:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16222; /* pred_sqrtrvvm2sf */

        case 9:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16223; /* pred_sqrtrvvm1sf */

        case 10:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16224; /* pred_sqrtrvvmf2sf */

        case 11:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16225; /* pred_sqrtrvvm8df */

        case 12:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16226; /* pred_sqrtrvvm4df */

        case 13:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16227; /* pred_sqrtrvvm2df */

        case 14:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16228; /* pred_sqrtrvvm1df */

        case 15:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 16229; /* pred_sqrtv1hf */

        case 16:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 16230; /* pred_sqrtv2hf */

        case 17:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 16231; /* pred_sqrtv4hf */

        case 18:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 16232; /* pred_sqrtv8hf */

        case 19:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 16233; /* pred_sqrtv16hf */

        case 20:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16234; /* pred_sqrtv32hf */

        case 21:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16235; /* pred_sqrtv64hf */

        case 22:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16236; /* pred_sqrtv128hf */

        case 23:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16237; /* pred_sqrtv256hf */

        case 24:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16238; /* pred_sqrtv512hf */

        case 25:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16239; /* pred_sqrtv1024hf */

        case 26:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16240; /* pred_sqrtv2048hf */

        case 27:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16241; /* pred_sqrtv1sf */

        case 28:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16242; /* pred_sqrtv2sf */

        case 29:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16243; /* pred_sqrtv4sf */

        case 30:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16244; /* pred_sqrtv8sf */

        case 31:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16245; /* pred_sqrtv16sf */

        case 32:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16246; /* pred_sqrtv32sf */

        case 33:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16247; /* pred_sqrtv64sf */

        case 34:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16248; /* pred_sqrtv128sf */

        case 35:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16249; /* pred_sqrtv256sf */

        case 36:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16250; /* pred_sqrtv512sf */

        case 37:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16251; /* pred_sqrtv1024sf */

        case 38:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16252; /* pred_sqrtv1df */

        case 39:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16253; /* pred_sqrtv2df */

        case 40:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16254; /* pred_sqrtv4df */

        case 41:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16255; /* pred_sqrtv8df */

        case 42:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16256; /* pred_sqrtv16df */

        case 43:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16257; /* pred_sqrtv32df */

        case 44:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16258; /* pred_sqrtv64df */

        case 45:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16259; /* pred_sqrtv128df */

        case 46:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16260; /* pred_sqrtv256df */

        case 47:
          if (!(
#line 6915 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16261; /* pred_sqrtv512df */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_1340 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_1344 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_1345 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[8] = x11;
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      x13 = XEXP (x2, 2);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern504 (x2, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18065; /* pred_truncrvvm8sf */

        case E_RVVM2HFmode:
          if (pattern504 (x2, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18066; /* pred_truncrvvm4sf */

        case E_RVVM1HFmode:
          if (pattern504 (x2, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18067; /* pred_truncrvvm2sf */

        case E_RVVMF2HFmode:
          if (pattern504 (x2, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18068; /* pred_truncrvvm1sf */

        case E_RVVMF4HFmode:
          if (pattern504 (x2, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18069; /* pred_truncrvvmf2sf */

        case E_RVVM4SFmode:
          if (pattern504 (x2, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18070; /* pred_truncrvvm8df */

        case E_RVVM2SFmode:
          if (pattern504 (x2, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18071; /* pred_truncrvvm4df */

        case E_RVVM1SFmode:
          if (pattern504 (x2, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18072; /* pred_truncrvvm2df */

        case E_RVVMF2SFmode:
          if (pattern504 (x2, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18073; /* pred_truncrvvm1df */

        case E_V1HFmode:
          if (pattern504 (x2, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18074; /* pred_truncv1sf */

        case E_V2HFmode:
          if (pattern504 (x2, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18075; /* pred_truncv2sf */

        case E_V4HFmode:
          if (pattern504 (x2, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18076; /* pred_truncv4sf */

        case E_V8HFmode:
          if (pattern504 (x2, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18077; /* pred_truncv8sf */

        case E_V16HFmode:
          if (pattern504 (x2, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18078; /* pred_truncv16sf */

        case E_V32HFmode:
          if (pattern504 (x2, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18079; /* pred_truncv32sf */

        case E_V64HFmode:
          if (pattern504 (x2, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18080; /* pred_truncv64sf */

        case E_V128HFmode:
          if (pattern504 (x2, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18081; /* pred_truncv128sf */

        case E_V256HFmode:
          if (pattern504 (x2, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18082; /* pred_truncv256sf */

        case E_V512HFmode:
          if (pattern504 (x2, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18083; /* pred_truncv512sf */

        case E_V1024HFmode:
          if (pattern504 (x2, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18084; /* pred_truncv1024sf */

        case E_V1SFmode:
          if (pattern504 (x2, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18085; /* pred_truncv1df */

        case E_V2SFmode:
          if (pattern504 (x2, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18086; /* pred_truncv2df */

        case E_V4SFmode:
          if (pattern504 (x2, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18087; /* pred_truncv4df */

        case E_V8SFmode:
          if (pattern504 (x2, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18088; /* pred_truncv8df */

        case E_V16SFmode:
          if (pattern504 (x2, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18089; /* pred_truncv16df */

        case E_V32SFmode:
          if (pattern504 (x2, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18090; /* pred_truncv32df */

        case E_V64SFmode:
          if (pattern504 (x2, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18091; /* pred_truncv64df */

        case E_V128SFmode:
          if (pattern504 (x2, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18092; /* pred_truncv128df */

        case E_V256SFmode:
          if (pattern504 (x2, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18093; /* pred_truncv256df */

        case E_V512SFmode:
          if (pattern504 (x2, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0
              || !(
#line 7722 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18094; /* pred_truncv512df */

        case E_RVVM4BFmode:
          if (pattern504 (x2, 
E_RVVM4BFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 53 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 21 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33762; /* pred_truncrvvm8sf_to_bf16 */

        case E_RVVM2BFmode:
          if (pattern504 (x2, 
E_RVVM2BFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 53 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 22 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33763; /* pred_truncrvvm4sf_to_bf16 */

        case E_RVVM1BFmode:
          if (pattern504 (x2, 
E_RVVM1BFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 53 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 23 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33764; /* pred_truncrvvm2sf_to_bf16 */

        case E_RVVMF2BFmode:
          if (pattern504 (x2, 
E_RVVMF2BFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 53 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33765; /* pred_truncrvvm1sf_to_bf16 */

        case E_RVVMF4BFmode:
          if (pattern504 (x2, 
E_RVVMF4BFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 53 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 25 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 33766; /* pred_truncrvvmf2sf_to_bf16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1458 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[3], E_V64HFmode)
          || GET_MODE (x9) != E_V64HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17108; /* *pred_cmpv64hf_scalar_merge_tie_mask */

    case E_V64SFmode:
      if (!register_operand (operands[3], E_V64SFmode)
          || GET_MODE (x9) != E_V64SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17120; /* *pred_cmpv64sf_scalar_merge_tie_mask */

    case E_V64DFmode:
      if (!register_operand (operands[3], E_V64DFmode)
          || GET_MODE (x9) != E_V64DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17131; /* *pred_cmpv64df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1459 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || GET_MODE (x9) != E_V128HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HFmode)) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 17157; /* *pred_cmpv128hf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HFmode)) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17205; /* *pred_cmpv128hf_scalar_narrow */

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || GET_MODE (x9) != E_V128SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SFmode)) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 17169; /* *pred_cmpv128sf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SFmode)) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17217; /* *pred_cmpv128sf_scalar_narrow */

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || GET_MODE (x9) != E_V128DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DFmode)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 17180; /* *pred_cmpv128df_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DFmode)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17228; /* *pred_cmpv128df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GT:
    case LE:
    case GTU:
    case LEU:
      res = recog_1373 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
    case LT:
    case GEU:
    case LTU:
      res = recog_1400 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GT:
    case LE:
    case LT:
    case GTU:
    case LEU:
    case LTU:
      res = recog_1430 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF2BImode:
              if (pattern548 (x2, 
E_RVVMF2BImode) != 0)
                return -1;
              operands[3] = x3;
              if (pattern607 (x2, 
E_RVVMF2BImode, 
E_RVVM8HFmode) == 0
                  && (
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HFmode)) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return 16943; /* *pred_cmprvvm8hf */
              operands[2] = x3;
              if (pattern608 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) == 0
                  && (
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return 16991; /* *pred_cmprvvm8hf_narrow_merge_tie_mask */
              operands[3] = x3;
              if (pattern607 (x2, 
E_RVVMF2BImode, 
E_RVVM8HFmode) != 0
                  || !(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HFmode)) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 17039; /* *pred_cmprvvm8hf_narrow */

            case E_RVVMF4BImode:
              if (pattern548 (x2, 
E_RVVMF4BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern609 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HFmode)) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return 16944; /* *pred_cmprvvm4hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SFmode)) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return 16949; /* *pred_cmprvvm8sf */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_RVVMF4BImode))
                {
                  res = recog_1431 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern609 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HFmode)) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 17040; /* *pred_cmprvvm4hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SFmode)) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17045; /* *pred_cmprvvm8sf_narrow */

                default:
                  return -1;
                }

            case E_RVVMF8BImode:
              if (pattern548 (x2, 
E_RVVMF8BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern610 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HFmode)) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return 16945; /* *pred_cmprvvm2hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SFmode)) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return 16950; /* *pred_cmprvvm4sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DFmode)) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return 16954; /* *pred_cmprvvm8df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_RVVMF8BImode))
                {
                  res = recog_1432 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern610 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HFmode)) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 17041; /* *pred_cmprvvm2hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SFmode)) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17046; /* *pred_cmprvvm4sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DFmode)) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17050; /* *pred_cmprvvm8df_narrow */

                default:
                  return -1;
                }

            case E_RVVMF16BImode:
              if (pattern548 (x2, 
E_RVVMF16BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern611 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HFmode)) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return 16946; /* *pred_cmprvvm1hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SFmode)) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return 16951; /* *pred_cmprvvm2sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DFmode)) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return 16955; /* *pred_cmprvvm4df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_RVVMF16BImode))
                {
                  res = recog_1433 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern611 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HFmode)) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 17042; /* *pred_cmprvvm1hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SFmode)) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17047; /* *pred_cmprvvm2sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DFmode)) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17051; /* *pred_cmprvvm4df_narrow */

                default:
                  return -1;
                }

            case E_RVVMF32BImode:
              if (pattern548 (x2, 
E_RVVMF32BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern612 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HFmode)) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return 16947; /* *pred_cmprvvmf2hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SFmode)) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return 16952; /* *pred_cmprvvm1sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DFmode)) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return 16956; /* *pred_cmprvvm2df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_RVVMF32BImode))
                {
                  res = recog_1434 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern612 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HFmode)) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 17043; /* *pred_cmprvvmf2hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SFmode)) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17048; /* *pred_cmprvvm1sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DFmode)) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17052; /* *pred_cmprvvm2df_narrow */

                default:
                  return -1;
                }

            case E_RVVMF64BImode:
              if (pattern548 (x2, 
E_RVVMF64BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern613 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HFmode)) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return 16948; /* *pred_cmprvvmf4hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SFmode)) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return 16953; /* *pred_cmprvvmf2sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DFmode)) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return 16957; /* *pred_cmprvvm1df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_RVVMF64BImode))
                {
                  res = recog_1435 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern613 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HFmode)) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 17044; /* *pred_cmprvvmf4hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SFmode)) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 17049; /* *pred_cmprvvmf2sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DFmode)) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17053; /* *pred_cmprvvm1df_narrow */

                default:
                  return -1;
                }

            case E_V1BImode:
              if (pattern548 (x2, 
E_V1BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern614 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HFmode)) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return 16958; /* *pred_cmpv1hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SFmode)) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return 16970; /* *pred_cmpv1sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DFmode)) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                    return 16981; /* *pred_cmpv1df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V1BImode))
                {
                  res = recog_1436 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern614 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HFmode)) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 17054; /* *pred_cmpv1hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SFmode)) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17066; /* *pred_cmpv1sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DFmode)) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17077; /* *pred_cmpv1df_narrow */

                default:
                  return -1;
                }

            case E_V2BImode:
              if (pattern548 (x2, 
E_V2BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern615 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HFmode)) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return 16959; /* *pred_cmpv2hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SFmode)) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return 16971; /* *pred_cmpv2sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DFmode)) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                    return 16982; /* *pred_cmpv2df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V2BImode))
                {
                  res = recog_1437 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern615 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HFmode)) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 17055; /* *pred_cmpv2hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SFmode)) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17067; /* *pred_cmpv2sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DFmode)) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17078; /* *pred_cmpv2df_narrow */

                default:
                  return -1;
                }

            case E_V4BImode:
              if (pattern548 (x2, 
E_V4BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern616 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HFmode)) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return 16960; /* *pred_cmpv4hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SFmode)) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return 16972; /* *pred_cmpv4sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DFmode)) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                    return 16983; /* *pred_cmpv4df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V4BImode))
                {
                  res = recog_1438 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern616 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HFmode)) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 17056; /* *pred_cmpv4hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SFmode)) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17068; /* *pred_cmpv4sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DFmode)) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                    return -1;
                  return 17079; /* *pred_cmpv4df_narrow */

                default:
                  return -1;
                }

            case E_V8BImode:
              if (pattern548 (x2, 
E_V8BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern617 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HFmode)) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return 16961; /* *pred_cmpv8hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SFmode)) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return 16973; /* *pred_cmpv8sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DFmode)) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                    return 16984; /* *pred_cmpv8df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V8BImode))
                {
                  res = recog_1439 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern617 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HFmode)) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 17057; /* *pred_cmpv8hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SFmode)) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 17069; /* *pred_cmpv8sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DFmode)) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 17080; /* *pred_cmpv8df_narrow */

                default:
                  return -1;
                }

            case E_V16BImode:
              if (pattern548 (x2, 
E_V16BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern618 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HFmode)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return 16962; /* *pred_cmpv16hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SFmode)) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return 16974; /* *pred_cmpv16sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DFmode)) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                    return 16985; /* *pred_cmpv16df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V16BImode))
                {
                  res = recog_1440 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern618 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HFmode)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 17058; /* *pred_cmpv16hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SFmode)) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 17070; /* *pred_cmpv16sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DFmode)) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 17081; /* *pred_cmpv16df_narrow */

                default:
                  return -1;
                }

            case E_V32BImode:
              if (pattern548 (x2, 
E_V32BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern619 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HFmode)) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return 16963; /* *pred_cmpv32hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SFmode)) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return 16975; /* *pred_cmpv32sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DFmode)) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                    return 16986; /* *pred_cmpv32df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V32BImode))
                {
                  res = recog_1441 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern619 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HFmode)) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 17059; /* *pred_cmpv32hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SFmode)) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 17071; /* *pred_cmpv32sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DFmode)) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 17082; /* *pred_cmpv32df_narrow */

                default:
                  return -1;
                }

            case E_V64BImode:
              if (pattern548 (x2, 
E_V64BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern620 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64HFmode)) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return 16964; /* *pred_cmpv64hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64SFmode)) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return 16976; /* *pred_cmpv64sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DFmode)) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                    return 16987; /* *pred_cmpv64df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V64BImode))
                {
                  res = recog_1442 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern620 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64HFmode)) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 17060; /* *pred_cmpv64hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64SFmode)) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 17072; /* *pred_cmpv64sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DFmode)) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 17083; /* *pred_cmpv64df_narrow */

                default:
                  return -1;
                }

            case E_V128BImode:
              if (pattern548 (x2, 
E_V128BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern621 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HFmode)) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return 16965; /* *pred_cmpv128hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SFmode)) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return 16977; /* *pred_cmpv128sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DFmode)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                    return 16988; /* *pred_cmpv128df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V128BImode))
                {
                  res = recog_1443 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern621 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HFmode)) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 17061; /* *pred_cmpv128hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SFmode)) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 17073; /* *pred_cmpv128sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DFmode)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 17084; /* *pred_cmpv128df_narrow */

                default:
                  return -1;
                }

            case E_V256BImode:
              if (pattern548 (x2, 
E_V256BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern622 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HFmode)) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return 16966; /* *pred_cmpv256hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SFmode)) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return 16978; /* *pred_cmpv256sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DFmode)) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                    return 16989; /* *pred_cmpv256df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V256BImode))
                {
                  res = recog_1444 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern622 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HFmode)) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 17062; /* *pred_cmpv256hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SFmode)) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 17074; /* *pred_cmpv256sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DFmode)) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 17085; /* *pred_cmpv256df_narrow */

                default:
                  return -1;
                }

            case E_V512BImode:
              if (pattern548 (x2, 
E_V512BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern623 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HFmode)) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return 16967; /* *pred_cmpv512hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SFmode)) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return 16979; /* *pred_cmpv512sf */
                  break;

                case 2:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DFmode)) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                    return 16990; /* *pred_cmpv512df */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V512BImode))
                {
                  res = recog_1445 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern623 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HFmode)) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 17063; /* *pred_cmpv512hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SFmode)) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 17075; /* *pred_cmpv512sf_narrow */

                case 2:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DFmode)) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 17086; /* *pred_cmpv512df_narrow */

                default:
                  return -1;
                }

            case E_V1024BImode:
              if (pattern548 (x2, 
E_V1024BImode) != 0)
                return -1;
              operands[3] = x3;
              switch (pattern624 (x2))
                {
                case 0:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HFmode)) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return 16968; /* *pred_cmpv1024hf */
                  break;

                case 1:
                  if ((
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SFmode)) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return 16980; /* *pred_cmpv1024sf */
                  break;

                default:
                  break;
                }
              operands[2] = x3;
              if (register_operand (operands[1], E_V1024BImode))
                {
                  res = recog_1446 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[3] = x3;
              switch (pattern624 (x2))
                {
                case 0:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HFmode)) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 17064; /* *pred_cmpv1024hf_narrow */

                case 1:
                  if (!(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SFmode)) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 17076; /* *pred_cmpv1024sf_narrow */

                default:
                  return -1;
                }

            case E_V2048BImode:
              if (pattern548 (x2, 
E_V2048BImode) != 0)
                return -1;
              operands[3] = x3;
              if (pattern607 (x2, 
E_V2048BImode, 
E_V2048HFmode) == 0
                  && (
#line 7310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HFmode)) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return 16969; /* *pred_cmpv2048hf */
              operands[2] = x3;
              if (pattern608 (x2, 
E_V2048HFmode, 
E_V2048BImode) == 0
                  && (
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return 17017; /* *pred_cmpv2048hf_narrow_merge_tie_mask */
              operands[3] = x3;
              if (pattern607 (x2, 
E_V2048BImode, 
E_V2048HFmode) != 0
                  || !(
#line 7354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HFmode)) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 17065; /* *pred_cmpv2048hf_narrow */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          return recog_1470 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 99; /* sminsf3 */

    case 1:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 100; /* smindf3 */

    case 2:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 101; /* sminhf3 */

    case 3:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 570; /* *sminsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33925; /* riscv_cv_alu_min */

    case 4:
      if (!(
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 574; /* *smindi3 */

    case 5:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24548; /* sminrvvm8qi3 */

    case 6:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24562; /* sminrvvm4qi3 */

    case 7:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24576; /* sminrvvm2qi3 */

    case 8:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24590; /* sminrvvm1qi3 */

    case 9:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24604; /* sminrvvm8hi3 */

    case 10:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24618; /* sminrvvm4hi3 */

    case 11:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24632; /* sminrvvm2hi3 */

    case 12:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24646; /* sminrvvm1hi3 */

    case 13:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24660; /* sminrvvm8si3 */

    case 14:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24674; /* sminrvvm4si3 */

    case 15:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24688; /* sminrvvm2si3 */

    case 16:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24702; /* sminrvvm1si3 */

    case 17:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24716; /* sminrvvm8di3 */

    case 18:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24730; /* sminrvvm4di3 */

    case 19:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24744; /* sminrvvm2di3 */

    case 20:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24758; /* sminrvvm1di3 */

    case 21:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24772; /* sminrvvmf2qi3 */

    case 22:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24786; /* sminrvvmf4qi3 */

    case 23:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24800; /* sminrvvmf8qi3 */

    case 24:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24814; /* sminrvvmf2hi3 */

    case 25:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24828; /* sminrvvmf4hi3 */

    case 26:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24842; /* sminrvvmf2si3 */

    case 27:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24856; /* sminv1qi3 */

    case 28:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24870; /* sminv2qi3 */

    case 29:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24884; /* sminv4qi3 */

    case 30:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24898; /* sminv8qi3 */

    case 31:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24912; /* sminv16qi3 */

    case 32:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24926; /* sminv32qi3 */

    case 33:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24940; /* sminv64qi3 */

    case 34:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24954; /* sminv128qi3 */

    case 35:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24968; /* sminv256qi3 */

    case 36:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24982; /* sminv512qi3 */

    case 37:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24996; /* sminv1024qi3 */

    case 38:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25010; /* sminv2048qi3 */

    case 39:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25024; /* sminv4096qi3 */

    case 40:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25038; /* sminv1hi3 */

    case 41:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25052; /* sminv2hi3 */

    case 42:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25066; /* sminv4hi3 */

    case 43:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25080; /* sminv8hi3 */

    case 44:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25094; /* sminv16hi3 */

    case 45:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25108; /* sminv32hi3 */

    case 46:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25122; /* sminv64hi3 */

    case 47:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25136; /* sminv128hi3 */

    case 48:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25150; /* sminv256hi3 */

    case 49:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25164; /* sminv512hi3 */

    case 50:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25178; /* sminv1024hi3 */

    case 51:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25192; /* sminv2048hi3 */

    case 52:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25206; /* sminv1si3 */

    case 53:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25220; /* sminv2si3 */

    case 54:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25234; /* sminv4si3 */

    case 55:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25248; /* sminv8si3 */

    case 56:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25262; /* sminv16si3 */

    case 57:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25276; /* sminv32si3 */

    case 58:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25290; /* sminv64si3 */

    case 59:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25304; /* sminv128si3 */

    case 60:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25318; /* sminv256si3 */

    case 61:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25332; /* sminv512si3 */

    case 62:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25346; /* sminv1024si3 */

    case 63:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25360; /* sminv1di3 */

    case 64:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25374; /* sminv2di3 */

    case 65:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25388; /* sminv4di3 */

    case 66:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25402; /* sminv8di3 */

    case 67:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25416; /* sminv16di3 */

    case 68:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25430; /* sminv32di3 */

    case 69:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25444; /* sminv64di3 */

    case 70:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25458; /* sminv128di3 */

    case 71:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25472; /* sminv256di3 */

    case 72:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25486; /* sminv512di3 */

    case 73:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27700; /* sminrvvm8hf3 */

    case 74:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27702; /* sminrvvm4hf3 */

    case 75:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27704; /* sminrvvm2hf3 */

    case 76:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27706; /* sminrvvm1hf3 */

    case 77:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27708; /* sminrvvmf2hf3 */

    case 78:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27710; /* sminrvvmf4hf3 */

    case 79:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27712; /* sminrvvm8sf3 */

    case 80:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27714; /* sminrvvm4sf3 */

    case 81:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27716; /* sminrvvm2sf3 */

    case 82:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27718; /* sminrvvm1sf3 */

    case 83:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27720; /* sminrvvmf2sf3 */

    case 84:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27722; /* sminrvvm8df3 */

    case 85:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27724; /* sminrvvm4df3 */

    case 86:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27726; /* sminrvvm2df3 */

    case 87:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27728; /* sminrvvm1df3 */

    case 88:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27730; /* sminv1hf3 */

    case 89:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27732; /* sminv2hf3 */

    case 90:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27734; /* sminv4hf3 */

    case 91:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27736; /* sminv8hf3 */

    case 92:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27738; /* sminv16hf3 */

    case 93:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27740; /* sminv32hf3 */

    case 94:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27742; /* sminv64hf3 */

    case 95:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27744; /* sminv128hf3 */

    case 96:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27746; /* sminv256hf3 */

    case 97:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27748; /* sminv512hf3 */

    case 98:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27750; /* sminv1024hf3 */

    case 99:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27752; /* sminv2048hf3 */

    case 100:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27754; /* sminv1sf3 */

    case 101:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27756; /* sminv2sf3 */

    case 102:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27758; /* sminv4sf3 */

    case 103:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27760; /* sminv8sf3 */

    case 104:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27762; /* sminv16sf3 */

    case 105:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27764; /* sminv32sf3 */

    case 106:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27766; /* sminv64sf3 */

    case 107:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27768; /* sminv128sf3 */

    case 108:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27770; /* sminv256sf3 */

    case 109:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27772; /* sminv512sf3 */

    case 110:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27774; /* sminv1024sf3 */

    case 111:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27776; /* sminv1df3 */

    case 112:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27778; /* sminv2df3 */

    case 113:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27780; /* sminv4df3 */

    case 114:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27782; /* sminv8df3 */

    case 115:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27784; /* sminv16df3 */

    case 116:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27786; /* sminv32df3 */

    case 117:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27788; /* sminv64df3 */

    case 118:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27790; /* sminv128df3 */

    case 119:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27792; /* sminv256df3 */

    case 120:
      if (!(
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27794; /* sminv512df3 */

    default:
      return -1;
    }
}

 int
recog_1495 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 571; /* *uminsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33926; /* riscv_cv_alu_minu */

    case 1:
      if (!(
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 575; /* *umindi3 */

    case 2:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24549; /* uminrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24563; /* uminrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24577; /* uminrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24591; /* uminrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24605; /* uminrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24619; /* uminrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24633; /* uminrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24647; /* uminrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24661; /* uminrvvm8si3 */

    case 11:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24675; /* uminrvvm4si3 */

    case 12:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24689; /* uminrvvm2si3 */

    case 13:
      if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24703; /* uminrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24717; /* uminrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24731; /* uminrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24745; /* uminrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24759; /* uminrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24773; /* uminrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24787; /* uminrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24801; /* uminrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24815; /* uminrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24829; /* uminrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24843; /* uminrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24857; /* uminv1qi3 */

    case 25:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24871; /* uminv2qi3 */

    case 26:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24885; /* uminv4qi3 */

    case 27:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24899; /* uminv8qi3 */

    case 28:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24913; /* uminv16qi3 */

    case 29:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24927; /* uminv32qi3 */

    case 30:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24941; /* uminv64qi3 */

    case 31:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24955; /* uminv128qi3 */

    case 32:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24969; /* uminv256qi3 */

    case 33:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24983; /* uminv512qi3 */

    case 34:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24997; /* uminv1024qi3 */

    case 35:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25011; /* uminv2048qi3 */

    case 36:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25025; /* uminv4096qi3 */

    case 37:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25039; /* uminv1hi3 */

    case 38:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25053; /* uminv2hi3 */

    case 39:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25067; /* uminv4hi3 */

    case 40:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25081; /* uminv8hi3 */

    case 41:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25095; /* uminv16hi3 */

    case 42:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25109; /* uminv32hi3 */

    case 43:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25123; /* uminv64hi3 */

    case 44:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25137; /* uminv128hi3 */

    case 45:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25151; /* uminv256hi3 */

    case 46:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25165; /* uminv512hi3 */

    case 47:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25179; /* uminv1024hi3 */

    case 48:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25193; /* uminv2048hi3 */

    case 49:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25207; /* uminv1si3 */

    case 50:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25221; /* uminv2si3 */

    case 51:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25235; /* uminv4si3 */

    case 52:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25249; /* uminv8si3 */

    case 53:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25263; /* uminv16si3 */

    case 54:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25277; /* uminv32si3 */

    case 55:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25291; /* uminv64si3 */

    case 56:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25305; /* uminv128si3 */

    case 57:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25319; /* uminv256si3 */

    case 58:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25333; /* uminv512si3 */

    case 59:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25347; /* uminv1024si3 */

    case 60:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25361; /* uminv1di3 */

    case 61:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25375; /* uminv2di3 */

    case 62:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25389; /* uminv4di3 */

    case 63:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25403; /* uminv8di3 */

    case 64:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25417; /* uminv16di3 */

    case 65:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25431; /* uminv32di3 */

    case 66:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25445; /* uminv64di3 */

    case 67:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25459; /* uminv128di3 */

    case 68:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25473; /* uminv256di3 */

    case 69:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25487; /* uminv512di3 */

    default:
      return -1;
    }
}

 int
recog_1503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern118 (x3))
    {
    case 0:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27939; /* smulrvvm8qi3_highpart */

    case 1:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27941; /* smulrvvm4qi3_highpart */

    case 2:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27943; /* smulrvvm2qi3_highpart */

    case 3:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27945; /* smulrvvm1qi3_highpart */

    case 4:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27947; /* smulrvvmf2qi3_highpart */

    case 5:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27949; /* smulrvvmf4qi3_highpart */

    case 6:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27951; /* smulrvvmf8qi3_highpart */

    case 7:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27953; /* smulrvvm8hi3_highpart */

    case 8:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27955; /* smulrvvm4hi3_highpart */

    case 9:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27957; /* smulrvvm2hi3_highpart */

    case 10:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27959; /* smulrvvm1hi3_highpart */

    case 11:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27961; /* smulrvvmf2hi3_highpart */

    case 12:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27963; /* smulrvvmf4hi3_highpart */

    case 13:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27965; /* smulrvvm8si3_highpart */

    case 14:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27967; /* smulrvvm4si3_highpart */

    case 15:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27969; /* smulrvvm2si3_highpart */

    case 16:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27971; /* smulrvvm1si3_highpart */

    case 17:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27973; /* smulrvvmf2si3_highpart */

    case 18:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27975; /* smulrvvm8di3_highpart */

    case 19:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27977; /* smulrvvm4di3_highpart */

    case 20:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27979; /* smulrvvm2di3_highpart */

    case 21:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27981; /* smulrvvm1di3_highpart */

    case 22:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27983; /* smulv1qi3_highpart */

    case 23:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27985; /* smulv2qi3_highpart */

    case 24:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27987; /* smulv4qi3_highpart */

    case 25:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27989; /* smulv8qi3_highpart */

    case 26:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27991; /* smulv16qi3_highpart */

    case 27:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27993; /* smulv32qi3_highpart */

    case 28:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27995; /* smulv64qi3_highpart */

    case 29:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27997; /* smulv128qi3_highpart */

    case 30:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27999; /* smulv256qi3_highpart */

    case 31:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28001; /* smulv512qi3_highpart */

    case 32:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28003; /* smulv1024qi3_highpart */

    case 33:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28005; /* smulv2048qi3_highpart */

    case 34:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28007; /* smulv4096qi3_highpart */

    case 35:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28009; /* smulv1hi3_highpart */

    case 36:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28011; /* smulv2hi3_highpart */

    case 37:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28013; /* smulv4hi3_highpart */

    case 38:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28015; /* smulv8hi3_highpart */

    case 39:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28017; /* smulv16hi3_highpart */

    case 40:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28019; /* smulv32hi3_highpart */

    case 41:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28021; /* smulv64hi3_highpart */

    case 42:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28023; /* smulv128hi3_highpart */

    case 43:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28025; /* smulv256hi3_highpart */

    case 44:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28027; /* smulv512hi3_highpart */

    case 45:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28029; /* smulv1024hi3_highpart */

    case 46:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28031; /* smulv2048hi3_highpart */

    case 47:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28033; /* smulv1si3_highpart */

    case 48:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28035; /* smulv2si3_highpart */

    case 49:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28037; /* smulv4si3_highpart */

    case 50:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28039; /* smulv8si3_highpart */

    case 51:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28041; /* smulv16si3_highpart */

    case 52:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28043; /* smulv32si3_highpart */

    case 53:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28045; /* smulv64si3_highpart */

    case 54:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28047; /* smulv128si3_highpart */

    case 55:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28049; /* smulv256si3_highpart */

    case 56:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28051; /* smulv512si3_highpart */

    case 57:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28053; /* smulv1024si3_highpart */

    case 58:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28055; /* smulv1di3_highpart */

    case 59:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28057; /* smulv2di3_highpart */

    case 60:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28059; /* smulv4di3_highpart */

    case 61:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28061; /* smulv8di3_highpart */

    case 62:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28063; /* smulv16di3_highpart */

    case 63:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28065; /* smulv32di3_highpart */

    case 64:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28067; /* smulv64di3_highpart */

    case 65:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28069; /* smulv128di3_highpart */

    case 66:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28071; /* smulv256di3_highpart */

    case 67:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28073; /* smulv512di3_highpart */

    default:
      return -1;
    }
}

 int
recog_1517 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!absolute_symbolic_operand (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      switch (pattern424 (
E_QImode))
        {
        case 0:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 842; /* *local_pic_storeqi */

        case 1:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 846; /* *local_pic_storeqi */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern424 (
E_HImode))
        {
        case 0:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 843; /* *local_pic_storehi */

        case 1:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 847; /* *local_pic_storehi */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern424 (
E_SImode))
        {
        case 0:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 844; /* *local_pic_storesi */

        case 1:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 848; /* *local_pic_storesi */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern424 (
E_DImode))
        {
        case 0:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return -1;
          return 845; /* *local_pic_storedi */

        case 1:
          if (!(
#line 93 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          return 849; /* *local_pic_storedi */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern425 (
E_SFmode))
        {
        case 0:
          if ((
#line 102 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return 850; /* *local_pic_storesf */
          if (!(
#line 128 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 862; /* *local_pic_store_sfsf */

        case 1:
          if ((
#line 102 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return 853; /* *local_pic_storesf */
          if (!(
#line 128 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 865; /* *local_pic_store_sfsf */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern425 (
E_DFmode))
        {
        case 0:
          if ((
#line 102 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return 851; /* *local_pic_storedf */
          if (!(
#line 128 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return -1;
          return 863; /* *local_pic_store_sfdf */

        case 1:
          if ((
#line 102 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return 854; /* *local_pic_storedf */
          if (!(
#line 128 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          return 866; /* *local_pic_store_sfdf */

        default:
          return -1;
        }

    case E_HFmode:
      switch (pattern425 (
E_HFmode))
        {
        case 0:
          if ((
#line 102 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return 852; /* *local_pic_storehf */
          if (!(
#line 128 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return -1;
          return 864; /* *local_pic_store_sfhf */

        case 1:
          if ((
#line 102 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return 855; /* *local_pic_storehf */
          if (!(
#line 128 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          return 867; /* *local_pic_store_sfhf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              switch (pattern345 (x1))
                {
                case 0:
                  if (!(
#line 883 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 10; /* *lui_constraintsi_and_to_or */

                case 1:
                  if (!(
#line 883 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 11; /* *lui_constraintdi_and_to_or */

                default:
                  return -1;
                }

            case ASHIFT:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 1);
              operands[2] = x9;
              if (!imm123_operand (operands[2], E_QImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              if (!consecutive_bits_operand (operands[3], E_DImode))
                return -1;
              x11 = XEXP (x3, 1);
              operands[4] = x11;
              if (!register_operand (operands[4], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[5] = x12;
              if (!scratch_operand (operands[5], E_DImode)
                  || !
#line 96 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))))
                return -1;
              return 511; /* *andi_add.uw */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || pattern408 (x1) != 0
              || !
#line 4684 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
            return -1;
          return 492; /* *riscv.md:4678 */

        case REG:
          if (pattern271 (x1, 
1) != 0)
            return -1;
          x11 = XEXP (x3, 1);
          operands[0] = x11;
          if (!stack_pop_up_to_ra_operand (operands[0], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x5, 1);
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 1);
          switch (XWINT (x15, 0))
            {
            case -4L:
              if (pattern538 (x1, 
E_SImode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33805; /* gpr_multi_pop_up_to_ra_si */

            case -8L:
              if (pattern538 (x1, 
E_DImode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33806; /* gpr_multi_pop_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_1524 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 3064 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return -1;
          return 333; /* *extractsi3 */

        case 1:
          if (!(
#line 3064 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 335; /* *extractdi3 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 3064 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return -1;
          return 334; /* *zero_extractsi3 */

        case 1:
          if (!(
#line 3064 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 336; /* *zero_extractdi3 */

        default:
          return -1;
        }

    case AND:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (pattern340 (x1) != 0
              || !
#line 3138 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)))
            return -1;
          return 337; /* zero_extendsidi2_shifted */

        case NOT:
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              switch (pattern373 (x1))
                {
                case 0:
                  if (!(
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 519; /* *and_not_constsi */

                case 1:
                  if (!(
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 521; /* *and_not_constdi */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern369 (x1))
                {
                case 0:
                  if (!(
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 611; /* *bitmanip.md:722 */

                case 1:
                  if (!(
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 613; /* *bitmanip.md:722 */

                case 2:
                  if (!(
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 615; /* *bitmanip.md:750 */

                case 3:
                  if (!(
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 617; /* *bitmanip.md:750 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern369 (x1))
                {
                case 0:
                  if (!(
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 612; /* *bitmanip.md:722 */

                case 1:
                  if (!(
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 614; /* *bitmanip.md:722 */

                case 2:
                  if (!(
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 616; /* *bitmanip.md:750 */

                case 3:
                  if (!(
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 618; /* *bitmanip.md:750 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_1523 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case PC:
          res = recog_1514 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_1520 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case REG:
          switch (REGNO (x3))
            {
            case 7:
              res = recog_1521 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case 69:
              if (GET_MODE (x3) == E_SImode)
                {
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) == SET)
                    {
                      x12 = XEXP (x5, 0);
                      if (GET_CODE (x12) == REG
                          && REGNO (x12) == 69
                          && GET_MODE (x12) == E_SImode)
                        {
                          operands[0] = x6;
                          if (register_operand (operands[0], E_SImode))
                            {
                              x13 = XEXP (x5, 1);
                              operands[1] = x13;
                              if (reg_or_int_operand (operands[1], E_SImode)
                                  && 
#line 1100 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                                return 2722; /* fsrmsi_backup */
                            }
                        }
                    }
                }
              break;

            case 1:
              res = recog_1522 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x3;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          operands[0] = x6;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (a0a1_reg_operand (operands[2], E_SImode)
              && a0a1_reg_operand (operands[0], E_SImode)
              && zcmp_mv_sreg_operand (operands[1], E_SImode))
            {
              x13 = XEXP (x5, 1);
              operands[3] = x13;
              if (zcmp_mv_sreg_operand (operands[3], E_SImode)
                  && (
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP
   && (REGNO (operands[2]) != REGNO (operands[0]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 33901; /* *mva01ssi */
            }
          if (!zcmp_mv_sreg_operand (operands[2], E_SImode)
              || !zcmp_mv_sreg_operand (operands[0], E_SImode)
              || !a0a1_reg_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x5, 1);
          operands[3] = x13;
          if (!a0a1_reg_operand (operands[3], E_SImode)
              || !(
#line 1454 "../../gcc-15.0.1-20250313/gcc/config/riscv/zc.md"
(TARGET_ZCMP
   && (REGNO (operands[0]) != REGNO (operands[2]))
   && (REGNO (operands[1]) != REGNO (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33903; /* *mvsa01si */

        case MEM:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          operands[0] = x6;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              switch (pattern417 (x3, 
E_SFmode))
                {
                case 0:
                  if ((
#line 56 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return 827; /* *local_pic_loadsf */
                  if (!(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return -1;
                  return 833; /* *local_pic_load_32dsf */

                case 1:
                  if ((
#line 56 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return 830; /* *local_pic_loadsf */
                  if (!(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return -1;
                  return 836; /* *local_pic_load_32dsf */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern417 (x3, 
E_DFmode))
                {
                case 0:
                  if ((
#line 56 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return 828; /* *local_pic_loaddf */
                  if (!(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return -1;
                  return 834; /* *local_pic_load_32ddf */

                case 1:
                  if ((
#line 56 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return 831; /* *local_pic_loaddf */
                  if (!(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return -1;
                  return 837; /* *local_pic_load_32ddf */

                default:
                  return -1;
                }

            case E_HFmode:
              switch (pattern417 (x3, 
E_HFmode))
                {
                case 0:
                  if ((
#line 56 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return 829; /* *local_pic_loadhf */
                  if (!(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return -1;
                  return 835; /* *local_pic_load_32dhf */

                case 1:
                  if ((
#line 56 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return 832; /* *local_pic_loadhf */
                  if (!(
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return -1;
                  return 838; /* *local_pic_load_32dhf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern272 (x5) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      x12 = XEXP (x5, 0);
      x16 = XVECEXP (x12, 0, 0);
      operands[3] = x16;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      if (
#line 3961 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(SIBLING_CALL_P (insn)))
        return 455; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 457; /* call_value_internal */

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          switch (pattern409 (x1))
            {
            case 0:
              if (!
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff))
                return -1;
              return 491; /* *riscv.md:4543 */

            case 1:
              if (!
#line 4700 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
                return -1;
              return 493; /* *riscv.md:4693 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern370 (x1))
            {
            case 0:
              if (!(
#line 636 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 589; /* *bitmanip.md:628 */

            case 1:
              if (!(
#line 636 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 591; /* *bitmanip.md:628 */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          if (pattern371 (x1, 
SIGN_EXTEND) != 0
              || !
#line 437 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && TARGET_64BIT && reload_completed
   && th_mempair_operands_p (operands, true, SImode)))
            return -1;
          return 917; /* *th_mempair_load_extendsidi2 */

        default:
          return -1;
        }

    case IOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NOT:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (pattern373 (x1))
            {
            case 0:
              if (!(
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 520; /* *ior_not_constsi */

            case 1:
              if (!(
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 522; /* *ior_not_constdi */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern342 (x1))
            {
            case 0:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 595; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 599; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 603; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 607; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern342 (x1))
            {
            case 0:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 597; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 601; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 605; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 609; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          switch (pattern370 (x1))
            {
            case 0:
              if (!(
#line 636 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 590; /* *bitmanip.md:628 */

            case 1:
              if (!(
#line 636 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 592; /* *bitmanip.md:628 */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          if (pattern371 (x1, 
ZERO_EXTEND) != 0
              || !
#line 451 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && TARGET_64BIT && reload_completed
   && th_mempair_operands_p (operands, true, SImode)))
            return -1;
          return 918; /* *th_mempair_load_zero_extendsidi2 */

        default:
          return -1;
        }

    case XOR:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x11 = XEXP (x3, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[4] = x12;
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x4, 0);
          switch (pattern439 (x7))
            {
            case 0:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 596; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 600; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 604; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 608; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 0);
          switch (pattern439 (x7))
            {
            case 0:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 598; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 602; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 606; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 610; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x17 = XVECEXP (x3, 0, 1);
      if (!const_int_operand (x17, E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 82:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          operands[2] = x17;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          x18 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x18))
            {
            case PLUS:
              switch (pattern427 (x3))
                {
                case 0:
                  if (!
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 736; /* lrsc_atomic_addsi */

                case 1:
                  if (!(
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 740; /* lrsc_atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern427 (x3))
                {
                case 0:
                  if (!
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 737; /* lrsc_atomic_orsi */

                case 1:
                  if (!(
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 741; /* lrsc_atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern427 (x3))
                {
                case 0:
                  if (!
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 738; /* lrsc_atomic_xorsi */

                case 1:
                  if (!(
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 742; /* lrsc_atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern427 (x3))
                {
                case 0:
                  if (!
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 739; /* lrsc_atomic_andsi */

                case 1:
                  if (!(
#line 140 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 743; /* lrsc_atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 85:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x18 = XVECEXP (x3, 0, 0);
          operands[1] = x18;
          operands[3] = x17;
          x13 = XEXP (x5, 1);
          operands[2] = x13;
          x12 = XEXP (x5, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern443 (x3, 
E_SImode) != 0)
                return -1;
              if (
#line 396 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                return 773; /* amo_atomic_exchangesi */
              if (pnum_clobbers == NULL
                  || !
#line 410 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                return -1;
              *pnum_clobbers = 1;
              return 775; /* lrsc_atomic_exchangesi */

            case E_DImode:
              if (pattern443 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 396 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 774; /* amo_atomic_exchangedi */
              if (pnum_clobbers == NULL
                  || !(
#line 410 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 776; /* lrsc_atomic_exchangedi */

            default:
              return -1;
            }

        case 87:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x18 = XVECEXP (x3, 0, 0);
          operands[1] = x18;
          operands[3] = x17;
          x13 = XEXP (x5, 1);
          operands[2] = x13;
          x12 = XEXP (x5, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern443 (x3, 
E_QImode) != 0
                  || !
#line 445 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                return -1;
              return 777; /* zabha_atomic_exchangeqi */

            case E_HImode:
              if (pattern443 (x3, 
E_HImode) != 0
                  || !
#line 445 "../../gcc-15.0.1-20250313/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                return -1;
              return 778; /* zabha_atomic_exchangehi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9296 (insn, operands);

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9298 (insn, operands);

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9300 (insn, operands);

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9302 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9304 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9306 (insn, operands);

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9308 (insn, operands);

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9310 (insn, operands);

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9312 (insn, operands);

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !(
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9314 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9316 (insn, operands);

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9318 (insn, operands);

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9320 (insn, operands);

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9322 (insn, operands);

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9324 (insn, operands);

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9326 (insn, operands);

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9328 (insn, operands);

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9330 (insn, operands);

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9332 (insn, operands);

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9334 (insn, operands);

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9336 (insn, operands);

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9338 (insn, operands);

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9340 (insn, operands);

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9342 (insn, operands);

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9344 (insn, operands);

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9346 (insn, operands);

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9348 (insn, operands);

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9350 (insn, operands);

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9352 (insn, operands);

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9354 (insn, operands);

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9356 (insn, operands);

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9358 (insn, operands);

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9360 (insn, operands);

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9362 (insn, operands);

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9364 (insn, operands);

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9366 (insn, operands);

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9368 (insn, operands);

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9370 (insn, operands);

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9372 (insn, operands);

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9374 (insn, operands);

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9376 (insn, operands);

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9378 (insn, operands);

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9380 (insn, operands);

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9382 (insn, operands);

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9384 (insn, operands);

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9386 (insn, operands);

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9388 (insn, operands);

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !((
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9390 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9392 (insn, operands);

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9393 (insn, operands);

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9394 (insn, operands);

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9395 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9396 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9397 (insn, operands);

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9398 (insn, operands);

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9399 (insn, operands);

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9400 (insn, operands);

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !(
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9401 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9402 (insn, operands);

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9403 (insn, operands);

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9404 (insn, operands);

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9405 (insn, operands);

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9406 (insn, operands);

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9407 (insn, operands);

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9408 (insn, operands);

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9409 (insn, operands);

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9410 (insn, operands);

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9411 (insn, operands);

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9412 (insn, operands);

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9413 (insn, operands);

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9414 (insn, operands);

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9415 (insn, operands);

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9416 (insn, operands);

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9417 (insn, operands);

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9418 (insn, operands);

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9419 (insn, operands);

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9420 (insn, operands);

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9421 (insn, operands);

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9422 (insn, operands);

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9423 (insn, operands);

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9424 (insn, operands);

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9425 (insn, operands);

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9426 (insn, operands);

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9427 (insn, operands);

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9428 (insn, operands);

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9429 (insn, operands);

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9430 (insn, operands);

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9431 (insn, operands);

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9432 (insn, operands);

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9433 (insn, operands);

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9434 (insn, operands);

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9435 (insn, operands);

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9436 (insn, operands);

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9437 (insn, operands);

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9438 (insn, operands);

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !((
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9439 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_3 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return gen_split_317 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4338 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16DFmode)
       || !register_operand (operands[1], V16DFmode)))))
        return gen_split_1981 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2164 (insn, operands);
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DFmode)
      && reg_or_mem_operand (operands[1], E_V8DFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return gen_split_316 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))) && 
#line 4337 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8DFmode)
       || !register_operand (operands[1], V8DFmode)))))
        return gen_split_1980 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8DFmode)
      || !register_operand (operands[1], E_V8DFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2163 (insn, operands);
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_315 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DFmode)
       || !register_operand (operands[1], V4DFmode)))))
        return gen_split_1979 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2162 (insn, operands);
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SFmode)
      && reg_or_mem_operand (operands[1], E_V16SFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return gen_split_306 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))) && 
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SFmode)
       || !register_operand (operands[1], V16SFmode)))))
        return gen_split_1976 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SFmode)
      || !register_operand (operands[1], E_V16SFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2153 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SFmode)
      && reg_or_mem_operand (operands[1], E_V1SFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_302 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SFmode)
       || register_operand (operands[1], V1SFmode))) && 
#line 4329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SFmode)
       || !register_operand (operands[1], V1SFmode)))))
        return gen_split_1972 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SFmode)
      || !register_operand (operands[1], E_V1SFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2149 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HFmode)
      && reg_or_mem_operand (operands[1], E_V2HFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_291 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HFmode)
       || register_operand (operands[1], V2HFmode))) && 
#line 4325 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HFmode)
       || !register_operand (operands[1], V2HFmode)))))
        return gen_split_1968 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HFmode)
      || !register_operand (operands[1], E_V2HFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2138 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DImode)
      && reg_or_mem_operand (operands[1], E_V4DImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_282 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))) && 
#line 4321 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DImode)
       || !register_operand (operands[1], V4DImode)))))
        return gen_split_1964 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DImode)
      || !register_operand (operands[1], E_V4DImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2129 (insn, operands);
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SImode)
      && reg_or_mem_operand (operands[1], E_V8SImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return gen_split_272 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))) && 
#line 4317 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8SImode)
       || !register_operand (operands[1], V8SImode)))))
        return gen_split_1960 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8SImode)
      || !register_operand (operands[1], E_V8SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2119 (insn, operands);
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HImode)
      && reg_or_mem_operand (operands[1], E_V16HImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return gen_split_261 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HImode)
       || register_operand (operands[1], V16HImode))) && 
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16HImode)
       || !register_operand (operands[1], V16HImode)))))
        return gen_split_1956 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16HImode)
      || !register_operand (operands[1], E_V16HImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2108 (insn, operands);
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8QImode)
      && reg_or_mem_operand (operands[1], E_V8QImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return gen_split_247 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))) && 
#line 4307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8QImode)
       || !register_operand (operands[1], V8QImode)))))
        return gen_split_1950 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8QImode)
      || !register_operand (operands[1], E_V8QImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2094 (insn, operands);
}

 rtx_insn *
split_47 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4BImode)
      && reg_or_mem_operand (operands[1], E_V4BImode)
      && ((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))) && 
#line 4342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4BImode)
       || !register_operand (operands[1], V4BImode)))))
    return gen_split_1984 (insn, operands);
  if (!register_operand (operands[0], E_V4BImode)
      || !register_operand (operands[1], E_V4BImode)
      || !((
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2172 (insn, operands);
}

 rtx_insn *
split_53 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64DFmode)
      && reg_or_mem_operand (operands[1], E_V64DFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return gen_split_319 (insn, operands);
  if (!register_operand (operands[0], E_V64DFmode)
      || !register_operand (operands[1], E_V64DFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2166 (insn, operands);
}

 rtx_insn *
split_59 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64SFmode)
      && reg_or_mem_operand (operands[1], E_V64SFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return gen_split_308 (insn, operands);
  if (!register_operand (operands[0], E_V64SFmode)
      || !register_operand (operands[1], E_V64SFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2155 (insn, operands);
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128HFmode)
      && reg_or_mem_operand (operands[1], E_V128HFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return gen_split_297 (insn, operands);
  if (!register_operand (operands[0], E_V128HFmode)
      || !register_operand (operands[1], E_V128HFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2144 (insn, operands);
}

 rtx_insn *
split_71 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64DImode)
      && reg_or_mem_operand (operands[1], E_V64DImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return gen_split_286 (insn, operands);
  if (!register_operand (operands[0], E_V64DImode)
      || !register_operand (operands[1], E_V64DImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2133 (insn, operands);
}

 rtx_insn *
split_77 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64SImode)
      && reg_or_mem_operand (operands[1], E_V64SImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_275 (insn, operands);
  if (!register_operand (operands[0], E_V64SImode)
      || !register_operand (operands[1], E_V64SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2122 (insn, operands);
}

 rtx_insn *
split_84 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64HImode)
      && reg_or_mem_operand (operands[1], E_V64HImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_263 (insn, operands);
  if (!register_operand (operands[0], E_V64HImode)
      || !register_operand (operands[1], E_V64HImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2110 (insn, operands);
}

 rtx_insn *
split_91 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128QImode)
      && reg_or_mem_operand (operands[1], E_V128QImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_251 (insn, operands);
  if (!register_operand (operands[0], E_V128QImode)
      || !register_operand (operands[1], E_V128QImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2098 (insn, operands);
}

 rtx_insn *
split_98 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF16BImode)
      && 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_239 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF16BImode)
      || !register_operand (operands[1], E_RVVMF16BImode)
      || !(
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1576 (insn, operands);
}

 rtx_insn *
split_105 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2BFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2BFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
    return gen_split_220 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2BFmode)
      || !register_operand (operands[1], E_RVVMF2BFmode)
      || !((
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1568 (insn, operands);
}

 rtx_insn *
split_112 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern205 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM4QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10231 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10327 (insn, operands);

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM2QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10232 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10328 (insn, operands);

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM1QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10233 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10329 (insn, operands);

    case 3:
      if (vector_shift_operand (operands[2], E_RVVMF2QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10234 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10330 (insn, operands);

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF4QImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10235 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10331 (insn, operands);

    case 5:
      if (vector_shift_operand (operands[2], E_RVVMF8QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10236 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10332 (insn, operands);

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10237 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10333 (insn, operands);

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10238 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10334 (insn, operands);

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10239 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10335 (insn, operands);

    case 9:
      if (vector_shift_operand (operands[2], E_RVVMF2HImode)
          && (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10240 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10336 (insn, operands);

    case 10:
      if (vector_shift_operand (operands[2], E_RVVMF4HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10241 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10337 (insn, operands);

    case 11:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10242 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10338 (insn, operands);

    case 12:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10243 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10339 (insn, operands);

    case 13:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10244 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10340 (insn, operands);

    case 14:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10245 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10341 (insn, operands);

    case 15:
      if (vector_shift_operand (operands[2], E_V1QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10246 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10342 (insn, operands);

    case 16:
      if (vector_shift_operand (operands[2], E_V2QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10247 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10343 (insn, operands);

    case 17:
      if (vector_shift_operand (operands[2], E_V4QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10248 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10344 (insn, operands);

    case 18:
      if (vector_shift_operand (operands[2], E_V8QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10249 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10345 (insn, operands);

    case 19:
      if (vector_shift_operand (operands[2], E_V16QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10250 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10346 (insn, operands);

    case 20:
      if (vector_shift_operand (operands[2], E_V32QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10251 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10347 (insn, operands);

    case 21:
      if (vector_shift_operand (operands[2], E_V64QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10252 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10348 (insn, operands);

    case 22:
      if (vector_shift_operand (operands[2], E_V128QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10253 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10349 (insn, operands);

    case 23:
      if (vector_shift_operand (operands[2], E_V256QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10254 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10350 (insn, operands);

    case 24:
      if (vector_shift_operand (operands[2], E_V512QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10255 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10351 (insn, operands);

    case 25:
      if (vector_shift_operand (operands[2], E_V1024QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10256 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10352 (insn, operands);

    case 26:
      if (vector_shift_operand (operands[2], E_V2048QImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10257 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10353 (insn, operands);

    case 27:
      if (vector_shift_operand (operands[2], E_V1HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10258 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10354 (insn, operands);

    case 28:
      if (vector_shift_operand (operands[2], E_V2HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10259 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10355 (insn, operands);

    case 29:
      if (vector_shift_operand (operands[2], E_V4HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10260 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10356 (insn, operands);

    case 30:
      if (vector_shift_operand (operands[2], E_V8HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10261 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10357 (insn, operands);

    case 31:
      if (vector_shift_operand (operands[2], E_V16HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10262 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10358 (insn, operands);

    case 32:
      if (vector_shift_operand (operands[2], E_V32HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10263 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10359 (insn, operands);

    case 33:
      if (vector_shift_operand (operands[2], E_V64HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10264 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10360 (insn, operands);

    case 34:
      if (vector_shift_operand (operands[2], E_V128HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10265 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10361 (insn, operands);

    case 35:
      if (vector_shift_operand (operands[2], E_V256HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10266 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10362 (insn, operands);

    case 36:
      if (vector_shift_operand (operands[2], E_V512HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10267 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10363 (insn, operands);

    case 37:
      if (vector_shift_operand (operands[2], E_V1024HImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10268 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10364 (insn, operands);

    case 38:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10269 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10365 (insn, operands);

    case 39:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10270 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10366 (insn, operands);

    case 40:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10271 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10367 (insn, operands);

    case 41:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10272 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10368 (insn, operands);

    case 42:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10273 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10369 (insn, operands);

    case 43:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10274 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10370 (insn, operands);

    case 44:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10275 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10371 (insn, operands);

    case 45:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10276 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10372 (insn, operands);

    case 46:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10277 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10373 (insn, operands);

    case 47:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && ((
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10278 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10374 (insn, operands);

    case 48:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10279 (insn, operands);

    case 49:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10280 (insn, operands);

    case 50:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10281 (insn, operands);

    case 51:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10282 (insn, operands);

    case 52:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10283 (insn, operands);

    case 53:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10284 (insn, operands);

    case 54:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10285 (insn, operands);

    case 55:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10286 (insn, operands);

    case 56:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10287 (insn, operands);

    case 57:
      if (!(
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10288 (insn, operands);

    case 58:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10289 (insn, operands);

    case 59:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10290 (insn, operands);

    case 60:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10291 (insn, operands);

    case 61:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10292 (insn, operands);

    case 62:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10293 (insn, operands);

    case 63:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10294 (insn, operands);

    case 64:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10295 (insn, operands);

    case 65:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10296 (insn, operands);

    case 66:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10297 (insn, operands);

    case 67:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10298 (insn, operands);

    case 68:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10299 (insn, operands);

    case 69:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10300 (insn, operands);

    case 70:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10301 (insn, operands);

    case 71:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10302 (insn, operands);

    case 72:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10303 (insn, operands);

    case 73:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10304 (insn, operands);

    case 74:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10305 (insn, operands);

    case 75:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10306 (insn, operands);

    case 76:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10307 (insn, operands);

    case 77:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10308 (insn, operands);

    case 78:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10309 (insn, operands);

    case 79:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10310 (insn, operands);

    case 80:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10311 (insn, operands);

    case 81:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10312 (insn, operands);

    case 82:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10313 (insn, operands);

    case 83:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10314 (insn, operands);

    case 84:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10315 (insn, operands);

    case 85:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10316 (insn, operands);

    case 86:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10317 (insn, operands);

    case 87:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10318 (insn, operands);

    case 88:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10319 (insn, operands);

    case 89:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10320 (insn, operands);

    case 90:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10321 (insn, operands);

    case 91:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10322 (insn, operands);

    case 92:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10323 (insn, operands);

    case 93:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10324 (insn, operands);

    case 94:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10325 (insn, operands);

    case 95:
      if (!((
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10326 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_123 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern595 (x2))
    {
    case 0:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6595 (insn, operands);

    case 1:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6597 (insn, operands);

    case 2:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6599 (insn, operands);

    case 3:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6601 (insn, operands);

    case 4:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6603 (insn, operands);

    case 5:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6605 (insn, operands);

    case 6:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6607 (insn, operands);

    case 7:
      if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6691 (insn, operands);

    case 8:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6609 (insn, operands);

    case 9:
      if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6693 (insn, operands);

    case 10:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6611 (insn, operands);

    case 11:
      if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6695 (insn, operands);

    case 12:
      if (!(
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6613 (insn, operands);

    case 13:
      if (!(
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6697 (insn, operands);

    case 14:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6615 (insn, operands);

    case 15:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6699 (insn, operands);

    case 16:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6617 (insn, operands);

    case 17:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6701 (insn, operands);

    case 18:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6751 (insn, operands);

    case 19:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6619 (insn, operands);

    case 20:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6703 (insn, operands);

    case 21:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6753 (insn, operands);

    case 22:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6621 (insn, operands);

    case 23:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6705 (insn, operands);

    case 24:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6755 (insn, operands);

    case 25:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6623 (insn, operands);

    case 26:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6707 (insn, operands);

    case 27:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6757 (insn, operands);

    case 28:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6625 (insn, operands);

    case 29:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6627 (insn, operands);

    case 30:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6629 (insn, operands);

    case 31:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6631 (insn, operands);

    case 32:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6633 (insn, operands);

    case 33:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6635 (insn, operands);

    case 34:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6637 (insn, operands);

    case 35:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6639 (insn, operands);

    case 36:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6641 (insn, operands);

    case 37:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6643 (insn, operands);

    case 38:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6645 (insn, operands);

    case 39:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6647 (insn, operands);

    case 40:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6649 (insn, operands);

    case 41:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6709 (insn, operands);

    case 42:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6651 (insn, operands);

    case 43:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6711 (insn, operands);

    case 44:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6653 (insn, operands);

    case 45:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6713 (insn, operands);

    case 46:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6655 (insn, operands);

    case 47:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6715 (insn, operands);

    case 48:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6657 (insn, operands);

    case 49:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6717 (insn, operands);

    case 50:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6659 (insn, operands);

    case 51:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6719 (insn, operands);

    case 52:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6661 (insn, operands);

    case 53:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6721 (insn, operands);

    case 54:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6663 (insn, operands);

    case 55:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6723 (insn, operands);

    case 56:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6665 (insn, operands);

    case 57:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6725 (insn, operands);

    case 58:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6667 (insn, operands);

    case 59:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6727 (insn, operands);

    case 60:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6669 (insn, operands);

    case 61:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6729 (insn, operands);

    case 62:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6671 (insn, operands);

    case 63:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6731 (insn, operands);

    case 64:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6759 (insn, operands);

    case 65:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6673 (insn, operands);

    case 66:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6733 (insn, operands);

    case 67:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6761 (insn, operands);

    case 68:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6675 (insn, operands);

    case 69:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6735 (insn, operands);

    case 70:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6763 (insn, operands);

    case 71:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6677 (insn, operands);

    case 72:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6737 (insn, operands);

    case 73:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6765 (insn, operands);

    case 74:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6679 (insn, operands);

    case 75:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6739 (insn, operands);

    case 76:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6767 (insn, operands);

    case 77:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6681 (insn, operands);

    case 78:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6741 (insn, operands);

    case 79:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6769 (insn, operands);

    case 80:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6683 (insn, operands);

    case 81:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6743 (insn, operands);

    case 82:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6771 (insn, operands);

    case 83:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6685 (insn, operands);

    case 84:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6745 (insn, operands);

    case 85:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6773 (insn, operands);

    case 86:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6687 (insn, operands);

    case 87:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6747 (insn, operands);

    case 88:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6775 (insn, operands);

    case 89:
      if (!((
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6689 (insn, operands);

    case 90:
      if (!((
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6749 (insn, operands);

    case 91:
      if (!((
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6777 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_127 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_801 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_807 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_813 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_819 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_825 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_831 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_837 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_843 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_849 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_855 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_861 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_867 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_873 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_879 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_885 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_891 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_897 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_903 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_909 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_915 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_921 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_927 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_933 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_939 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_945 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_951 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_957 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_963 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_969 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_975 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_981 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_987 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_993 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_999 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1005 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1011 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1017 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1023 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1029 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1035 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1041 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1047 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1053 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1059 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1065 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1071 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1077 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1083 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1089 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1095 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1101 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1107 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1113 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1119 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1125 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1131 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1137 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1143 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1149 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1155 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1161 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1167 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1173 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1179 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1185 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1191 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1197 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1203 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1209 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1215 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1221 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1227 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1233 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1239 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1245 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1251 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1257 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1263 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1269 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1275 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1281 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1287 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1293 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1299 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1305 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1311 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1317 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1323 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1329 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1335 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1341 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1347 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1353 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1359 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1365 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1371 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1377 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1383 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1389 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1395 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1401 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1407 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1413 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1419 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1425 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1431 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1437 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1443 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1449 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1455 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1461 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1467 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1473 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1479 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1485 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1491 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1497 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1503 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1509 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1515 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1521 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1527 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_135 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5293 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5294 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5295 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5296 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5297 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5298 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5299 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5300 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5301 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5302 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5303 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5304 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5305 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5306 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5307 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5308 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5309 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5310 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5311 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5312 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5313 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5314 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5315 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5316 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5317 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5318 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5319 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5320 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5321 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5322 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5323 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5324 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5325 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5326 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4096QImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5327 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5328 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5329 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5330 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5331 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5332 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5333 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5334 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5335 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5336 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5337 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5338 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5339 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5340 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5341 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5342 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5343 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5344 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5345 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5346 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5347 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5348 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5349 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5350 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5351 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5352 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5353 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5354 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5355 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5356 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5357 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5358 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5359 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DImode) != 0
          || !((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5360 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5409 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5410 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5411 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5412 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5413 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5414 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5415 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5416 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5417 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5418 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5419 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5420 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5421 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5422 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5423 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5424 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5425 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5426 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5427 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5428 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5429 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5430 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5431 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5432 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5433 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5434 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5435 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5436 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5437 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5438 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5439 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5440 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5441 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5442 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5443 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5444 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5445 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5446 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5447 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5448 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5449 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5450 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5451 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5452 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5453 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5454 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5455 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DFmode) != 0
          || !((
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5456 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_144 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern160 (x2))
    {
    case 0:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7845 (insn, operands);

    case 1:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7849 (insn, operands);

    case 2:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7853 (insn, operands);

    case 3:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7857 (insn, operands);

    case 4:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7861 (insn, operands);

    case 5:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7865 (insn, operands);

    case 6:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7869 (insn, operands);

    case 7:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7873 (insn, operands);

    case 8:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7877 (insn, operands);

    case 9:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7881 (insn, operands);

    case 10:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7885 (insn, operands);

    case 11:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7889 (insn, operands);

    case 12:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7893 (insn, operands);

    case 13:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7897 (insn, operands);

    case 14:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7901 (insn, operands);

    case 15:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7905 (insn, operands);

    case 16:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7909 (insn, operands);

    case 17:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7913 (insn, operands);

    case 18:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7917 (insn, operands);

    case 19:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7921 (insn, operands);

    case 20:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7925 (insn, operands);

    case 21:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7929 (insn, operands);

    case 22:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7933 (insn, operands);

    case 23:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7937 (insn, operands);

    case 24:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7941 (insn, operands);

    case 25:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7945 (insn, operands);

    case 26:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7949 (insn, operands);

    case 27:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7953 (insn, operands);

    case 28:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7957 (insn, operands);

    case 29:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7961 (insn, operands);

    case 30:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7965 (insn, operands);

    case 31:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7969 (insn, operands);

    case 32:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7973 (insn, operands);

    case 33:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7977 (insn, operands);

    case 34:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7981 (insn, operands);

    case 35:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7985 (insn, operands);

    case 36:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7989 (insn, operands);

    case 37:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7993 (insn, operands);

    case 38:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7997 (insn, operands);

    case 39:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8001 (insn, operands);

    case 40:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8005 (insn, operands);

    case 41:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8009 (insn, operands);

    case 42:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8013 (insn, operands);

    case 43:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8017 (insn, operands);

    case 44:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8021 (insn, operands);

    case 45:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8025 (insn, operands);

    case 46:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8029 (insn, operands);

    case 47:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8033 (insn, operands);

    case 48:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7847 (insn, operands);

    case 49:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7851 (insn, operands);

    case 50:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7855 (insn, operands);

    case 51:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7859 (insn, operands);

    case 52:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7863 (insn, operands);

    case 53:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7867 (insn, operands);

    case 54:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7871 (insn, operands);

    case 55:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7875 (insn, operands);

    case 56:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7879 (insn, operands);

    case 57:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7883 (insn, operands);

    case 58:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7887 (insn, operands);

    case 59:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7891 (insn, operands);

    case 60:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7895 (insn, operands);

    case 61:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7899 (insn, operands);

    case 62:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7903 (insn, operands);

    case 63:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7907 (insn, operands);

    case 64:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7911 (insn, operands);

    case 65:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7915 (insn, operands);

    case 66:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7919 (insn, operands);

    case 67:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7923 (insn, operands);

    case 68:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7927 (insn, operands);

    case 69:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7931 (insn, operands);

    case 70:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7935 (insn, operands);

    case 71:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7939 (insn, operands);

    case 72:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7943 (insn, operands);

    case 73:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7947 (insn, operands);

    case 74:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7951 (insn, operands);

    case 75:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7955 (insn, operands);

    case 76:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7959 (insn, operands);

    case 77:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7963 (insn, operands);

    case 78:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7967 (insn, operands);

    case 79:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7971 (insn, operands);

    case 80:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7975 (insn, operands);

    case 81:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7979 (insn, operands);

    case 82:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7983 (insn, operands);

    case 83:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7987 (insn, operands);

    case 84:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7991 (insn, operands);

    case 85:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7995 (insn, operands);

    case 86:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7999 (insn, operands);

    case 87:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8003 (insn, operands);

    case 88:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8007 (insn, operands);

    case 89:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8011 (insn, operands);

    case 90:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8015 (insn, operands);

    case 91:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8019 (insn, operands);

    case 92:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8023 (insn, operands);

    case 93:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8027 (insn, operands);

    case 94:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8031 (insn, operands);

    case 95:
      if (!((
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8035 (insn, operands);

    case 96:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8037 (insn, operands);

    case 97:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8039 (insn, operands);

    case 98:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8041 (insn, operands);

    case 99:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8043 (insn, operands);

    case 100:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8045 (insn, operands);

    case 101:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8047 (insn, operands);

    case 102:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8049 (insn, operands);

    case 103:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8051 (insn, operands);

    case 104:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8053 (insn, operands);

    case 105:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8055 (insn, operands);

    case 106:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8057 (insn, operands);

    case 107:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8059 (insn, operands);

    case 108:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8061 (insn, operands);

    case 109:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8063 (insn, operands);

    case 110:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8065 (insn, operands);

    case 111:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8067 (insn, operands);

    case 112:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8069 (insn, operands);

    case 113:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8071 (insn, operands);

    case 114:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8073 (insn, operands);

    case 115:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8075 (insn, operands);

    case 116:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8077 (insn, operands);

    case 117:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8079 (insn, operands);

    case 118:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8081 (insn, operands);

    case 119:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8083 (insn, operands);

    case 120:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8085 (insn, operands);

    case 121:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8087 (insn, operands);

    case 122:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8089 (insn, operands);

    case 123:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8091 (insn, operands);

    case 124:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8093 (insn, operands);

    case 125:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8095 (insn, operands);

    case 126:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8097 (insn, operands);

    case 127:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8099 (insn, operands);

    case 128:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8101 (insn, operands);

    case 129:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8103 (insn, operands);

    case 130:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8105 (insn, operands);

    case 131:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8107 (insn, operands);

    case 132:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8109 (insn, operands);

    case 133:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8111 (insn, operands);

    case 134:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8113 (insn, operands);

    case 135:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8115 (insn, operands);

    case 136:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8117 (insn, operands);

    case 137:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8119 (insn, operands);

    case 138:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8121 (insn, operands);

    case 139:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8123 (insn, operands);

    case 140:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8125 (insn, operands);

    case 141:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8127 (insn, operands);

    case 142:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8129 (insn, operands);

    case 143:
      if (!((
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8131 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_154 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern117 (x2))
    {
    case 0:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2183 (insn, operands);

    case 1:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2184 (insn, operands);

    case 2:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2185 (insn, operands);

    case 3:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2186 (insn, operands);

    case 4:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2187 (insn, operands);

    case 5:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2188 (insn, operands);

    case 6:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2189 (insn, operands);

    case 7:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2190 (insn, operands);

    case 8:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2191 (insn, operands);

    case 9:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2192 (insn, operands);

    case 10:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2193 (insn, operands);

    case 11:
      if (!(
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2194 (insn, operands);

    case 12:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2195 (insn, operands);

    case 13:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2196 (insn, operands);

    case 14:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2197 (insn, operands);

    case 15:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2198 (insn, operands);

    case 16:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2199 (insn, operands);

    case 17:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2200 (insn, operands);

    case 18:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2201 (insn, operands);

    case 19:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2202 (insn, operands);

    case 20:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2203 (insn, operands);

    case 21:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2204 (insn, operands);

    case 22:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2205 (insn, operands);

    case 23:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2206 (insn, operands);

    case 24:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2207 (insn, operands);

    case 25:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2208 (insn, operands);

    case 26:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2209 (insn, operands);

    case 27:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2210 (insn, operands);

    case 28:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2211 (insn, operands);

    case 29:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2212 (insn, operands);

    case 30:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2213 (insn, operands);

    case 31:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2214 (insn, operands);

    case 32:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2215 (insn, operands);

    case 33:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2216 (insn, operands);

    case 34:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2217 (insn, operands);

    case 35:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2218 (insn, operands);

    case 36:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2219 (insn, operands);

    case 37:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2220 (insn, operands);

    case 38:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2221 (insn, operands);

    case 39:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2222 (insn, operands);

    case 40:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2223 (insn, operands);

    case 41:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2224 (insn, operands);

    case 42:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2225 (insn, operands);

    case 43:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2226 (insn, operands);

    case 44:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2227 (insn, operands);

    case 45:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2228 (insn, operands);

    case 46:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2229 (insn, operands);

    case 47:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2230 (insn, operands);

    case 48:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2231 (insn, operands);

    case 49:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2232 (insn, operands);

    case 50:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2233 (insn, operands);

    case 51:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2234 (insn, operands);

    case 52:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2235 (insn, operands);

    case 53:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2236 (insn, operands);

    case 54:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2237 (insn, operands);

    case 55:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2238 (insn, operands);

    case 56:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2239 (insn, operands);

    case 57:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2240 (insn, operands);

    case 58:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2241 (insn, operands);

    case 59:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2242 (insn, operands);

    case 60:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2243 (insn, operands);

    case 61:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2244 (insn, operands);

    case 62:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2245 (insn, operands);

    case 63:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2246 (insn, operands);

    case 64:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2247 (insn, operands);

    case 65:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2248 (insn, operands);

    case 66:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2249 (insn, operands);

    case 67:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2250 (insn, operands);

    case 68:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2251 (insn, operands);

    case 69:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2252 (insn, operands);

    case 70:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2253 (insn, operands);

    case 71:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2254 (insn, operands);

    case 72:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2255 (insn, operands);

    case 73:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2256 (insn, operands);

    case 74:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2257 (insn, operands);

    case 75:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2258 (insn, operands);

    case 76:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2259 (insn, operands);

    case 77:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2260 (insn, operands);

    case 78:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2261 (insn, operands);

    case 79:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2262 (insn, operands);

    case 80:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2263 (insn, operands);

    case 81:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2264 (insn, operands);

    case 82:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2265 (insn, operands);

    case 83:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2266 (insn, operands);

    case 84:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2267 (insn, operands);

    case 85:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2268 (insn, operands);

    case 86:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2269 (insn, operands);

    case 87:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2270 (insn, operands);

    case 88:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2271 (insn, operands);

    case 89:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2272 (insn, operands);

    case 90:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2273 (insn, operands);

    case 91:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2274 (insn, operands);

    case 92:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2275 (insn, operands);

    case 93:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2276 (insn, operands);

    case 94:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2277 (insn, operands);

    case 95:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2278 (insn, operands);

    case 96:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2279 (insn, operands);

    case 97:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2280 (insn, operands);

    case 98:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2281 (insn, operands);

    case 99:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2282 (insn, operands);

    case 100:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2283 (insn, operands);

    case 101:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2284 (insn, operands);

    case 102:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2285 (insn, operands);

    case 103:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2286 (insn, operands);

    case 104:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2287 (insn, operands);

    case 105:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2288 (insn, operands);

    case 106:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2289 (insn, operands);

    case 107:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2290 (insn, operands);

    case 108:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2291 (insn, operands);

    case 109:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2292 (insn, operands);

    case 110:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2293 (insn, operands);

    case 111:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2294 (insn, operands);

    case 112:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2295 (insn, operands);

    case 113:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2296 (insn, operands);

    case 114:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2297 (insn, operands);

    case 115:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2298 (insn, operands);

    case 116:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2299 (insn, operands);

    case 117:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2300 (insn, operands);

    case 118:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2301 (insn, operands);

    case 119:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2302 (insn, operands);

    case 120:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2303 (insn, operands);

    case 121:
      if (!((
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2304 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_165 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2599 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2613 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2627 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2641 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2655 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2669 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2683 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2697 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2711 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2725 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2739 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2753 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2767 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2781 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2795 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2809 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2823 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2837 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2851 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2865 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2879 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2893 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2907 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2921 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2935 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2949 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2963 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2977 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2991 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3005 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3019 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3033 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3047 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3061 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3075 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3089 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3103 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3117 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3131 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3145 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3159 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3173 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3187 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3201 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3215 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3229 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3243 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3257 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3271 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3285 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3299 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3313 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3327 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3341 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3355 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3369 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3383 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3397 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3411 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3425 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3439 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3453 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3467 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3481 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3495 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3509 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3523 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3537 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_170 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      return split_142 (x1, insn);

    case AND:
      switch (pattern201 (x2))
        {
        case 0:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10131 (insn, operands);

        case 1:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10134 (insn, operands);

        case 2:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10137 (insn, operands);

        case 3:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10140 (insn, operands);

        case 4:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10143 (insn, operands);

        case 5:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10146 (insn, operands);

        case 6:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10149 (insn, operands);

        case 7:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10152 (insn, operands);

        case 8:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10155 (insn, operands);

        case 9:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10158 (insn, operands);

        case 10:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10161 (insn, operands);

        case 11:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10164 (insn, operands);

        case 12:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10167 (insn, operands);

        case 13:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10170 (insn, operands);

        case 14:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10173 (insn, operands);

        case 15:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10176 (insn, operands);

        case 16:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10179 (insn, operands);

        case 17:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10182 (insn, operands);

        case 18:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10185 (insn, operands);

        case 19:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10188 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern201 (x2))
        {
        case 0:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10132 (insn, operands);

        case 1:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10135 (insn, operands);

        case 2:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10138 (insn, operands);

        case 3:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10141 (insn, operands);

        case 4:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10144 (insn, operands);

        case 5:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10147 (insn, operands);

        case 6:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10150 (insn, operands);

        case 7:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10153 (insn, operands);

        case 8:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10156 (insn, operands);

        case 9:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10159 (insn, operands);

        case 10:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10162 (insn, operands);

        case 11:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10165 (insn, operands);

        case 12:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10168 (insn, operands);

        case 13:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10171 (insn, operands);

        case 14:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10174 (insn, operands);

        case 15:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10177 (insn, operands);

        case 16:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10180 (insn, operands);

        case 17:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10183 (insn, operands);

        case 18:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10186 (insn, operands);

        case 19:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10189 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern201 (x2))
        {
        case 0:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10133 (insn, operands);

        case 1:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10136 (insn, operands);

        case 2:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10139 (insn, operands);

        case 3:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10142 (insn, operands);

        case 4:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10145 (insn, operands);

        case 5:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10148 (insn, operands);

        case 6:
          if (!(
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10151 (insn, operands);

        case 7:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10154 (insn, operands);

        case 8:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10157 (insn, operands);

        case 9:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10160 (insn, operands);

        case 10:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10163 (insn, operands);

        case 11:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10166 (insn, operands);

        case 12:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10169 (insn, operands);

        case 13:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10172 (insn, operands);

        case 14:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10175 (insn, operands);

        case 15:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10178 (insn, operands);

        case 16:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10181 (insn, operands);

        case 17:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10184 (insn, operands);

        case 18:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10187 (insn, operands);

        case 19:
          if (!((
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10190 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
