/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      return pattern145 (x1); /* [-1, 47] */

    case REG:
    case SUBREG:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern154 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode) != 0)
            return -1;
          return 96;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 97;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 98;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 101;

        case E_RVVM8SImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode) != 0)
            return -1;
          return 102;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 103;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 104;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 106;

        case E_RVVM8DImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode) != 0)
            return -1;
          return 107;

        case E_RVVM4DImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode) != 0)
            return -1;
          return 108;

        case E_RVVM2DImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode) != 0)
            return -1;
          return 109;

        case E_RVVM1DImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode) != 0)
            return -1;
          return 110;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1QImode, 
E_V1HImode) != 0)
            return -1;
          return 111;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2QImode, 
E_V2HImode) != 0)
            return -1;
          return 112;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4QImode, 
E_V4HImode) != 0)
            return -1;
          return 113;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 114;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16QImode, 
E_V16HImode) != 0)
            return -1;
          return 115;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32QImode, 
E_V32HImode) != 0)
            return -1;
          return 116;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64QImode, 
E_V64HImode) != 0)
            return -1;
          return 117;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128QImode, 
E_V128HImode) != 0)
            return -1;
          return 118;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256QImode, 
E_V256HImode) != 0)
            return -1;
          return 119;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512QImode, 
E_V512HImode) != 0)
            return -1;
          return 120;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024QImode, 
E_V1024HImode) != 0)
            return -1;
          return 121;

        case E_V2048HImode:
          if (pattern154 (x1, 
E_V2048QImode, 
E_V2048HImode) != 0)
            return -1;
          return 122;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1SImode) != 0)
            return -1;
          return 123;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2SImode) != 0)
            return -1;
          return 124;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 125;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 126;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16SImode) != 0)
            return -1;
          return 127;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32SImode) != 0)
            return -1;
          return 128;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64SImode) != 0)
            return -1;
          return 129;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128SImode) != 0)
            return -1;
          return 130;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256SImode) != 0)
            return -1;
          return 131;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512SImode) != 0)
            return -1;
          return 132;

        case E_V1024SImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024SImode) != 0)
            return -1;
          return 133;

        case E_V1DImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1DImode) != 0)
            return -1;
          return 134;

        case E_V2DImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 135;

        case E_V4DImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 136;

        case E_V8DImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 137;

        case E_V16DImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 138;

        case E_V32DImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 139;

        case E_V64DImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 140;

        case E_V128DImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128DImode) != 0)
            return -1;
          return 141;

        case E_V256DImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256DImode) != 0)
            return -1;
          return 142;

        case E_V512DImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern188 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 3;

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 6;

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      return 7;

    case E_RVVM1x2QImode:
      if (!register_operand (operands[3], E_RVVM1x2QImode))
        return -1;
      return 8;

    case E_RVVM1x3QImode:
      if (!register_operand (operands[3], E_RVVM1x3QImode))
        return -1;
      return 9;

    case E_RVVM1x4QImode:
      if (!register_operand (operands[3], E_RVVM1x4QImode))
        return -1;
      return 10;

    case E_RVVM1x5QImode:
      if (!register_operand (operands[3], E_RVVM1x5QImode))
        return -1;
      return 11;

    case E_RVVM1x6QImode:
      if (!register_operand (operands[3], E_RVVM1x6QImode))
        return -1;
      return 12;

    case E_RVVM1x7QImode:
      if (!register_operand (operands[3], E_RVVM1x7QImode))
        return -1;
      return 13;

    case E_RVVM1x8QImode:
      if (!register_operand (operands[3], E_RVVM1x8QImode))
        return -1;
      return 14;

    case E_RVVM2x2HImode:
      if (!register_operand (operands[3], E_RVVM2x2HImode))
        return -1;
      return 15;

    case E_RVVM2x3HImode:
      if (!register_operand (operands[3], E_RVVM2x3HImode))
        return -1;
      return 16;

    case E_RVVM2x4HImode:
      if (!register_operand (operands[3], E_RVVM2x4HImode))
        return -1;
      return 17;

    case E_RVVM4x2SImode:
      if (!register_operand (operands[3], E_RVVM4x2SImode))
        return -1;
      return 18;

    case E_RVVM2x2BFmode:
      if (!register_operand (operands[3], E_RVVM2x2BFmode))
        return -1;
      return 19;

    case E_RVVM2x3BFmode:
      if (!register_operand (operands[3], E_RVVM2x3BFmode))
        return -1;
      return 20;

    case E_RVVM2x4BFmode:
      if (!register_operand (operands[3], E_RVVM2x4BFmode))
        return -1;
      return 21;

    case E_RVVM2x2HFmode:
      if (!register_operand (operands[3], E_RVVM2x2HFmode))
        return -1;
      return 22;

    case E_RVVM2x3HFmode:
      if (!register_operand (operands[3], E_RVVM2x3HFmode))
        return -1;
      return 23;

    case E_RVVM2x4HFmode:
      if (!register_operand (operands[3], E_RVVM2x4HFmode))
        return -1;
      return 24;

    case E_RVVM4x2SFmode:
      if (!register_operand (operands[3], E_RVVM4x2SFmode))
        return -1;
      return 25;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern196 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern196 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern196 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern196 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern196 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern196 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern196 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern196 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern196 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern196 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern196 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern196 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern196 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern196 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern196 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern196 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern196 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern196 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern196 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern196 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern196 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern196 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern196 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern196 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern196 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern196 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern196 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern196 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern196 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern196 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern196 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern196 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern196 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern196 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern196 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern196 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern196 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern196 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern196 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern196 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern196 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern196 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern196 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern196 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern196 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern196 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern196 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern196 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern206 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern206 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern206 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern206 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern206 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern206 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern206 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern206 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern206 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern206 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern206 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern206 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern206 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern206 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern206 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern206 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern206 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern206 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern206 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern206 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern206 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern206 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern206 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern206 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern206 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern206 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern206 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern206 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern206 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern206 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern206 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern206 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern206 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern206 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern206 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern206 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern206 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern206 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern206 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern206 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern206 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern206 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern206 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern206 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern206 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern206 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern206 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern206 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern206 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern206 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern206 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern206 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern206 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern206 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern206 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern206 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern206 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern206 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern206 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern206 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern206 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern206 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern206 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern206 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern206 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern206 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern206 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern206 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern206 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern206 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern206 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern206 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern206 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern206 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern206 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern206 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern206 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern206 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern206 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern206 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern206 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern206 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern206 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern206 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern206 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern206 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern206 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern206 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern206 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern206 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern206 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern206 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern206 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern206 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern206 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern206 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern206 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern206 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern206 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern206 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern206 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern206 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern206 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern206 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern206 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern206 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern206 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern206 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern206 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern206 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern206 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern206 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern206 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern206 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern206 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern206 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern206 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern206 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern206 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern206 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern206 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern206 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern207 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern207 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern207 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern207 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern207 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern207 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern207 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern207 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern207 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern207 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern207 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern207 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern207 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern207 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern207 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern207 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern207 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern207 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern207 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern207 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern207 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern207 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern207 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern207 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern207 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern207 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern207 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern207 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern207 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern207 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern207 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern207 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern207 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern207 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern207 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern207 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern207 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern207 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern207 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern207 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern207 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern207 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern207 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern207 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern207 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern207 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern207 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern207 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern208 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern208 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern208 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern208 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern208 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern208 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern208 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern208 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern208 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern208 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern208 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern208 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern208 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern208 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern208 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern208 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern208 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern208 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern208 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern208 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern208 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern208 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern208 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern208 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern208 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern208 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern208 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern208 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern208 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern208 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern208 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern208 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern208 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern208 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern208 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern208 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern208 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern208 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern208 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern208 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern208 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern208 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern208 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern208 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern208 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern208 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern208 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern208 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern209 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern209 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern209 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern209 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern209 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern209 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern209 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern209 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern209 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern209 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern209 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern209 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern209 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern209 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern209 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern209 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern209 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern209 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern209 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern209 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern209 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern209 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern209 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern209 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern209 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern209 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern209 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern209 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern209 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern209 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern209 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern209 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern209 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern209 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern209 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern209 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern209 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern209 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern209 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern209 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern209 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern209 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern209 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern209 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern209 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern209 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern209 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern209 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern209 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern209 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern209 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern209 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern209 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern209 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern209 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern209 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern209 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern209 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern209 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern209 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern209 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern209 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern209 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern209 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern209 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern209 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern209 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern209 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern209 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern209 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern209 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern209 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern209 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern209 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern209 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern209 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern209 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern209 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern209 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern209 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern439 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern341 (x6); /* [-1, 3] */
}

int
pattern446 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[1], E_V1SImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 9;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 10;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 11;

    case E_V128SImode:
      if (!register_operand (operands[1], E_V128SImode))
        return -1;
      return 12;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 13;

    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 14;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 1);
  operands[6] = x9;
  if (!autovec_length_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern455 (x1, 
E_SImode); /* [-1, 19] */

    case E_DImode:
      res = pattern455 (x1, 
E_DImode);
      if (res >= 0)
        return res + 20; /* [20, 39] */
      return -1;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!branch_on_bit_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern464 (x1); /* [-1, 1] */
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3)
      || !vector_merge_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern473 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern473 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern473 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern473 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern473 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern473 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern473 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern473 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern473 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern473 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern473 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern473 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern473 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern473 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern473 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern473 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern473 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern473 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern473 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern473 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern473 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern473 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern473 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern473 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern473 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern473 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern473 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern473 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern473 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern473 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern473 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern473 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern473 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern473 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern473 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern473 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern473 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern473 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern473 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern473 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern473 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern473 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern473 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern473 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern473 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern473 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern473 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern473 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern473 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern473 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern473 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern473 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern473 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern473 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern473 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern473 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern473 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern473 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern473 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern473 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern473 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern473 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern473 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern473 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern473 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern473 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern473 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern473 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern473 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern473 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern473 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern473 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern473 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern473 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern473 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern473 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern473 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern473 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern473 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern473 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern473 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern473 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern473 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern473 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern473 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern473 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern473 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern473 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern473 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern473 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern473 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern473 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern473 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern473 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern473 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern473 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern473 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern473 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern473 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern473 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern473 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern473 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern473 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern473 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern473 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern473 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern473 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern473 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern473 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern473 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern473 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern473 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern473 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern473 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern473 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern473 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern473 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern473 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern473 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern473 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern473 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern473 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V256QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 0;

    case E_V256HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 1;

    case E_V256SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2048QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 0;

    case E_V2048HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern532 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          return pattern531 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern531 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern531 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern531 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern531 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern531 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SImode:
          if (pattern531 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (pattern531 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SImode:
          if (pattern531 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SImode:
          if (pattern531 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (pattern531 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DImode:
          if (pattern531 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DImode:
          if (pattern531 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DImode:
          if (pattern531 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DImode:
          if (pattern531 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HImode:
          if (pattern531 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HImode:
          if (pattern531 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HImode:
          if (pattern531 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern531 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern531 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HImode:
          if (pattern531 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HImode:
          if (pattern531 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HImode:
          if (pattern531 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HImode:
          if (pattern531 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HImode:
          if (pattern531 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HImode:
          if (pattern531 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HImode:
          if (pattern531 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SImode:
          if (pattern531 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SImode:
          if (pattern531 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SImode:
          if (pattern531 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SImode:
          if (pattern531 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SImode:
          if (pattern531 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SImode:
          if (pattern531 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SImode:
          if (pattern531 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SImode:
          if (pattern531 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SImode:
          if (pattern531 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SImode:
          if (pattern531 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SImode:
          if (pattern531 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DImode:
          if (pattern531 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DImode:
          if (pattern531 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DImode:
          if (pattern531 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DImode:
          if (pattern531 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DImode:
          if (pattern531 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DImode:
          if (pattern531 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DImode:
          if (pattern531 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DImode:
          if (pattern531 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DImode:
          if (pattern531 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DImode:
          if (pattern531 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern533 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
            return -1;
          return 48;

        case E_RVVM4HImode:
          if (pattern533 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
            return -1;
          return 49;

        case E_RVVM2HImode:
          if (pattern533 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
            return -1;
          return 50;

        case E_RVVM1HImode:
          if (pattern533 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HImode:
          if (pattern533 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HImode:
          if (pattern533 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
            return -1;
          return 53;

        case E_RVVM8SImode:
          if (pattern533 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
            return -1;
          return 54;

        case E_RVVM4SImode:
          if (pattern533 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
            return -1;
          return 55;

        case E_RVVM2SImode:
          if (pattern533 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
            return -1;
          return 56;

        case E_RVVM1SImode:
          if (pattern533 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SImode:
          if (pattern533 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
            return -1;
          return 58;

        case E_RVVM8DImode:
          if (pattern533 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
            return -1;
          return 59;

        case E_RVVM4DImode:
          if (pattern533 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
            return -1;
          return 60;

        case E_RVVM2DImode:
          if (pattern533 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
            return -1;
          return 61;

        case E_RVVM1DImode:
          if (pattern533 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
            return -1;
          return 62;

        case E_V1HImode:
          if (pattern533 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
            return -1;
          return 63;

        case E_V2HImode:
          if (pattern533 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
            return -1;
          return 64;

        case E_V4HImode:
          if (pattern533 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
            return -1;
          return 65;

        case E_V8HImode:
          if (pattern533 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
            return -1;
          return 66;

        case E_V16HImode:
          if (pattern533 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
            return -1;
          return 67;

        case E_V32HImode:
          if (pattern533 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
            return -1;
          return 68;

        case E_V64HImode:
          if (pattern533 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
            return -1;
          return 69;

        case E_V128HImode:
          if (pattern533 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
            return -1;
          return 70;

        case E_V256HImode:
          if (pattern533 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
            return -1;
          return 71;

        case E_V512HImode:
          if (pattern533 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
            return -1;
          return 72;

        case E_V1024HImode:
          if (pattern533 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
            return -1;
          return 73;

        case E_V2048HImode:
          if (pattern533 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
            return -1;
          return 74;

        case E_V1SImode:
          if (pattern533 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
            return -1;
          return 75;

        case E_V2SImode:
          if (pattern533 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
            return -1;
          return 76;

        case E_V4SImode:
          if (pattern533 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
            return -1;
          return 77;

        case E_V8SImode:
          if (pattern533 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
            return -1;
          return 78;

        case E_V16SImode:
          if (pattern533 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
            return -1;
          return 79;

        case E_V32SImode:
          if (pattern533 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
            return -1;
          return 80;

        case E_V64SImode:
          if (pattern533 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
            return -1;
          return 81;

        case E_V128SImode:
          if (pattern533 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
            return -1;
          return 82;

        case E_V256SImode:
          if (pattern533 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
            return -1;
          return 83;

        case E_V512SImode:
          if (pattern533 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
            return -1;
          return 84;

        case E_V1024SImode:
          if (pattern533 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
            return -1;
          return 85;

        case E_V1DImode:
          if (pattern533 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
            return -1;
          return 86;

        case E_V2DImode:
          if (pattern533 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
            return -1;
          return 87;

        case E_V4DImode:
          if (pattern533 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
            return -1;
          return 88;

        case E_V8DImode:
          if (pattern533 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
            return -1;
          return 89;

        case E_V16DImode:
          if (pattern533 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
            return -1;
          return 90;

        case E_V32DImode:
          if (pattern533 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
            return -1;
          return 91;

        case E_V64DImode:
          if (pattern533 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
            return -1;
          return 92;

        case E_V128DImode:
          if (pattern533 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
            return -1;
          return 93;

        case E_V256DImode:
          if (pattern533 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
            return -1;
          return 94;

        case E_V512DImode:
          if (pattern533 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  return pattern534 (x1); /* [-1, 95] */
}

int
pattern568 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i4
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!comparison_except_ge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern493 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern493 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern493 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern493 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern493 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern493 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern493 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern493 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern493 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern493 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern493 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern493 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern493 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern493 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern493 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern493 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern493 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern493 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern493 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern493 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern493 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern493 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern493 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern493 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern493 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern493 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern493 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern493 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern493 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern493 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern493 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern493 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern493 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern493 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern493 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern493 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern493 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern493 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern493 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern493 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern493 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern493 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern493 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern493 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern493 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern493 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern493 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern493 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_neg_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern606 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[4], E_RVVM2HFmode)
          || !register_operand (operands[5], E_RVVM2HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[4], E_RVVM4SFmode)
          || !register_operand (operands[5], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVM8DFmode:
      if (!register_operand (operands[4], E_RVVM8DFmode)
          || !register_operand (operands[5], E_RVVM8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[4], E_RVVMF2HFmode)
          || !register_operand (operands[5], E_RVVMF2HFmode))
        return -1;
      return 0;

    case E_RVVM1SFmode:
      if (!register_operand (operands[4], E_RVVM1SFmode)
          || !register_operand (operands[5], E_RVVM1SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[4], E_RVVM2DFmode)
          || !register_operand (operands[5], E_RVVM2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[4], E_V2HFmode)
          || !register_operand (operands[5], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[4], E_V2SFmode)
          || !register_operand (operands[5], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[4], E_V2DFmode)
          || !register_operand (operands[5], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || !register_operand (operands[5], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || !register_operand (operands[5], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || !register_operand (operands[5], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || !register_operand (operands[5], E_V128HFmode))
        return -1;
      return 0;

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || !register_operand (operands[5], E_V128SFmode))
        return -1;
      return 1;

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || !register_operand (operands[5], E_V128DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i3))
    return -1;
  x10 = XEXP (x1, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode)
          || !vector_arith_operand (operands[2], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode)
          || !vector_arith_operand (operands[2], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !vector_arith_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !vector_arith_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !vector_arith_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !vector_arith_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode)
          || !register_operand (operands[2], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode)
          || !register_operand (operands[2], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[2], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew16_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern645 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i3)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern659 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern663 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern675 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_RVVM1DImode
      || !register_operand (operands[4], E_RVVM1DImode)
      || !vector_merge_operand (operands[2], E_RVVM1DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      return 4;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 5;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      return 6;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      return 7;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      return 8;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      return 9;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      return 10;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      return 11;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      return 12;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern684 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern695 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern704 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i4))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern717 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew16_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern721 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern725 (x5, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern728 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern542 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern542 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern542 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern542 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern542 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern542 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern542 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern542 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern542 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern542 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern542 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern542 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern542 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern542 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern542 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern729 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern671 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4HImode
          || !vector_merge_operand (operands[2], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2HImode
          || !vector_merge_operand (operands[2], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1HImode
          || !vector_merge_operand (operands[2], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2HImode
          || !vector_merge_operand (operands[2], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF4HImode
          || !vector_merge_operand (operands[2], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1HImode
          || !vector_merge_operand (operands[2], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2HImode
          || !vector_merge_operand (operands[2], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !vector_merge_operand (operands[2], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8HImode
          || !vector_merge_operand (operands[2], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16HImode
          || !vector_merge_operand (operands[2], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32HImode
          || !vector_merge_operand (operands[2], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64HImode
          || !vector_merge_operand (operands[2], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128HImode
          || !vector_merge_operand (operands[2], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256HImode
          || !vector_merge_operand (operands[2], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512HImode
          || !vector_merge_operand (operands[2], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024HImode
          || !vector_merge_operand (operands[2], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern671 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern671 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern671 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern671 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern671 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern671 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern671 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern671 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern671 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern671 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern671 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern671 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern671 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern671 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern671 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern671 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern671 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern671 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern671 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 23:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2186 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 179; /* lrintsfsi2_sext */

            case 1:
              if (!(
#line 2186 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 180; /* lrintdfsi2_sext */

            case 2:
              if (!(
#line 2186 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 181; /* lrinthfsi2_sext */

            default:
              return -1;
            }

        case 17:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 203; /* lroundsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 209; /* lrounddfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 215; /* lroundhfsi2_sext */

            default:
              return -1;
            }

        case 18:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 204; /* lfloorsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 210; /* lfloordfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 216; /* lfloorhfsi2_sext */

            default:
              return -1;
            }

        case 19:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 205; /* lceilsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 211; /* lceildfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 217; /* lceilhfsi2_sext */

            default:
              return -1;
            }

        case 20:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 206; /* lbtruncsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 212; /* lbtruncdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 218; /* lbtrunchfsi2_sext */

            default:
              return -1;
            }

        case 21:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 207; /* lroundevensfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 213; /* lroundevendfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 219; /* lroundevenhfsi2_sext */

            default:
              return -1;
            }

        case 22:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 208; /* lnearbyintsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 214; /* lnearbyintdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 220; /* lnearbyinthfsi2_sext */

            default:
              return -1;
            }

        case 62:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 698; /* riscv_sha256sig0_di_extended */

        case 63:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 699; /* riscv_sha256sig1_di_extended */

        case 64:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 700; /* riscv_sha256sum0_di_extended */

        case 65:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 701; /* riscv_sha256sum1_di_extended */

        case 76:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 714; /* riscv_sm3p0_di_extended */

        case 77:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 715; /* riscv_sm3p1_di_extended */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_3_operand (operands[3], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 78:
          if (!
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 718; /* riscv_sm4ed_di_extended */

        case 79:
          if (!
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 719; /* riscv_sm4ks_di_extended */

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_SImode) != 0)
        return -1;
      if ((
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 907; /* *th_mulssi */
      if (
#line 373 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
        return 910; /* *th_mulswsi2 */
      if (!
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
        return -1;
      return 33906; /* riscv_cv_mac_msu */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_DImode) != 0
          || !(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 908; /* *th_mulsdi */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8QImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27247; /* fnmarvvm8qi4 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4QImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27248; /* fnmarvvm4qi4 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2QImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27249; /* fnmarvvm2qi4 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1QImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27250; /* fnmarvvm1qi4 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27251; /* fnmarvvm8hi4 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27252; /* fnmarvvm4hi4 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27253; /* fnmarvvm2hi4 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27254; /* fnmarvvm1hi4 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27255; /* fnmarvvm8si4 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27256; /* fnmarvvm4si4 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27257; /* fnmarvvm2si4 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SImode) != 0
          || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27258; /* fnmarvvm1si4 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27259; /* fnmarvvm8di4 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27260; /* fnmarvvm4di4 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27261; /* fnmarvvm2di4 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27262; /* fnmarvvm1di4 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27263; /* fnmarvvmf2qi4 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27264; /* fnmarvvmf4qi4 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27265; /* fnmarvvmf8qi4 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27266; /* fnmarvvmf2hi4 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27267; /* fnmarvvmf4hi4 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27268; /* fnmarvvmf2si4 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27269; /* fnmav1qi4 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27270; /* fnmav2qi4 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27271; /* fnmav4qi4 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27272; /* fnmav8qi4 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27273; /* fnmav16qi4 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27274; /* fnmav32qi4 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27275; /* fnmav64qi4 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27276; /* fnmav128qi4 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27277; /* fnmav256qi4 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27278; /* fnmav512qi4 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27279; /* fnmav1024qi4 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27280; /* fnmav2048qi4 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4096QImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27281; /* fnmav4096qi4 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27282; /* fnmav1hi4 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27283; /* fnmav2hi4 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27284; /* fnmav4hi4 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27285; /* fnmav8hi4 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27286; /* fnmav16hi4 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27287; /* fnmav32hi4 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27288; /* fnmav64hi4 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27289; /* fnmav128hi4 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27290; /* fnmav256hi4 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27291; /* fnmav512hi4 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27292; /* fnmav1024hi4 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27293; /* fnmav2048hi4 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27294; /* fnmav1si4 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27295; /* fnmav2si4 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27296; /* fnmav4si4 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27297; /* fnmav8si4 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27298; /* fnmav16si4 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27299; /* fnmav32si4 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27300; /* fnmav64si4 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27301; /* fnmav128si4 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27302; /* fnmav256si4 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27303; /* fnmav512si4 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27304; /* fnmav1024si4 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27305; /* fnmav1di4 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27306; /* fnmav2di4 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27307; /* fnmav4di4 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27308; /* fnmav8di4 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27309; /* fnmav16di4 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27310; /* fnmav32di4 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27311; /* fnmav64di4 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27312; /* fnmav128di4 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27313; /* fnmav256di4 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DImode) != 0
          || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27314; /* fnmav512di4 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27363; /* fnmarvvm8hf4 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27364; /* fnmarvvm4hf4 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27365; /* fnmarvvm2hf4 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27366; /* fnmarvvm1hf4 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27367; /* fnmarvvmf2hf4 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27368; /* fnmarvvmf4hf4 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27369; /* fnmarvvm8sf4 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27370; /* fnmarvvm4sf4 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27371; /* fnmarvvm2sf4 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27372; /* fnmarvvm1sf4 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27373; /* fnmarvvmf2sf4 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27374; /* fnmarvvm8df4 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27375; /* fnmarvvm4df4 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27376; /* fnmarvvm2df4 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27377; /* fnmarvvm1df4 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27378; /* fnmav1hf4 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27379; /* fnmav2hf4 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27380; /* fnmav4hf4 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27381; /* fnmav8hf4 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27382; /* fnmav16hf4 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27383; /* fnmav32hf4 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27384; /* fnmav64hf4 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27385; /* fnmav128hf4 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27386; /* fnmav256hf4 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27387; /* fnmav512hf4 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27388; /* fnmav1024hf4 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27389; /* fnmav2048hf4 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27390; /* fnmav1sf4 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27391; /* fnmav2sf4 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27392; /* fnmav4sf4 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27393; /* fnmav8sf4 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27394; /* fnmav16sf4 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27395; /* fnmav32sf4 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27396; /* fnmav64sf4 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27397; /* fnmav128sf4 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27398; /* fnmav256sf4 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27399; /* fnmav512sf4 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27400; /* fnmav1024sf4 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27401; /* fnmav1df4 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27402; /* fnmav2df4 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27403; /* fnmav4df4 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27404; /* fnmav8df4 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27405; /* fnmav16df4 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27406; /* fnmav32df4 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27407; /* fnmav64df4 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27408; /* fnmav128df4 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27409; /* fnmav256df4 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DFmode) != 0
          || !(
#line 1244 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27410; /* fnmav512df4 */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern160 (x2))
    {
    case 0:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29858; /* *narrow_ashrextendrvvm8hi */

    case 1:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29862; /* *narrow_ashrextendrvvm4hi */

    case 2:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29866; /* *narrow_ashrextendrvvm2hi */

    case 3:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29870; /* *narrow_ashrextendrvvm1hi */

    case 4:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29874; /* *narrow_ashrextendrvvmf2hi */

    case 5:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29878; /* *narrow_ashrextendrvvmf4hi */

    case 6:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29882; /* *narrow_ashrextendrvvm8si */

    case 7:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29886; /* *narrow_ashrextendrvvm4si */

    case 8:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29890; /* *narrow_ashrextendrvvm2si */

    case 9:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29894; /* *narrow_ashrextendrvvm1si */

    case 10:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29898; /* *narrow_ashrextendrvvmf2si */

    case 11:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29902; /* *narrow_ashrextendrvvm8di */

    case 12:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29906; /* *narrow_ashrextendrvvm4di */

    case 13:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29910; /* *narrow_ashrextendrvvm2di */

    case 14:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29914; /* *narrow_ashrextendrvvm1di */

    case 15:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29918; /* *narrow_ashrextendv1hi */

    case 16:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29922; /* *narrow_ashrextendv2hi */

    case 17:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29926; /* *narrow_ashrextendv4hi */

    case 18:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29930; /* *narrow_ashrextendv8hi */

    case 19:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29934; /* *narrow_ashrextendv16hi */

    case 20:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29938; /* *narrow_ashrextendv32hi */

    case 21:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29942; /* *narrow_ashrextendv64hi */

    case 22:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29946; /* *narrow_ashrextendv128hi */

    case 23:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29950; /* *narrow_ashrextendv256hi */

    case 24:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29954; /* *narrow_ashrextendv512hi */

    case 25:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29958; /* *narrow_ashrextendv1024hi */

    case 26:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29962; /* *narrow_ashrextendv2048hi */

    case 27:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29966; /* *narrow_ashrextendv1si */

    case 28:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29970; /* *narrow_ashrextendv2si */

    case 29:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29974; /* *narrow_ashrextendv4si */

    case 30:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29978; /* *narrow_ashrextendv8si */

    case 31:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29982; /* *narrow_ashrextendv16si */

    case 32:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29986; /* *narrow_ashrextendv32si */

    case 33:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29990; /* *narrow_ashrextendv64si */

    case 34:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29994; /* *narrow_ashrextendv128si */

    case 35:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29998; /* *narrow_ashrextendv256si */

    case 36:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30002; /* *narrow_ashrextendv512si */

    case 37:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30006; /* *narrow_ashrextendv1024si */

    case 38:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30010; /* *narrow_ashrextendv1di */

    case 39:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30014; /* *narrow_ashrextendv2di */

    case 40:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30018; /* *narrow_ashrextendv4di */

    case 41:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30022; /* *narrow_ashrextendv8di */

    case 42:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30026; /* *narrow_ashrextendv16di */

    case 43:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30030; /* *narrow_ashrextendv32di */

    case 44:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30034; /* *narrow_ashrextendv64di */

    case 45:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30038; /* *narrow_ashrextendv128di */

    case 46:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30042; /* *narrow_ashrextendv256di */

    case 47:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30046; /* *narrow_ashrextendv512di */

    case 48:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29860; /* *narrow_ashrzero_extendrvvm8hi */

    case 49:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29864; /* *narrow_ashrzero_extendrvvm4hi */

    case 50:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29868; /* *narrow_ashrzero_extendrvvm2hi */

    case 51:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29872; /* *narrow_ashrzero_extendrvvm1hi */

    case 52:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29876; /* *narrow_ashrzero_extendrvvmf2hi */

    case 53:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29880; /* *narrow_ashrzero_extendrvvmf4hi */

    case 54:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29884; /* *narrow_ashrzero_extendrvvm8si */

    case 55:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29888; /* *narrow_ashrzero_extendrvvm4si */

    case 56:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29892; /* *narrow_ashrzero_extendrvvm2si */

    case 57:
      if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29896; /* *narrow_ashrzero_extendrvvm1si */

    case 58:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29900; /* *narrow_ashrzero_extendrvvmf2si */

    case 59:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29904; /* *narrow_ashrzero_extendrvvm8di */

    case 60:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29908; /* *narrow_ashrzero_extendrvvm4di */

    case 61:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29912; /* *narrow_ashrzero_extendrvvm2di */

    case 62:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29916; /* *narrow_ashrzero_extendrvvm1di */

    case 63:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29920; /* *narrow_ashrzero_extendv1hi */

    case 64:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29924; /* *narrow_ashrzero_extendv2hi */

    case 65:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29928; /* *narrow_ashrzero_extendv4hi */

    case 66:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29932; /* *narrow_ashrzero_extendv8hi */

    case 67:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29936; /* *narrow_ashrzero_extendv16hi */

    case 68:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29940; /* *narrow_ashrzero_extendv32hi */

    case 69:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29944; /* *narrow_ashrzero_extendv64hi */

    case 70:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29948; /* *narrow_ashrzero_extendv128hi */

    case 71:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29952; /* *narrow_ashrzero_extendv256hi */

    case 72:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29956; /* *narrow_ashrzero_extendv512hi */

    case 73:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29960; /* *narrow_ashrzero_extendv1024hi */

    case 74:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29964; /* *narrow_ashrzero_extendv2048hi */

    case 75:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29968; /* *narrow_ashrzero_extendv1si */

    case 76:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29972; /* *narrow_ashrzero_extendv2si */

    case 77:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29976; /* *narrow_ashrzero_extendv4si */

    case 78:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29980; /* *narrow_ashrzero_extendv8si */

    case 79:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29984; /* *narrow_ashrzero_extendv16si */

    case 80:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29988; /* *narrow_ashrzero_extendv32si */

    case 81:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29992; /* *narrow_ashrzero_extendv64si */

    case 82:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29996; /* *narrow_ashrzero_extendv128si */

    case 83:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30000; /* *narrow_ashrzero_extendv256si */

    case 84:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30004; /* *narrow_ashrzero_extendv512si */

    case 85:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30008; /* *narrow_ashrzero_extendv1024si */

    case 86:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30012; /* *narrow_ashrzero_extendv1di */

    case 87:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30016; /* *narrow_ashrzero_extendv2di */

    case 88:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30020; /* *narrow_ashrzero_extendv4di */

    case 89:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30024; /* *narrow_ashrzero_extendv8di */

    case 90:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30028; /* *narrow_ashrzero_extendv16di */

    case 91:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30032; /* *narrow_ashrzero_extendv32di */

    case 92:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30036; /* *narrow_ashrzero_extendv64di */

    case 93:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30040; /* *narrow_ashrzero_extendv128di */

    case 94:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30044; /* *narrow_ashrzero_extendv256di */

    case 95:
      if (!(
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30048; /* *narrow_ashrzero_extendv512di */

    case 96:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30050; /* *narrow_ashrrvvm8hi_scalar */

    case 97:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30052; /* *narrow_ashrrvvm4hi_scalar */

    case 98:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30054; /* *narrow_ashrrvvm2hi_scalar */

    case 99:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30056; /* *narrow_ashrrvvm1hi_scalar */

    case 100:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30058; /* *narrow_ashrrvvmf2hi_scalar */

    case 101:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30060; /* *narrow_ashrrvvmf4hi_scalar */

    case 102:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30062; /* *narrow_ashrrvvm8si_scalar */

    case 103:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30064; /* *narrow_ashrrvvm4si_scalar */

    case 104:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30066; /* *narrow_ashrrvvm2si_scalar */

    case 105:
      if (!
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30068; /* *narrow_ashrrvvm1si_scalar */

    case 106:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30070; /* *narrow_ashrrvvmf2si_scalar */

    case 107:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30072; /* *narrow_ashrrvvm8di_scalar */

    case 108:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30074; /* *narrow_ashrrvvm4di_scalar */

    case 109:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30076; /* *narrow_ashrrvvm2di_scalar */

    case 110:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30078; /* *narrow_ashrrvvm1di_scalar */

    case 111:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30080; /* *narrow_ashrv1hi_scalar */

    case 112:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30082; /* *narrow_ashrv2hi_scalar */

    case 113:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30084; /* *narrow_ashrv4hi_scalar */

    case 114:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30086; /* *narrow_ashrv8hi_scalar */

    case 115:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30088; /* *narrow_ashrv16hi_scalar */

    case 116:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30090; /* *narrow_ashrv32hi_scalar */

    case 117:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30092; /* *narrow_ashrv64hi_scalar */

    case 118:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30094; /* *narrow_ashrv128hi_scalar */

    case 119:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30096; /* *narrow_ashrv256hi_scalar */

    case 120:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30098; /* *narrow_ashrv512hi_scalar */

    case 121:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30100; /* *narrow_ashrv1024hi_scalar */

    case 122:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30102; /* *narrow_ashrv2048hi_scalar */

    case 123:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30104; /* *narrow_ashrv1si_scalar */

    case 124:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30106; /* *narrow_ashrv2si_scalar */

    case 125:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30108; /* *narrow_ashrv4si_scalar */

    case 126:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30110; /* *narrow_ashrv8si_scalar */

    case 127:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30112; /* *narrow_ashrv16si_scalar */

    case 128:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30114; /* *narrow_ashrv32si_scalar */

    case 129:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30116; /* *narrow_ashrv64si_scalar */

    case 130:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30118; /* *narrow_ashrv128si_scalar */

    case 131:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30120; /* *narrow_ashrv256si_scalar */

    case 132:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30122; /* *narrow_ashrv512si_scalar */

    case 133:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30124; /* *narrow_ashrv1024si_scalar */

    case 134:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30126; /* *narrow_ashrv1di_scalar */

    case 135:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30128; /* *narrow_ashrv2di_scalar */

    case 136:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30130; /* *narrow_ashrv4di_scalar */

    case 137:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30132; /* *narrow_ashrv8di_scalar */

    case 138:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30134; /* *narrow_ashrv16di_scalar */

    case 139:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30136; /* *narrow_ashrv32di_scalar */

    case 140:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30138; /* *narrow_ashrv64di_scalar */

    case 141:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30140; /* *narrow_ashrv128di_scalar */

    case 142:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30142; /* *narrow_ashrv256di_scalar */

    case 143:
      if (!(
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30144; /* *narrow_ashrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (pattern168 (x3, 
E_SFmode) != 0
          || !
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 81; /* copysignsf3 */

    case E_DFmode:
      if (pattern168 (x3, 
E_DFmode) != 0
          || !(
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 82; /* copysigndf3 */

    case E_HFmode:
      if (pattern168 (x3, 
E_HFmode) != 0
          || !(
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 83; /* copysignhf3 */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern388 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 477; /* stack_protect_test_si */

    case E_DImode:
      if (pattern388 (x3, 
E_DImode) != 0
          || !
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 478; /* stack_protect_test_di */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern176 ())
        {
        case 0:
          if (!(
#line 3585 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3585 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3585 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern176 ())
        {
        case 0:
          if (!(
#line 3585 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3585 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3585 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !register_operand (operands[3], E_RVVMF4BImode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_RVVMF4BImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x4))
    {
    case E_RVVM2QImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8691; /* pred_madcrvvm2qi_scalar */

    case E_RVVM4HImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8697; /* pred_madcrvvm4hi_scalar */

    case E_RVVM8SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM8SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8702; /* pred_madcrvvm8si_scalar */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18129; /* pred_redminrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18137; /* pred_redminrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18145; /* pred_redminrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18153; /* pred_redminrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18257; /* pred_redminrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18265; /* pred_redminrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18273; /* pred_redminrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18305; /* pred_redminv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18313; /* pred_redminv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18321; /* pred_redminv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18329; /* pred_redminv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18337; /* pred_redminv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18345; /* pred_redminv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18353; /* pred_redminv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18361; /* pred_redminv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18369; /* pred_redminv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18377; /* pred_redminv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18385; /* pred_redminv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18393; /* pred_redminv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18401; /* pred_redminv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18161; /* pred_redminrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18169; /* pred_redminrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18177; /* pred_redminrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18185; /* pred_redminrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18281; /* pred_redminrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18289; /* pred_redminrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18409; /* pred_redminv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18417; /* pred_redminv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18425; /* pred_redminv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18433; /* pred_redminv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18441; /* pred_redminv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18449; /* pred_redminv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18457; /* pred_redminv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18465; /* pred_redminv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18473; /* pred_redminv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18481; /* pred_redminv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18489; /* pred_redminv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18497; /* pred_redminv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18193; /* pred_redminrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18201; /* pred_redminrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18209; /* pred_redminrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18217; /* pred_redminrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18297; /* pred_redminrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18505; /* pred_redminv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18513; /* pred_redminv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18521; /* pred_redminv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18529; /* pred_redminv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18537; /* pred_redminv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18545; /* pred_redminv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18553; /* pred_redminv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18561; /* pred_redminv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18569; /* pred_redminv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18577; /* pred_redminv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18585; /* pred_redminv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18225; /* pred_redminrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18233; /* pred_redminrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18241; /* pred_redminrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18249; /* pred_redminrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18593; /* pred_redminv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18601; /* pred_redminv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18609; /* pred_redminv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18617; /* pred_redminv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18625; /* pred_redminv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18633; /* pred_redminv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18641; /* pred_redminv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18649; /* pred_redminv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18657; /* pred_redminv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18665; /* pred_redminv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19430; /* pred_redminrvvm8hf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19432; /* pred_redminrvvm4hf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19434; /* pred_redminrvvm2hf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19436; /* pred_redminrvvm1hf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19438; /* pred_redminrvvmf2hf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19440; /* pred_redminrvvmf4hf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19460; /* pred_redminv1hf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19462; /* pred_redminv2hf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19464; /* pred_redminv4hf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19466; /* pred_redminv8hf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19468; /* pred_redminv16hf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19470; /* pred_redminv32hf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19472; /* pred_redminv64hf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19474; /* pred_redminv128hf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19476; /* pred_redminv256hf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19478; /* pred_redminv512hf */

        case 16:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19480; /* pred_redminv1024hf */

        case 17:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19482; /* pred_redminv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19442; /* pred_redminrvvm8sf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19444; /* pred_redminrvvm4sf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19446; /* pred_redminrvvm2sf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19448; /* pred_redminrvvm1sf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19450; /* pred_redminrvvmf2sf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19484; /* pred_redminv1sf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19486; /* pred_redminv2sf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19488; /* pred_redminv4sf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19490; /* pred_redminv8sf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19492; /* pred_redminv16sf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19494; /* pred_redminv32sf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19496; /* pred_redminv64sf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19498; /* pred_redminv128sf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19500; /* pred_redminv256sf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19502; /* pred_redminv512sf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19504; /* pred_redminv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19452; /* pred_redminrvvm8df */

        case 1:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19454; /* pred_redminrvvm4df */

        case 2:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19456; /* pred_redminrvvm2df */

        case 3:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19458; /* pred_redminrvvm1df */

        case 4:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19506; /* pred_redminv1df */

        case 5:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19508; /* pred_redminv2df */

        case 6:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19510; /* pred_redminv4df */

        case 7:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19512; /* pred_redminv8df */

        case 8:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19514; /* pred_redminv16df */

        case 9:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19516; /* pred_redminv32df */

        case 10:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19518; /* pred_redminv64df */

        case 11:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19520; /* pred_redminv128df */

        case 12:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19522; /* pred_redminv256df */

        case 13:
          if (!(
#line 7867 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19524; /* pred_redminv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18130; /* pred_redandrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18138; /* pred_redandrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18146; /* pred_redandrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18154; /* pred_redandrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18258; /* pred_redandrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18266; /* pred_redandrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18274; /* pred_redandrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18306; /* pred_redandv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18314; /* pred_redandv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18322; /* pred_redandv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18330; /* pred_redandv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18338; /* pred_redandv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18346; /* pred_redandv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18354; /* pred_redandv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18362; /* pred_redandv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18370; /* pred_redandv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18378; /* pred_redandv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18386; /* pred_redandv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18394; /* pred_redandv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18402; /* pred_redandv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18162; /* pred_redandrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18170; /* pred_redandrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18178; /* pred_redandrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18186; /* pred_redandrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18282; /* pred_redandrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18290; /* pred_redandrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18410; /* pred_redandv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18418; /* pred_redandv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18426; /* pred_redandv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18434; /* pred_redandv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18442; /* pred_redandv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18450; /* pred_redandv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18458; /* pred_redandv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18466; /* pred_redandv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18474; /* pred_redandv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18482; /* pred_redandv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18490; /* pred_redandv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18498; /* pred_redandv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18194; /* pred_redandrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18202; /* pred_redandrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18210; /* pred_redandrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18218; /* pred_redandrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18298; /* pred_redandrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18506; /* pred_redandv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18514; /* pred_redandv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18522; /* pred_redandv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18530; /* pred_redandv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18538; /* pred_redandv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18546; /* pred_redandv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18554; /* pred_redandv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18562; /* pred_redandv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18570; /* pred_redandv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18578; /* pred_redandv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18586; /* pred_redandv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18226; /* pred_redandrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18234; /* pred_redandrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18242; /* pred_redandrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18250; /* pred_redandrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18594; /* pred_redandv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18602; /* pred_redandv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18610; /* pred_redandv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18618; /* pred_redandv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18626; /* pred_redandv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18634; /* pred_redandv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18642; /* pred_redandv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18650; /* pred_redandv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18658; /* pred_redandv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18666; /* pred_redandv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19621; /* pred_redosumrvvm8hf */

        case 1:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19623; /* pred_redosumrvvm4hf */

        case 2:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19625; /* pred_redosumrvvm2hf */

        case 3:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19627; /* pred_redosumrvvm1hf */

        case 4:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19629; /* pred_redosumrvvmf2hf */

        case 5:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19631; /* pred_redosumrvvmf4hf */

        case 6:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19651; /* pred_redosumv1hf */

        case 7:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19653; /* pred_redosumv2hf */

        case 8:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19655; /* pred_redosumv4hf */

        case 9:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19657; /* pred_redosumv8hf */

        case 10:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19659; /* pred_redosumv16hf */

        case 11:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19661; /* pred_redosumv32hf */

        case 12:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19663; /* pred_redosumv64hf */

        case 13:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19665; /* pred_redosumv128hf */

        case 14:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19667; /* pred_redosumv256hf */

        case 15:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19669; /* pred_redosumv512hf */

        case 16:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19671; /* pred_redosumv1024hf */

        case 17:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19673; /* pred_redosumv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19633; /* pred_redosumrvvm8sf */

        case 1:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19635; /* pred_redosumrvvm4sf */

        case 2:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19637; /* pred_redosumrvvm2sf */

        case 3:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19639; /* pred_redosumrvvm1sf */

        case 4:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19641; /* pred_redosumrvvmf2sf */

        case 5:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19675; /* pred_redosumv1sf */

        case 6:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19677; /* pred_redosumv2sf */

        case 7:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19679; /* pred_redosumv4sf */

        case 8:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19681; /* pred_redosumv8sf */

        case 9:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19683; /* pred_redosumv16sf */

        case 10:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19685; /* pred_redosumv32sf */

        case 11:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19687; /* pred_redosumv64sf */

        case 12:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19689; /* pred_redosumv128sf */

        case 13:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19691; /* pred_redosumv256sf */

        case 14:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19693; /* pred_redosumv512sf */

        case 15:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19695; /* pred_redosumv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19643; /* pred_redosumrvvm8df */

        case 1:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19645; /* pred_redosumrvvm4df */

        case 2:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19647; /* pred_redosumrvvm2df */

        case 3:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19649; /* pred_redosumrvvm1df */

        case 4:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19697; /* pred_redosumv1df */

        case 5:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19699; /* pred_redosumv2df */

        case 6:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19701; /* pred_redosumv4df */

        case 7:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19703; /* pred_redosumv8df */

        case 8:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19705; /* pred_redosumv16df */

        case 9:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19707; /* pred_redosumv32df */

        case 10:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19709; /* pred_redosumv64df */

        case 11:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19711; /* pred_redosumv128df */

        case 12:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19713; /* pred_redosumv256df */

        case 13:
          if (!(
#line 7912 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19715; /* pred_redosumv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[3], E_RVVMF8x2QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21603; /* pred_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[3], E_RVVMF8x3QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21604; /* pred_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[3], E_RVVMF8x4QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21605; /* pred_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[3], E_RVVMF8x5QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21606; /* pred_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[3], E_RVVMF8x6QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21607; /* pred_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[3], E_RVVMF8x7QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21608; /* pred_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[3], E_RVVMF8x8QImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21609; /* pred_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[3], E_RVVMF4x2HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21610; /* pred_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[3], E_RVVMF4x3HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21611; /* pred_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[3], E_RVVMF4x4HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21612; /* pred_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[3], E_RVVMF4x5HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21613; /* pred_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[3], E_RVVMF4x6HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21614; /* pred_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[3], E_RVVMF4x7HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21615; /* pred_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[3], E_RVVMF4x8HImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21616; /* pred_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[3], E_RVVMF2x2SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21617; /* pred_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[3], E_RVVMF2x3SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21618; /* pred_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[3], E_RVVMF2x4SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21619; /* pred_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[3], E_RVVMF2x5SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21620; /* pred_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[3], E_RVVMF2x6SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21621; /* pred_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[3], E_RVVMF2x7SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21622; /* pred_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[3], E_RVVMF2x8SImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21623; /* pred_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[3], E_RVVM1x2DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21624; /* pred_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[3], E_RVVM1x3DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21625; /* pred_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[3], E_RVVM1x4DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21626; /* pred_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[3], E_RVVM1x5DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21627; /* pred_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[3], E_RVVM1x6DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21628; /* pred_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[3], E_RVVM1x7DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21629; /* pred_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[3], E_RVVM1x8DImode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21630; /* pred_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[3], E_RVVMF4x2BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21631; /* pred_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[3], E_RVVMF4x3BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21632; /* pred_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[3], E_RVVMF4x4BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21633; /* pred_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[3], E_RVVMF4x5BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21634; /* pred_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[3], E_RVVMF4x6BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21635; /* pred_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[3], E_RVVMF4x7BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21636; /* pred_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[3], E_RVVMF4x8BFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21637; /* pred_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[3], E_RVVMF4x2HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21638; /* pred_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[3], E_RVVMF4x3HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21639; /* pred_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[3], E_RVVMF4x4HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21640; /* pred_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[3], E_RVVMF4x5HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21641; /* pred_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[3], E_RVVMF4x6HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21642; /* pred_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[3], E_RVVMF4x7HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21643; /* pred_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[3], E_RVVMF4x8HFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21644; /* pred_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[3], E_RVVMF2x2SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21645; /* pred_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[3], E_RVVMF2x3SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21646; /* pred_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[3], E_RVVMF2x4SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21647; /* pred_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[3], E_RVVMF2x5SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21648; /* pred_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[3], E_RVVMF2x6SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21649; /* pred_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[3], E_RVVMF2x7SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21650; /* pred_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[3], E_RVVMF2x8SFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21651; /* pred_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[3], E_RVVM1x2DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21652; /* pred_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[3], E_RVVM1x3DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21653; /* pred_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[3], E_RVVM1x4DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21654; /* pred_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[3], E_RVVM1x5DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21655; /* pred_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[3], E_RVVM1x6DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21656; /* pred_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[3], E_RVVM1x7DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21657; /* pred_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[3], E_RVVM1x8DFmode)
          || !(
#line 8435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21658; /* pred_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5188; /* pred_indexed_ustorervvmf8qirvvmf8qi */

    case 1:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5190; /* pred_indexed_ustorervvmf4hirvvmf8qi */

    case 2:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5192; /* pred_indexed_ustorervvmf2sirvvmf8qi */

    case 3:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 809 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5194; /* pred_indexed_ustorervvm1dirvvmf8qi */

    case 4:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 810 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5196; /* pred_indexed_ustorervvmf4bfrvvmf8qi */

    case 5:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 811 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5198; /* pred_indexed_ustorervvmf4hfrvvmf8qi */

    case 6:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5200; /* pred_indexed_ustorervvmf2sfrvvmf8qi */

    case 7:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 813 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5202; /* pred_indexed_ustorervvm1dfrvvmf8qi */

    case 8:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23238; /* pred_indexed_ustorervvmf8x2qirvvmf8qi */

    case 9:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23246; /* pred_indexed_ustorervvmf8x3qirvvmf8qi */

    case 10:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23254; /* pred_indexed_ustorervvmf8x4qirvvmf8qi */

    case 11:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23262; /* pred_indexed_ustorervvmf8x5qirvvmf8qi */

    case 12:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23270; /* pred_indexed_ustorervvmf8x6qirvvmf8qi */

    case 13:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23278; /* pred_indexed_ustorervvmf8x7qirvvmf8qi */

    case 14:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23286; /* pred_indexed_ustorervvmf8x8qirvvmf8qi */

    case 15:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23294; /* pred_indexed_ustorervvmf4x2hirvvmf8qi */

    case 16:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23302; /* pred_indexed_ustorervvmf4x3hirvvmf8qi */

    case 17:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23310; /* pred_indexed_ustorervvmf4x4hirvvmf8qi */

    case 18:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23318; /* pred_indexed_ustorervvmf4x5hirvvmf8qi */

    case 19:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23326; /* pred_indexed_ustorervvmf4x6hirvvmf8qi */

    case 20:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23334; /* pred_indexed_ustorervvmf4x7hirvvmf8qi */

    case 21:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23342; /* pred_indexed_ustorervvmf4x8hirvvmf8qi */

    case 22:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23350; /* pred_indexed_ustorervvmf2x2sirvvmf8qi */

    case 23:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23358; /* pred_indexed_ustorervvmf2x3sirvvmf8qi */

    case 24:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23366; /* pred_indexed_ustorervvmf2x4sirvvmf8qi */

    case 25:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23374; /* pred_indexed_ustorervvmf2x5sirvvmf8qi */

    case 26:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23382; /* pred_indexed_ustorervvmf2x6sirvvmf8qi */

    case 27:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23390; /* pred_indexed_ustorervvmf2x7sirvvmf8qi */

    case 28:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23398; /* pred_indexed_ustorervvmf2x8sirvvmf8qi */

    case 29:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23406; /* pred_indexed_ustorervvm1x2dirvvmf8qi */

    case 30:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23414; /* pred_indexed_ustorervvm1x3dirvvmf8qi */

    case 31:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23422; /* pred_indexed_ustorervvm1x4dirvvmf8qi */

    case 32:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23430; /* pred_indexed_ustorervvm1x5dirvvmf8qi */

    case 33:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23438; /* pred_indexed_ustorervvm1x6dirvvmf8qi */

    case 34:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23446; /* pred_indexed_ustorervvm1x7dirvvmf8qi */

    case 35:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23454; /* pred_indexed_ustorervvm1x8dirvvmf8qi */

    case 36:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23462; /* pred_indexed_ustorervvmf4x2bfrvvmf8qi */

    case 37:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23470; /* pred_indexed_ustorervvmf4x3bfrvvmf8qi */

    case 38:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23478; /* pred_indexed_ustorervvmf4x4bfrvvmf8qi */

    case 39:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23486; /* pred_indexed_ustorervvmf4x5bfrvvmf8qi */

    case 40:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23494; /* pred_indexed_ustorervvmf4x6bfrvvmf8qi */

    case 41:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23502; /* pred_indexed_ustorervvmf4x7bfrvvmf8qi */

    case 42:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23510; /* pred_indexed_ustorervvmf4x8bfrvvmf8qi */

    case 43:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23518; /* pred_indexed_ustorervvmf4x2hfrvvmf8qi */

    case 44:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23526; /* pred_indexed_ustorervvmf4x3hfrvvmf8qi */

    case 45:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23534; /* pred_indexed_ustorervvmf4x4hfrvvmf8qi */

    case 46:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23542; /* pred_indexed_ustorervvmf4x5hfrvvmf8qi */

    case 47:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23550; /* pred_indexed_ustorervvmf4x6hfrvvmf8qi */

    case 48:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23558; /* pred_indexed_ustorervvmf4x7hfrvvmf8qi */

    case 49:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23566; /* pred_indexed_ustorervvmf4x8hfrvvmf8qi */

    case 50:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23574; /* pred_indexed_ustorervvmf2x2sfrvvmf8qi */

    case 51:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23582; /* pred_indexed_ustorervvmf2x3sfrvvmf8qi */

    case 52:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23590; /* pred_indexed_ustorervvmf2x4sfrvvmf8qi */

    case 53:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23598; /* pred_indexed_ustorervvmf2x5sfrvvmf8qi */

    case 54:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23606; /* pred_indexed_ustorervvmf2x6sfrvvmf8qi */

    case 55:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23614; /* pred_indexed_ustorervvmf2x7sfrvvmf8qi */

    case 56:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23622; /* pred_indexed_ustorervvmf2x8sfrvvmf8qi */

    case 57:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23630; /* pred_indexed_ustorervvm1x2dfrvvmf8qi */

    case 58:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23638; /* pred_indexed_ustorervvm1x3dfrvvmf8qi */

    case 59:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23646; /* pred_indexed_ustorervvm1x4dfrvvmf8qi */

    case 60:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23654; /* pred_indexed_ustorervvm1x5dfrvvmf8qi */

    case 61:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23662; /* pred_indexed_ustorervvm1x6dfrvvmf8qi */

    case 62:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23670; /* pred_indexed_ustorervvm1x7dfrvvmf8qi */

    case 63:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23678; /* pred_indexed_ustorervvm1x8dfrvvmf8qi */

    case 64:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5204; /* pred_indexed_ustorervvmf8qirvvmf4hi */

    case 65:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5206; /* pred_indexed_ustorervvmf4hirvvmf4hi */

    case 66:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5208; /* pred_indexed_ustorervvmf2sirvvmf4hi */

    case 67:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 809 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5210; /* pred_indexed_ustorervvm1dirvvmf4hi */

    case 68:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 810 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5212; /* pred_indexed_ustorervvmf4bfrvvmf4hi */

    case 69:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 811 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5214; /* pred_indexed_ustorervvmf4hfrvvmf4hi */

    case 70:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5216; /* pred_indexed_ustorervvmf2sfrvvmf4hi */

    case 71:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 813 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5218; /* pred_indexed_ustorervvm1dfrvvmf4hi */

    case 72:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23240; /* pred_indexed_ustorervvmf8x2qirvvmf4hi */

    case 73:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23248; /* pred_indexed_ustorervvmf8x3qirvvmf4hi */

    case 74:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23256; /* pred_indexed_ustorervvmf8x4qirvvmf4hi */

    case 75:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23264; /* pred_indexed_ustorervvmf8x5qirvvmf4hi */

    case 76:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23272; /* pred_indexed_ustorervvmf8x6qirvvmf4hi */

    case 77:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23280; /* pred_indexed_ustorervvmf8x7qirvvmf4hi */

    case 78:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23288; /* pred_indexed_ustorervvmf8x8qirvvmf4hi */

    case 79:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23296; /* pred_indexed_ustorervvmf4x2hirvvmf4hi */

    case 80:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23304; /* pred_indexed_ustorervvmf4x3hirvvmf4hi */

    case 81:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23312; /* pred_indexed_ustorervvmf4x4hirvvmf4hi */

    case 82:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23320; /* pred_indexed_ustorervvmf4x5hirvvmf4hi */

    case 83:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23328; /* pred_indexed_ustorervvmf4x6hirvvmf4hi */

    case 84:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23336; /* pred_indexed_ustorervvmf4x7hirvvmf4hi */

    case 85:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23344; /* pred_indexed_ustorervvmf4x8hirvvmf4hi */

    case 86:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23352; /* pred_indexed_ustorervvmf2x2sirvvmf4hi */

    case 87:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23360; /* pred_indexed_ustorervvmf2x3sirvvmf4hi */

    case 88:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23368; /* pred_indexed_ustorervvmf2x4sirvvmf4hi */

    case 89:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23376; /* pred_indexed_ustorervvmf2x5sirvvmf4hi */

    case 90:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23384; /* pred_indexed_ustorervvmf2x6sirvvmf4hi */

    case 91:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23392; /* pred_indexed_ustorervvmf2x7sirvvmf4hi */

    case 92:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23400; /* pred_indexed_ustorervvmf2x8sirvvmf4hi */

    case 93:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23408; /* pred_indexed_ustorervvm1x2dirvvmf4hi */

    case 94:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23416; /* pred_indexed_ustorervvm1x3dirvvmf4hi */

    case 95:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23424; /* pred_indexed_ustorervvm1x4dirvvmf4hi */

    case 96:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23432; /* pred_indexed_ustorervvm1x5dirvvmf4hi */

    case 97:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23440; /* pred_indexed_ustorervvm1x6dirvvmf4hi */

    case 98:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23448; /* pred_indexed_ustorervvm1x7dirvvmf4hi */

    case 99:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23456; /* pred_indexed_ustorervvm1x8dirvvmf4hi */

    case 100:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23464; /* pred_indexed_ustorervvmf4x2bfrvvmf4hi */

    case 101:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23472; /* pred_indexed_ustorervvmf4x3bfrvvmf4hi */

    case 102:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23480; /* pred_indexed_ustorervvmf4x4bfrvvmf4hi */

    case 103:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23488; /* pred_indexed_ustorervvmf4x5bfrvvmf4hi */

    case 104:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23496; /* pred_indexed_ustorervvmf4x6bfrvvmf4hi */

    case 105:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23504; /* pred_indexed_ustorervvmf4x7bfrvvmf4hi */

    case 106:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23512; /* pred_indexed_ustorervvmf4x8bfrvvmf4hi */

    case 107:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23520; /* pred_indexed_ustorervvmf4x2hfrvvmf4hi */

    case 108:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23528; /* pred_indexed_ustorervvmf4x3hfrvvmf4hi */

    case 109:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23536; /* pred_indexed_ustorervvmf4x4hfrvvmf4hi */

    case 110:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23544; /* pred_indexed_ustorervvmf4x5hfrvvmf4hi */

    case 111:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23552; /* pred_indexed_ustorervvmf4x6hfrvvmf4hi */

    case 112:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23560; /* pred_indexed_ustorervvmf4x7hfrvvmf4hi */

    case 113:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23568; /* pred_indexed_ustorervvmf4x8hfrvvmf4hi */

    case 114:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23576; /* pred_indexed_ustorervvmf2x2sfrvvmf4hi */

    case 115:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23584; /* pred_indexed_ustorervvmf2x3sfrvvmf4hi */

    case 116:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23592; /* pred_indexed_ustorervvmf2x4sfrvvmf4hi */

    case 117:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23600; /* pred_indexed_ustorervvmf2x5sfrvvmf4hi */

    case 118:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23608; /* pred_indexed_ustorervvmf2x6sfrvvmf4hi */

    case 119:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23616; /* pred_indexed_ustorervvmf2x7sfrvvmf4hi */

    case 120:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23624; /* pred_indexed_ustorervvmf2x8sfrvvmf4hi */

    case 121:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23632; /* pred_indexed_ustorervvm1x2dfrvvmf4hi */

    case 122:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23640; /* pred_indexed_ustorervvm1x3dfrvvmf4hi */

    case 123:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23648; /* pred_indexed_ustorervvm1x4dfrvvmf4hi */

    case 124:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23656; /* pred_indexed_ustorervvm1x5dfrvvmf4hi */

    case 125:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23664; /* pred_indexed_ustorervvm1x6dfrvvmf4hi */

    case 126:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23672; /* pred_indexed_ustorervvm1x7dfrvvmf4hi */

    case 127:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23680; /* pred_indexed_ustorervvm1x8dfrvvmf4hi */

    case 128:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5220; /* pred_indexed_ustorervvmf8qirvvmf2si */

    case 129:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5222; /* pred_indexed_ustorervvmf4hirvvmf2si */

    case 130:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5224; /* pred_indexed_ustorervvmf2sirvvmf2si */

    case 131:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 809 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5226; /* pred_indexed_ustorervvm1dirvvmf2si */

    case 132:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 810 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5228; /* pred_indexed_ustorervvmf4bfrvvmf2si */

    case 133:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 811 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5230; /* pred_indexed_ustorervvmf4hfrvvmf2si */

    case 134:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5232; /* pred_indexed_ustorervvmf2sfrvvmf2si */

    case 135:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 813 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5234; /* pred_indexed_ustorervvm1dfrvvmf2si */

    case 136:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23242; /* pred_indexed_ustorervvmf8x2qirvvmf2si */

    case 137:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23250; /* pred_indexed_ustorervvmf8x3qirvvmf2si */

    case 138:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23258; /* pred_indexed_ustorervvmf8x4qirvvmf2si */

    case 139:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23266; /* pred_indexed_ustorervvmf8x5qirvvmf2si */

    case 140:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23274; /* pred_indexed_ustorervvmf8x6qirvvmf2si */

    case 141:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23282; /* pred_indexed_ustorervvmf8x7qirvvmf2si */

    case 142:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23290; /* pred_indexed_ustorervvmf8x8qirvvmf2si */

    case 143:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23298; /* pred_indexed_ustorervvmf4x2hirvvmf2si */

    case 144:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23306; /* pred_indexed_ustorervvmf4x3hirvvmf2si */

    case 145:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23314; /* pred_indexed_ustorervvmf4x4hirvvmf2si */

    case 146:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23322; /* pred_indexed_ustorervvmf4x5hirvvmf2si */

    case 147:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23330; /* pred_indexed_ustorervvmf4x6hirvvmf2si */

    case 148:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23338; /* pred_indexed_ustorervvmf4x7hirvvmf2si */

    case 149:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23346; /* pred_indexed_ustorervvmf4x8hirvvmf2si */

    case 150:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23354; /* pred_indexed_ustorervvmf2x2sirvvmf2si */

    case 151:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23362; /* pred_indexed_ustorervvmf2x3sirvvmf2si */

    case 152:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23370; /* pred_indexed_ustorervvmf2x4sirvvmf2si */

    case 153:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23378; /* pred_indexed_ustorervvmf2x5sirvvmf2si */

    case 154:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23386; /* pred_indexed_ustorervvmf2x6sirvvmf2si */

    case 155:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23394; /* pred_indexed_ustorervvmf2x7sirvvmf2si */

    case 156:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23402; /* pred_indexed_ustorervvmf2x8sirvvmf2si */

    case 157:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23410; /* pred_indexed_ustorervvm1x2dirvvmf2si */

    case 158:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23418; /* pred_indexed_ustorervvm1x3dirvvmf2si */

    case 159:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23426; /* pred_indexed_ustorervvm1x4dirvvmf2si */

    case 160:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23434; /* pred_indexed_ustorervvm1x5dirvvmf2si */

    case 161:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23442; /* pred_indexed_ustorervvm1x6dirvvmf2si */

    case 162:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23450; /* pred_indexed_ustorervvm1x7dirvvmf2si */

    case 163:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23458; /* pred_indexed_ustorervvm1x8dirvvmf2si */

    case 164:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23466; /* pred_indexed_ustorervvmf4x2bfrvvmf2si */

    case 165:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23474; /* pred_indexed_ustorervvmf4x3bfrvvmf2si */

    case 166:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23482; /* pred_indexed_ustorervvmf4x4bfrvvmf2si */

    case 167:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23490; /* pred_indexed_ustorervvmf4x5bfrvvmf2si */

    case 168:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23498; /* pred_indexed_ustorervvmf4x6bfrvvmf2si */

    case 169:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23506; /* pred_indexed_ustorervvmf4x7bfrvvmf2si */

    case 170:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23514; /* pred_indexed_ustorervvmf4x8bfrvvmf2si */

    case 171:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23522; /* pred_indexed_ustorervvmf4x2hfrvvmf2si */

    case 172:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23530; /* pred_indexed_ustorervvmf4x3hfrvvmf2si */

    case 173:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23538; /* pred_indexed_ustorervvmf4x4hfrvvmf2si */

    case 174:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23546; /* pred_indexed_ustorervvmf4x5hfrvvmf2si */

    case 175:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23554; /* pred_indexed_ustorervvmf4x6hfrvvmf2si */

    case 176:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23562; /* pred_indexed_ustorervvmf4x7hfrvvmf2si */

    case 177:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23570; /* pred_indexed_ustorervvmf4x8hfrvvmf2si */

    case 178:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23578; /* pred_indexed_ustorervvmf2x2sfrvvmf2si */

    case 179:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23586; /* pred_indexed_ustorervvmf2x3sfrvvmf2si */

    case 180:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23594; /* pred_indexed_ustorervvmf2x4sfrvvmf2si */

    case 181:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23602; /* pred_indexed_ustorervvmf2x5sfrvvmf2si */

    case 182:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23610; /* pred_indexed_ustorervvmf2x6sfrvvmf2si */

    case 183:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23618; /* pred_indexed_ustorervvmf2x7sfrvvmf2si */

    case 184:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23626; /* pred_indexed_ustorervvmf2x8sfrvvmf2si */

    case 185:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23634; /* pred_indexed_ustorervvm1x2dfrvvmf2si */

    case 186:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23642; /* pred_indexed_ustorervvm1x3dfrvvmf2si */

    case 187:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23650; /* pred_indexed_ustorervvm1x4dfrvvmf2si */

    case 188:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23658; /* pred_indexed_ustorervvm1x5dfrvvmf2si */

    case 189:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23666; /* pred_indexed_ustorervvm1x6dfrvvmf2si */

    case 190:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23674; /* pred_indexed_ustorervvm1x7dfrvvmf2si */

    case 191:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23682; /* pred_indexed_ustorervvm1x8dfrvvmf2si */

    case 192:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 806 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 5236; /* pred_indexed_ustorervvmf8qirvvm1di */

    case 193:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 5238; /* pred_indexed_ustorervvmf4hirvvm1di */

    case 194:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 5240; /* pred_indexed_ustorervvmf2sirvvm1di */

    case 195:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 809 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5242; /* pred_indexed_ustorervvm1dirvvm1di */

    case 196:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 810 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5244; /* pred_indexed_ustorervvmf4bfrvvm1di */

    case 197:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 811 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5246; /* pred_indexed_ustorervvmf4hfrvvm1di */

    case 198:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5248; /* pred_indexed_ustorervvmf2sfrvvm1di */

    case 199:
      if (!(
#line 2588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 813 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5250; /* pred_indexed_ustorervvm1dfrvvm1di */

    case 200:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23244; /* pred_indexed_ustorervvmf8x2qirvvm1di */

    case 201:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23252; /* pred_indexed_ustorervvmf8x3qirvvm1di */

    case 202:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23260; /* pred_indexed_ustorervvmf8x4qirvvm1di */

    case 203:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23268; /* pred_indexed_ustorervvmf8x5qirvvm1di */

    case 204:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23276; /* pred_indexed_ustorervvmf8x6qirvvm1di */

    case 205:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23284; /* pred_indexed_ustorervvmf8x7qirvvm1di */

    case 206:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23292; /* pred_indexed_ustorervvmf8x8qirvvm1di */

    case 207:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23300; /* pred_indexed_ustorervvmf4x2hirvvm1di */

    case 208:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23308; /* pred_indexed_ustorervvmf4x3hirvvm1di */

    case 209:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23316; /* pred_indexed_ustorervvmf4x4hirvvm1di */

    case 210:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23324; /* pred_indexed_ustorervvmf4x5hirvvm1di */

    case 211:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23332; /* pred_indexed_ustorervvmf4x6hirvvm1di */

    case 212:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23340; /* pred_indexed_ustorervvmf4x7hirvvm1di */

    case 213:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23348; /* pred_indexed_ustorervvmf4x8hirvvm1di */

    case 214:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23356; /* pred_indexed_ustorervvmf2x2sirvvm1di */

    case 215:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23364; /* pred_indexed_ustorervvmf2x3sirvvm1di */

    case 216:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23372; /* pred_indexed_ustorervvmf2x4sirvvm1di */

    case 217:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23380; /* pred_indexed_ustorervvmf2x5sirvvm1di */

    case 218:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23388; /* pred_indexed_ustorervvmf2x6sirvvm1di */

    case 219:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23396; /* pred_indexed_ustorervvmf2x7sirvvm1di */

    case 220:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23404; /* pred_indexed_ustorervvmf2x8sirvvm1di */

    case 221:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23412; /* pred_indexed_ustorervvm1x2dirvvm1di */

    case 222:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23420; /* pred_indexed_ustorervvm1x3dirvvm1di */

    case 223:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23428; /* pred_indexed_ustorervvm1x4dirvvm1di */

    case 224:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23436; /* pred_indexed_ustorervvm1x5dirvvm1di */

    case 225:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23444; /* pred_indexed_ustorervvm1x6dirvvm1di */

    case 226:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23452; /* pred_indexed_ustorervvm1x7dirvvm1di */

    case 227:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23460; /* pred_indexed_ustorervvm1x8dirvvm1di */

    case 228:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23468; /* pred_indexed_ustorervvmf4x2bfrvvm1di */

    case 229:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23476; /* pred_indexed_ustorervvmf4x3bfrvvm1di */

    case 230:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23484; /* pred_indexed_ustorervvmf4x4bfrvvm1di */

    case 231:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23492; /* pred_indexed_ustorervvmf4x5bfrvvm1di */

    case 232:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23500; /* pred_indexed_ustorervvmf4x6bfrvvm1di */

    case 233:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23508; /* pred_indexed_ustorervvmf4x7bfrvvm1di */

    case 234:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23516; /* pred_indexed_ustorervvmf4x8bfrvvm1di */

    case 235:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23524; /* pred_indexed_ustorervvmf4x2hfrvvm1di */

    case 236:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23532; /* pred_indexed_ustorervvmf4x3hfrvvm1di */

    case 237:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23540; /* pred_indexed_ustorervvmf4x4hfrvvm1di */

    case 238:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23548; /* pred_indexed_ustorervvmf4x5hfrvvm1di */

    case 239:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23556; /* pred_indexed_ustorervvmf4x6hfrvvm1di */

    case 240:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23564; /* pred_indexed_ustorervvmf4x7hfrvvm1di */

    case 241:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23572; /* pred_indexed_ustorervvmf4x8hfrvvm1di */

    case 242:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23580; /* pred_indexed_ustorervvmf2x2sfrvvm1di */

    case 243:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23588; /* pred_indexed_ustorervvmf2x3sfrvvm1di */

    case 244:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23596; /* pred_indexed_ustorervvmf2x4sfrvvm1di */

    case 245:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23604; /* pred_indexed_ustorervvmf2x5sfrvvm1di */

    case 246:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23612; /* pred_indexed_ustorervvmf2x6sfrvvm1di */

    case 247:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23620; /* pred_indexed_ustorervvmf2x7sfrvvm1di */

    case 248:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23628; /* pred_indexed_ustorervvmf2x8sfrvvm1di */

    case 249:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23636; /* pred_indexed_ustorervvm1x2dfrvvm1di */

    case 250:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23644; /* pred_indexed_ustorervvm1x3dfrvvm1di */

    case 251:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23652; /* pred_indexed_ustorervvm1x4dfrvvm1di */

    case 252:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23660; /* pred_indexed_ustorervvm1x5dfrvvm1di */

    case 253:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23668; /* pred_indexed_ustorervvm1x6dfrvvm1di */

    case 254:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23676; /* pred_indexed_ustorervvm1x7dfrvvm1di */

    case 255:
      if (!(
#line 8609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23684; /* pred_indexed_ustorervvm1x8dfrvvm1di */

    case 256:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5252; /* pred_indexed_ustorervvmf4qirvvmf4qi */

    case 257:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5260; /* pred_indexed_ustorervvmf2hirvvmf4qi */

    case 258:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5268; /* pred_indexed_ustorervvm1sirvvmf4qi */

    case 259:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5276; /* pred_indexed_ustorervvm2dirvvmf4qi */

    case 260:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5284; /* pred_indexed_ustorervvmf2bfrvvmf4qi */

    case 261:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5292; /* pred_indexed_ustorervvmf2hfrvvmf4qi */

    case 262:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5300; /* pred_indexed_ustorervvm1sfrvvmf4qi */

    case 263:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5308; /* pred_indexed_ustorervvm2dfrvvmf4qi */

    case 264:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23686; /* pred_indexed_ustorervvmf4x2qirvvmf4qi */

    case 265:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23688; /* pred_indexed_ustorervvmf4x3qirvvmf4qi */

    case 266:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23690; /* pred_indexed_ustorervvmf4x4qirvvmf4qi */

    case 267:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23692; /* pred_indexed_ustorervvmf4x5qirvvmf4qi */

    case 268:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23694; /* pred_indexed_ustorervvmf4x6qirvvmf4qi */

    case 269:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23696; /* pred_indexed_ustorervvmf4x7qirvvmf4qi */

    case 270:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23698; /* pred_indexed_ustorervvmf4x8qirvvmf4qi */

    case 271:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23700; /* pred_indexed_ustorervvmf2x2hirvvmf4qi */

    case 272:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23702; /* pred_indexed_ustorervvmf2x3hirvvmf4qi */

    case 273:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23704; /* pred_indexed_ustorervvmf2x4hirvvmf4qi */

    case 274:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23706; /* pred_indexed_ustorervvmf2x5hirvvmf4qi */

    case 275:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23708; /* pred_indexed_ustorervvmf2x6hirvvmf4qi */

    case 276:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23710; /* pred_indexed_ustorervvmf2x7hirvvmf4qi */

    case 277:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23712; /* pred_indexed_ustorervvmf2x8hirvvmf4qi */

    case 278:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23714; /* pred_indexed_ustorervvm1x2sirvvmf4qi */

    case 279:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23716; /* pred_indexed_ustorervvm1x3sirvvmf4qi */

    case 280:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23718; /* pred_indexed_ustorervvm1x4sirvvmf4qi */

    case 281:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23720; /* pred_indexed_ustorervvm1x5sirvvmf4qi */

    case 282:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23722; /* pred_indexed_ustorervvm1x6sirvvmf4qi */

    case 283:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23724; /* pred_indexed_ustorervvm1x7sirvvmf4qi */

    case 284:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23726; /* pred_indexed_ustorervvm1x8sirvvmf4qi */

    case 285:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23728; /* pred_indexed_ustorervvm2x2dirvvmf4qi */

    case 286:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23730; /* pred_indexed_ustorervvm2x3dirvvmf4qi */

    case 287:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23732; /* pred_indexed_ustorervvm2x4dirvvmf4qi */

    case 288:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23734; /* pred_indexed_ustorervvmf2x2bfrvvmf4qi */

    case 289:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23736; /* pred_indexed_ustorervvmf2x3bfrvvmf4qi */

    case 290:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23738; /* pred_indexed_ustorervvmf2x4bfrvvmf4qi */

    case 291:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23740; /* pred_indexed_ustorervvmf2x5bfrvvmf4qi */

    case 292:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23742; /* pred_indexed_ustorervvmf2x6bfrvvmf4qi */

    case 293:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23744; /* pred_indexed_ustorervvmf2x7bfrvvmf4qi */

    case 294:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23746; /* pred_indexed_ustorervvmf2x8bfrvvmf4qi */

    case 295:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23748; /* pred_indexed_ustorervvmf2x2hfrvvmf4qi */

    case 296:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23750; /* pred_indexed_ustorervvmf2x3hfrvvmf4qi */

    case 297:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23752; /* pred_indexed_ustorervvmf2x4hfrvvmf4qi */

    case 298:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23754; /* pred_indexed_ustorervvmf2x5hfrvvmf4qi */

    case 299:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23756; /* pred_indexed_ustorervvmf2x6hfrvvmf4qi */

    case 300:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23758; /* pred_indexed_ustorervvmf2x7hfrvvmf4qi */

    case 301:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23760; /* pred_indexed_ustorervvmf2x8hfrvvmf4qi */

    case 302:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23762; /* pred_indexed_ustorervvm1x2sfrvvmf4qi */

    case 303:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23764; /* pred_indexed_ustorervvm1x3sfrvvmf4qi */

    case 304:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23766; /* pred_indexed_ustorervvm1x4sfrvvmf4qi */

    case 305:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23768; /* pred_indexed_ustorervvm1x5sfrvvmf4qi */

    case 306:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23770; /* pred_indexed_ustorervvm1x6sfrvvmf4qi */

    case 307:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23772; /* pred_indexed_ustorervvm1x7sfrvvmf4qi */

    case 308:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23774; /* pred_indexed_ustorervvm1x8sfrvvmf4qi */

    case 309:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23776; /* pred_indexed_ustorervvm2x2dfrvvmf4qi */

    case 310:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23778; /* pred_indexed_ustorervvm2x3dfrvvmf4qi */

    case 311:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23780; /* pred_indexed_ustorervvm2x4dfrvvmf4qi */

    case 312:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5254; /* pred_indexed_ustorervvmf4qirvvmf2hi */

    case 313:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5262; /* pred_indexed_ustorervvmf2hirvvmf2hi */

    case 314:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5270; /* pred_indexed_ustorervvm1sirvvmf2hi */

    case 315:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5278; /* pred_indexed_ustorervvm2dirvvmf2hi */

    case 316:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5286; /* pred_indexed_ustorervvmf2bfrvvmf2hi */

    case 317:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5294; /* pred_indexed_ustorervvmf2hfrvvmf2hi */

    case 318:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5302; /* pred_indexed_ustorervvm1sfrvvmf2hi */

    case 319:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5310; /* pred_indexed_ustorervvm2dfrvvmf2hi */

    case 320:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23782; /* pred_indexed_ustorervvmf4x2qirvvmf2hi */

    case 321:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23784; /* pred_indexed_ustorervvmf4x3qirvvmf2hi */

    case 322:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23786; /* pred_indexed_ustorervvmf4x4qirvvmf2hi */

    case 323:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23788; /* pred_indexed_ustorervvmf4x5qirvvmf2hi */

    case 324:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23790; /* pred_indexed_ustorervvmf4x6qirvvmf2hi */

    case 325:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23792; /* pred_indexed_ustorervvmf4x7qirvvmf2hi */

    case 326:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23794; /* pred_indexed_ustorervvmf4x8qirvvmf2hi */

    case 327:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23796; /* pred_indexed_ustorervvmf2x2hirvvmf2hi */

    case 328:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23798; /* pred_indexed_ustorervvmf2x3hirvvmf2hi */

    case 329:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23800; /* pred_indexed_ustorervvmf2x4hirvvmf2hi */

    case 330:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23802; /* pred_indexed_ustorervvmf2x5hirvvmf2hi */

    case 331:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23804; /* pred_indexed_ustorervvmf2x6hirvvmf2hi */

    case 332:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23806; /* pred_indexed_ustorervvmf2x7hirvvmf2hi */

    case 333:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23808; /* pred_indexed_ustorervvmf2x8hirvvmf2hi */

    case 334:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23810; /* pred_indexed_ustorervvm1x2sirvvmf2hi */

    case 335:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23812; /* pred_indexed_ustorervvm1x3sirvvmf2hi */

    case 336:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23814; /* pred_indexed_ustorervvm1x4sirvvmf2hi */

    case 337:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23816; /* pred_indexed_ustorervvm1x5sirvvmf2hi */

    case 338:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23818; /* pred_indexed_ustorervvm1x6sirvvmf2hi */

    case 339:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23820; /* pred_indexed_ustorervvm1x7sirvvmf2hi */

    case 340:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23822; /* pred_indexed_ustorervvm1x8sirvvmf2hi */

    case 341:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23824; /* pred_indexed_ustorervvm2x2dirvvmf2hi */

    case 342:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23826; /* pred_indexed_ustorervvm2x3dirvvmf2hi */

    case 343:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23828; /* pred_indexed_ustorervvm2x4dirvvmf2hi */

    case 344:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23830; /* pred_indexed_ustorervvmf2x2bfrvvmf2hi */

    case 345:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23832; /* pred_indexed_ustorervvmf2x3bfrvvmf2hi */

    case 346:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23834; /* pred_indexed_ustorervvmf2x4bfrvvmf2hi */

    case 347:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23836; /* pred_indexed_ustorervvmf2x5bfrvvmf2hi */

    case 348:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23838; /* pred_indexed_ustorervvmf2x6bfrvvmf2hi */

    case 349:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23840; /* pred_indexed_ustorervvmf2x7bfrvvmf2hi */

    case 350:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23842; /* pred_indexed_ustorervvmf2x8bfrvvmf2hi */

    case 351:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23844; /* pred_indexed_ustorervvmf2x2hfrvvmf2hi */

    case 352:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23846; /* pred_indexed_ustorervvmf2x3hfrvvmf2hi */

    case 353:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23848; /* pred_indexed_ustorervvmf2x4hfrvvmf2hi */

    case 354:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23850; /* pred_indexed_ustorervvmf2x5hfrvvmf2hi */

    case 355:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23852; /* pred_indexed_ustorervvmf2x6hfrvvmf2hi */

    case 356:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23854; /* pred_indexed_ustorervvmf2x7hfrvvmf2hi */

    case 357:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23856; /* pred_indexed_ustorervvmf2x8hfrvvmf2hi */

    case 358:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23858; /* pred_indexed_ustorervvm1x2sfrvvmf2hi */

    case 359:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23860; /* pred_indexed_ustorervvm1x3sfrvvmf2hi */

    case 360:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23862; /* pred_indexed_ustorervvm1x4sfrvvmf2hi */

    case 361:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23864; /* pred_indexed_ustorervvm1x5sfrvvmf2hi */

    case 362:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23866; /* pred_indexed_ustorervvm1x6sfrvvmf2hi */

    case 363:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23868; /* pred_indexed_ustorervvm1x7sfrvvmf2hi */

    case 364:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23870; /* pred_indexed_ustorervvm1x8sfrvvmf2hi */

    case 365:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23872; /* pred_indexed_ustorervvm2x2dfrvvmf2hi */

    case 366:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23874; /* pred_indexed_ustorervvm2x3dfrvvmf2hi */

    case 367:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23876; /* pred_indexed_ustorervvm2x4dfrvvmf2hi */

    case 368:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5256; /* pred_indexed_ustorervvmf4qirvvm1si */

    case 369:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5264; /* pred_indexed_ustorervvmf2hirvvm1si */

    case 370:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5272; /* pred_indexed_ustorervvm1sirvvm1si */

    case 371:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5280; /* pred_indexed_ustorervvm2dirvvm1si */

    case 372:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5288; /* pred_indexed_ustorervvmf2bfrvvm1si */

    case 373:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5296; /* pred_indexed_ustorervvmf2hfrvvm1si */

    case 374:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5304; /* pred_indexed_ustorervvm1sfrvvm1si */

    case 375:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5312; /* pred_indexed_ustorervvm2dfrvvm1si */

    case 376:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23878; /* pred_indexed_ustorervvmf4x2qirvvm1si */

    case 377:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23880; /* pred_indexed_ustorervvmf4x3qirvvm1si */

    case 378:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23882; /* pred_indexed_ustorervvmf4x4qirvvm1si */

    case 379:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23884; /* pred_indexed_ustorervvmf4x5qirvvm1si */

    case 380:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23886; /* pred_indexed_ustorervvmf4x6qirvvm1si */

    case 381:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23888; /* pred_indexed_ustorervvmf4x7qirvvm1si */

    case 382:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23890; /* pred_indexed_ustorervvmf4x8qirvvm1si */

    case 383:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23892; /* pred_indexed_ustorervvmf2x2hirvvm1si */

    case 384:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23894; /* pred_indexed_ustorervvmf2x3hirvvm1si */

    case 385:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23896; /* pred_indexed_ustorervvmf2x4hirvvm1si */

    case 386:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23898; /* pred_indexed_ustorervvmf2x5hirvvm1si */

    case 387:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23900; /* pred_indexed_ustorervvmf2x6hirvvm1si */

    case 388:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23902; /* pred_indexed_ustorervvmf2x7hirvvm1si */

    case 389:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23904; /* pred_indexed_ustorervvmf2x8hirvvm1si */

    case 390:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23906; /* pred_indexed_ustorervvm1x2sirvvm1si */

    case 391:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23908; /* pred_indexed_ustorervvm1x3sirvvm1si */

    case 392:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23910; /* pred_indexed_ustorervvm1x4sirvvm1si */

    case 393:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23912; /* pred_indexed_ustorervvm1x5sirvvm1si */

    case 394:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23914; /* pred_indexed_ustorervvm1x6sirvvm1si */

    case 395:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23916; /* pred_indexed_ustorervvm1x7sirvvm1si */

    case 396:
      if (!
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23918; /* pred_indexed_ustorervvm1x8sirvvm1si */

    case 397:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23920; /* pred_indexed_ustorervvm2x2dirvvm1si */

    case 398:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23922; /* pred_indexed_ustorervvm2x3dirvvm1si */

    case 399:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23924; /* pred_indexed_ustorervvm2x4dirvvm1si */

    case 400:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23926; /* pred_indexed_ustorervvmf2x2bfrvvm1si */

    case 401:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23928; /* pred_indexed_ustorervvmf2x3bfrvvm1si */

    case 402:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23930; /* pred_indexed_ustorervvmf2x4bfrvvm1si */

    case 403:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23932; /* pred_indexed_ustorervvmf2x5bfrvvm1si */

    case 404:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23934; /* pred_indexed_ustorervvmf2x6bfrvvm1si */

    case 405:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23936; /* pred_indexed_ustorervvmf2x7bfrvvm1si */

    case 406:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23938; /* pred_indexed_ustorervvmf2x8bfrvvm1si */

    case 407:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23940; /* pred_indexed_ustorervvmf2x2hfrvvm1si */

    case 408:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23942; /* pred_indexed_ustorervvmf2x3hfrvvm1si */

    case 409:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23944; /* pred_indexed_ustorervvmf2x4hfrvvm1si */

    case 410:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23946; /* pred_indexed_ustorervvmf2x5hfrvvm1si */

    case 411:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23948; /* pred_indexed_ustorervvmf2x6hfrvvm1si */

    case 412:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23950; /* pred_indexed_ustorervvmf2x7hfrvvm1si */

    case 413:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23952; /* pred_indexed_ustorervvmf2x8hfrvvm1si */

    case 414:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23954; /* pred_indexed_ustorervvm1x2sfrvvm1si */

    case 415:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23956; /* pred_indexed_ustorervvm1x3sfrvvm1si */

    case 416:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23958; /* pred_indexed_ustorervvm1x4sfrvvm1si */

    case 417:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23960; /* pred_indexed_ustorervvm1x5sfrvvm1si */

    case 418:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23962; /* pred_indexed_ustorervvm1x6sfrvvm1si */

    case 419:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23964; /* pred_indexed_ustorervvm1x7sfrvvm1si */

    case 420:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23966; /* pred_indexed_ustorervvm1x8sfrvvm1si */

    case 421:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23968; /* pred_indexed_ustorervvm2x2dfrvvm1si */

    case 422:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23970; /* pred_indexed_ustorervvm2x3dfrvvm1si */

    case 423:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23972; /* pred_indexed_ustorervvm2x4dfrvvm1si */

    case 424:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5258; /* pred_indexed_ustorervvmf4qirvvm2di */

    case 425:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5266; /* pred_indexed_ustorervvmf2hirvvm2di */

    case 426:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5274; /* pred_indexed_ustorervvm1sirvvm2di */

    case 427:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 820 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5282; /* pred_indexed_ustorervvm2dirvvm2di */

    case 428:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 821 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5290; /* pred_indexed_ustorervvmf2bfrvvm2di */

    case 429:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 822 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5298; /* pred_indexed_ustorervvmf2hfrvvm2di */

    case 430:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 823 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5306; /* pred_indexed_ustorervvm1sfrvvm2di */

    case 431:
      if (!(
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 824 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5314; /* pred_indexed_ustorervvm2dfrvvm2di */

    case 432:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23974; /* pred_indexed_ustorervvmf4x2qirvvm2di */

    case 433:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23976; /* pred_indexed_ustorervvmf4x3qirvvm2di */

    case 434:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23978; /* pred_indexed_ustorervvmf4x4qirvvm2di */

    case 435:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23980; /* pred_indexed_ustorervvmf4x5qirvvm2di */

    case 436:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23982; /* pred_indexed_ustorervvmf4x6qirvvm2di */

    case 437:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23984; /* pred_indexed_ustorervvmf4x7qirvvm2di */

    case 438:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23986; /* pred_indexed_ustorervvmf4x8qirvvm2di */

    case 439:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23988; /* pred_indexed_ustorervvmf2x2hirvvm2di */

    case 440:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23990; /* pred_indexed_ustorervvmf2x3hirvvm2di */

    case 441:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23992; /* pred_indexed_ustorervvmf2x4hirvvm2di */

    case 442:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23994; /* pred_indexed_ustorervvmf2x5hirvvm2di */

    case 443:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23996; /* pred_indexed_ustorervvmf2x6hirvvm2di */

    case 444:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23998; /* pred_indexed_ustorervvmf2x7hirvvm2di */

    case 445:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24000; /* pred_indexed_ustorervvmf2x8hirvvm2di */

    case 446:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24002; /* pred_indexed_ustorervvm1x2sirvvm2di */

    case 447:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24004; /* pred_indexed_ustorervvm1x3sirvvm2di */

    case 448:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24006; /* pred_indexed_ustorervvm1x4sirvvm2di */

    case 449:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24008; /* pred_indexed_ustorervvm1x5sirvvm2di */

    case 450:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24010; /* pred_indexed_ustorervvm1x6sirvvm2di */

    case 451:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24012; /* pred_indexed_ustorervvm1x7sirvvm2di */

    case 452:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24014; /* pred_indexed_ustorervvm1x8sirvvm2di */

    case 453:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24016; /* pred_indexed_ustorervvm2x2dirvvm2di */

    case 454:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24018; /* pred_indexed_ustorervvm2x3dirvvm2di */

    case 455:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24020; /* pred_indexed_ustorervvm2x4dirvvm2di */

    case 456:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24022; /* pred_indexed_ustorervvmf2x2bfrvvm2di */

    case 457:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24024; /* pred_indexed_ustorervvmf2x3bfrvvm2di */

    case 458:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24026; /* pred_indexed_ustorervvmf2x4bfrvvm2di */

    case 459:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24028; /* pred_indexed_ustorervvmf2x5bfrvvm2di */

    case 460:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24030; /* pred_indexed_ustorervvmf2x6bfrvvm2di */

    case 461:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24032; /* pred_indexed_ustorervvmf2x7bfrvvm2di */

    case 462:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24034; /* pred_indexed_ustorervvmf2x8bfrvvm2di */

    case 463:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24036; /* pred_indexed_ustorervvmf2x2hfrvvm2di */

    case 464:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24038; /* pred_indexed_ustorervvmf2x3hfrvvm2di */

    case 465:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24040; /* pred_indexed_ustorervvmf2x4hfrvvm2di */

    case 466:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24042; /* pred_indexed_ustorervvmf2x5hfrvvm2di */

    case 467:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24044; /* pred_indexed_ustorervvmf2x6hfrvvm2di */

    case 468:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24046; /* pred_indexed_ustorervvmf2x7hfrvvm2di */

    case 469:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24048; /* pred_indexed_ustorervvmf2x8hfrvvm2di */

    case 470:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24050; /* pred_indexed_ustorervvm1x2sfrvvm2di */

    case 471:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24052; /* pred_indexed_ustorervvm1x3sfrvvm2di */

    case 472:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24054; /* pred_indexed_ustorervvm1x4sfrvvm2di */

    case 473:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24056; /* pred_indexed_ustorervvm1x5sfrvvm2di */

    case 474:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24058; /* pred_indexed_ustorervvm1x6sfrvvm2di */

    case 475:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24060; /* pred_indexed_ustorervvm1x7sfrvvm2di */

    case 476:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24062; /* pred_indexed_ustorervvm1x8sfrvvm2di */

    case 477:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24064; /* pred_indexed_ustorervvm2x2dfrvvm2di */

    case 478:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24066; /* pred_indexed_ustorervvm2x3dfrvvm2di */

    case 479:
      if (!(
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24068; /* pred_indexed_ustorervvm2x4dfrvvm2di */

    case 480:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5316; /* pred_indexed_ustorervvmf2qirvvmf2qi */

    case 481:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5318; /* pred_indexed_ustorervvm1hirvvmf2qi */

    case 482:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5320; /* pred_indexed_ustorervvm2sirvvmf2qi */

    case 483:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5322; /* pred_indexed_ustorervvm4dirvvmf2qi */

    case 484:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5324; /* pred_indexed_ustorervvm1bfrvvmf2qi */

    case 485:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5326; /* pred_indexed_ustorervvm1hfrvvmf2qi */

    case 486:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5328; /* pred_indexed_ustorervvm2sfrvvmf2qi */

    case 487:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5330; /* pred_indexed_ustorervvm4dfrvvmf2qi */

    case 488:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24070; /* pred_indexed_ustorervvmf2x2qirvvmf2qi */

    case 489:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24072; /* pred_indexed_ustorervvmf2x3qirvvmf2qi */

    case 490:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24074; /* pred_indexed_ustorervvmf2x4qirvvmf2qi */

    case 491:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24076; /* pred_indexed_ustorervvmf2x5qirvvmf2qi */

    case 492:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24078; /* pred_indexed_ustorervvmf2x6qirvvmf2qi */

    case 493:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24080; /* pred_indexed_ustorervvmf2x7qirvvmf2qi */

    case 494:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24082; /* pred_indexed_ustorervvmf2x8qirvvmf2qi */

    case 495:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24084; /* pred_indexed_ustorervvm1x2hirvvmf2qi */

    case 496:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24086; /* pred_indexed_ustorervvm1x3hirvvmf2qi */

    case 497:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24088; /* pred_indexed_ustorervvm1x4hirvvmf2qi */

    case 498:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24090; /* pred_indexed_ustorervvm1x5hirvvmf2qi */

    case 499:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24092; /* pred_indexed_ustorervvm1x6hirvvmf2qi */

    case 500:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24094; /* pred_indexed_ustorervvm1x7hirvvmf2qi */

    case 501:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24096; /* pred_indexed_ustorervvm1x8hirvvmf2qi */

    case 502:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24098; /* pred_indexed_ustorervvm2x2sirvvmf2qi */

    case 503:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24100; /* pred_indexed_ustorervvm2x3sirvvmf2qi */

    case 504:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24102; /* pred_indexed_ustorervvm2x4sirvvmf2qi */

    case 505:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24104; /* pred_indexed_ustorervvm4x2dirvvmf2qi */

    case 506:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24106; /* pred_indexed_ustorervvm1x2bfrvvmf2qi */

    case 507:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24108; /* pred_indexed_ustorervvm1x3bfrvvmf2qi */

    case 508:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24110; /* pred_indexed_ustorervvm1x4bfrvvmf2qi */

    case 509:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24112; /* pred_indexed_ustorervvm1x5bfrvvmf2qi */

    case 510:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24114; /* pred_indexed_ustorervvm1x6bfrvvmf2qi */

    case 511:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24116; /* pred_indexed_ustorervvm1x7bfrvvmf2qi */

    case 512:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24118; /* pred_indexed_ustorervvm1x8bfrvvmf2qi */

    case 513:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24120; /* pred_indexed_ustorervvm1x2hfrvvmf2qi */

    case 514:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24122; /* pred_indexed_ustorervvm1x3hfrvvmf2qi */

    case 515:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24124; /* pred_indexed_ustorervvm1x4hfrvvmf2qi */

    case 516:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24126; /* pred_indexed_ustorervvm1x5hfrvvmf2qi */

    case 517:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24128; /* pred_indexed_ustorervvm1x6hfrvvmf2qi */

    case 518:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24130; /* pred_indexed_ustorervvm1x7hfrvvmf2qi */

    case 519:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24132; /* pred_indexed_ustorervvm1x8hfrvvmf2qi */

    case 520:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24134; /* pred_indexed_ustorervvm2x2sfrvvmf2qi */

    case 521:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24136; /* pred_indexed_ustorervvm2x3sfrvvmf2qi */

    case 522:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24138; /* pred_indexed_ustorervvm2x4sfrvvmf2qi */

    case 523:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24140; /* pred_indexed_ustorervvm4x2dfrvvmf2qi */

    case 524:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5332; /* pred_indexed_ustorervvmf2qirvvm1hi */

    case 525:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5334; /* pred_indexed_ustorervvm1hirvvm1hi */

    case 526:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5336; /* pred_indexed_ustorervvm2sirvvm1hi */

    case 527:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5338; /* pred_indexed_ustorervvm4dirvvm1hi */

    case 528:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5340; /* pred_indexed_ustorervvm1bfrvvm1hi */

    case 529:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5342; /* pred_indexed_ustorervvm1hfrvvm1hi */

    case 530:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5344; /* pred_indexed_ustorervvm2sfrvvm1hi */

    case 531:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5346; /* pred_indexed_ustorervvm4dfrvvm1hi */

    case 532:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24142; /* pred_indexed_ustorervvmf2x2qirvvm1hi */

    case 533:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24144; /* pred_indexed_ustorervvmf2x3qirvvm1hi */

    case 534:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24146; /* pred_indexed_ustorervvmf2x4qirvvm1hi */

    case 535:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24148; /* pred_indexed_ustorervvmf2x5qirvvm1hi */

    case 536:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24150; /* pred_indexed_ustorervvmf2x6qirvvm1hi */

    case 537:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24152; /* pred_indexed_ustorervvmf2x7qirvvm1hi */

    case 538:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24154; /* pred_indexed_ustorervvmf2x8qirvvm1hi */

    case 539:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24156; /* pred_indexed_ustorervvm1x2hirvvm1hi */

    case 540:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24158; /* pred_indexed_ustorervvm1x3hirvvm1hi */

    case 541:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24160; /* pred_indexed_ustorervvm1x4hirvvm1hi */

    case 542:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24162; /* pred_indexed_ustorervvm1x5hirvvm1hi */

    case 543:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24164; /* pred_indexed_ustorervvm1x6hirvvm1hi */

    case 544:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24166; /* pred_indexed_ustorervvm1x7hirvvm1hi */

    case 545:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24168; /* pred_indexed_ustorervvm1x8hirvvm1hi */

    case 546:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24170; /* pred_indexed_ustorervvm2x2sirvvm1hi */

    case 547:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24172; /* pred_indexed_ustorervvm2x3sirvvm1hi */

    case 548:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24174; /* pred_indexed_ustorervvm2x4sirvvm1hi */

    case 549:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24176; /* pred_indexed_ustorervvm4x2dirvvm1hi */

    case 550:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24178; /* pred_indexed_ustorervvm1x2bfrvvm1hi */

    case 551:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24180; /* pred_indexed_ustorervvm1x3bfrvvm1hi */

    case 552:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24182; /* pred_indexed_ustorervvm1x4bfrvvm1hi */

    case 553:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24184; /* pred_indexed_ustorervvm1x5bfrvvm1hi */

    case 554:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24186; /* pred_indexed_ustorervvm1x6bfrvvm1hi */

    case 555:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24188; /* pred_indexed_ustorervvm1x7bfrvvm1hi */

    case 556:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24190; /* pred_indexed_ustorervvm1x8bfrvvm1hi */

    case 557:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24192; /* pred_indexed_ustorervvm1x2hfrvvm1hi */

    case 558:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24194; /* pred_indexed_ustorervvm1x3hfrvvm1hi */

    case 559:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24196; /* pred_indexed_ustorervvm1x4hfrvvm1hi */

    case 560:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24198; /* pred_indexed_ustorervvm1x5hfrvvm1hi */

    case 561:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24200; /* pred_indexed_ustorervvm1x6hfrvvm1hi */

    case 562:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24202; /* pred_indexed_ustorervvm1x7hfrvvm1hi */

    case 563:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24204; /* pred_indexed_ustorervvm1x8hfrvvm1hi */

    case 564:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24206; /* pred_indexed_ustorervvm2x2sfrvvm1hi */

    case 565:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24208; /* pred_indexed_ustorervvm2x3sfrvvm1hi */

    case 566:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24210; /* pred_indexed_ustorervvm2x4sfrvvm1hi */

    case 567:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24212; /* pred_indexed_ustorervvm4x2dfrvvm1hi */

    case 568:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5348; /* pred_indexed_ustorervvmf2qirvvm2si */

    case 569:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5350; /* pred_indexed_ustorervvm1hirvvm2si */

    case 570:
      if (!
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5352; /* pred_indexed_ustorervvm2sirvvm2si */

    case 571:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5354; /* pred_indexed_ustorervvm4dirvvm2si */

    case 572:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5356; /* pred_indexed_ustorervvm1bfrvvm2si */

    case 573:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5358; /* pred_indexed_ustorervvm1hfrvvm2si */

    case 574:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5360; /* pred_indexed_ustorervvm2sfrvvm2si */

    case 575:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5362; /* pred_indexed_ustorervvm4dfrvvm2si */

    case 576:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24214; /* pred_indexed_ustorervvmf2x2qirvvm2si */

    case 577:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24216; /* pred_indexed_ustorervvmf2x3qirvvm2si */

    case 578:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24218; /* pred_indexed_ustorervvmf2x4qirvvm2si */

    case 579:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24220; /* pred_indexed_ustorervvmf2x5qirvvm2si */

    case 580:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24222; /* pred_indexed_ustorervvmf2x6qirvvm2si */

    case 581:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24224; /* pred_indexed_ustorervvmf2x7qirvvm2si */

    case 582:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24226; /* pred_indexed_ustorervvmf2x8qirvvm2si */

    case 583:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24228; /* pred_indexed_ustorervvm1x2hirvvm2si */

    case 584:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24230; /* pred_indexed_ustorervvm1x3hirvvm2si */

    case 585:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24232; /* pred_indexed_ustorervvm1x4hirvvm2si */

    case 586:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24234; /* pred_indexed_ustorervvm1x5hirvvm2si */

    case 587:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24236; /* pred_indexed_ustorervvm1x6hirvvm2si */

    case 588:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24238; /* pred_indexed_ustorervvm1x7hirvvm2si */

    case 589:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24240; /* pred_indexed_ustorervvm1x8hirvvm2si */

    case 590:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24242; /* pred_indexed_ustorervvm2x2sirvvm2si */

    case 591:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24244; /* pred_indexed_ustorervvm2x3sirvvm2si */

    case 592:
      if (!
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24246; /* pred_indexed_ustorervvm2x4sirvvm2si */

    case 593:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24248; /* pred_indexed_ustorervvm4x2dirvvm2si */

    case 594:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24250; /* pred_indexed_ustorervvm1x2bfrvvm2si */

    case 595:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24252; /* pred_indexed_ustorervvm1x3bfrvvm2si */

    case 596:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24254; /* pred_indexed_ustorervvm1x4bfrvvm2si */

    case 597:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24256; /* pred_indexed_ustorervvm1x5bfrvvm2si */

    case 598:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24258; /* pred_indexed_ustorervvm1x6bfrvvm2si */

    case 599:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24260; /* pred_indexed_ustorervvm1x7bfrvvm2si */

    case 600:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24262; /* pred_indexed_ustorervvm1x8bfrvvm2si */

    case 601:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24264; /* pred_indexed_ustorervvm1x2hfrvvm2si */

    case 602:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24266; /* pred_indexed_ustorervvm1x3hfrvvm2si */

    case 603:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24268; /* pred_indexed_ustorervvm1x4hfrvvm2si */

    case 604:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24270; /* pred_indexed_ustorervvm1x5hfrvvm2si */

    case 605:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24272; /* pred_indexed_ustorervvm1x6hfrvvm2si */

    case 606:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24274; /* pred_indexed_ustorervvm1x7hfrvvm2si */

    case 607:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24276; /* pred_indexed_ustorervvm1x8hfrvvm2si */

    case 608:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24278; /* pred_indexed_ustorervvm2x2sfrvvm2si */

    case 609:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24280; /* pred_indexed_ustorervvm2x3sfrvvm2si */

    case 610:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24282; /* pred_indexed_ustorervvm2x4sfrvvm2si */

    case 611:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24284; /* pred_indexed_ustorervvm4x2dfrvvm2si */

    case 612:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5364; /* pred_indexed_ustorervvmf2qirvvm4di */

    case 613:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5366; /* pred_indexed_ustorervvm1hirvvm4di */

    case 614:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5368; /* pred_indexed_ustorervvm2sirvvm4di */

    case 615:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 831 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5370; /* pred_indexed_ustorervvm4dirvvm4di */

    case 616:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5372; /* pred_indexed_ustorervvm1bfrvvm4di */

    case 617:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 833 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5374; /* pred_indexed_ustorervvm1hfrvvm4di */

    case 618:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 834 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5376; /* pred_indexed_ustorervvm2sfrvvm4di */

    case 619:
      if (!(
#line 2622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 835 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5378; /* pred_indexed_ustorervvm4dfrvvm4di */

    case 620:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24286; /* pred_indexed_ustorervvmf2x2qirvvm4di */

    case 621:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24288; /* pred_indexed_ustorervvmf2x3qirvvm4di */

    case 622:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24290; /* pred_indexed_ustorervvmf2x4qirvvm4di */

    case 623:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24292; /* pred_indexed_ustorervvmf2x5qirvvm4di */

    case 624:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24294; /* pred_indexed_ustorervvmf2x6qirvvm4di */

    case 625:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24296; /* pred_indexed_ustorervvmf2x7qirvvm4di */

    case 626:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24298; /* pred_indexed_ustorervvmf2x8qirvvm4di */

    case 627:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24300; /* pred_indexed_ustorervvm1x2hirvvm4di */

    case 628:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24302; /* pred_indexed_ustorervvm1x3hirvvm4di */

    case 629:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24304; /* pred_indexed_ustorervvm1x4hirvvm4di */

    case 630:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24306; /* pred_indexed_ustorervvm1x5hirvvm4di */

    case 631:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24308; /* pred_indexed_ustorervvm1x6hirvvm4di */

    case 632:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24310; /* pred_indexed_ustorervvm1x7hirvvm4di */

    case 633:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24312; /* pred_indexed_ustorervvm1x8hirvvm4di */

    case 634:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24314; /* pred_indexed_ustorervvm2x2sirvvm4di */

    case 635:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24316; /* pred_indexed_ustorervvm2x3sirvvm4di */

    case 636:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24318; /* pred_indexed_ustorervvm2x4sirvvm4di */

    case 637:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24320; /* pred_indexed_ustorervvm4x2dirvvm4di */

    case 638:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24322; /* pred_indexed_ustorervvm1x2bfrvvm4di */

    case 639:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24324; /* pred_indexed_ustorervvm1x3bfrvvm4di */

    case 640:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24326; /* pred_indexed_ustorervvm1x4bfrvvm4di */

    case 641:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24328; /* pred_indexed_ustorervvm1x5bfrvvm4di */

    case 642:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24330; /* pred_indexed_ustorervvm1x6bfrvvm4di */

    case 643:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24332; /* pred_indexed_ustorervvm1x7bfrvvm4di */

    case 644:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24334; /* pred_indexed_ustorervvm1x8bfrvvm4di */

    case 645:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24336; /* pred_indexed_ustorervvm1x2hfrvvm4di */

    case 646:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24338; /* pred_indexed_ustorervvm1x3hfrvvm4di */

    case 647:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24340; /* pred_indexed_ustorervvm1x4hfrvvm4di */

    case 648:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24342; /* pred_indexed_ustorervvm1x5hfrvvm4di */

    case 649:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24344; /* pred_indexed_ustorervvm1x6hfrvvm4di */

    case 650:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24346; /* pred_indexed_ustorervvm1x7hfrvvm4di */

    case 651:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24348; /* pred_indexed_ustorervvm1x8hfrvvm4di */

    case 652:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24350; /* pred_indexed_ustorervvm2x2sfrvvm4di */

    case 653:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24352; /* pred_indexed_ustorervvm2x3sfrvvm4di */

    case 654:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24354; /* pred_indexed_ustorervvm2x4sfrvvm4di */

    case 655:
      if (!(
#line 8643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24356; /* pred_indexed_ustorervvm4x2dfrvvm4di */

    case 656:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5380; /* pred_indexed_ustorervvm1qirvvm1qi */

    case 657:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5382; /* pred_indexed_ustorervvm2hirvvm1qi */

    case 658:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5384; /* pred_indexed_ustorervvm4sirvvm1qi */

    case 659:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5386; /* pred_indexed_ustorervvm8dirvvm1qi */

    case 660:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5388; /* pred_indexed_ustorervvm2bfrvvm1qi */

    case 661:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5390; /* pred_indexed_ustorervvm2hfrvvm1qi */

    case 662:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5392; /* pred_indexed_ustorervvm4sfrvvm1qi */

    case 663:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5394; /* pred_indexed_ustorervvm8dfrvvm1qi */

    case 664:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24358; /* pred_indexed_ustorervvm1x2qirvvm1qi */

    case 665:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24366; /* pred_indexed_ustorervvm1x3qirvvm1qi */

    case 666:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24374; /* pred_indexed_ustorervvm1x4qirvvm1qi */

    case 667:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24382; /* pred_indexed_ustorervvm1x5qirvvm1qi */

    case 668:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24390; /* pred_indexed_ustorervvm1x6qirvvm1qi */

    case 669:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24398; /* pred_indexed_ustorervvm1x7qirvvm1qi */

    case 670:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24406; /* pred_indexed_ustorervvm1x8qirvvm1qi */

    case 671:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24414; /* pred_indexed_ustorervvm2x2hirvvm1qi */

    case 672:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24422; /* pred_indexed_ustorervvm2x3hirvvm1qi */

    case 673:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24430; /* pred_indexed_ustorervvm2x4hirvvm1qi */

    case 674:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24438; /* pred_indexed_ustorervvm4x2sirvvm1qi */

    case 675:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24446; /* pred_indexed_ustorervvm2x2bfrvvm1qi */

    case 676:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24454; /* pred_indexed_ustorervvm2x3bfrvvm1qi */

    case 677:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24462; /* pred_indexed_ustorervvm2x4bfrvvm1qi */

    case 678:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24470; /* pred_indexed_ustorervvm2x2hfrvvm1qi */

    case 679:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24478; /* pred_indexed_ustorervvm2x3hfrvvm1qi */

    case 680:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24486; /* pred_indexed_ustorervvm2x4hfrvvm1qi */

    case 681:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24494; /* pred_indexed_ustorervvm4x2sfrvvm1qi */

    case 682:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5396; /* pred_indexed_ustorervvm1qirvvm2hi */

    case 683:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5398; /* pred_indexed_ustorervvm2hirvvm2hi */

    case 684:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5400; /* pred_indexed_ustorervvm4sirvvm2hi */

    case 685:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5402; /* pred_indexed_ustorervvm8dirvvm2hi */

    case 686:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5404; /* pred_indexed_ustorervvm2bfrvvm2hi */

    case 687:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5406; /* pred_indexed_ustorervvm2hfrvvm2hi */

    case 688:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5408; /* pred_indexed_ustorervvm4sfrvvm2hi */

    case 689:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5410; /* pred_indexed_ustorervvm8dfrvvm2hi */

    case 690:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24360; /* pred_indexed_ustorervvm1x2qirvvm2hi */

    case 691:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24368; /* pred_indexed_ustorervvm1x3qirvvm2hi */

    case 692:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24376; /* pred_indexed_ustorervvm1x4qirvvm2hi */

    case 693:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24384; /* pred_indexed_ustorervvm1x5qirvvm2hi */

    case 694:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24392; /* pred_indexed_ustorervvm1x6qirvvm2hi */

    case 695:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24400; /* pred_indexed_ustorervvm1x7qirvvm2hi */

    case 696:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24408; /* pred_indexed_ustorervvm1x8qirvvm2hi */

    case 697:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24416; /* pred_indexed_ustorervvm2x2hirvvm2hi */

    case 698:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24424; /* pred_indexed_ustorervvm2x3hirvvm2hi */

    case 699:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24432; /* pred_indexed_ustorervvm2x4hirvvm2hi */

    case 700:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24440; /* pred_indexed_ustorervvm4x2sirvvm2hi */

    case 701:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24448; /* pred_indexed_ustorervvm2x2bfrvvm2hi */

    case 702:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24456; /* pred_indexed_ustorervvm2x3bfrvvm2hi */

    case 703:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24464; /* pred_indexed_ustorervvm2x4bfrvvm2hi */

    case 704:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24472; /* pred_indexed_ustorervvm2x2hfrvvm2hi */

    case 705:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24480; /* pred_indexed_ustorervvm2x3hfrvvm2hi */

    case 706:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24488; /* pred_indexed_ustorervvm2x4hfrvvm2hi */

    case 707:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24496; /* pred_indexed_ustorervvm4x2sfrvvm2hi */

    case 708:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5412; /* pred_indexed_ustorervvm1qirvvm4si */

    case 709:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5414; /* pred_indexed_ustorervvm2hirvvm4si */

    case 710:
      if (!
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5416; /* pred_indexed_ustorervvm4sirvvm4si */

    case 711:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5418; /* pred_indexed_ustorervvm8dirvvm4si */

    case 712:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5420; /* pred_indexed_ustorervvm2bfrvvm4si */

    case 713:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5422; /* pred_indexed_ustorervvm2hfrvvm4si */

    case 714:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5424; /* pred_indexed_ustorervvm4sfrvvm4si */

    case 715:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5426; /* pred_indexed_ustorervvm8dfrvvm4si */

    case 716:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24362; /* pred_indexed_ustorervvm1x2qirvvm4si */

    case 717:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24370; /* pred_indexed_ustorervvm1x3qirvvm4si */

    case 718:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24378; /* pred_indexed_ustorervvm1x4qirvvm4si */

    case 719:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24386; /* pred_indexed_ustorervvm1x5qirvvm4si */

    case 720:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24394; /* pred_indexed_ustorervvm1x6qirvvm4si */

    case 721:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24402; /* pred_indexed_ustorervvm1x7qirvvm4si */

    case 722:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24410; /* pred_indexed_ustorervvm1x8qirvvm4si */

    case 723:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24418; /* pred_indexed_ustorervvm2x2hirvvm4si */

    case 724:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24426; /* pred_indexed_ustorervvm2x3hirvvm4si */

    case 725:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24434; /* pred_indexed_ustorervvm2x4hirvvm4si */

    case 726:
      if (!
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24442; /* pred_indexed_ustorervvm4x2sirvvm4si */

    case 727:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24450; /* pred_indexed_ustorervvm2x2bfrvvm4si */

    case 728:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24458; /* pred_indexed_ustorervvm2x3bfrvvm4si */

    case 729:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24466; /* pred_indexed_ustorervvm2x4bfrvvm4si */

    case 730:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24474; /* pred_indexed_ustorervvm2x2hfrvvm4si */

    case 731:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24482; /* pred_indexed_ustorervvm2x3hfrvvm4si */

    case 732:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24490; /* pred_indexed_ustorervvm2x4hfrvvm4si */

    case 733:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24498; /* pred_indexed_ustorervvm4x2sfrvvm4si */

    case 734:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5428; /* pred_indexed_ustorervvm1qirvvm8di */

    case 735:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5430; /* pred_indexed_ustorervvm2hirvvm8di */

    case 736:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5432; /* pred_indexed_ustorervvm4sirvvm8di */

    case 737:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 842 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5434; /* pred_indexed_ustorervvm8dirvvm8di */

    case 738:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 843 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5436; /* pred_indexed_ustorervvm2bfrvvm8di */

    case 739:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 844 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5438; /* pred_indexed_ustorervvm2hfrvvm8di */

    case 740:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 845 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5440; /* pred_indexed_ustorervvm4sfrvvm8di */

    case 741:
      if (!(
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5442; /* pred_indexed_ustorervvm8dfrvvm8di */

    case 742:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24364; /* pred_indexed_ustorervvm1x2qirvvm8di */

    case 743:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24372; /* pred_indexed_ustorervvm1x3qirvvm8di */

    case 744:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24380; /* pred_indexed_ustorervvm1x4qirvvm8di */

    case 745:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24388; /* pred_indexed_ustorervvm1x5qirvvm8di */

    case 746:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24396; /* pred_indexed_ustorervvm1x6qirvvm8di */

    case 747:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24404; /* pred_indexed_ustorervvm1x7qirvvm8di */

    case 748:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24412; /* pred_indexed_ustorervvm1x8qirvvm8di */

    case 749:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24420; /* pred_indexed_ustorervvm2x2hirvvm8di */

    case 750:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24428; /* pred_indexed_ustorervvm2x3hirvvm8di */

    case 751:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24436; /* pred_indexed_ustorervvm2x4hirvvm8di */

    case 752:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24444; /* pred_indexed_ustorervvm4x2sirvvm8di */

    case 753:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24452; /* pred_indexed_ustorervvm2x2bfrvvm8di */

    case 754:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24460; /* pred_indexed_ustorervvm2x3bfrvvm8di */

    case 755:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24468; /* pred_indexed_ustorervvm2x4bfrvvm8di */

    case 756:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24476; /* pred_indexed_ustorervvm2x2hfrvvm8di */

    case 757:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24484; /* pred_indexed_ustorervvm2x3hfrvvm8di */

    case 758:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24492; /* pred_indexed_ustorervvm2x4hfrvvm8di */

    case 759:
      if (!(
#line 8660 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24500; /* pred_indexed_ustorervvm4x2sfrvvm8di */

    case 760:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5444; /* pred_indexed_ustorervvm2qirvvm2qi */

    case 761:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5446; /* pred_indexed_ustorervvm4hirvvm2qi */

    case 762:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5448; /* pred_indexed_ustorervvm8sirvvm2qi */

    case 763:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5450; /* pred_indexed_ustorervvm4bfrvvm2qi */

    case 764:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5452; /* pred_indexed_ustorervvm4hfrvvm2qi */

    case 765:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5454; /* pred_indexed_ustorervvm8sfrvvm2qi */

    case 766:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24502; /* pred_indexed_ustorervvm2x2qirvvm2qi */

    case 767:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24508; /* pred_indexed_ustorervvm2x3qirvvm2qi */

    case 768:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24514; /* pred_indexed_ustorervvm2x4qirvvm2qi */

    case 769:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24520; /* pred_indexed_ustorervvm4x2hirvvm2qi */

    case 770:
      if (!(
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24526; /* pred_indexed_ustorervvm4x2bfrvvm2qi */

    case 771:
      if (!(
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24532; /* pred_indexed_ustorervvm4x2hfrvvm2qi */

    case 772:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5456; /* pred_indexed_ustorervvm2qirvvm4hi */

    case 773:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5458; /* pred_indexed_ustorervvm4hirvvm4hi */

    case 774:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5460; /* pred_indexed_ustorervvm8sirvvm4hi */

    case 775:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5462; /* pred_indexed_ustorervvm4bfrvvm4hi */

    case 776:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5464; /* pred_indexed_ustorervvm4hfrvvm4hi */

    case 777:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5466; /* pred_indexed_ustorervvm8sfrvvm4hi */

    case 778:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24504; /* pred_indexed_ustorervvm2x2qirvvm4hi */

    case 779:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24510; /* pred_indexed_ustorervvm2x3qirvvm4hi */

    case 780:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24516; /* pred_indexed_ustorervvm2x4qirvvm4hi */

    case 781:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24522; /* pred_indexed_ustorervvm4x2hirvvm4hi */

    case 782:
      if (!(
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24528; /* pred_indexed_ustorervvm4x2bfrvvm4hi */

    case 783:
      if (!(
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24534; /* pred_indexed_ustorervvm4x2hfrvvm4hi */

    case 784:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5468; /* pred_indexed_ustorervvm2qirvvm8si */

    case 785:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5470; /* pred_indexed_ustorervvm4hirvvm8si */

    case 786:
      if (!
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5472; /* pred_indexed_ustorervvm8sirvvm8si */

    case 787:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5474; /* pred_indexed_ustorervvm4bfrvvm8si */

    case 788:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5476; /* pred_indexed_ustorervvm4hfrvvm8si */

    case 789:
      if (!(
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5478; /* pred_indexed_ustorervvm8sfrvvm8si */

    case 790:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24506; /* pred_indexed_ustorervvm2x2qirvvm8si */

    case 791:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24512; /* pred_indexed_ustorervvm2x3qirvvm8si */

    case 792:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24518; /* pred_indexed_ustorervvm2x4qirvvm8si */

    case 793:
      if (!
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24524; /* pred_indexed_ustorervvm4x2hirvvm8si */

    case 794:
      if (!(
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24530; /* pred_indexed_ustorervvm4x2bfrvvm8si */

    case 795:
      if (!(
#line 8677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24536; /* pred_indexed_ustorervvm4x2hfrvvm8si */

    case 796:
      if (!
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5480; /* pred_indexed_ustorervvm4qirvvm4qi */

    case 797:
      if (!
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5482; /* pred_indexed_ustorervvm8hirvvm4qi */

    case 798:
      if (!(
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 861 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5484; /* pred_indexed_ustorervvm8bfrvvm4qi */

    case 799:
      if (!(
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 862 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5486; /* pred_indexed_ustorervvm8hfrvvm4qi */

    case 800:
      if (!
#line 8694 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24538; /* pred_indexed_ustorervvm4x2qirvvm4qi */

    case 801:
      if (!
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5488; /* pred_indexed_ustorervvm4qirvvm8hi */

    case 802:
      if (!
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5490; /* pred_indexed_ustorervvm8hirvvm8hi */

    case 803:
      if (!(
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 861 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5492; /* pred_indexed_ustorervvm8bfrvvm8hi */

    case 804:
      if (!(
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 862 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5494; /* pred_indexed_ustorervvm8hfrvvm8hi */

    case 805:
      if (!
#line 8694 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24540; /* pred_indexed_ustorervvm4x2qirvvm8hi */

    case 806:
      if (!
#line 2690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5496; /* pred_indexed_ustorervvm8qirvvm8qi */

    default:
      return -1;
    }
}

 int
recog_482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 4285; /* *pred_broadcastv2048qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4407; /* *pred_broadcastv2048qi_imm */
}

 int
recog_489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 4278; /* *pred_broadcastv16qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 4400; /* *pred_broadcastv16qi_imm */
}

 int
recog_496 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM4DFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4271; /* *pred_broadcastrvvm4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4DFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4393; /* *pred_broadcastrvvm4df_imm */
}

 int
recog_503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVMF4HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return 4264; /* *pred_broadcastrvvmf4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 4386; /* *pred_broadcastrvvmf4hf_imm */
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern669 (x2))
    {
    case 0:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4720; /* pred_indexed_uloadrvvm8qi_same_eew */

    case 1:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4722; /* pred_indexed_uloadrvvm4qi_same_eew */

    case 2:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5088; /* pred_indexed_uloadrvvm4qi_x2_smaller_eew */

    case 3:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4724; /* pred_indexed_uloadrvvm2qi_same_eew */

    case 4:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5090; /* pred_indexed_uloadrvvm2qi_x2_smaller_eew */

    case 5:
      if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5146; /* pred_indexed_uloadrvvm2qi_x4_smaller_eew */

    case 6:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4726; /* pred_indexed_uloadrvvm1qi_same_eew */

    case 7:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5092; /* pred_indexed_uloadrvvm1qi_x2_smaller_eew */

    case 8:
      if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5148; /* pred_indexed_uloadrvvm1qi_x4_smaller_eew */

    case 9:
      if (!(
#line 2571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 395 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5180; /* pred_indexed_uloadrvvm1qi_x8_smaller_eew */

    case 10:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4728; /* pred_indexed_uloadrvvmf2qi_same_eew */

    case 11:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5094; /* pred_indexed_uloadrvvmf2qi_x2_smaller_eew */

    case 12:
      if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5150; /* pred_indexed_uloadrvvmf2qi_x4_smaller_eew */

    case 13:
      if (!(
#line 2571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5182; /* pred_indexed_uloadrvvmf2qi_x8_smaller_eew */

    case 14:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4730; /* pred_indexed_uloadrvvmf4qi_same_eew */

    case 15:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5096; /* pred_indexed_uloadrvvmf4qi_x2_smaller_eew */

    case 16:
      if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5152; /* pred_indexed_uloadrvvmf4qi_x4_smaller_eew */

    case 17:
      if (!(
#line 2571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 397 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5184; /* pred_indexed_uloadrvvmf4qi_x8_smaller_eew */

    case 18:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4732; /* pred_indexed_uloadrvvmf8qi_same_eew */

    case 19:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 352 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5098; /* pred_indexed_uloadrvvmf8qi_x2_smaller_eew */

    case 20:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 376 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5154; /* pred_indexed_uloadrvvmf8qi_x4_smaller_eew */

    case 21:
      if (!(
#line 2571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 398 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5186; /* pred_indexed_uloadrvvmf8qi_x8_smaller_eew */

    case 22:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4734; /* pred_indexed_uloadrvvm8hi_same_eew */

    case 23:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4964; /* pred_indexed_uloadrvvm8hi_x2_greater_eew */

    case 24:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4736; /* pred_indexed_uloadrvvm4hi_same_eew */

    case 25:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4966; /* pred_indexed_uloadrvvm4hi_x2_greater_eew */

    case 26:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5100; /* pred_indexed_uloadrvvm4hi_x2_smaller_eew */

    case 27:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4738; /* pred_indexed_uloadrvvm2hi_same_eew */

    case 28:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4968; /* pred_indexed_uloadrvvm2hi_x2_greater_eew */

    case 29:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5102; /* pred_indexed_uloadrvvm2hi_x2_smaller_eew */

    case 30:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 378 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5156; /* pred_indexed_uloadrvvm2hi_x4_smaller_eew */

    case 31:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4740; /* pred_indexed_uloadrvvm1hi_same_eew */

    case 32:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4970; /* pred_indexed_uloadrvvm1hi_x2_greater_eew */

    case 33:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5104; /* pred_indexed_uloadrvvm1hi_x2_smaller_eew */

    case 34:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5158; /* pred_indexed_uloadrvvm1hi_x4_smaller_eew */

    case 35:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4742; /* pred_indexed_uloadrvvmf2hi_same_eew */

    case 36:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4972; /* pred_indexed_uloadrvvmf2hi_x2_greater_eew */

    case 37:
      if (!
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5106; /* pred_indexed_uloadrvvmf2hi_x2_smaller_eew */

    case 38:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 380 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5160; /* pred_indexed_uloadrvvmf2hi_x4_smaller_eew */

    case 39:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1544 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4744; /* pred_indexed_uloadrvvmf4hi_same_eew */

    case 40:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4974; /* pred_indexed_uloadrvvmf4hi_x2_greater_eew */

    case 41:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5108; /* pred_indexed_uloadrvvmf4hi_x2_smaller_eew */

    case 42:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 381 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5162; /* pred_indexed_uloadrvvmf4hi_x4_smaller_eew */

    case 43:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4746; /* pred_indexed_uloadrvvm8si_same_eew */

    case 44:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5000; /* pred_indexed_uloadrvvm8si_x2_greater_eew */

    case 45:
      if (!
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5036; /* pred_indexed_uloadrvvm8si_x4_greater_eew */

    case 46:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4748; /* pred_indexed_uloadrvvm4si_same_eew */

    case 47:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5002; /* pred_indexed_uloadrvvm4si_x2_greater_eew */

    case 48:
      if (!
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5038; /* pred_indexed_uloadrvvm4si_x4_greater_eew */

    case 49:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5130; /* pred_indexed_uloadrvvm4si_x2_smaller_eew */

    case 50:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4750; /* pred_indexed_uloadrvvm2si_same_eew */

    case 51:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5004; /* pred_indexed_uloadrvvm2si_x2_greater_eew */

    case 52:
      if (!
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5040; /* pred_indexed_uloadrvvm2si_x4_greater_eew */

    case 53:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 365 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5132; /* pred_indexed_uloadrvvm2si_x2_smaller_eew */

    case 54:
      if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4752; /* pred_indexed_uloadrvvm1si_same_eew */

    case 55:
      if (!
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5006; /* pred_indexed_uloadrvvm1si_x2_greater_eew */

    case 56:
      if (!
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5042; /* pred_indexed_uloadrvvm1si_x4_greater_eew */

    case 57:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 366 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5134; /* pred_indexed_uloadrvvm1si_x2_smaller_eew */

    case 58:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4754; /* pred_indexed_uloadrvvmf2si_same_eew */

    case 59:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5008; /* pred_indexed_uloadrvvmf2si_x2_greater_eew */

    case 60:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5044; /* pred_indexed_uloadrvvmf2si_x4_greater_eew */

    case 61:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 367 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5136; /* pred_indexed_uloadrvvmf2si_x2_smaller_eew */

    case 62:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4756; /* pred_indexed_uloadrvvm8di_same_eew */

    case 63:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5020; /* pred_indexed_uloadrvvm8di_x2_greater_eew */

    case 64:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5056; /* pred_indexed_uloadrvvm8di_x4_greater_eew */

    case 65:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5072; /* pred_indexed_uloadrvvm8di_x8_greater_eew */

    case 66:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1549 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4758; /* pred_indexed_uloadrvvm4di_same_eew */

    case 67:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5022; /* pred_indexed_uloadrvvm4di_x2_greater_eew */

    case 68:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5058; /* pred_indexed_uloadrvvm4di_x4_greater_eew */

    case 69:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5074; /* pred_indexed_uloadrvvm4di_x8_greater_eew */

    case 70:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4760; /* pred_indexed_uloadrvvm2di_same_eew */

    case 71:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5024; /* pred_indexed_uloadrvvm2di_x2_greater_eew */

    case 72:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5060; /* pred_indexed_uloadrvvm2di_x4_greater_eew */

    case 73:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5076; /* pred_indexed_uloadrvvm2di_x8_greater_eew */

    case 74:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4762; /* pred_indexed_uloadrvvm1di_same_eew */

    case 75:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5026; /* pred_indexed_uloadrvvm1di_x2_greater_eew */

    case 76:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5062; /* pred_indexed_uloadrvvm1di_x4_greater_eew */

    case 77:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5078; /* pred_indexed_uloadrvvm1di_x8_greater_eew */

    case 78:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4764; /* pred_indexed_uloadrvvm8bf_same_eew */

    case 79:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4976; /* pred_indexed_uloadrvvm8bf_x2_greater_eew */

    case 80:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1554 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4766; /* pred_indexed_uloadrvvm4bf_same_eew */

    case 81:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4978; /* pred_indexed_uloadrvvm4bf_x2_greater_eew */

    case 82:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5110; /* pred_indexed_uloadrvvm4bf_x2_smaller_eew */

    case 83:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4768; /* pred_indexed_uloadrvvm2bf_same_eew */

    case 84:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4980; /* pred_indexed_uloadrvvm2bf_x2_greater_eew */

    case 85:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5112; /* pred_indexed_uloadrvvm2bf_x2_smaller_eew */

    case 86:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 383 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5164; /* pred_indexed_uloadrvvm2bf_x4_smaller_eew */

    case 87:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4770; /* pred_indexed_uloadrvvm1bf_same_eew */

    case 88:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4982; /* pred_indexed_uloadrvvm1bf_x2_greater_eew */

    case 89:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5114; /* pred_indexed_uloadrvvm1bf_x2_smaller_eew */

    case 90:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5166; /* pred_indexed_uloadrvvm1bf_x4_smaller_eew */

    case 91:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4772; /* pred_indexed_uloadrvvmf2bf_same_eew */

    case 92:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4984; /* pred_indexed_uloadrvvmf2bf_x2_greater_eew */

    case 93:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5116; /* pred_indexed_uloadrvvmf2bf_x2_smaller_eew */

    case 94:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5168; /* pred_indexed_uloadrvvmf2bf_x4_smaller_eew */

    case 95:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1558 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4774; /* pred_indexed_uloadrvvmf4bf_same_eew */

    case 96:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4986; /* pred_indexed_uloadrvvmf4bf_x2_greater_eew */

    case 97:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 358 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5118; /* pred_indexed_uloadrvvmf4bf_x2_smaller_eew */

    case 98:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5170; /* pred_indexed_uloadrvvmf4bf_x4_smaller_eew */

    case 99:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4776; /* pred_indexed_uloadrvvm8hf_same_eew */

    case 100:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4988; /* pred_indexed_uloadrvvm8hf_x2_greater_eew */

    case 101:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4778; /* pred_indexed_uloadrvvm4hf_same_eew */

    case 102:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4990; /* pred_indexed_uloadrvvm4hf_x2_greater_eew */

    case 103:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5120; /* pred_indexed_uloadrvvm4hf_x2_smaller_eew */

    case 104:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4780; /* pred_indexed_uloadrvvm2hf_same_eew */

    case 105:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4992; /* pred_indexed_uloadrvvm2hf_x2_greater_eew */

    case 106:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5122; /* pred_indexed_uloadrvvm2hf_x2_smaller_eew */

    case 107:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 388 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5172; /* pred_indexed_uloadrvvm2hf_x4_smaller_eew */

    case 108:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4782; /* pred_indexed_uloadrvvm1hf_same_eew */

    case 109:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4994; /* pred_indexed_uloadrvvm1hf_x2_greater_eew */

    case 110:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5124; /* pred_indexed_uloadrvvm1hf_x2_smaller_eew */

    case 111:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5174; /* pred_indexed_uloadrvvm1hf_x4_smaller_eew */

    case 112:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4784; /* pred_indexed_uloadrvvmf2hf_same_eew */

    case 113:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4996; /* pred_indexed_uloadrvvmf2hf_x2_greater_eew */

    case 114:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5126; /* pred_indexed_uloadrvvmf2hf_x2_smaller_eew */

    case 115:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 390 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5176; /* pred_indexed_uloadrvvmf2hf_x4_smaller_eew */

    case 116:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1562 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4786; /* pred_indexed_uloadrvvmf4hf_same_eew */

    case 117:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 316 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4998; /* pred_indexed_uloadrvvmf4hf_x2_greater_eew */

    case 118:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 362 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5128; /* pred_indexed_uloadrvvmf4hf_x2_smaller_eew */

    case 119:
      if (!(
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 391 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5178; /* pred_indexed_uloadrvvmf4hf_x4_smaller_eew */

    case 120:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4788; /* pred_indexed_uloadrvvm8sf_same_eew */

    case 121:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5010; /* pred_indexed_uloadrvvm8sf_x2_greater_eew */

    case 122:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5046; /* pred_indexed_uloadrvvm8sf_x4_greater_eew */

    case 123:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4790; /* pred_indexed_uloadrvvm4sf_same_eew */

    case 124:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5012; /* pred_indexed_uloadrvvm4sf_x2_greater_eew */

    case 125:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5048; /* pred_indexed_uloadrvvm4sf_x4_greater_eew */

    case 126:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 369 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5138; /* pred_indexed_uloadrvvm4sf_x2_smaller_eew */

    case 127:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4792; /* pred_indexed_uloadrvvm2sf_same_eew */

    case 128:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5014; /* pred_indexed_uloadrvvm2sf_x2_greater_eew */

    case 129:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5050; /* pred_indexed_uloadrvvm2sf_x4_greater_eew */

    case 130:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 370 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5140; /* pred_indexed_uloadrvvm2sf_x2_smaller_eew */

    case 131:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4794; /* pred_indexed_uloadrvvm1sf_same_eew */

    case 132:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5016; /* pred_indexed_uloadrvvm1sf_x2_greater_eew */

    case 133:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5052; /* pred_indexed_uloadrvvm1sf_x4_greater_eew */

    case 134:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5142; /* pred_indexed_uloadrvvm1sf_x2_smaller_eew */

    case 135:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1566 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4796; /* pred_indexed_uloadrvvmf2sf_same_eew */

    case 136:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5018; /* pred_indexed_uloadrvvmf2sf_x2_greater_eew */

    case 137:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5054; /* pred_indexed_uloadrvvmf2sf_x4_greater_eew */

    case 138:
      if (!(
#line 2529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 372 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5144; /* pred_indexed_uloadrvvmf2sf_x2_smaller_eew */

    case 139:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4798; /* pred_indexed_uloadrvvm8df_same_eew */

    case 140:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5028; /* pred_indexed_uloadrvvm8df_x2_greater_eew */

    case 141:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5064; /* pred_indexed_uloadrvvm8df_x4_greater_eew */

    case 142:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5080; /* pred_indexed_uloadrvvm8df_x8_greater_eew */

    case 143:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4800; /* pred_indexed_uloadrvvm4df_same_eew */

    case 144:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5030; /* pred_indexed_uloadrvvm4df_x2_greater_eew */

    case 145:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5066; /* pred_indexed_uloadrvvm4df_x4_greater_eew */

    case 146:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5082; /* pred_indexed_uloadrvvm4df_x8_greater_eew */

    case 147:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4802; /* pred_indexed_uloadrvvm2df_same_eew */

    case 148:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5032; /* pred_indexed_uloadrvvm2df_x2_greater_eew */

    case 149:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5068; /* pred_indexed_uloadrvvm2df_x4_greater_eew */

    case 150:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5084; /* pred_indexed_uloadrvvm2df_x8_greater_eew */

    case 151:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4804; /* pred_indexed_uloadrvvm1df_same_eew */

    case 152:
      if (!(
#line 2465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5034; /* pred_indexed_uloadrvvm1df_x2_greater_eew */

    case 153:
      if (!(
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5070; /* pred_indexed_uloadrvvm1df_x4_greater_eew */

    case 154:
      if (!(
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5086; /* pred_indexed_uloadrvvm1df_x8_greater_eew */

    case 155:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4806; /* pred_indexed_uloadv1qi_same_eew */

    case 156:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4808; /* pred_indexed_uloadv2qi_same_eew */

    case 157:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4810; /* pred_indexed_uloadv4qi_same_eew */

    case 158:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4812; /* pred_indexed_uloadv8qi_same_eew */

    case 159:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4814; /* pred_indexed_uloadv16qi_same_eew */

    case 160:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4816; /* pred_indexed_uloadv32qi_same_eew */

    case 161:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4818; /* pred_indexed_uloadv64qi_same_eew */

    case 162:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4820; /* pred_indexed_uloadv128qi_same_eew */

    case 163:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4822; /* pred_indexed_uloadv256qi_same_eew */

    case 164:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4824; /* pred_indexed_uloadv512qi_same_eew */

    case 165:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4826; /* pred_indexed_uloadv1024qi_same_eew */

    case 166:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4828; /* pred_indexed_uloadv2048qi_same_eew */

    case 167:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4830; /* pred_indexed_uloadv4096qi_same_eew */

    case 168:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4832; /* pred_indexed_uloadv1hi_same_eew */

    case 169:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4834; /* pred_indexed_uloadv2hi_same_eew */

    case 170:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4836; /* pred_indexed_uloadv4hi_same_eew */

    case 171:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4838; /* pred_indexed_uloadv8hi_same_eew */

    case 172:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4840; /* pred_indexed_uloadv16hi_same_eew */

    case 173:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4842; /* pred_indexed_uloadv32hi_same_eew */

    case 174:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4844; /* pred_indexed_uloadv64hi_same_eew */

    case 175:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4846; /* pred_indexed_uloadv128hi_same_eew */

    case 176:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4848; /* pred_indexed_uloadv256hi_same_eew */

    case 177:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4850; /* pred_indexed_uloadv512hi_same_eew */

    case 178:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4852; /* pred_indexed_uloadv1024hi_same_eew */

    case 179:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4854; /* pred_indexed_uloadv2048hi_same_eew */

    case 180:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4856; /* pred_indexed_uloadv1si_same_eew */

    case 181:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4858; /* pred_indexed_uloadv2si_same_eew */

    case 182:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4860; /* pred_indexed_uloadv4si_same_eew */

    case 183:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4862; /* pred_indexed_uloadv8si_same_eew */

    case 184:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4864; /* pred_indexed_uloadv16si_same_eew */

    case 185:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4866; /* pred_indexed_uloadv32si_same_eew */

    case 186:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4868; /* pred_indexed_uloadv64si_same_eew */

    case 187:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4870; /* pred_indexed_uloadv128si_same_eew */

    case 188:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4872; /* pred_indexed_uloadv256si_same_eew */

    case 189:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4874; /* pred_indexed_uloadv512si_same_eew */

    case 190:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4876; /* pred_indexed_uloadv1024si_same_eew */

    case 191:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1609 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4878; /* pred_indexed_uloadv1di_same_eew */

    case 192:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4880; /* pred_indexed_uloadv2di_same_eew */

    case 193:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1611 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4882; /* pred_indexed_uloadv4di_same_eew */

    case 194:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1612 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4884; /* pred_indexed_uloadv8di_same_eew */

    case 195:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4886; /* pred_indexed_uloadv16di_same_eew */

    case 196:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1614 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4888; /* pred_indexed_uloadv32di_same_eew */

    case 197:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1615 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4890; /* pred_indexed_uloadv64di_same_eew */

    case 198:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1616 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4892; /* pred_indexed_uloadv128di_same_eew */

    case 199:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1617 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4894; /* pred_indexed_uloadv256di_same_eew */

    case 200:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1618 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4896; /* pred_indexed_uloadv512di_same_eew */

    case 201:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 4898; /* pred_indexed_uloadv1hf_same_eew */

    case 202:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1621 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 4900; /* pred_indexed_uloadv2hf_same_eew */

    case 203:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 4902; /* pred_indexed_uloadv4hf_same_eew */

    case 204:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1623 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 4904; /* pred_indexed_uloadv8hf_same_eew */

    case 205:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1624 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 4906; /* pred_indexed_uloadv16hf_same_eew */

    case 206:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1625 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4908; /* pred_indexed_uloadv32hf_same_eew */

    case 207:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1626 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4910; /* pred_indexed_uloadv64hf_same_eew */

    case 208:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1627 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4912; /* pred_indexed_uloadv128hf_same_eew */

    case 209:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1628 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4914; /* pred_indexed_uloadv256hf_same_eew */

    case 210:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4916; /* pred_indexed_uloadv512hf_same_eew */

    case 211:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4918; /* pred_indexed_uloadv1024hf_same_eew */

    case 212:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4920; /* pred_indexed_uloadv2048hf_same_eew */

    case 213:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4922; /* pred_indexed_uloadv1sf_same_eew */

    case 214:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1633 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4924; /* pred_indexed_uloadv2sf_same_eew */

    case 215:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1634 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4926; /* pred_indexed_uloadv4sf_same_eew */

    case 216:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1635 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4928; /* pred_indexed_uloadv8sf_same_eew */

    case 217:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1636 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4930; /* pred_indexed_uloadv16sf_same_eew */

    case 218:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4932; /* pred_indexed_uloadv32sf_same_eew */

    case 219:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1638 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4934; /* pred_indexed_uloadv64sf_same_eew */

    case 220:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4936; /* pred_indexed_uloadv128sf_same_eew */

    case 221:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4938; /* pred_indexed_uloadv256sf_same_eew */

    case 222:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1641 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4940; /* pred_indexed_uloadv512sf_same_eew */

    case 223:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1642 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4942; /* pred_indexed_uloadv1024sf_same_eew */

    case 224:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1643 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4944; /* pred_indexed_uloadv1df_same_eew */

    case 225:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1644 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4946; /* pred_indexed_uloadv2df_same_eew */

    case 226:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1645 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4948; /* pred_indexed_uloadv4df_same_eew */

    case 227:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1646 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4950; /* pred_indexed_uloadv8df_same_eew */

    case 228:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4952; /* pred_indexed_uloadv16df_same_eew */

    case 229:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1648 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4954; /* pred_indexed_uloadv32df_same_eew */

    case 230:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4956; /* pred_indexed_uloadv64df_same_eew */

    case 231:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1650 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4958; /* pred_indexed_uloadv128df_same_eew */

    case 232:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1651 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4960; /* pred_indexed_uloadv256df_same_eew */

    case 233:
      if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1652 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4962; /* pred_indexed_uloadv512df_same_eew */

    case 234:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21934; /* pred_indexed_uloadrvvmf8x2qirvvmf8qi */

    case 235:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21936; /* pred_indexed_uloadrvvmf8x2qirvvmf4hi */

    case 236:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21938; /* pred_indexed_uloadrvvmf8x2qirvvmf2si */

    case 237:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21940; /* pred_indexed_uloadrvvmf8x2qirvvm1di */

    case 238:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21942; /* pred_indexed_uloadrvvmf8x3qirvvmf8qi */

    case 239:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21944; /* pred_indexed_uloadrvvmf8x3qirvvmf4hi */

    case 240:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21946; /* pred_indexed_uloadrvvmf8x3qirvvmf2si */

    case 241:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21948; /* pred_indexed_uloadrvvmf8x3qirvvm1di */

    case 242:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21950; /* pred_indexed_uloadrvvmf8x4qirvvmf8qi */

    case 243:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21952; /* pred_indexed_uloadrvvmf8x4qirvvmf4hi */

    case 244:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21954; /* pred_indexed_uloadrvvmf8x4qirvvmf2si */

    case 245:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21956; /* pred_indexed_uloadrvvmf8x4qirvvm1di */

    case 246:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21958; /* pred_indexed_uloadrvvmf8x5qirvvmf8qi */

    case 247:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21960; /* pred_indexed_uloadrvvmf8x5qirvvmf4hi */

    case 248:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21962; /* pred_indexed_uloadrvvmf8x5qirvvmf2si */

    case 249:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21964; /* pred_indexed_uloadrvvmf8x5qirvvm1di */

    case 250:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21966; /* pred_indexed_uloadrvvmf8x6qirvvmf8qi */

    case 251:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21968; /* pred_indexed_uloadrvvmf8x6qirvvmf4hi */

    case 252:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21970; /* pred_indexed_uloadrvvmf8x6qirvvmf2si */

    case 253:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21972; /* pred_indexed_uloadrvvmf8x6qirvvm1di */

    case 254:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21974; /* pred_indexed_uloadrvvmf8x7qirvvmf8qi */

    case 255:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21976; /* pred_indexed_uloadrvvmf8x7qirvvmf4hi */

    case 256:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21978; /* pred_indexed_uloadrvvmf8x7qirvvmf2si */

    case 257:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21980; /* pred_indexed_uloadrvvmf8x7qirvvm1di */

    case 258:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21982; /* pred_indexed_uloadrvvmf8x8qirvvmf8qi */

    case 259:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21984; /* pred_indexed_uloadrvvmf8x8qirvvmf4hi */

    case 260:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21986; /* pred_indexed_uloadrvvmf8x8qirvvmf2si */

    case 261:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21988; /* pred_indexed_uloadrvvmf8x8qirvvm1di */

    case 262:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21990; /* pred_indexed_uloadrvvmf4x2hirvvmf8qi */

    case 263:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21992; /* pred_indexed_uloadrvvmf4x2hirvvmf4hi */

    case 264:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21994; /* pred_indexed_uloadrvvmf4x2hirvvmf2si */

    case 265:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21996; /* pred_indexed_uloadrvvmf4x2hirvvm1di */

    case 266:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21998; /* pred_indexed_uloadrvvmf4x3hirvvmf8qi */

    case 267:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22000; /* pred_indexed_uloadrvvmf4x3hirvvmf4hi */

    case 268:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22002; /* pred_indexed_uloadrvvmf4x3hirvvmf2si */

    case 269:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22004; /* pred_indexed_uloadrvvmf4x3hirvvm1di */

    case 270:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22006; /* pred_indexed_uloadrvvmf4x4hirvvmf8qi */

    case 271:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22008; /* pred_indexed_uloadrvvmf4x4hirvvmf4hi */

    case 272:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22010; /* pred_indexed_uloadrvvmf4x4hirvvmf2si */

    case 273:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22012; /* pred_indexed_uloadrvvmf4x4hirvvm1di */

    case 274:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22014; /* pred_indexed_uloadrvvmf4x5hirvvmf8qi */

    case 275:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22016; /* pred_indexed_uloadrvvmf4x5hirvvmf4hi */

    case 276:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22018; /* pred_indexed_uloadrvvmf4x5hirvvmf2si */

    case 277:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22020; /* pred_indexed_uloadrvvmf4x5hirvvm1di */

    case 278:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22022; /* pred_indexed_uloadrvvmf4x6hirvvmf8qi */

    case 279:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22024; /* pred_indexed_uloadrvvmf4x6hirvvmf4hi */

    case 280:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22026; /* pred_indexed_uloadrvvmf4x6hirvvmf2si */

    case 281:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22028; /* pred_indexed_uloadrvvmf4x6hirvvm1di */

    case 282:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22030; /* pred_indexed_uloadrvvmf4x7hirvvmf8qi */

    case 283:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22032; /* pred_indexed_uloadrvvmf4x7hirvvmf4hi */

    case 284:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22034; /* pred_indexed_uloadrvvmf4x7hirvvmf2si */

    case 285:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22036; /* pred_indexed_uloadrvvmf4x7hirvvm1di */

    case 286:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22038; /* pred_indexed_uloadrvvmf4x8hirvvmf8qi */

    case 287:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22040; /* pred_indexed_uloadrvvmf4x8hirvvmf4hi */

    case 288:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22042; /* pred_indexed_uloadrvvmf4x8hirvvmf2si */

    case 289:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22044; /* pred_indexed_uloadrvvmf4x8hirvvm1di */

    case 290:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22046; /* pred_indexed_uloadrvvmf2x2sirvvmf8qi */

    case 291:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22048; /* pred_indexed_uloadrvvmf2x2sirvvmf4hi */

    case 292:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22050; /* pred_indexed_uloadrvvmf2x2sirvvmf2si */

    case 293:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22052; /* pred_indexed_uloadrvvmf2x2sirvvm1di */

    case 294:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22054; /* pred_indexed_uloadrvvmf2x3sirvvmf8qi */

    case 295:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22056; /* pred_indexed_uloadrvvmf2x3sirvvmf4hi */

    case 296:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22058; /* pred_indexed_uloadrvvmf2x3sirvvmf2si */

    case 297:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22060; /* pred_indexed_uloadrvvmf2x3sirvvm1di */

    case 298:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22062; /* pred_indexed_uloadrvvmf2x4sirvvmf8qi */

    case 299:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22064; /* pred_indexed_uloadrvvmf2x4sirvvmf4hi */

    case 300:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22066; /* pred_indexed_uloadrvvmf2x4sirvvmf2si */

    case 301:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22068; /* pred_indexed_uloadrvvmf2x4sirvvm1di */

    case 302:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22070; /* pred_indexed_uloadrvvmf2x5sirvvmf8qi */

    case 303:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22072; /* pred_indexed_uloadrvvmf2x5sirvvmf4hi */

    case 304:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22074; /* pred_indexed_uloadrvvmf2x5sirvvmf2si */

    case 305:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22076; /* pred_indexed_uloadrvvmf2x5sirvvm1di */

    case 306:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22078; /* pred_indexed_uloadrvvmf2x6sirvvmf8qi */

    case 307:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22080; /* pred_indexed_uloadrvvmf2x6sirvvmf4hi */

    case 308:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22082; /* pred_indexed_uloadrvvmf2x6sirvvmf2si */

    case 309:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22084; /* pred_indexed_uloadrvvmf2x6sirvvm1di */

    case 310:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22086; /* pred_indexed_uloadrvvmf2x7sirvvmf8qi */

    case 311:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22088; /* pred_indexed_uloadrvvmf2x7sirvvmf4hi */

    case 312:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22090; /* pred_indexed_uloadrvvmf2x7sirvvmf2si */

    case 313:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22092; /* pred_indexed_uloadrvvmf2x7sirvvm1di */

    case 314:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22094; /* pred_indexed_uloadrvvmf2x8sirvvmf8qi */

    case 315:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22096; /* pred_indexed_uloadrvvmf2x8sirvvmf4hi */

    case 316:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22098; /* pred_indexed_uloadrvvmf2x8sirvvmf2si */

    case 317:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22100; /* pred_indexed_uloadrvvmf2x8sirvvm1di */

    case 318:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22102; /* pred_indexed_uloadrvvm1x2dirvvmf8qi */

    case 319:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22104; /* pred_indexed_uloadrvvm1x2dirvvmf4hi */

    case 320:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22106; /* pred_indexed_uloadrvvm1x2dirvvmf2si */

    case 321:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22108; /* pred_indexed_uloadrvvm1x2dirvvm1di */

    case 322:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22110; /* pred_indexed_uloadrvvm1x3dirvvmf8qi */

    case 323:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22112; /* pred_indexed_uloadrvvm1x3dirvvmf4hi */

    case 324:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22114; /* pred_indexed_uloadrvvm1x3dirvvmf2si */

    case 325:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22116; /* pred_indexed_uloadrvvm1x3dirvvm1di */

    case 326:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22118; /* pred_indexed_uloadrvvm1x4dirvvmf8qi */

    case 327:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22120; /* pred_indexed_uloadrvvm1x4dirvvmf4hi */

    case 328:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22122; /* pred_indexed_uloadrvvm1x4dirvvmf2si */

    case 329:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22124; /* pred_indexed_uloadrvvm1x4dirvvm1di */

    case 330:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22126; /* pred_indexed_uloadrvvm1x5dirvvmf8qi */

    case 331:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22128; /* pred_indexed_uloadrvvm1x5dirvvmf4hi */

    case 332:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22130; /* pred_indexed_uloadrvvm1x5dirvvmf2si */

    case 333:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22132; /* pred_indexed_uloadrvvm1x5dirvvm1di */

    case 334:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22134; /* pred_indexed_uloadrvvm1x6dirvvmf8qi */

    case 335:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22136; /* pred_indexed_uloadrvvm1x6dirvvmf4hi */

    case 336:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22138; /* pred_indexed_uloadrvvm1x6dirvvmf2si */

    case 337:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22140; /* pred_indexed_uloadrvvm1x6dirvvm1di */

    case 338:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22142; /* pred_indexed_uloadrvvm1x7dirvvmf8qi */

    case 339:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22144; /* pred_indexed_uloadrvvm1x7dirvvmf4hi */

    case 340:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22146; /* pred_indexed_uloadrvvm1x7dirvvmf2si */

    case 341:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22148; /* pred_indexed_uloadrvvm1x7dirvvm1di */

    case 342:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22150; /* pred_indexed_uloadrvvm1x8dirvvmf8qi */

    case 343:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22152; /* pred_indexed_uloadrvvm1x8dirvvmf4hi */

    case 344:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22154; /* pred_indexed_uloadrvvm1x8dirvvmf2si */

    case 345:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22156; /* pred_indexed_uloadrvvm1x8dirvvm1di */

    case 346:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22158; /* pred_indexed_uloadrvvmf4x2bfrvvmf8qi */

    case 347:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22160; /* pred_indexed_uloadrvvmf4x2bfrvvmf4hi */

    case 348:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22162; /* pred_indexed_uloadrvvmf4x2bfrvvmf2si */

    case 349:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22164; /* pred_indexed_uloadrvvmf4x2bfrvvm1di */

    case 350:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22166; /* pred_indexed_uloadrvvmf4x3bfrvvmf8qi */

    case 351:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22168; /* pred_indexed_uloadrvvmf4x3bfrvvmf4hi */

    case 352:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22170; /* pred_indexed_uloadrvvmf4x3bfrvvmf2si */

    case 353:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22172; /* pred_indexed_uloadrvvmf4x3bfrvvm1di */

    case 354:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22174; /* pred_indexed_uloadrvvmf4x4bfrvvmf8qi */

    case 355:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22176; /* pred_indexed_uloadrvvmf4x4bfrvvmf4hi */

    case 356:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22178; /* pred_indexed_uloadrvvmf4x4bfrvvmf2si */

    case 357:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22180; /* pred_indexed_uloadrvvmf4x4bfrvvm1di */

    case 358:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22182; /* pred_indexed_uloadrvvmf4x5bfrvvmf8qi */

    case 359:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22184; /* pred_indexed_uloadrvvmf4x5bfrvvmf4hi */

    case 360:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22186; /* pred_indexed_uloadrvvmf4x5bfrvvmf2si */

    case 361:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22188; /* pred_indexed_uloadrvvmf4x5bfrvvm1di */

    case 362:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22190; /* pred_indexed_uloadrvvmf4x6bfrvvmf8qi */

    case 363:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22192; /* pred_indexed_uloadrvvmf4x6bfrvvmf4hi */

    case 364:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22194; /* pred_indexed_uloadrvvmf4x6bfrvvmf2si */

    case 365:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22196; /* pred_indexed_uloadrvvmf4x6bfrvvm1di */

    case 366:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22198; /* pred_indexed_uloadrvvmf4x7bfrvvmf8qi */

    case 367:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22200; /* pred_indexed_uloadrvvmf4x7bfrvvmf4hi */

    case 368:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22202; /* pred_indexed_uloadrvvmf4x7bfrvvmf2si */

    case 369:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22204; /* pred_indexed_uloadrvvmf4x7bfrvvm1di */

    case 370:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22206; /* pred_indexed_uloadrvvmf4x8bfrvvmf8qi */

    case 371:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22208; /* pred_indexed_uloadrvvmf4x8bfrvvmf4hi */

    case 372:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22210; /* pred_indexed_uloadrvvmf4x8bfrvvmf2si */

    case 373:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22212; /* pred_indexed_uloadrvvmf4x8bfrvvm1di */

    case 374:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22214; /* pred_indexed_uloadrvvmf4x2hfrvvmf8qi */

    case 375:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22216; /* pred_indexed_uloadrvvmf4x2hfrvvmf4hi */

    case 376:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22218; /* pred_indexed_uloadrvvmf4x2hfrvvmf2si */

    case 377:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22220; /* pred_indexed_uloadrvvmf4x2hfrvvm1di */

    case 378:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22222; /* pred_indexed_uloadrvvmf4x3hfrvvmf8qi */

    case 379:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22224; /* pred_indexed_uloadrvvmf4x3hfrvvmf4hi */

    case 380:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22226; /* pred_indexed_uloadrvvmf4x3hfrvvmf2si */

    case 381:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22228; /* pred_indexed_uloadrvvmf4x3hfrvvm1di */

    case 382:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22230; /* pred_indexed_uloadrvvmf4x4hfrvvmf8qi */

    case 383:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22232; /* pred_indexed_uloadrvvmf4x4hfrvvmf4hi */

    case 384:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22234; /* pred_indexed_uloadrvvmf4x4hfrvvmf2si */

    case 385:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22236; /* pred_indexed_uloadrvvmf4x4hfrvvm1di */

    case 386:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22238; /* pred_indexed_uloadrvvmf4x5hfrvvmf8qi */

    case 387:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22240; /* pred_indexed_uloadrvvmf4x5hfrvvmf4hi */

    case 388:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22242; /* pred_indexed_uloadrvvmf4x5hfrvvmf2si */

    case 389:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22244; /* pred_indexed_uloadrvvmf4x5hfrvvm1di */

    case 390:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22246; /* pred_indexed_uloadrvvmf4x6hfrvvmf8qi */

    case 391:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22248; /* pred_indexed_uloadrvvmf4x6hfrvvmf4hi */

    case 392:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22250; /* pred_indexed_uloadrvvmf4x6hfrvvmf2si */

    case 393:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22252; /* pred_indexed_uloadrvvmf4x6hfrvvm1di */

    case 394:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22254; /* pred_indexed_uloadrvvmf4x7hfrvvmf8qi */

    case 395:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22256; /* pred_indexed_uloadrvvmf4x7hfrvvmf4hi */

    case 396:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22258; /* pred_indexed_uloadrvvmf4x7hfrvvmf2si */

    case 397:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22260; /* pred_indexed_uloadrvvmf4x7hfrvvm1di */

    case 398:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22262; /* pred_indexed_uloadrvvmf4x8hfrvvmf8qi */

    case 399:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22264; /* pred_indexed_uloadrvvmf4x8hfrvvmf4hi */

    case 400:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22266; /* pred_indexed_uloadrvvmf4x8hfrvvmf2si */

    case 401:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22268; /* pred_indexed_uloadrvvmf4x8hfrvvm1di */

    case 402:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22270; /* pred_indexed_uloadrvvmf2x2sfrvvmf8qi */

    case 403:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22272; /* pred_indexed_uloadrvvmf2x2sfrvvmf4hi */

    case 404:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22274; /* pred_indexed_uloadrvvmf2x2sfrvvmf2si */

    case 405:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22276; /* pred_indexed_uloadrvvmf2x2sfrvvm1di */

    case 406:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22278; /* pred_indexed_uloadrvvmf2x3sfrvvmf8qi */

    case 407:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22280; /* pred_indexed_uloadrvvmf2x3sfrvvmf4hi */

    case 408:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22282; /* pred_indexed_uloadrvvmf2x3sfrvvmf2si */

    case 409:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22284; /* pred_indexed_uloadrvvmf2x3sfrvvm1di */

    case 410:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22286; /* pred_indexed_uloadrvvmf2x4sfrvvmf8qi */

    case 411:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22288; /* pred_indexed_uloadrvvmf2x4sfrvvmf4hi */

    case 412:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22290; /* pred_indexed_uloadrvvmf2x4sfrvvmf2si */

    case 413:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22292; /* pred_indexed_uloadrvvmf2x4sfrvvm1di */

    case 414:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22294; /* pred_indexed_uloadrvvmf2x5sfrvvmf8qi */

    case 415:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22296; /* pred_indexed_uloadrvvmf2x5sfrvvmf4hi */

    case 416:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22298; /* pred_indexed_uloadrvvmf2x5sfrvvmf2si */

    case 417:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22300; /* pred_indexed_uloadrvvmf2x5sfrvvm1di */

    case 418:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22302; /* pred_indexed_uloadrvvmf2x6sfrvvmf8qi */

    case 419:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22304; /* pred_indexed_uloadrvvmf2x6sfrvvmf4hi */

    case 420:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22306; /* pred_indexed_uloadrvvmf2x6sfrvvmf2si */

    case 421:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22308; /* pred_indexed_uloadrvvmf2x6sfrvvm1di */

    case 422:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22310; /* pred_indexed_uloadrvvmf2x7sfrvvmf8qi */

    case 423:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22312; /* pred_indexed_uloadrvvmf2x7sfrvvmf4hi */

    case 424:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22314; /* pred_indexed_uloadrvvmf2x7sfrvvmf2si */

    case 425:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22316; /* pred_indexed_uloadrvvmf2x7sfrvvm1di */

    case 426:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22318; /* pred_indexed_uloadrvvmf2x8sfrvvmf8qi */

    case 427:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22320; /* pred_indexed_uloadrvvmf2x8sfrvvmf4hi */

    case 428:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22322; /* pred_indexed_uloadrvvmf2x8sfrvvmf2si */

    case 429:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22324; /* pred_indexed_uloadrvvmf2x8sfrvvm1di */

    case 430:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22326; /* pred_indexed_uloadrvvm1x2dfrvvmf8qi */

    case 431:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22328; /* pred_indexed_uloadrvvm1x2dfrvvmf4hi */

    case 432:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22330; /* pred_indexed_uloadrvvm1x2dfrvvmf2si */

    case 433:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22332; /* pred_indexed_uloadrvvm1x2dfrvvm1di */

    case 434:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22334; /* pred_indexed_uloadrvvm1x3dfrvvmf8qi */

    case 435:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22336; /* pred_indexed_uloadrvvm1x3dfrvvmf4hi */

    case 436:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22338; /* pred_indexed_uloadrvvm1x3dfrvvmf2si */

    case 437:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22340; /* pred_indexed_uloadrvvm1x3dfrvvm1di */

    case 438:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22342; /* pred_indexed_uloadrvvm1x4dfrvvmf8qi */

    case 439:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22344; /* pred_indexed_uloadrvvm1x4dfrvvmf4hi */

    case 440:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22346; /* pred_indexed_uloadrvvm1x4dfrvvmf2si */

    case 441:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22348; /* pred_indexed_uloadrvvm1x4dfrvvm1di */

    case 442:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22350; /* pred_indexed_uloadrvvm1x5dfrvvmf8qi */

    case 443:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22352; /* pred_indexed_uloadrvvm1x5dfrvvmf4hi */

    case 444:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22354; /* pred_indexed_uloadrvvm1x5dfrvvmf2si */

    case 445:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22356; /* pred_indexed_uloadrvvm1x5dfrvvm1di */

    case 446:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22358; /* pred_indexed_uloadrvvm1x6dfrvvmf8qi */

    case 447:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22360; /* pred_indexed_uloadrvvm1x6dfrvvmf4hi */

    case 448:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22362; /* pred_indexed_uloadrvvm1x6dfrvvmf2si */

    case 449:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22364; /* pred_indexed_uloadrvvm1x6dfrvvm1di */

    case 450:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22366; /* pred_indexed_uloadrvvm1x7dfrvvmf8qi */

    case 451:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22368; /* pred_indexed_uloadrvvm1x7dfrvvmf4hi */

    case 452:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22370; /* pred_indexed_uloadrvvm1x7dfrvvmf2si */

    case 453:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22372; /* pred_indexed_uloadrvvm1x7dfrvvm1di */

    case 454:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22374; /* pred_indexed_uloadrvvm1x8dfrvvmf8qi */

    case 455:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22376; /* pred_indexed_uloadrvvm1x8dfrvvmf4hi */

    case 456:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22378; /* pred_indexed_uloadrvvm1x8dfrvvmf2si */

    case 457:
      if (!(
#line 8487 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22380; /* pred_indexed_uloadrvvm1x8dfrvvm1di */

    case 458:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22382; /* pred_indexed_uloadrvvmf4x2qirvvmf4qi */

    case 459:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22478; /* pred_indexed_uloadrvvmf4x2qirvvmf2hi */

    case 460:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22574; /* pred_indexed_uloadrvvmf4x2qirvvm1si */

    case 461:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22670; /* pred_indexed_uloadrvvmf4x2qirvvm2di */

    case 462:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22384; /* pred_indexed_uloadrvvmf4x3qirvvmf4qi */

    case 463:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22480; /* pred_indexed_uloadrvvmf4x3qirvvmf2hi */

    case 464:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22576; /* pred_indexed_uloadrvvmf4x3qirvvm1si */

    case 465:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22672; /* pred_indexed_uloadrvvmf4x3qirvvm2di */

    case 466:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22386; /* pred_indexed_uloadrvvmf4x4qirvvmf4qi */

    case 467:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22482; /* pred_indexed_uloadrvvmf4x4qirvvmf2hi */

    case 468:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22578; /* pred_indexed_uloadrvvmf4x4qirvvm1si */

    case 469:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22674; /* pred_indexed_uloadrvvmf4x4qirvvm2di */

    case 470:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22388; /* pred_indexed_uloadrvvmf4x5qirvvmf4qi */

    case 471:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22484; /* pred_indexed_uloadrvvmf4x5qirvvmf2hi */

    case 472:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22580; /* pred_indexed_uloadrvvmf4x5qirvvm1si */

    case 473:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22676; /* pred_indexed_uloadrvvmf4x5qirvvm2di */

    case 474:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22390; /* pred_indexed_uloadrvvmf4x6qirvvmf4qi */

    case 475:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22486; /* pred_indexed_uloadrvvmf4x6qirvvmf2hi */

    case 476:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22582; /* pred_indexed_uloadrvvmf4x6qirvvm1si */

    case 477:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22678; /* pred_indexed_uloadrvvmf4x6qirvvm2di */

    case 478:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22392; /* pred_indexed_uloadrvvmf4x7qirvvmf4qi */

    case 479:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22488; /* pred_indexed_uloadrvvmf4x7qirvvmf2hi */

    case 480:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22584; /* pred_indexed_uloadrvvmf4x7qirvvm1si */

    case 481:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22680; /* pred_indexed_uloadrvvmf4x7qirvvm2di */

    case 482:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22394; /* pred_indexed_uloadrvvmf4x8qirvvmf4qi */

    case 483:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22490; /* pred_indexed_uloadrvvmf4x8qirvvmf2hi */

    case 484:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22586; /* pred_indexed_uloadrvvmf4x8qirvvm1si */

    case 485:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22682; /* pred_indexed_uloadrvvmf4x8qirvvm2di */

    case 486:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22396; /* pred_indexed_uloadrvvmf2x2hirvvmf4qi */

    case 487:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22492; /* pred_indexed_uloadrvvmf2x2hirvvmf2hi */

    case 488:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22588; /* pred_indexed_uloadrvvmf2x2hirvvm1si */

    case 489:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22684; /* pred_indexed_uloadrvvmf2x2hirvvm2di */

    case 490:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22398; /* pred_indexed_uloadrvvmf2x3hirvvmf4qi */

    case 491:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22494; /* pred_indexed_uloadrvvmf2x3hirvvmf2hi */

    case 492:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22590; /* pred_indexed_uloadrvvmf2x3hirvvm1si */

    case 493:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22686; /* pred_indexed_uloadrvvmf2x3hirvvm2di */

    case 494:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22400; /* pred_indexed_uloadrvvmf2x4hirvvmf4qi */

    case 495:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22496; /* pred_indexed_uloadrvvmf2x4hirvvmf2hi */

    case 496:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22592; /* pred_indexed_uloadrvvmf2x4hirvvm1si */

    case 497:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22688; /* pred_indexed_uloadrvvmf2x4hirvvm2di */

    case 498:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22402; /* pred_indexed_uloadrvvmf2x5hirvvmf4qi */

    case 499:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22498; /* pred_indexed_uloadrvvmf2x5hirvvmf2hi */

    case 500:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22594; /* pred_indexed_uloadrvvmf2x5hirvvm1si */

    case 501:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22690; /* pred_indexed_uloadrvvmf2x5hirvvm2di */

    case 502:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22404; /* pred_indexed_uloadrvvmf2x6hirvvmf4qi */

    case 503:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22500; /* pred_indexed_uloadrvvmf2x6hirvvmf2hi */

    case 504:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22596; /* pred_indexed_uloadrvvmf2x6hirvvm1si */

    case 505:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22692; /* pred_indexed_uloadrvvmf2x6hirvvm2di */

    case 506:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22406; /* pred_indexed_uloadrvvmf2x7hirvvmf4qi */

    case 507:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22502; /* pred_indexed_uloadrvvmf2x7hirvvmf2hi */

    case 508:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22598; /* pred_indexed_uloadrvvmf2x7hirvvm1si */

    case 509:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22694; /* pred_indexed_uloadrvvmf2x7hirvvm2di */

    case 510:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22408; /* pred_indexed_uloadrvvmf2x8hirvvmf4qi */

    case 511:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22504; /* pred_indexed_uloadrvvmf2x8hirvvmf2hi */

    case 512:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22600; /* pred_indexed_uloadrvvmf2x8hirvvm1si */

    case 513:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22696; /* pred_indexed_uloadrvvmf2x8hirvvm2di */

    case 514:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22410; /* pred_indexed_uloadrvvm1x2sirvvmf4qi */

    case 515:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22506; /* pred_indexed_uloadrvvm1x2sirvvmf2hi */

    case 516:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22602; /* pred_indexed_uloadrvvm1x2sirvvm1si */

    case 517:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22698; /* pred_indexed_uloadrvvm1x2sirvvm2di */

    case 518:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22412; /* pred_indexed_uloadrvvm1x3sirvvmf4qi */

    case 519:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22508; /* pred_indexed_uloadrvvm1x3sirvvmf2hi */

    case 520:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22604; /* pred_indexed_uloadrvvm1x3sirvvm1si */

    case 521:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22700; /* pred_indexed_uloadrvvm1x3sirvvm2di */

    case 522:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22414; /* pred_indexed_uloadrvvm1x4sirvvmf4qi */

    case 523:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22510; /* pred_indexed_uloadrvvm1x4sirvvmf2hi */

    case 524:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22606; /* pred_indexed_uloadrvvm1x4sirvvm1si */

    case 525:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22702; /* pred_indexed_uloadrvvm1x4sirvvm2di */

    case 526:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22416; /* pred_indexed_uloadrvvm1x5sirvvmf4qi */

    case 527:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22512; /* pred_indexed_uloadrvvm1x5sirvvmf2hi */

    case 528:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22608; /* pred_indexed_uloadrvvm1x5sirvvm1si */

    case 529:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22704; /* pred_indexed_uloadrvvm1x5sirvvm2di */

    case 530:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22418; /* pred_indexed_uloadrvvm1x6sirvvmf4qi */

    case 531:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22514; /* pred_indexed_uloadrvvm1x6sirvvmf2hi */

    case 532:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22610; /* pred_indexed_uloadrvvm1x6sirvvm1si */

    case 533:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22706; /* pred_indexed_uloadrvvm1x6sirvvm2di */

    case 534:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22420; /* pred_indexed_uloadrvvm1x7sirvvmf4qi */

    case 535:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22516; /* pred_indexed_uloadrvvm1x7sirvvmf2hi */

    case 536:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22612; /* pred_indexed_uloadrvvm1x7sirvvm1si */

    case 537:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22708; /* pred_indexed_uloadrvvm1x7sirvvm2di */

    case 538:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22422; /* pred_indexed_uloadrvvm1x8sirvvmf4qi */

    case 539:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22518; /* pred_indexed_uloadrvvm1x8sirvvmf2hi */

    case 540:
      if (!
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22614; /* pred_indexed_uloadrvvm1x8sirvvm1si */

    case 541:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22710; /* pred_indexed_uloadrvvm1x8sirvvm2di */

    case 542:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22424; /* pred_indexed_uloadrvvm2x2dirvvmf4qi */

    case 543:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22520; /* pred_indexed_uloadrvvm2x2dirvvmf2hi */

    case 544:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22616; /* pred_indexed_uloadrvvm2x2dirvvm1si */

    case 545:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22712; /* pred_indexed_uloadrvvm2x2dirvvm2di */

    case 546:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22426; /* pred_indexed_uloadrvvm2x3dirvvmf4qi */

    case 547:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22522; /* pred_indexed_uloadrvvm2x3dirvvmf2hi */

    case 548:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22618; /* pred_indexed_uloadrvvm2x3dirvvm1si */

    case 549:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22714; /* pred_indexed_uloadrvvm2x3dirvvm2di */

    case 550:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22428; /* pred_indexed_uloadrvvm2x4dirvvmf4qi */

    case 551:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22524; /* pred_indexed_uloadrvvm2x4dirvvmf2hi */

    case 552:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22620; /* pred_indexed_uloadrvvm2x4dirvvm1si */

    case 553:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22716; /* pred_indexed_uloadrvvm2x4dirvvm2di */

    case 554:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22430; /* pred_indexed_uloadrvvmf2x2bfrvvmf4qi */

    case 555:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22526; /* pred_indexed_uloadrvvmf2x2bfrvvmf2hi */

    case 556:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22622; /* pred_indexed_uloadrvvmf2x2bfrvvm1si */

    case 557:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22718; /* pred_indexed_uloadrvvmf2x2bfrvvm2di */

    case 558:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22432; /* pred_indexed_uloadrvvmf2x3bfrvvmf4qi */

    case 559:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22528; /* pred_indexed_uloadrvvmf2x3bfrvvmf2hi */

    case 560:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22624; /* pred_indexed_uloadrvvmf2x3bfrvvm1si */

    case 561:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22720; /* pred_indexed_uloadrvvmf2x3bfrvvm2di */

    case 562:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22434; /* pred_indexed_uloadrvvmf2x4bfrvvmf4qi */

    case 563:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22530; /* pred_indexed_uloadrvvmf2x4bfrvvmf2hi */

    case 564:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22626; /* pred_indexed_uloadrvvmf2x4bfrvvm1si */

    case 565:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22722; /* pred_indexed_uloadrvvmf2x4bfrvvm2di */

    case 566:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22436; /* pred_indexed_uloadrvvmf2x5bfrvvmf4qi */

    case 567:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22532; /* pred_indexed_uloadrvvmf2x5bfrvvmf2hi */

    case 568:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22628; /* pred_indexed_uloadrvvmf2x5bfrvvm1si */

    case 569:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22724; /* pred_indexed_uloadrvvmf2x5bfrvvm2di */

    case 570:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22438; /* pred_indexed_uloadrvvmf2x6bfrvvmf4qi */

    case 571:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22534; /* pred_indexed_uloadrvvmf2x6bfrvvmf2hi */

    case 572:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22630; /* pred_indexed_uloadrvvmf2x6bfrvvm1si */

    case 573:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22726; /* pred_indexed_uloadrvvmf2x6bfrvvm2di */

    case 574:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22440; /* pred_indexed_uloadrvvmf2x7bfrvvmf4qi */

    case 575:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22536; /* pred_indexed_uloadrvvmf2x7bfrvvmf2hi */

    case 576:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22632; /* pred_indexed_uloadrvvmf2x7bfrvvm1si */

    case 577:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22728; /* pred_indexed_uloadrvvmf2x7bfrvvm2di */

    case 578:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22442; /* pred_indexed_uloadrvvmf2x8bfrvvmf4qi */

    case 579:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22538; /* pred_indexed_uloadrvvmf2x8bfrvvmf2hi */

    case 580:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22634; /* pred_indexed_uloadrvvmf2x8bfrvvm1si */

    case 581:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22730; /* pred_indexed_uloadrvvmf2x8bfrvvm2di */

    case 582:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22444; /* pred_indexed_uloadrvvmf2x2hfrvvmf4qi */

    case 583:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22540; /* pred_indexed_uloadrvvmf2x2hfrvvmf2hi */

    case 584:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22636; /* pred_indexed_uloadrvvmf2x2hfrvvm1si */

    case 585:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22732; /* pred_indexed_uloadrvvmf2x2hfrvvm2di */

    case 586:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22446; /* pred_indexed_uloadrvvmf2x3hfrvvmf4qi */

    case 587:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22542; /* pred_indexed_uloadrvvmf2x3hfrvvmf2hi */

    case 588:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22638; /* pred_indexed_uloadrvvmf2x3hfrvvm1si */

    case 589:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22734; /* pred_indexed_uloadrvvmf2x3hfrvvm2di */

    case 590:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22448; /* pred_indexed_uloadrvvmf2x4hfrvvmf4qi */

    case 591:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22544; /* pred_indexed_uloadrvvmf2x4hfrvvmf2hi */

    case 592:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22640; /* pred_indexed_uloadrvvmf2x4hfrvvm1si */

    case 593:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22736; /* pred_indexed_uloadrvvmf2x4hfrvvm2di */

    case 594:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22450; /* pred_indexed_uloadrvvmf2x5hfrvvmf4qi */

    case 595:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22546; /* pred_indexed_uloadrvvmf2x5hfrvvmf2hi */

    case 596:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22642; /* pred_indexed_uloadrvvmf2x5hfrvvm1si */

    case 597:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22738; /* pred_indexed_uloadrvvmf2x5hfrvvm2di */

    case 598:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22452; /* pred_indexed_uloadrvvmf2x6hfrvvmf4qi */

    case 599:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22548; /* pred_indexed_uloadrvvmf2x6hfrvvmf2hi */

    case 600:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22644; /* pred_indexed_uloadrvvmf2x6hfrvvm1si */

    case 601:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22740; /* pred_indexed_uloadrvvmf2x6hfrvvm2di */

    case 602:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22454; /* pred_indexed_uloadrvvmf2x7hfrvvmf4qi */

    case 603:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22550; /* pred_indexed_uloadrvvmf2x7hfrvvmf2hi */

    case 604:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22646; /* pred_indexed_uloadrvvmf2x7hfrvvm1si */

    case 605:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22742; /* pred_indexed_uloadrvvmf2x7hfrvvm2di */

    case 606:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22456; /* pred_indexed_uloadrvvmf2x8hfrvvmf4qi */

    case 607:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22552; /* pred_indexed_uloadrvvmf2x8hfrvvmf2hi */

    case 608:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22648; /* pred_indexed_uloadrvvmf2x8hfrvvm1si */

    case 609:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22744; /* pred_indexed_uloadrvvmf2x8hfrvvm2di */

    case 610:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22458; /* pred_indexed_uloadrvvm1x2sfrvvmf4qi */

    case 611:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22554; /* pred_indexed_uloadrvvm1x2sfrvvmf2hi */

    case 612:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22650; /* pred_indexed_uloadrvvm1x2sfrvvm1si */

    case 613:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22746; /* pred_indexed_uloadrvvm1x2sfrvvm2di */

    case 614:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22460; /* pred_indexed_uloadrvvm1x3sfrvvmf4qi */

    case 615:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22556; /* pred_indexed_uloadrvvm1x3sfrvvmf2hi */

    case 616:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22652; /* pred_indexed_uloadrvvm1x3sfrvvm1si */

    case 617:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22748; /* pred_indexed_uloadrvvm1x3sfrvvm2di */

    case 618:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22462; /* pred_indexed_uloadrvvm1x4sfrvvmf4qi */

    case 619:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22558; /* pred_indexed_uloadrvvm1x4sfrvvmf2hi */

    case 620:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22654; /* pred_indexed_uloadrvvm1x4sfrvvm1si */

    case 621:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22750; /* pred_indexed_uloadrvvm1x4sfrvvm2di */

    case 622:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22464; /* pred_indexed_uloadrvvm1x5sfrvvmf4qi */

    case 623:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22560; /* pred_indexed_uloadrvvm1x5sfrvvmf2hi */

    case 624:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22656; /* pred_indexed_uloadrvvm1x5sfrvvm1si */

    case 625:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22752; /* pred_indexed_uloadrvvm1x5sfrvvm2di */

    case 626:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22466; /* pred_indexed_uloadrvvm1x6sfrvvmf4qi */

    case 627:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22562; /* pred_indexed_uloadrvvm1x6sfrvvmf2hi */

    case 628:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22658; /* pred_indexed_uloadrvvm1x6sfrvvm1si */

    case 629:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22754; /* pred_indexed_uloadrvvm1x6sfrvvm2di */

    case 630:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22468; /* pred_indexed_uloadrvvm1x7sfrvvmf4qi */

    case 631:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22564; /* pred_indexed_uloadrvvm1x7sfrvvmf2hi */

    case 632:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22660; /* pred_indexed_uloadrvvm1x7sfrvvm1si */

    case 633:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22756; /* pred_indexed_uloadrvvm1x7sfrvvm2di */

    case 634:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22470; /* pred_indexed_uloadrvvm1x8sfrvvmf4qi */

    case 635:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22566; /* pred_indexed_uloadrvvm1x8sfrvvmf2hi */

    case 636:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22662; /* pred_indexed_uloadrvvm1x8sfrvvm1si */

    case 637:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22758; /* pred_indexed_uloadrvvm1x8sfrvvm2di */

    case 638:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22472; /* pred_indexed_uloadrvvm2x2dfrvvmf4qi */

    case 639:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22568; /* pred_indexed_uloadrvvm2x2dfrvvmf2hi */

    case 640:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22664; /* pred_indexed_uloadrvvm2x2dfrvvm1si */

    case 641:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22760; /* pred_indexed_uloadrvvm2x2dfrvvm2di */

    case 642:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22474; /* pred_indexed_uloadrvvm2x3dfrvvmf4qi */

    case 643:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22570; /* pred_indexed_uloadrvvm2x3dfrvvmf2hi */

    case 644:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22666; /* pred_indexed_uloadrvvm2x3dfrvvm1si */

    case 645:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22762; /* pred_indexed_uloadrvvm2x3dfrvvm2di */

    case 646:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22476; /* pred_indexed_uloadrvvm2x4dfrvvmf4qi */

    case 647:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22572; /* pred_indexed_uloadrvvm2x4dfrvvmf2hi */

    case 648:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22668; /* pred_indexed_uloadrvvm2x4dfrvvm1si */

    case 649:
      if (!(
#line 8508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22764; /* pred_indexed_uloadrvvm2x4dfrvvm2di */

    case 650:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22766; /* pred_indexed_uloadrvvmf2x2qirvvmf2qi */

    case 651:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22838; /* pred_indexed_uloadrvvmf2x2qirvvm1hi */

    case 652:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22910; /* pred_indexed_uloadrvvmf2x2qirvvm2si */

    case 653:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22982; /* pred_indexed_uloadrvvmf2x2qirvvm4di */

    case 654:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22768; /* pred_indexed_uloadrvvmf2x3qirvvmf2qi */

    case 655:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22840; /* pred_indexed_uloadrvvmf2x3qirvvm1hi */

    case 656:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22912; /* pred_indexed_uloadrvvmf2x3qirvvm2si */

    case 657:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22984; /* pred_indexed_uloadrvvmf2x3qirvvm4di */

    case 658:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22770; /* pred_indexed_uloadrvvmf2x4qirvvmf2qi */

    case 659:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22842; /* pred_indexed_uloadrvvmf2x4qirvvm1hi */

    case 660:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22914; /* pred_indexed_uloadrvvmf2x4qirvvm2si */

    case 661:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22986; /* pred_indexed_uloadrvvmf2x4qirvvm4di */

    case 662:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22772; /* pred_indexed_uloadrvvmf2x5qirvvmf2qi */

    case 663:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22844; /* pred_indexed_uloadrvvmf2x5qirvvm1hi */

    case 664:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22916; /* pred_indexed_uloadrvvmf2x5qirvvm2si */

    case 665:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22988; /* pred_indexed_uloadrvvmf2x5qirvvm4di */

    case 666:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22774; /* pred_indexed_uloadrvvmf2x6qirvvmf2qi */

    case 667:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22846; /* pred_indexed_uloadrvvmf2x6qirvvm1hi */

    case 668:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22918; /* pred_indexed_uloadrvvmf2x6qirvvm2si */

    case 669:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22990; /* pred_indexed_uloadrvvmf2x6qirvvm4di */

    case 670:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22776; /* pred_indexed_uloadrvvmf2x7qirvvmf2qi */

    case 671:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22848; /* pred_indexed_uloadrvvmf2x7qirvvm1hi */

    case 672:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22920; /* pred_indexed_uloadrvvmf2x7qirvvm2si */

    case 673:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22992; /* pred_indexed_uloadrvvmf2x7qirvvm4di */

    case 674:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22778; /* pred_indexed_uloadrvvmf2x8qirvvmf2qi */

    case 675:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22850; /* pred_indexed_uloadrvvmf2x8qirvvm1hi */

    case 676:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22922; /* pred_indexed_uloadrvvmf2x8qirvvm2si */

    case 677:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22994; /* pred_indexed_uloadrvvmf2x8qirvvm4di */

    case 678:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22780; /* pred_indexed_uloadrvvm1x2hirvvmf2qi */

    case 679:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22852; /* pred_indexed_uloadrvvm1x2hirvvm1hi */

    case 680:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22924; /* pred_indexed_uloadrvvm1x2hirvvm2si */

    case 681:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22996; /* pred_indexed_uloadrvvm1x2hirvvm4di */

    case 682:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22782; /* pred_indexed_uloadrvvm1x3hirvvmf2qi */

    case 683:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22854; /* pred_indexed_uloadrvvm1x3hirvvm1hi */

    case 684:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22926; /* pred_indexed_uloadrvvm1x3hirvvm2si */

    case 685:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22998; /* pred_indexed_uloadrvvm1x3hirvvm4di */

    case 686:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22784; /* pred_indexed_uloadrvvm1x4hirvvmf2qi */

    case 687:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22856; /* pred_indexed_uloadrvvm1x4hirvvm1hi */

    case 688:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22928; /* pred_indexed_uloadrvvm1x4hirvvm2si */

    case 689:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23000; /* pred_indexed_uloadrvvm1x4hirvvm4di */

    case 690:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22786; /* pred_indexed_uloadrvvm1x5hirvvmf2qi */

    case 691:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22858; /* pred_indexed_uloadrvvm1x5hirvvm1hi */

    case 692:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22930; /* pred_indexed_uloadrvvm1x5hirvvm2si */

    case 693:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23002; /* pred_indexed_uloadrvvm1x5hirvvm4di */

    case 694:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22788; /* pred_indexed_uloadrvvm1x6hirvvmf2qi */

    case 695:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22860; /* pred_indexed_uloadrvvm1x6hirvvm1hi */

    case 696:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22932; /* pred_indexed_uloadrvvm1x6hirvvm2si */

    case 697:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23004; /* pred_indexed_uloadrvvm1x6hirvvm4di */

    case 698:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22790; /* pred_indexed_uloadrvvm1x7hirvvmf2qi */

    case 699:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22862; /* pred_indexed_uloadrvvm1x7hirvvm1hi */

    case 700:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22934; /* pred_indexed_uloadrvvm1x7hirvvm2si */

    case 701:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23006; /* pred_indexed_uloadrvvm1x7hirvvm4di */

    case 702:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22792; /* pred_indexed_uloadrvvm1x8hirvvmf2qi */

    case 703:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22864; /* pred_indexed_uloadrvvm1x8hirvvm1hi */

    case 704:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22936; /* pred_indexed_uloadrvvm1x8hirvvm2si */

    case 705:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23008; /* pred_indexed_uloadrvvm1x8hirvvm4di */

    case 706:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22794; /* pred_indexed_uloadrvvm2x2sirvvmf2qi */

    case 707:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22866; /* pred_indexed_uloadrvvm2x2sirvvm1hi */

    case 708:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22938; /* pred_indexed_uloadrvvm2x2sirvvm2si */

    case 709:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23010; /* pred_indexed_uloadrvvm2x2sirvvm4di */

    case 710:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22796; /* pred_indexed_uloadrvvm2x3sirvvmf2qi */

    case 711:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22868; /* pred_indexed_uloadrvvm2x3sirvvm1hi */

    case 712:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22940; /* pred_indexed_uloadrvvm2x3sirvvm2si */

    case 713:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23012; /* pred_indexed_uloadrvvm2x3sirvvm4di */

    case 714:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22798; /* pred_indexed_uloadrvvm2x4sirvvmf2qi */

    case 715:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22870; /* pred_indexed_uloadrvvm2x4sirvvm1hi */

    case 716:
      if (!
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22942; /* pred_indexed_uloadrvvm2x4sirvvm2si */

    case 717:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23014; /* pred_indexed_uloadrvvm2x4sirvvm4di */

    case 718:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22800; /* pred_indexed_uloadrvvm4x2dirvvmf2qi */

    case 719:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22872; /* pred_indexed_uloadrvvm4x2dirvvm1hi */

    case 720:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22944; /* pred_indexed_uloadrvvm4x2dirvvm2si */

    case 721:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23016; /* pred_indexed_uloadrvvm4x2dirvvm4di */

    case 722:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22802; /* pred_indexed_uloadrvvm1x2bfrvvmf2qi */

    case 723:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22874; /* pred_indexed_uloadrvvm1x2bfrvvm1hi */

    case 724:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22946; /* pred_indexed_uloadrvvm1x2bfrvvm2si */

    case 725:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23018; /* pred_indexed_uloadrvvm1x2bfrvvm4di */

    case 726:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22804; /* pred_indexed_uloadrvvm1x3bfrvvmf2qi */

    case 727:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22876; /* pred_indexed_uloadrvvm1x3bfrvvm1hi */

    case 728:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22948; /* pred_indexed_uloadrvvm1x3bfrvvm2si */

    case 729:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23020; /* pred_indexed_uloadrvvm1x3bfrvvm4di */

    case 730:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22806; /* pred_indexed_uloadrvvm1x4bfrvvmf2qi */

    case 731:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22878; /* pred_indexed_uloadrvvm1x4bfrvvm1hi */

    case 732:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22950; /* pred_indexed_uloadrvvm1x4bfrvvm2si */

    case 733:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23022; /* pred_indexed_uloadrvvm1x4bfrvvm4di */

    case 734:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22808; /* pred_indexed_uloadrvvm1x5bfrvvmf2qi */

    case 735:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22880; /* pred_indexed_uloadrvvm1x5bfrvvm1hi */

    case 736:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22952; /* pred_indexed_uloadrvvm1x5bfrvvm2si */

    case 737:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23024; /* pred_indexed_uloadrvvm1x5bfrvvm4di */

    case 738:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22810; /* pred_indexed_uloadrvvm1x6bfrvvmf2qi */

    case 739:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22882; /* pred_indexed_uloadrvvm1x6bfrvvm1hi */

    case 740:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22954; /* pred_indexed_uloadrvvm1x6bfrvvm2si */

    case 741:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23026; /* pred_indexed_uloadrvvm1x6bfrvvm4di */

    case 742:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22812; /* pred_indexed_uloadrvvm1x7bfrvvmf2qi */

    case 743:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22884; /* pred_indexed_uloadrvvm1x7bfrvvm1hi */

    case 744:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22956; /* pred_indexed_uloadrvvm1x7bfrvvm2si */

    case 745:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23028; /* pred_indexed_uloadrvvm1x7bfrvvm4di */

    case 746:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22814; /* pred_indexed_uloadrvvm1x8bfrvvmf2qi */

    case 747:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22886; /* pred_indexed_uloadrvvm1x8bfrvvm1hi */

    case 748:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22958; /* pred_indexed_uloadrvvm1x8bfrvvm2si */

    case 749:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23030; /* pred_indexed_uloadrvvm1x8bfrvvm4di */

    case 750:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22816; /* pred_indexed_uloadrvvm1x2hfrvvmf2qi */

    case 751:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22888; /* pred_indexed_uloadrvvm1x2hfrvvm1hi */

    case 752:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22960; /* pred_indexed_uloadrvvm1x2hfrvvm2si */

    case 753:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23032; /* pred_indexed_uloadrvvm1x2hfrvvm4di */

    case 754:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22818; /* pred_indexed_uloadrvvm1x3hfrvvmf2qi */

    case 755:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22890; /* pred_indexed_uloadrvvm1x3hfrvvm1hi */

    case 756:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22962; /* pred_indexed_uloadrvvm1x3hfrvvm2si */

    case 757:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23034; /* pred_indexed_uloadrvvm1x3hfrvvm4di */

    case 758:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22820; /* pred_indexed_uloadrvvm1x4hfrvvmf2qi */

    case 759:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22892; /* pred_indexed_uloadrvvm1x4hfrvvm1hi */

    case 760:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22964; /* pred_indexed_uloadrvvm1x4hfrvvm2si */

    case 761:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23036; /* pred_indexed_uloadrvvm1x4hfrvvm4di */

    case 762:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22822; /* pred_indexed_uloadrvvm1x5hfrvvmf2qi */

    case 763:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22894; /* pred_indexed_uloadrvvm1x5hfrvvm1hi */

    case 764:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22966; /* pred_indexed_uloadrvvm1x5hfrvvm2si */

    case 765:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23038; /* pred_indexed_uloadrvvm1x5hfrvvm4di */

    case 766:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22824; /* pred_indexed_uloadrvvm1x6hfrvvmf2qi */

    case 767:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22896; /* pred_indexed_uloadrvvm1x6hfrvvm1hi */

    case 768:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22968; /* pred_indexed_uloadrvvm1x6hfrvvm2si */

    case 769:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23040; /* pred_indexed_uloadrvvm1x6hfrvvm4di */

    case 770:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22826; /* pred_indexed_uloadrvvm1x7hfrvvmf2qi */

    case 771:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22898; /* pred_indexed_uloadrvvm1x7hfrvvm1hi */

    case 772:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22970; /* pred_indexed_uloadrvvm1x7hfrvvm2si */

    case 773:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23042; /* pred_indexed_uloadrvvm1x7hfrvvm4di */

    case 774:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22828; /* pred_indexed_uloadrvvm1x8hfrvvmf2qi */

    case 775:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22900; /* pred_indexed_uloadrvvm1x8hfrvvm1hi */

    case 776:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22972; /* pred_indexed_uloadrvvm1x8hfrvvm2si */

    case 777:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23044; /* pred_indexed_uloadrvvm1x8hfrvvm4di */

    case 778:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22830; /* pred_indexed_uloadrvvm2x2sfrvvmf2qi */

    case 779:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22902; /* pred_indexed_uloadrvvm2x2sfrvvm1hi */

    case 780:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22974; /* pred_indexed_uloadrvvm2x2sfrvvm2si */

    case 781:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23046; /* pred_indexed_uloadrvvm2x2sfrvvm4di */

    case 782:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22832; /* pred_indexed_uloadrvvm2x3sfrvvmf2qi */

    case 783:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22904; /* pred_indexed_uloadrvvm2x3sfrvvm1hi */

    case 784:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22976; /* pred_indexed_uloadrvvm2x3sfrvvm2si */

    case 785:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1310 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23048; /* pred_indexed_uloadrvvm2x3sfrvvm4di */

    case 786:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22834; /* pred_indexed_uloadrvvm2x4sfrvvmf2qi */

    case 787:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22906; /* pred_indexed_uloadrvvm2x4sfrvvm1hi */

    case 788:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22978; /* pred_indexed_uloadrvvm2x4sfrvvm2si */

    case 789:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23050; /* pred_indexed_uloadrvvm2x4sfrvvm4di */

    case 790:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22836; /* pred_indexed_uloadrvvm4x2dfrvvmf2qi */

    case 791:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22908; /* pred_indexed_uloadrvvm4x2dfrvvm1hi */

    case 792:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22980; /* pred_indexed_uloadrvvm4x2dfrvvm2si */

    case 793:
      if (!(
#line 8529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1312 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23052; /* pred_indexed_uloadrvvm4x2dfrvvm4di */

    case 794:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23054; /* pred_indexed_uloadrvvm1x2qirvvm1qi */

    case 795:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23056; /* pred_indexed_uloadrvvm1x2qirvvm2hi */

    case 796:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23058; /* pred_indexed_uloadrvvm1x2qirvvm4si */

    case 797:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23060; /* pred_indexed_uloadrvvm1x2qirvvm8di */

    case 798:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23062; /* pred_indexed_uloadrvvm1x3qirvvm1qi */

    case 799:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23064; /* pred_indexed_uloadrvvm1x3qirvvm2hi */

    case 800:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23066; /* pred_indexed_uloadrvvm1x3qirvvm4si */

    case 801:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23068; /* pred_indexed_uloadrvvm1x3qirvvm8di */

    case 802:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23070; /* pred_indexed_uloadrvvm1x4qirvvm1qi */

    case 803:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23072; /* pred_indexed_uloadrvvm1x4qirvvm2hi */

    case 804:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23074; /* pred_indexed_uloadrvvm1x4qirvvm4si */

    case 805:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23076; /* pred_indexed_uloadrvvm1x4qirvvm8di */

    case 806:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23078; /* pred_indexed_uloadrvvm1x5qirvvm1qi */

    case 807:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23080; /* pred_indexed_uloadrvvm1x5qirvvm2hi */

    case 808:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23082; /* pred_indexed_uloadrvvm1x5qirvvm4si */

    case 809:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23084; /* pred_indexed_uloadrvvm1x5qirvvm8di */

    case 810:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23086; /* pred_indexed_uloadrvvm1x6qirvvm1qi */

    case 811:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23088; /* pred_indexed_uloadrvvm1x6qirvvm2hi */

    case 812:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23090; /* pred_indexed_uloadrvvm1x6qirvvm4si */

    case 813:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23092; /* pred_indexed_uloadrvvm1x6qirvvm8di */

    case 814:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23094; /* pred_indexed_uloadrvvm1x7qirvvm1qi */

    case 815:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23096; /* pred_indexed_uloadrvvm1x7qirvvm2hi */

    case 816:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23098; /* pred_indexed_uloadrvvm1x7qirvvm4si */

    case 817:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23100; /* pred_indexed_uloadrvvm1x7qirvvm8di */

    case 818:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23102; /* pred_indexed_uloadrvvm1x8qirvvm1qi */

    case 819:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23104; /* pred_indexed_uloadrvvm1x8qirvvm2hi */

    case 820:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23106; /* pred_indexed_uloadrvvm1x8qirvvm4si */

    case 821:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23108; /* pred_indexed_uloadrvvm1x8qirvvm8di */

    case 822:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23110; /* pred_indexed_uloadrvvm2x2hirvvm1qi */

    case 823:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23112; /* pred_indexed_uloadrvvm2x2hirvvm2hi */

    case 824:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23114; /* pred_indexed_uloadrvvm2x2hirvvm4si */

    case 825:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23116; /* pred_indexed_uloadrvvm2x2hirvvm8di */

    case 826:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23118; /* pred_indexed_uloadrvvm2x3hirvvm1qi */

    case 827:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23120; /* pred_indexed_uloadrvvm2x3hirvvm2hi */

    case 828:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23122; /* pred_indexed_uloadrvvm2x3hirvvm4si */

    case 829:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23124; /* pred_indexed_uloadrvvm2x3hirvvm8di */

    case 830:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23126; /* pred_indexed_uloadrvvm2x4hirvvm1qi */

    case 831:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23128; /* pred_indexed_uloadrvvm2x4hirvvm2hi */

    case 832:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23130; /* pred_indexed_uloadrvvm2x4hirvvm4si */

    case 833:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23132; /* pred_indexed_uloadrvvm2x4hirvvm8di */

    case 834:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23134; /* pred_indexed_uloadrvvm4x2sirvvm1qi */

    case 835:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23136; /* pred_indexed_uloadrvvm4x2sirvvm2hi */

    case 836:
      if (!
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23138; /* pred_indexed_uloadrvvm4x2sirvvm4si */

    case 837:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23140; /* pred_indexed_uloadrvvm4x2sirvvm8di */

    case 838:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23142; /* pred_indexed_uloadrvvm2x2bfrvvm1qi */

    case 839:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23144; /* pred_indexed_uloadrvvm2x2bfrvvm2hi */

    case 840:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23146; /* pred_indexed_uloadrvvm2x2bfrvvm4si */

    case 841:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23148; /* pred_indexed_uloadrvvm2x2bfrvvm8di */

    case 842:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23150; /* pred_indexed_uloadrvvm2x3bfrvvm1qi */

    case 843:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23152; /* pred_indexed_uloadrvvm2x3bfrvvm2hi */

    case 844:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23154; /* pred_indexed_uloadrvvm2x3bfrvvm4si */

    case 845:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23156; /* pred_indexed_uloadrvvm2x3bfrvvm8di */

    case 846:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23158; /* pred_indexed_uloadrvvm2x4bfrvvm1qi */

    case 847:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23160; /* pred_indexed_uloadrvvm2x4bfrvvm2hi */

    case 848:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23162; /* pred_indexed_uloadrvvm2x4bfrvvm4si */

    case 849:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23164; /* pred_indexed_uloadrvvm2x4bfrvvm8di */

    case 850:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23166; /* pred_indexed_uloadrvvm2x2hfrvvm1qi */

    case 851:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23168; /* pred_indexed_uloadrvvm2x2hfrvvm2hi */

    case 852:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23170; /* pred_indexed_uloadrvvm2x2hfrvvm4si */

    case 853:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23172; /* pred_indexed_uloadrvvm2x2hfrvvm8di */

    case 854:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23174; /* pred_indexed_uloadrvvm2x3hfrvvm1qi */

    case 855:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23176; /* pred_indexed_uloadrvvm2x3hfrvvm2hi */

    case 856:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23178; /* pred_indexed_uloadrvvm2x3hfrvvm4si */

    case 857:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23180; /* pred_indexed_uloadrvvm2x3hfrvvm8di */

    case 858:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23182; /* pred_indexed_uloadrvvm2x4hfrvvm1qi */

    case 859:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23184; /* pred_indexed_uloadrvvm2x4hfrvvm2hi */

    case 860:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23186; /* pred_indexed_uloadrvvm2x4hfrvvm4si */

    case 861:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23188; /* pred_indexed_uloadrvvm2x4hfrvvm8di */

    case 862:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23190; /* pred_indexed_uloadrvvm4x2sfrvvm1qi */

    case 863:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23192; /* pred_indexed_uloadrvvm4x2sfrvvm2hi */

    case 864:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23194; /* pred_indexed_uloadrvvm4x2sfrvvm4si */

    case 865:
      if (!(
#line 8550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23196; /* pred_indexed_uloadrvvm4x2sfrvvm8di */

    case 866:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23198; /* pred_indexed_uloadrvvm2x2qirvvm2qi */

    case 867:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23200; /* pred_indexed_uloadrvvm2x2qirvvm4hi */

    case 868:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23202; /* pred_indexed_uloadrvvm2x2qirvvm8si */

    case 869:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23204; /* pred_indexed_uloadrvvm2x3qirvvm2qi */

    case 870:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23206; /* pred_indexed_uloadrvvm2x3qirvvm4hi */

    case 871:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23208; /* pred_indexed_uloadrvvm2x3qirvvm8si */

    case 872:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23210; /* pred_indexed_uloadrvvm2x4qirvvm2qi */

    case 873:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23212; /* pred_indexed_uloadrvvm2x4qirvvm4hi */

    case 874:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23214; /* pred_indexed_uloadrvvm2x4qirvvm8si */

    case 875:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23216; /* pred_indexed_uloadrvvm4x2hirvvm2qi */

    case 876:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23218; /* pred_indexed_uloadrvvm4x2hirvvm4hi */

    case 877:
      if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23220; /* pred_indexed_uloadrvvm4x2hirvvm8si */

    case 878:
      if (!(
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23222; /* pred_indexed_uloadrvvm4x2bfrvvm2qi */

    case 879:
      if (!(
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23224; /* pred_indexed_uloadrvvm4x2bfrvvm4hi */

    case 880:
      if (!(
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23226; /* pred_indexed_uloadrvvm4x2bfrvvm8si */

    case 881:
      if (!(
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23228; /* pred_indexed_uloadrvvm4x2hfrvvm2qi */

    case 882:
      if (!(
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23230; /* pred_indexed_uloadrvvm4x2hfrvvm4hi */

    case 883:
      if (!(
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23232; /* pred_indexed_uloadrvvm4x2hfrvvm8si */

    case 884:
      if (!
#line 8592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23234; /* pred_indexed_uloadrvvm4x2qirvvm4qi */

    case 885:
      if (!
#line 8592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23236; /* pred_indexed_uloadrvvm4x2qirvvm8hi */

    default:
      return -1;
    }
}

 int
recog_899 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern503 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5513; /* pred_umodrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5530; /* pred_umodrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5547; /* pred_umodrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5564; /* pred_umodrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5581; /* pred_umodrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5598; /* pred_umodrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5615; /* pred_umodrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5632; /* pred_umodrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5649; /* pred_umodrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5666; /* pred_umodrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5683; /* pred_umodrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5700; /* pred_umodrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5717; /* pred_umodrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5734; /* pred_umodrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5751; /* pred_umodrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5768; /* pred_umodrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5785; /* pred_umodrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5802; /* pred_umodrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5819; /* pred_umodrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5836; /* pred_umodrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5853; /* pred_umodrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5870; /* pred_umodrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5887; /* pred_umodv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5904; /* pred_umodv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5921; /* pred_umodv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5938; /* pred_umodv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5955; /* pred_umodv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5972; /* pred_umodv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5989; /* pred_umodv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6006; /* pred_umodv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6023; /* pred_umodv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6040; /* pred_umodv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6057; /* pred_umodv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6074; /* pred_umodv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6091; /* pred_umodv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6108; /* pred_umodv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6125; /* pred_umodv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6142; /* pred_umodv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6159; /* pred_umodv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6176; /* pred_umodv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6193; /* pred_umodv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6210; /* pred_umodv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6227; /* pred_umodv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6244; /* pred_umodv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6261; /* pred_umodv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6278; /* pred_umodv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6295; /* pred_umodv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6312; /* pred_umodv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6329; /* pred_umodv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6346; /* pred_umodv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6363; /* pred_umodv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6380; /* pred_umodv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6397; /* pred_umodv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6414; /* pred_umodv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6431; /* pred_umodv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6448; /* pred_umodv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6465; /* pred_umodv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6482; /* pred_umodv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6499; /* pred_umodv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6516; /* pred_umodv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6533; /* pred_umodv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6550; /* pred_umodv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6567; /* pred_umodv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6584; /* pred_umodv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6601; /* pred_umodv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6618; /* pred_umodv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6635; /* pred_umodv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6652; /* pred_umodv512di */

    case 68:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7347; /* pred_umodrvvm8qi_scalar */

    case 69:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7352; /* pred_umodrvvm4qi_scalar */

    case 70:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7357; /* pred_umodrvvm2qi_scalar */

    case 71:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7362; /* pred_umodrvvm1qi_scalar */

    case 72:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7367; /* pred_umodrvvmf2qi_scalar */

    case 73:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7372; /* pred_umodrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7377; /* pred_umodrvvmf8qi_scalar */

    case 75:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7382; /* pred_umodrvvm8hi_scalar */

    case 76:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7387; /* pred_umodrvvm4hi_scalar */

    case 77:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7392; /* pred_umodrvvm2hi_scalar */

    case 78:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7397; /* pred_umodrvvm1hi_scalar */

    case 79:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7402; /* pred_umodrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7407; /* pred_umodrvvmf4hi_scalar */

    case 81:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7412; /* pred_umodrvvm8si_scalar */

    case 82:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7417; /* pred_umodrvvm4si_scalar */

    case 83:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7422; /* pred_umodrvvm2si_scalar */

    case 84:
      if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7427; /* pred_umodrvvm1si_scalar */

    case 85:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7432; /* pred_umodrvvmf2si_scalar */

    case 86:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7437; /* pred_umodv1qi_scalar */

    case 87:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7442; /* pred_umodv2qi_scalar */

    case 88:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7447; /* pred_umodv4qi_scalar */

    case 89:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7452; /* pred_umodv8qi_scalar */

    case 90:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7457; /* pred_umodv16qi_scalar */

    case 91:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7462; /* pred_umodv32qi_scalar */

    case 92:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7467; /* pred_umodv64qi_scalar */

    case 93:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7472; /* pred_umodv128qi_scalar */

    case 94:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7477; /* pred_umodv256qi_scalar */

    case 95:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7482; /* pred_umodv512qi_scalar */

    case 96:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7487; /* pred_umodv1024qi_scalar */

    case 97:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7492; /* pred_umodv2048qi_scalar */

    case 98:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7497; /* pred_umodv4096qi_scalar */

    case 99:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7502; /* pred_umodv1hi_scalar */

    case 100:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7507; /* pred_umodv2hi_scalar */

    case 101:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7512; /* pred_umodv4hi_scalar */

    case 102:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7517; /* pred_umodv8hi_scalar */

    case 103:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7522; /* pred_umodv16hi_scalar */

    case 104:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7527; /* pred_umodv32hi_scalar */

    case 105:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7532; /* pred_umodv64hi_scalar */

    case 106:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7537; /* pred_umodv128hi_scalar */

    case 107:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7542; /* pred_umodv256hi_scalar */

    case 108:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7547; /* pred_umodv512hi_scalar */

    case 109:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7552; /* pred_umodv1024hi_scalar */

    case 110:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7557; /* pred_umodv2048hi_scalar */

    case 111:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7562; /* pred_umodv1si_scalar */

    case 112:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7567; /* pred_umodv2si_scalar */

    case 113:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7572; /* pred_umodv4si_scalar */

    case 114:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7577; /* pred_umodv8si_scalar */

    case 115:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7582; /* pred_umodv16si_scalar */

    case 116:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7587; /* pred_umodv32si_scalar */

    case 117:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7592; /* pred_umodv64si_scalar */

    case 118:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7597; /* pred_umodv128si_scalar */

    case 119:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7602; /* pred_umodv256si_scalar */

    case 120:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7607; /* pred_umodv512si_scalar */

    case 121:
      if (!(
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7612; /* pred_umodv1024si_scalar */

    case 122:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7923; /* *pred_umodrvvm8di_scalar */

    case 123:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7928; /* *pred_umodrvvm4di_scalar */

    case 124:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7933; /* *pred_umodrvvm2di_scalar */

    case 125:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7938; /* *pred_umodrvvm1di_scalar */

    case 126:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7943; /* *pred_umodv1di_scalar */

    case 127:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7948; /* *pred_umodv2di_scalar */

    case 128:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7953; /* *pred_umodv4di_scalar */

    case 129:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7958; /* *pred_umodv8di_scalar */

    case 130:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7963; /* *pred_umodv16di_scalar */

    case 131:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7968; /* *pred_umodv32di_scalar */

    case 132:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7973; /* *pred_umodv64di_scalar */

    case 133:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7978; /* *pred_umodv128di_scalar */

    case 134:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7983; /* *pred_umodv256di_scalar */

    case 135:
      if (!(
#line 2955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7988; /* *pred_umodv512di_scalar */

    case 136:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7993; /* *pred_umodrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7998; /* *pred_umodrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8003; /* *pred_umodrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8008; /* *pred_umodrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8013; /* *pred_umodv1di_extended_scalar */

    case 141:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8018; /* *pred_umodv2di_extended_scalar */

    case 142:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8023; /* *pred_umodv4di_extended_scalar */

    case 143:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8028; /* *pred_umodv8di_extended_scalar */

    case 144:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8033; /* *pred_umodv16di_extended_scalar */

    case 145:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8038; /* *pred_umodv32di_extended_scalar */

    case 146:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8043; /* *pred_umodv64di_extended_scalar */

    case 147:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8048; /* *pred_umodv128di_extended_scalar */

    case 148:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8053; /* *pred_umodv256di_extended_scalar */

    case 149:
      if (!(
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8058; /* *pred_umodv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_909 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10888; /* pred_ussubrvvm8qi */

        case 1:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10892; /* pred_ussubrvvm4qi */

        case 2:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10896; /* pred_ussubrvvm2qi */

        case 3:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10900; /* pred_ussubrvvm1qi */

        case 4:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10904; /* pred_ussubrvvm8hi */

        case 5:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10908; /* pred_ussubrvvm4hi */

        case 6:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10912; /* pred_ussubrvvm2hi */

        case 7:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10916; /* pred_ussubrvvm1hi */

        case 8:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10920; /* pred_ussubrvvm8si */

        case 9:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10924; /* pred_ussubrvvm4si */

        case 10:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10928; /* pred_ussubrvvm2si */

        case 11:
          if (!
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10932; /* pred_ussubrvvm1si */

        case 12:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10936; /* pred_ussubrvvm8di */

        case 13:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10940; /* pred_ussubrvvm4di */

        case 14:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10944; /* pred_ussubrvvm2di */

        case 15:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10948; /* pred_ussubrvvm1di */

        case 16:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10952; /* pred_ussubrvvmf2qi */

        case 17:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10956; /* pred_ussubrvvmf4qi */

        case 18:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10960; /* pred_ussubrvvmf8qi */

        case 19:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10964; /* pred_ussubrvvmf2hi */

        case 20:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10968; /* pred_ussubrvvmf4hi */

        case 21:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10972; /* pred_ussubrvvmf2si */

        case 22:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 10976; /* pred_ussubv1qi */

        case 23:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 10980; /* pred_ussubv2qi */

        case 24:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 10984; /* pred_ussubv4qi */

        case 25:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 10988; /* pred_ussubv8qi */

        case 26:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 10992; /* pred_ussubv16qi */

        case 27:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 10996; /* pred_ussubv32qi */

        case 28:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11000; /* pred_ussubv64qi */

        case 29:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11004; /* pred_ussubv128qi */

        case 30:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11008; /* pred_ussubv256qi */

        case 31:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11012; /* pred_ussubv512qi */

        case 32:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11016; /* pred_ussubv1024qi */

        case 33:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11020; /* pred_ussubv2048qi */

        case 34:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11024; /* pred_ussubv4096qi */

        case 35:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11028; /* pred_ussubv1hi */

        case 36:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11032; /* pred_ussubv2hi */

        case 37:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11036; /* pred_ussubv4hi */

        case 38:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11040; /* pred_ussubv8hi */

        case 39:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11044; /* pred_ussubv16hi */

        case 40:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11048; /* pred_ussubv32hi */

        case 41:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11052; /* pred_ussubv64hi */

        case 42:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11056; /* pred_ussubv128hi */

        case 43:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11060; /* pred_ussubv256hi */

        case 44:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11064; /* pred_ussubv512hi */

        case 45:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11068; /* pred_ussubv1024hi */

        case 46:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11072; /* pred_ussubv2048hi */

        case 47:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11076; /* pred_ussubv1si */

        case 48:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11080; /* pred_ussubv2si */

        case 49:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11084; /* pred_ussubv4si */

        case 50:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11088; /* pred_ussubv8si */

        case 51:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11092; /* pred_ussubv16si */

        case 52:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11096; /* pred_ussubv32si */

        case 53:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11100; /* pred_ussubv64si */

        case 54:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11104; /* pred_ussubv128si */

        case 55:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11108; /* pred_ussubv256si */

        case 56:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11112; /* pred_ussubv512si */

        case 57:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11116; /* pred_ussubv1024si */

        case 58:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11120; /* pred_ussubv1di */

        case 59:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11124; /* pred_ussubv2di */

        case 60:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11128; /* pred_ussubv4di */

        case 61:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11132; /* pred_ussubv8di */

        case 62:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11136; /* pred_ussubv16di */

        case 63:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11140; /* pred_ussubv32di */

        case 64:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11144; /* pred_ussubv64di */

        case 65:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11148; /* pred_ussubv128di */

        case 66:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11152; /* pred_ussubv256di */

        case 67:
          if (!(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11156; /* pred_ussubv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern605 (x2))
        {
        case 0:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11266; /* pred_ussubrvvm8qi_scalar */

        case 1:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11268; /* pred_ussubrvvm4qi_scalar */

        case 2:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11270; /* pred_ussubrvvm2qi_scalar */

        case 3:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11272; /* pred_ussubrvvm1qi_scalar */

        case 4:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11274; /* pred_ussubrvvmf2qi_scalar */

        case 5:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11276; /* pred_ussubrvvmf4qi_scalar */

        case 6:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11278; /* pred_ussubrvvmf8qi_scalar */

        case 7:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11280; /* pred_ussubrvvm8hi_scalar */

        case 8:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11282; /* pred_ussubrvvm4hi_scalar */

        case 9:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11284; /* pred_ussubrvvm2hi_scalar */

        case 10:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11286; /* pred_ussubrvvm1hi_scalar */

        case 11:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11288; /* pred_ussubrvvmf2hi_scalar */

        case 12:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11290; /* pred_ussubrvvmf4hi_scalar */

        case 13:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11292; /* pred_ussubrvvm8si_scalar */

        case 14:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11294; /* pred_ussubrvvm4si_scalar */

        case 15:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11296; /* pred_ussubrvvm2si_scalar */

        case 16:
          if (!
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11298; /* pred_ussubrvvm1si_scalar */

        case 17:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11300; /* pred_ussubrvvmf2si_scalar */

        case 18:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 11302; /* pred_ussubv1qi_scalar */

        case 19:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 11304; /* pred_ussubv2qi_scalar */

        case 20:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 11306; /* pred_ussubv4qi_scalar */

        case 21:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 11308; /* pred_ussubv8qi_scalar */

        case 22:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 11310; /* pred_ussubv16qi_scalar */

        case 23:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 11312; /* pred_ussubv32qi_scalar */

        case 24:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11314; /* pred_ussubv64qi_scalar */

        case 25:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11316; /* pred_ussubv128qi_scalar */

        case 26:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11318; /* pred_ussubv256qi_scalar */

        case 27:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11320; /* pred_ussubv512qi_scalar */

        case 28:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11322; /* pred_ussubv1024qi_scalar */

        case 29:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11324; /* pred_ussubv2048qi_scalar */

        case 30:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11326; /* pred_ussubv4096qi_scalar */

        case 31:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11328; /* pred_ussubv1hi_scalar */

        case 32:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11330; /* pred_ussubv2hi_scalar */

        case 33:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11332; /* pred_ussubv4hi_scalar */

        case 34:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11334; /* pred_ussubv8hi_scalar */

        case 35:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11336; /* pred_ussubv16hi_scalar */

        case 36:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11338; /* pred_ussubv32hi_scalar */

        case 37:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11340; /* pred_ussubv64hi_scalar */

        case 38:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11342; /* pred_ussubv128hi_scalar */

        case 39:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11344; /* pred_ussubv256hi_scalar */

        case 40:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11346; /* pred_ussubv512hi_scalar */

        case 41:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11348; /* pred_ussubv1024hi_scalar */

        case 42:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11350; /* pred_ussubv2048hi_scalar */

        case 43:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11352; /* pred_ussubv1si_scalar */

        case 44:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11354; /* pred_ussubv2si_scalar */

        case 45:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11356; /* pred_ussubv4si_scalar */

        case 46:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11358; /* pred_ussubv8si_scalar */

        case 47:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11360; /* pred_ussubv16si_scalar */

        case 48:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11362; /* pred_ussubv32si_scalar */

        case 49:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11364; /* pred_ussubv64si_scalar */

        case 50:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11366; /* pred_ussubv128si_scalar */

        case 51:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11368; /* pred_ussubv256si_scalar */

        case 52:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11370; /* pred_ussubv512si_scalar */

        case 53:
          if (!(
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11372; /* pred_ussubv1024si_scalar */

        case 54:
          if (!(
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11390; /* *pred_ussubrvvm8di_scalar */

        case 55:
          if (!(
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11392; /* *pred_ussubrvvm4di_scalar */

        case 56:
          if (!(
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11394; /* *pred_ussubrvvm2di_scalar */

        case 57:
          if (!(
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11396; /* *pred_ussubrvvm1di_scalar */

        case 58:
          if (!(
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11398; /* *pred_ussubrvvm8di_extended_scalar */

        case 59:
          if (!(
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11400; /* *pred_ussubrvvm4di_extended_scalar */

        case 60:
          if (!(
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11402; /* *pred_ussubrvvm2di_extended_scalar */

        case 61:
          if (!(
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11404; /* *pred_ussubrvvm1di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_922 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1256; /* *pred_mov_widthwurvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1262; /* *pred_mov_widthwurvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1268; /* *pred_mov_widthwurvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1274; /* *pred_mov_widthwurvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1280; /* *pred_mov_widthwurvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1286; /* *pred_mov_widthwurvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1292; /* *pred_mov_widthwurvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1298; /* *pred_mov_widthwurvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1304; /* *pred_mov_widthwurvvm8si */

    case 9:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1310; /* *pred_mov_widthwurvvm4si */

    case 10:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1316; /* *pred_mov_widthwurvvm2si */

    case 11:
      if (!
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1322; /* *pred_mov_widthwurvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1328; /* *pred_mov_widthwurvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1334; /* *pred_mov_widthwurvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1340; /* *pred_mov_widthwurvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1346; /* *pred_mov_widthwurvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1352; /* *pred_mov_widthwurvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1358; /* *pred_mov_widthwurvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1364; /* *pred_mov_widthwurvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1370; /* *pred_mov_widthwurvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1376; /* *pred_mov_widthwurvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1382; /* *pred_mov_widthwurvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1388; /* *pred_mov_widthwurvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1394; /* *pred_mov_widthwurvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1400; /* *pred_mov_widthwurvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1406; /* *pred_mov_widthwurvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1412; /* *pred_mov_widthwurvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1418; /* *pred_mov_widthwurvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1424; /* *pred_mov_widthwurvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1430; /* *pred_mov_widthwurvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1436; /* *pred_mov_widthwurvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1442; /* *pred_mov_widthwurvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1448; /* *pred_mov_widthwurvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1454; /* *pred_mov_widthwurvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1460; /* *pred_mov_widthwurvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1466; /* *pred_mov_widthwurvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1472; /* *pred_mov_widthwurvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1478; /* *pred_mov_widthwurvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1484; /* *pred_mov_widthwurvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1490; /* *pred_mov_widthwurvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1496; /* *pred_mov_widthwurvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1502; /* *pred_mov_widthwurvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1508; /* *pred_mov_widthwurvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1514; /* *pred_mov_widthwuv1qi */

    case 44:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1520; /* *pred_mov_widthwuv2qi */

    case 45:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1526; /* *pred_mov_widthwuv4qi */

    case 46:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1532; /* *pred_mov_widthwuv8qi */

    case 47:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1538; /* *pred_mov_widthwuv16qi */

    case 48:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1544; /* *pred_mov_widthwuv32qi */

    case 49:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1550; /* *pred_mov_widthwuv64qi */

    case 50:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1556; /* *pred_mov_widthwuv128qi */

    case 51:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1562; /* *pred_mov_widthwuv256qi */

    case 52:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1568; /* *pred_mov_widthwuv512qi */

    case 53:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1574; /* *pred_mov_widthwuv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1580; /* *pred_mov_widthwuv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1586; /* *pred_mov_widthwuv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1592; /* *pred_mov_widthwuv1hi */

    case 57:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1598; /* *pred_mov_widthwuv2hi */

    case 58:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1604; /* *pred_mov_widthwuv4hi */

    case 59:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1610; /* *pred_mov_widthwuv8hi */

    case 60:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1616; /* *pred_mov_widthwuv16hi */

    case 61:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1622; /* *pred_mov_widthwuv32hi */

    case 62:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1628; /* *pred_mov_widthwuv64hi */

    case 63:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1634; /* *pred_mov_widthwuv128hi */

    case 64:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1640; /* *pred_mov_widthwuv256hi */

    case 65:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1646; /* *pred_mov_widthwuv512hi */

    case 66:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1652; /* *pred_mov_widthwuv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1658; /* *pred_mov_widthwuv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1664; /* *pred_mov_widthwuv1si */

    case 69:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1670; /* *pred_mov_widthwuv2si */

    case 70:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1676; /* *pred_mov_widthwuv4si */

    case 71:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1682; /* *pred_mov_widthwuv8si */

    case 72:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1688; /* *pred_mov_widthwuv16si */

    case 73:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1694; /* *pred_mov_widthwuv32si */

    case 74:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1700; /* *pred_mov_widthwuv64si */

    case 75:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1706; /* *pred_mov_widthwuv128si */

    case 76:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1712; /* *pred_mov_widthwuv256si */

    case 77:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1718; /* *pred_mov_widthwuv512si */

    case 78:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1724; /* *pred_mov_widthwuv1024si */

    case 79:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1730; /* *pred_mov_widthwuv1di */

    case 80:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1736; /* *pred_mov_widthwuv2di */

    case 81:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1742; /* *pred_mov_widthwuv4di */

    case 82:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1748; /* *pred_mov_widthwuv8di */

    case 83:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1754; /* *pred_mov_widthwuv16di */

    case 84:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1760; /* *pred_mov_widthwuv32di */

    case 85:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1766; /* *pred_mov_widthwuv64di */

    case 86:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1772; /* *pred_mov_widthwuv128di */

    case 87:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1778; /* *pred_mov_widthwuv256di */

    case 88:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1784; /* *pred_mov_widthwuv512di */

    case 89:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1790; /* *pred_mov_widthwuv1hf */

    case 90:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1796; /* *pred_mov_widthwuv2hf */

    case 91:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1802; /* *pred_mov_widthwuv4hf */

    case 92:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1808; /* *pred_mov_widthwuv8hf */

    case 93:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1814; /* *pred_mov_widthwuv16hf */

    case 94:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1820; /* *pred_mov_widthwuv32hf */

    case 95:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1826; /* *pred_mov_widthwuv64hf */

    case 96:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1832; /* *pred_mov_widthwuv128hf */

    case 97:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1838; /* *pred_mov_widthwuv256hf */

    case 98:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1844; /* *pred_mov_widthwuv512hf */

    case 99:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1850; /* *pred_mov_widthwuv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1856; /* *pred_mov_widthwuv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1862; /* *pred_mov_widthwuv1sf */

    case 102:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1868; /* *pred_mov_widthwuv2sf */

    case 103:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1874; /* *pred_mov_widthwuv4sf */

    case 104:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1880; /* *pred_mov_widthwuv8sf */

    case 105:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1886; /* *pred_mov_widthwuv16sf */

    case 106:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1892; /* *pred_mov_widthwuv32sf */

    case 107:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1898; /* *pred_mov_widthwuv64sf */

    case 108:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1904; /* *pred_mov_widthwuv128sf */

    case 109:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1910; /* *pred_mov_widthwuv256sf */

    case 110:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1916; /* *pred_mov_widthwuv512sf */

    case 111:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1922; /* *pred_mov_widthwuv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1928; /* *pred_mov_widthwuv1df */

    case 113:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1934; /* *pred_mov_widthwuv2df */

    case 114:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1940; /* *pred_mov_widthwuv4df */

    case 115:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1946; /* *pred_mov_widthwuv8df */

    case 116:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1952; /* *pred_mov_widthwuv16df */

    case 117:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1958; /* *pred_mov_widthwuv32df */

    case 118:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1964; /* *pred_mov_widthwuv64df */

    case 119:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1970; /* *pred_mov_widthwuv128df */

    case 120:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1976; /* *pred_mov_widthwuv256df */

    case 121:
      if (!(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1982; /* *pred_mov_widthwuv512df */

    default:
      return -1;
    }
}

 int
recog_934 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11406; /* pred_aaddrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11882; /* pred_aaddrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11413; /* pred_aaddrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11887; /* pred_aaddrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11420; /* pred_aaddrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11892; /* pred_aaddrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11427; /* pred_aaddrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11897; /* pred_aaddrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11434; /* pred_aaddrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11917; /* pred_aaddrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11441; /* pred_aaddrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11922; /* pred_aaddrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11448; /* pred_aaddrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11927; /* pred_aaddrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11455; /* pred_aaddrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11932; /* pred_aaddrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11462; /* pred_aaddrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11947; /* pred_aaddrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11469; /* pred_aaddrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11952; /* pred_aaddrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11476; /* pred_aaddrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11957; /* pred_aaddrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11483; /* pred_aaddrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11962; /* pred_aaddrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11490; /* pred_aaddrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12196; /* *pred_aaddrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11497; /* pred_aaddrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12201; /* *pred_aaddrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11504; /* pred_aaddrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12206; /* *pred_aaddrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11511; /* pred_aaddrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12211; /* *pred_aaddrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11518; /* pred_aaddrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11902; /* pred_aaddrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11525; /* pred_aaddrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11907; /* pred_aaddrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11532; /* pred_aaddrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11912; /* pred_aaddrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11539; /* pred_aaddrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11937; /* pred_aaddrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11546; /* pred_aaddrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11942; /* pred_aaddrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11553; /* pred_aaddrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11967; /* pred_aaddrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11560; /* pred_aaddv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11972; /* pred_aaddv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11567; /* pred_aaddv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11977; /* pred_aaddv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11574; /* pred_aaddv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11982; /* pred_aaddv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11581; /* pred_aaddv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11987; /* pred_aaddv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11588; /* pred_aaddv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11992; /* pred_aaddv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11595; /* pred_aaddv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11997; /* pred_aaddv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11602; /* pred_aaddv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12002; /* pred_aaddv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11609; /* pred_aaddv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12007; /* pred_aaddv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11616; /* pred_aaddv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12012; /* pred_aaddv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11623; /* pred_aaddv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12017; /* pred_aaddv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11630; /* pred_aaddv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12022; /* pred_aaddv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11637; /* pred_aaddv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12027; /* pred_aaddv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11644; /* pred_aaddv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12032; /* pred_aaddv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11651; /* pred_aaddv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12037; /* pred_aaddv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11658; /* pred_aaddv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12042; /* pred_aaddv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11665; /* pred_aaddv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12047; /* pred_aaddv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11672; /* pred_aaddv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12052; /* pred_aaddv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11679; /* pred_aaddv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12057; /* pred_aaddv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11686; /* pred_aaddv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12062; /* pred_aaddv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11693; /* pred_aaddv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12067; /* pred_aaddv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11700; /* pred_aaddv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12072; /* pred_aaddv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11707; /* pred_aaddv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12077; /* pred_aaddv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11714; /* pred_aaddv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12082; /* pred_aaddv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11721; /* pred_aaddv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12087; /* pred_aaddv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11728; /* pred_aaddv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12092; /* pred_aaddv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11735; /* pred_aaddv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12097; /* pred_aaddv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11742; /* pred_aaddv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12102; /* pred_aaddv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11749; /* pred_aaddv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12107; /* pred_aaddv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11756; /* pred_aaddv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12112; /* pred_aaddv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11763; /* pred_aaddv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12117; /* pred_aaddv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11770; /* pred_aaddv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12122; /* pred_aaddv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11777; /* pred_aaddv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12127; /* pred_aaddv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11784; /* pred_aaddv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12132; /* pred_aaddv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11791; /* pred_aaddv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12137; /* pred_aaddv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11798; /* pred_aaddv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12142; /* pred_aaddv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11805; /* pred_aaddv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12147; /* pred_aaddv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11812; /* pred_aaddv1di */

    case 59:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11819; /* pred_aaddv2di */

    case 60:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11826; /* pred_aaddv4di */

    case 61:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11833; /* pred_aaddv8di */

    case 62:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11840; /* pred_aaddv16di */

    case 63:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11847; /* pred_aaddv32di */

    case 64:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11854; /* pred_aaddv64di */

    case 65:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11861; /* pred_aaddv128di */

    case 66:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11868; /* pred_aaddv256di */

    case 67:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11875; /* pred_aaddv512di */

    case 68:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12216; /* *pred_aaddrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12221; /* *pred_aaddrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12226; /* *pred_aaddrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12231; /* *pred_aaddrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_1091 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15826; /* *pred_mul_neg_addv256df_undef */
}

 int
recog_1101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1084 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15908; /* *pred_nmsubv2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16004; /* *pred_nmsacv2df */
}

 int
recog_1111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1074 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15888; /* *pred_nmsubv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15984; /* *pred_nmsacv4sf */
}

 int
recog_1121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1064 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15868; /* *pred_nmsubv16hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15964; /* *pred_nmsacv16hf */
}

 int
recog_1130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1055 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15850; /* *pred_nmsubrvvmf2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15946; /* *pred_nmsacrvvmf2sf */
}

 int
recog_1141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern583 (x2))
    {
    case 0:
      return recog_1044 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1043 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1042 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1041 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1040 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1039 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1038 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1037 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1036 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1035 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1034 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1033 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1032 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1031 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1030 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1029 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1028 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1027 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1026 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1025 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1024 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1023 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1022 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1021 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1020 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1019 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1018 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1017 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1016 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1015 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1014 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1013 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1012 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1011 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1010 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1009 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1008 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1007 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1006 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1005 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1004 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1003 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1002 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1001 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1000 (x1, insn, pnum_clobbers);

    case 45:
      return recog_999 (x1, insn, pnum_clobbers);

    case 46:
      return recog_998 (x1, insn, pnum_clobbers);

    case 47:
      return recog_997 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15542; /* *pred_maddrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15638; /* *pred_maccrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15544; /* *pred_maddrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15640; /* *pred_maccrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15546; /* *pred_maddrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15642; /* *pred_maccrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15548; /* *pred_maddrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15644; /* *pred_maccrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15550; /* *pred_maddrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15646; /* *pred_maccrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 15552; /* *pred_maddrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15648; /* *pred_maccrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15554; /* *pred_maddrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15650; /* *pred_maccrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15556; /* *pred_maddrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15652; /* *pred_maccrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15558; /* *pred_maddrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15654; /* *pred_maccrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15560; /* *pred_maddrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15656; /* *pred_maccrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 15562; /* *pred_maddrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15658; /* *pred_maccrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15564; /* *pred_maddrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15660; /* *pred_maccrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15566; /* *pred_maddrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15662; /* *pred_maccrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15568; /* *pred_maddrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15664; /* *pred_maccrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15570; /* *pred_maddrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15666; /* *pred_maccrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 15572; /* *pred_maddv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15668; /* *pred_maccv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 15574; /* *pred_maddv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15670; /* *pred_maccv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 15576; /* *pred_maddv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15672; /* *pred_maccv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 15578; /* *pred_maddv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15674; /* *pred_maccv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 15580; /* *pred_maddv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15676; /* *pred_maccv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 15582; /* *pred_maddv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15678; /* *pred_maccv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 15584; /* *pred_maddv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15680; /* *pred_maccv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 15586; /* *pred_maddv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15682; /* *pred_maccv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 15588; /* *pred_maddv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15684; /* *pred_maccv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 15590; /* *pred_maddv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15686; /* *pred_maccv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 15592; /* *pred_maddv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15688; /* *pred_maccv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 15594; /* *pred_maddv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15690; /* *pred_maccv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15596; /* *pred_maddv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15692; /* *pred_maccv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15598; /* *pred_maddv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15694; /* *pred_maccv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15600; /* *pred_maddv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15696; /* *pred_maccv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15602; /* *pred_maddv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15698; /* *pred_maccv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 15604; /* *pred_maddv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15700; /* *pred_maccv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 15606; /* *pred_maddv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15702; /* *pred_maccv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 15608; /* *pred_maddv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15704; /* *pred_maccv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 15610; /* *pred_maddv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15706; /* *pred_maccv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 15612; /* *pred_maddv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15708; /* *pred_maccv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 15614; /* *pred_maddv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15710; /* *pred_maccv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 15616; /* *pred_maddv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15712; /* *pred_maccv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15618; /* *pred_maddv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15714; /* *pred_maccv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15620; /* *pred_maddv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15716; /* *pred_maccv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15622; /* *pred_maddv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15718; /* *pred_maccv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 15624; /* *pred_maddv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15720; /* *pred_maccv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 15626; /* *pred_maddv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15722; /* *pred_maccv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 15628; /* *pred_maddv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15724; /* *pred_maccv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 15630; /* *pred_maddv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15726; /* *pred_maccv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 15632; /* *pred_maddv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15728; /* *pred_maccv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 15634; /* *pred_maddv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15730; /* *pred_maccv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 15636; /* *pred_maddv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15732; /* *pred_maccv512df_scalar */

    case 96:
      return recog_996 (x1, insn, pnum_clobbers);

    case 97:
      return recog_995 (x1, insn, pnum_clobbers);

    case 98:
      return recog_994 (x1, insn, pnum_clobbers);

    case 99:
      return recog_993 (x1, insn, pnum_clobbers);

    case 100:
      return recog_992 (x1, insn, pnum_clobbers);

    case 101:
      if (pattern702 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16713; /* pred_widen_mul_addrvvm8df */

    case 102:
      if (pattern702 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16715; /* pred_widen_mul_addrvvm4df */

    case 103:
      if (pattern702 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16717; /* pred_widen_mul_addrvvm2df */

    case 104:
      if (pattern702 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16719; /* pred_widen_mul_addrvvm1df */

    case 105:
      if (pattern702 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16721; /* pred_widen_mul_addv1sf */

    case 106:
      if (pattern702 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16723; /* pred_widen_mul_addv2sf */

    case 107:
      if (pattern702 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16725; /* pred_widen_mul_addv4sf */

    case 108:
      if (pattern702 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16727; /* pred_widen_mul_addv8sf */

    case 109:
      if (pattern702 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16729; /* pred_widen_mul_addv16sf */

    case 110:
      if (pattern702 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16731; /* pred_widen_mul_addv32sf */

    case 111:
      if (pattern702 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16733; /* pred_widen_mul_addv64sf */

    case 112:
      if (pattern702 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16735; /* pred_widen_mul_addv128sf */

    case 113:
      if (pattern702 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16737; /* pred_widen_mul_addv256sf */

    case 114:
      if (pattern702 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16739; /* pred_widen_mul_addv512sf */

    case 115:
      if (pattern702 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16741; /* pred_widen_mul_addv1024sf */

    case 116:
      if (pattern702 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16743; /* pred_widen_mul_addv1df */

    case 117:
      if (pattern702 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16745; /* pred_widen_mul_addv2df */

    case 118:
      if (pattern702 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16747; /* pred_widen_mul_addv4df */

    case 119:
      if (pattern702 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16749; /* pred_widen_mul_addv8df */

    case 120:
      if (pattern702 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16751; /* pred_widen_mul_addv16df */

    case 121:
      if (pattern702 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16753; /* pred_widen_mul_addv32df */

    case 122:
      if (pattern702 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16755; /* pred_widen_mul_addv64df */

    case 123:
      if (pattern702 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16757; /* pred_widen_mul_addv128df */

    case 124:
      if (pattern702 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16759; /* pred_widen_mul_addv256df */

    case 125:
      if (pattern702 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16761; /* pred_widen_mul_addv512df */

    case 126:
      return recog_991 (x1, insn, pnum_clobbers);

    case 127:
      return recog_990 (x1, insn, pnum_clobbers);

    case 128:
      return recog_989 (x1, insn, pnum_clobbers);

    case 129:
      return recog_988 (x1, insn, pnum_clobbers);

    case 130:
      return recog_987 (x1, insn, pnum_clobbers);

    case 131:
      if (pattern704 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16773; /* pred_widen_mul_addrvvm8df_scalar */

    case 132:
      if (pattern704 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16775; /* pred_widen_mul_addrvvm4df_scalar */

    case 133:
      if (pattern704 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16777; /* pred_widen_mul_addrvvm2df_scalar */

    case 134:
      if (pattern704 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16779; /* pred_widen_mul_addrvvm1df_scalar */

    case 135:
      if (pattern704 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16781; /* pred_widen_mul_addv1sf_scalar */

    case 136:
      if (pattern704 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16783; /* pred_widen_mul_addv2sf_scalar */

    case 137:
      if (pattern704 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16785; /* pred_widen_mul_addv4sf_scalar */

    case 138:
      if (pattern704 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16787; /* pred_widen_mul_addv8sf_scalar */

    case 139:
      if (pattern704 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16789; /* pred_widen_mul_addv16sf_scalar */

    case 140:
      if (pattern704 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16791; /* pred_widen_mul_addv32sf_scalar */

    case 141:
      if (pattern704 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16793; /* pred_widen_mul_addv64sf_scalar */

    case 142:
      if (pattern704 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16795; /* pred_widen_mul_addv128sf_scalar */

    case 143:
      if (pattern704 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16797; /* pred_widen_mul_addv256sf_scalar */

    case 144:
      if (pattern704 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16799; /* pred_widen_mul_addv512sf_scalar */

    case 145:
      if (pattern704 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16801; /* pred_widen_mul_addv1024sf_scalar */

    case 146:
      if (pattern704 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16803; /* pred_widen_mul_addv1df_scalar */

    case 147:
      if (pattern704 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16805; /* pred_widen_mul_addv2df_scalar */

    case 148:
      if (pattern704 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16807; /* pred_widen_mul_addv4df_scalar */

    case 149:
      if (pattern704 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16809; /* pred_widen_mul_addv8df_scalar */

    case 150:
      if (pattern704 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16811; /* pred_widen_mul_addv16df_scalar */

    case 151:
      if (pattern704 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16813; /* pred_widen_mul_addv32df_scalar */

    case 152:
      if (pattern704 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16815; /* pred_widen_mul_addv64df_scalar */

    case 153:
      if (pattern704 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16817; /* pred_widen_mul_addv128df_scalar */

    case 154:
      if (pattern704 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16819; /* pred_widen_mul_addv256df_scalar */

    case 155:
      if (pattern704 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16821; /* pred_widen_mul_addv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern576 (x2))
    {
    case 0:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17472; /* pred_floatunsrvvm8hf */

    case 1:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17474; /* pred_floatunsrvvm4hf */

    case 2:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18006; /* pred_narrow_floatunsrvvm8si */

    case 3:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17476; /* pred_floatunsrvvm2hf */

    case 4:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18008; /* pred_narrow_floatunsrvvm4si */

    case 5:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17478; /* pred_floatunsrvvm1hf */

    case 6:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18010; /* pred_narrow_floatunsrvvm2si */

    case 7:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17480; /* pred_floatunsrvvmf2hf */

    case 8:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18012; /* pred_narrow_floatunsrvvm1si */

    case 9:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17482; /* pred_floatunsrvvmf4hf */

    case 10:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18014; /* pred_narrow_floatunsrvvmf2si */

    case 11:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17484; /* pred_floatunsrvvm8sf */

    case 12:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17486; /* pred_floatunsrvvm4sf */

    case 13:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18016; /* pred_narrow_floatunsrvvm8di */

    case 14:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17488; /* pred_floatunsrvvm2sf */

    case 15:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18018; /* pred_narrow_floatunsrvvm4di */

    case 16:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17490; /* pred_floatunsrvvm1sf */

    case 17:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18020; /* pred_narrow_floatunsrvvm2di */

    case 18:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17492; /* pred_floatunsrvvmf2sf */

    case 19:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18022; /* pred_narrow_floatunsrvvm1di */

    case 20:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17494; /* pred_floatunsrvvm8df */

    case 21:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17496; /* pred_floatunsrvvm4df */

    case 22:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17498; /* pred_floatunsrvvm2df */

    case 23:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17500; /* pred_floatunsrvvm1df */

    case 24:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17502; /* pred_floatunsv1hf */

    case 25:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 18024; /* pred_narrow_floatunsv1si */

    case 26:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17504; /* pred_floatunsv2hf */

    case 27:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 18026; /* pred_narrow_floatunsv2si */

    case 28:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17506; /* pred_floatunsv4hf */

    case 29:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 18028; /* pred_narrow_floatunsv4si */

    case 30:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17508; /* pred_floatunsv8hf */

    case 31:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 18030; /* pred_narrow_floatunsv8si */

    case 32:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17510; /* pred_floatunsv16hf */

    case 33:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18032; /* pred_narrow_floatunsv16si */

    case 34:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17512; /* pred_floatunsv32hf */

    case 35:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18034; /* pred_narrow_floatunsv32si */

    case 36:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17514; /* pred_floatunsv64hf */

    case 37:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18036; /* pred_narrow_floatunsv64si */

    case 38:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17516; /* pred_floatunsv128hf */

    case 39:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18038; /* pred_narrow_floatunsv128si */

    case 40:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17518; /* pred_floatunsv256hf */

    case 41:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18040; /* pred_narrow_floatunsv256si */

    case 42:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17520; /* pred_floatunsv512hf */

    case 43:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18042; /* pred_narrow_floatunsv512si */

    case 44:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17522; /* pred_floatunsv1024hf */

    case 45:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18044; /* pred_narrow_floatunsv1024si */

    case 46:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17524; /* pred_floatunsv2048hf */

    case 47:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17526; /* pred_floatunsv1sf */

    case 48:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18046; /* pred_narrow_floatunsv1di */

    case 49:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17528; /* pred_floatunsv2sf */

    case 50:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18048; /* pred_narrow_floatunsv2di */

    case 51:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17530; /* pred_floatunsv4sf */

    case 52:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18050; /* pred_narrow_floatunsv4di */

    case 53:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17532; /* pred_floatunsv8sf */

    case 54:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18052; /* pred_narrow_floatunsv8di */

    case 55:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17534; /* pred_floatunsv16sf */

    case 56:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18054; /* pred_narrow_floatunsv16di */

    case 57:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17536; /* pred_floatunsv32sf */

    case 58:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18056; /* pred_narrow_floatunsv32di */

    case 59:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17538; /* pred_floatunsv64sf */

    case 60:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18058; /* pred_narrow_floatunsv64di */

    case 61:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17540; /* pred_floatunsv128sf */

    case 62:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18060; /* pred_narrow_floatunsv128di */

    case 63:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17542; /* pred_floatunsv256sf */

    case 64:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18062; /* pred_narrow_floatunsv256di */

    case 65:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17544; /* pred_floatunsv512sf */

    case 66:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18064; /* pred_narrow_floatunsv512di */

    case 67:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17546; /* pred_floatunsv1024sf */

    case 68:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17548; /* pred_floatunsv1df */

    case 69:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17550; /* pred_floatunsv2df */

    case 70:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17552; /* pred_floatunsv4df */

    case 71:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17554; /* pred_floatunsv8df */

    case 72:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17556; /* pred_floatunsv16df */

    case 73:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17558; /* pred_floatunsv32df */

    case 74:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17560; /* pred_floatunsv64df */

    case 75:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17562; /* pred_floatunsv128df */

    case 76:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17564; /* pred_floatunsv256df */

    case 77:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17566; /* pred_floatunsv512df */

    default:
      return -1;
    }
}

 int
recog_1359 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V64QImode:
      if (!register_operand (operands[3], E_V64QImode)
          || !vector_arith_operand (operands[4], E_V64QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12455; /* *pred_cmpv64qi_merge_tie_mask */

    case E_V64HImode:
      if (!register_operand (operands[3], E_V64HImode)
          || !vector_arith_operand (operands[4], E_V64HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12468; /* *pred_cmpv64hi_merge_tie_mask */

    case E_V64SImode:
      if (!register_operand (operands[3], E_V64SImode)
          || !vector_arith_operand (operands[4], E_V64SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12480; /* *pred_cmpv64si_merge_tie_mask */

    case E_V64DImode:
      if (!register_operand (operands[3], E_V64DImode)
          || !vector_arith_operand (operands[4], E_V64DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12491; /* *pred_cmpv64di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1362 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || !vector_arith_operand (operands[5], E_V512QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12526; /* *pred_cmpv512qi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12594; /* *pred_cmpv512qi_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || !vector_arith_operand (operands[5], E_V512HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12539; /* *pred_cmpv512hi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12607; /* *pred_cmpv512hi_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || !vector_arith_operand (operands[5], E_V512SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12551; /* *pred_cmpv512si */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12619; /* *pred_cmpv512si_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || !vector_arith_operand (operands[5], E_V512DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12562; /* *pred_cmpv512di */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12630; /* *pred_cmpv512di_narrow */

    default:
      return -1;
    }
}

 int
recog_1372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1355 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || !vector_arith_operand (operands[5], E_V4QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12519; /* *pred_cmpv4qi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12587; /* *pred_cmpv4qi_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || !vector_arith_operand (operands[5], E_V4HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12532; /* *pred_cmpv4hi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12600; /* *pred_cmpv4hi_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || !vector_arith_operand (operands[5], E_V4SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12544; /* *pred_cmpv4si */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12612; /* *pred_cmpv4si_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || !vector_arith_operand (operands[5], E_V4DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12555; /* *pred_cmpv4di */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12623; /* *pred_cmpv4di_narrow */

    default:
      return -1;
    }
}

 int
recog_1384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode)
          || !vector_neg_arith_operand (operands[4], E_V16QImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12657; /* *pred_ltgev16qi_merge_tie_mask */

    case E_V16HImode:
      if (!register_operand (operands[3], E_V16HImode)
          || !vector_neg_arith_operand (operands[4], E_V16HImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12670; /* *pred_ltgev16hi_merge_tie_mask */

    case E_V16SImode:
      if (!register_operand (operands[3], E_V16SImode)
          || !vector_neg_arith_operand (operands[4], E_V16SImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12682; /* *pred_ltgev16si_merge_tie_mask */

    case E_V16DImode:
      if (!register_operand (operands[3], E_V16DImode)
          || !vector_neg_arith_operand (operands[4], E_V16DImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12693; /* *pred_ltgev16di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2048QImode:
      if (!register_operand (operands[3], E_V2048QImode)
          || !vector_neg_arith_operand (operands[4], E_V2048QImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12664; /* *pred_ltgev2048qi_merge_tie_mask */

    case E_V2048HImode:
      if (!register_operand (operands[3], E_V2048HImode)
          || !vector_neg_arith_operand (operands[4], E_V2048HImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12677; /* *pred_ltgev2048hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1385 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32QImode:
      if (!register_operand (operands[4], E_V32QImode)
          || !vector_neg_arith_operand (operands[5], E_V32QImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32QImode)) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 12726; /* *pred_ltgev32qi */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32QImode)) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12794; /* *pred_ltgev32qi_narrow */

    case E_V32HImode:
      if (!register_operand (operands[4], E_V32HImode)
          || !vector_neg_arith_operand (operands[5], E_V32HImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HImode)) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12739; /* *pred_ltgev32hi */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HImode)) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12807; /* *pred_ltgev32hi_narrow */

    case E_V32SImode:
      if (!register_operand (operands[4], E_V32SImode)
          || !vector_neg_arith_operand (operands[5], E_V32SImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SImode)) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12751; /* *pred_ltgev32si */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SImode)) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12819; /* *pred_ltgev32si_narrow */

    case E_V32DImode:
      if (!register_operand (operands[4], E_V32DImode)
          || !vector_neg_arith_operand (operands[5], E_V32DImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode)) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12762; /* *pred_ltgev32di */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode)) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12830; /* *pred_ltgev32di_narrow */

    default:
      return -1;
    }
}

 int
recog_1405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || GET_MODE (x9) != E_RVVMF4QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12840; /* *pred_cmprvvmf4qi_scalar_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || GET_MODE (x9) != E_RVVMF2HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12846; /* *pred_cmprvvmf2hi_scalar_merge_tie_mask */

    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || GET_MODE (x9) != E_RVVM1SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12851; /* *pred_cmprvvm1si_scalar_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || GET_MODE (x9) != E_RVVM2DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12999; /* *pred_cmprvvm2di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || GET_MODE (x9) != E_V32QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12858; /* *pred_cmpv32qi_scalar_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || GET_MODE (x9) != E_V32HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12871; /* *pred_cmpv32hi_scalar_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || GET_MODE (x9) != E_V32SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12883; /* *pred_cmpv32si_scalar_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || GET_MODE (x9) != E_V32DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13006; /* *pred_cmpv32di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1419 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1416 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12916; /* *pred_cmpv512qi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12970; /* *pred_cmpv512qi_scalar_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12929; /* *pred_cmpv512hi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12983; /* *pred_cmpv512hi_scalar_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12941; /* *pred_cmpv512si_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12995; /* *pred_cmpv512si_scalar_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 13024; /* *pred_cmpv512di_scalar */
      if (!(
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13038; /* *pred_cmpv512di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1426 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1409 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12909; /* *pred_cmpv4qi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12963; /* *pred_cmpv4qi_scalar_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12922; /* *pred_cmpv4hi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12976; /* *pred_cmpv4hi_scalar_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12934; /* *pred_cmpv4si_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12988; /* *pred_cmpv4si_scalar_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 13017; /* *pred_cmpv4di_scalar */
      if (!(
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13031; /* *pred_cmpv4di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16996; /* *pred_cmprvvmf4hf_narrow_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || !register_operand (operands[4], E_RVVMF2SFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17001; /* *pred_cmprvvmf2sf_narrow_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || !register_operand (operands[4], E_RVVM1DFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17005; /* *pred_cmprvvm1df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || !register_operand (operands[4], E_V16HFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17010; /* *pred_cmpv16hf_narrow_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || !register_operand (operands[4], E_V16SFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17022; /* *pred_cmpv16sf_narrow_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || !register_operand (operands[4], E_V16DFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17033; /* *pred_cmpv16df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1445 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || !register_operand (operands[4], E_V512HFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17015; /* *pred_cmpv512hf_narrow_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || !register_operand (operands[4], E_V512SFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17027; /* *pred_cmpv512sf_narrow_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || !register_operand (operands[4], E_V512DFmode)
          || !(
#line 7330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17038; /* *pred_cmpv512df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1451 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || GET_MODE (x9) != E_RVVMF4HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17092; /* *pred_cmprvvmf4hf_scalar_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || GET_MODE (x9) != E_RVVMF2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17097; /* *pred_cmprvvmf2sf_scalar_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || GET_MODE (x9) != E_RVVM1DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17101; /* *pred_cmprvvm1df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1456 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || GET_MODE (x9) != E_V16HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17106; /* *pred_cmpv16hf_scalar_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || GET_MODE (x9) != E_V16SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17118; /* *pred_cmpv16sf_scalar_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || GET_MODE (x9) != E_V16DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17129; /* *pred_cmpv16df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[3], E_V1024HFmode)
          || GET_MODE (x9) != E_V1024HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17112; /* *pred_cmpv1024hf_scalar_merge_tie_mask */

    case E_V1024SFmode:
      if (!register_operand (operands[3], E_V1024SFmode)
          || GET_MODE (x9) != E_V1024SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17124; /* *pred_cmpv1024sf_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1457 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[4], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HFmode)) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 17155; /* *pred_cmpv32hf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HFmode)) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17203; /* *pred_cmpv32hf_scalar_narrow */

    case E_V32SFmode:
      if (!register_operand (operands[4], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SFmode)) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 17167; /* *pred_cmpv32sf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SFmode)) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17215; /* *pred_cmpv32sf_scalar_narrow */

    case E_V32DFmode:
      if (!register_operand (operands[4], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DFmode)) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 17178; /* *pred_cmpv32df_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DFmode)) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17226; /* *pred_cmpv32df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern219 (x2))
    {
    case 0:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25981; /* vcond_mask_rvvm8qirvvm1bi */

    case 1:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25982; /* vcond_mask_rvvm4qirvvmf2bi */

    case 2:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25983; /* vcond_mask_rvvm2qirvvmf4bi */

    case 3:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25984; /* vcond_mask_rvvm1qirvvmf8bi */

    case 4:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25985; /* vcond_mask_rvvm8hirvvmf2bi */

    case 5:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25986; /* vcond_mask_rvvm4hirvvmf4bi */

    case 6:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25987; /* vcond_mask_rvvm2hirvvmf8bi */

    case 7:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25988; /* vcond_mask_rvvm1hirvvmf16bi */

    case 8:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25989; /* vcond_mask_rvvm8sirvvmf4bi */

    case 9:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25990; /* vcond_mask_rvvm4sirvvmf8bi */

    case 10:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25991; /* vcond_mask_rvvm2sirvvmf16bi */

    case 11:
      if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25992; /* vcond_mask_rvvm1sirvvmf32bi */

    case 12:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25993; /* vcond_mask_rvvm8dirvvmf8bi */

    case 13:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25994; /* vcond_mask_rvvm4dirvvmf16bi */

    case 14:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25995; /* vcond_mask_rvvm2dirvvmf32bi */

    case 15:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25996; /* vcond_mask_rvvm1dirvvmf64bi */

    case 16:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25997; /* vcond_mask_rvvmf2qirvvmf16bi */

    case 17:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25998; /* vcond_mask_rvvmf4qirvvmf32bi */

    case 18:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25999; /* vcond_mask_rvvmf8qirvvmf64bi */

    case 19:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26000; /* vcond_mask_rvvmf2hirvvmf32bi */

    case 20:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26001; /* vcond_mask_rvvmf4hirvvmf64bi */

    case 21:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26002; /* vcond_mask_rvvmf2sirvvmf64bi */

    case 22:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26003; /* vcond_mask_rvvm8bfrvvmf2bi */

    case 23:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26004; /* vcond_mask_rvvm4bfrvvmf4bi */

    case 24:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26005; /* vcond_mask_rvvm2bfrvvmf8bi */

    case 25:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26006; /* vcond_mask_rvvm1bfrvvmf16bi */

    case 26:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26007; /* vcond_mask_rvvmf2bfrvvmf32bi */

    case 27:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26008; /* vcond_mask_rvvmf4bfrvvmf64bi */

    case 28:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26009; /* vcond_mask_rvvm8hfrvvmf2bi */

    case 29:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26010; /* vcond_mask_rvvm4hfrvvmf4bi */

    case 30:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26011; /* vcond_mask_rvvm2hfrvvmf8bi */

    case 31:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26012; /* vcond_mask_rvvm1hfrvvmf16bi */

    case 32:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26013; /* vcond_mask_rvvmf2hfrvvmf32bi */

    case 33:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26014; /* vcond_mask_rvvmf4hfrvvmf64bi */

    case 34:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26015; /* vcond_mask_rvvm8sfrvvmf4bi */

    case 35:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26016; /* vcond_mask_rvvm4sfrvvmf8bi */

    case 36:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26017; /* vcond_mask_rvvm2sfrvvmf16bi */

    case 37:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26018; /* vcond_mask_rvvm1sfrvvmf32bi */

    case 38:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26019; /* vcond_mask_rvvmf2sfrvvmf64bi */

    case 39:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26020; /* vcond_mask_rvvm8dfrvvmf8bi */

    case 40:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26021; /* vcond_mask_rvvm4dfrvvmf16bi */

    case 41:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26022; /* vcond_mask_rvvm2dfrvvmf32bi */

    case 42:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26023; /* vcond_mask_rvvm1dfrvvmf64bi */

    case 43:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26024; /* vcond_mask_v1qiv1bi */

    case 44:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26025; /* vcond_mask_v2qiv2bi */

    case 45:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26026; /* vcond_mask_v4qiv4bi */

    case 46:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26027; /* vcond_mask_v8qiv8bi */

    case 47:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26028; /* vcond_mask_v16qiv16bi */

    case 48:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26029; /* vcond_mask_v32qiv32bi */

    case 49:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26030; /* vcond_mask_v64qiv64bi */

    case 50:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26031; /* vcond_mask_v128qiv128bi */

    case 51:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26032; /* vcond_mask_v256qiv256bi */

    case 52:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26033; /* vcond_mask_v512qiv512bi */

    case 53:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26034; /* vcond_mask_v1024qiv1024bi */

    case 54:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26035; /* vcond_mask_v2048qiv2048bi */

    case 55:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26036; /* vcond_mask_v4096qiv4096bi */

    case 56:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26037; /* vcond_mask_v1hiv1bi */

    case 57:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26038; /* vcond_mask_v2hiv2bi */

    case 58:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26039; /* vcond_mask_v4hiv4bi */

    case 59:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26040; /* vcond_mask_v8hiv8bi */

    case 60:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26041; /* vcond_mask_v16hiv16bi */

    case 61:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26042; /* vcond_mask_v32hiv32bi */

    case 62:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26043; /* vcond_mask_v64hiv64bi */

    case 63:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26044; /* vcond_mask_v128hiv128bi */

    case 64:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26045; /* vcond_mask_v256hiv256bi */

    case 65:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26046; /* vcond_mask_v512hiv512bi */

    case 66:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26047; /* vcond_mask_v1024hiv1024bi */

    case 67:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26048; /* vcond_mask_v2048hiv2048bi */

    case 68:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26049; /* vcond_mask_v1siv1bi */

    case 69:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26050; /* vcond_mask_v2siv2bi */

    case 70:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26051; /* vcond_mask_v4siv4bi */

    case 71:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 26052; /* vcond_mask_v8siv8bi */

    case 72:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26053; /* vcond_mask_v16siv16bi */

    case 73:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26054; /* vcond_mask_v32siv32bi */

    case 74:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26055; /* vcond_mask_v64siv64bi */

    case 75:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26056; /* vcond_mask_v128siv128bi */

    case 76:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26057; /* vcond_mask_v256siv256bi */

    case 77:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26058; /* vcond_mask_v512siv512bi */

    case 78:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26059; /* vcond_mask_v1024siv1024bi */

    case 79:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26060; /* vcond_mask_v1div1bi */

    case 80:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26061; /* vcond_mask_v2div2bi */

    case 81:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26062; /* vcond_mask_v4div4bi */

    case 82:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26063; /* vcond_mask_v8div8bi */

    case 83:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26064; /* vcond_mask_v16div16bi */

    case 84:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26065; /* vcond_mask_v32div32bi */

    case 85:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26066; /* vcond_mask_v64div64bi */

    case 86:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26067; /* vcond_mask_v128div128bi */

    case 87:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26068; /* vcond_mask_v256div256bi */

    case 88:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26069; /* vcond_mask_v512div512bi */

    case 89:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26070; /* vcond_mask_v1hfv1bi */

    case 90:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26071; /* vcond_mask_v2hfv2bi */

    case 91:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26072; /* vcond_mask_v4hfv4bi */

    case 92:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26073; /* vcond_mask_v8hfv8bi */

    case 93:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26074; /* vcond_mask_v16hfv16bi */

    case 94:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26075; /* vcond_mask_v32hfv32bi */

    case 95:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26076; /* vcond_mask_v64hfv64bi */

    case 96:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26077; /* vcond_mask_v128hfv128bi */

    case 97:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26078; /* vcond_mask_v256hfv256bi */

    case 98:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26079; /* vcond_mask_v512hfv512bi */

    case 99:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26080; /* vcond_mask_v1024hfv1024bi */

    case 100:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26081; /* vcond_mask_v2048hfv2048bi */

    case 101:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26082; /* vcond_mask_v1sfv1bi */

    case 102:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26083; /* vcond_mask_v2sfv2bi */

    case 103:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26084; /* vcond_mask_v4sfv4bi */

    case 104:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26085; /* vcond_mask_v8sfv8bi */

    case 105:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26086; /* vcond_mask_v16sfv16bi */

    case 106:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26087; /* vcond_mask_v32sfv32bi */

    case 107:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26088; /* vcond_mask_v64sfv64bi */

    case 108:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26089; /* vcond_mask_v128sfv128bi */

    case 109:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26090; /* vcond_mask_v256sfv256bi */

    case 110:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26091; /* vcond_mask_v512sfv512bi */

    case 111:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26092; /* vcond_mask_v1024sfv1024bi */

    case 112:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26093; /* vcond_mask_v1dfv1bi */

    case 113:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26094; /* vcond_mask_v2dfv2bi */

    case 114:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26095; /* vcond_mask_v4dfv4bi */

    case 115:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26096; /* vcond_mask_v8dfv8bi */

    case 116:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26097; /* vcond_mask_v16dfv16bi */

    case 117:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26098; /* vcond_mask_v32dfv32bi */

    case 118:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26099; /* vcond_mask_v64dfv64bi */

    case 119:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26100; /* vcond_mask_v128dfv128bi */

    case 120:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26101; /* vcond_mask_v256dfv256bi */

    case 121:
      if (!(
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26102; /* vcond_mask_v512dfv512bi */

    case 122:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28328; /* *cond_absrvvm8hf */

    case 123:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28329; /* *cond_absrvvm4hf */

    case 124:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28330; /* *cond_absrvvm2hf */

    case 125:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28331; /* *cond_absrvvm1hf */

    case 126:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28332; /* *cond_absrvvmf2hf */

    case 127:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28333; /* *cond_absrvvmf4hf */

    case 128:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28334; /* *cond_absrvvm8sf */

    case 129:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28335; /* *cond_absrvvm4sf */

    case 130:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28336; /* *cond_absrvvm2sf */

    case 131:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28337; /* *cond_absrvvm1sf */

    case 132:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28338; /* *cond_absrvvmf2sf */

    case 133:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28339; /* *cond_absrvvm8df */

    case 134:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28340; /* *cond_absrvvm4df */

    case 135:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28341; /* *cond_absrvvm2df */

    case 136:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28342; /* *cond_absrvvm1df */

    case 137:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28343; /* *cond_absv1hf */

    case 138:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28344; /* *cond_absv2hf */

    case 139:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28345; /* *cond_absv4hf */

    case 140:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28346; /* *cond_absv8hf */

    case 141:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28347; /* *cond_absv16hf */

    case 142:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28348; /* *cond_absv32hf */

    case 143:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28349; /* *cond_absv64hf */

    case 144:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28350; /* *cond_absv128hf */

    case 145:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28351; /* *cond_absv256hf */

    case 146:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28352; /* *cond_absv512hf */

    case 147:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28353; /* *cond_absv1024hf */

    case 148:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28354; /* *cond_absv2048hf */

    case 149:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28355; /* *cond_absv1sf */

    case 150:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28356; /* *cond_absv2sf */

    case 151:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28357; /* *cond_absv4sf */

    case 152:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28358; /* *cond_absv8sf */

    case 153:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28359; /* *cond_absv16sf */

    case 154:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28360; /* *cond_absv32sf */

    case 155:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28361; /* *cond_absv64sf */

    case 156:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28362; /* *cond_absv128sf */

    case 157:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28363; /* *cond_absv256sf */

    case 158:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28364; /* *cond_absv512sf */

    case 159:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28365; /* *cond_absv1024sf */

    case 160:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28366; /* *cond_absv1df */

    case 161:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28367; /* *cond_absv2df */

    case 162:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28368; /* *cond_absv4df */

    case 163:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28369; /* *cond_absv8df */

    case 164:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28370; /* *cond_absv16df */

    case 165:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28371; /* *cond_absv32df */

    case 166:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28372; /* *cond_absv64df */

    case 167:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28373; /* *cond_absv128df */

    case 168:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28374; /* *cond_absv256df */

    case 169:
      if (!(
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28375; /* *cond_absv512df */

    case 170:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28376; /* *cond_sqrtrvvm8hf */

    case 171:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28377; /* *cond_sqrtrvvm4hf */

    case 172:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28378; /* *cond_sqrtrvvm2hf */

    case 173:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28379; /* *cond_sqrtrvvm1hf */

    case 174:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28380; /* *cond_sqrtrvvmf2hf */

    case 175:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28381; /* *cond_sqrtrvvmf4hf */

    case 176:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28382; /* *cond_sqrtrvvm8sf */

    case 177:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28383; /* *cond_sqrtrvvm4sf */

    case 178:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28384; /* *cond_sqrtrvvm2sf */

    case 179:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28385; /* *cond_sqrtrvvm1sf */

    case 180:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28386; /* *cond_sqrtrvvmf2sf */

    case 181:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28387; /* *cond_sqrtrvvm8df */

    case 182:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28388; /* *cond_sqrtrvvm4df */

    case 183:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28389; /* *cond_sqrtrvvm2df */

    case 184:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28390; /* *cond_sqrtrvvm1df */

    case 185:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28391; /* *cond_sqrtv1hf */

    case 186:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28392; /* *cond_sqrtv2hf */

    case 187:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28393; /* *cond_sqrtv4hf */

    case 188:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28394; /* *cond_sqrtv8hf */

    case 189:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28395; /* *cond_sqrtv16hf */

    case 190:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28396; /* *cond_sqrtv32hf */

    case 191:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28397; /* *cond_sqrtv64hf */

    case 192:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28398; /* *cond_sqrtv128hf */

    case 193:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28399; /* *cond_sqrtv256hf */

    case 194:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28400; /* *cond_sqrtv512hf */

    case 195:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28401; /* *cond_sqrtv1024hf */

    case 196:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28402; /* *cond_sqrtv2048hf */

    case 197:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28403; /* *cond_sqrtv1sf */

    case 198:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28404; /* *cond_sqrtv2sf */

    case 199:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28405; /* *cond_sqrtv4sf */

    case 200:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28406; /* *cond_sqrtv8sf */

    case 201:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28407; /* *cond_sqrtv16sf */

    case 202:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28408; /* *cond_sqrtv32sf */

    case 203:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28409; /* *cond_sqrtv64sf */

    case 204:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28410; /* *cond_sqrtv128sf */

    case 205:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28411; /* *cond_sqrtv256sf */

    case 206:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28412; /* *cond_sqrtv512sf */

    case 207:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28413; /* *cond_sqrtv1024sf */

    case 208:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28414; /* *cond_sqrtv1df */

    case 209:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28415; /* *cond_sqrtv2df */

    case 210:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28416; /* *cond_sqrtv4df */

    case 211:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28417; /* *cond_sqrtv8df */

    case 212:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28418; /* *cond_sqrtv16df */

    case 213:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28419; /* *cond_sqrtv32df */

    case 214:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28420; /* *cond_sqrtv64df */

    case 215:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28421; /* *cond_sqrtv128df */

    case 216:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28422; /* *cond_sqrtv256df */

    case 217:
      if (!(
#line 126 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28423; /* *cond_sqrtv512df */

    case 218:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28424; /* *cond_extendrvvm4qirvvm8hi */

    case 219:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28426; /* *cond_extendrvvm2qirvvm4hi */

    case 220:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28428; /* *cond_extendrvvm1qirvvm2hi */

    case 221:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28430; /* *cond_extendrvvmf2qirvvm1hi */

    case 222:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28432; /* *cond_extendrvvmf4qirvvmf2hi */

    case 223:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28434; /* *cond_extendrvvmf8qirvvmf4hi */

    case 224:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28436; /* *cond_extendrvvm4hirvvm8si */

    case 225:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28520; /* *cond_extendrvvm2qirvvm8si */

    case 226:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28438; /* *cond_extendrvvm2hirvvm4si */

    case 227:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28522; /* *cond_extendrvvm1qirvvm4si */

    case 228:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28440; /* *cond_extendrvvm1hirvvm2si */

    case 229:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28524; /* *cond_extendrvvmf2qirvvm2si */

    case 230:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28442; /* *cond_extendrvvmf2hirvvm1si */

    case 231:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28526; /* *cond_extendrvvmf4qirvvm1si */

    case 232:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28444; /* *cond_extendrvvmf4hirvvmf2si */

    case 233:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28528; /* *cond_extendrvvmf8qirvvmf2si */

    case 234:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28446; /* *cond_extendrvvm4sirvvm8di */

    case 235:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28530; /* *cond_extendrvvm2hirvvm8di */

    case 236:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28580; /* *cond_extendrvvm1qirvvm8di */

    case 237:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28448; /* *cond_extendrvvm2sirvvm4di */

    case 238:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28532; /* *cond_extendrvvm1hirvvm4di */

    case 239:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28582; /* *cond_extendrvvmf2qirvvm4di */

    case 240:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28450; /* *cond_extendrvvm1sirvvm2di */

    case 241:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28534; /* *cond_extendrvvmf2hirvvm2di */

    case 242:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28584; /* *cond_extendrvvmf4qirvvm2di */

    case 243:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28452; /* *cond_extendrvvmf2sirvvm1di */

    case 244:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28536; /* *cond_extendrvvmf4hirvvm1di */

    case 245:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28586; /* *cond_extendrvvmf8qirvvm1di */

    case 246:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28454; /* *cond_extendv1qiv1hi */

    case 247:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28456; /* *cond_extendv2qiv2hi */

    case 248:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28458; /* *cond_extendv4qiv4hi */

    case 249:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28460; /* *cond_extendv8qiv8hi */

    case 250:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28462; /* *cond_extendv16qiv16hi */

    case 251:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28464; /* *cond_extendv32qiv32hi */

    case 252:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28466; /* *cond_extendv64qiv64hi */

    case 253:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28468; /* *cond_extendv128qiv128hi */

    case 254:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28470; /* *cond_extendv256qiv256hi */

    case 255:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28472; /* *cond_extendv512qiv512hi */

    case 256:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28474; /* *cond_extendv1024qiv1024hi */

    case 257:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28476; /* *cond_extendv2048qiv2048hi */

    case 258:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28478; /* *cond_extendv1hiv1si */

    case 259:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28538; /* *cond_extendv1qiv1si */

    case 260:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28480; /* *cond_extendv2hiv2si */

    case 261:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28540; /* *cond_extendv2qiv2si */

    case 262:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28482; /* *cond_extendv4hiv4si */

    case 263:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28542; /* *cond_extendv4qiv4si */

    case 264:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28484; /* *cond_extendv8hiv8si */

    case 265:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28544; /* *cond_extendv8qiv8si */

    case 266:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28486; /* *cond_extendv16hiv16si */

    case 267:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28546; /* *cond_extendv16qiv16si */

    case 268:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28488; /* *cond_extendv32hiv32si */

    case 269:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28548; /* *cond_extendv32qiv32si */

    case 270:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28490; /* *cond_extendv64hiv64si */

    case 271:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28550; /* *cond_extendv64qiv64si */

    case 272:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28492; /* *cond_extendv128hiv128si */

    case 273:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28552; /* *cond_extendv128qiv128si */

    case 274:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28494; /* *cond_extendv256hiv256si */

    case 275:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28554; /* *cond_extendv256qiv256si */

    case 276:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28496; /* *cond_extendv512hiv512si */

    case 277:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28556; /* *cond_extendv512qiv512si */

    case 278:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28498; /* *cond_extendv1024hiv1024si */

    case 279:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28558; /* *cond_extendv1024qiv1024si */

    case 280:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28500; /* *cond_extendv1siv1di */

    case 281:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28560; /* *cond_extendv1hiv1di */

    case 282:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28588; /* *cond_extendv1qiv1di */

    case 283:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28502; /* *cond_extendv2siv2di */

    case 284:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28562; /* *cond_extendv2hiv2di */

    case 285:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28590; /* *cond_extendv2qiv2di */

    case 286:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28504; /* *cond_extendv4siv4di */

    case 287:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28564; /* *cond_extendv4hiv4di */

    case 288:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28592; /* *cond_extendv4qiv4di */

    case 289:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28506; /* *cond_extendv8siv8di */

    case 290:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28566; /* *cond_extendv8hiv8di */

    case 291:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28594; /* *cond_extendv8qiv8di */

    case 292:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28508; /* *cond_extendv16siv16di */

    case 293:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28568; /* *cond_extendv16hiv16di */

    case 294:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28596; /* *cond_extendv16qiv16di */

    case 295:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28510; /* *cond_extendv32siv32di */

    case 296:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28570; /* *cond_extendv32hiv32di */

    case 297:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28598; /* *cond_extendv32qiv32di */

    case 298:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28512; /* *cond_extendv64siv64di */

    case 299:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28572; /* *cond_extendv64hiv64di */

    case 300:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28600; /* *cond_extendv64qiv64di */

    case 301:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28514; /* *cond_extendv128siv128di */

    case 302:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28574; /* *cond_extendv128hiv128di */

    case 303:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28602; /* *cond_extendv128qiv128di */

    case 304:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28516; /* *cond_extendv256siv256di */

    case 305:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28576; /* *cond_extendv256hiv256di */

    case 306:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28604; /* *cond_extendv256qiv256di */

    case 307:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28518; /* *cond_extendv512siv512di */

    case 308:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28578; /* *cond_extendv512hiv512di */

    case 309:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28606; /* *cond_extendv512qiv512di */

    case 310:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28425; /* *cond_zero_extendrvvm4qirvvm8hi */

    case 311:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28427; /* *cond_zero_extendrvvm2qirvvm4hi */

    case 312:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28429; /* *cond_zero_extendrvvm1qirvvm2hi */

    case 313:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28431; /* *cond_zero_extendrvvmf2qirvvm1hi */

    case 314:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28433; /* *cond_zero_extendrvvmf4qirvvmf2hi */

    case 315:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28435; /* *cond_zero_extendrvvmf8qirvvmf4hi */

    case 316:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28437; /* *cond_zero_extendrvvm4hirvvm8si */

    case 317:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28521; /* *cond_zero_extendrvvm2qirvvm8si */

    case 318:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28439; /* *cond_zero_extendrvvm2hirvvm4si */

    case 319:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28523; /* *cond_zero_extendrvvm1qirvvm4si */

    case 320:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28441; /* *cond_zero_extendrvvm1hirvvm2si */

    case 321:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28525; /* *cond_zero_extendrvvmf2qirvvm2si */

    case 322:
      if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28443; /* *cond_zero_extendrvvmf2hirvvm1si */

    case 323:
      if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28527; /* *cond_zero_extendrvvmf4qirvvm1si */

    case 324:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28445; /* *cond_zero_extendrvvmf4hirvvmf2si */

    case 325:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28529; /* *cond_zero_extendrvvmf8qirvvmf2si */

    case 326:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28447; /* *cond_zero_extendrvvm4sirvvm8di */

    case 327:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28531; /* *cond_zero_extendrvvm2hirvvm8di */

    case 328:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28581; /* *cond_zero_extendrvvm1qirvvm8di */

    case 329:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28449; /* *cond_zero_extendrvvm2sirvvm4di */

    case 330:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28533; /* *cond_zero_extendrvvm1hirvvm4di */

    case 331:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28583; /* *cond_zero_extendrvvmf2qirvvm4di */

    case 332:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28451; /* *cond_zero_extendrvvm1sirvvm2di */

    case 333:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28535; /* *cond_zero_extendrvvmf2hirvvm2di */

    case 334:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28585; /* *cond_zero_extendrvvmf4qirvvm2di */

    case 335:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28453; /* *cond_zero_extendrvvmf2sirvvm1di */

    case 336:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28537; /* *cond_zero_extendrvvmf4hirvvm1di */

    case 337:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28587; /* *cond_zero_extendrvvmf8qirvvm1di */

    case 338:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28455; /* *cond_zero_extendv1qiv1hi */

    case 339:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28457; /* *cond_zero_extendv2qiv2hi */

    case 340:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28459; /* *cond_zero_extendv4qiv4hi */

    case 341:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28461; /* *cond_zero_extendv8qiv8hi */

    case 342:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28463; /* *cond_zero_extendv16qiv16hi */

    case 343:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28465; /* *cond_zero_extendv32qiv32hi */

    case 344:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28467; /* *cond_zero_extendv64qiv64hi */

    case 345:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28469; /* *cond_zero_extendv128qiv128hi */

    case 346:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28471; /* *cond_zero_extendv256qiv256hi */

    case 347:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28473; /* *cond_zero_extendv512qiv512hi */

    case 348:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28475; /* *cond_zero_extendv1024qiv1024hi */

    case 349:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28477; /* *cond_zero_extendv2048qiv2048hi */

    case 350:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28479; /* *cond_zero_extendv1hiv1si */

    case 351:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28539; /* *cond_zero_extendv1qiv1si */

    case 352:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28481; /* *cond_zero_extendv2hiv2si */

    case 353:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28541; /* *cond_zero_extendv2qiv2si */

    case 354:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28483; /* *cond_zero_extendv4hiv4si */

    case 355:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28543; /* *cond_zero_extendv4qiv4si */

    case 356:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28485; /* *cond_zero_extendv8hiv8si */

    case 357:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28545; /* *cond_zero_extendv8qiv8si */

    case 358:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28487; /* *cond_zero_extendv16hiv16si */

    case 359:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28547; /* *cond_zero_extendv16qiv16si */

    case 360:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28489; /* *cond_zero_extendv32hiv32si */

    case 361:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28549; /* *cond_zero_extendv32qiv32si */

    case 362:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28491; /* *cond_zero_extendv64hiv64si */

    case 363:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28551; /* *cond_zero_extendv64qiv64si */

    case 364:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28493; /* *cond_zero_extendv128hiv128si */

    case 365:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28553; /* *cond_zero_extendv128qiv128si */

    case 366:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28495; /* *cond_zero_extendv256hiv256si */

    case 367:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28555; /* *cond_zero_extendv256qiv256si */

    case 368:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28497; /* *cond_zero_extendv512hiv512si */

    case 369:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28557; /* *cond_zero_extendv512qiv512si */

    case 370:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28499; /* *cond_zero_extendv1024hiv1024si */

    case 371:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28559; /* *cond_zero_extendv1024qiv1024si */

    case 372:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28501; /* *cond_zero_extendv1siv1di */

    case 373:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28561; /* *cond_zero_extendv1hiv1di */

    case 374:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28589; /* *cond_zero_extendv1qiv1di */

    case 375:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28503; /* *cond_zero_extendv2siv2di */

    case 376:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28563; /* *cond_zero_extendv2hiv2di */

    case 377:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28591; /* *cond_zero_extendv2qiv2di */

    case 378:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28505; /* *cond_zero_extendv4siv4di */

    case 379:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28565; /* *cond_zero_extendv4hiv4di */

    case 380:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28593; /* *cond_zero_extendv4qiv4di */

    case 381:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28507; /* *cond_zero_extendv8siv8di */

    case 382:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28567; /* *cond_zero_extendv8hiv8di */

    case 383:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28595; /* *cond_zero_extendv8qiv8di */

    case 384:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28509; /* *cond_zero_extendv16siv16di */

    case 385:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28569; /* *cond_zero_extendv16hiv16di */

    case 386:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28597; /* *cond_zero_extendv16qiv16di */

    case 387:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28511; /* *cond_zero_extendv32siv32di */

    case 388:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28571; /* *cond_zero_extendv32hiv32di */

    case 389:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28599; /* *cond_zero_extendv32qiv32di */

    case 390:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28513; /* *cond_zero_extendv64siv64di */

    case 391:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28573; /* *cond_zero_extendv64hiv64di */

    case 392:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28601; /* *cond_zero_extendv64qiv64di */

    case 393:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28515; /* *cond_zero_extendv128siv128di */

    case 394:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28575; /* *cond_zero_extendv128hiv128di */

    case 395:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28603; /* *cond_zero_extendv128qiv128di */

    case 396:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28517; /* *cond_zero_extendv256siv256di */

    case 397:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28577; /* *cond_zero_extendv256hiv256di */

    case 398:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28605; /* *cond_zero_extendv256qiv256di */

    case 399:
      if (!(
#line 144 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28519; /* *cond_zero_extendv512siv512di */

    case 400:
      if (!(
#line 164 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28579; /* *cond_zero_extendv512hiv512di */

    case 401:
      if (!(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28607; /* *cond_zero_extendv512qiv512di */

    case 402:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28792; /* *cond_truncrvvm8hirvvm4qi */

    case 403:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28793; /* *cond_truncrvvm4hirvvm2qi */

    case 404:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28794; /* *cond_truncrvvm2hirvvm1qi */

    case 405:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28795; /* *cond_truncrvvm1hirvvmf2qi */

    case 406:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28796; /* *cond_truncrvvmf2hirvvmf4qi */

    case 407:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28797; /* *cond_truncrvvmf4hirvvmf8qi */

    case 408:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28798; /* *cond_truncrvvm8sirvvm4hi */

    case 409:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28799; /* *cond_truncrvvm4sirvvm2hi */

    case 410:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28800; /* *cond_truncrvvm2sirvvm1hi */

    case 411:
      if (!
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28801; /* *cond_truncrvvm1sirvvmf2hi */

    case 412:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28802; /* *cond_truncrvvmf2sirvvmf4hi */

    case 413:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28803; /* *cond_truncrvvm8dirvvm4si */

    case 414:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28804; /* *cond_truncrvvm4dirvvm2si */

    case 415:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28805; /* *cond_truncrvvm2dirvvm1si */

    case 416:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28806; /* *cond_truncrvvm1dirvvmf2si */

    case 417:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28807; /* *cond_truncv1hiv1qi */

    case 418:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28808; /* *cond_truncv2hiv2qi */

    case 419:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28809; /* *cond_truncv4hiv4qi */

    case 420:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28810; /* *cond_truncv8hiv8qi */

    case 421:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28811; /* *cond_truncv16hiv16qi */

    case 422:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28812; /* *cond_truncv32hiv32qi */

    case 423:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28813; /* *cond_truncv64hiv64qi */

    case 424:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28814; /* *cond_truncv128hiv128qi */

    case 425:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28815; /* *cond_truncv256hiv256qi */

    case 426:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28816; /* *cond_truncv512hiv512qi */

    case 427:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28817; /* *cond_truncv1024hiv1024qi */

    case 428:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28818; /* *cond_truncv2048hiv2048qi */

    case 429:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28819; /* *cond_truncv1siv1hi */

    case 430:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28820; /* *cond_truncv2siv2hi */

    case 431:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28821; /* *cond_truncv4siv4hi */

    case 432:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28822; /* *cond_truncv8siv8hi */

    case 433:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28823; /* *cond_truncv16siv16hi */

    case 434:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28824; /* *cond_truncv32siv32hi */

    case 435:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28825; /* *cond_truncv64siv64hi */

    case 436:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28826; /* *cond_truncv128siv128hi */

    case 437:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28827; /* *cond_truncv256siv256hi */

    case 438:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28828; /* *cond_truncv512siv512hi */

    case 439:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28829; /* *cond_truncv1024siv1024hi */

    case 440:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28830; /* *cond_truncv1div1si */

    case 441:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28831; /* *cond_truncv2div2si */

    case 442:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28832; /* *cond_truncv4div4si */

    case 443:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28833; /* *cond_truncv8div8si */

    case 444:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28834; /* *cond_truncv16div16si */

    case 445:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28835; /* *cond_truncv32div32si */

    case 446:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28836; /* *cond_truncv64div64si */

    case 447:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28837; /* *cond_truncv128div128si */

    case 448:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28838; /* *cond_truncv256div256si */

    case 449:
      if (!(
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28839; /* *cond_truncv512div512si */

    case 450:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29434; /* *cond_vashrextendtruncrvvm8hi */

    case 451:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29438; /* *cond_vashrextendtruncrvvm4hi */

    case 452:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29442; /* *cond_vashrextendtruncrvvm2hi */

    case 453:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29446; /* *cond_vashrextendtruncrvvm1hi */

    case 454:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29450; /* *cond_vashrextendtruncrvvmf2hi */

    case 455:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29454; /* *cond_vashrextendtruncrvvmf4hi */

    case 456:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29458; /* *cond_vashrextendtruncrvvm8si */

    case 457:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29462; /* *cond_vashrextendtruncrvvm4si */

    case 458:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29466; /* *cond_vashrextendtruncrvvm2si */

    case 459:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29470; /* *cond_vashrextendtruncrvvm1si */

    case 460:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29474; /* *cond_vashrextendtruncrvvmf2si */

    case 461:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29478; /* *cond_vashrextendtruncrvvm8di */

    case 462:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29482; /* *cond_vashrextendtruncrvvm4di */

    case 463:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29486; /* *cond_vashrextendtruncrvvm2di */

    case 464:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29490; /* *cond_vashrextendtruncrvvm1di */

    case 465:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29494; /* *cond_vashrextendtruncv1hi */

    case 466:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29498; /* *cond_vashrextendtruncv2hi */

    case 467:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29502; /* *cond_vashrextendtruncv4hi */

    case 468:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29506; /* *cond_vashrextendtruncv8hi */

    case 469:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29510; /* *cond_vashrextendtruncv16hi */

    case 470:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29514; /* *cond_vashrextendtruncv32hi */

    case 471:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29518; /* *cond_vashrextendtruncv64hi */

    case 472:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29522; /* *cond_vashrextendtruncv128hi */

    case 473:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29526; /* *cond_vashrextendtruncv256hi */

    case 474:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29530; /* *cond_vashrextendtruncv512hi */

    case 475:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29534; /* *cond_vashrextendtruncv1024hi */

    case 476:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29538; /* *cond_vashrextendtruncv2048hi */

    case 477:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29542; /* *cond_vashrextendtruncv1si */

    case 478:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29546; /* *cond_vashrextendtruncv2si */

    case 479:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29550; /* *cond_vashrextendtruncv4si */

    case 480:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29554; /* *cond_vashrextendtruncv8si */

    case 481:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29558; /* *cond_vashrextendtruncv16si */

    case 482:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29562; /* *cond_vashrextendtruncv32si */

    case 483:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29566; /* *cond_vashrextendtruncv64si */

    case 484:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29570; /* *cond_vashrextendtruncv128si */

    case 485:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29574; /* *cond_vashrextendtruncv256si */

    case 486:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29578; /* *cond_vashrextendtruncv512si */

    case 487:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29582; /* *cond_vashrextendtruncv1024si */

    case 488:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29586; /* *cond_vashrextendtruncv1di */

    case 489:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29590; /* *cond_vashrextendtruncv2di */

    case 490:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29594; /* *cond_vashrextendtruncv4di */

    case 491:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29598; /* *cond_vashrextendtruncv8di */

    case 492:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29602; /* *cond_vashrextendtruncv16di */

    case 493:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29606; /* *cond_vashrextendtruncv32di */

    case 494:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29610; /* *cond_vashrextendtruncv64di */

    case 495:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29614; /* *cond_vashrextendtruncv128di */

    case 496:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29618; /* *cond_vashrextendtruncv256di */

    case 497:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29622; /* *cond_vashrextendtruncv512di */

    case 498:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29436; /* *cond_vashrzero_extendtruncrvvm8hi */

    case 499:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29440; /* *cond_vashrzero_extendtruncrvvm4hi */

    case 500:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29444; /* *cond_vashrzero_extendtruncrvvm2hi */

    case 501:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29448; /* *cond_vashrzero_extendtruncrvvm1hi */

    case 502:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29452; /* *cond_vashrzero_extendtruncrvvmf2hi */

    case 503:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29456; /* *cond_vashrzero_extendtruncrvvmf4hi */

    case 504:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29460; /* *cond_vashrzero_extendtruncrvvm8si */

    case 505:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29464; /* *cond_vashrzero_extendtruncrvvm4si */

    case 506:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29468; /* *cond_vashrzero_extendtruncrvvm2si */

    case 507:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29472; /* *cond_vashrzero_extendtruncrvvm1si */

    case 508:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29476; /* *cond_vashrzero_extendtruncrvvmf2si */

    case 509:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29480; /* *cond_vashrzero_extendtruncrvvm8di */

    case 510:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29484; /* *cond_vashrzero_extendtruncrvvm4di */

    case 511:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29488; /* *cond_vashrzero_extendtruncrvvm2di */

    case 512:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29492; /* *cond_vashrzero_extendtruncrvvm1di */

    case 513:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29496; /* *cond_vashrzero_extendtruncv1hi */

    case 514:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29500; /* *cond_vashrzero_extendtruncv2hi */

    case 515:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29504; /* *cond_vashrzero_extendtruncv4hi */

    case 516:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29508; /* *cond_vashrzero_extendtruncv8hi */

    case 517:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29512; /* *cond_vashrzero_extendtruncv16hi */

    case 518:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29516; /* *cond_vashrzero_extendtruncv32hi */

    case 519:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29520; /* *cond_vashrzero_extendtruncv64hi */

    case 520:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29524; /* *cond_vashrzero_extendtruncv128hi */

    case 521:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29528; /* *cond_vashrzero_extendtruncv256hi */

    case 522:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29532; /* *cond_vashrzero_extendtruncv512hi */

    case 523:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29536; /* *cond_vashrzero_extendtruncv1024hi */

    case 524:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29540; /* *cond_vashrzero_extendtruncv2048hi */

    case 525:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29544; /* *cond_vashrzero_extendtruncv1si */

    case 526:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29548; /* *cond_vashrzero_extendtruncv2si */

    case 527:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29552; /* *cond_vashrzero_extendtruncv4si */

    case 528:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29556; /* *cond_vashrzero_extendtruncv8si */

    case 529:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29560; /* *cond_vashrzero_extendtruncv16si */

    case 530:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29564; /* *cond_vashrzero_extendtruncv32si */

    case 531:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29568; /* *cond_vashrzero_extendtruncv64si */

    case 532:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29572; /* *cond_vashrzero_extendtruncv128si */

    case 533:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29576; /* *cond_vashrzero_extendtruncv256si */

    case 534:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29580; /* *cond_vashrzero_extendtruncv512si */

    case 535:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29584; /* *cond_vashrzero_extendtruncv1024si */

    case 536:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29588; /* *cond_vashrzero_extendtruncv1di */

    case 537:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29592; /* *cond_vashrzero_extendtruncv2di */

    case 538:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29596; /* *cond_vashrzero_extendtruncv4di */

    case 539:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29600; /* *cond_vashrzero_extendtruncv8di */

    case 540:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29604; /* *cond_vashrzero_extendtruncv16di */

    case 541:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29608; /* *cond_vashrzero_extendtruncv32di */

    case 542:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29612; /* *cond_vashrzero_extendtruncv64di */

    case 543:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29616; /* *cond_vashrzero_extendtruncv128di */

    case 544:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29620; /* *cond_vashrzero_extendtruncv256di */

    case 545:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29624; /* *cond_vashrzero_extendtruncv512di */

    case 546:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29626; /* *cond_ashrtruncrvvm8hi */

    case 547:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29628; /* *cond_ashrtruncrvvm4hi */

    case 548:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29630; /* *cond_ashrtruncrvvm2hi */

    case 549:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29632; /* *cond_ashrtruncrvvm1hi */

    case 550:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29634; /* *cond_ashrtruncrvvmf2hi */

    case 551:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29636; /* *cond_ashrtruncrvvmf4hi */

    case 552:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29638; /* *cond_ashrtruncrvvm8si */

    case 553:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29640; /* *cond_ashrtruncrvvm4si */

    case 554:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29642; /* *cond_ashrtruncrvvm2si */

    case 555:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29644; /* *cond_ashrtruncrvvm1si */

    case 556:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29646; /* *cond_ashrtruncrvvmf2si */

    case 557:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29648; /* *cond_ashrtruncrvvm8di */

    case 558:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29650; /* *cond_ashrtruncrvvm4di */

    case 559:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29652; /* *cond_ashrtruncrvvm2di */

    case 560:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29654; /* *cond_ashrtruncrvvm1di */

    case 561:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29656; /* *cond_ashrtruncv1hi */

    case 562:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29658; /* *cond_ashrtruncv2hi */

    case 563:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29660; /* *cond_ashrtruncv4hi */

    case 564:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29662; /* *cond_ashrtruncv8hi */

    case 565:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29664; /* *cond_ashrtruncv16hi */

    case 566:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29666; /* *cond_ashrtruncv32hi */

    case 567:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29668; /* *cond_ashrtruncv64hi */

    case 568:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29670; /* *cond_ashrtruncv128hi */

    case 569:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29672; /* *cond_ashrtruncv256hi */

    case 570:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29674; /* *cond_ashrtruncv512hi */

    case 571:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29676; /* *cond_ashrtruncv1024hi */

    case 572:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29678; /* *cond_ashrtruncv2048hi */

    case 573:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29680; /* *cond_ashrtruncv1si */

    case 574:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29682; /* *cond_ashrtruncv2si */

    case 575:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29684; /* *cond_ashrtruncv4si */

    case 576:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29686; /* *cond_ashrtruncv8si */

    case 577:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29688; /* *cond_ashrtruncv16si */

    case 578:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29690; /* *cond_ashrtruncv32si */

    case 579:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29692; /* *cond_ashrtruncv64si */

    case 580:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29694; /* *cond_ashrtruncv128si */

    case 581:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29696; /* *cond_ashrtruncv256si */

    case 582:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29698; /* *cond_ashrtruncv512si */

    case 583:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29700; /* *cond_ashrtruncv1024si */

    case 584:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29702; /* *cond_ashrtruncv1di */

    case 585:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29704; /* *cond_ashrtruncv2di */

    case 586:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29706; /* *cond_ashrtruncv4di */

    case 587:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29708; /* *cond_ashrtruncv8di */

    case 588:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29710; /* *cond_ashrtruncv16di */

    case 589:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29712; /* *cond_ashrtruncv32di */

    case 590:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29714; /* *cond_ashrtruncv64di */

    case 591:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29716; /* *cond_ashrtruncv128di */

    case 592:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29718; /* *cond_ashrtruncv256di */

    case 593:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29720; /* *cond_ashrtruncv512di */

    case 594:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29435; /* *cond_vlshrextendtruncrvvm8hi */

    case 595:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29439; /* *cond_vlshrextendtruncrvvm4hi */

    case 596:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29443; /* *cond_vlshrextendtruncrvvm2hi */

    case 597:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29447; /* *cond_vlshrextendtruncrvvm1hi */

    case 598:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29451; /* *cond_vlshrextendtruncrvvmf2hi */

    case 599:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29455; /* *cond_vlshrextendtruncrvvmf4hi */

    case 600:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29459; /* *cond_vlshrextendtruncrvvm8si */

    case 601:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29463; /* *cond_vlshrextendtruncrvvm4si */

    case 602:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29467; /* *cond_vlshrextendtruncrvvm2si */

    case 603:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29471; /* *cond_vlshrextendtruncrvvm1si */

    case 604:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29475; /* *cond_vlshrextendtruncrvvmf2si */

    case 605:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29479; /* *cond_vlshrextendtruncrvvm8di */

    case 606:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29483; /* *cond_vlshrextendtruncrvvm4di */

    case 607:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29487; /* *cond_vlshrextendtruncrvvm2di */

    case 608:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29491; /* *cond_vlshrextendtruncrvvm1di */

    case 609:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29495; /* *cond_vlshrextendtruncv1hi */

    case 610:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29499; /* *cond_vlshrextendtruncv2hi */

    case 611:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29503; /* *cond_vlshrextendtruncv4hi */

    case 612:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29507; /* *cond_vlshrextendtruncv8hi */

    case 613:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29511; /* *cond_vlshrextendtruncv16hi */

    case 614:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29515; /* *cond_vlshrextendtruncv32hi */

    case 615:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29519; /* *cond_vlshrextendtruncv64hi */

    case 616:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29523; /* *cond_vlshrextendtruncv128hi */

    case 617:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29527; /* *cond_vlshrextendtruncv256hi */

    case 618:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29531; /* *cond_vlshrextendtruncv512hi */

    case 619:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29535; /* *cond_vlshrextendtruncv1024hi */

    case 620:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29539; /* *cond_vlshrextendtruncv2048hi */

    case 621:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29543; /* *cond_vlshrextendtruncv1si */

    case 622:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29547; /* *cond_vlshrextendtruncv2si */

    case 623:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29551; /* *cond_vlshrextendtruncv4si */

    case 624:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29555; /* *cond_vlshrextendtruncv8si */

    case 625:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29559; /* *cond_vlshrextendtruncv16si */

    case 626:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29563; /* *cond_vlshrextendtruncv32si */

    case 627:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29567; /* *cond_vlshrextendtruncv64si */

    case 628:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29571; /* *cond_vlshrextendtruncv128si */

    case 629:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29575; /* *cond_vlshrextendtruncv256si */

    case 630:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29579; /* *cond_vlshrextendtruncv512si */

    case 631:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29583; /* *cond_vlshrextendtruncv1024si */

    case 632:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29587; /* *cond_vlshrextendtruncv1di */

    case 633:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29591; /* *cond_vlshrextendtruncv2di */

    case 634:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29595; /* *cond_vlshrextendtruncv4di */

    case 635:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29599; /* *cond_vlshrextendtruncv8di */

    case 636:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29603; /* *cond_vlshrextendtruncv16di */

    case 637:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29607; /* *cond_vlshrextendtruncv32di */

    case 638:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29611; /* *cond_vlshrextendtruncv64di */

    case 639:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29615; /* *cond_vlshrextendtruncv128di */

    case 640:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29619; /* *cond_vlshrextendtruncv256di */

    case 641:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29623; /* *cond_vlshrextendtruncv512di */

    case 642:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29437; /* *cond_vlshrzero_extendtruncrvvm8hi */

    case 643:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29441; /* *cond_vlshrzero_extendtruncrvvm4hi */

    case 644:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29445; /* *cond_vlshrzero_extendtruncrvvm2hi */

    case 645:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29449; /* *cond_vlshrzero_extendtruncrvvm1hi */

    case 646:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29453; /* *cond_vlshrzero_extendtruncrvvmf2hi */

    case 647:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29457; /* *cond_vlshrzero_extendtruncrvvmf4hi */

    case 648:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29461; /* *cond_vlshrzero_extendtruncrvvm8si */

    case 649:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29465; /* *cond_vlshrzero_extendtruncrvvm4si */

    case 650:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29469; /* *cond_vlshrzero_extendtruncrvvm2si */

    case 651:
      if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29473; /* *cond_vlshrzero_extendtruncrvvm1si */

    case 652:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29477; /* *cond_vlshrzero_extendtruncrvvmf2si */

    case 653:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29481; /* *cond_vlshrzero_extendtruncrvvm8di */

    case 654:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29485; /* *cond_vlshrzero_extendtruncrvvm4di */

    case 655:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29489; /* *cond_vlshrzero_extendtruncrvvm2di */

    case 656:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29493; /* *cond_vlshrzero_extendtruncrvvm1di */

    case 657:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29497; /* *cond_vlshrzero_extendtruncv1hi */

    case 658:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29501; /* *cond_vlshrzero_extendtruncv2hi */

    case 659:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29505; /* *cond_vlshrzero_extendtruncv4hi */

    case 660:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29509; /* *cond_vlshrzero_extendtruncv8hi */

    case 661:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29513; /* *cond_vlshrzero_extendtruncv16hi */

    case 662:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29517; /* *cond_vlshrzero_extendtruncv32hi */

    case 663:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29521; /* *cond_vlshrzero_extendtruncv64hi */

    case 664:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29525; /* *cond_vlshrzero_extendtruncv128hi */

    case 665:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29529; /* *cond_vlshrzero_extendtruncv256hi */

    case 666:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29533; /* *cond_vlshrzero_extendtruncv512hi */

    case 667:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29537; /* *cond_vlshrzero_extendtruncv1024hi */

    case 668:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29541; /* *cond_vlshrzero_extendtruncv2048hi */

    case 669:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29545; /* *cond_vlshrzero_extendtruncv1si */

    case 670:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29549; /* *cond_vlshrzero_extendtruncv2si */

    case 671:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29553; /* *cond_vlshrzero_extendtruncv4si */

    case 672:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29557; /* *cond_vlshrzero_extendtruncv8si */

    case 673:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29561; /* *cond_vlshrzero_extendtruncv16si */

    case 674:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29565; /* *cond_vlshrzero_extendtruncv32si */

    case 675:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29569; /* *cond_vlshrzero_extendtruncv64si */

    case 676:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29573; /* *cond_vlshrzero_extendtruncv128si */

    case 677:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29577; /* *cond_vlshrzero_extendtruncv256si */

    case 678:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29581; /* *cond_vlshrzero_extendtruncv512si */

    case 679:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29585; /* *cond_vlshrzero_extendtruncv1024si */

    case 680:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29589; /* *cond_vlshrzero_extendtruncv1di */

    case 681:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29593; /* *cond_vlshrzero_extendtruncv2di */

    case 682:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29597; /* *cond_vlshrzero_extendtruncv4di */

    case 683:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29601; /* *cond_vlshrzero_extendtruncv8di */

    case 684:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29605; /* *cond_vlshrzero_extendtruncv16di */

    case 685:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29609; /* *cond_vlshrzero_extendtruncv32di */

    case 686:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29613; /* *cond_vlshrzero_extendtruncv64di */

    case 687:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29617; /* *cond_vlshrzero_extendtruncv128di */

    case 688:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29621; /* *cond_vlshrzero_extendtruncv256di */

    case 689:
      if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29625; /* *cond_vlshrzero_extendtruncv512di */

    case 690:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29627; /* *cond_lshrtruncrvvm8hi */

    case 691:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29629; /* *cond_lshrtruncrvvm4hi */

    case 692:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29631; /* *cond_lshrtruncrvvm2hi */

    case 693:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29633; /* *cond_lshrtruncrvvm1hi */

    case 694:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29635; /* *cond_lshrtruncrvvmf2hi */

    case 695:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29637; /* *cond_lshrtruncrvvmf4hi */

    case 696:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29639; /* *cond_lshrtruncrvvm8si */

    case 697:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29641; /* *cond_lshrtruncrvvm4si */

    case 698:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29643; /* *cond_lshrtruncrvvm2si */

    case 699:
      if (!
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29645; /* *cond_lshrtruncrvvm1si */

    case 700:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29647; /* *cond_lshrtruncrvvmf2si */

    case 701:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29649; /* *cond_lshrtruncrvvm8di */

    case 702:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29651; /* *cond_lshrtruncrvvm4di */

    case 703:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29653; /* *cond_lshrtruncrvvm2di */

    case 704:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29655; /* *cond_lshrtruncrvvm1di */

    case 705:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29657; /* *cond_lshrtruncv1hi */

    case 706:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29659; /* *cond_lshrtruncv2hi */

    case 707:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29661; /* *cond_lshrtruncv4hi */

    case 708:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29663; /* *cond_lshrtruncv8hi */

    case 709:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29665; /* *cond_lshrtruncv16hi */

    case 710:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29667; /* *cond_lshrtruncv32hi */

    case 711:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29669; /* *cond_lshrtruncv64hi */

    case 712:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29671; /* *cond_lshrtruncv128hi */

    case 713:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29673; /* *cond_lshrtruncv256hi */

    case 714:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29675; /* *cond_lshrtruncv512hi */

    case 715:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29677; /* *cond_lshrtruncv1024hi */

    case 716:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29679; /* *cond_lshrtruncv2048hi */

    case 717:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29681; /* *cond_lshrtruncv1si */

    case 718:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29683; /* *cond_lshrtruncv2si */

    case 719:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29685; /* *cond_lshrtruncv4si */

    case 720:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29687; /* *cond_lshrtruncv8si */

    case 721:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29689; /* *cond_lshrtruncv16si */

    case 722:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29691; /* *cond_lshrtruncv32si */

    case 723:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29693; /* *cond_lshrtruncv64si */

    case 724:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29695; /* *cond_lshrtruncv128si */

    case 725:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29697; /* *cond_lshrtruncv256si */

    case 726:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29699; /* *cond_lshrtruncv512si */

    case 727:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29701; /* *cond_lshrtruncv1024si */

    case 728:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29703; /* *cond_lshrtruncv1di */

    case 729:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29705; /* *cond_lshrtruncv2di */

    case 730:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29707; /* *cond_lshrtruncv4di */

    case 731:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29709; /* *cond_lshrtruncv8di */

    case 732:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29711; /* *cond_lshrtruncv16di */

    case 733:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29713; /* *cond_lshrtruncv32di */

    case 734:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29715; /* *cond_lshrtruncv64di */

    case 735:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29717; /* *cond_lshrtruncv128di */

    case 736:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29719; /* *cond_lshrtruncv256di */

    case 737:
      if (!(
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29721; /* *cond_lshrtruncv512di */

    case 738:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28840; /* *cond_extendrvvm4hfrvvm8sf */

    case 739:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28841; /* *cond_extendrvvm2hfrvvm4sf */

    case 740:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28842; /* *cond_extendrvvm1hfrvvm2sf */

    case 741:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28843; /* *cond_extendrvvmf2hfrvvm1sf */

    case 742:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28844; /* *cond_extendrvvmf4hfrvvmf2sf */

    case 743:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28845; /* *cond_extendrvvm4sfrvvm8df */

    case 744:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28846; /* *cond_extendrvvm2sfrvvm4df */

    case 745:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28847; /* *cond_extendrvvm1sfrvvm2df */

    case 746:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28848; /* *cond_extendrvvmf2sfrvvm1df */

    case 747:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28849; /* *cond_extendv1hfv1sf */

    case 748:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28850; /* *cond_extendv2hfv2sf */

    case 749:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28851; /* *cond_extendv4hfv4sf */

    case 750:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28852; /* *cond_extendv8hfv8sf */

    case 751:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28853; /* *cond_extendv16hfv16sf */

    case 752:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28854; /* *cond_extendv32hfv32sf */

    case 753:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28855; /* *cond_extendv64hfv64sf */

    case 754:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28856; /* *cond_extendv128hfv128sf */

    case 755:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28857; /* *cond_extendv256hfv256sf */

    case 756:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28858; /* *cond_extendv512hfv512sf */

    case 757:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28859; /* *cond_extendv1024hfv1024sf */

    case 758:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28860; /* *cond_extendv1sfv1df */

    case 759:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28861; /* *cond_extendv2sfv2df */

    case 760:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28862; /* *cond_extendv4sfv4df */

    case 761:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28863; /* *cond_extendv8sfv8df */

    case 762:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28864; /* *cond_extendv16sfv16df */

    case 763:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28865; /* *cond_extendv32sfv32df */

    case 764:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28866; /* *cond_extendv64sfv64df */

    case 765:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28867; /* *cond_extendv128sfv128df */

    case 766:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28868; /* *cond_extendv256sfv256df */

    case 767:
      if (!(
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28869; /* *cond_extendv512sfv512df */

    case 768:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28900; /* *cond_truncrvvm8sfrvvm4hf */

    case 769:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28901; /* *cond_truncrvvm4sfrvvm2hf */

    case 770:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28902; /* *cond_truncrvvm2sfrvvm1hf */

    case 771:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28903; /* *cond_truncrvvm1sfrvvmf2hf */

    case 772:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28904; /* *cond_truncrvvmf2sfrvvmf4hf */

    case 773:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28905; /* *cond_truncrvvm8dfrvvm4sf */

    case 774:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28906; /* *cond_truncrvvm4dfrvvm2sf */

    case 775:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28907; /* *cond_truncrvvm2dfrvvm1sf */

    case 776:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28908; /* *cond_truncrvvm1dfrvvmf2sf */

    case 777:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28909; /* *cond_truncv1sfv1hf */

    case 778:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28910; /* *cond_truncv2sfv2hf */

    case 779:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28911; /* *cond_truncv4sfv4hf */

    case 780:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28912; /* *cond_truncv8sfv8hf */

    case 781:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28913; /* *cond_truncv16sfv16hf */

    case 782:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28914; /* *cond_truncv32sfv32hf */

    case 783:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28915; /* *cond_truncv64sfv64hf */

    case 784:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28916; /* *cond_truncv128sfv128hf */

    case 785:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28917; /* *cond_truncv256sfv256hf */

    case 786:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28918; /* *cond_truncv512sfv512hf */

    case 787:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28919; /* *cond_truncv1024sfv1024hf */

    case 788:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28920; /* *cond_truncv1dfv1sf */

    case 789:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28921; /* *cond_truncv2dfv2sf */

    case 790:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28922; /* *cond_truncv4dfv4sf */

    case 791:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28923; /* *cond_truncv8dfv8sf */

    case 792:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28924; /* *cond_truncv16dfv16sf */

    case 793:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28925; /* *cond_truncv32dfv32sf */

    case 794:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28926; /* *cond_truncv64dfv64sf */

    case 795:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28927; /* *cond_truncv128dfv128sf */

    case 796:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28928; /* *cond_truncv256dfv256sf */

    case 797:
      if (!(
#line 350 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28929; /* *cond_truncv512dfv512sf */

    case 798:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28930; /* *cond_fix_truncrvvm8hfrvvm8hi */

    case 799:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28932; /* *cond_fix_truncrvvm4hfrvvm4hi */

    case 800:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29290; /* *cond_fix_truncrvvm8sfrvvm4hi */

    case 801:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28934; /* *cond_fix_truncrvvm2hfrvvm2hi */

    case 802:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29292; /* *cond_fix_truncrvvm4sfrvvm2hi */

    case 803:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28936; /* *cond_fix_truncrvvm1hfrvvm1hi */

    case 804:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29294; /* *cond_fix_truncrvvm2sfrvvm1hi */

    case 805:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28938; /* *cond_fix_truncrvvmf2hfrvvmf2hi */

    case 806:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29296; /* *cond_fix_truncrvvm1sfrvvmf2hi */

    case 807:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28940; /* *cond_fix_truncrvvmf4hfrvvmf4hi */

    case 808:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29298; /* *cond_fix_truncrvvmf2sfrvvmf4hi */

    case 809:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28942; /* *cond_fix_truncrvvm8sfrvvm8si */

    case 810:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29122; /* *cond_fix_truncrvvm4hfrvvm8si */

    case 811:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28944; /* *cond_fix_truncrvvm4sfrvvm4si */

    case 812:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29124; /* *cond_fix_truncrvvm2hfrvvm4si */

    case 813:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29300; /* *cond_fix_truncrvvm8dfrvvm4si */

    case 814:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28946; /* *cond_fix_truncrvvm2sfrvvm2si */

    case 815:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29126; /* *cond_fix_truncrvvm1hfrvvm2si */

    case 816:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29302; /* *cond_fix_truncrvvm4dfrvvm2si */

    case 817:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28948; /* *cond_fix_truncrvvm1sfrvvm1si */

    case 818:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29128; /* *cond_fix_truncrvvmf2hfrvvm1si */

    case 819:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29304; /* *cond_fix_truncrvvm2dfrvvm1si */

    case 820:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28950; /* *cond_fix_truncrvvmf2sfrvvmf2si */

    case 821:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29130; /* *cond_fix_truncrvvmf4hfrvvmf2si */

    case 822:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29306; /* *cond_fix_truncrvvm1dfrvvmf2si */

    case 823:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28952; /* *cond_fix_truncrvvm8dfrvvm8di */

    case 824:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29132; /* *cond_fix_truncrvvm4sfrvvm8di */

    case 825:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28954; /* *cond_fix_truncrvvm4dfrvvm4di */

    case 826:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29134; /* *cond_fix_truncrvvm2sfrvvm4di */

    case 827:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28956; /* *cond_fix_truncrvvm2dfrvvm2di */

    case 828:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29136; /* *cond_fix_truncrvvm1sfrvvm2di */

    case 829:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28958; /* *cond_fix_truncrvvm1dfrvvm1di */

    case 830:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29138; /* *cond_fix_truncrvvmf2sfrvvm1di */

    case 831:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28960; /* *cond_fix_truncv1hfv1hi */

    case 832:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29332; /* *cond_fix_truncv1sfv1hi */

    case 833:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28962; /* *cond_fix_truncv2hfv2hi */

    case 834:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29334; /* *cond_fix_truncv2sfv2hi */

    case 835:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28964; /* *cond_fix_truncv4hfv4hi */

    case 836:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29336; /* *cond_fix_truncv4sfv4hi */

    case 837:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28966; /* *cond_fix_truncv8hfv8hi */

    case 838:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29338; /* *cond_fix_truncv8sfv8hi */

    case 839:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28968; /* *cond_fix_truncv16hfv16hi */

    case 840:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29340; /* *cond_fix_truncv16sfv16hi */

    case 841:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28970; /* *cond_fix_truncv32hfv32hi */

    case 842:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29342; /* *cond_fix_truncv32sfv32hi */

    case 843:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28972; /* *cond_fix_truncv64hfv64hi */

    case 844:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29344; /* *cond_fix_truncv64sfv64hi */

    case 845:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28974; /* *cond_fix_truncv128hfv128hi */

    case 846:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29346; /* *cond_fix_truncv128sfv128hi */

    case 847:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28976; /* *cond_fix_truncv256hfv256hi */

    case 848:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29348; /* *cond_fix_truncv256sfv256hi */

    case 849:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28978; /* *cond_fix_truncv512hfv512hi */

    case 850:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29350; /* *cond_fix_truncv512sfv512hi */

    case 851:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28980; /* *cond_fix_truncv1024hfv1024hi */

    case 852:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29352; /* *cond_fix_truncv1024sfv1024hi */

    case 853:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28982; /* *cond_fix_truncv2048hfv2048hi */

    case 854:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28984; /* *cond_fix_truncv1sfv1si */

    case 855:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29140; /* *cond_fix_truncv1hfv1si */

    case 856:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29354; /* *cond_fix_truncv1dfv1si */

    case 857:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28986; /* *cond_fix_truncv2sfv2si */

    case 858:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29142; /* *cond_fix_truncv2hfv2si */

    case 859:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29356; /* *cond_fix_truncv2dfv2si */

    case 860:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28988; /* *cond_fix_truncv4sfv4si */

    case 861:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29144; /* *cond_fix_truncv4hfv4si */

    case 862:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29358; /* *cond_fix_truncv4dfv4si */

    case 863:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28990; /* *cond_fix_truncv8sfv8si */

    case 864:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29146; /* *cond_fix_truncv8hfv8si */

    case 865:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29360; /* *cond_fix_truncv8dfv8si */

    case 866:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28992; /* *cond_fix_truncv16sfv16si */

    case 867:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29148; /* *cond_fix_truncv16hfv16si */

    case 868:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29362; /* *cond_fix_truncv16dfv16si */

    case 869:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28994; /* *cond_fix_truncv32sfv32si */

    case 870:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29150; /* *cond_fix_truncv32hfv32si */

    case 871:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29364; /* *cond_fix_truncv32dfv32si */

    case 872:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28996; /* *cond_fix_truncv64sfv64si */

    case 873:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29152; /* *cond_fix_truncv64hfv64si */

    case 874:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29366; /* *cond_fix_truncv64dfv64si */

    case 875:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28998; /* *cond_fix_truncv128sfv128si */

    case 876:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29154; /* *cond_fix_truncv128hfv128si */

    case 877:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29368; /* *cond_fix_truncv128dfv128si */

    case 878:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29000; /* *cond_fix_truncv256sfv256si */

    case 879:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29156; /* *cond_fix_truncv256hfv256si */

    case 880:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29370; /* *cond_fix_truncv256dfv256si */

    case 881:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29002; /* *cond_fix_truncv512sfv512si */

    case 882:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29158; /* *cond_fix_truncv512hfv512si */

    case 883:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29372; /* *cond_fix_truncv512dfv512si */

    case 884:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29004; /* *cond_fix_truncv1024sfv1024si */

    case 885:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29160; /* *cond_fix_truncv1024hfv1024si */

    case 886:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29006; /* *cond_fix_truncv1dfv1di */

    case 887:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29162; /* *cond_fix_truncv1sfv1di */

    case 888:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29008; /* *cond_fix_truncv2dfv2di */

    case 889:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29164; /* *cond_fix_truncv2sfv2di */

    case 890:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29010; /* *cond_fix_truncv4dfv4di */

    case 891:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29166; /* *cond_fix_truncv4sfv4di */

    case 892:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29012; /* *cond_fix_truncv8dfv8di */

    case 893:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29168; /* *cond_fix_truncv8sfv8di */

    case 894:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29014; /* *cond_fix_truncv16dfv16di */

    case 895:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29170; /* *cond_fix_truncv16sfv16di */

    case 896:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29016; /* *cond_fix_truncv32dfv32di */

    case 897:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29172; /* *cond_fix_truncv32sfv32di */

    case 898:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29018; /* *cond_fix_truncv64dfv64di */

    case 899:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29174; /* *cond_fix_truncv64sfv64di */

    case 900:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29020; /* *cond_fix_truncv128dfv128di */

    case 901:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29176; /* *cond_fix_truncv128sfv128di */

    case 902:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29022; /* *cond_fix_truncv256dfv256di */

    case 903:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29178; /* *cond_fix_truncv256sfv256di */

    case 904:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29024; /* *cond_fix_truncv512dfv512di */

    case 905:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29180; /* *cond_fix_truncv512sfv512di */

    case 906:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29278; /* *cond_fix_truncrvvm8hfrvvm4qi */

    case 907:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29280; /* *cond_fix_truncrvvm4hfrvvm2qi */

    case 908:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29282; /* *cond_fix_truncrvvm2hfrvvm1qi */

    case 909:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29284; /* *cond_fix_truncrvvm1hfrvvmf2qi */

    case 910:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29286; /* *cond_fix_truncrvvmf2hfrvvmf4qi */

    case 911:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29288; /* *cond_fix_truncrvvmf4hfrvvmf8qi */

    case 912:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29308; /* *cond_fix_truncv1hfv1qi */

    case 913:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29310; /* *cond_fix_truncv2hfv2qi */

    case 914:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29312; /* *cond_fix_truncv4hfv4qi */

    case 915:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29314; /* *cond_fix_truncv8hfv8qi */

    case 916:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29316; /* *cond_fix_truncv16hfv16qi */

    case 917:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29318; /* *cond_fix_truncv32hfv32qi */

    case 918:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29320; /* *cond_fix_truncv64hfv64qi */

    case 919:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29322; /* *cond_fix_truncv128hfv128qi */

    case 920:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29324; /* *cond_fix_truncv256hfv256qi */

    case 921:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29326; /* *cond_fix_truncv512hfv512qi */

    case 922:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29328; /* *cond_fix_truncv1024hfv1024qi */

    case 923:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29330; /* *cond_fix_truncv2048hfv2048qi */

    case 924:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28931; /* *cond_fixuns_truncrvvm8hfrvvm8hi */

    case 925:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28933; /* *cond_fixuns_truncrvvm4hfrvvm4hi */

    case 926:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29291; /* *cond_fixuns_truncrvvm8sfrvvm4hi */

    case 927:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28935; /* *cond_fixuns_truncrvvm2hfrvvm2hi */

    case 928:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29293; /* *cond_fixuns_truncrvvm4sfrvvm2hi */

    case 929:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28937; /* *cond_fixuns_truncrvvm1hfrvvm1hi */

    case 930:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29295; /* *cond_fixuns_truncrvvm2sfrvvm1hi */

    case 931:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28939; /* *cond_fixuns_truncrvvmf2hfrvvmf2hi */

    case 932:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29297; /* *cond_fixuns_truncrvvm1sfrvvmf2hi */

    case 933:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28941; /* *cond_fixuns_truncrvvmf4hfrvvmf4hi */

    case 934:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29299; /* *cond_fixuns_truncrvvmf2sfrvvmf4hi */

    case 935:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28943; /* *cond_fixuns_truncrvvm8sfrvvm8si */

    case 936:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29123; /* *cond_fixuns_truncrvvm4hfrvvm8si */

    case 937:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28945; /* *cond_fixuns_truncrvvm4sfrvvm4si */

    case 938:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29125; /* *cond_fixuns_truncrvvm2hfrvvm4si */

    case 939:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29301; /* *cond_fixuns_truncrvvm8dfrvvm4si */

    case 940:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28947; /* *cond_fixuns_truncrvvm2sfrvvm2si */

    case 941:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29127; /* *cond_fixuns_truncrvvm1hfrvvm2si */

    case 942:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29303; /* *cond_fixuns_truncrvvm4dfrvvm2si */

    case 943:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28949; /* *cond_fixuns_truncrvvm1sfrvvm1si */

    case 944:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29129; /* *cond_fixuns_truncrvvmf2hfrvvm1si */

    case 945:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29305; /* *cond_fixuns_truncrvvm2dfrvvm1si */

    case 946:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28951; /* *cond_fixuns_truncrvvmf2sfrvvmf2si */

    case 947:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29131; /* *cond_fixuns_truncrvvmf4hfrvvmf2si */

    case 948:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29307; /* *cond_fixuns_truncrvvm1dfrvvmf2si */

    case 949:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28953; /* *cond_fixuns_truncrvvm8dfrvvm8di */

    case 950:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29133; /* *cond_fixuns_truncrvvm4sfrvvm8di */

    case 951:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28955; /* *cond_fixuns_truncrvvm4dfrvvm4di */

    case 952:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29135; /* *cond_fixuns_truncrvvm2sfrvvm4di */

    case 953:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28957; /* *cond_fixuns_truncrvvm2dfrvvm2di */

    case 954:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29137; /* *cond_fixuns_truncrvvm1sfrvvm2di */

    case 955:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28959; /* *cond_fixuns_truncrvvm1dfrvvm1di */

    case 956:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29139; /* *cond_fixuns_truncrvvmf2sfrvvm1di */

    case 957:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28961; /* *cond_fixuns_truncv1hfv1hi */

    case 958:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29333; /* *cond_fixuns_truncv1sfv1hi */

    case 959:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28963; /* *cond_fixuns_truncv2hfv2hi */

    case 960:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29335; /* *cond_fixuns_truncv2sfv2hi */

    case 961:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28965; /* *cond_fixuns_truncv4hfv4hi */

    case 962:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29337; /* *cond_fixuns_truncv4sfv4hi */

    case 963:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28967; /* *cond_fixuns_truncv8hfv8hi */

    case 964:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29339; /* *cond_fixuns_truncv8sfv8hi */

    case 965:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28969; /* *cond_fixuns_truncv16hfv16hi */

    case 966:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29341; /* *cond_fixuns_truncv16sfv16hi */

    case 967:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28971; /* *cond_fixuns_truncv32hfv32hi */

    case 968:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29343; /* *cond_fixuns_truncv32sfv32hi */

    case 969:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28973; /* *cond_fixuns_truncv64hfv64hi */

    case 970:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29345; /* *cond_fixuns_truncv64sfv64hi */

    case 971:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28975; /* *cond_fixuns_truncv128hfv128hi */

    case 972:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29347; /* *cond_fixuns_truncv128sfv128hi */

    case 973:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28977; /* *cond_fixuns_truncv256hfv256hi */

    case 974:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29349; /* *cond_fixuns_truncv256sfv256hi */

    case 975:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28979; /* *cond_fixuns_truncv512hfv512hi */

    case 976:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29351; /* *cond_fixuns_truncv512sfv512hi */

    case 977:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28981; /* *cond_fixuns_truncv1024hfv1024hi */

    case 978:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29353; /* *cond_fixuns_truncv1024sfv1024hi */

    case 979:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28983; /* *cond_fixuns_truncv2048hfv2048hi */

    case 980:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28985; /* *cond_fixuns_truncv1sfv1si */

    case 981:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29141; /* *cond_fixuns_truncv1hfv1si */

    case 982:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29355; /* *cond_fixuns_truncv1dfv1si */

    case 983:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28987; /* *cond_fixuns_truncv2sfv2si */

    case 984:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29143; /* *cond_fixuns_truncv2hfv2si */

    case 985:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29357; /* *cond_fixuns_truncv2dfv2si */

    case 986:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28989; /* *cond_fixuns_truncv4sfv4si */

    case 987:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29145; /* *cond_fixuns_truncv4hfv4si */

    case 988:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29359; /* *cond_fixuns_truncv4dfv4si */

    case 989:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28991; /* *cond_fixuns_truncv8sfv8si */

    case 990:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29147; /* *cond_fixuns_truncv8hfv8si */

    case 991:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29361; /* *cond_fixuns_truncv8dfv8si */

    case 992:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28993; /* *cond_fixuns_truncv16sfv16si */

    case 993:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29149; /* *cond_fixuns_truncv16hfv16si */

    case 994:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29363; /* *cond_fixuns_truncv16dfv16si */

    case 995:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28995; /* *cond_fixuns_truncv32sfv32si */

    case 996:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29151; /* *cond_fixuns_truncv32hfv32si */

    case 997:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29365; /* *cond_fixuns_truncv32dfv32si */

    case 998:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28997; /* *cond_fixuns_truncv64sfv64si */

    case 999:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29153; /* *cond_fixuns_truncv64hfv64si */

    case 1000:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29367; /* *cond_fixuns_truncv64dfv64si */

    case 1001:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28999; /* *cond_fixuns_truncv128sfv128si */

    case 1002:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29155; /* *cond_fixuns_truncv128hfv128si */

    case 1003:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29369; /* *cond_fixuns_truncv128dfv128si */

    case 1004:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29001; /* *cond_fixuns_truncv256sfv256si */

    case 1005:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29157; /* *cond_fixuns_truncv256hfv256si */

    case 1006:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29371; /* *cond_fixuns_truncv256dfv256si */

    case 1007:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29003; /* *cond_fixuns_truncv512sfv512si */

    case 1008:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29159; /* *cond_fixuns_truncv512hfv512si */

    case 1009:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29373; /* *cond_fixuns_truncv512dfv512si */

    case 1010:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29005; /* *cond_fixuns_truncv1024sfv1024si */

    case 1011:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29161; /* *cond_fixuns_truncv1024hfv1024si */

    case 1012:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29007; /* *cond_fixuns_truncv1dfv1di */

    case 1013:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29163; /* *cond_fixuns_truncv1sfv1di */

    case 1014:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29009; /* *cond_fixuns_truncv2dfv2di */

    case 1015:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29165; /* *cond_fixuns_truncv2sfv2di */

    case 1016:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29011; /* *cond_fixuns_truncv4dfv4di */

    case 1017:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29167; /* *cond_fixuns_truncv4sfv4di */

    case 1018:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29013; /* *cond_fixuns_truncv8dfv8di */

    case 1019:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29169; /* *cond_fixuns_truncv8sfv8di */

    case 1020:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29015; /* *cond_fixuns_truncv16dfv16di */

    case 1021:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29171; /* *cond_fixuns_truncv16sfv16di */

    case 1022:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29017; /* *cond_fixuns_truncv32dfv32di */

    case 1023:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29173; /* *cond_fixuns_truncv32sfv32di */

    case 1024:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29019; /* *cond_fixuns_truncv64dfv64di */

    case 1025:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29175; /* *cond_fixuns_truncv64sfv64di */

    case 1026:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29021; /* *cond_fixuns_truncv128dfv128di */

    case 1027:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29177; /* *cond_fixuns_truncv128sfv128di */

    case 1028:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29023; /* *cond_fixuns_truncv256dfv256di */

    case 1029:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29179; /* *cond_fixuns_truncv256sfv256di */

    case 1030:
      if (!(
#line 371 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29025; /* *cond_fixuns_truncv512dfv512di */

    case 1031:
      if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29181; /* *cond_fixuns_truncv512sfv512di */

    case 1032:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29279; /* *cond_fixuns_truncrvvm8hfrvvm4qi */

    case 1033:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29281; /* *cond_fixuns_truncrvvm4hfrvvm2qi */

    case 1034:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29283; /* *cond_fixuns_truncrvvm2hfrvvm1qi */

    case 1035:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29285; /* *cond_fixuns_truncrvvm1hfrvvmf2qi */

    case 1036:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29287; /* *cond_fixuns_truncrvvmf2hfrvvmf4qi */

    case 1037:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29289; /* *cond_fixuns_truncrvvmf4hfrvvmf8qi */

    case 1038:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29309; /* *cond_fixuns_truncv1hfv1qi */

    case 1039:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29311; /* *cond_fixuns_truncv2hfv2qi */

    case 1040:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29313; /* *cond_fixuns_truncv4hfv4qi */

    case 1041:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29315; /* *cond_fixuns_truncv8hfv8qi */

    case 1042:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29317; /* *cond_fixuns_truncv16hfv16qi */

    case 1043:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29319; /* *cond_fixuns_truncv32hfv32qi */

    case 1044:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29321; /* *cond_fixuns_truncv64hfv64qi */

    case 1045:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29323; /* *cond_fixuns_truncv128hfv128qi */

    case 1046:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29325; /* *cond_fixuns_truncv256hfv256qi */

    case 1047:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29327; /* *cond_fixuns_truncv512hfv512qi */

    case 1048:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29329; /* *cond_fixuns_truncv1024hfv1024qi */

    case 1049:
      if (!(
#line 455 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29331; /* *cond_fixuns_truncv2048hfv2048qi */

    case 1050:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29026; /* *cond_floatrvvm8hirvvm8hf */

    case 1051:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29182; /* *cond_floatrvvm4qirvvm8hf */

    case 1052:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29028; /* *cond_floatrvvm4hirvvm4hf */

    case 1053:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29184; /* *cond_floatrvvm2qirvvm4hf */

    case 1054:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29374; /* *cond_floatrvvm8sirvvm4hf2 */

    case 1055:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29030; /* *cond_floatrvvm2hirvvm2hf */

    case 1056:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29186; /* *cond_floatrvvm1qirvvm2hf */

    case 1057:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29376; /* *cond_floatrvvm4sirvvm2hf2 */

    case 1058:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29032; /* *cond_floatrvvm1hirvvm1hf */

    case 1059:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29188; /* *cond_floatrvvmf2qirvvm1hf */

    case 1060:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29378; /* *cond_floatrvvm2sirvvm1hf2 */

    case 1061:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29034; /* *cond_floatrvvmf2hirvvmf2hf */

    case 1062:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29190; /* *cond_floatrvvmf4qirvvmf2hf */

    case 1063:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29380; /* *cond_floatrvvm1sirvvmf2hf2 */

    case 1064:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29036; /* *cond_floatrvvmf4hirvvmf4hf */

    case 1065:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29192; /* *cond_floatrvvmf8qirvvmf4hf */

    case 1066:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29382; /* *cond_floatrvvmf2sirvvmf4hf2 */

    case 1067:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29038; /* *cond_floatrvvm8sirvvm8sf */

    case 1068:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29194; /* *cond_floatrvvm4hirvvm8sf */

    case 1069:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29040; /* *cond_floatrvvm4sirvvm4sf */

    case 1070:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29196; /* *cond_floatrvvm2hirvvm4sf */

    case 1071:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29384; /* *cond_floatrvvm8dirvvm4sf2 */

    case 1072:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29042; /* *cond_floatrvvm2sirvvm2sf */

    case 1073:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29198; /* *cond_floatrvvm1hirvvm2sf */

    case 1074:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29386; /* *cond_floatrvvm4dirvvm2sf2 */

    case 1075:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29044; /* *cond_floatrvvm1sirvvm1sf */

    case 1076:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29200; /* *cond_floatrvvmf2hirvvm1sf */

    case 1077:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29388; /* *cond_floatrvvm2dirvvm1sf2 */

    case 1078:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29046; /* *cond_floatrvvmf2sirvvmf2sf */

    case 1079:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29202; /* *cond_floatrvvmf4hirvvmf2sf */

    case 1080:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29390; /* *cond_floatrvvm1dirvvmf2sf2 */

    case 1081:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29048; /* *cond_floatrvvm8dirvvm8df */

    case 1082:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29204; /* *cond_floatrvvm4sirvvm8df */

    case 1083:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29050; /* *cond_floatrvvm4dirvvm4df */

    case 1084:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29206; /* *cond_floatrvvm2sirvvm4df */

    case 1085:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29052; /* *cond_floatrvvm2dirvvm2df */

    case 1086:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29208; /* *cond_floatrvvm1sirvvm2df */

    case 1087:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29054; /* *cond_floatrvvm1dirvvm1df */

    case 1088:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29210; /* *cond_floatrvvmf2sirvvm1df */

    case 1089:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29056; /* *cond_floatv1hiv1hf */

    case 1090:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29212; /* *cond_floatv1qiv1hf */

    case 1091:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29392; /* *cond_floatv1siv1hf2 */

    case 1092:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29058; /* *cond_floatv2hiv2hf */

    case 1093:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29214; /* *cond_floatv2qiv2hf */

    case 1094:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29394; /* *cond_floatv2siv2hf2 */

    case 1095:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29060; /* *cond_floatv4hiv4hf */

    case 1096:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29216; /* *cond_floatv4qiv4hf */

    case 1097:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29396; /* *cond_floatv4siv4hf2 */

    case 1098:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29062; /* *cond_floatv8hiv8hf */

    case 1099:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29218; /* *cond_floatv8qiv8hf */

    case 1100:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29398; /* *cond_floatv8siv8hf2 */

    case 1101:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29064; /* *cond_floatv16hiv16hf */

    case 1102:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29220; /* *cond_floatv16qiv16hf */

    case 1103:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29400; /* *cond_floatv16siv16hf2 */

    case 1104:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29066; /* *cond_floatv32hiv32hf */

    case 1105:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29222; /* *cond_floatv32qiv32hf */

    case 1106:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29402; /* *cond_floatv32siv32hf2 */

    case 1107:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29068; /* *cond_floatv64hiv64hf */

    case 1108:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29224; /* *cond_floatv64qiv64hf */

    case 1109:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29404; /* *cond_floatv64siv64hf2 */

    case 1110:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29070; /* *cond_floatv128hiv128hf */

    case 1111:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29226; /* *cond_floatv128qiv128hf */

    case 1112:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29406; /* *cond_floatv128siv128hf2 */

    case 1113:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29072; /* *cond_floatv256hiv256hf */

    case 1114:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29228; /* *cond_floatv256qiv256hf */

    case 1115:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29408; /* *cond_floatv256siv256hf2 */

    case 1116:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29074; /* *cond_floatv512hiv512hf */

    case 1117:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29230; /* *cond_floatv512qiv512hf */

    case 1118:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29410; /* *cond_floatv512siv512hf2 */

    case 1119:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29076; /* *cond_floatv1024hiv1024hf */

    case 1120:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29232; /* *cond_floatv1024qiv1024hf */

    case 1121:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29412; /* *cond_floatv1024siv1024hf2 */

    case 1122:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29078; /* *cond_floatv2048hiv2048hf */

    case 1123:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29234; /* *cond_floatv2048qiv2048hf */

    case 1124:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29080; /* *cond_floatv1siv1sf */

    case 1125:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29236; /* *cond_floatv1hiv1sf */

    case 1126:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29414; /* *cond_floatv1div1sf2 */

    case 1127:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29082; /* *cond_floatv2siv2sf */

    case 1128:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29238; /* *cond_floatv2hiv2sf */

    case 1129:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29416; /* *cond_floatv2div2sf2 */

    case 1130:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29084; /* *cond_floatv4siv4sf */

    case 1131:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29240; /* *cond_floatv4hiv4sf */

    case 1132:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29418; /* *cond_floatv4div4sf2 */

    case 1133:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29086; /* *cond_floatv8siv8sf */

    case 1134:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29242; /* *cond_floatv8hiv8sf */

    case 1135:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29420; /* *cond_floatv8div8sf2 */

    case 1136:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29088; /* *cond_floatv16siv16sf */

    case 1137:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29244; /* *cond_floatv16hiv16sf */

    case 1138:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29422; /* *cond_floatv16div16sf2 */

    case 1139:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29090; /* *cond_floatv32siv32sf */

    case 1140:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29246; /* *cond_floatv32hiv32sf */

    case 1141:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29424; /* *cond_floatv32div32sf2 */

    case 1142:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29092; /* *cond_floatv64siv64sf */

    case 1143:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29248; /* *cond_floatv64hiv64sf */

    case 1144:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29426; /* *cond_floatv64div64sf2 */

    case 1145:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29094; /* *cond_floatv128siv128sf */

    case 1146:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29250; /* *cond_floatv128hiv128sf */

    case 1147:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29428; /* *cond_floatv128div128sf2 */

    case 1148:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29096; /* *cond_floatv256siv256sf */

    case 1149:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29252; /* *cond_floatv256hiv256sf */

    case 1150:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29430; /* *cond_floatv256div256sf2 */

    case 1151:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29098; /* *cond_floatv512siv512sf */

    case 1152:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29254; /* *cond_floatv512hiv512sf */

    case 1153:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29432; /* *cond_floatv512div512sf2 */

    case 1154:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29100; /* *cond_floatv1024siv1024sf */

    case 1155:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29256; /* *cond_floatv1024hiv1024sf */

    case 1156:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29102; /* *cond_floatv1div1df */

    case 1157:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29258; /* *cond_floatv1siv1df */

    case 1158:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29104; /* *cond_floatv2div2df */

    case 1159:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29260; /* *cond_floatv2siv2df */

    case 1160:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29106; /* *cond_floatv4div4df */

    case 1161:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29262; /* *cond_floatv4siv4df */

    case 1162:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29108; /* *cond_floatv8div8df */

    case 1163:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29264; /* *cond_floatv8siv8df */

    case 1164:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29110; /* *cond_floatv16div16df */

    case 1165:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29266; /* *cond_floatv16siv16df */

    case 1166:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29112; /* *cond_floatv32div32df */

    case 1167:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29268; /* *cond_floatv32siv32df */

    case 1168:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29114; /* *cond_floatv64div64df */

    case 1169:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29270; /* *cond_floatv64siv64df */

    case 1170:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29116; /* *cond_floatv128div128df */

    case 1171:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29272; /* *cond_floatv128siv128df */

    case 1172:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29118; /* *cond_floatv256div256df */

    case 1173:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29274; /* *cond_floatv256siv256df */

    case 1174:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29120; /* *cond_floatv512div512df */

    case 1175:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29276; /* *cond_floatv512siv512df */

    case 1176:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29027; /* *cond_floatunsrvvm8hirvvm8hf */

    case 1177:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29183; /* *cond_floatunsrvvm4qirvvm8hf */

    case 1178:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29029; /* *cond_floatunsrvvm4hirvvm4hf */

    case 1179:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29185; /* *cond_floatunsrvvm2qirvvm4hf */

    case 1180:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29375; /* *cond_floatunsrvvm8sirvvm4hf2 */

    case 1181:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29031; /* *cond_floatunsrvvm2hirvvm2hf */

    case 1182:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29187; /* *cond_floatunsrvvm1qirvvm2hf */

    case 1183:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29377; /* *cond_floatunsrvvm4sirvvm2hf2 */

    case 1184:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29033; /* *cond_floatunsrvvm1hirvvm1hf */

    case 1185:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29189; /* *cond_floatunsrvvmf2qirvvm1hf */

    case 1186:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29379; /* *cond_floatunsrvvm2sirvvm1hf2 */

    case 1187:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29035; /* *cond_floatunsrvvmf2hirvvmf2hf */

    case 1188:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29191; /* *cond_floatunsrvvmf4qirvvmf2hf */

    case 1189:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29381; /* *cond_floatunsrvvm1sirvvmf2hf2 */

    case 1190:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29037; /* *cond_floatunsrvvmf4hirvvmf4hf */

    case 1191:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29193; /* *cond_floatunsrvvmf8qirvvmf4hf */

    case 1192:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29383; /* *cond_floatunsrvvmf2sirvvmf4hf2 */

    case 1193:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29039; /* *cond_floatunsrvvm8sirvvm8sf */

    case 1194:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29195; /* *cond_floatunsrvvm4hirvvm8sf */

    case 1195:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29041; /* *cond_floatunsrvvm4sirvvm4sf */

    case 1196:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29197; /* *cond_floatunsrvvm2hirvvm4sf */

    case 1197:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29385; /* *cond_floatunsrvvm8dirvvm4sf2 */

    case 1198:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29043; /* *cond_floatunsrvvm2sirvvm2sf */

    case 1199:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29199; /* *cond_floatunsrvvm1hirvvm2sf */

    case 1200:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29387; /* *cond_floatunsrvvm4dirvvm2sf2 */

    case 1201:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29045; /* *cond_floatunsrvvm1sirvvm1sf */

    case 1202:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29201; /* *cond_floatunsrvvmf2hirvvm1sf */

    case 1203:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29389; /* *cond_floatunsrvvm2dirvvm1sf2 */

    case 1204:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29047; /* *cond_floatunsrvvmf2sirvvmf2sf */

    case 1205:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29203; /* *cond_floatunsrvvmf4hirvvmf2sf */

    case 1206:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29391; /* *cond_floatunsrvvm1dirvvmf2sf2 */

    case 1207:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29049; /* *cond_floatunsrvvm8dirvvm8df */

    case 1208:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29205; /* *cond_floatunsrvvm4sirvvm8df */

    case 1209:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29051; /* *cond_floatunsrvvm4dirvvm4df */

    case 1210:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29207; /* *cond_floatunsrvvm2sirvvm4df */

    case 1211:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29053; /* *cond_floatunsrvvm2dirvvm2df */

    case 1212:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29209; /* *cond_floatunsrvvm1sirvvm2df */

    case 1213:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29055; /* *cond_floatunsrvvm1dirvvm1df */

    case 1214:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29211; /* *cond_floatunsrvvmf2sirvvm1df */

    case 1215:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29057; /* *cond_floatunsv1hiv1hf */

    case 1216:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29213; /* *cond_floatunsv1qiv1hf */

    case 1217:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29393; /* *cond_floatunsv1siv1hf2 */

    case 1218:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29059; /* *cond_floatunsv2hiv2hf */

    case 1219:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29215; /* *cond_floatunsv2qiv2hf */

    case 1220:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29395; /* *cond_floatunsv2siv2hf2 */

    case 1221:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29061; /* *cond_floatunsv4hiv4hf */

    case 1222:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29217; /* *cond_floatunsv4qiv4hf */

    case 1223:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29397; /* *cond_floatunsv4siv4hf2 */

    case 1224:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29063; /* *cond_floatunsv8hiv8hf */

    case 1225:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29219; /* *cond_floatunsv8qiv8hf */

    case 1226:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29399; /* *cond_floatunsv8siv8hf2 */

    case 1227:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29065; /* *cond_floatunsv16hiv16hf */

    case 1228:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29221; /* *cond_floatunsv16qiv16hf */

    case 1229:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29401; /* *cond_floatunsv16siv16hf2 */

    case 1230:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29067; /* *cond_floatunsv32hiv32hf */

    case 1231:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29223; /* *cond_floatunsv32qiv32hf */

    case 1232:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29403; /* *cond_floatunsv32siv32hf2 */

    case 1233:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29069; /* *cond_floatunsv64hiv64hf */

    case 1234:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29225; /* *cond_floatunsv64qiv64hf */

    case 1235:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29405; /* *cond_floatunsv64siv64hf2 */

    case 1236:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29071; /* *cond_floatunsv128hiv128hf */

    case 1237:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29227; /* *cond_floatunsv128qiv128hf */

    case 1238:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29407; /* *cond_floatunsv128siv128hf2 */

    case 1239:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29073; /* *cond_floatunsv256hiv256hf */

    case 1240:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29229; /* *cond_floatunsv256qiv256hf */

    case 1241:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29409; /* *cond_floatunsv256siv256hf2 */

    case 1242:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29075; /* *cond_floatunsv512hiv512hf */

    case 1243:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29231; /* *cond_floatunsv512qiv512hf */

    case 1244:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29411; /* *cond_floatunsv512siv512hf2 */

    case 1245:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29077; /* *cond_floatunsv1024hiv1024hf */

    case 1246:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29233; /* *cond_floatunsv1024qiv1024hf */

    case 1247:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29413; /* *cond_floatunsv1024siv1024hf2 */

    case 1248:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29079; /* *cond_floatunsv2048hiv2048hf */

    case 1249:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29235; /* *cond_floatunsv2048qiv2048hf */

    case 1250:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29081; /* *cond_floatunsv1siv1sf */

    case 1251:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29237; /* *cond_floatunsv1hiv1sf */

    case 1252:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29415; /* *cond_floatunsv1div1sf2 */

    case 1253:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29083; /* *cond_floatunsv2siv2sf */

    case 1254:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29239; /* *cond_floatunsv2hiv2sf */

    case 1255:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29417; /* *cond_floatunsv2div2sf2 */

    case 1256:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29085; /* *cond_floatunsv4siv4sf */

    case 1257:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29241; /* *cond_floatunsv4hiv4sf */

    case 1258:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29419; /* *cond_floatunsv4div4sf2 */

    case 1259:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29087; /* *cond_floatunsv8siv8sf */

    case 1260:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29243; /* *cond_floatunsv8hiv8sf */

    case 1261:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29421; /* *cond_floatunsv8div8sf2 */

    case 1262:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29089; /* *cond_floatunsv16siv16sf */

    case 1263:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29245; /* *cond_floatunsv16hiv16sf */

    case 1264:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29423; /* *cond_floatunsv16div16sf2 */

    case 1265:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29091; /* *cond_floatunsv32siv32sf */

    case 1266:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29247; /* *cond_floatunsv32hiv32sf */

    case 1267:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29425; /* *cond_floatunsv32div32sf2 */

    case 1268:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29093; /* *cond_floatunsv64siv64sf */

    case 1269:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29249; /* *cond_floatunsv64hiv64sf */

    case 1270:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29427; /* *cond_floatunsv64div64sf2 */

    case 1271:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29095; /* *cond_floatunsv128siv128sf */

    case 1272:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29251; /* *cond_floatunsv128hiv128sf */

    case 1273:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29429; /* *cond_floatunsv128div128sf2 */

    case 1274:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29097; /* *cond_floatunsv256siv256sf */

    case 1275:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29253; /* *cond_floatunsv256hiv256sf */

    case 1276:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29431; /* *cond_floatunsv256div256sf2 */

    case 1277:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29099; /* *cond_floatunsv512siv512sf */

    case 1278:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29255; /* *cond_floatunsv512hiv512sf */

    case 1279:
      if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29433; /* *cond_floatunsv512div512sf2 */

    case 1280:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29101; /* *cond_floatunsv1024siv1024sf */

    case 1281:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29257; /* *cond_floatunsv1024hiv1024sf */

    case 1282:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29103; /* *cond_floatunsv1div1df */

    case 1283:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29259; /* *cond_floatunsv1siv1df */

    case 1284:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29105; /* *cond_floatunsv2div2df */

    case 1285:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29261; /* *cond_floatunsv2siv2df */

    case 1286:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29107; /* *cond_floatunsv4div4df */

    case 1287:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29263; /* *cond_floatunsv4siv4df */

    case 1288:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29109; /* *cond_floatunsv8div8df */

    case 1289:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29265; /* *cond_floatunsv8siv8df */

    case 1290:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29111; /* *cond_floatunsv16div16df */

    case 1291:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29267; /* *cond_floatunsv16siv16df */

    case 1292:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29113; /* *cond_floatunsv32div32df */

    case 1293:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29269; /* *cond_floatunsv32siv32df */

    case 1294:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29115; /* *cond_floatunsv64div64df */

    case 1295:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29271; /* *cond_floatunsv64siv64df */

    case 1296:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29117; /* *cond_floatunsv128div128df */

    case 1297:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29273; /* *cond_floatunsv128siv128df */

    case 1298:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29119; /* *cond_floatunsv256div256df */

    case 1299:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29275; /* *cond_floatunsv256siv256df */

    case 1300:
      if (!(
#line 392 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29121; /* *cond_floatunsv512div512df */

    case 1301:
      if (!(
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29277; /* *cond_floatunsv512siv512df */

    case 1302:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29722; /* *cond_smulrvvm8qi3_highpart */

    case 1303:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29724; /* *cond_smulrvvm4qi3_highpart */

    case 1304:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29726; /* *cond_smulrvvm2qi3_highpart */

    case 1305:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29728; /* *cond_smulrvvm1qi3_highpart */

    case 1306:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29730; /* *cond_smulrvvmf2qi3_highpart */

    case 1307:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29732; /* *cond_smulrvvmf4qi3_highpart */

    case 1308:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29734; /* *cond_smulrvvmf8qi3_highpart */

    case 1309:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29736; /* *cond_smulrvvm8hi3_highpart */

    case 1310:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29738; /* *cond_smulrvvm4hi3_highpart */

    case 1311:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29740; /* *cond_smulrvvm2hi3_highpart */

    case 1312:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29742; /* *cond_smulrvvm1hi3_highpart */

    case 1313:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29744; /* *cond_smulrvvmf2hi3_highpart */

    case 1314:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29746; /* *cond_smulrvvmf4hi3_highpart */

    case 1315:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29748; /* *cond_smulrvvm8si3_highpart */

    case 1316:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29750; /* *cond_smulrvvm4si3_highpart */

    case 1317:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29752; /* *cond_smulrvvm2si3_highpart */

    case 1318:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29754; /* *cond_smulrvvm1si3_highpart */

    case 1319:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29756; /* *cond_smulrvvmf2si3_highpart */

    case 1320:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29758; /* *cond_smulrvvm8di3_highpart */

    case 1321:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29760; /* *cond_smulrvvm4di3_highpart */

    case 1322:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29762; /* *cond_smulrvvm2di3_highpart */

    case 1323:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29764; /* *cond_smulrvvm1di3_highpart */

    case 1324:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 29766; /* *cond_smulv1qi3_highpart */

    case 1325:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 29768; /* *cond_smulv2qi3_highpart */

    case 1326:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 29770; /* *cond_smulv4qi3_highpart */

    case 1327:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 29772; /* *cond_smulv8qi3_highpart */

    case 1328:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 29774; /* *cond_smulv16qi3_highpart */

    case 1329:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 29776; /* *cond_smulv32qi3_highpart */

    case 1330:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29778; /* *cond_smulv64qi3_highpart */

    case 1331:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29780; /* *cond_smulv128qi3_highpart */

    case 1332:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29782; /* *cond_smulv256qi3_highpart */

    case 1333:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29784; /* *cond_smulv512qi3_highpart */

    case 1334:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29786; /* *cond_smulv1024qi3_highpart */

    case 1335:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29788; /* *cond_smulv2048qi3_highpart */

    case 1336:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29790; /* *cond_smulv4096qi3_highpart */

    case 1337:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29792; /* *cond_smulv1hi3_highpart */

    case 1338:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29794; /* *cond_smulv2hi3_highpart */

    case 1339:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29796; /* *cond_smulv4hi3_highpart */

    case 1340:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29798; /* *cond_smulv8hi3_highpart */

    case 1341:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29800; /* *cond_smulv16hi3_highpart */

    case 1342:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29802; /* *cond_smulv32hi3_highpart */

    case 1343:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29804; /* *cond_smulv64hi3_highpart */

    case 1344:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29806; /* *cond_smulv128hi3_highpart */

    case 1345:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29808; /* *cond_smulv256hi3_highpart */

    case 1346:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29810; /* *cond_smulv512hi3_highpart */

    case 1347:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29812; /* *cond_smulv1024hi3_highpart */

    case 1348:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29814; /* *cond_smulv2048hi3_highpart */

    case 1349:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29816; /* *cond_smulv1si3_highpart */

    case 1350:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29818; /* *cond_smulv2si3_highpart */

    case 1351:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29820; /* *cond_smulv4si3_highpart */

    case 1352:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29822; /* *cond_smulv8si3_highpart */

    case 1353:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29824; /* *cond_smulv16si3_highpart */

    case 1354:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29826; /* *cond_smulv32si3_highpart */

    case 1355:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29828; /* *cond_smulv64si3_highpart */

    case 1356:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29830; /* *cond_smulv128si3_highpart */

    case 1357:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29832; /* *cond_smulv256si3_highpart */

    case 1358:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29834; /* *cond_smulv512si3_highpart */

    case 1359:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29836; /* *cond_smulv1024si3_highpart */

    case 1360:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 29838; /* *cond_smulv1di3_highpart */

    case 1361:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 29840; /* *cond_smulv2di3_highpart */

    case 1362:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 29842; /* *cond_smulv4di3_highpart */

    case 1363:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29844; /* *cond_smulv8di3_highpart */

    case 1364:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29846; /* *cond_smulv16di3_highpart */

    case 1365:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29848; /* *cond_smulv32di3_highpart */

    case 1366:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29850; /* *cond_smulv64di3_highpart */

    case 1367:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29852; /* *cond_smulv128di3_highpart */

    case 1368:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29854; /* *cond_smulv256di3_highpart */

    case 1369:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29856; /* *cond_smulv512di3_highpart */

    case 1370:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29723; /* *cond_umulrvvm8qi3_highpart */

    case 1371:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29725; /* *cond_umulrvvm4qi3_highpart */

    case 1372:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29727; /* *cond_umulrvvm2qi3_highpart */

    case 1373:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29729; /* *cond_umulrvvm1qi3_highpart */

    case 1374:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29731; /* *cond_umulrvvmf2qi3_highpart */

    case 1375:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29733; /* *cond_umulrvvmf4qi3_highpart */

    case 1376:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29735; /* *cond_umulrvvmf8qi3_highpart */

    case 1377:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29737; /* *cond_umulrvvm8hi3_highpart */

    case 1378:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29739; /* *cond_umulrvvm4hi3_highpart */

    case 1379:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29741; /* *cond_umulrvvm2hi3_highpart */

    case 1380:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29743; /* *cond_umulrvvm1hi3_highpart */

    case 1381:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29745; /* *cond_umulrvvmf2hi3_highpart */

    case 1382:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29747; /* *cond_umulrvvmf4hi3_highpart */

    case 1383:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29749; /* *cond_umulrvvm8si3_highpart */

    case 1384:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29751; /* *cond_umulrvvm4si3_highpart */

    case 1385:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29753; /* *cond_umulrvvm2si3_highpart */

    case 1386:
      if (!
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29755; /* *cond_umulrvvm1si3_highpart */

    case 1387:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29757; /* *cond_umulrvvmf2si3_highpart */

    case 1388:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29759; /* *cond_umulrvvm8di3_highpart */

    case 1389:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29761; /* *cond_umulrvvm4di3_highpart */

    case 1390:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29763; /* *cond_umulrvvm2di3_highpart */

    case 1391:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29765; /* *cond_umulrvvm1di3_highpart */

    case 1392:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 29767; /* *cond_umulv1qi3_highpart */

    case 1393:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 29769; /* *cond_umulv2qi3_highpart */

    case 1394:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 29771; /* *cond_umulv4qi3_highpart */

    case 1395:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 29773; /* *cond_umulv8qi3_highpart */

    case 1396:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 29775; /* *cond_umulv16qi3_highpart */

    case 1397:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 29777; /* *cond_umulv32qi3_highpart */

    case 1398:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29779; /* *cond_umulv64qi3_highpart */

    case 1399:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29781; /* *cond_umulv128qi3_highpart */

    case 1400:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29783; /* *cond_umulv256qi3_highpart */

    case 1401:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29785; /* *cond_umulv512qi3_highpart */

    case 1402:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29787; /* *cond_umulv1024qi3_highpart */

    case 1403:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29789; /* *cond_umulv2048qi3_highpart */

    case 1404:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29791; /* *cond_umulv4096qi3_highpart */

    case 1405:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29793; /* *cond_umulv1hi3_highpart */

    case 1406:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29795; /* *cond_umulv2hi3_highpart */

    case 1407:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29797; /* *cond_umulv4hi3_highpart */

    case 1408:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29799; /* *cond_umulv8hi3_highpart */

    case 1409:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29801; /* *cond_umulv16hi3_highpart */

    case 1410:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29803; /* *cond_umulv32hi3_highpart */

    case 1411:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29805; /* *cond_umulv64hi3_highpart */

    case 1412:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29807; /* *cond_umulv128hi3_highpart */

    case 1413:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29809; /* *cond_umulv256hi3_highpart */

    case 1414:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29811; /* *cond_umulv512hi3_highpart */

    case 1415:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29813; /* *cond_umulv1024hi3_highpart */

    case 1416:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29815; /* *cond_umulv2048hi3_highpart */

    case 1417:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29817; /* *cond_umulv1si3_highpart */

    case 1418:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29819; /* *cond_umulv2si3_highpart */

    case 1419:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29821; /* *cond_umulv4si3_highpart */

    case 1420:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29823; /* *cond_umulv8si3_highpart */

    case 1421:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29825; /* *cond_umulv16si3_highpart */

    case 1422:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29827; /* *cond_umulv32si3_highpart */

    case 1423:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29829; /* *cond_umulv64si3_highpart */

    case 1424:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29831; /* *cond_umulv128si3_highpart */

    case 1425:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29833; /* *cond_umulv256si3_highpart */

    case 1426:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29835; /* *cond_umulv512si3_highpart */

    case 1427:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29837; /* *cond_umulv1024si3_highpart */

    case 1428:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 29839; /* *cond_umulv1di3_highpart */

    case 1429:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 29841; /* *cond_umulv2di3_highpart */

    case 1430:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 29843; /* *cond_umulv4di3_highpart */

    case 1431:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29845; /* *cond_umulv8di3_highpart */

    case 1432:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29847; /* *cond_umulv16di3_highpart */

    case 1433:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29849; /* *cond_umulv32di3_highpart */

    case 1434:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29851; /* *cond_umulv64di3_highpart */

    case 1435:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29853; /* *cond_umulv128di3_highpart */

    case 1436:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29855; /* *cond_umulv256di3_highpart */

    case 1437:
      if (!(
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29857; /* *cond_umulv512di3_highpart */

    default:
      return -1;
    }
}

 rtx_insn *
split_143 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern163 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10375 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10435 (insn, operands);

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10376 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10436 (insn, operands);

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10377 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10437 (insn, operands);

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10378 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10438 (insn, operands);

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10379 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10439 (insn, operands);

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10380 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10440 (insn, operands);

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10381 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10441 (insn, operands);

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10382 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10442 (insn, operands);

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10383 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10443 (insn, operands);

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10384 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10444 (insn, operands);

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10385 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10445 (insn, operands);

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10386 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10446 (insn, operands);

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10387 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10447 (insn, operands);

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10388 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10448 (insn, operands);

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10389 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10449 (insn, operands);

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10390 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10450 (insn, operands);

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10391 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10451 (insn, operands);

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10392 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10452 (insn, operands);

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10393 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10453 (insn, operands);

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10394 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10454 (insn, operands);

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10395 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10455 (insn, operands);

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10396 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10456 (insn, operands);

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10397 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10457 (insn, operands);

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10398 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10458 (insn, operands);

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10399 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10459 (insn, operands);

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10400 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10460 (insn, operands);

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10401 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10461 (insn, operands);

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10402 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10462 (insn, operands);

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10403 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10463 (insn, operands);

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && ((
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10404 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1649 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10464 (insn, operands);

    case 30:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10405 (insn, operands);

    case 31:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10406 (insn, operands);

    case 32:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10407 (insn, operands);

    case 33:
      if (!(
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10408 (insn, operands);

    case 34:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10409 (insn, operands);

    case 35:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10410 (insn, operands);

    case 36:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10411 (insn, operands);

    case 37:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10412 (insn, operands);

    case 38:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10413 (insn, operands);

    case 39:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10414 (insn, operands);

    case 40:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10415 (insn, operands);

    case 41:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10416 (insn, operands);

    case 42:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10417 (insn, operands);

    case 43:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10418 (insn, operands);

    case 44:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10419 (insn, operands);

    case 45:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10420 (insn, operands);

    case 46:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10421 (insn, operands);

    case 47:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10422 (insn, operands);

    case 48:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10423 (insn, operands);

    case 49:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10424 (insn, operands);

    case 50:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10425 (insn, operands);

    case 51:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10426 (insn, operands);

    case 52:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10427 (insn, operands);

    case 53:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10428 (insn, operands);

    case 54:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10429 (insn, operands);

    case 55:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10430 (insn, operands);

    case 56:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10431 (insn, operands);

    case 57:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10432 (insn, operands);

    case 58:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10433 (insn, operands);

    case 59:
      if (!((
#line 1629 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1631 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10434 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_152 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern125 (x2))
    {
    case 0:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4442 (insn, operands);

    case 1:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4444 (insn, operands);

    case 2:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4802 (insn, operands);

    case 3:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4446 (insn, operands);

    case 4:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4804 (insn, operands);

    case 5:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4448 (insn, operands);

    case 6:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4806 (insn, operands);

    case 7:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4450 (insn, operands);

    case 8:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4808 (insn, operands);

    case 9:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4452 (insn, operands);

    case 10:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4810 (insn, operands);

    case 11:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4454 (insn, operands);

    case 12:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4634 (insn, operands);

    case 13:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4456 (insn, operands);

    case 14:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4636 (insn, operands);

    case 15:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4812 (insn, operands);

    case 16:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4458 (insn, operands);

    case 17:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4638 (insn, operands);

    case 18:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4814 (insn, operands);

    case 19:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4460 (insn, operands);

    case 20:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4640 (insn, operands);

    case 21:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4816 (insn, operands);

    case 22:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4462 (insn, operands);

    case 23:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4642 (insn, operands);

    case 24:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4818 (insn, operands);

    case 25:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4464 (insn, operands);

    case 26:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4644 (insn, operands);

    case 27:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4466 (insn, operands);

    case 28:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4646 (insn, operands);

    case 29:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4468 (insn, operands);

    case 30:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4648 (insn, operands);

    case 31:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4470 (insn, operands);

    case 32:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4650 (insn, operands);

    case 33:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4472 (insn, operands);

    case 34:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4844 (insn, operands);

    case 35:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4474 (insn, operands);

    case 36:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4846 (insn, operands);

    case 37:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4476 (insn, operands);

    case 38:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4848 (insn, operands);

    case 39:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4478 (insn, operands);

    case 40:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4850 (insn, operands);

    case 41:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4480 (insn, operands);

    case 42:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4852 (insn, operands);

    case 43:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4482 (insn, operands);

    case 44:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4854 (insn, operands);

    case 45:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4484 (insn, operands);

    case 46:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4856 (insn, operands);

    case 47:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4486 (insn, operands);

    case 48:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4858 (insn, operands);

    case 49:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4488 (insn, operands);

    case 50:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4860 (insn, operands);

    case 51:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4490 (insn, operands);

    case 52:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4862 (insn, operands);

    case 53:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4492 (insn, operands);

    case 54:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4864 (insn, operands);

    case 55:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4494 (insn, operands);

    case 56:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4496 (insn, operands);

    case 57:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4652 (insn, operands);

    case 58:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4866 (insn, operands);

    case 59:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4498 (insn, operands);

    case 60:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4654 (insn, operands);

    case 61:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4868 (insn, operands);

    case 62:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4500 (insn, operands);

    case 63:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4656 (insn, operands);

    case 64:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4870 (insn, operands);

    case 65:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4502 (insn, operands);

    case 66:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4658 (insn, operands);

    case 67:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4872 (insn, operands);

    case 68:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4504 (insn, operands);

    case 69:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4660 (insn, operands);

    case 70:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4874 (insn, operands);

    case 71:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4506 (insn, operands);

    case 72:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4662 (insn, operands);

    case 73:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4876 (insn, operands);

    case 74:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4508 (insn, operands);

    case 75:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4664 (insn, operands);

    case 76:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4878 (insn, operands);

    case 77:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4510 (insn, operands);

    case 78:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4666 (insn, operands);

    case 79:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4880 (insn, operands);

    case 80:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4512 (insn, operands);

    case 81:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4668 (insn, operands);

    case 82:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4882 (insn, operands);

    case 83:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4514 (insn, operands);

    case 84:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4670 (insn, operands);

    case 85:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4884 (insn, operands);

    case 86:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4516 (insn, operands);

    case 87:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4672 (insn, operands);

    case 88:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4518 (insn, operands);

    case 89:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4674 (insn, operands);

    case 90:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4520 (insn, operands);

    case 91:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4676 (insn, operands);

    case 92:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4522 (insn, operands);

    case 93:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4678 (insn, operands);

    case 94:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4524 (insn, operands);

    case 95:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4680 (insn, operands);

    case 96:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4526 (insn, operands);

    case 97:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4682 (insn, operands);

    case 98:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4528 (insn, operands);

    case 99:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4684 (insn, operands);

    case 100:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4530 (insn, operands);

    case 101:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4686 (insn, operands);

    case 102:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4532 (insn, operands);

    case 103:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4688 (insn, operands);

    case 104:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4534 (insn, operands);

    case 105:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4690 (insn, operands);

    case 106:
      if (!((
#line 914 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 916 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4536 (insn, operands);

    case 107:
      if (!((
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4692 (insn, operands);

    case 108:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4790 (insn, operands);

    case 109:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4792 (insn, operands);

    case 110:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4794 (insn, operands);

    case 111:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4796 (insn, operands);

    case 112:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4798 (insn, operands);

    case 113:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4800 (insn, operands);

    case 114:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4820 (insn, operands);

    case 115:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4822 (insn, operands);

    case 116:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4824 (insn, operands);

    case 117:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4826 (insn, operands);

    case 118:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4828 (insn, operands);

    case 119:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4830 (insn, operands);

    case 120:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4832 (insn, operands);

    case 121:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4834 (insn, operands);

    case 122:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4836 (insn, operands);

    case 123:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4838 (insn, operands);

    case 124:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4840 (insn, operands);

    case 125:
      if (!((
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4842 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_160 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (XINT (x3, 1) != 93
              || pattern265 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case CONST_VECTOR:
              operands[1] = x4;
              x5 = XVECEXP (x3, 0, 1);
              operands[4] = x5;
              if (!vector_length_operand (operands[4], E_VOIDmode))
                return NULL;
              x6 = XVECEXP (x3, 0, 2);
              operands[5] = x6;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 2);
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVMF64BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF64BImode)
                      || pattern578 (x2, 
E_RVVMF64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_779 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF64BImode, 5))))
                    return NULL;
                  return gen_split_2431 (insn, operands);

                case E_RVVMF32BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF32BImode)
                      || pattern578 (x2, 
E_RVVMF32BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_780 (insn, operands);
                  if (!(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF32BImode, 5))))
                    return NULL;
                  return gen_split_2432 (insn, operands);

                case E_RVVMF16BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF16BImode)
                      || pattern578 (x2, 
E_RVVMF16BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_781 (insn, operands);
                  if (!(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF16BImode, 5))))
                    return NULL;
                  return gen_split_2433 (insn, operands);

                case E_RVVMF8BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF8BImode)
                      || pattern578 (x2, 
E_RVVMF8BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_782 (insn, operands);
                  if (!(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8BImode, 5))))
                    return NULL;
                  return gen_split_2434 (insn, operands);

                case E_RVVMF4BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF4BImode)
                      || pattern578 (x2, 
E_RVVMF4BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_783 (insn, operands);
                  if (!(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BImode, 5))))
                    return NULL;
                  return gen_split_2435 (insn, operands);

                case E_RVVMF2BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF2BImode)
                      || pattern578 (x2, 
E_RVVMF2BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_784 (insn, operands);
                  if (!(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BImode, 5))))
                    return NULL;
                  return gen_split_2436 (insn, operands);

                case E_RVVM1BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVM1BImode)
                      || pattern578 (x2, 
E_RVVM1BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_785 (insn, operands);
                  if (!(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BImode, 5))))
                    return NULL;
                  return gen_split_2437 (insn, operands);

                case E_V1BImode:
                  if (!nonimmediate_operand (operands[0], E_V1BImode)
                      || pattern578 (x2, 
E_V1BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_786 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1BImode, 5))))
                    return NULL;
                  return gen_split_2438 (insn, operands);

                case E_V2BImode:
                  if (!nonimmediate_operand (operands[0], E_V2BImode)
                      || pattern578 (x2, 
E_V2BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_787 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2BImode, 5))))
                    return NULL;
                  return gen_split_2439 (insn, operands);

                case E_V4BImode:
                  if (!nonimmediate_operand (operands[0], E_V4BImode)
                      || pattern578 (x2, 
E_V4BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_788 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4BImode, 5))))
                    return NULL;
                  return gen_split_2440 (insn, operands);

                case E_V8BImode:
                  if (!nonimmediate_operand (operands[0], E_V8BImode)
                      || pattern578 (x2, 
E_V8BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_789 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8BImode, 5))))
                    return NULL;
                  return gen_split_2441 (insn, operands);

                case E_V16BImode:
                  if (!nonimmediate_operand (operands[0], E_V16BImode)
                      || pattern578 (x2, 
E_V16BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_790 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16BImode, 5))))
                    return NULL;
                  return gen_split_2442 (insn, operands);

                case E_V32BImode:
                  if (!nonimmediate_operand (operands[0], E_V32BImode)
                      || pattern578 (x2, 
E_V32BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_791 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32BImode, 5))))
                    return NULL;
                  return gen_split_2443 (insn, operands);

                case E_V64BImode:
                  if (!nonimmediate_operand (operands[0], E_V64BImode)
                      || pattern578 (x2, 
E_V64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_792 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64BImode, 5))))
                    return NULL;
                  return gen_split_2444 (insn, operands);

                case E_V128BImode:
                  if (!nonimmediate_operand (operands[0], E_V128BImode)
                      || pattern578 (x2, 
E_V128BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_793 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128BImode, 5))))
                    return NULL;
                  return gen_split_2445 (insn, operands);

                case E_V256BImode:
                  if (!nonimmediate_operand (operands[0], E_V256BImode)
                      || pattern578 (x2, 
E_V256BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_794 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256BImode, 5))))
                    return NULL;
                  return gen_split_2446 (insn, operands);

                case E_V512BImode:
                  if (!nonimmediate_operand (operands[0], E_V512BImode)
                      || pattern578 (x2, 
E_V512BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_795 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512BImode, 5))))
                    return NULL;
                  return gen_split_2447 (insn, operands);

                case E_V1024BImode:
                  if (!nonimmediate_operand (operands[0], E_V1024BImode)
                      || pattern578 (x2, 
E_V1024BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_796 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024BImode, 5))))
                    return NULL;
                  return gen_split_2448 (insn, operands);

                case E_V2048BImode:
                  if (!nonimmediate_operand (operands[0], E_V2048BImode)
                      || pattern578 (x2, 
E_V2048BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_797 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048BImode, 5))))
                    return NULL;
                  return gen_split_2449 (insn, operands);

                case E_V4096BImode:
                  if (!nonimmediate_operand (operands[0], E_V4096BImode)
                      || pattern578 (x2, 
E_V4096BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_798 (insn, operands);
                  if (!((
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096BImode, 5))))
                    return NULL;
                  return gen_split_2450 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              return split_124 (x1, insn);

            default:
              return NULL;
            }

        case 7:
          return split_132 (x1, insn);

        case 6:
          if (pattern267 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[4] = x5;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x3, 0, 2);
          operands[5] = x6;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x3, 0, 3);
          operands[6] = x9;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || pattern578 (x2, 
E_RVVMF64BImode) != 0
                  || !(
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return NULL;
              return gen_split_6307 (insn, operands);

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || pattern578 (x2, 
E_RVVMF32BImode) != 0
                  || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6308 (insn, operands);

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || pattern578 (x2, 
E_RVVMF16BImode) != 0
                  || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6309 (insn, operands);

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || pattern578 (x2, 
E_RVVMF8BImode) != 0
                  || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6310 (insn, operands);

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || pattern578 (x2, 
E_RVVMF4BImode) != 0
                  || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6311 (insn, operands);

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || pattern578 (x2, 
E_RVVMF2BImode) != 0
                  || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6312 (insn, operands);

            case E_RVVM1BImode:
              if (!register_operand (operands[0], E_RVVM1BImode)
                  || pattern578 (x2, 
E_RVVM1BImode) != 0
                  || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6313 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_133 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_166 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2600 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2614 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2628 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2642 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2656 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2670 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2684 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2698 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2712 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2726 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2740 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2754 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2768 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2782 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2796 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2810 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2824 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2838 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2852 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2866 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2880 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2894 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2908 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2922 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2936 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2950 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2964 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2978 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2992 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3006 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3020 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3034 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3048 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3062 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3076 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3090 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3104 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3118 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3132 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3146 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3160 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3174 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3188 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3202 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3216 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3230 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3244 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3258 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3272 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3286 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3300 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3314 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3328 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3342 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3356 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3370 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3384 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3398 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3412 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3426 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3440 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3454 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3468 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3482 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3496 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3510 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3524 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3538 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_174 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (equality_operator (x4, E_VOIDmode))
    {
      switch (pattern419 (x3))
        {
        case 0:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_54 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_57 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_77 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_81 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 1:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_55 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_58 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_78 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_82 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 2:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_56 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_59 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_79 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_83 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 3:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode)
              && scratch_operand (operands[4], E_DImode)
              && ((
#line 3168 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
            return gen_split_60 (insn, operands);
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_80 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_84 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 4:
          x5 = XEXP (x4, 0);
          x6 = XEXP (x5, 1);
          if (XWINT (x6, 0) == 1L)
            {
              switch (pattern465 (x3))
                {
                case 0:
                  if ((
#line 3435 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return gen_split_97 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3435 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return gen_split_98 (insn, operands);
                  break;

                case 2:
                  if (((
#line 1143 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1145 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_185 (insn, operands);
                  break;

                case 3:
                  if (((
#line 1143 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1145 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_186 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern466 (x3))
                {
                case 0:
                  if ((
#line 3467 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return gen_split_99 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3467 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return gen_split_100 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  if (!ne_operator (x4, E_VOIDmode))
    return NULL;
  switch (pattern411 (x3))
    {
    case 0:
      if (!((
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_91 (insn, operands);

    case 1:
      if (!((
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_92 (insn, operands);

    case 2:
      if (!((
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_93 (insn, operands);

    case 3:
      if (!((
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_94 (insn, operands);

    case 4:
      if (!((
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_95 (insn, operands);

    case 5:
      if (!((
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_96 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
          return split_149 (x1, insn);

        case ZERO_EXTEND:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
              return split_8 (x1, insn);

            case PLUS:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x5), 0)
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x6 = XEXP (x4, 0);
              if (GET_MODE (x6) != E_SImode)
                return NULL;
              x7 = XEXP (x5, 0);
              if (!register_operand (x7, E_DImode))
                return NULL;
              switch (GET_CODE (x6))
                {
                case ASHIFT:
                  x8 = XEXP (x6, 0);
                  if (GET_CODE (x8) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x8), 0)
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x10 = XEXP (x6, 1);
                  operands[2] = x10;
                  if (!imm123_operand (operands[2], E_QImode))
                    return NULL;
                  operands[3] = x7;
                  if (!
#line 72 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_107 (insn, operands);

                case SUBREG:
                  if (maybe_ne (SUBREG_BYTE (x6), 0))
                    return NULL;
                  x8 = XEXP (x6, 0);
                  if (pattern420 (x8) != 0
                      || !imm123_operand (operands[2], E_QImode))
                    return NULL;
                  x11 = XEXP (x8, 1);
                  operands[3] = x11;
                  if (!consecutive_bits_operand (operands[3], E_DImode))
                    return NULL;
                  operands[4] = x7;
                  if (!
#line 82 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))))
                    return NULL;
                  return gen_split_108 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x6 = XEXP (x4, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x5 = XEXP (x4, 1);
              if (pattern331 (x5) != 0
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x7 = XEXP (x5, 0);
              x12 = XEXP (x7, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x13 = XEXP (x7, 1);
              operands[2] = x13;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !(
#line 659 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_138 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
              return split_9 (x1, insn);

            case ASHIFT:
              switch (pattern135 (x3))
                {
                case 0:
                  x5 = XEXP (x4, 1);
                  if (!subreg_lowpart_operator (x5, E_VOIDmode))
                    return NULL;
                  switch (pattern401 (x5))
                    {
                    case 0:
                      if (!(
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                        return NULL;
                      return gen_split_34 (insn, operands);

                    case 1:
                      if (!(
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                        return NULL;
                      return gen_split_37 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  x5 = XEXP (x4, 1);
                  if (pattern331 (x5) != 0)
                    return NULL;
                  x7 = XEXP (x5, 0);
                  x12 = XEXP (x7, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x13 = XEXP (x7, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_VOIDmode)
                      || !(
#line 659 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_137 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              switch (pattern228 (x3))
                {
                case 0:
                  if (!(
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case 1:
                  if (!(
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_38 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              switch (pattern228 (x3))
                {
                case 0:
                  if (!(
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                case 1:
                  if (!(
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_39 (insn, operands);

                default:
                  return NULL;
                }

            case ROTATE:
              switch (pattern228 (x3))
                {
                case 0:
                  if (!(
#line 450 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 452 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case 1:
                  if (!((
#line 450 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 452 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_127 (insn, operands);

                default:
                  return NULL;
                }

            case ROTATERT:
              switch (pattern228 (x3))
                {
                case 0:
                  if (!(
#line 450 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 452 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_126 (insn, operands);

                case 1:
                  if (!((
#line 450 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 452 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_128 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          return split_110 (x1, insn);

        case ASHIFT:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x14 = XEXP (x3, 1);
              if (subreg_lowpart_operator (x14, E_VOIDmode))
                {
                  switch (pattern270 (x3))
                    {
                    case 0:
                      return gen_split_22 (insn, operands);

                    case 1:
                      if ((
#line 31 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                        return gen_split_28 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                        return gen_split_25 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                        return gen_split_31 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x14;
              return split_111 (x1, insn);

            case ZERO_EXTEND:
              return split_112 (x1, insn);

            default:
              return NULL;
            }

        case ASHIFTRT:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x14 = XEXP (x3, 1);
          if (subreg_lowpart_operator (x14, E_VOIDmode))
            {
              switch (pattern270 (x3))
                {
                case 0:
                  return gen_split_23 (insn, operands);

                case 1:
                  if ((
#line 31 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_29 (insn, operands);
                  break;

                case 2:
                  if ((
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_26 (insn, operands);
                  break;

                case 3:
                  if ((
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_32 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[2] = x14;
          return split_113 (x1, insn);

        case LSHIFTRT:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x14 = XEXP (x3, 1);
          if (subreg_lowpart_operator (x14, E_VOIDmode))
            {
              switch (pattern270 (x3))
                {
                case 0:
                  return gen_split_24 (insn, operands);

                case 1:
                  if ((
#line 31 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_30 (insn, operands);
                  break;

                case 2:
                  if ((
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_27 (insn, operands);
                  break;

                case 3:
                  if ((
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_33 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[2] = x14;
          return split_114 (x1, insn);

        case AND:
          return split_146 (x1, insn);

        case IOR:
          return split_148 (x1, insn);

        case XOR:
          return split_162 (x1, insn);

        case ROTATE:
          switch (pattern122 (x3))
            {
            case 0:
              if (!(
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_117 (insn, operands);

            case 1:
              if (!((
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_121 (insn, operands);

            case 2:
              if (!((
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_119 (insn, operands);

            case 3:
              if (!((
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_123 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern122 (x3))
            {
            case 0:
              if (!(
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_118 (insn, operands);

            case 1:
              if (!((
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_122 (insn, operands);

            case 2:
              if (!((
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_120 (insn, operands);

            case 3:
              if (!((
#line 432 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_124 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) != ZERO_EXTRACT)
                return NULL;
              x10 = XEXP (x6, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x5 = XEXP (x4, 1);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x15 = XEXP (x6, 2);
              operands[2] = x15;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern261 (x3, 
E_SImode) != 0
                      || !
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS))
                    return NULL;
                  return gen_split_174 (insn, operands);

                case E_DImode:
                  if (pattern261 (x3, 
E_DImode) != 0
                      || !(
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_175 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x4;
              return split_116 (x1, insn);

            case UNSPEC:
              switch (pattern152 (x3))
                {
                case 0:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10076 (insn, operands);

                case 1:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10077 (insn, operands);

                case 2:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10078 (insn, operands);

                case 3:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10079 (insn, operands);

                case 4:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10080 (insn, operands);

                case 5:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10081 (insn, operands);

                case 6:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10082 (insn, operands);

                case 7:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10083 (insn, operands);

                case 8:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10084 (insn, operands);

                case 9:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10085 (insn, operands);

                case 10:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10086 (insn, operands);

                case 11:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10087 (insn, operands);

                case 12:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10088 (insn, operands);

                case 13:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10089 (insn, operands);

                case 14:
                  if (!((
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_10090 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSPEC:
          return split_171 (x1, insn);

        case IF_THEN_ELSE:
          return split_160 (x1, insn);

        case VEC_DUPLICATE:
          return split_154 (x1, insn);

        case MINUS:
          return split_161 (x1, insn);

        case SMAX:
          return split_158 (x1, insn);

        case UMAX:
          return split_169 (x1, insn);

        case SMIN:
          return split_159 (x1, insn);

        case UMIN:
          return split_168 (x1, insn);

        case MULT:
          return split_147 (x1, insn);

        case DIV:
          return split_157 (x1, insn);

        case UDIV:
          return split_167 (x1, insn);

        case MOD:
          return split_165 (x1, insn);

        case UMOD:
          return split_166 (x1, insn);

        case NOT:
          return split_170 (x1, insn);

        case TRUNCATE:
          return split_145 (x1, insn);

        case FLOAT_EXTEND:
          return split_156 (x1, insn);

        case FLOAT_TRUNCATE:
          return split_155 (x1, insn);

        case FIX:
          return split_153 (x1, insn);

        case UNSIGNED_FIX:
          return split_152 (x1, insn);

        case FLOAT:
          return split_151 (x1, insn);

        case UNSIGNED_FLOAT:
          return split_150 (x1, insn);

        case ABS:
          switch (pattern127 (x3))
            {
            case 0:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5082 (insn, operands);

            case 1:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5084 (insn, operands);

            case 2:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5086 (insn, operands);

            case 3:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5088 (insn, operands);

            case 4:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5090 (insn, operands);

            case 5:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5092 (insn, operands);

            case 6:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5094 (insn, operands);

            case 7:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5096 (insn, operands);

            case 8:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5098 (insn, operands);

            case 9:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5100 (insn, operands);

            case 10:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5102 (insn, operands);

            case 11:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5104 (insn, operands);

            case 12:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5106 (insn, operands);

            case 13:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5108 (insn, operands);

            case 14:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5110 (insn, operands);

            case 15:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5112 (insn, operands);

            case 16:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5114 (insn, operands);

            case 17:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5116 (insn, operands);

            case 18:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5118 (insn, operands);

            case 19:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5120 (insn, operands);

            case 20:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5122 (insn, operands);

            case 21:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5124 (insn, operands);

            case 22:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5126 (insn, operands);

            case 23:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5128 (insn, operands);

            case 24:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5130 (insn, operands);

            case 25:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5132 (insn, operands);

            case 26:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5134 (insn, operands);

            case 27:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5136 (insn, operands);

            case 28:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5138 (insn, operands);

            case 29:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5140 (insn, operands);

            case 30:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5142 (insn, operands);

            case 31:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5144 (insn, operands);

            case 32:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5146 (insn, operands);

            case 33:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5148 (insn, operands);

            case 34:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5150 (insn, operands);

            case 35:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5152 (insn, operands);

            case 36:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5154 (insn, operands);

            case 37:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5156 (insn, operands);

            case 38:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5158 (insn, operands);

            case 39:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5160 (insn, operands);

            case 40:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5162 (insn, operands);

            case 41:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5164 (insn, operands);

            case 42:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5166 (insn, operands);

            case 43:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5168 (insn, operands);

            case 44:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5170 (insn, operands);

            case 45:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5172 (insn, operands);

            case 46:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5174 (insn, operands);

            case 47:
              if (!((
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5176 (insn, operands);

            default:
              return NULL;
            }

        case SQRT:
          return split_173 (x1, insn);

        case SMUL_HIGHPART:
          return split_164 (x1, insn);

        case UMUL_HIGHPART:
          return split_163 (x1, insn);

        case POPCOUNT:
          return split_172 (x1, insn);

        default:
          return NULL;
        }

    case PARALLEL:
      return split_180 (x1, insn);

    case EH_RETURN:
      if (!
#line 3901 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(epilogue_completed))
        return NULL;
      return gen_split_102 (insn, operands);

    default:
      return NULL;
    }
}
