/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern10 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_TImode) != 0)
        return -1;
      return 0;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern7 (x3, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern7 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V8QImode:
      if (pattern8 (x3, 
E_V8QImode) != 0)
        return -1;
      return 5;

    case E_V4QImode:
      if (pattern7 (x3, 
E_V4QImode) != 0)
        return -1;
      return 6;

    case E_V2QImode:
      if (pattern7 (x3, 
E_V2QImode) != 0)
        return -1;
      return 7;

    case E_V2HImode:
      if (pattern7 (x3, 
E_V2HImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !nonimmediate_operand (operands[1], E_V16QImode))
            return -1;
          return 0;

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !nonimmediate_operand (operands[1], E_V32QImode))
            return -1;
          return 1;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_V8QImode))
            return -1;
          return 2;

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              return 3;

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              return 4;

            default:
              return -1;
            }

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 5;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 7;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 9;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 10;

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 12;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 13;

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2QImode:
              if (!memory_operand (operands[1], E_V2QImode))
                return -1;
              return 15;

            case E_V2HImode:
              if (!memory_operand (operands[1], E_V2HImode))
                return -1;
              return 16;

            case E_V2SImode:
              if (!memory_operand (operands[1], E_V2SImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!memory_operand (operands[1], E_XImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern107 (x1, pnum_clobbers); /* [-1, 4] */
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != -65536L)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != BSWAP
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  return 0;
}

int
pattern120 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern127 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern127 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern127 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern127 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern127 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern127 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern152 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V32HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V32HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_V32HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern163 (x3, 
E_V32HFmode, 
E_V64QImode, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern163 (x3, 
E_V16HFmode, 
E_V32QImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern170 (x3, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern170 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern170 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x6, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      return pattern186 (x1); /* [-1, 0] */

    case 8:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x4, 0, 4);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x4, 0, 6);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x4, 0, 7);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x24 = XVECEXP (x7, 0, 4);
      if (GET_CODE (x24) != CONST_INT)
        return -1;
      x25 = XVECEXP (x7, 0, 5);
      if (GET_CODE (x25) != CONST_INT)
        return -1;
      x26 = XVECEXP (x7, 0, 6);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x27 = XVECEXP (x7, 0, 7);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (XWINT (x14, 0))
        {
        case 4L:
          if (XWINT (x15, 0) != 6L
              || XWINT (x16, 0) != 8L
              || XWINT (x17, 0) != 10L
              || XWINT (x22, 0) != 5L
              || XWINT (x23, 0) != 7L
              || XWINT (x24, 0) != 9L
              || XWINT (x25, 0) != 11L
              || pattern187 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case 8L:
          if (XWINT (x15, 0) != 10L
              || XWINT (x16, 0) != 4L
              || XWINT (x17, 0) != 6L
              || XWINT (x22, 0) != 9L
              || XWINT (x23, 0) != 11L
              || XWINT (x24, 0) != 5L
              || XWINT (x25, 0) != 7L
              || pattern185 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 4:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern187 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x2, 0);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern219 (x7, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern219 (x7, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    case E_DFmode:
      if (pattern219 (x7, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern233 (x1, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern233 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern233 (x1, 
E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return pattern243 (x6); /* [-1, 1] */
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern261 (); /* [-1, 2] */
}

int
pattern267 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (pnum_clobbers == NULL
          || maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          return pattern266 (x1); /* [-1, 1] */

        case PLUS:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern266 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern2 (x1);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        default:
          return -1;
        }

    case CONST_INT:
      return 6;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LTU:
    case UNLT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!flags_reg_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x1, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern308 (x1, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern308 (x1, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern308 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8DImode:
      res = pattern309 (x1, 
E_V8DImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case E_V4DImode:
      res = pattern309 (x1, 
E_V4DImode);
      if (res >= 0)
        return res + 5; /* [5, 6] */
      return -1;

    case E_V2DImode:
      res = pattern309 (x1, 
E_V2DImode);
      if (res >= 0)
        return res + 7; /* [7, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode))
            return -1;
          return 1;

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 3;

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode))
            return -1;
          return 4;

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode))
            return -1;
          return 6;

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode))
            return -1;
          return 10;

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !x86_64_general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !x86_64_general_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !x86_64_general_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !x86_64_general_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !x86_64_general_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !x86_64_general_operand (operands[2], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern359 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern357 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern357 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern358 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern358 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern368 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!x86_64_zext_immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern378 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern383 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern382 (x6, 
37); /* [-1, 0] */
}

int
pattern393 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 21
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != CONST
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[1] = x13;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x14 = XVECEXP (x4, 0, 1);
  operands[2] = x14;
  if (!constant_call_address_operand (operands[2], E_VOIDmode))
    return -1;
  x15 = XVECEXP (x7, 0, 0);
  operands[3] = x15;
  if (!tls_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x16 = XEXP (x8, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x17 = XEXP (x9, 0);
  operands[5] = x17;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern415 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LTU)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode
      || !nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || GET_MODE (x2) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern257 (x5, 
E_DImode, 
E_TImode); /* [-1, 1] */
}

int
pattern432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern440 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      operands[3] = x3;
      x4 = XEXP (x1, 0);
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      return pattern438 (x1); /* [-1, 1] */

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_QImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      x6 = XEXP (x4, 1);
      if (!nonmemory_operand (x6, E_QImode))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 64L:
          if (pattern439 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case 32L:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern455 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern454 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern454 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern454 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern471 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern478 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern487 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern488 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern487 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern487 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern487 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern487 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern487 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern487 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern487 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern487 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern487 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SFmode
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[3], E_V2SFmode)
      || !const0_operand (operands[4], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern507 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!nonimmediate_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!nonimmediate_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!memory_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XINT (x2, 1) != 151)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (XVECLEN (x5, 0))
    {
    case 16:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          return pattern527 (x1, 
E_V32HImode, 
E_V16HImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern527 (x1, 
E_V32QImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 8:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern527 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V8SImode:
          if (pattern527 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 32:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x22 = XVECEXP (x5, 0, 16);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x23 = XVECEXP (x5, 0, 17);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x24 = XVECEXP (x5, 0, 18);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
        return -1;
      x25 = XVECEXP (x5, 0, 19);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
        return -1;
      x26 = XVECEXP (x5, 0, 20);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
        return -1;
      x27 = XVECEXP (x5, 0, 21);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
        return -1;
      x28 = XVECEXP (x5, 0, 22);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
        return -1;
      x29 = XVECEXP (x5, 0, 23);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
        return -1;
      x30 = XVECEXP (x5, 0, 24);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x31 = XVECEXP (x5, 0, 25);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x32 = XVECEXP (x5, 0, 26);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x33 = XVECEXP (x5, 0, 27);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x34 = XVECEXP (x5, 0, 28);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x35 = XVECEXP (x5, 0, 29);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x36 = XVECEXP (x5, 0, 30);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x37 = XVECEXP (x5, 0, 31);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern527 (x1, 
E_V64QImode, 
E_V32QImode) != 0)
        return -1;
      return 4;

    case 4:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern527 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
      operands[3] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern603 (x1, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern603 (x1, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_TImode:
          if (pattern604 (x1, 
E_TImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern605 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!const_1_to_63_operand (operands[2], E_QImode)
      || !register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || !register_operand (operands[1], E_TImode))
    return -1;
  return 0;
}

int
pattern622 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern447 (x1); /* [-1, 1] */

    case PLUS:
      res = pattern447 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern16 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[4] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return 0;

        case E_V16HFmode:
          return 1;

        case E_V8HFmode:
          return 2;

        case E_V16SFmode:
          return 3;

        case E_V8SFmode:
          return 4;

        case E_V4SFmode:
          return 5;

        case E_V8DFmode:
          return 6;

        case E_V4DFmode:
          return 7;

        case E_V2DFmode:
          return 8;

        case E_V32BFmode:
          return 9;

        case E_V16BFmode:
          return 10;

        case E_V8BFmode:
          return 11;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x2, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 12;

        case E_V4SFmode:
          return 13;

        case E_V2DFmode:
          return 14;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern648 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[4] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern645 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern645 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern645 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern645 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern645 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern645 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern645 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern645 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern645 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern647 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern665 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern665 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern665 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern675 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_BFmode:
      if (!memory_operand (operands[1], E_BFmode))
        return -1;
      return 0;

    case E_HFmode:
      if (!memory_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern682 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 110)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern692 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case ZERO_EXTRACT:
      return 1;

    default:
      return -1;
    }
}

int
pattern697 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern705 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

int
pattern712 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1)
    return -1;
  return 0;
}

int
pattern717 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  return 0;
}

int
pattern724 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_SImode:
      res = pattern293 (x1);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    case E_DImode:
      res = pattern294 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern734 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern742 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[3], E_HImode))
        return -1;
      return pattern740 (); /* [-1, 2] */

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[3], E_QImode))
        return -1;
      res = pattern741 ();
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern755 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SImode)
          || !const0_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SImode)
          || !const0_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DImode)
          || !const0_operand (operands[2], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !const0_operand (operands[2], E_V32QImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const0_operand (operands[2], E_V16QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern779 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  return pattern778 (x1); /* [-1, 2] */
}

int
pattern793 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern805 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !movq_parallel (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern814 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 7
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern817 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x2;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern822 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 38)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  return pattern543 (x1); /* [-1, 1] */
}

int
pattern827 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 38)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x10 = XVECEXP (x2, 0, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern838 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern837 (x1, 
i1, 
i2, 
i3, 
i4) != 0)
    return -1;
  return 0;
}

int
pattern849 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern852 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern851 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern851 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern858 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern862 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern869 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern878 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern887 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern898 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2DImode
      || !nonimm_or_0_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!memory_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern906 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || !register_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 8:
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x8, 0, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x8, 0, 3);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x13 = XVECEXP (x8, 0, 4);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x14 = XVECEXP (x8, 0, 5);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x15 = XVECEXP (x8, 0, 6);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x16 = XVECEXP (x8, 0, 7);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x4) != E_V16QImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              return pattern135 (x1, 
E_V8HImode); /* [-1, 0] */

            case E_V8SImode:
              if (pattern135 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1;

            case E_V8DImode:
              if (pattern135 (x1, 
E_V8DImode) != 0)
                return -1;
              return 2;

            default:
              return -1;
            }

        case 4:
          res = pattern904 (x1, 
E_V8HImode, 
E_V4HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case 2:
          if (pattern905 (x1, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case VEC_MERGE:
      if (GET_MODE (x5) != E_V4SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != VEC_DUPLICATE
          || GET_MODE (x7) != E_V4SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_VECTOR
          || XVECLEN (x6, 0) != 4
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x17 = XVECEXP (x6, 0, 0);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x18 = XVECEXP (x6, 0, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x6, 0, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XVECEXP (x6, 0, 3);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x21 = XEXP (x5, 2);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XEXP (x7, 0);
      operands[1] = x22;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 4:
          res = pattern904 (x1, 
E_V16QImode, 
E_V4QImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case 2:
          if (pattern905 (x1, 
E_V8HImode, 
E_V2HImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern955 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern954 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern954 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern963 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x3, 1);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  x8 = XEXP (x5, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = PATTERN (peep2_next_insn (3));
  return pattern962 (x9, 
i1); /* [-1, 0] */
}

int
pattern970 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern974 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  if (XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern976 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_HFmode)
      || GET_MODE (x1) != E_HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern979 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      return pattern271 (x1, 
E_V2HFmode, 
E_V4HFmode); /* [-1, 0] */

    case E_V2BFmode:
      if (pattern271 (x1, 
E_V2BFmode, 
E_V4BFmode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern271 (x1, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern986 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern989 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[1], E_V64QImode)
      || !nonimmediate_operand (operands[2], E_V64QImode)
      || !const_0_to_7_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern994 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1005 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i2)
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1013 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !sse_comparison_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1019 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1027 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1035 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1042 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode)
          || !extract_operator (operands[4], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode)
          || !extract_operator (operands[4], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode)
          || !extract_operator (operands[4], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1046 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, i1))
    return -1;
  return 0;
}

int
pattern1051 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1054 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (!register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case DIV:
      return 0;

    case UDIV:
      return 1;

    case MOD:
      return 2;

    case UMOD:
      return 3;

    default:
      return -1;
    }
}

int
pattern1064 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern1073 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  return pattern741 (); /* [-1, 5] */
}

int
pattern1080 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern1079 (x2); /* [-1, 11] */
}

int
pattern1085 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 1;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 2;

        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 4;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 6;

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 7;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 9;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 10;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1120 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 223
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3L
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode)
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_V8HFmode))
    return -1;
  x8 = XVECEXP (x4, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  operands[5] = x11;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  x12 = XEXP (x2, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern1141 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 3;

        case E_HImode:
          return 4;

        case E_SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern1165 (x2, 
i1); /* [-1, 2] */
}

int
pattern1174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1182 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1181 (); /* [-1, 3] */
}

int
pattern1188 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1195 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != LTU
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x3, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 17
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  x13 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x13) != PARALLEL
      || XVECLEN (x13, 0) != 2)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (GET_CODE (x14) != SET)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != NEG
      || GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x13, 0, 1);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 17
      || GET_MODE (x17) != E_CCmode)
    return -1;
  x18 = XEXP (x15, 0);
  if (!rtx_equal_p (x18, operands[0]))
    return -1;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[0]))
    return -1;
  return 0;
}

int
pattern1220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1231 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_MODE (x7))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern374 (x4); /* [-1, 1] */
}

int
pattern1257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern1261 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[0], i1)
      || !const0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 0);
  switch (GET_CODE (x9))
    {
    case STRICT_LOW_PART:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return pattern1266 (); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      res = pattern1266 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1293 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1303 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1331 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  return pattern405 (x1); /* [-1, 1] */
}

int
pattern1343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CALL)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  return 0;
}

int
pattern1351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1357 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1364 (); /* [-1, 3] */
}

int
pattern1368 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1386 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || pattern1374 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1414 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1419 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1426 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode)
      || !register_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern1440 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[5], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1453 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1462 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1471 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1478 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1488 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1499 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1511 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1520 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1538 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1559 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8SFmode
      || !vector_operand (operands[1], E_V4SFmode))
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  return 0;
}

int
pattern1567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1580 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !x86_64_dwzext_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1587 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1596 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1605 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1604 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1604 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1615 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1614 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1614 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1627 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern1637 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1645 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1656 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1655 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1655 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1669 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 2);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_63_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1693 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !register_operand (operands[2], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1705 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1704 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1704 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1715 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1723 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1730 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 0);
      switch (GET_MODE (x9))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1750 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1757 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1766 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1774 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1781 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !general_reg_operand (operands[4], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  return 0;
}

int
pattern1788 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  return 0;
}

int
pattern1795 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1794 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1803 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!register_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern1811 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1820 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || !register_operand (operands[5], i1)
      || !register_operand (operands[6], i1)
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1825 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1831 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1840 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !ix86_carry_flag_operator (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1849 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12L)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 28L)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13L)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 29L)
    return -1;
  return 0;
}

int
pattern1856 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != GTU
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[7] = x5;
  if (!register_operand (operands[7], E_QImode))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != LTU
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x7, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x6, 0);
  operands[8] = x10;
  if (!register_operand (operands[8], E_QImode))
    return -1;
  x11 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != COMPARE)
    return -1;
  x13 = XEXP (x11, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 17)
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[7]))
    return -1;
  x15 = XEXP (x12, 1);
  if (!rtx_equal_p (x15, operands[8]))
    return -1;
  return 0;
}

int
pattern1869 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_16_to_31_operand (operands[11], E_VOIDmode)
      || !const_16_to_31_operand (operands[12], E_VOIDmode)
      || !const_16_to_31_operand (operands[13], E_VOIDmode)
      || !const_16_to_31_operand (operands[14], E_VOIDmode)
      || !const_16_to_31_operand (operands[15], E_VOIDmode)
      || !const_16_to_31_operand (operands[16], E_VOIDmode)
      || !const_16_to_31_operand (operands[17], E_VOIDmode)
      || !const_16_to_31_operand (operands[18], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1881 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      operands[8] = x2;
      if (!ix86_comparison_int_operator (operands[8], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[7] = x5;
      if (!nonimmediate_operand (operands[7], E_QImode))
        return -1;
      return 0;

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      if (!ix86_comparison_int_operator (x3, E_VOIDmode))
        return -1;
      operands[7] = x3;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x9 = XEXP (x4, 0);
      operands[8] = x9;
      return 1;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x4) != E_CCFPmode)
    return -1;
  switch (GET_CODE (x4))
    {
    case COMPARE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x6;
          switch (GET_MODE (operands[1]))
            {
            case E_XFmode:
              if (!register_operand (operands[1], E_XFmode)
                  || !reg_or_0_operand (operands[2], E_XFmode)
                  || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 35; /* *cmpxf_i387 */

            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !nonimm_or_0_operand (operands[2], E_SFmode)
                  || !
#line 1949 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 36; /* *cmpsf_i387 */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !nonimm_or_0_operand (operands[2], E_DFmode)
                  || !
#line 1949 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 37; /* *cmpdf_i387 */

            default:
              return -1;
            }

        case FLOAT:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              switch (pattern1263 (x6, 
E_SFmode))
                {
                case 0:
                  if (!
#line 1963 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 38; /* *cmpsf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 41; /* *cmpsf_si_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern1263 (x6, 
E_DFmode))
                {
                case 0:
                  if (!
#line 1963 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 39; /* *cmpdf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 42; /* *cmpdf_si_i387 */

                default:
                  return -1;
                }

            case E_XFmode:
              switch (pattern1263 (x6, 
E_XFmode))
                {
                case 0:
                  if (!
#line 1963 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 40; /* *cmpxf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 43; /* *cmpxf_si_i387 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 26)
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x8) != COMPARE
          || GET_MODE (x8) != E_CCFPmode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !register_operand (operands[2], E_SFmode)
              || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 44; /* *cmpusf_i387 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !register_operand (operands[2], E_DFmode)
              || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 45; /* *cmpudf_i387 */

        case E_XFmode:
          if (!register_operand (operands[1], E_XFmode)
              || !register_operand (operands[2], E_XFmode)
              || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 46; /* *cmpuxf_i387 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 18
          || !
#line 23858 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 1714; /* x86_fnstsw_1 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 24:
      return recog_7 (x1, insn, pnum_clobbers);

    case 25:
      if (pattern55 (x1, 
E_HImode) != 0
          || !
#line 1994 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SAHF))
        return -1;
      return 47; /* x86_sahf_1 */

    case 26:
      return recog_6 (x1, insn, pnum_clobbers);

    case 44:
      if (GET_MODE (x2) != E_CCFPmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != COMPARE
          || GET_MODE (x3) != E_CCFPmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 2045 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
            return -1;
          return 50; /* *cmpxsf */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 2045 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
            return -1;
          return 52; /* *cmpxdf */

        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !
#line 2058 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
            return -1;
          return 54; /* *cmpxhf */

        default:
          return -1;
        }

    case 41:
      if (pattern57 (x1, 
E_CCCmode) != 0)
        return -1;
      return 63; /* x86_stc */

    case 42:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!flags_reg_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!push_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)))
            return -1;
          return 80; /* pushflsi2 */

        case E_DImode:
          if (!push_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !(
#line 2323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return -1;
          return 81; /* pushfldi2 */

        default:
          return -1;
        }

    case 43:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!flags_reg_operand (operands[0], E_CCmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!pop_operand (operands[1], E_SImode)
              || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode))
            return -1;
          return 82; /* popflsi1 */

        case E_DImode:
          if (!pop_operand (operands[1], E_DImode)
              || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode))
            return -1;
          return 83; /* popfldi1 */

        default:
          return -1;
        }

    case 60:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_BFmode)
          || !
#line 5471 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE2))
        return -1;
      return 203; /* extendbfsf2_1 */

    case 28:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_HImode)
          || !
#line 6045 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 238; /* x86_fnstcw_1 */

    case 97:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 21718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)))
        return 1562; /* tzcnt_hi_nf */
      if (pnum_clobbers == NULL
          || !(
#line 21718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(true) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)))
        return -1;
      *pnum_clobbers = 1;
      return 1563; /* tzcnt_hi */

    case 96:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 21718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
        return 1564; /* lzcnt_hi_nf */
      if (pnum_clobbers == NULL
          || !(
#line 21718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(true) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
        return -1;
      *pnum_clobbers = 1;
      return 1565; /* lzcnt_hi */

    case 27:
      if (pattern55 (x1, 
E_QImode) != 0)
        return -1;
      return 1648; /* parityqi2_cmp */

    case 54:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 23455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE && TARGET_SSE_MATH))
            return -1;
          return 1680; /* *rcpsf2_sse */

        case 1:
          if (!
#line 23481 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1681; /* rcphf2 */

        default:
          return -1;
        }

    case 31:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 23698 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1706; /* truncxfsf2_i387_noop_unspec */

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 23698 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1707; /* truncxfdf2_i387_noop_unspec */

        default:
          return -1;
        }

    case 55:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 23718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE))
            return -1;
          return 1709; /* *rsqrtsf2_sse */

        case 1:
          if (!
#line 23754 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1710; /* rsqrthf2 */

        default:
          return -1;
        }

    case 64:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24021 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1717; /* sinxf2 */

    case 65:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24021 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1718; /* cosxf2 */

    case 71:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24647 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1725; /* *f2xm1xf2_i387 */

    case 69:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24981 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1732; /* rintxf2 */

    case 70:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 25122 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1734; /* lrintxfhi2 */

    case 74:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1736; /* frndintxf2_roundeven */

    case 75:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1737; /* frndintxf2_floor */

    case 76:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1738; /* frndintxf2_ceil */

    case 77:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1739; /* frndintxf2_trunc */

    case 78:
      if (pattern60 (x1, pnum_clobbers) != 0
          || !
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1744; /* *fisthi2_floor_1 */

    case 79:
      if (pattern60 (x1, pnum_clobbers) != 0
          || !
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1745; /* *fisthi2_ceil_1 */

    case 73:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 25431 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1756; /* fxamsf2_i387 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 25431 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1757; /* fxamdf2_i387 */

        case E_XFmode:
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 25431 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1758; /* fxamxf2_i387 */

        default:
          return -1;
        }

    case 112:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 900 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2059; /* mmx_rcpv2sf2 */

    case 115:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 948 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2062; /* mmx_rsqrtv2sf2 */

    case 172:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
            return -1;
          return 4788; /* unspec_sse_cvttps2pi */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 8928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4904; /* unspec_sse2_cvttpd2pi */

        default:
          return -1;
        }

    case 46:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 8910 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4903; /* sse2_cvtpd2pi */

    case 173:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2DFmode)
          || !
#line 8969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_MMX_WITH_SSE && TARGET_AVX512VL))
        return -1;
      return 4906; /* unspec_fixuns_truncv2dfv2si2 */

    case 191:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 10273 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5201; /* avx512vl_cvtb2maskv16qi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 10273 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5204; /* avx512vl_cvtw2maskv16hi */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 10283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5206; /* avx512f_cvtd2maskv16si */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 10273 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5205; /* avx512vl_cvtw2maskv8hi */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 10283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5207; /* avx512vl_cvtd2maskv8si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 10283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5208; /* avx512vl_cvtd2maskv4si */

            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !(
#line 10283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5209; /* avx512f_cvtq2maskv8di */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !(
#line 10283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5210; /* avx512vl_cvtq2maskv4di */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !(
#line 10283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5211; /* avx512vl_cvtq2maskv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 117:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!memory_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 23425 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8675; /* sse4a_movntsf */

            case E_DFmode:
              if (!memory_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 23425 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8676; /* sse4a_movntdf */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1066 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 23437 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8677; /* sse4a_vmmovntv4sf */

            case E_DFmode:
              if (pattern1066 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 23437 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4A) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8678; /* sse4a_vmmovntv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 136:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 27004 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9057; /* xop_frczsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 27004 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9058; /* xop_frczdf2 */

        default:
          return -1;
        }

    case 283:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_DImode)
          || !
#line 346 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
(TARGET_80387))
        return -1;
      return 11023; /* loaddi_via_fpu */

    case 285:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_DImode)
          || !
#line 369 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
(TARGET_SSE))
        return -1;
      return 11025; /* loaddi_via_sse */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (pattern261 ())
            {
            case 0:
              if (
#line 5769 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 212; /* fix_trunchfsi2 */
              break;

            case 1:
              if (
#line 5945 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 225; /* fix_truncsfsi_sse */
              break;

            case 2:
              if (
#line 5945 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 227; /* fix_truncdfsi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 230; /* fix_truncsi_i387_fisttp */
        }
      if (!
#line 5993 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 233; /* *fix_truncsi_i387_1 */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          switch (pattern261 ())
            {
            case 0:
              if ((
#line 5769 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 214; /* fix_trunchfdi2 */
              break;

            case 1:
              if ((
#line 5945 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 226; /* fix_truncsfdi_sse */
              break;

            case 2:
              if ((
#line 5945 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 228; /* fix_truncdfdi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 231; /* fix_truncdi_i387_fisttp */
        }
      if (!
#line 5993 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 234; /* *fix_truncdi_i387_1 */

    case E_HImode:
      if (pattern260 (x3, pnum_clobbers, 
E_VOIDmode, 
E_HImode) != 0)
        return -1;
      if (
#line 5975 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 229; /* fix_trunchi_i387_fisttp */
        }
      if (!
#line 5993 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 232; /* *fix_trunchi_i387_1 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 8945 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4905; /* sse2_cvttpd2pi */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern743 (x2, 
E_HImode) != 0
              || !
#line 13607 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 835; /* *notxorhi_1 */

        case E_QImode:
          if (pattern743 (x2, 
E_QImode) != 0
              || !
#line 13807 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 871; /* *notxorqi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14976 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1031; /* *one_cmplti2_doubleword */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14989 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1032; /* *one_cmplhi2_1 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 15033 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1041; /* *one_cmplqi2_1 */

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x2) != E_V4QImode
                  || !register_operand (operands[1], E_V4QImode))
                return -1;
              return 2265; /* one_cmplv4qi2 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x2) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode))
                return -1;
              return 2266; /* one_cmplv2qi2 */

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode))
                return -1;
              return 2267; /* one_cmplv2hi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 15059 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1042; /* *one_cmplqi_1_slp */

        case 2:
          if (!
#line 15059 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1043; /* *one_cmplhi_1_slp */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      if (!const_0_to_63_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      x10 = XEXP (x3, 2);
      if (!rtx_equal_p (x10, operands[1])
          || !
#line 19040 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
        return -1;
      *pnum_clobbers = 1;
      return 1415; /* *btcq_imm */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      x13 = XVECEXP (x3, 0, 2);
      operands[3] = x13;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern972 (x2))
                {
                case 0:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3421; /* *avx512f_cmpv16si3 */

                case 1:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3428; /* *avx512vl_cmpv16hf3 */

                case 2:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3430; /* *avx512f_cmpv16sf3 */

                case 3:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3486; /* *avx512vl_cmpv16qi3 */

                case 4:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3492; /* *avx512vl_cmpv16hi3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern973 (x2))
                {
                case 0:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3422; /* *avx512vl_cmpv8si3 */

                case 1:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3423; /* *avx512vl_cmpv4si3 */

                case 2:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3424; /* *avx512f_cmpv8di3 */

                case 3:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3425; /* *avx512vl_cmpv4di3 */

                case 4:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3426; /* *avx512vl_cmpv2di3 */

                case 5:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3429; /* *avx512fp16_cmpv8hf3 */

                case 6:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3431; /* *avx512vl_cmpv8sf3 */

                case 7:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3432; /* *avx512vl_cmpv4sf3 */

                case 8:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3433; /* *avx512f_cmpv8df3 */

                case 9:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3434; /* *avx512vl_cmpv4df3 */

                case 10:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3435; /* *avx512vl_cmpv2df3 */

                case 11:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3494; /* *avx512vl_cmpv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern1072 (x2))
                {
                case 0:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3487; /* *avx512vl_cmpv16qi3 */

                case 1:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3493; /* *avx512vl_cmpv16hi3 */

                case 2:
                  if (!(
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3640; /* *avx512f_ucmpv16si3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern1073 (x2))
                {
                case 0:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3495; /* *avx512vl_cmpv8hi3 */

                case 1:
                  if (!(
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3641; /* *avx512vl_ucmpv8si3 */

                case 2:
                  if (!(
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3642; /* *avx512vl_ucmpv4si3 */

                case 3:
                  if (!(
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3643; /* *avx512f_ucmpv8di3 */

                case 4:
                  if (!(
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3644; /* *avx512vl_ucmpv4di3 */

                case 5:
                  if (!(
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3645; /* *avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_55 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x2, 1);
          if (pattern600 (x7) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (pattern1267 (x1))
            {
            case 0:
              if (!
#line 8248 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8248 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8248 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x11 = XEXP (x1, 0);
      operands[0] = x11;
      switch (pattern289 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1358 (x2, 
E_QImode) != 0
                  || !
#line 9277 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1358 (x2, 
E_HImode) != 0
                  || !
#line 9277 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 488; /* subhi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1272 (x2, 
E_QImode) != 0
                  || !
#line 10230 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1272 (x2, 
E_HImode) != 0
                  || !
#line 10230 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *subhi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern91 (x1))
        {
        case 0:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (pattern974 (x2) != 0)
            return -1;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1511 (x2, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 1058 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()))
                return -1;
              return 2067; /* *mmx_hsubv2sf3_low */

            case E_DFmode:
              if (pattern1511 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_V2DF_REDUCTION_PREFER_HADDPD))
                return -1;
              return 3190; /* *sse3_hsubv2df3_low */

            default:
              return -1;
            }

        case 1:
          switch (pattern854 (x2))
            {
            case 0:
              if (!
#line 22628 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8601; /* ssse3_phsubwv4hi3 */

            case 1:
              if (!
#line 22715 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8608; /* ssse3_phsubdv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1722 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2089; /* *vec_dupv2sf */

        case E_V4HFmode:
          if (!register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 5674 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2344; /* *vec_dupv4hf */

        case E_V4BFmode:
          if (!register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 5674 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2345; /* *vec_dupv4bf */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 5674 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2346; /* *vec_dupv4hi */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2347; /* *vec_dupv2si */

        case E_V2HFmode:
          if (!register_operand (operands[0], E_V2HFmode)
              || GET_MODE (x3) != E_V2HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 6266 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2375; /* *vec_dupv2hf */

        case E_V2BFmode:
          if (!register_operand (operands[0], E_V2BFmode)
              || GET_MODE (x3) != E_V2BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 6266 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2376; /* *vec_dupv2bf */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 6266 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2377; /* *vec_dupv2hi */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 2343; /* *vec_dupv4hi */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !
#line 6256 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2374; /* *vec_dupv2hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern434 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 266; /* *adddi3_doubleword */
            }
          if (x86_64_general_operand (operands[2], E_DImode))
            {
              if ((
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 284; /* *adddi_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 285; /* *adddi_1 */
                }
            }
          break;

        case 1:
          if (
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 282; /* *addsi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            {
              *pnum_clobbers = 1;
              return 283; /* *addsi_1 */
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_SImode)
          || pattern435 (x3, 
22) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!tls_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 23272 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
        return -1;
      return 1664; /* *tls_dynamic_gnu2_lea_32 */

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      switch (pattern277 (x3, pnum_clobbers, 
E_DImode, 
E_SImode))
        {
        case 0:
          if (!(
#line 6511 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* *adddi3_doubleword_zext */

        case 1:
          if (!(
#line 14077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 898; /* *concatsidi3_2 */

        case 2:
          if (!(
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 916; /* *concatsidi3_4 */

        case 3:
          if (!(
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 919; /* *concatsidi3_4 */

        case 4:
          if (!(
#line 14198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 946; /* *concatsidi3_7 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ZERO_EXTEND
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          switch (pattern84 (x3, 
E_DImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 6542 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 270; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6573 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 276; /* *adddi3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x8;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1273 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 455; /* addsi3_carry */

            case E_DImode:
              if (pattern1273 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 456; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1202 (x3, 
E_SImode) != 0
                  || !
#line 10136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 556; /* *addsi3_eq */

            case E_DImode:
              if (pattern1202 (x3, 
E_DImode) != 0
                  || !(
#line 10136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 557; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1203 (x3, 
E_SImode) != 0
                  || !
#line 10157 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 560; /* *addsi3_ne */

            case E_DImode:
              if (pattern1203 (x3, 
E_DImode) != 0
                  || !(
#line 10157 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 561; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 271; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 277; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 272; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 278; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1077 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 459; /* *addsi3_carry_0 */

        case 1:
          if (pattern1077 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 460; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1078 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 463; /* *addsi3_carry_0r */

        case 1:
          if (pattern1078 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 464; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern105 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 564; /* *addsi3_eq_0 */

        case 1:
          if (!(
#line 10183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 565; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern105 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10204 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 568; /* *addsi3_ne_0 */

        case 1:
          if (!(
#line 10204 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 569; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case NE:
          switch (pattern750 (x3))
            {
            case 0:
              if (!
#line 10252 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 576; /* *subsi3_ne */

            case 1:
              if (!(
#line 10252 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 577; /* *subdi3_ne */

            default:
              return -1;
            }

        case EQ:
          switch (pattern750 (x3))
            {
            case 0:
              if (!
#line 10281 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 580; /* *subsi3_eq_1 */

            case 1:
              if (!(
#line 10281 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 581; /* *subdi3_eq_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (pattern257 (x5, 
E_SImode, 
E_DImode))
            {
            case 0:
              if (!(
#line 14060 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 892; /* *concatsidi3_1 */

            case 1:
              if (!(
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 928; /* *concatsidi3_5 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern980 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 904; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 934; /* *concatsidi3_6 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern980 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 907; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 937; /* *concatsidi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern415 (x5, 
E_CCCmode, 
ASHIFT) != 0)
        return -1;
      x12 = XEXP (x5, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      switch (XWINT (x12, 0))
        {
        case 31L:
          if (pattern1451 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1385; /* rcrsi2 */

        case 63L:
          if (pattern1451 (x3, 
E_DImode) != 0
              || !
#line 18754 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1386; /* rcrdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x13 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 7)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 6)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (!tls_symbolic_operand (x7, E_VOIDmode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 21:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x14 = XVECEXP (x4, 0, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x15 = XVECEXP (x4, 0, 1);
              operands[2] = x15;
              if (!constant_call_address_operand (operands[2], E_VOIDmode)
                  || GET_MODE (x13) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || GET_MODE (x6) != E_SImode)
                return -1;
              operands[3] = x7;
              *pnum_clobbers = 3;
              return 1657; /* *tls_local_dynamic_32_once */

            case 22:
              x14 = XVECEXP (x4, 0, 0);
              operands[2] = x14;
              if (!tls_modbase_operand (operands[2], E_VOIDmode))
                return -1;
              x15 = XVECEXP (x4, 0, 1);
              operands[3] = x15;
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern1635 (x3, 
E_SImode) != 0
                      || !(
#line 23365 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1671; /* *tls_dynamic_gnu2_combine_64_si */

                case E_DImode:
                  if (pattern1635 (x3, 
E_DImode) != 0
                      || !(
#line 23365 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1672; /* *tls_dynamic_gnu2_combine_64_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 19)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern752 (x3))
            {
            case 0:
              if (!
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1661; /* *add_tp_si */

            case 1:
              if (!
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1662; /* *add_tp_di */

            default:
              return -1;
            }

        case 4:
          if (XINT (x4, 1) != 22
              || GET_MODE (x4) != E_SImode)
            return -1;
          x16 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 7
              || GET_MODE (x16) != E_SImode
              || pattern435 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[3] = x14;
          if (!tls_modbase_operand (operands[3], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[4] = x15;
          x13 = XVECEXP (x4, 0, 2);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[1] = x7;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 23306 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          *pnum_clobbers = 1;
          return 1666; /* *tls_dynamic_gnu2_combine_32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern618 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 10604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF))
            return 592; /* *mulsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 10604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 593; /* *mulsi3_1 */

        case E_DImode:
          if (pattern618 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 10604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 594; /* *muldi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 10604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 595; /* *muldi3_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
ZERO_EXTEND) != 0
          || !(
#line 10994 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 617; /* *umulsidi3_1 */

    case SIGN_EXTEND:
      if (pattern114 (x3, 
SIGN_EXTEND) != 0)
        return -1;
      if ((
#line 11040 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 619; /* *mulsidi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 11040 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 620; /* *mulsidi3_1 */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern762 (x3, 
E_SImode) != 0
              || !
#line 13607 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 836; /* *notxorsi_1 */

        case E_DImode:
          if (pattern762 (x3, 
E_DImode) != 0
              || !(
#line 13607 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 837; /* *notxordi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern115 (x3))
        {
        case 0:
          if ((
#line 14976 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 1030; /* *one_cmpldi2_doubleword */
          if (!(
#line 14989 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1034; /* *one_cmpldi2_1 */

        case 1:
          if (!
#line 14989 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 1033; /* *one_cmplsi2_1 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      switch (XINT (x4, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern988 (x3))
                {
                case 0:
                  if (!(
#line 4468 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return -1;
                  return 3427; /* *avx512bw_cmpv32hf3 */

                case 1:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3488; /* *avx512vl_cmpv32qi3 */

                case 2:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3490; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            case E_DImode:
              if (pattern989 (x3) != 0
                  || !(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3484; /* *avx512bw_cmpv64qi3 */

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1089 (x3, 
E_V64QImode, 
E_DImode) != 0
                  || !(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3485; /* *avx512bw_cmpv64qi3 */

            case E_SImode:
              switch (pattern1090 (x3))
                {
                case 0:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3489; /* *avx512vl_cmpv32qi3 */

                case 1:
                  if (!(
#line 4563 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3491; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[2], E_SImode))
    {
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (register_operand (operands[0], E_SImode))
        {
          x3 = XEXP (x1, 1);
          if (GET_MODE (x3) == E_SImode
              && nonimmediate_operand (operands[1], E_SImode)
              && 
#line 17313 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return 1171; /* *bmi2_lshrsi3_1 */
        }
    }
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (pnum_clobbers != NULL
          && register_operand (operands[1], E_DImode)
          && nonmemory_operand (operands[2], E_QImode)
          && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
        {
          *pnum_clobbers = 1;
          return 1130; /* lshrdi3_doubleword */
        }
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode)
          || !(
#line 17313 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1173; /* *bmi2_lshrdi3_1 */

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (pattern623 (x3, 
E_SImode) != 0)
        return -1;
      if (
#line 17385 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 1180; /* *lshrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17385 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 1181; /* *lshrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern20 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18182 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1296; /* *rotlsi3_mask_1 */

    case 1:
      if (!(
#line 18182 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1298; /* *rotldi3_mask_1 */

    case 2:
      if (!
#line 18253 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1312; /* *rotlsi3_add_1 */

    case 3:
      if (!(
#line 18253 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1314; /* *rotldi3_add_1 */

    case 4:
      if (!
#line 18322 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1328; /* *rotlsi3_sub_1 */

    case 5:
      if (!(
#line 18322 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1330; /* *rotldi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern448 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 18142 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1288; /* *rotlsi3_mask */
                }
              break;

            case 1:
              if ((
#line 18142 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1290; /* *rotldi3_mask */
                }
              break;

            case 2:
              if (
#line 18217 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1304; /* *rotlsi3_add */
                }
              break;

            case 3:
              if ((
#line 18217 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1306; /* *rotldi3_add */
                }
              break;

            case 4:
              if (
#line 18286 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1320; /* *rotlsi3_sub */
                }
              break;

            case 5:
              if ((
#line 18286 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1322; /* *rotldi3_sub */
                }
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          if (pnum_clobbers != NULL)
            {
              operands[2] = x3;
              if (const_1_to_31_operand (operands[2], E_QImode)
                  && register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && register_operand (operands[1], E_DImode)
                  && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 2;
                  return 1332; /* ix86_rotldi3_doubleword */
                }
            }
          if (XWINT (x3, 0) == 32L
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode)
              && 
#line 18427 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return 1336; /* rotl32di2_doubleword */
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern16 (x2))
        {
        case 0:
          if (
#line 18478 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1342; /* *rotlsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18478 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1343; /* *rotlsi3_1 */

        case 1:
          if ((
#line 18478 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1346; /* *rotldi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 18478 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1347; /* *rotldi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_109 (x1, insn, pnum_clobbers);

    case 1:
      return recog_108 (x1, insn, pnum_clobbers);

    case 4:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 7
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      switch (XINT (x2, 1))
        {
        case 20:
          if (!register_operand (operands[1], E_SImode)
              || !tls_symbolic_operand (operands[2], E_VOIDmode)
              || !constant_call_address_operand (operands[3], E_VOIDmode)
              || !
#line 22933 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU_TLS))
            return -1;
          *pnum_clobbers = 3;
          return 1649; /* *tls_global_dynamic_32_gnu */

        case 22:
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode)
              || !
#line 23288 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          *pnum_clobbers = 1;
          return 1665; /* *tls_dynamic_gnu2_call_32 */

        default:
          return -1;
        }

    case 3:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (XINT (x2, 1))
        {
        case 21:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_SImode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 7
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!constant_call_address_operand (operands[2], E_VOIDmode)
              || !
#line 23053 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU_TLS))
            return -1;
          *pnum_clobbers = 3;
          return 1653; /* *tls_local_dynamic_base_32_gnu */

        case 22:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 7)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1207 (x2, 
E_SImode) != 0
                  || !(
#line 23348 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 1669; /* *tls_dynamic_gnu2_call_64_si */

            case E_DImode:
              if (pattern1207 (x2, 
E_DImode) != 0
                  || !(
#line 23348 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return -1;
              *pnum_clobbers = 1;
              return 1670; /* *tls_dynamic_gnu2_call_64_di */

            default:
              return -1;
            }

        case 59:
          x5 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x5;
              x7 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x7) != CONST_INT)
                return -1;
              operands[3] = x7;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              switch (pattern23 (x2))
                {
                case 0:
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V32HFmode:
                      if (register_operand (operands[1], E_V32HFmode)
                          && nonimmediate_operand (operands[2], E_V32HFmode)
                          && const_0_to_31_operand (operands[3], E_SImode)
                          && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                        return 3301; /* avx512bw_cmpv32hf3 */
                      break;

                    case E_V32QImode:
                      if (register_operand (operands[1], E_V32QImode)
                          && nonimmediate_operand (operands[2], E_V32QImode)
                          && const_0_to_7_operand (operands[3], E_SImode)
                          && (
#line 4486 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3440; /* avx512vl_cmpv32qi3 */
                      break;

                    case E_V32HImode:
                      if (register_operand (operands[1], E_V32HImode)
                          && nonimmediate_operand (operands[2], E_V32HImode)
                          && const_0_to_7_operand (operands[3], E_SImode)
                          && (
#line 4486 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3442; /* avx512bw_cmpv32hi3 */
                      break;

                    case E_V32BFmode:
                      if (register_operand (operands[1], E_V32BFmode)
                          && nonimmediate_operand (operands[2], E_V32BFmode)
                          && const_0_to_31_operand (operands[3], E_VOIDmode)
                          && (
#line 32459 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                        return 10729; /* avx10_2_cmpbf16_v32bf */
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (register_operand (operands[1], E_V64QImode)
                      && nonimmediate_operand (operands[2], E_V64QImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4486 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 3436; /* avx512bw_cmpv64qi3 */
                  break;

                default:
                  break;
                }
              if (XWINT (x7, 0) != 0L)
                return -1;
              operands[2] = x6;
              switch (pattern990 (x2))
                {
                case 0:
                  if (!(
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3496; /* *avx512bw_eqv64qi3_1 */

                case 1:
                  if (!(
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3504; /* *avx512vl_eqv32qi3_1 */

                case 2:
                  if (!(
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3508; /* *avx512bw_eqv32hi3_1 */

                default:
                  return -1;
                }

            case US_MINUS:
              switch (pattern453 (x2))
                {
                case 0:
                  if (!(
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3646; /* *avx512bw_ucmpv64qi3_1 */

                case 1:
                  if (!(
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3650; /* *avx512vl_ucmpv32qi3_1 */

                case 2:
                  if (!(
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3652; /* *avx512bw_ucmpv32hi3_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 157:
          x5 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x5;
              x7 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x7) != CONST_INT)
                return -1;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              if (XWINT (x7, 0) == 0L)
                {
                  switch (pattern990 (x2))
                    {
                    case 0:
                      if ((
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3498; /* *avx512bw_eqv64qi3_1 */
                      break;

                    case 1:
                      if ((
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3506; /* *avx512vl_eqv32qi3_1 */
                      break;

                    case 2:
                      if ((
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3510; /* *avx512bw_eqv32hi3_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              switch (pattern298 (x2))
                {
                case 0:
                  if (!(
#line 4596 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3520; /* avx512bw_ucmpv64qi3 */

                case 1:
                  if (!(
#line 4596 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3524; /* avx512vl_ucmpv32qi3 */

                case 2:
                  if (!(
#line 4596 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3526; /* avx512bw_ucmpv32hi3 */

                default:
                  return -1;
                }

            case US_MINUS:
              switch (pattern453 (x2))
                {
                case 0:
                  if (!(
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3647; /* *avx512bw_ucmpv64qi3_1 */

                case 1:
                  if (!(
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3651; /* *avx512vl_ucmpv32qi3_1 */

                case 2:
                  if (!(
#line 4788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3653; /* *avx512bw_ucmpv32hi3_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          if (pattern301 (x2) != 0
              || !
#line 23283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 8650; /* ssse3_palignrdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern998 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 7043; /* avx512bw_getexpv32hf_mask */

    case E_V16HFmode:
      if (pattern998 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 7047; /* avx512vl_getexpv16hf_mask */

    case E_V8HFmode:
      if (pattern998 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 7050; /* avx512fp16_getexpv8hf_mask */

    case E_V16SFmode:
      if (pattern998 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7053; /* avx512f_getexpv16sf_mask */

    case E_V8SFmode:
      if (pattern998 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7057; /* avx512vl_getexpv8sf_mask */

    case E_V4SFmode:
      if (pattern998 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7060; /* avx512vl_getexpv4sf_mask */

    case E_V8DFmode:
      if (pattern998 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7063; /* avx512f_getexpv8df_mask */

    case E_V4DFmode:
      if (pattern998 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7067; /* avx512vl_getexpv4df_mask */

    case E_V2DFmode:
      if (pattern998 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7070; /* avx512vl_getexpv2df_mask */

    case E_V32BFmode:
      if (pattern626 (x2, 
E_V32BFmode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32418 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10700; /* avx10_2_getexpbf16_v32bf_mask */

    case E_V16BFmode:
      if (pattern626 (x2, 
E_V16BFmode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32418 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 10702; /* avx10_2_getexpbf16_v16bf_mask */

    case E_V8BFmode:
      if (pattern626 (x2, 
E_V8BFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32418 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 10704; /* avx10_2_getexpbf16_v8bf_mask */

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[5] = x7;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern471 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10943; /* avx10_2_minmaxpv32hf_mask */

        case E_V16HFmode:
          if (pattern471 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10947; /* avx10_2_minmaxpv16hf_mask */

        case E_V8HFmode:
          if (pattern471 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10951; /* avx10_2_minmaxpv8hf_mask */

        case E_V16SFmode:
          if (pattern471 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10955; /* avx10_2_minmaxpv16sf_mask */

        case E_V8SFmode:
          if (pattern471 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10959; /* avx10_2_minmaxpv8sf_mask */

        case E_V4SFmode:
          if (pattern471 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10963; /* avx10_2_minmaxpv4sf_mask */

        case E_V8DFmode:
          if (pattern471 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 533 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10967; /* avx10_2_minmaxpv8df_mask */

        case E_V4DFmode:
          if (pattern471 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10971; /* avx10_2_minmaxpv4df_mask */

        case E_V2DFmode:
          if (pattern471 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10975; /* avx10_2_minmaxpv2df_mask */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x7, 0) != 1L)
        return -1;
      switch (pattern456 (x2))
        {
        case 0:
          if (!(
#line 32663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 10977; /* avx10_2_minmaxsv8hf */

        case 1:
          if (!
#line 32663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10981; /* avx10_2_minmaxsv4sf */

        case 2:
          if (!(
#line 32663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 10985; /* avx10_2_minmaxsv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[4] = x7;
  x8 = XEXP (x2, 2);
  operands[5] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern476 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7084; /* avx512f_alignv16si_mask */

    case E_V8SImode:
      if (pattern476 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7086; /* avx512vl_alignv8si_mask */

    case E_V4SImode:
      if (pattern476 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7088; /* avx512vl_alignv4si_mask */

    case E_V8DImode:
      if (pattern476 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7090; /* avx512f_alignv8di_mask */

    case E_V4DImode:
      if (pattern476 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7092; /* avx512vl_alignv4di_mask */

    case E_V2DImode:
      if (pattern476 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14069 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7094; /* avx512vl_alignv2di_mask */

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      switch (XINT (x4, 1))
        {
        case 54:
          if (pattern1286 (x2) != 0
              || !(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2978 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2892; /* avx512fp16_vmrcpv8hf2_mask */

        case 161:
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1371 (x2, 
E_V4SFmode) != 0
                  || !
#line 3034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2908; /* srcp14v4sf_mask */

            case E_V2DFmode:
              if (pattern1371 (x2, 
E_V2DFmode) != 0
                  || !(
#line 3034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2909; /* srcp14v2df_mask */

            default:
              return -1;
            }

        case 162:
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1371 (x2, 
E_V4SFmode) != 0
                  || !
#line 3188 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2986; /* rsqrt14_v4sf_mask */

            case E_V2DFmode:
              if (pattern1371 (x2, 
E_V2DFmode) != 0
                  || !(
#line 3188 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2987; /* rsqrt14_v2df_mask */

            default:
              return -1;
            }

        case 55:
          if (pattern1286 (x2) != 0
              || !(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2991; /* avx512fp16_vmrsqrtv8hf2_mask */

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XINT (x4, 1))
        {
        case 63:
          switch (pattern768 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3158; /* avx512fp16_ieee_vmmaxv8hf3_mask */

            case 1:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3485 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 3166; /* sse_ieee_vmmaxv4sf3_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3174; /* sse2_ieee_vmmaxv2df3_mask */

            default:
              return -1;
            }

        case 62:
          switch (pattern768 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3162; /* avx512fp16_ieee_vmminv8hf3_mask */

            case 1:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3485 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 3170; /* sse_ieee_vmminv4sf3_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3485 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3178; /* sse2_ieee_vmminv2df3_mask */

            default:
              return -1;
            }

        case 221:
          if (pattern769 (x2) != 0
              || !(
#line 412 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7522 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4416; /* avx512fp16_fmulcsh_v8hf_mask */

        case 222:
          if (pattern769 (x2) != 0
              || !(
#line 412 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7522 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4420; /* avx512fp16_fcmulcsh_v8hf_mask */

        case 58:
          switch (pattern768 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13625 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 5423; /* avx512f_vmscalefv8hf_mask */

            case 1:
              if (!
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 5427; /* avx512f_vmscalefv4sf_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13625 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 5431; /* avx512f_vmscalefv2df_mask */

            default:
              return -1;
            }

        case 165:
          switch (pattern768 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14058 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 7072; /* avx512f_sgetexpv8hf_mask */

            case 1:
              if (!
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 7076; /* avx512f_sgetexpv4sf_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14058 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 7080; /* avx512f_sgetexpv2df_mask */

            default:
              return -1;
            }

        case 94:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          x10 = XVECEXP (x4, 0, 1);
          operands[3] = x10;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          x8 = XEXP (x3, 2);
          operands[5] = x8;
          if (!register_operand (operands[5], E_QImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1541 (x2, 
E_V8HFmode) != 0
                  || !(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14252 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 7176; /* avx512f_rndscalev8hf_mask */

            case E_V4SFmode:
              if (pattern1541 (x2, 
E_V4SFmode) != 0
                  || !
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 7180; /* avx512f_rndscalev4sf_mask */

            case E_V2DFmode:
              if (pattern1541 (x2, 
E_V2DFmode) != 0
                  || !(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14252 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 7184; /* avx512f_rndscalev2df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x4, 0, 2);
      operands[3] = x11;
      switch (XINT (x4, 1))
        {
        case 192:
          switch (pattern1108 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4040 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3226; /* reducesv8hf_mask */

            case 1:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4040 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode)))))
                return -1;
              return 3230; /* reducesv4sf_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4040 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3234; /* reducesv2df_mask */

            default:
              return -1;
            }

        case 217:
          switch (pattern1109 (x2))
            {
            case 0:
              if (!(
#line 394 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7487 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4403; /* avx512fp16_fma_fmaddcsh_v8hf_maskz */

            case 1:
              if (!
#line 7507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4410; /* avx512fp16_fmaddcsh_v8hf_mask */

            default:
              return -1;
            }

        case 219:
          switch (pattern1109 (x2))
            {
            case 0:
              if (!(
#line 394 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7487 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4407; /* avx512fp16_fma_fcmaddcsh_v8hf_maskz */

            case 1:
              if (!
#line 7507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4412; /* avx512fp16_fcmaddcsh_v8hf_mask */

            default:
              return -1;
            }

        case 194:
          if (XWINT (x5, 0) != 1L
              || !const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          x8 = XEXP (x3, 2);
          operands[5] = x8;
          if (!register_operand (operands[5], E_QImode))
            return -1;
          x9 = XEXP (x2, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1106 (x2, 
E_V4SFmode) != 0
                  || !(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29848 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 9984; /* avx512dq_rangesv4sf_mask */

            case E_V2DFmode:
              if (pattern1106 (x2, 
E_V2DFmode) != 0
                  || !(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29848 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 9988; /* avx512dq_rangesv2df_mask */

            default:
              return -1;
            }

        case 166:
          if (XWINT (x5, 0) != 1L
              || !const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1107 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29916 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 10046; /* avx512f_vgetmantv8hf_mask */

            case 1:
              if (!
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 10050; /* avx512f_vgetmantv4sf_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29916 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 10054; /* avx512f_vgetmantv2df_mask */

            default:
              return -1;
            }

        case 278:
          switch (pattern1108 (x2))
            {
            case 0:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 10978; /* avx10_2_minmaxsv8hf_mask */

            case 1:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10982; /* avx10_2_minmaxsv4sf_mask */

            case 2:
              if (!(
#line 378 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 10986; /* avx10_2_minmaxsv2df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (XINT (x4, 1) != 163)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x4, 0, 2);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 3);
      operands[4] = x12;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[5] = x7;
          x5 = XEXP (x2, 2);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x3, 2);
          operands[6] = x8;
          if (!register_operand (operands[6], E_QImode))
            return -1;
          x9 = XEXP (x2, 1);
          if (!rtx_equal_p (x9, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1636 (x2, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 154 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 7135; /* avx512f_sfixupimmv4sf_maskz_1 */

            case E_V2DFmode:
              if (pattern1636 (x2, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !(
#line 154 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14207 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 7139; /* avx512f_sfixupimmv2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          x8 = XEXP (x3, 2);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XEXP (x2, 2);
          operands[5] = x5;
          if (!register_operand (operands[5], E_QImode))
            return -1;
          x9 = XEXP (x2, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1637 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !
#line 14226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 7141; /* avx512f_sfixupimmv4sf_mask */

            case E_V2DFmode:
              if (pattern1637 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !(
#line 14226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 7143; /* avx512f_sfixupimmv2df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x3;
      x4 = XEXP (x2, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[5] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1389 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && nonimmediate_operand (operands[2], E_V4SFmode)
                  && nonimmediate_operand (operands[3], E_V4SFmode)
                  && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 4012; /* *fma_fnmsub_v4sf */
              if (!bcst_vector_operand (operands[1], E_V4SFmode)
                  || !bcst_vector_operand (operands[2], E_V4SFmode)
                  || !bcst_vector_operand (operands[3], E_V4SFmode)
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4048; /* fma_fnmsub_v4sf_maskz_1 */

            case E_V2DFmode:
              if (pattern1389 (x2, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && nonimmediate_operand (operands[2], E_V2DFmode)
                  && nonimmediate_operand (operands[3], E_V2DFmode)
                  && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 4016; /* *fma_fnmsub_v2df */
              if (!bcst_vector_operand (operands[1], E_V2DFmode)
                  || !bcst_vector_operand (operands[2], E_V2DFmode)
                  || !bcst_vector_operand (operands[3], E_V2DFmode)
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4059; /* fma_fnmsub_v2df_maskz_1 */

            case E_V8SFmode:
              if (pattern1389 (x2, 
E_V8SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 4020; /* *fma_fnmsub_v8sf */
              if (!bcst_vector_operand (operands[1], E_V8SFmode)
                  || !bcst_vector_operand (operands[2], E_V8SFmode)
                  || !bcst_vector_operand (operands[3], E_V8SFmode)
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4044; /* fma_fnmsub_v8sf_maskz_1 */

            case E_V4DFmode:
              if (pattern1389 (x2, 
E_V4DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 4024; /* *fma_fnmsub_v4df */
              if (!bcst_vector_operand (operands[1], E_V4DFmode)
                  || !bcst_vector_operand (operands[2], E_V4DFmode)
                  || !bcst_vector_operand (operands[3], E_V4DFmode)
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4055; /* fma_fnmsub_v4df_maskz_1 */

            case E_V32HFmode:
              if (pattern1390 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5927 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4028; /* fma_fnmsub_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1390 (x2, 
E_HImode, 
E_V16HFmode) != 0
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4032; /* fma_fnmsub_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1390 (x2, 
E_QImode, 
E_V8HFmode) != 0
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5929 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4036; /* fma_fnmsub_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1390 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4040; /* fma_fnmsub_v16sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1390 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4051; /* fma_fnmsub_v8df_maskz_1 */

            case E_V32BFmode:
              if (pattern1391 (x2, 
E_SImode, 
E_V32BFmode) != 0
                  || !(
#line 32342 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10670; /* avx10_2_fnmsubbf16_v32bf_maskz_1 */

            case E_V16BFmode:
              if (pattern1391 (x2, 
E_HImode, 
E_V16BFmode) != 0
                  || !
#line 32342 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10672; /* avx10_2_fnmsubbf16_v16bf_maskz_1 */

            case E_V8BFmode:
              if (pattern1391 (x2, 
E_QImode, 
E_V8BFmode) != 0
                  || !
#line 32342 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10674; /* avx10_2_fnmsubbf16_v8bf_maskz_1 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1392 (x2, 
E_V4SFmode) != 0
                  || !
#line 7004 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA4))
                return -1;
              return 4326; /* *fma4i_vmfnmsub_v4sf */

            case E_V2DFmode:
              if (pattern1392 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7004 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 4327; /* *fma4i_vmfnmsub_v2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern636 (x2))
        {
        case 0:
          if (pattern1299 (x2, 
E_V32HFmode, 
E_SImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V32HFmode)
              && vector_operand (operands[3], E_V32HFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 4060; /* avx512bw_fnmsub_v32hf_mask */
          if (!vector_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[3], E_V32HFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4075; /* avx512bw_fnmsub_v32hf_mask3 */

        case 1:
          if (pattern1299 (x2, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16HFmode)
              && vector_operand (operands[3], E_V16HFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 4062; /* avx512vl_fnmsub_v16hf_mask */
          if (!vector_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[3], E_V16HFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4077; /* avx512vl_fnmsub_v16hf_mask3 */

        case 2:
          if (pattern1299 (x2, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8HFmode)
              && vector_operand (operands[3], E_V8HFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 4064; /* avx512fp16_fnmsub_v8hf_mask */
          if (!vector_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[3], E_V8HFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4079; /* avx512fp16_fnmsub_v8hf_mask3 */

        case 3:
          if (pattern1299 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16SFmode)
              && vector_operand (operands[3], E_V16SFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 4065; /* avx512f_fnmsub_v16sf_mask */
          if (!vector_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[3], E_V16SFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4080; /* avx512f_fnmsub_v16sf_mask3 */

        case 4:
          if (pattern1299 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && vector_operand (operands[3], E_V8SFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4067; /* avx512vl_fnmsub_v8sf_mask */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[3], E_V8SFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4082; /* avx512vl_fnmsub_v8sf_mask3 */

        case 5:
          if (pattern1299 (x2, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && vector_operand (operands[3], E_V4SFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4069; /* avx512vl_fnmsub_v4sf_mask */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[3], E_V4SFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4084; /* avx512vl_fnmsub_v4sf_mask3 */

        case 6:
          if (pattern1299 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8DFmode)
              && vector_operand (operands[3], E_V8DFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 4070; /* avx512f_fnmsub_v8df_mask */
          if (!vector_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[3], E_V8DFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4085; /* avx512f_fnmsub_v8df_mask3 */

        case 7:
          if (pattern1299 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && vector_operand (operands[3], E_V4DFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4072; /* avx512vl_fnmsub_v4df_mask */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[3], E_V4DFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4087; /* avx512vl_fnmsub_v4df_mask3 */

        case 8:
          if (pattern1299 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && vector_operand (operands[3], E_V2DFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4074; /* avx512vl_fnmsub_v2df_mask */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[3], E_V2DFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4089; /* avx512vl_fnmsub_v2df_mask3 */

        case 9:
          if (pattern1300 (x2, 
E_SImode, 
E_V32BFmode) != 0)
            return -1;
          if (rtx_equal_p (x3, operands[1])
              && (
#line 32362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return 10675; /* avx10_2_fnmsubbf16_v32bf_mask */
          if (!rtx_equal_p (x3, operands[3])
              || !(
#line 32381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10678; /* avx10_2_fnmsubbf16_v32bf_mask3 */

        case 10:
          if (pattern1300 (x2, 
E_HImode, 
E_V16BFmode) != 0)
            return -1;
          if (rtx_equal_p (x3, operands[1])
              && 
#line 32362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return 10676; /* avx10_2_fnmsubbf16_v16bf_mask */
          if (!rtx_equal_p (x3, operands[3])
              || !
#line 32381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10679; /* avx10_2_fnmsubbf16_v16bf_mask3 */

        case 11:
          if (pattern1300 (x2, 
E_QImode, 
E_V8BFmode) != 0)
            return -1;
          if (rtx_equal_p (x3, operands[1])
              && 
#line 32362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return 10677; /* avx10_2_fnmsubbf16_v8bf_mask */
          if (!rtx_equal_p (x3, operands[3])
              || !
#line 32381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10680; /* avx10_2_fnmsubbf16_v8bf_mask3 */

        case 12:
          if (pattern1393 (x2, 
E_V8HFmode) != 0
              || !(
#line 6651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4242; /* *fmai_fnmsub_v8hf */

        case 13:
          if (pattern1393 (x2, 
E_V4SFmode) != 0
              || !
#line 6651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
            return -1;
          return 4244; /* *fmai_fnmsub_v4sf */

        case 14:
          if (pattern1393 (x2, 
E_V2DFmode) != 0
              || !(
#line 6651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4246; /* *fmai_fnmsub_v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  if (const_0_to_7_operand (operands[2], E_VOIDmode))
    {
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      if (const_0_to_7_operand (operands[3], E_VOIDmode))
        {
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          if (register_operand (operands[5], E_QImode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1546 (x2, 
E_V2DFmode, 
E_V8DFmode) == 0
                      && (
#line 12448 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && INTVAL (operands[2]) % 2 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[4]))) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5341; /* avx512dq_vextractf64x2_1_mask */
                  break;

                case E_V2DImode:
                  if (pattern1546 (x2, 
E_V2DImode, 
E_V8DImode) == 0
                      && (
#line 12448 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && INTVAL (operands[2]) % 2 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[4]))) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5342; /* avx512dq_vextracti64x2_1_mask */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 0L:
      if (XWINT (x6, 0) != 1L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!nonimmediate_operand (operands[0], E_V2DImode)
              || pattern1547 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 12878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5365; /* vec_extract_lo_v4di_mask */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[0], E_V2DFmode)
              || pattern1547 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 12878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5366; /* vec_extract_lo_v4df_mask */

        default:
          return -1;
        }

    case 2L:
      if (XWINT (x6, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!nonimmediate_operand (operands[0], E_V2DImode)
              || pattern1547 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 12915 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5369; /* vec_extract_hi_v4di_mask */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[0], E_V2DFmode)
              || pattern1547 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 12915 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 5370; /* vec_extract_hi_v4df_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) == CONST_INT)
    {
      res = recog_170 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x5;
  res = recog_172 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 0L
      || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern1302 (x2, 
E_V8HImode) != 0
      || pattern1548 (x4) != 0)
    return -1;
  x9 = XEXP (x2, 1);
  operands[6] = x9;
  if (!nonimm_or_0_operand (operands[6], E_V8HImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[7] = x10;
  if (!register_operand (operands[7], E_QImode)
      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 21016 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512BW && TARGET_AVX512VL)))
    return -1;
  return 8458; /* sse2_pshufhw_1_mask */
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  res = recog_175 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern1303 (x4, 
11, 
10, 
9, 
8) != 0
      || pattern755 (x2, 
E_V16HImode) != 0
      || pattern1548 (x4) != 0)
    return -1;
  x9 = XVECEXP (x4, 0, 12);
  operands[6] = x9;
  if (!const_12_to_15_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x4, 0, 13);
  operands[7] = x10;
  if (!const_12_to_15_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x4, 0, 14);
  operands[8] = x11;
  if (!const_12_to_15_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x4, 0, 15);
  operands[9] = x12;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode))
    return -1;
  x13 = XEXP (x2, 1);
  operands[10] = x13;
  if (!nonimm_or_0_operand (operands[10], E_V16HImode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[11] = x14;
  if (!register_operand (operands[11], E_HImode)
      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20950 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2
   && TARGET_AVX512BW && TARGET_AVX512VL
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9]))))
    return -1;
  return 8456; /* avx2_pshufhw_1_mask */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern1119 (x2, 
E_HImode, 
E_V16QImode, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8306; /* sse2_packsswb_mask */

        case E_V8HImode:
          if (pattern1119 (x2, 
E_QImode, 
E_V8HImode, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19319 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8312; /* sse2_packssdw_mask */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT)
        return -1;
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != PARALLEL)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (XVECLEN (x10, 0))
        {
        case 8:
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x12 = XVECEXP (x10, 0, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
            return -1;
          x13 = XVECEXP (x10, 0, 2);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 10]
              || pattern1413 (x10, 
15, 
14, 
13, 
12, 
11) != 0
              || !register_operand (operands[4], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1517 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20108 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8402; /* vec_set_lo_v16sf_mask */

            case E_V16SImode:
              if (pattern1517 (x2, 
E_V16SImode, 
E_V8SImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20108 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8404; /* vec_set_lo_v16si_mask */

            default:
              return -1;
            }

        case 4:
          if (pattern1215 (x10, 
7, 
6, 
5, 
4) != 0
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1517 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20140 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8410; /* vec_set_lo_v8df_mask */

            case E_V8DImode:
              if (pattern1517 (x2, 
E_V8DImode, 
E_V4DImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20140 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8412; /* vec_set_lo_v8di_mask */

            case E_V8SImode:
              if (pattern1517 (x2, 
E_V8SImode, 
E_V4SImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28494 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9474; /* vec_set_lo_v8si_mask */

            case E_V8SFmode:
              if (pattern1517 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28494 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9476; /* vec_set_lo_v8sf_mask */

            default:
              return -1;
            }

        case 2:
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x10, 0, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern1517 (x2, 
E_V4DImode, 
E_V2DImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28445 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 9466; /* vec_set_lo_v4di_mask */

            case E_V4DFmode:
              if (pattern1517 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28445 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 9468; /* vec_set_lo_v4df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (XVECLEN (x14, 0))
        {
        case 8:
          if (pattern639 (x14) != 0)
            return -1;
          x15 = XVECEXP (x14, 0, 4);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x16 = XVECEXP (x14, 0, 5);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x17 = XVECEXP (x14, 0, 6);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x18 = XVECEXP (x14, 0, 7);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[4], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1471 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20125 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8406; /* vec_set_hi_v16sf_mask */

            case E_V16SImode:
              if (pattern1471 (x2, 
E_V16SImode, 
E_V8SImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20125 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8408; /* vec_set_hi_v16si_mask */

            default:
              return -1;
            }

        case 4:
          if (pattern639 (x14) != 0
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1471 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20155 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8414; /* vec_set_hi_v8df_mask */

            case E_V8DImode:
              if (pattern1471 (x2, 
E_V8DImode, 
E_V4DImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20155 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8416; /* vec_set_hi_v8di_mask */

            case E_V8SImode:
              if (pattern1471 (x2, 
E_V8SImode, 
E_V4SImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28517 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9478; /* vec_set_hi_v8si_mask */

            case E_V8SFmode:
              if (pattern1471 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28517 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9480; /* vec_set_hi_v8sf_mask */

            default:
              return -1;
            }

        case 2:
          x19 = XVECEXP (x14, 0, 0);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x14, 0, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern1471 (x2, 
E_V4DImode, 
E_V2DImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28469 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 9470; /* vec_set_hi_v4di_mask */

            case E_V4DFmode:
              if (pattern1471 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28469 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512DQ)))
                return -1;
              return 9472; /* vec_set_hi_v4df_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 150
          || GET_MODE (x4) != E_V4HImode
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x21 = XVECEXP (x4, 0, 0);
      operands[1] = x21;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x22 = XVECEXP (x4, 0, 1);
      operands[2] = x22;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const0_operand (operands[3], E_V4HImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      if (!nonimm_or_0_operand (operands[4], E_V8HImode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[5] = x9;
      if (!register_operand (operands[5], E_QImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL) && TARGET_AVX512VL)))
        return -1;
      return 9663; /* *vcvtps2ph_mask */

    case FLOAT_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      x9 = XEXP (x2, 2);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1121 (x2, 
E_SImode, 
E_V32BFmode, 
E_V16SFmode, 
E_V16BFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31022 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10342; /* avx512f_cvtne2ps2bf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern1121 (x2, 
E_HImode, 
E_V16BFmode, 
E_V8SFmode, 
E_V8BFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31022 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10344; /* avx512f_cvtne2ps2bf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern1121 (x2, 
E_QImode, 
E_V8BFmode, 
E_V4SFmode, 
E_V4BFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31022 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10346; /* avx512f_cvtne2ps2bf16_v8bf_mask */

        case E_V32HFmode:
          if (pattern1122 (x2, 
E_SImode, 
E_V32HFmode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10442; /* avx10_2_cvt2ps2phx_v32hf_mask */

        case E_V16HFmode:
          if (pattern1122 (x2, 
E_HImode, 
E_V16HFmode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1)))
            return -1;
          return 10446; /* avx10_2_cvt2ps2phx_v16hf_mask */

        case E_V8HFmode:
          if (pattern1122 (x2, 
E_QImode, 
E_V8HFmode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1)))
            return -1;
          return 10449; /* avx10_2_cvt2ps2phx_v8hf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern773 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4716; /* avx512fp16_float_extend_phv8df2_mask */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10234 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 467 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 5192; /* avx512f_cvtps2pd512_mask */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern774 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16HFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4720; /* avx512fp16_float_extend_phv16sf2_mask */

        case E_V8SFmode:
          if (pattern774 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8HFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4724; /* avx512fp16_float_extend_phv8sf2_mask */

        case E_V4DFmode:
          if (pattern773 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8070 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4733; /* *avx512fp16_float_extend_phv4df2_load_mask */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10234 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL) && 1)))
                return -1;
              return 5196; /* avx_cvtps2pd256_mask */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern148 (x2, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8070 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4735; /* *avx512fp16_float_extend_phv4sf2_load_mask */

        case E_V2DFmode:
          if (pattern773 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8109 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4739; /* *avx512fp16_float_extend_phv2df2_load_mask */

            case E_V2SFmode:
              if (!memory_operand (operands[1], E_V2SFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10416 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                return -1;
              return 5245; /* sse2_cvtps2pd_mask_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL)
        return -1;
      switch (XVECLEN (x7, 0))
        {
        case 4:
          if (pattern639 (x7) != 0
              || GET_MODE (x4) != E_V4HFmode)
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          x6 = XEXP (x2, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern135 (x2, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1)))
                return -1;
              return 4728; /* avx512fp16_float_extend_phv4df2_mask */

            case E_V4SFmode:
              if (pattern135 (x2, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1)))
                return -1;
              return 4731; /* avx512fp16_float_extend_phv4sf2_mask */

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x7, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x7, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          x6 = XEXP (x2, 2);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[3] = x6;
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!nonimm_or_0_operand (operands[2], E_V2DFmode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8099 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 4737; /* avx512fp16_float_extend_phv2df2_mask */

                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10402 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                    return -1;
                  return 5243; /* sse2_cvtps2pd_mask */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x6, 0) != 1L
                  || GET_MODE (x4) != E_V2SFmode)
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!nonimmediate_operand (operands[2], E_V4SFmode))
                return -1;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 10060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 5173; /* sse2_cvtss2sd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern127 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3730; /* *xorv8sf3_mask */

        case E_V4SFmode:
          if (pattern127 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 3736; /* *xorv4sf3_mask */

        case E_V4DFmode:
          if (pattern127 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3742; /* *xorv4df3_mask */

        case E_V2DFmode:
          if (pattern127 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3748; /* *xorv2df3_mask */

        case E_V16SFmode:
          if (pattern128 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3760; /* *xorv16sf3_mask */

        case E_V8DFmode:
          if (pattern128 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3766; /* *xorv8df3_mask */

        case E_V16SImode:
          if (pattern485 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V16SImode, operands)) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 8013; /* *xorv16si3_mask */

        case E_V8SImode:
          if (pattern485 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V8SImode, operands)) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8019; /* *xorv8si3_mask */

        case E_V4SImode:
          if (pattern485 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V4SImode, operands))))
            return -1;
          return 8025; /* *xorv4si3_mask */

        case E_V8DImode:
          if (pattern485 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V8DImode, operands)) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 8031; /* *xorv8di3_mask */

        case E_V4DImode:
          if (pattern485 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V4DImode, operands)) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8037; /* *xorv4di3_mask */

        case E_V2DImode:
          if (pattern485 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (XOR, V2DImode, operands))))
            return -1;
          return 8043; /* *xorv2di3_mask */

        default:
          return -1;
        }

    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1016 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18371 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7961; /* one_cmplv16si2_mask */

        case E_V8DImode:
          if (pattern1016 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18371 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7963; /* one_cmplv8di2_mask */

        case E_V8SImode:
          if (pattern1016 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18371 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7971; /* one_cmplv8si2_mask */

        case E_V4SImode:
          if (pattern1016 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18371 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || SImode == SImode
       || SImode == DImode))))
            return -1;
          return 7973; /* one_cmplv4si2_mask */

        case E_V4DImode:
          if (pattern1016 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18371 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7975; /* one_cmplv4di2_mask */

        case E_V2DImode:
          if (pattern1016 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18371 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!true
       || DImode == SImode
       || DImode == DImode))))
            return -1;
          return 7977; /* one_cmplv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern321 (x2))
    {
    case 0:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4426; /* avx512fp16_vcvtph2w_v32hi */

    case 1:
      switch (pattern641 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4434; /* avx512fp16_vcvtph2dq_v16si */

        case 1:
          if (!
#line 8708 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4841; /* avx512f_fix_notruncv16sfv16si */

        default:
          return -1;
        }

    case 2:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4442; /* avx512fp16_vcvtph2qq_v8di */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 8729 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4855; /* *avx512dq_cvtps2qqv8di */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5101; /* fix_notruncv8dfv8di2 */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4450; /* avx512fp16_vcvtph2w_v16hi */

    case 4:
      switch (pattern640 (x2))
        {
        case 0:
          if (!(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4458; /* avx512fp16_vcvtph2dq_v8si */

        case 1:
          if (!(
#line 8692 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4835; /* avx_fix_notruncv8sfv8si */

        case 2:
          if (!
#line 9411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5005; /* avx512f_cvtpd2dq512 */

        default:
          return -1;
        }

    case 5:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4466; /* avx512fp16_vcvtph2qq_v4di */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 8729 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4859; /* *avx512dq_cvtps2qqv4di */

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !(
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5105; /* fix_notruncv4dfv4di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4472; /* avx512fp16_vcvtph2w_v8hi */

    case 7:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4476; /* avx512fp16_vcvtph2dq_v4si */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8692 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 4839; /* sse2_fix_notruncv4sfv4si */

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !
#line 9421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!false || TARGET_AVX10_2_256)))
            return -1;
          return 5009; /* avx_cvtpd2dq256 */

        default:
          return -1;
        }

    case 8:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4480; /* avx512fp16_vcvtph2qq_v2di */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !(
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5109; /* fix_notruncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 8742 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4863; /* *avx512dq_cvtps2qqv2di */

    default:
      return -1;
    }
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (pattern1130 (x2))
    {
    case 0:
      if (pattern1595 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 5927 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 3947; /* fma_fnmadd_v32hf_maskz_1_round */

    case 1:
      if (pattern1595 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 5928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 3951; /* fma_fnmadd_v16hf_maskz_1_round */

    case 2:
      if (pattern1595 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 5931 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3959; /* fma_fnmadd_v16sf_maskz_1_round */

    case 3:
      if (pattern1595 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 5932 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3963; /* fma_fnmadd_v8sf_maskz_1_round */

    case 4:
      if (pattern1595 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 5933 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3970; /* fma_fnmadd_v8df_maskz_1_round */

    case 5:
      if (pattern1595 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 5934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3974; /* fma_fnmadd_v4df_maskz_1_round */

    case 6:
      if (pattern1596 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && register_operand (operands[3], E_V32HFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return 3978; /* avx512bw_fnmadd_v32hf_mask_round */
        }
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 3993; /* avx512bw_fnmadd_v32hf_mask3_round */

    case 7:
      if (pattern1596 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && register_operand (operands[3], E_V16HFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return 3980; /* avx512vl_fnmadd_v16hf_mask_round */
        }
      if (!register_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 3995; /* avx512vl_fnmadd_v16hf_mask3_round */

    case 8:
      if (pattern1596 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && register_operand (operands[3], E_V16SFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return 3983; /* avx512f_fnmadd_v16sf_mask_round */
        }
      if (!register_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3998; /* avx512f_fnmadd_v16sf_mask3_round */

    case 9:
      if (pattern1596 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && register_operand (operands[3], E_V8SFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 3985; /* avx512vl_fnmadd_v8sf_mask_round */
        }
      if (!register_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4000; /* avx512vl_fnmadd_v8sf_mask3_round */

    case 10:
      if (pattern1596 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && register_operand (operands[3], E_V8DFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return 3988; /* avx512f_fnmadd_v8df_mask_round */
        }
      if (!register_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4003; /* avx512f_fnmadd_v8df_mask3_round */

    case 11:
      if (pattern1596 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && register_operand (operands[3], E_V4DFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 3990; /* avx512vl_fnmadd_v4df_mask_round */
        }
      if (!register_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4005; /* avx512vl_fnmadd_v4df_mask3_round */

    case 12:
      if (pattern1650 (x2, 
E_V8HFmode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6632 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
        return -1;
      return 4237; /* *fmai_fnmadd_v8hf_round */

    case 13:
      if (pattern1650 (x2, 
E_V4SFmode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6632 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
        return -1;
      return 4239; /* *fmai_fnmadd_v4sf_round */

    case 14:
      if (pattern1650 (x2, 
E_V2DFmode) != 0
          || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6632 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 4241; /* *fmai_fnmadd_v2df_round */

    case 15:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x3, 2);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 1);
          operands[6] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1597 (x2, 
E_V4SFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return -1;
              return 4014; /* *fma_fnmsub_v4sf */

            case E_V2DFmode:
              if (pattern1597 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return -1;
              return 4018; /* *fma_fnmsub_v2df */

            case E_V8SFmode:
              if (pattern1598 (x2, 
E_V8SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return 4022; /* *fma_fnmsub_v8sf */
              if (!register_operand (operands[1], E_V8SFmode)
                  || !register_operand (operands[2], E_V8SFmode)
                  || !register_operand (operands[3], E_V8SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 5932 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4046; /* fma_fnmsub_v8sf_maskz_1_round */

            case E_V4DFmode:
              if (pattern1598 (x2, 
E_V4DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6226 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return 4026; /* *fma_fnmsub_v4df */
              if (!register_operand (operands[1], E_V4DFmode)
                  || !register_operand (operands[2], E_V4DFmode)
                  || !register_operand (operands[3], E_V4DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 5934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4057; /* fma_fnmsub_v4df_maskz_1_round */

            case E_V32HFmode:
              if (pattern1599 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 5927 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 4030; /* fma_fnmsub_v32hf_maskz_1_round */

            case E_V16HFmode:
              if (pattern1599 (x2, 
E_HImode, 
E_V16HFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 5928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 4034; /* fma_fnmsub_v16hf_maskz_1_round */

            case E_V16SFmode:
              if (pattern1599 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 5931 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4042; /* fma_fnmsub_v16sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1599 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 5933 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4053; /* fma_fnmsub_v8df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern1129 (x2))
            {
            case 0:
              if (pattern1600 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V32HFmode)
                  && register_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return 4061; /* avx512bw_fnmsub_v32hf_mask_round */
              if (!register_operand (operands[1], E_V32HFmode)
                  || !nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 4076; /* avx512bw_fnmsub_v32hf_mask3_round */

            case 1:
              if (pattern1600 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V16HFmode)
                  && register_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 4063; /* avx512vl_fnmsub_v16hf_mask_round */
              if (!register_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 4078; /* avx512vl_fnmsub_v16hf_mask3_round */

            case 2:
              if (pattern1600 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V16SFmode)
                  && register_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 4066; /* avx512f_fnmsub_v16sf_mask_round */
              if (!register_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4081; /* avx512f_fnmsub_v16sf_mask3_round */

            case 3:
              if (pattern1600 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && register_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 4068; /* avx512vl_fnmsub_v8sf_mask_round */
              if (!register_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4083; /* avx512vl_fnmsub_v8sf_mask3_round */

            case 4:
              if (pattern1600 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8DFmode)
                  && register_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 4071; /* avx512f_fnmsub_v8df_mask_round */
              if (!register_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4086; /* avx512f_fnmsub_v8df_mask3_round */

            case 5:
              if (pattern1600 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && register_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6304 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 4073; /* avx512vl_fnmsub_v4df_mask_round */
              if (!register_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4088; /* avx512vl_fnmsub_v4df_mask3_round */

            case 6:
              if (pattern1651 (x2, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4243; /* *fmai_fnmsub_v8hf_round */

            case 7:
              if (pattern1651 (x2, 
E_V4SFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
                return -1;
              return 4245; /* *fmai_fnmsub_v4sf_round */

            case 8:
              if (pattern1651 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 4247; /* *fmai_fnmsub_v2df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM)
    return -1;
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 154)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!const1248_operand (operands[4], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  x8 = XEXP (x1, 1);
  x9 = XVECEXP (x8, 0, 1);
  operands[3] = x9;
  x10 = XVECEXP (x8, 0, 0);
  if (!rtx_equal_p (x10, operands[6]))
    return -1;
  switch (GET_MODE (operands[5]))
    {
    case E_V16SImode:
      if (!vsib_mem_operator (operands[5], E_V16SImode)
          || GET_MODE (x8) != E_V16SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          switch (pattern1700 (
E_SImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9843; /* *avx512f_scattersiv16si */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9867; /* *avx512f_scatterdiv16si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1700 (
E_DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9855; /* *avx512f_scattersiv16si */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9879; /* *avx512f_scatterdiv16si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!vsib_mem_operator (operands[5], E_V16SFmode)
          || GET_MODE (x8) != E_V16SFmode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          switch (pattern1701 (
E_SImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9844; /* *avx512f_scattersiv16sf */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9868; /* *avx512f_scatterdiv16sf */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1701 (
E_DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9856; /* *avx512f_scattersiv16sf */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9880; /* *avx512f_scatterdiv16sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern1602 (x1, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9845; /* *avx512f_scattersiv8di */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9869; /* *avx512f_scatterdiv8di */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9857; /* *avx512f_scattersiv8di */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9881; /* *avx512f_scatterdiv8di */

        default:
          return -1;
        }

    case E_V8DFmode:
      switch (pattern1602 (x1, 
E_V8DFmode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9846; /* *avx512f_scattersiv8df */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9870; /* *avx512f_scatterdiv8df */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9858; /* *avx512f_scattersiv8df */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9882; /* *avx512f_scatterdiv8df */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern1603 (x1, 
E_V8SImode))
        {
        case 0:
          switch (pattern1737 (
E_SImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9847; /* *avx512f_scattersiv8si */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9871; /* *avx512f_scatterdiv8si */

            default:
              return -1;
            }

        case 1:
          switch (pattern1737 (
E_DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9859; /* *avx512f_scattersiv8si */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9883; /* *avx512f_scatterdiv8si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8SFmode:
      switch (pattern1603 (x1, 
E_V8SFmode))
        {
        case 0:
          switch (pattern1738 (
E_SImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9848; /* *avx512f_scattersiv8sf */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9872; /* *avx512f_scatterdiv8sf */

            default:
              return -1;
            }

        case 1:
          switch (pattern1738 (
E_DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9860; /* *avx512f_scattersiv8sf */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9884; /* *avx512f_scatterdiv8sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern1605 (x1, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9849; /* *avx512f_scattersiv4di */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9873; /* *avx512f_scatterdiv4di */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9861; /* *avx512f_scattersiv4di */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9885; /* *avx512f_scatterdiv4di */

        default:
          return -1;
        }

    case E_V4DFmode:
      switch (pattern1605 (x1, 
E_V4DFmode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9850; /* *avx512f_scattersiv4df */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9874; /* *avx512f_scatterdiv4df */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9862; /* *avx512f_scattersiv4df */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9886; /* *avx512f_scatterdiv4df */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern1607 (x1, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9851; /* *avx512f_scattersiv4si */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9875; /* *avx512f_scatterdiv4si */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9863; /* *avx512f_scattersiv4si */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9887; /* *avx512f_scatterdiv4si */

        default:
          return -1;
        }

    case E_V4SFmode:
      switch (pattern1607 (x1, 
E_V4SFmode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9852; /* *avx512f_scattersiv4sf */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9876; /* *avx512f_scatterdiv4sf */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9864; /* *avx512f_scattersiv4sf */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9888; /* *avx512f_scatterdiv4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern1607 (x1, 
E_V2DImode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9853; /* *avx512f_scattersiv2di */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9877; /* *avx512f_scatterdiv2di */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9865; /* *avx512f_scattersiv2di */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9889; /* *avx512f_scatterdiv2di */

        default:
          return -1;
        }

    case E_V2DFmode:
      switch (pattern1607 (x1, 
E_V2DFmode))
        {
        case 0:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9854; /* *avx512f_scattersiv2df */

        case 1:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9878; /* *avx512f_scatterdiv2df */

        case 2:
          if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9866; /* *avx512f_scattersiv2df */

        case 3:
          if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9890; /* *avx512f_scatterdiv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
      switch (pattern494 (x3))
        {
        case 0:
          if (!
#line 21611 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512VBMI
   && ix86_pre_reload_split ()))
            return -1;
          return 8488; /* *vec_concatv16qi_permt2 */

        case 1:
          if (!
#line 21636 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW
   && ix86_pre_reload_split ()))
            return -1;
          return 8489; /* *vec_concatv8hi_permt2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern170 (x3, 
E_V16SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9385; /* avx512f_vpermt2varv16si3 */

        case E_V16SFmode:
          if (pattern1027 (x3, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9387; /* avx512f_vpermt2varv16sf3 */

        case E_V8DImode:
          if (pattern170 (x3, 
E_V8DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9389; /* avx512f_vpermt2varv8di3 */

        case E_V8DFmode:
          if (pattern1027 (x3, 
E_V8DFmode, 
E_V8DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9391; /* avx512f_vpermt2varv8df3 */

        case E_V8SImode:
          if (pattern170 (x3, 
E_V8SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9393; /* avx512vl_vpermt2varv8si3 */

        case E_V8SFmode:
          if (pattern1027 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9395; /* avx512vl_vpermt2varv8sf3 */

        case E_V4DImode:
          if (pattern170 (x3, 
E_V4DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9397; /* avx512vl_vpermt2varv4di3 */

        case E_V4DFmode:
          if (pattern1027 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9399; /* avx512vl_vpermt2varv4df3 */

        case E_V4SImode:
          if (pattern170 (x3, 
E_V4SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9401; /* avx512vl_vpermt2varv4si3 */

        case E_V4SFmode:
          if (pattern1027 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9403; /* avx512vl_vpermt2varv4sf3 */

        case E_V2DImode:
          if (pattern170 (x3, 
E_V2DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9405; /* avx512vl_vpermt2varv2di3 */

        case E_V2DFmode:
          if (pattern1027 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9407; /* avx512vl_vpermt2varv2df3 */

        case E_V32HImode:
          if (pattern170 (x3, 
E_V32HImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28149 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 9409; /* avx512bw_vpermt2varv32hi3 */

        case E_V16HImode:
          if (pattern170 (x3, 
E_V16HImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28150 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9411; /* avx512vl_vpermt2varv16hi3 */

        case E_V8HImode:
          if (pattern170 (x3, 
E_V8HImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9413; /* avx512vl_vpermt2varv8hi3 */

        case E_V64QImode:
          if (pattern170 (x3, 
E_V64QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28152 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 9415; /* avx512bw_vpermt2varv64qi3 */

        case E_V32QImode:
          if (pattern170 (x3, 
E_V32QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28153 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9417; /* avx512vl_vpermt2varv32qi3 */

        case E_V16QImode:
          if (pattern170 (x3, 
E_V16QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9419; /* avx512vl_vpermt2varv16qi3 */

        case E_V32HFmode:
          if (pattern1027 (x3, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9421; /* avx512bw_vpermt2varv32hf3 */

        case E_V16HFmode:
          if (pattern1027 (x3, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9423; /* avx512vl_vpermt2varv16hf3 */

        case E_V8HFmode:
          if (pattern1027 (x3, 
E_V8HFmode, 
E_V8HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9425; /* avx512fp16_vpermt2varv8hf3 */

        case E_V32BFmode:
          if (pattern1027 (x3, 
E_V32BFmode, 
E_V32HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9427; /* avx512bw_vpermt2varv32bf3 */

        case E_V16BFmode:
          if (pattern1027 (x3, 
E_V16BFmode, 
E_V16HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9429; /* avx512vl_vpermt2varv16bf3 */

        case E_V8BFmode:
          if (pattern1027 (x3, 
E_V8BFmode, 
E_V8HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9431; /* avx512vl_vpermt2varv8bf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (pattern150 (x3, 
E_V16SFmode) != 0
          || !(
#line 29825 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9963; /* avx512dq_rangepv16sf */

    case E_V8SFmode:
      if (pattern150 (x3, 
E_V8SFmode) != 0
          || !(
#line 29825 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9967; /* avx512dq_rangepv8sf */

    case E_V4SFmode:
      if (pattern150 (x3, 
E_V4SFmode) != 0
          || !(
#line 29825 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9971; /* avx512dq_rangepv4sf */

    case E_V8DFmode:
      if (pattern150 (x3, 
E_V8DFmode) != 0
          || !(
#line 29825 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9973; /* avx512dq_rangepv8df */

    case E_V4DFmode:
      if (pattern150 (x3, 
E_V4DFmode) != 0
          || !(
#line 29825 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9977; /* avx512dq_rangepv4df */

    case E_V2DFmode:
      if (pattern150 (x3, 
E_V2DFmode) != 0
          || !(
#line 29825 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9981; /* avx512dq_rangepv2df */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern173 (x1))
    {
    case 0:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10186; /* vpshrd_v32hi */

    case 1:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10188; /* vpshrd_v16si */

    case 2:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10190; /* vpshrd_v8di */

    case 3:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10192; /* vpshrd_v16hi */

    case 4:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10194; /* vpshrd_v8si */

    case 5:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10196; /* vpshrd_v4di */

    case 6:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10198; /* vpshrd_v8hi */

    case 7:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10200; /* vpshrd_v4si */

    case 8:
      if (!(
#line 30409 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10202; /* vpshrd_v2di */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 51:
      return recog_248 (x1, insn, pnum_clobbers);

    case 59:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!cmpps_imm_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern61 (x2, 
E_V8SFmode) != 0
              || !(
#line 4096 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3237; /* avx_cmpv8sf3 */

        case E_V4SFmode:
          if (pattern61 (x2, 
E_V4SFmode) != 0
              || !
#line 4096 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3238; /* avx_cmpv4sf3 */

        case E_V4DFmode:
          if (pattern61 (x2, 
E_V4DFmode) != 0
              || !(
#line 4096 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 3239; /* avx_cmpv4df3 */

        case E_V2DFmode:
          if (pattern61 (x2, 
E_V2DFmode) != 0
              || !(
#line 4096 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3240; /* avx_cmpv2df3 */

        default:
          return -1;
        }

    case 133:
      return recog_247 (x1, insn, pnum_clobbers);

    case 217:
      return recog_263 (x1, insn, pnum_clobbers);

    case 219:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern666 (x2))
        {
        case 0:
          if ((
#line 7160 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 4332; /* fma_fcmaddc_v32hf */
          break;

        case 1:
          if ((
#line 7160 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4340; /* fma_fcmaddc_v16hf */
          break;

        case 2:
          if ((
#line 7160 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4346; /* fma_fcmaddc_v8hf */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      switch (pattern592 (x2))
        {
        case 0:
          if (!(
#line 7266 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4369; /* fma_v32hf_fcmaddc_bcst */

        case 1:
          if (!(
#line 7266 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4370; /* fma_v16hf_fcmaddc_bcst */

        case 2:
          if (!(
#line 7266 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4371; /* fma_v8hf_fcmaddc_bcst */

        default:
          return -1;
        }

    case 218:
      switch (pattern167 (x1))
        {
        case 0:
          if (!(
#line 7225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4360; /* fma_fmaddc_v16sf_pair */

        case 1:
          if (!(
#line 7225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4362; /* fma_fmaddc_v8sf_pair */

        case 2:
          if (!(
#line 7225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4364; /* fma_fmaddc_v4sf_pair */

        default:
          return -1;
        }

    case 220:
      switch (pattern167 (x1))
        {
        case 0:
          if (!(
#line 7225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4361; /* fma_fcmaddc_v16sf_pair */

        case 1:
          if (!(
#line 7225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4363; /* fma_fcmaddc_v8sf_pair */

        case 2:
          if (!(
#line 7225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4365; /* fma_fcmaddc_v4sf_pair */

        default:
          return -1;
        }

    case 50:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern969 (x2, 
E_V4SImode) != 0
              || !
#line 12243 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 5335; /* sse4_1_insertps_v4si */

        case E_V4SFmode:
          if (pattern969 (x2, 
E_V4SFmode) != 0
              || !
#line 12243 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 5336; /* sse4_1_insertps_v4sf */

        default:
          return -1;
        }

    case 167:
      return recog_255 (x1, insn, pnum_clobbers);

    case 155:
      return recog_250 (x1, insn, pnum_clobbers);

    case 47:
      return recog_246 (x1, insn, pnum_clobbers);

    case 121:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4TImode:
          if (pattern150 (x2, 
E_V4TImode) != 0
              || !(
#line 23254 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 725 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8647; /* avx512bw_palignrv4ti */

        case E_V2TImode:
          if (pattern150 (x2, 
E_V2TImode) != 0
              || !(
#line 23254 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 725 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8648; /* avx2_palignrv2ti */

        case E_V1TImode:
          if (pattern150 (x2, 
E_V1TImode) != 0
              || !
#line 23254 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8649; /* ssse3_palignrv1ti */

        default:
          return -1;
        }

    case 122:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_VOIDmode)
          || !
#line 23448 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 8679; /* sse4a_extrqi */

    case 126:
      return recog_261 (x1, insn, pnum_clobbers);

    case 128:
      return recog_262 (x1, insn, pnum_clobbers);

    case 53:
      if (pattern63 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!nonimmediate_operand (operands[3], E_V16QImode)
          || !
#line 26496 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 9032; /* xop_pperm */

    case 135:
      return recog_260 (x1, insn, pnum_clobbers);

    case 143:
      if (pattern158 (x1, 
E_V2DImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode)
          || !
#line 27209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_PCLMUL))
        return -1;
      return 9091; /* pclmulqdq */

    case 152:
      if (pattern63 (x1, 
E_V4DImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode)
          || !
#line 27666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
        return -1;
      return 9181; /* avx2_permv2ti */

    case 146:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern61 (x2, 
E_V8SImode) != 0
              || !
#line 28319 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9451; /* *avx_vperm2f128v8si_full */

        case E_V8SFmode:
          if (pattern61 (x2, 
E_V8SFmode) != 0
              || !
#line 28319 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9452; /* *avx_vperm2f128v8sf_full */

        case E_V4DFmode:
          if (pattern61 (x2, 
E_V4DFmode) != 0
              || !
#line 28319 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9453; /* *avx_vperm2f128v4df_full */

        default:
          return -1;
        }

    case 153:
      return recog_245 (x1, insn, pnum_clobbers);

    case 169:
      return recog_252 (x1, insn, pnum_clobbers);

    case 170:
      return recog_251 (x1, insn, pnum_clobbers);

    case 171:
      return recog_249 (x1, insn, pnum_clobbers);

    case 194:
      return recog_254 (x1, insn, pnum_clobbers);

    case 186:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern161 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 29937 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10057; /* *avx512bw_dbpsadbwv8hi */

        case E_V16HImode:
          if (pattern161 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 29937 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10059; /* *avx512bw_dbpsadbwv16hi */

        case E_V32HImode:
          if (pattern161 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 29937 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10061; /* *avx512bw_dbpsadbwv32hi */

        default:
          return -1;
        }

    case 182:
      if (pattern158 (x1, 
E_V4SImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_3_operand (operands[3], E_SImode)
          || !
#line 30005 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 10090; /* sha1rnds4 */

    case 185:
      if (pattern158 (x1, 
E_V4SImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 30040 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 10093; /* sha256rnds2 */

    case 224:
      if (pattern169 (x1) != 0
          || !
#line 30053 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SM3))
        return -1;
      return 10094; /* vsm3msg1 */

    case 225:
      if (pattern169 (x1) != 0
          || !
#line 30065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SM3))
        return -1;
      return 10095; /* vsm3msg2 */

    case 241:
      if (pattern157 (x1, 
E_V4DImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V2DImode)
          || !
#line 30113 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 10099; /* vsha512rnds2 */

    case 195:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 30222 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA && TARGET_EVEX512))
            return -1;
          return 10112; /* vpmadd52luqv8di */

        case 1:
          if (!(
#line 30235 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10114; /* vpmadd52luqv4di */

        case 2:
          if (!
#line 30235 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)))
            return -1;
          return 10116; /* vpmadd52luqv2di */

        default:
          return -1;
        }

    case 196:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 30222 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA && TARGET_EVEX512))
            return -1;
          return 10113; /* vpmadd52huqv8di */

        case 1:
          if (!(
#line 30235 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10115; /* vpmadd52huqv4di */

        case 2:
          if (!
#line 30235 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXIFMA || (TARGET_AVX512IFMA && TARGET_AVX512VL)))
            return -1;
          return 10117; /* vpmadd52huqv2di */

        default:
          return -1;
        }

    case 198:
      switch (pattern172 (x1))
        {
        case 0:
          if (!(
#line 30359 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 10168; /* vgf2p8affineinvqb_v64qi */

        case 1:
          if (!(
#line 30359 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10170; /* vgf2p8affineinvqb_v32qi */

        case 2:
          if (!
#line 30359 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 10172; /* vgf2p8affineinvqb_v16qi */

        default:
          return -1;
        }

    case 199:
      switch (pattern172 (x1))
        {
        case 0:
          if (!(
#line 30376 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 10174; /* vgf2p8affineqb_v64qi */

        case 1:
          if (!(
#line 30376 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10176; /* vgf2p8affineqb_v32qi */

        case 2:
          if (!
#line 30376 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 10178; /* vgf2p8affineqb_v16qi */

        default:
          return -1;
        }

    case 202:
      return recog_259 (x1, insn, pnum_clobbers);

    case 201:
      return recog_257 (x1, insn, pnum_clobbers);

    case 203:
      return recog_258 (x1, insn, pnum_clobbers);

    case 204:
      return recog_256 (x1, insn, pnum_clobbers);

    case 205:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30593 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10276; /* vpdpbusd_v16si */

        case 1:
          if (!(
#line 30604 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10277; /* vpdpbusd_v8si */

        case 2:
          if (!
#line 30604 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10278; /* vpdpbusd_v4si */

        default:
          return -1;
        }

    case 206:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10285; /* vpdpbusds_v16si */

        case 1:
          if (!(
#line 30673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10286; /* vpdpbusds_v8si */

        case 2:
          if (!
#line 30673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10287; /* vpdpbusds_v4si */

        default:
          return -1;
        }

    case 207:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30731 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10294; /* vpdpwssd_v16si */

        case 1:
          if (!(
#line 30742 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10295; /* vpdpwssd_v8si */

        case 2:
          if (!
#line 30742 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10296; /* vpdpwssd_v4si */

        default:
          return -1;
        }

    case 208:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 30800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI && TARGET_EVEX512))
            return -1;
          return 10303; /* vpdpwssds_v16si */

        case 1:
          if (!(
#line 30811 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)) && 
#line 668 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 10304; /* vpdpwssds_v8si */

        case 2:
          if (!
#line 30811 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNI || (TARGET_AVX512VNNI && TARGET_AVX512VL)))
            return -1;
          return 10305; /* vpdpwssds_v4si */

        default:
          return -1;
        }

    case 213:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DImode:
          if (pattern150 (x2, 
E_V8DImode) != 0
              || !(
#line 30924 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_VPCLMULQDQ) && 
#line 620 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 10324; /* vpclmulqdq_v8di */

        case E_V4DImode:
          if (pattern150 (x2, 
E_V4DImode) != 0
              || !
#line 30924 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_VPCLMULQDQ))
            return -1;
          return 10325; /* vpclmulqdq_v4di */

        case E_V2DImode:
          if (pattern150 (x2, 
E_V2DImode) != 0
              || !(
#line 30924 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_VPCLMULQDQ) && 
#line 620 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10326; /* vpclmulqdq_v2di */

        default:
          return -1;
        }

    case 216:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern919 (x2, 
E_V32BFmode, 
E_V16SFmode) != 0
              || !(
#line 31203 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10354; /* avx512f_dpbf16ps_v16sf */

        case E_V8SFmode:
          if (pattern919 (x2, 
E_V16BFmode, 
E_V8SFmode) != 0
              || !(
#line 31203 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10356; /* avx512f_dpbf16ps_v8sf */

        case E_V4SFmode:
          if (pattern919 (x2, 
E_V8BFmode, 
E_V4SFmode) != 0
              || !(
#line 31203 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10358; /* avx512f_dpbf16ps_v4sf */

        default:
          return -1;
        }

    case 227:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10374; /* vpdpbssd_v8si */

        case 1:
          if (!
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10380; /* vpdpbssd_v4si */

        case 2:
          if (!
#line 31585 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10386; /* vpdpbssd_v16si */

        default:
          return -1;
        }

    case 228:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10375; /* vpdpbssds_v8si */

        case 1:
          if (!
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10381; /* vpdpbssds_v4si */

        case 2:
          if (!
#line 31585 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10387; /* vpdpbssds_v16si */

        default:
          return -1;
        }

    case 229:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10376; /* vpdpbsud_v8si */

        case 1:
          if (!
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10382; /* vpdpbsud_v4si */

        case 2:
          if (!
#line 31585 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10388; /* vpdpbsud_v16si */

        default:
          return -1;
        }

    case 230:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10377; /* vpdpbsuds_v8si */

        case 1:
          if (!
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10383; /* vpdpbsuds_v4si */

        case 2:
          if (!
#line 31585 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10389; /* vpdpbsuds_v16si */

        default:
          return -1;
        }

    case 231:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10378; /* vpdpbuud_v8si */

        case 1:
          if (!
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10384; /* vpdpbuud_v4si */

        case 2:
          if (!
#line 31585 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10390; /* vpdpbuud_v16si */

        default:
          return -1;
        }

    case 232:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10379; /* vpdpbuuds_v8si */

        case 1:
          if (!
#line 31574 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT8 || TARGET_AVX10_2_256))
            return -1;
          return 10385; /* vpdpbuuds_v4si */

        case 2:
          if (!
#line 31585 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10391; /* vpdpbuuds_v16si */

        default:
          return -1;
        }

    case 233:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10528; /* vpdpwusd_v8si */

        case 1:
          if (!
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10534; /* vpdpwusd_v4si */

        case 2:
          if (!
#line 31994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10540; /* vpdpwusd_v16si */

        default:
          return -1;
        }

    case 234:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10529; /* vpdpwusds_v8si */

        case 1:
          if (!
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10535; /* vpdpwusds_v4si */

        case 2:
          if (!
#line 31994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10541; /* vpdpwusds_v16si */

        default:
          return -1;
        }

    case 235:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10530; /* vpdpwsud_v8si */

        case 1:
          if (!
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10536; /* vpdpwsud_v4si */

        case 2:
          if (!
#line 31994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10542; /* vpdpwsud_v16si */

        default:
          return -1;
        }

    case 236:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10531; /* vpdpwsuds_v8si */

        case 1:
          if (!
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10537; /* vpdpwsuds_v4si */

        case 2:
          if (!
#line 31994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10543; /* vpdpwsuds_v16si */

        default:
          return -1;
        }

    case 237:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10532; /* vpdpwuud_v8si */

        case 1:
          if (!
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10538; /* vpdpwuud_v4si */

        case 2:
          if (!
#line 31994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10544; /* vpdpwuud_v16si */

        default:
          return -1;
        }

    case 238:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 10533; /* vpdpwuuds_v8si */

        case 1:
          if (!
#line 31983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXVNNIINT16 || TARGET_AVX10_2_256))
            return -1;
          return 10539; /* vpdpwuuds_v4si */

        case 2:
          if (!
#line 31994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))
            return -1;
          return 10545; /* vpdpwuuds_v16si */

        default:
          return -1;
        }

    case 244:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern170 (x2, 
E_V16SFmode) != 0
              || !(
#line 32046 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10582; /* vdpphps_v16sf */

        case E_V8SFmode:
          if (pattern170 (x2, 
E_V8SFmode) != 0
              || !
#line 32046 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10583; /* vdpphps_v8sf */

        case E_V4SFmode:
          if (pattern170 (x2, 
E_V4SFmode) != 0
              || !
#line 32046 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10584; /* vdpphps_v4sf */

        default:
          return -1;
        }

    case 277:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1029 (x2, 
E_V32BFmode) != 0
              || !(
#line 32636 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10935; /* avx10_2_minmaxbf16_v32bf */

        case E_V16BFmode:
          if (pattern1029 (x2, 
E_V16BFmode) != 0
              || !
#line 32636 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10937; /* avx10_2_minmaxbf16_v16bf */

        case E_V8BFmode:
          if (pattern1029 (x2, 
E_V8BFmode) != 0
              || !
#line 32636 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10939; /* avx10_2_minmaxbf16_v8bf */

        default:
          return -1;
        }

    case 278:
      return recog_253 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  res = recog_286 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (XWINT (x5, 0) != 1L
          || XWINT (x6, 0) != 2L
          || XWINT (x7, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !nonimmediate_operand (operands[1], E_V8DFmode)
              || !(
#line 12650 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5351; /* vec_extract_lo_v8df */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !nonimmediate_operand (operands[1], E_V8DImode)
              || !(
#line 12650 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5352; /* vec_extract_lo_v8di */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V8SImode)
              || !
#line 12983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5375; /* vec_extract_lo_v8si */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 12983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5376; /* vec_extract_lo_v8sf */

        default:
          return -1;
        }

    case 4L:
      if (XWINT (x5, 0) != 5L
          || XWINT (x6, 0) != 6L
          || XWINT (x7, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !register_operand (operands[1], E_V8DFmode)
              || !(
#line 12686 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5355; /* vec_extract_hi_v8df */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_V8DImode)
              || !(
#line 12686 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5356; /* vec_extract_hi_v8di */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 13015 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5379; /* vec_extract_hi_v8si */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 13015 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5380; /* vec_extract_hi_v8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_292 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x4;
  res = recog_294 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 0L
      || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern837 (x3, 
11, 
10, 
9, 
8) != 0
      || !register_operand (operands[0], E_V16HImode)
      || GET_MODE (x2) != E_V16HImode
      || !nonimmediate_operand (operands[1], E_V16HImode)
      || pattern1488 (x3) != 0)
    return -1;
  x8 = XVECEXP (x3, 0, 12);
  operands[6] = x8;
  if (!const_12_to_15_operand (operands[6], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 13);
  operands[7] = x9;
  if (!const_12_to_15_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 14);
  operands[8] = x10;
  if (!const_12_to_15_operand (operands[8], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 15);
  operands[9] = x11;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode)
      || !
#line 20950 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2
   && 1 && 1
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9])))
    return -1;
  return 8455; /* avx2_pshufhw_1 */
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (register_operand (operands[1], E_V4SFmode)
                  && (
#line 11726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 5286; /* avx2_vec_dupv8sf */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9203; /* avx512vl_vec_dupv8sf */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !
#line 11738 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 5288; /* avx2_vec_dupv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          if (register_operand (operands[1], E_V4SFmode)
              && 
#line 11726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 5287; /* avx2_vec_dupv4sf */
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9205; /* avx512vl_vec_dupv4sf */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x2) != E_V16SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !(
#line 11750 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5289; /* avx512f_vec_dupv16sf_1 */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9201; /* avx512f_vec_dupv16sf */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x2) != E_V8DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 11750 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5290; /* avx512f_vec_dupv8df_1 */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9207; /* avx512f_vec_dupv8df */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9094; /* avx2_pbroadcastv16si */
              if (!(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9189; /* avx512f_vec_dupv16si */

            case E_V16SImode:
              if (!nonimmediate_operand (operands[1], E_V16SImode)
                  || !(
#line 27712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9183; /* avx512f_vec_dupv16si_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9095; /* avx2_pbroadcastv8di */
              if (!(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9195; /* avx512f_vec_dupv8di */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 27712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9184; /* avx512f_vec_dupv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x2) != E_V64QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9096; /* avx2_pbroadcastv64qi */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9213; /* avx512bw_vec_dupv64qi */

            case E_V64QImode:
              if (!nonimmediate_operand (operands[1], E_V64QImode)
                  || !(
#line 27712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9186; /* avx512bw_vec_dupv64qi_1 */

            default:
              return -1;
            }

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9097; /* avx2_pbroadcastv32qi */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9217; /* avx512vl_vec_dupv32qi */

            case E_V32QImode:
              if (!nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 27309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9112; /* avx2_pbroadcastv32qi_1 */

            default:
              return -1;
            }

        case E_V16QImode:
          if (pattern932 (x2, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          if (
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9098; /* avx2_pbroadcastv16qi */
          if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9215; /* avx512vl_vec_dupv16qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x2) != E_V32HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9099; /* avx2_pbroadcastv32hi */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9219; /* avx512bw_vec_dupv32hi */

            case E_V32HImode:
              if (!nonimmediate_operand (operands[1], E_V32HImode)
                  || !(
#line 27712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9185; /* avx512bw_vec_dupv32hi_1 */

            default:
              return -1;
            }

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9100; /* avx2_pbroadcastv16hi */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9221; /* avx512vl_vec_dupv16hi */

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode)
                  || !
#line 27309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9113; /* avx2_pbroadcastv16hi_1 */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern932 (x2, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          if (
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9101; /* avx2_pbroadcastv8hi */
          if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9223; /* avx512vl_vec_dupv8hi */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9102; /* avx2_pbroadcastv8si */
              if (!(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9191; /* avx512vl_vec_dupv8si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !
#line 27309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9114; /* avx2_pbroadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern932 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          if (
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9103; /* avx2_pbroadcastv4si */
          if (!(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9193; /* avx512vl_vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9104; /* avx2_pbroadcastv4di */
              if (!(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9197; /* avx512vl_vec_dupv4di */

            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !
#line 27309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9115; /* avx2_pbroadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern932 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return -1;
          if (
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9105; /* avx2_pbroadcastv2di */
          if (!(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9199; /* avx512vl_vec_dupv2di */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x2) != E_V32HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9106; /* avx2_pbroadcastv32hf */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9225; /* avx512bw_vec_dupv32hf */

            case E_V32HFmode:
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !(
#line 27712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9187; /* avx512bw_vec_dupv32hf_1 */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9107; /* avx2_pbroadcastv16hf */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9227; /* avx512vl_vec_dupv16hf */

            case E_V16HFmode:
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !
#line 27309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9116; /* avx2_pbroadcastv16hf_1 */

            default:
              return -1;
            }

        case E_V8HFmode:
          if (pattern932 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
            return -1;
          if (
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9108; /* avx2_pbroadcastv8hf */
          if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9229; /* avx512fp16_vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x2) != E_V32BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9109; /* avx2_pbroadcastv32bf */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9231; /* avx512bw_vec_dupv32bf */

            case E_V32BFmode:
              if (!nonimmediate_operand (operands[1], E_V32BFmode)
                  || !(
#line 27712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9188; /* avx512bw_vec_dupv32bf_1 */

            default:
              return -1;
            }

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9110; /* avx2_pbroadcastv16bf */
              if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9233; /* avx512vl_vec_dupv16bf */

            case E_V16BFmode:
              if (!nonimmediate_operand (operands[1], E_V16BFmode)
                  || !
#line 27309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9117; /* avx2_pbroadcastv16bf_1 */

            default:
              return -1;
            }

        case E_V8BFmode:
          if (pattern932 (x2, 
E_V8BFmode, 
E_BFmode) != 0)
            return -1;
          if (
#line 27295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9111; /* avx2_pbroadcastv8bf */
          if (!(
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9235; /* avx512vl_vec_dupv8bf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (register_operand (operands[1], E_V2DFmode)
              && 
#line 27700 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9182; /* avx2_vec_dupv4df */
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9209; /* avx512vl_vec_dupv4df */

        case E_V2DFmode:
          if (pattern932 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9211; /* avx512vl_vec_dupv2df */

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern928 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V16SImode) != 0
              || !(
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9323; /* *avx512dq_broadcastv16si */

        case E_V8SImode:
          if (pattern928 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V8SImode) != 0
              || !(
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9325; /* *avx512dq_broadcastv8si */

        case E_V4SImode:
          if (pattern932 (x2, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9327; /* *avx512dq_broadcastv4si */

        case E_V16SFmode:
          if (pattern928 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V16SFmode) != 0
              || !(
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28036 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9329; /* *avx512dq_broadcastv16sf */

        case E_V8SFmode:
          if (pattern928 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V8SFmode) != 0
              || !(
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28036 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9331; /* *avx512dq_broadcastv8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern536 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5866; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5893; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5920; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5947; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5974; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6001; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6028; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6055; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6082; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6109; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6136; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6163; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5869; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5896; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5923; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5950; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5977; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6004; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6031; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6058; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6085; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6112; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6139; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6166; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5872; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5899; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5926; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5953; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5980; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6007; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6034; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6061; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6088; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6115; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6142; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6169; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6934; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6943; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6952; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6961; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6970; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6979; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6988; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6997; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 7006; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7015; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7024; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 7033; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6514; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6541; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6568; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6595; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6622; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6649; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6676; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6703; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6730; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6757; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6784; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6811; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6517; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6544; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6571; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6598; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6625; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6652; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6679; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6706; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6733; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6760; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6787; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6814; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6520; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6547; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6574; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6601; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6628; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6655; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6682; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6709; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6736; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6763; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6790; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6817; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      return recog_184 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_181 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_204 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_192 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_179 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_186 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_203 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_200 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_197 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_198 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_178 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x4;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1013 (x3, 
E_V4SFmode) != 0
              || !
#line 4365 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3279; /* sse_vmmaskcmpv4sf3 */

        case E_V2DFmode:
          if (pattern1013 (x3, 
E_V2DFmode) != 0
              || !(
#line 4365 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3280; /* sse2_vmmaskcmpv2df3 */

        default:
          return -1;
        }

    case AND:
      return recog_191 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_205 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_196 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_182 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_202 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_201 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_195 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_199 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_189 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern773 (x3, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4742; /* avx512fp16_vcvtpd2ph_v8df_mask */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4750; /* avx512fp16_vcvtps2ph_v8sf_mask */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern774 (x3, 
E_V16HFmode, 
E_HImode, 
E_V16SFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4746; /* avx512fp16_vcvtps2ph_v16sf_mask */

        case E_V8SFmode:
          if (pattern774 (x3, 
E_V8SFmode, 
E_QImode, 
E_V8DFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10099 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5180; /* avx512f_cvtpd2ps512_mask */

        case E_V4SFmode:
          if (pattern774 (x3, 
E_V4SFmode, 
E_QImode, 
E_V4DFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10109 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL
   && (!false || TARGET_AVX10_2_256))))
            return -1;
          return 5184; /* avx_cvtpd2ps256_mask */

        case E_V16BFmode:
          if (pattern147 (x3, 
E_V16BFmode, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31180 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31108 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10351; /* avx512f_cvtneps2bf16_v16sf_mask */

        case E_V8BFmode:
          if (pattern147 (x3, 
E_V8BFmode, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31180 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31108 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10353; /* avx512f_cvtneps2bf16_v8sf_mask */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_180 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      switch (pattern138 (x3))
        {
        case 0:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7244; /* avx512f_ss_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15320 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15237 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7280; /* avx512vl_ss_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7247; /* avx512f_ss_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7250; /* avx512f_ss_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7253; /* avx512f_ss_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15320 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7277; /* avx512vl_ss_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15220 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7260; /* avx512bw_ss_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15320 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7274; /* avx512vl_ss_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_190 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      switch (pattern138 (x3))
        {
        case 0:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7246; /* avx512f_us_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15320 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15237 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7282; /* avx512vl_us_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7249; /* avx512f_us_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7252; /* avx512f_us_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7255; /* avx512f_us_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15320 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7279; /* avx512vl_us_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15220 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7262; /* avx512bw_us_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15320 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7276; /* avx512vl_us_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7515; /* *avx512bw_ssaddv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7523; /* *avx2_ssaddv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands))))
            return -1;
          return 7531; /* *sse2_ssaddv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7539; /* *avx512bw_ssaddv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7547; /* *avx2_ssaddv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands))))
            return -1;
          return 7555; /* *sse2_ssaddv8hi3_mask */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7517; /* *avx512bw_usaddv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7525; /* *avx2_usaddv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V16QImode, operands))))
            return -1;
          return 7533; /* *sse2_usaddv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7541; /* *avx512bw_usaddv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7549; /* *avx2_usaddv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V8HImode, operands))))
            return -1;
          return 7557; /* *sse2_usaddv8hi3_mask */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7519; /* *avx512bw_sssubv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7527; /* *avx2_sssubv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V16QImode, operands))))
            return -1;
          return 7535; /* *sse2_sssubv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7543; /* *avx512bw_sssubv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7551; /* *avx2_sssubv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V8HImode, operands))))
            return -1;
          return 7559; /* *sse2_sssubv8hi3_mask */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7521; /* *avx512bw_ussubv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7529; /* *avx2_ussubv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands))))
            return -1;
          return 7537; /* *sse2_ussubv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7545; /* *avx512bw_ussubv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7553; /* *avx2_ussubv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands))))
            return -1;
          return 7561; /* *sse2_ussubv8hi3_mask */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_185 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_188 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_187 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern142 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7715; /* avx512f_rolvv16si_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7719; /* avx512vl_rolvv8si_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7723; /* avx512vl_rolvv4si_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7727; /* avx512f_rolvv8di_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7731; /* avx512vl_rolvv4di_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7735; /* avx512vl_rolvv2di_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7739; /* avx512f_rolv16si_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7743; /* avx512vl_rolv8si_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7747; /* avx512vl_rolv4si_mask */

        case 9:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7751; /* avx512f_rolv8di_mask */

        case 10:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7755; /* avx512vl_rolv4di_mask */

        case 11:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7759; /* avx512vl_rolv2di_mask */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern142 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7717; /* avx512f_rorvv16si_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7721; /* avx512vl_rorvv8si_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7725; /* avx512vl_rorvv4si_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7729; /* avx512f_rorvv8di_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7733; /* avx512vl_rorvv4di_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7737; /* avx512vl_rorvv2di_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7741; /* avx512f_rorv16si_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7745; /* avx512vl_rorv8si_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7749; /* avx512vl_rorv4si_mask */

        case 9:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7753; /* avx512f_rorv8di_mask */

        case 10:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7757; /* avx512vl_rorv4di_mask */

        case 11:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7761; /* avx512vl_rorv2di_mask */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern143 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7779; /* *avx512f_umaxv16si3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7787; /* *avx512f_umaxv8si3_mask */

        case 2:
          if (nonimmediate_operand (operands[1], E_V4SImode)
              && nonimmediate_operand (operands[2], E_V4SImode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7795; /* *avx512f_umaxv4si3_mask */
          if (!vector_operand (operands[1], E_V4SImode)
              || !vector_operand (operands[2], E_V4SImode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7885; /* *sse4_1_umaxv4si3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7803; /* *avx512f_umaxv8di3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7811; /* *avx512f_umaxv4di3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7819; /* *avx512f_umaxv2di3_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7827; /* *avx512bw_umaxv64qi3_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7835; /* *avx512bw_umaxv16qi3_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7843; /* *avx512bw_umaxv32qi3_mask */

        case 9:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7851; /* *avx512bw_umaxv32hi3_mask */

        case 10:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7859; /* *avx512bw_umaxv16hi3_mask */

        case 11:
          if (nonimmediate_operand (operands[1], E_V8HImode)
              && nonimmediate_operand (operands[2], E_V8HImode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7867; /* *avx512bw_umaxv8hi3_mask */
          if (!vector_operand (operands[1], E_V8HImode)
              || !vector_operand (operands[2], E_V8HImode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7881; /* *sse4_1_umaxv8hi3_mask */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern143 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7781; /* *avx512f_uminv16si3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7789; /* *avx512f_uminv8si3_mask */

        case 2:
          if (nonimmediate_operand (operands[1], E_V4SImode)
              && nonimmediate_operand (operands[2], E_V4SImode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7797; /* *avx512f_uminv4si3_mask */
          if (!vector_operand (operands[1], E_V4SImode)
              || !vector_operand (operands[2], E_V4SImode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7887; /* *sse4_1_uminv4si3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7805; /* *avx512f_uminv8di3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7813; /* *avx512f_uminv4di3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7821; /* *avx512f_uminv2di3_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7829; /* *avx512bw_uminv64qi3_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7837; /* *avx512bw_uminv16qi3_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7845; /* *avx512bw_uminv32qi3_mask */

        case 9:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7853; /* *avx512bw_uminv32hi3_mask */

        case 10:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7861; /* *avx512bw_uminv16hi3_mask */

        case 11:
          if (nonimmediate_operand (operands[1], E_V8HImode)
              && nonimmediate_operand (operands[2], E_V8HImode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7869; /* *avx512bw_uminv8hi3_mask */
          if (!vector_operand (operands[1], E_V8HImode)
              || !vector_operand (operands[2], E_V8HImode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7883; /* *sse4_1_uminv8hi3_mask */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_183 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern146 (x3))
        {
        case 0:
          if (!(
#line 23380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8663; /* absv16si2_mask */

        case 1:
          if (!(
#line 23380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8664; /* absv8si2_mask */

        case 2:
          if (!(
#line 23380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8665; /* absv4si2_mask */

        case 3:
          if (!(
#line 23380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8666; /* absv8di2_mask */

        case 4:
          if (!(
#line 23380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8667; /* absv4di2_mask */

        case 5:
          if (!(
#line 23380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8668; /* absv2di2_mask */

        case 6:
          if (!(
#line 23393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8669; /* absv64qi2_mask */

        case 7:
          if (!(
#line 23393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8670; /* absv16qi2_mask */

        case 8:
          if (!(
#line 23393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8671; /* absv32qi2_mask */

        case 9:
          if (!(
#line 23393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8672; /* absv32hi2_mask */

        case 10:
          if (!(
#line 23393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8673; /* absv16hi2_mask */

        case 11:
          if (!(
#line 23393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8674; /* absv8hi2_mask */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_194 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_193 (x1, insn, pnum_clobbers);

    case CLZ:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern144 (x3, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10064; /* clzv16si2_mask */

        case E_V8SImode:
          if (pattern144 (x3, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10066; /* clzv8si2_mask */

        case E_V4SImode:
          if (pattern144 (x3, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10068; /* clzv4si2_mask */

        case E_V8DImode:
          if (pattern144 (x3, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10070; /* clzv8di2_mask */

        case E_V4DImode:
          if (pattern144 (x3, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10072; /* clzv4di2_mask */

        case E_V2DImode:
          if (pattern144 (x3, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10074; /* clzv2di2_mask */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern146 (x3))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10137; /* vpopcountv16si_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10139; /* vpopcountv8si_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10141; /* vpopcountv4si_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10143; /* vpopcountv8di_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10145; /* vpopcountv4di_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10147; /* vpopcountv2di_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10157; /* vpopcountv64qi_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10159; /* vpopcountv16qi_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10161; /* vpopcountv32qi_mask */

        case 9:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10163; /* vpopcountv32hi_mask */

        case 10:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10165; /* vpopcountv16hi_mask */

        case 11:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10167; /* vpopcountv8hi_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern514 (x3))
            {
            case 0:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4484; /* avx512fp16_vcvtuw2ph_v8hi */

            case 1:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4506; /* avx512fp16_vcvtudq2ph_v8si */

            case 2:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4522; /* avx512fp16_vcvtuqq2ph_v8di */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern515 (x3))
            {
            case 0:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4490; /* avx512fp16_vcvtuw2ph_v16hi */

            case 1:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4514; /* avx512fp16_vcvtudq2ph_v16si */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HImode)
              || !(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4498; /* avx512fp16_vcvtuw2ph_v32hi */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode
              || !nonimmediate_operand (operands[1], E_V16SImode)
              || !(
#line 8663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4825; /* *floatunsv16siv16sf2 */

        case E_V8SFmode:
          switch (pattern517 (x3, 
E_V8SFmode))
            {
            case 0:
              if (!(
#line 8663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4829; /* *floatunsv8siv8sf2 */

            case 1:
              if (!(
#line 9198 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4977; /* floatunsv8div8sf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern518 (x3, 
E_V4SFmode))
            {
            case 0:
              if (!(
#line 8663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4833; /* *floatunsv4siv4sf2 */

            case 1:
              if (!(
#line 9198 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4985; /* floatunsv4div4sf2 */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern516 (x3))
            {
            case 0:
              if (!
#line 8900 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_MMX_WITH_SSE && TARGET_AVX512VL))
                return -1;
              return 4902; /* floatunsv2siv2df2 */

            case 1:
              if (!(
#line 9184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4971; /* floatunsv2div2df2 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 9184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4957; /* floatunsv8div8df2 */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 9348 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4995; /* floatunsv8siv8df2 */

            default:
              return -1;
            }

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 9184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4965; /* floatunsv4div4df2 */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 9348 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4997; /* floatunsv4siv4df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_V4SImode)
          || !
#line 9360 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 4999; /* *floatunsv2siv2df2 */

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (pattern181 (x3))
        {
        case 0:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2687; /* *subv32hf3 */

        case 1:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2695; /* *subv16hf3 */

        case 2:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2703; /* *subv8hf3 */

        case 3:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2711; /* *subv16sf3 */

        case 4:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2719; /* *subv8sf3 */

        case 5:
          if (!
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2727; /* *subv4sf3 */

        case 6:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2735; /* *subv8df3 */

        case 7:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2743; /* *subv4df3 */

        case 8:
          if (!(
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2751; /* *subv2df3 */

        case 9:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V64QImode, operands)) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7467; /* *subv64qi3 */

        case 10:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V32QImode, operands)) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7469; /* *subv32qi3 */

        case 11:
          if (!
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V16QImode, operands)))
            return -1;
          return 7471; /* *subv16qi3 */

        case 12:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V32HImode, operands)) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7473; /* *subv32hi3 */

        case 13:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V16HImode, operands)) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7475; /* *subv16hi3 */

        case 14:
          if (!
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V8HImode, operands)))
            return -1;
          return 7477; /* *subv8hi3 */

        case 15:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V16SImode, operands)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7479; /* *subv16si3 */

        case 16:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V8SImode, operands)) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7481; /* *subv8si3 */

        case 17:
          if (!
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V4SImode, operands)))
            return -1;
          return 7483; /* *subv4si3 */

        case 18:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V8DImode, operands)) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7485; /* *subv8di3 */

        case 19:
          if (!(
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V4DImode, operands)) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7487; /* *subv4di3 */

        case 20:
          if (!
#line 16280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V2DImode, operands)))
            return -1;
          return 7489; /* *subv2di3 */

        case 21:
          if (!(
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10611; /* avx10_2_subbf16_v32bf */

        case 22:
          if (!
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10619; /* avx10_2_subbf16_v16bf */

        case 23:
          if (!
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10627; /* avx10_2_subbf16_v8bf */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern188 (x3))
        {
        case 0:
          if (!
#line 22580 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8593; /* avx2_phsubwv16hi3 */

        case 1:
          if (!
#line 22603 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8597; /* ssse3_phsubwv8hi3 */

        case 2:
          if (!
#line 22670 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8604; /* avx2_phsubdv8si3 */

        case 3:
          if (!
#line 22691 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8606; /* ssse3_phsubdv4si3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern190 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 26443 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9029; /* xop_phsubbw */

        case 1:
          if (!
#line 26463 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9030; /* xop_phsubwd */

        case 2:
          if (!
#line 26481 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9031; /* xop_phsubdq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case CLOBBER:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MEM:
          if (GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SCRATCH)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (push_operand (operands[0], E_SImode)
                  && general_no_elim_operand (operands[1], E_SImode)
                  && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode))
                return 74; /* *pushsi2_prologue */
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !pop_operand (operands[1], E_SImode)
                  || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode))
                return -1;
              return 78; /* *popsi1_epilogue */

            case E_DImode:
              if (push_operand (operands[0], E_DImode)
                  && general_no_elim_operand (operands[1], E_DImode)
                  && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode))
                return 75; /* *pushdi2_prologue */
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !pop_operand (operands[1], E_DImode)
                  || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode))
                return -1;
              return 79; /* *popdi1_epilogue */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (const0_operand (operands[1], E_SImode))
                {
                  if (register_operand (operands[0], E_SImode)
                      && 
#line 2424 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                    return 84; /* *movsi_xor */
                  if (memory_operand (operands[0], E_SImode)
                      && 
#line 2434 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                    return 87; /* *movsi_and */
                }
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !constm1_operand (operands[1], E_SImode)
                  || !
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 90; /* *movsi_or */

            case E_DImode:
              if (const0_operand (operands[1], E_DImode))
                {
                  if (register_operand (operands[0], E_DImode)
                      && (
#line 2424 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 85; /* *movdi_xor */
                  if (memory_operand (operands[0], E_DImode)
                      && (
#line 2434 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 88; /* *movdi_and */
                }
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !constm1_operand (operands[1], E_DImode)
                  || !(
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 91; /* *movdi_or */

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && const0_operand (operands[1], E_HImode)
                  && 
#line 2434 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                return 86; /* *movhi_and */
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || !constm1_operand (operands[1], E_HImode)
                  || !
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 89; /* *movhi_or */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 107; /* swapsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 108; /* swapdi */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 109; /* *swapqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 110; /* *swaphi */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 4644 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 173; /* *swapxf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 72
              || GET_MODE (x8) != E_XFmode
              || !register_operand (operands[0], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!const1_operand (operands[3], E_SFmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_XFmode)
              || !
#line 24085 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1720; /* fptanxf4_i387 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_DImode)
          && push_operand (operands[0], E_DImode)
          && 
#line 3910 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return 161; /* pushp_di */
      if (!pop_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || !
#line 3918 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_PPX))
        return -1;
      return 162; /* popp_di */

    default:
      return -1;
    }
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern338 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !general_operand (operands[2], E_QImode)
              || !
#line 6677 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 287; /* *addqi_1_zexthi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode)
                  || !
#line 6677 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 289; /* *addqi_1_zextsi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 293; /* *addhi_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode)
                  || !
#line 6677 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 291; /* *addqi_1_zextdi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 295; /* *addhi_1_zextdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !
#line 6760 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 296; /* addsi_1_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case LTU:
        case UNLT:
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 1);
          operands[1] = x10;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (pattern1151 (x3))
            {
            case 0:
              if (pattern1750 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 465; /* *addqi3_carry_zexthi */

            case 1:
              if (pattern1750 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 466; /* *addqi3_carry_zextsi */

            case 2:
              if (pattern1750 (x5, 
E_HImode) != 0
                  || !
#line 8914 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 468; /* *addhi3_carry_zextsi */

            case 3:
              if (pattern1750 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 467; /* *addqi3_carry_zextdi */

            case 4:
              if (pattern1750 (x5, 
E_HImode) != 0
                  || !
#line 8914 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 469; /* *addhi3_carry_zextdi */

            case 5:
              if (pattern1750 (x5, 
E_SImode) != 0
                  || !
#line 8933 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 470; /* *addsi3_carry_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern1152 (x3))
        {
        case 0:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 471; /* *addqi3_carry_zexthi_0 */

        case 1:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 472; /* *addqi3_carry_zextsi_0 */

        case 2:
          if (!ix86_carry_flag_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 8966 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 474; /* *addhi3_carry_zextsi_0 */

        case 3:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 473; /* *addqi3_carry_zextdi_0 */

        case 4:
          if (!ix86_carry_flag_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 8966 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 475; /* *addhi3_carry_zextdi_0 */

        case 5:
          if (!ix86_carry_flag_operator (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 8980 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 476; /* *addsi3_carry_zext_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern1152 (x3))
        {
        case 0:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 477; /* *addqi3_carry_zexthi_0r */

        case 1:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 478; /* *addqi3_carry_zextsi_0r */

        case 2:
          if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 9011 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 480; /* *addhi3_carry_zextsi_0r */

        case 3:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 479; /* *addqi3_carry_zextdi_0r */

        case 4:
          if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 9011 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 481; /* *addhi3_carry_zextdi_0r */

        case 5:
          if (!ix86_carry_flag_unset_operator (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 9025 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 482; /* *addsi3_carry_zext_0r */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern1153 (x5) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 23231 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_X32))
        return -1;
      return 1663; /* *add_tp_x32_zext */

    default:
      return -1;
    }
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[3], E_SFmode)
          || !nonimmediate_operand (operands[4], E_V4SFmode)
          || !
#line 5911 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
        return -1;
      *pnum_clobbers = 2;
      return 223; /* *fixuns_truncsf_1 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[3], E_DFmode)
          || !nonimmediate_operand (operands[4], E_V2DFmode)
          || !
#line 5911 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)))
        return -1;
      *pnum_clobbers = 2;
      return 224; /* *fixuns_truncdf_1 */

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      if (pnum_clobbers == NULL
          || !register_operand (operands[1], E_DImode))
        return -1;
      switch (pattern938 (x1))
        {
        case 0:
          if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          *pnum_clobbers = 2;
          return 254; /* floatdisf2_i387_with_xmm */

        case 1:
          if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          *pnum_clobbers = 2;
          return 255; /* floatdidf2_i387_with_xmm */

        case 2:
          if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)))
            return -1;
          *pnum_clobbers = 2;
          return 256; /* floatdixf2_i387_with_xmm */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern682 (x1, 
E_V2SImode, 
E_V2SFmode) != 0
          || !
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2081; /* mmx_floatv2siv2sf2 */

    default:
      return -1;
    }
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern557 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 266; /* *adddi3_doubleword */
          if (!x86_64_general_operand (operands[2], E_DImode)
              || !(
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 285; /* *adddi_1 */

        case E_TImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern563 (x5, 
E_TImode) != 0
              || !(
#line 6465 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 267; /* *addti3_doubleword */

        case E_SImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern565 (x5) != 0
              || !
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 283; /* *addsi_1 */

        case E_HImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern564 (x5, 
E_HImode) != 0
              || !
#line 6813 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 298; /* *addhi_1 */

        case E_QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern564 (x5, 
E_QImode) != 0
              || !
#line 6870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          return 300; /* *addqi_1 */

        case E_V2QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern567 (x5, 
E_V2QImode) != 0
              || !
#line 3241 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          return 2136; /* addv2qi3 */

        default:
          return -1;
        }

    case 1:
      x2 = XVECEXP (x1, 0, 1);
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x2, 1))
        {
        case 110:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern210 (x5, 
E_V2SFmode) != 0
              || !
#line 746 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (PLUS, V2SFmode, operands)))
            return -1;
          return 2052; /* *mmx_addv2sf3 */

        case 174:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern567 (x5, 
E_QImode) != 0
                  || !(
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2597; /* kaddqi */

            case E_HImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern567 (x5, 
E_HImode) != 0
                  || !(
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2598; /* kaddhi */

            case E_SImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern567 (x5, 
E_SImode) != 0
                  || !(
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2079 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 2599; /* kaddsi */

            case E_DImode:
              x4 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x4, 1);
              if (pattern567 (x5, 
E_DImode) != 0
                  || !(
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2079 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 2600; /* kadddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (!
#line 6946 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 301; /* *addqi_1_slp */

    case 3:
      if (!
#line 6946 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 302; /* *addhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_382 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pattern581 (x1, 
PLUS, 
E_CCZmode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  operands[1] = x9;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (pattern1752 (x8, 
E_QImode) != 0
          || !
#line 778 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])))
        return -1;
      return 11037; /* *atomic_fetch_add_cmpqi */

    case E_HImode:
      if (pattern1752 (x8, 
E_HImode) != 0
          || !
#line 778 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])))
        return -1;
      return 11038; /* *atomic_fetch_add_cmphi */

    case E_SImode:
      if (pattern1752 (x8, 
E_SImode) != 0
          || !
#line 778 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])))
        return -1;
      return 11039; /* *atomic_fetch_add_cmpsi */

    case E_DImode:
      if (pattern1752 (x8, 
E_DImode) != 0
          || !(
#line 778 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 11040; /* *atomic_fetch_add_cmpdi */

    default:
      return -1;
    }
}

 int
recog_385 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      res = recog_381 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x6) != SUBREG)
        return -1;
      switch (pattern816 (x1))
        {
        case 0:
          if (!
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return -1;
          return 782; /* *andqi_exthi_1_cc */

        case 1:
          if (!
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return -1;
          return 785; /* *andqi_extsi_1_cc */

        case 2:
          if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 788; /* *andqi_extdi_1_cc */

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (x5))
        {
        case E_SImode:
          if (pattern1427 (x6, 
E_SImode) != 0
              || !
#line 13386 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)))
            return -1;
          return 817; /* *andn_si_ccno */

        case E_DImode:
          if (pattern1427 (x6, 
E_DImode) != 0
              || !(
#line 13386 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 818; /* *andn_di_ccno */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != AND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != NEG)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (pattern1494 (x1))
            {
            case 0:
              if (!
#line 21790 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)))
                return -1;
              return 1572; /* *bmi_blsi_si_cmp */

            case 1:
              if (!(
#line 21790 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1573; /* *bmi_blsi_di_cmp */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern1237 (x1))
            {
            case 0:
              if (!
#line 21849 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)))
                return -1;
              return 1576; /* *bmi_blsi_si_ccno */

            case 1:
              if (!(
#line 21849 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1577; /* *bmi_blsi_di_ccno */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x14 = XEXP (x6, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
          || pattern815 (x2, 
E_CCZmode) != 0)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != AND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != PLUS)
            return -1;
          x15 = XEXP (x13, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (pattern1494 (x1))
            {
            case 0:
              if (!
#line 21942 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1584; /* *bmi_blsr_si_cmp */

            case 1:
              if (!(
#line 21942 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1585; /* *bmi_blsr_di_cmp */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern1237 (x1))
            {
            case 0:
              if (!
#line 21999 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1588; /* *bmi_blsr_si_ccz */

            case 1:
              if (!(
#line 21999 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1589; /* *bmi_blsr_di_ccz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (pattern363 (x1, 
AND))
        {
        case 0:
          return 11090; /* atomic_and_fetch_cmp_0qi_1 */

        case 1:
          return 11093; /* atomic_and_fetch_cmp_0hi_1 */

        case 2:
          return 11096; /* atomic_and_fetch_cmp_0si_1 */

        case 3:
          if (!
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 11099; /* atomic_and_fetch_cmp_0di_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      res = recog_389 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern817 (x4) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern229 (x5, 
E_CCmode, 
17) != 0
          || GET_MODE (x3) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 0);
      switch (GET_CODE (x8))
        {
        case STRICT_LOW_PART:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_QImode))
            return -1;
          switch (pattern1798 ())
            {
            case 0:
              if (!
#line 8215 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 405; /* *subqi_exthi_1_slp */

            case 1:
              if (!
#line 8215 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 406; /* *subqi_extsi_1_slp */

            case 2:
              if (!(
#line 8215 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 407; /* *subqi_extdi_1_slp */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x8;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          switch (pattern1798 ())
            {
            case 0:
              return 416; /* *subqi_exthi_0 */

            case 1:
              return 417; /* *subqi_extsi_0 */

            case 2:
              if (!
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 418; /* *subqi_extdi_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern372 (x5) != 0)
        return -1;
      switch (pattern1162 (x2))
        {
        case 0:
          if (!(
#line 8103 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 382; /* *subdi3_doubleword_zext */

        case 1:
          if (!(
#line 8103 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 383; /* *subti3_doubleword_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern687 (x1))
        {
        case 0:
          if (pattern1564 (x3, 
E_QImode) != 0
              || !
#line 9349 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 491; /* *subqi3_carry_0 */

        case 1:
          if (pattern1564 (x3, 
E_HImode) != 0
              || !
#line 9349 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 492; /* *subhi3_carry_0 */

        case 2:
          if (pattern1564 (x3, 
E_SImode) != 0
              || !
#line 9349 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 493; /* *subsi3_carry_0 */

        case 3:
          if (pattern1564 (x3, 
E_DImode) != 0
              || !(
#line 9349 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 494; /* *subdi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern687 (x1))
        {
        case 0:
          if (pattern1565 (x3, 
E_QImode) != 0
              || !
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 495; /* *subqi3_carry_0r */

        case 1:
          if (pattern1565 (x3, 
E_HImode) != 0
              || !
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 496; /* *subhi3_carry_0r */

        case 2:
          if (pattern1565 (x3, 
E_SImode) != 0
              || !
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 497; /* *subsi3_carry_0r */

        case 3:
          if (pattern1565 (x3, 
E_DImode) != 0
              || !(
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 498; /* *subdi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern691 (x1))
        {
        case 0:
          if (!
#line 10307 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 582; /* *subqi3_eq_0 */

        case 1:
          if (!
#line 10307 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 583; /* *subhi3_eq_0 */

        case 2:
          if (!
#line 10307 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 584; /* *subsi3_eq_0 */

        case 3:
          if (!(
#line 10307 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 585; /* *subdi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern691 (x1))
        {
        case 0:
          if (!
#line 10328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 586; /* *subqi3_ne_0 */

        case 1:
          if (!
#line 10328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 587; /* *subhi3_ne_0 */

        case 2:
          if (!
#line 10328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 588; /* *subsi3_ne_0 */

        case 3:
          if (!(
#line 10328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 589; /* *subdi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != ZERO_EXTEND)
        return -1;
      x9 = XEXP (x6, 0);
      switch (GET_CODE (x9))
        {
        case TRUNCATE:
          if (GET_MODE (x9) != E_QImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MOD
              || GET_MODE (x10) != E_HImode
              || XWINT (x7, 0) != 8L)
            return -1;
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != TRUNCATE
              || GET_MODE (x11) != E_QImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != DIV
              || GET_MODE (x12) != E_HImode)
            return -1;
          x13 = XVECEXP (x1, 0, 1);
          if (pattern229 (x13, 
E_CCmode, 
17) != 0
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || GET_MODE (x6) != E_HImode)
            return -1;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x15 = XEXP (x10, 1);
          if (GET_MODE (x15) != E_HImode
              || GET_MODE (x8) != E_HImode)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_MODE (x16) != E_HImode)
            return -1;
          x17 = XEXP (x12, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_CODE (x15))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x18 = XEXP (x15, 0);
              operands[2] = x18;
              if (!nonimmediate_operand (operands[2], E_QImode))
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 12017 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                return -1;
              return 679; /* divmodhiqi3 */

            case ZERO_EXTEND:
              if (GET_CODE (x16) != ZERO_EXTEND)
                return -1;
              x18 = XEXP (x15, 0);
              operands[2] = x18;
              if (!nonimmediate_operand (operands[2], E_QImode))
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 12017 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                return -1;
              return 681; /* udivmodhiqi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x9;
          x13 = XVECEXP (x1, 0, 1);
          if (pattern381 (x13, 
174, 
0) != 0)
            return -1;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          switch (XWINT (x7, 0))
            {
            case 8L:
              if (pattern1569 (x4, 
E_QImode, 
E_HImode) != 0
                  || !
#line 2536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2650; /* kunpckhi */

            case 16L:
              if (pattern1569 (x4, 
E_HImode, 
E_SImode) != 0
                  || !
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                return -1;
              return 2651; /* kunpcksi */

            case 32L:
              if (pattern1569 (x4, 
E_SImode, 
E_DImode) != 0
                  || !
#line 2562 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                return -1;
              return 2652; /* kunpckdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern229 (x13, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern1047 (x4, 
LSHIFTRT))
        {
        case 0:
          x8 = XEXP (x4, 1);
          x11 = XEXP (x8, 0);
          x12 = XEXP (x11, 0);
          x17 = XEXP (x12, 0);
          operands[1] = x17;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x5, 1);
              x20 = XEXP (x7, 0);
              operands[2] = x20;
              if (rtx_equal_p (x6, operands[0]))
                {
                  x21 = XEXP (x11, 1);
                  x22 = XEXP (x21, 1);
                  x23 = XEXP (x22, 0);
                  if (rtx_equal_p (x23, operands[2])
                      && 
#line 15401 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && true))
                    return 1063; /* x86_64_shld */
                }
            }
          operands[2] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          x20 = XEXP (x7, 0);
          operands[3] = x20;
          x21 = XEXP (x11, 1);
          x22 = XEXP (x21, 1);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[3])
              || !
#line 15422 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1065; /* x86_64_shld_ndd */

        case 1:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || pattern1046 (x4, 
E_SImode, 
E_DImode) != 0)
            return -1;
          x8 = XEXP (x4, 1);
          x11 = XEXP (x8, 0);
          x12 = XEXP (x11, 0);
          x17 = XEXP (x12, 0);
          operands[1] = x17;
          x7 = XEXP (x5, 1);
          x20 = XEXP (x7, 0);
          operands[2] = x20;
          if (rtx_equal_p (x6, operands[0]))
            {
              x21 = XEXP (x11, 1);
              x22 = XEXP (x21, 1);
              x23 = XEXP (x22, 0);
              if (rtx_equal_p (x23, operands[2]))
                return 1075; /* x86_shld */
            }
          operands[2] = x17;
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          operands[3] = x20;
          x21 = XEXP (x11, 1);
          x22 = XEXP (x21, 1);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[3])
              || !
#line 15653 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1077; /* x86_shld_ndd */

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SUBREG:
              switch (pattern1240 (x4, 
LSHIFTRT))
                {
                case 0:
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  if (pattern1677 (x4) == 0
                      && 
#line 15437 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                    return 1067; /* x86_64_shld_1 */
                  operands[3] = x7;
                  if (pattern1678 (x4) != 0
                      || !
#line 15459 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  if (pattern1679 (x4) == 0
                      && 
#line 15669 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                    return 1079; /* x86_shld_1 */
                  operands[3] = x7;
                  if (pattern1680 (x4) != 0
                      || !
#line 15691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1242 (x4))
                {
                case 0:
                  if (!
#line 15531 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (!
#line 15763 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (rtx_equal_p (x6, operands[0]))
                        {
                          x24 = XEXP (x8, 1);
                          x25 = XEXP (x24, 1);
                          if (rtx_equal_p (x25, operands[2])
                              && 
#line 15584 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            return 1072; /* *x86_64_shld_2 */
                        }
                    }
                  operands[2] = x11;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  operands[1] = x6;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x24 = XEXP (x8, 1);
                  x25 = XEXP (x24, 1);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 15605 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (rtx_equal_p (x6, operands[0]))
                        {
                          x24 = XEXP (x8, 1);
                          x25 = XEXP (x24, 1);
                          if (rtx_equal_p (x25, operands[2])
                              && 
#line 15815 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            return 1084; /* *x86_shld_2 */
                        }
                    }
                  operands[2] = x11;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x6;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x24 = XEXP (x8, 1);
                  x25 = XEXP (x24, 1);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 15836 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x6, 0) != 1L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (pattern229 (x13, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern370 (x4))
        {
        case 0:
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern946 (x4))
                {
                case 0:
                  if (
#line 18805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    return 1391; /* *btssi */
                  break;

                case 1:
                  if ((
#line 18805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1393; /* *btsdi */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x7) != SUBREG)
            return -1;
          switch (pattern1329 (x4))
            {
            case 0:
              if (!
#line 18824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18852 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18852 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          x4 = XEXP (x2, 1);
          if (GET_MODE (x4) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && nonmemory_operand (operands[2], E_QImode)
              && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return 1131; /* ashrdi3_doubleword */
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (const_int_operand (operands[2], E_QImode)
              && (
#line 17244 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1169; /* ashrdi3_cvt */
          if (!nonmemory_operand (operands[2], E_QImode)
              || !(
#line 17323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1178; /* *ashrdi3_1 */

        case E_TImode:
          x4 = XEXP (x2, 1);
          if (pattern1250 (x4, 
E_TImode) != 0
              || !
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1133; /* ashrti3_doubleword */

        case E_SImode:
          x4 = XEXP (x2, 1);
          if (pattern1497 (x4, 
E_SImode) != 0
              || !
#line 17323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 1176; /* *ashrsi3_1 */

        case E_QImode:
          x4 = XEXP (x2, 1);
          if (pattern1497 (x4, 
E_QImode) != 0
              || !
#line 17532 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 1209; /* *ashrqi3_1 */

        case E_HImode:
          x4 = XEXP (x2, 1);
          if (pattern1497 (x4, 
E_HImode) != 0
              || !
#line 17532 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 1211; /* *ashrhi3_1 */

        case E_V2QImode:
          x4 = XEXP (x2, 1);
          if (pattern1250 (x4, 
E_V2QImode) != 0
              || !
#line 4007 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
            return -1;
          return 2216; /* ashrv2qi3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      switch (pattern1251 (x2))
        {
        case 0:
          if (!
#line 17638 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1217; /* *ashrqi3_1_slp */

        case 1:
          if (!
#line 17638 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1219; /* *ashrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_408 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XVECEXP (x1, 0, 0);
      x4 = XEXP (x3, 1);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      switch (XINT (x2, 1))
        {
        case 37:
          x8 = XVECEXP (x2, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !(
#line 20376 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)))
                return -1;
              return 1481; /* *sibcall_value_memory */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !(
#line 20376 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)))
                return -1;
              return 1482; /* *sibcall_value_memory */

            default:
              return -1;
            }

        case 21:
          x8 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 7
              || !constant_call_address_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1528 (x1, 
E_SImode) != 0
                  || !(
#line 23091 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1654; /* *tls_local_dynamic_base_64_si */

            case E_DImode:
              if (pattern1528 (x1, 
E_DImode) != 0
                  || !(
#line 23091 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1655; /* *tls_local_dynamic_base_64_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x2, 1) != 20)
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 7)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      x4 = XEXP (x3, 1);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!constant_call_address_operand (operands[2], E_VOIDmode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x8 = XVECEXP (x2, 0, 0);
      operands[1] = x8;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1631 (x1, 
E_SImode) != 0
              || !(
#line 22976 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1650; /* *tls_global_dynamic_64_si */

        case E_DImode:
          if (pattern1631 (x1, 
E_DImode) != 0
              || !(
#line 22976 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1651; /* *tls_global_dynamic_64_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != TRUNCATE)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != TRUNCATE)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x5, 0);
  operands[2] = x9;
  x10 = XEXP (x6, 0);
  operands[3] = x10;
  if (!nonimmediate_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern1334 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
          || !
#line 26510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 9033; /* xop_pperm_pack_v2di_v4si */

    case E_V8HImode:
      if (pattern1334 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
          || !
#line 26523 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 9034; /* xop_pperm_pack_v4si_v8hi */

    case E_V16QImode:
      if (pattern1334 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
          || !
#line 26536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 9035; /* xop_pperm_pack_v8hi_v16qi */

    default:
      return -1;
    }
}

 int
recog_419 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (register_operand (operands[0], E_V64QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V64QImode)
          && register_operand (operands[2], E_V64QImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2422; /* *vmovv64qi_constm1_pternlog_false_dep */
      break;

    case E_V32QImode:
      if (register_operand (operands[0], E_V32QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32QImode)
          && register_operand (operands[2], E_V32QImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2423; /* *vmovv32qi_constm1_pternlog_false_dep */
      break;

    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16QImode)
          && register_operand (operands[2], E_V16QImode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2424; /* *vmovv16qi_constm1_pternlog_false_dep */
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HImode)
          && register_operand (operands[2], E_V32HImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2425; /* *vmovv32hi_constm1_pternlog_false_dep */
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HImode)
          && register_operand (operands[2], E_V16HImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2426; /* *vmovv16hi_constm1_pternlog_false_dep */
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HImode)
          && register_operand (operands[2], E_V8HImode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2427; /* *vmovv8hi_constm1_pternlog_false_dep */
      break;

    case E_V16SImode:
      if (register_operand (operands[0], E_V16SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SImode)
          && register_operand (operands[2], E_V16SImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2428; /* *vmovv16si_constm1_pternlog_false_dep */
      break;

    case E_V8SImode:
      if (register_operand (operands[0], E_V8SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SImode)
          && register_operand (operands[2], E_V8SImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2429; /* *vmovv8si_constm1_pternlog_false_dep */
      break;

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SImode)
          && register_operand (operands[2], E_V4SImode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2430; /* *vmovv4si_constm1_pternlog_false_dep */
      break;

    case E_V8DImode:
      if (register_operand (operands[0], E_V8DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DImode)
          && register_operand (operands[2], E_V8DImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2431; /* *vmovv8di_constm1_pternlog_false_dep */
      break;

    case E_V4DImode:
      if (register_operand (operands[0], E_V4DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DImode)
          && register_operand (operands[2], E_V4DImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2432; /* *vmovv4di_constm1_pternlog_false_dep */
      break;

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DImode)
          && register_operand (operands[2], E_V2DImode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2433; /* *vmovv2di_constm1_pternlog_false_dep */
      break;

    case E_V4TImode:
      if (register_operand (operands[0], E_V4TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4TImode)
          && register_operand (operands[2], E_V4TImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2434; /* *vmovv4ti_constm1_pternlog_false_dep */
      break;

    case E_V2TImode:
      if (register_operand (operands[0], E_V2TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2TImode)
          && register_operand (operands[2], E_V2TImode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2435; /* *vmovv2ti_constm1_pternlog_false_dep */
      break;

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V1TImode)
          && register_operand (operands[2], E_V1TImode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2436; /* *vmovv1ti_constm1_pternlog_false_dep */
      break;

    case E_V32HFmode:
      if (register_operand (operands[0], E_V32HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HFmode)
          && register_operand (operands[2], E_V32HFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2437; /* *vmovv32hf_constm1_pternlog_false_dep */
      break;

    case E_V16HFmode:
      if (register_operand (operands[0], E_V16HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HFmode)
          && register_operand (operands[2], E_V16HFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2438; /* *vmovv16hf_constm1_pternlog_false_dep */
      break;

    case E_V8HFmode:
      if (register_operand (operands[0], E_V8HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2439; /* *vmovv8hf_constm1_pternlog_false_dep */
      break;

    case E_V32BFmode:
      if (register_operand (operands[0], E_V32BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32BFmode)
          && register_operand (operands[2], E_V32BFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2440; /* *vmovv32bf_constm1_pternlog_false_dep */
      break;

    case E_V16BFmode:
      if (register_operand (operands[0], E_V16BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16BFmode)
          && register_operand (operands[2], E_V16BFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2441; /* *vmovv16bf_constm1_pternlog_false_dep */
      break;

    case E_V8BFmode:
      if (register_operand (operands[0], E_V8BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8BFmode)
          && register_operand (operands[2], E_V8BFmode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2442; /* *vmovv8bf_constm1_pternlog_false_dep */
      break;

    case E_V16SFmode:
      if (register_operand (operands[0], E_V16SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SFmode)
          && register_operand (operands[2], E_V16SFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2443; /* *vmovv16sf_constm1_pternlog_false_dep */
      break;

    case E_V8SFmode:
      if (register_operand (operands[0], E_V8SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SFmode)
          && register_operand (operands[2], E_V8SFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2444; /* *vmovv8sf_constm1_pternlog_false_dep */
      break;

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2445; /* *vmovv4sf_constm1_pternlog_false_dep */
      break;

    case E_V8DFmode:
      if (register_operand (operands[0], E_V8DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DFmode)
          && register_operand (operands[2], E_V8DFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2446; /* *vmovv8df_constm1_pternlog_false_dep */
      break;

    case E_V4DFmode:
      if (register_operand (operands[0], E_V4DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DFmode)
          && register_operand (operands[2], E_V4DFmode)
          && (
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2447; /* *vmovv4df_constm1_pternlog_false_dep */
      break;

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DFmode)
          && register_operand (operands[2], E_V2DFmode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2448; /* *vmovv2df_constm1_pternlog_false_dep */
      break;

    default:
      break;
    }
  switch (GET_CODE (x4))
    {
    case VEC_MERGE:
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1335 (x4, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 10374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5236; /* *avx512f_cvtmask2dv16si_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1335 (x4, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 10374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5237; /* *avx512vl_cvtmask2dv8si_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1335 (x4, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 10374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5238; /* *avx512vl_cvtmask2dv4si_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1335 (x4, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 10374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5239; /* *avx512f_cvtmask2qv8di_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1335 (x4, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 10374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5240; /* *avx512vl_cvtmask2qv4di_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1335 (x4, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 10374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5241; /* *avx512vl_cvtmask2qv2di_pternlog_false_dep */

        default:
          return -1;
        }

    case XOR:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1248 (x4, 
E_V16SImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 568 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7978; /* *one_cmplv16si2_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1248 (x4, 
E_V8DImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7979; /* *one_cmplv8di2_pternlog_false_dep */

        case E_V64QImode:
          if (pattern1248 (x4, 
E_V64QImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 570 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7980; /* *one_cmplv64qi2_pternlog_false_dep */

        case E_V32QImode:
          if (pattern1248 (x4, 
E_V32QImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 570 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7981; /* *one_cmplv32qi2_pternlog_false_dep */

        case E_V16QImode:
          if (pattern1248 (x4, 
E_V16QImode) != 0
              || !
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7982; /* *one_cmplv16qi2_pternlog_false_dep */

        case E_V32HImode:
          if (pattern1248 (x4, 
E_V32HImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7983; /* *one_cmplv32hi2_pternlog_false_dep */

        case E_V16HImode:
          if (pattern1248 (x4, 
E_V16HImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7984; /* *one_cmplv16hi2_pternlog_false_dep */

        case E_V8HImode:
          if (pattern1248 (x4, 
E_V8HImode) != 0
              || !
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7985; /* *one_cmplv8hi2_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1248 (x4, 
E_V8SImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7986; /* *one_cmplv8si2_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1248 (x4, 
E_V4SImode) != 0
              || !
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7987; /* *one_cmplv4si2_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1248 (x4, 
E_V4DImode) != 0
              || !(
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7988; /* *one_cmplv4di2_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1248 (x4, 
E_V2DImode) != 0
              || !
#line 18439 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7989; /* *one_cmplv2di2_pternlog_false_dep */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern70 (x3))
        {
        case 0:
          if (!(
#line 3704 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0) && 
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_22 (insn, operands);

        case 1:
          if (!(
#line 3726 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1) && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_25 (insn, operands);

        case 2:
          if (!(
#line 3748 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern829 (x3, 
E_QImode) != 0
              || !
#line 7095 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_129 (insn, operands);

        case E_HImode:
          if (pattern829 (x3, 
E_HImode) != 0
              || !
#line 7095 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_130 (insn, operands);

        case E_SImode:
          if (pattern830 (x3, 
E_SImode) != 0
              || !
#line 7095 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_131 (insn, operands);

        case E_DImode:
          if (pattern830 (x3, 
E_DImode) != 0
              || !(
#line 7095 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_132 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern426 (x3))
            {
            case 0:
              if (!(
#line 7898 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_150 (insn, operands);

            case 1:
              if (!(
#line 7898 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_151 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          switch (pattern429 (x3))
            {
            case 0:
              if (!(
#line 7964 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_156 (insn, operands);

            case 1:
              if (!(
#line 7964 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern576 (x3))
            {
            case 0:
              if (!(
#line 7990 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            case 1:
              if (!(
#line 7990 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_159 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern397 (x3))
        {
        case 0:
          if (!(
#line 7920 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_152 (insn, operands);

        case 1:
          if (!(
#line 7920 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_153 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1074 (x3, 
E_QImode) != 0
                      || !(
#line 7941 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_154 (insn, operands);

                case E_HImode:
                  if (pattern1074 (x3, 
E_HImode) != 0
                      || !(
#line 7941 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_155 (insn, operands);

                case E_DImode:
                  if (pattern604 (x3, 
E_DImode) != 0
                      || !((
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14151 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_466 (insn, operands);

                case E_TImode:
                  if (pattern604 (x3, 
E_TImode) != 0
                      || !((
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14151 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_469 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              switch (pattern955 (x3))
                {
                case 0:
                  if (!((
#line 14060 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14062 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_430 (insn, operands);

                case 1:
                  if (!((
#line 14060 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14062 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_433 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern715 (x3))
            {
            case 0:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_442 (insn, operands);

            case 1:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_448 (insn, operands);

            case 2:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_472 (insn, operands);

            case 3:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_478 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern715 (x3))
            {
            case 0:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_445 (insn, operands);

            case 1:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_451 (insn, operands);

            case 2:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_475 (insn, operands);

            case 3:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_481 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern402 (x3))
        {
        case 0:
          if (!((
#line 14077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14079 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_436 (insn, operands);

        case 1:
          if (!((
#line 14077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14079 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_439 (insn, operands);

        case 2:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_454 (insn, operands);

        case 3:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_460 (insn, operands);

        case 4:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_457 (insn, operands);

        case 5:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_463 (insn, operands);

        case 6:
          if (!((
#line 14198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14209 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_484 (insn, operands);

        case 7:
          if (!((
#line 14198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14209 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_487 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern229 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      switch (pattern1176 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && GET_MODE (x4) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode))
                {
                  if (x86_64_hilo_general_operand (operands[2], E_DImode)
                      && ((
#line 12501 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 12503 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_283 (insn, operands);
                  if (const_int_operand (operands[2], E_DImode)
                      && (
#line 12576 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (AND, DImode, operands)
   && IN_RANGE (exact_log2 (~INTVAL (operands[2])), 31, 63)) && 
#line 12580 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_285 (insn, operands);
                }
              break;

            case E_TImode:
              if (pattern563 (x4, 
E_TImode) == 0
                  && ((
#line 12501 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12503 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return gen_split_284 (insn, operands);
              break;

            case E_HImode:
              if (pattern1351 (x4, 
E_HImode) == 0
                  && 
#line 12825 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))))
                return gen_split_311 (insn, operands);
              break;

            case E_SImode:
              if (pattern1351 (x4, 
E_SImode) == 0
                  && 
#line 12825 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))))
                return gen_split_312 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 12741 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12745 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_287 (insn, operands);
          break;

        case 2:
          if ((
#line 12741 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12745 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_290 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) == CONST_INT)
        {
          res = split_17 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          res = split_18 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_int_operand (operands[2], E_DImode))
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x4) == E_DImode)
            {
              operands[1] = x5;
              if (nonimmediate_operand (operands[1], E_DImode)
                  && (
#line 12825 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_313 (insn, operands);
            }
        }
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (GET_MODE (x4) != E_DImode)
        return NULL;
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x6, 0))
            {
            case -65536L:
              if (register_operand (operands[0], E_DImode)
                  && (
#line 12860 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_FAST_PREFIX && !TARGET_PARTIAL_REG_STALL)
    || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_315 (insn, operands);
              break;

            case -256L:
              if (any_QIreg_operand (operands[0], E_DImode)
                  && (
#line 12870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_318 (insn, operands);
              break;

            case -65281L:
              if (QIreg_operand (operands[0], E_DImode)
                  && (
#line 12880 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_321 (insn, operands);
              break;

            default:
              break;
            }
        }
      operands[1] = x5;
      if (register_operand (operands[1], E_DImode)
          && QIreg_operand (operands[0], E_DImode))
        {
          operands[2] = x6;
          if (const_int_operand (operands[2], E_DImode)
              && (
#line 13261 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_369 (insn, operands);
        }
      if (general_operand (operands[1], E_DImode)
          && any_QIreg_operand (operands[0], E_DImode))
        {
          operands[2] = x6;
          if (const_int_operand (operands[2], E_DImode)
              && (
#line 13290 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_372 (insn, operands);
        }
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode
          || XWINT (x6, 0) != 63L
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x8 = XEXP (x5, 0);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      switch (GET_CODE (x8))
        {
        case CTZ:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 21118 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT) && 
#line 21120 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( (TARGET_AVOID_FALSE_DEP_FOR_BMI || TARGET_AVOID_FALSE_DEP_FOR_TZCNT)
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_875 (insn, operands);

        case CLZ:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 21557 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT) && 
#line 21559 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_888 (insn, operands);

        case POPCOUNT:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 22382 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT) && 
#line 22390 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_912 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1432 (x4, 
E_DImode) == 0)
                {
                  if (((
#line 13312 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13314 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_373 (insn, operands);
                  if (((
#line 13330 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13333 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_375 (insn, operands);
                }
              break;

            case E_TImode:
              if (pattern1432 (x4, 
E_TImode) == 0)
                {
                  if (((
#line 13312 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13314 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_374 (insn, operands);
                  if (((
#line 13330 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13333 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_376 (insn, operands);
                }
              break;

            case E_SImode:
              if (pattern1432 (x4, 
E_SImode) == 0
                  && 
#line 13398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
   && optimize_insn_for_size_p () && optimize_size > 1
   && REGNO (operands[0]) == REGNO (operands[1])
   && LEGACY_INT_REG_P (operands[0])
   && !REX_INT_REG_P (operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                return gen_split_377 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) != SUBREG
              || maybe_ne (SUBREG_BYTE (x8), 0)
              || GET_MODE (x8) != E_QImode)
            return NULL;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != LSHIFTRT
              || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1527 (x4))
            {
            case 0:
              if (!(
#line 19344 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19346 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_838 (insn, operands);

            case 1:
              if (!((
#line 19344 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19346 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1244 (x4))
            {
            case 0:
              if (!(
#line 19362 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19364 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 1:
              if (!((
#line 19362 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19364 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_841 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern1058 (x3, 
-2))
        {
        case 0:
          if (!(
#line 18892 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18897 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_804 (insn, operands);

        case 1:
          if (!((
#line 18892 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18897 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_805 (insn, operands);

        case 2:
          if (!(
#line 18920 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18925 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_806 (insn, operands);

        case 3:
          if (!((
#line 18920 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18925 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_807 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern952 (x3))
        {
        case 0:
          if (!(
#line 21761 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21763 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_898 (insn, operands);

        case 1:
          if (!((
#line 21761 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21763 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_899 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x10 = XEXP (x5, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return NULL;
      switch (pattern952 (x3))
        {
        case 0:
          if (!(
#line 21906 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21908 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_904 (insn, operands);

        case 1:
          if (!((
#line 21906 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21908 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_905 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern202 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) == SUBREG)
        {
          switch (pattern1333 (x4))
            {
            case 0:
              if (((
#line 16582 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16587 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                return gen_split_590 (insn, operands);
              break;

            case 1:
              if (((
#line 16582 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16587 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                return gen_split_592 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) == E_SImode
          && nonimmediate_operand (operands[1], E_SImode))
        {
          if (register_operand (operands[0], E_SImode))
            {
              operands[2] = x5;
              if (register_operand (operands[2], E_QImode)
                  && 
#line 17435 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return gen_split_623 (insn, operands);
            }
          if (GET_CODE (x5) == SUBREG)
            {
              switch (pattern1506 (x5))
                {
                case 0:
                  if ((
#line 17840 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17845 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_640 (insn, operands);
                  break;

                case 1:
                  if ((
#line 17888 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17892 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_652 (insn, operands);
                  break;

                case 2:
                  if ((
#line 17934 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17938 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_664 (insn, operands);
                  break;

                default:
                  break;
                }
            }
        }
      operands[2] = x5;
      switch (pattern1252 (x2))
        {
        case 0:
          if (register_operand (operands[1], E_DImode)
              && nonmemory_operand (operands[2], E_QImode)
              && (
#line 16694 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return gen_split_598 (insn, operands);
          if (nonimmediate_operand (operands[1], E_DImode)
              && register_operand (operands[2], E_QImode)
              && (
#line 17435 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_625 (insn, operands);
          break;

        case 1:
          if ((
#line 16694 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_600 (insn, operands);
          break;

        case 2:
          if ((
#line 17638 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17649 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return gen_split_629 (insn, operands);
          break;

        case 3:
          if ((
#line 17638 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17649 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return gen_split_631 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return NULL;
      switch (pattern1166 (x2, 
E_DImode))
        {
        case 0:
          if (!((
#line 17840 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17845 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_643 (insn, operands);

        case 1:
          if (!((
#line 17888 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17892 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 2:
          if (!((
#line 17934 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17938 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_667 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && ((
#line 16643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16648 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return gen_split_594 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !((
#line 17865 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_649 (insn, operands);

    case 2:
      if (!((
#line 16643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16648 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_596 (insn, operands);

    case 3:
      if (!(
#line 17865 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_646 (insn, operands);

    case 4:
      if (!(
#line 17912 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17916 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_658 (insn, operands);

    case 5:
      if (!((
#line 17912 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17916 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_661 (insn, operands);

    case 6:
      if (!(
#line 17964 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17968 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_670 (insn, operands);

    case 7:
      if (!((
#line 17964 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17968 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_673 (insn, operands);

    case 8:
      if (!((
#line 17988 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 17991 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_674 (insn, operands);

    case 9:
      if (!((
#line 17988 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17991 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_675 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      res = split_40 (x1, insn);
      if (res != NULL_RTX)
        return res;
      if (!bt_comparison_operator (x3, E_VOIDmode))
        return NULL;
      operands[3] = x3;
      x4 = XEXP (x3, 0);
      if (pattern83 (x4, 
E_CCZmode, 
130) != 0)
        return NULL;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != AND)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != NOT)
        return NULL;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != AND)
        return NULL;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != NOT)
        return NULL;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != PC)
        return NULL;
      x11 = XEXP (x1, 0);
      if (GET_CODE (x11) != PC)
        return NULL;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      x13 = XEXP (x5, 1);
      operands[2] = x13;
      x14 = XEXP (x2, 1);
      operands[0] = x14;
      x15 = XEXP (x8, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return NULL;
      x16 = XEXP (x7, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return NULL;
      switch (GET_MODE (x5))
        {
        case E_V16QImode:
          if (pattern1760 (x4, 
E_V16QImode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3676 (insn, operands);

        case E_V8HImode:
          if (pattern1760 (x4, 
E_V8HImode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3677 (insn, operands);

        case E_V4SImode:
          if (pattern1760 (x4, 
E_V4SImode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3678 (insn, operands);

        case E_V2DImode:
          if (pattern1760 (x4, 
E_V2DImode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3679 (insn, operands);

        case E_V1TImode:
          if (pattern1760 (x4, 
E_V1TImode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3680 (insn, operands);

        case E_V4SFmode:
          if (pattern1760 (x4, 
E_V4SFmode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3681 (insn, operands);

        case E_V2DFmode:
          if (pattern1760 (x4, 
E_V2DFmode) != 0
              || !
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3682 (insn, operands);

        case E_V32QImode:
          if (pattern1760 (x4, 
E_V32QImode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3683 (insn, operands);

        case E_V16HImode:
          if (pattern1760 (x4, 
E_V16HImode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3684 (insn, operands);

        case E_V8SImode:
          if (pattern1760 (x4, 
E_V8SImode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3685 (insn, operands);

        case E_V4DImode:
          if (pattern1760 (x4, 
E_V4DImode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3686 (insn, operands);

        case E_V2TImode:
          if (pattern1760 (x4, 
E_V2TImode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3687 (insn, operands);

        case E_V8SFmode:
          if (pattern1760 (x4, 
E_V8SFmode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3688 (insn, operands);

        case E_V4DFmode:
          if (pattern1760 (x4, 
E_V4DFmode) != 0
              || !(
#line 25450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3689 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_47 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return NULL;
  switch (pattern91 (x1))
    {
    case 0:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || pattern974 (x2) != 0
          || !register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || GET_MODE (x3) != E_SFmode)
        return NULL;
      x5 = XEXP (x2, 1);
      if (GET_MODE (x5) != E_SFmode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[1])
          || !(
#line 1058 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
( 1)))
        return NULL;
      return gen_split_1029 (insn, operands);

    case 1:
      switch (pattern854 (x2))
        {
        case 0:
          if (!
#line 22633 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_3467 (insn, operands);

        case 1:
          if (!
#line 22720 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_3470 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_48 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern975 (x2))
            {
            case 0:
              if ((
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1786 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
( reload_completed)))
                return gen_split_1032 (insn, operands);
              break;

            case 1:
              if ((
#line 12336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 12338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1556 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (nonimmediate_operand (operands[1], E_V2SImode)
                      && (
#line 5729 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 5732 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1118 (insn, operands);
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 21217 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return gen_split_3390 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HFmode:
          switch (pattern976 (x2))
            {
            case 0:
              if (((
#line 13245 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1579 (insn, operands);
              break;

            case 1:
              if ((
#line 13245 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1580 (insn, operands);
              break;

            case 2:
              if ((
#line 13245 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1581 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_BFmode:
          switch (pattern977 (x2))
            {
            case 0:
              if (((
#line 13245 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1582 (insn, operands);
              break;

            case 1:
              if ((
#line 13245 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1583 (insn, operands);
              break;

            case 2:
              if ((
#line 13245 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1584 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && nonimmediate_operand (operands[1], E_V2DFmode)
              && 
#line 14683 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return gen_split_3173 (insn, operands);
          break;

        case E_QImode:
          if (memory_operand (operands[0], E_QImode)
              && GET_MODE (x2) == E_QImode
              && register_operand (operands[1], E_V16QImode)
              && ((
#line 21077 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21070 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1)) && 
#line 21083 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3387 (insn, operands);
          break;

        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode
              && register_operand (operands[1], E_V8HImode)
              && (
#line 21077 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21083 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3388 (insn, operands);
          break;

        case E_TImode:
          if (nonimmediate_operand (operands[0], E_TImode)
              && GET_MODE (x2) == E_TImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4TImode:
                  if (register_operand (operands[1], E_V4TImode)
                      && (
#line 21451 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && reload_completed
   && (TARGET_AVX512VL || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 21444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3398 (insn, operands);
                  break;

                case E_V2TImode:
                  if (register_operand (operands[1], E_V2TImode)
                      && 
#line 21451 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && reload_completed
   && (TARGET_AVX512VL || !EXT_REX_SSE_REG_P (operands[1]))))
                    return gen_split_3399 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode
              && memory_operand (operands[1], E_V2SFmode)
              && 
#line 1827 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && reload_completed))
            return gen_split_1033 (insn, operands);
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && memory_operand (operands[1], E_V2SImode)
              && 
#line 5816 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && reload_completed))
            return gen_split_1120 (insn, operands);
          break;

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 14630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return gen_split_3171 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      if (nonimmediate_operand (operands[0], E_SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && const_0_to_3_operand (operands[2], E_SImode)
          && (
#line 12347 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 12354 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed && SSE_REG_P (operands[0]))))
        return gen_split_1557 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !(
#line 12390 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 12392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1558 (insn, operands);

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !memory_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_VOIDmode)
          || !
#line 21404 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3394 (insn, operands);

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !memory_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_VOIDmode)
          || !
#line 21404 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3395 (insn, operands);

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !
#line 21404 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3396 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_56 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 164)
    return NULL;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[4] = x6;
  if (!const_0_to_255_operand (operands[4], E_SImode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (pattern970 (x2, 
E_V64QImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V64QImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1587 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V64QImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case E_V32QImode:
      if (pattern970 (x2, 
E_V32QImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V32QImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1588 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V32QImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case E_V16QImode:
      if (pattern970 (x2, 
E_V16QImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V16QImode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1589 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V16QImode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1613 (insn, operands);

    case E_V32HImode:
      if (pattern970 (x2, 
E_V32HImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V32HImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1590 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V32HImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case E_V16HImode:
      if (pattern970 (x2, 
E_V16HImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V16HImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1591 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V16HImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case E_V8HImode:
      if (pattern970 (x2, 
E_V8HImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8HImode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1592 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8HImode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1616 (insn, operands);

    case E_V16SImode:
      if (pattern970 (x2, 
E_V16SImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V16SImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1593 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V16SImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1617 (insn, operands);

    case E_V8SImode:
      if (pattern970 (x2, 
E_V8SImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8SImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1594 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8SImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1618 (insn, operands);

    case E_V4SImode:
      if (pattern970 (x2, 
E_V4SImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V4SImode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1595 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V4SImode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1619 (insn, operands);

    case E_V8DImode:
      if (pattern970 (x2, 
E_V8DImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8DImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1596 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8DImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1620 (insn, operands);

    case E_V4DImode:
      if (pattern970 (x2, 
E_V4DImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V4DImode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1597 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V4DImode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1621 (insn, operands);

    case E_V2DImode:
      if (pattern970 (x2, 
E_V2DImode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V2DImode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1598 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V2DImode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1622 (insn, operands);

    case E_V32HFmode:
      if (pattern970 (x2, 
E_V32HFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V32HFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1599 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V32HFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1623 (insn, operands);

    case E_V16HFmode:
      if (pattern970 (x2, 
E_V16HFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V16HFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1600 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V16HFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1624 (insn, operands);

    case E_V8HFmode:
      if (pattern970 (x2, 
E_V8HFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8HFmode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1601 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8HFmode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1625 (insn, operands);

    case E_V32BFmode:
      if (pattern970 (x2, 
E_V32BFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V32BFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1602 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V32BFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case E_V16BFmode:
      if (pattern970 (x2, 
E_V16BFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V16BFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1603 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V16BFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case E_V8BFmode:
      if (pattern970 (x2, 
E_V8BFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8BFmode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1604 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8BFmode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1628 (insn, operands);

    case E_V16SFmode:
      if (pattern970 (x2, 
E_V16SFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V16SFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1605 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V16SFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case E_V8SFmode:
      if (pattern970 (x2, 
E_V8SFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8SFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1606 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8SFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case E_V4SFmode:
      if (pattern970 (x2, 
E_V4SFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V4SFmode)
          && 
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3))
        return gen_split_1607 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V4SFmode)
          || !
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0))
        return NULL;
      return gen_split_1631 (insn, operands);

    case E_V8DFmode:
      if (pattern970 (x2, 
E_V8DFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V8DFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return gen_split_1608 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V8DFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case E_V4DFmode:
      if (pattern970 (x2, 
E_V4DFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V4DFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return gen_split_1609 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V4DFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case E_V2DFmode:
      if (pattern970 (x2, 
E_V2DFmode) != 0)
        return NULL;
      if (memory_operand (operands[3], E_V2DFmode)
          && (
#line 13712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) == 3) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return gen_split_1610 (insn, operands);
      if (!nonimmediate_operand (operands[3], E_V2DFmode)
          || !(
#line 13733 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!reload_completed && vpternlog_redundant_operand_mask (operands[4]) != 0) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return NULL;
      return gen_split_1634 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern536 (x2))
        {
        case 0:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2001 (insn, operands);

        case 1:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2028 (insn, operands);

        case 2:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2055 (insn, operands);

        case 3:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2082 (insn, operands);

        case 4:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2109 (insn, operands);

        case 5:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2136 (insn, operands);

        case 6:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2163 (insn, operands);

        case 7:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2190 (insn, operands);

        case 8:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2217 (insn, operands);

        case 9:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2244 (insn, operands);

        case 10:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2271 (insn, operands);

        case 11:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2298 (insn, operands);

        case 12:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2004 (insn, operands);

        case 13:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2031 (insn, operands);

        case 14:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2058 (insn, operands);

        case 15:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2085 (insn, operands);

        case 16:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2112 (insn, operands);

        case 17:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2139 (insn, operands);

        case 18:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2166 (insn, operands);

        case 19:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2193 (insn, operands);

        case 20:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2220 (insn, operands);

        case 21:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2247 (insn, operands);

        case 22:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2274 (insn, operands);

        case 23:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2301 (insn, operands);

        case 24:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2007 (insn, operands);

        case 25:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2034 (insn, operands);

        case 26:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2061 (insn, operands);

        case 27:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2088 (insn, operands);

        case 28:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2115 (insn, operands);

        case 29:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2142 (insn, operands);

        case 30:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2169 (insn, operands);

        case 31:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2196 (insn, operands);

        case 32:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2223 (insn, operands);

        case 33:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2250 (insn, operands);

        case 34:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2277 (insn, operands);

        case 35:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2304 (insn, operands);

        case 36:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3069 (insn, operands);

        case 37:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3078 (insn, operands);

        case 38:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3087 (insn, operands);

        case 39:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3096 (insn, operands);

        case 40:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3105 (insn, operands);

        case 41:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3114 (insn, operands);

        case 42:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3123 (insn, operands);

        case 43:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3132 (insn, operands);

        case 44:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3141 (insn, operands);

        case 45:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3150 (insn, operands);

        case 46:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3159 (insn, operands);

        case 47:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3168 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern537 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2649 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2676 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2703 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2730 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2757 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2784 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2811 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2838 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2865 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2892 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2919 (insn, operands);

        case 11:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2946 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2652 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2679 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2706 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2733 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2760 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2787 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2814 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2841 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2868 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2895 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2922 (insn, operands);

        case 11:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2949 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2655 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2682 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2709 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2736 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2763 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2790 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2817 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2844 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2871 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2898 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2925 (insn, operands);

        case 11:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2952 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_78 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MINUS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PLUS)
        return NULL;
      operands[6] = x2;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      x9 = XEXP (x2, 2);
      operands[5] = x9;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1444 (x2, 
E_V8SFmode) != 0
              || !(
#line 3537 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1300 (insn, operands);

        case E_V4SFmode:
          if (pattern1444 (x2, 
E_V4SFmode) != 0
              || !
#line 3537 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
            return NULL;
          return gen_split_1301 (insn, operands);

        case E_V4DFmode:
          if (pattern1444 (x2, 
E_V4DFmode) != 0
              || !(
#line 3537 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1302 (insn, operands);

        case E_V2DFmode:
          if (pattern1444 (x2, 
E_V2DFmode) != 0
              || !(
#line 3537 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return NULL;
          return gen_split_1303 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != MINUS)
        return NULL;
      operands[6] = x2;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      x9 = XEXP (x2, 2);
      operands[5] = x9;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1445 (x2, 
E_V8SFmode) != 0
              || !(
#line 3559 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1304 (insn, operands);

        case E_V4SFmode:
          if (pattern1445 (x2, 
E_V4SFmode) != 0
              || !
#line 3559 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
            return NULL;
          return gen_split_1305 (insn, operands);

        case E_V4DFmode:
          if (pattern1445 (x2, 
E_V4DFmode) != 0
              || !(
#line 3559 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1306 (insn, operands);

        case E_V2DFmode:
          if (pattern1445 (x2, 
E_V2DFmode) != 0
              || !(
#line 3559 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return NULL;
          return gen_split_1307 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = split_57 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          switch (pattern315 (x2))
            {
            case 0:
              res = split_58 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case 1:
              if (vector_all_ones_operand (operands[1], E_V16QImode)
                  && const0_operand (operands[2], E_V16QImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3297 (insn, operands);
              if (const0_operand (operands[1], E_V16QImode)
                  && vector_all_ones_operand (operands[2], E_V16QImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3320 (insn, operands);
              break;

            case 2:
              if (vector_all_ones_operand (operands[1], E_V8HImode)
                  && const0_operand (operands[2], E_V8HImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3299 (insn, operands);
              if (const0_operand (operands[1], E_V8HImode)
                  && vector_all_ones_operand (operands[2], E_V8HImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3321 (insn, operands);
              break;

            case 3:
              if (vector_all_ones_operand (operands[1], E_V4SImode)
                  && const0_operand (operands[2], E_V4SImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3301 (insn, operands);
              if (const0_operand (operands[1], E_V4SImode)
                  && vector_all_ones_operand (operands[2], E_V4SImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3322 (insn, operands);
              break;

            case 4:
              if (vector_all_ones_operand (operands[1], E_V2DImode)
                  && const0_operand (operands[2], E_V2DImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3303 (insn, operands);
              if (const0_operand (operands[1], E_V2DImode)
                  && vector_all_ones_operand (operands[2], E_V2DImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3323 (insn, operands);
              break;

            case 5:
              if (vector_all_ones_operand (operands[1], E_V32QImode)
                  && const0_operand (operands[2], E_V32QImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3305 (insn, operands);
              if (const0_operand (operands[1], E_V32QImode)
                  && vector_all_ones_operand (operands[2], E_V32QImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3324 (insn, operands);
              break;

            case 6:
              if (vector_all_ones_operand (operands[1], E_V16HImode)
                  && const0_operand (operands[2], E_V16HImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3307 (insn, operands);
              if (const0_operand (operands[1], E_V16HImode)
                  && vector_all_ones_operand (operands[2], E_V16HImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3325 (insn, operands);
              break;

            case 7:
              if (vector_all_ones_operand (operands[1], E_V8SImode)
                  && const0_operand (operands[2], E_V8SImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3309 (insn, operands);
              if (const0_operand (operands[1], E_V8SImode)
                  && vector_all_ones_operand (operands[2], E_V8SImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3326 (insn, operands);
              break;

            case 8:
              if (vector_all_ones_operand (operands[1], E_V4DImode)
                  && const0_operand (operands[2], E_V4DImode)
                  && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3311 (insn, operands);
              if (const0_operand (operands[1], E_V4DImode)
                  && vector_all_ones_operand (operands[2], E_V4DImode)
                  && (
#line 18191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18196 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3327 (insn, operands);
              break;

            case 9:
              if (((
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1320 (insn, operands);
              break;

            case 10:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3288 (insn, operands);
              break;

            case 11:
              if ((
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1321 (insn, operands);
              break;

            case 12:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3284 (insn, operands);
              break;

            case 13:
              if (((
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1322 (insn, operands);
              break;

            case 14:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3289 (insn, operands);
              break;

            case 15:
              if (((
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1323 (insn, operands);
              break;

            case 16:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3285 (insn, operands);
              break;

            case 17:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3282 (insn, operands);
              break;

            case 18:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3283 (insn, operands);
              break;

            case 19:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3286 (insn, operands);
              break;

            case 20:
              if ((
#line 18008 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 18019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3287 (insn, operands);
              break;

            case 21:
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (register_operand (operands[0], E_V16SImode)
                      && GET_MODE (x2) == E_V16SImode
                      && register_operand (operands[1], E_HImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V16SImode)
                          && const0_operand (operands[3], E_V16SImode)
                          && ((
#line 10329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1522 (insn, operands);
                      if (const0_operand (operands[2], E_V16SImode)
                          && vector_all_ones_operand (operands[3], E_V16SImode)
                          && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1534 (insn, operands);
                    }
                  break;

                case E_V8SImode:
                  if (register_operand (operands[0], E_V8SImode)
                      && GET_MODE (x2) == E_V8SImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V8SImode)
                          && const0_operand (operands[3], E_V8SImode)
                          && ((
#line 10329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1523 (insn, operands);
                      if (const0_operand (operands[2], E_V8SImode)
                          && vector_all_ones_operand (operands[3], E_V8SImode)
                          && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1535 (insn, operands);
                    }
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x2) == E_V4SImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V4SImode)
                          && const0_operand (operands[3], E_V4SImode)
                          && ((
#line 10329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1524 (insn, operands);
                      if (const0_operand (operands[2], E_V4SImode)
                          && vector_all_ones_operand (operands[3], E_V4SImode)
                          && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1536 (insn, operands);
                    }
                  break;

                case E_V8DImode:
                  if (register_operand (operands[0], E_V8DImode)
                      && GET_MODE (x2) == E_V8DImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V8DImode)
                          && const0_operand (operands[3], E_V8DImode)
                          && ((
#line 10329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1525 (insn, operands);
                      if (const0_operand (operands[2], E_V8DImode)
                          && vector_all_ones_operand (operands[3], E_V8DImode)
                          && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1537 (insn, operands);
                    }
                  break;

                case E_V4DImode:
                  if (register_operand (operands[0], E_V4DImode)
                      && GET_MODE (x2) == E_V4DImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V4DImode)
                          && const0_operand (operands[3], E_V4DImode)
                          && ((
#line 10329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1526 (insn, operands);
                      if (const0_operand (operands[2], E_V4DImode)
                          && vector_all_ones_operand (operands[3], E_V4DImode)
                          && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1538 (insn, operands);
                    }
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x2) == E_V2DImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V2DImode)
                          && const0_operand (operands[3], E_V2DImode)
                          && ((
#line 10329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1527 (insn, operands);
                      if (const0_operand (operands[2], E_V2DImode)
                          && vector_all_ones_operand (operands[3], E_V2DImode)
                          && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1539 (insn, operands);
                    }
                  break;

                case E_V64QImode:
                  if (pattern1185 (x2, 
E_DImode, 
E_V64QImode) == 0
                      && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1528 (insn, operands);
                  break;

                case E_V32QImode:
                  if (pattern1185 (x2, 
E_SImode, 
E_V32QImode) == 0
                      && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 505 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1529 (insn, operands);
                  break;

                case E_V16QImode:
                  if (pattern1185 (x2, 
E_HImode, 
E_V16QImode) == 0
                      && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1530 (insn, operands);
                  break;

                case E_V32HImode:
                  if (pattern1185 (x2, 
E_SImode, 
E_V32HImode) == 0
                      && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1531 (insn, operands);
                  break;

                case E_V16HImode:
                  if (pattern1185 (x2, 
E_HImode, 
E_V16HImode) == 0
                      && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1532 (insn, operands);
                  break;

                case E_V8HImode:
                  if (pattern1185 (x2, 
E_QImode, 
E_V8HImode) == 0
                      && ((
#line 10355 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 509 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10357 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1533 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (pattern318 (x2))
        {
        case 0:
          if (!((
#line 4171 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1324 (insn, operands);

        case 1:
          if (!(
#line 4171 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1325 (insn, operands);

        case 2:
          if (!((
#line 4171 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1326 (insn, operands);

        case 3:
          if (!((
#line 4171 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1327 (insn, operands);

        case 4:
          if (!((
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1328 (insn, operands);

        case 5:
          if (!(
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1329 (insn, operands);

        case 6:
          if (!((
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1330 (insn, operands);

        case 7:
          if (!((
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1331 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return NULL;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x9 = XEXP (x2, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1009 (x2))
            {
            case 0:
              if (!(
#line 12050 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1540 (insn, operands);

            case 1:
              if (!(
#line 12050 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1541 (insn, operands);

            case 2:
              if (!(
#line 12050 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1542 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern310 (x2))
            {
            case 0:
              if (!((
#line 12090 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 803 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 12092 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1543 (insn, operands);

            case 1:
              if (!(
#line 12090 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12092 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1544 (insn, operands);

            case 2:
              if (!(
#line 12090 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12092 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1545 (insn, operands);

            case 3:
              if (!((
#line 12090 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 804 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 12092 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1546 (insn, operands);

            case 4:
              if (!((
#line 12204 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 12206 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1550 (insn, operands);

            case 5:
              if (!(
#line 12090 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12092 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1547 (insn, operands);

            case 6:
              if (!((
#line 12204 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 12206 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1551 (insn, operands);

            case 7:
              if (!(
#line 12090 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12092 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1548 (insn, operands);

            case 8:
              if (!(
#line 12204 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12206 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1552 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SUBREG:
            case MEM:
              if (!rtx_equal_p (x4, operands[0]))
                return NULL;
              x9 = XEXP (x2, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1186 (x2, 
E_SImode, 
E_V4SImode) != 0
                      || !
#line 12280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return NULL;
                  return gen_split_1554 (insn, operands);

                case E_V4SFmode:
                  if (pattern1186 (x2, 
E_SFmode, 
E_V4SFmode) != 0
                      || !
#line 12280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return NULL;
                  return gen_split_1555 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
              operands[1] = x4;
              operands[2] = x5;
              x9 = XEXP (x2, 2);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1061 (x2, 
E_V8HImode, 
E_HImode) != 0
                      || !
#line 19962 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && reload_completed
   && INTVAL (operands[3]) > 1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HImode))))
                    return NULL;
                  return gen_split_3384 (insn, operands);

                case E_V8HFmode:
                  if (pattern1061 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                      || !
#line 19962 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && reload_completed
   && INTVAL (operands[3]) > 1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HFmode))))
                    return NULL;
                  return gen_split_3385 (insn, operands);

                case E_V8BFmode:
                  if (pattern1061 (x2, 
E_V8BFmode, 
E_BFmode) != 0
                      || !
#line 19962 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && reload_completed
   && INTVAL (operands[3]) > 1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8BFmode))))
                    return NULL;
                  return gen_split_3386 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return NULL;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      if (GET_MODE (x4) != E_QImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LTU
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17
          || GET_MODE (x6) != E_CCCmode)
        return NULL;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != GEU
          || GET_MODE (x8) != E_QImode)
        return NULL;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 17
          || GET_MODE (x9) != E_CCCmode)
        return NULL;
      x10 = XEXP (x8, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCCmode
          || GET_MODE (x3) != E_CCCmode
          || !
#line 2162 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SLOW_STC && !optimize_insn_for_size_p ()))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case AND:
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCZmode
          || GET_MODE (x3) != E_CCZmode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return NULL;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || !
#line 12414 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_MEMORY_READ_STALL && !MEM_VOLATILE_P (operands[0])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_124 (insn, operands);

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !
#line 12414 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_MEMORY_READ_STALL && !MEM_VOLATILE_P (operands[0])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_125 (insn, operands);

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !(
#line 12414 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_MEMORY_READ_STALL && !MEM_VOLATILE_P (operands[0])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_126 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern409 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 5965 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (SFmode)
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_56 (insn, operands);

        case 1:
          if (!
#line 5965 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (DFmode)
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_58 (insn, operands);

        default:
          return NULL;
        }

    case E_DImode:
      switch (pattern409 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 5965 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (SFmode)
   && optimize_insn_for_speed_p ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_57 (insn, operands);

        case 1:
          if (!(
#line 5965 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (DFmode)
   && optimize_insn_for_speed_p ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_59 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!bt_comparison_operator (operands[1], E_QImode))
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCZmode)
    return NULL;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!nonimmediate_operand (operands[0], E_QImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  if (pattern1256 (x6, 
0) != 0)
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (pattern1780 (x7) != 0)
    return NULL;
  x10 = XEXP (x8, 1);
  operands[3] = x10;
  if (!
#line 19651 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_168 (insn, operands);
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && const_int_operand (operands[1], E_DImode)
          && 
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && optimize_insn_for_size_p ()
   && LEGACY_INT_REG_P (operands[0])
   && !x86_64_immediate_operand (operands[1], DImode)
   && !x86_64_zext_immediate_operand (operands[1], DImode)
   && !((UINTVAL (operands[1]) >> ctz_hwi (UINTVAL (operands[1])))
	& ~HOST_WIDE_INT_C (0xffffffff))
   && peep2_regno_dead_p (0, FLAGS_REG)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_4 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!general_reg_operand (operands[0], E_DImode))
        return NULL;
      if (const_int_operand (operands[1], E_DImode))
        {
          if ((
#line 2948 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && optimize_size > 1
   && operands[1] != const0_rtx
   && IN_RANGE (INTVAL (operands[1]), -128, 127)
   && !ix86_red_zone_used
   && REGNO (operands[0]) != SP_REG) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_7 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count >= 2)
            {
              x2 = PATTERN (peep2_next_insn (1));
              switch (pattern1063 (x2))
                {
                case 0:
                  if ((
#line 3656 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_36 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 3656 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_38 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 3656 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_40 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (peep2_current_count < 2)
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern958 (x2, 
E_DImode) != 0
          || !(
#line 3283 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], DImode)
       || (constm1_operand (operands[1], DImode)
	   && (8 > 1 || TARGET_AVX512DQ)))) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_14 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[0], E_HImode))
        return NULL;
      if (const_int_operand (operands[1], E_HImode)
          && 
#line 2948 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && optimize_size > 1
   && operands[1] != const0_rtx
   && IN_RANGE (INTVAL (operands[1]), -128, 127)
   && !ix86_red_zone_used
   && REGNO (operands[0]) != SP_REG))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_5 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern958 (x2, 
E_HImode) != 0
          || !
#line 3283 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], HImode)
       || (constm1_operand (operands[1], HImode)
	   && (2 > 1 || TARGET_AVX512DQ)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[0], E_SImode))
        return NULL;
      if (const_int_operand (operands[1], E_SImode))
        {
          if (
#line 2948 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && optimize_size > 1
   && operands[1] != const0_rtx
   && IN_RANGE (INTVAL (operands[1]), -128, 127)
   && !ix86_red_zone_used
   && REGNO (operands[0]) != SP_REG))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_6 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count >= 2)
            {
              x2 = PATTERN (peep2_next_insn (1));
              switch (pattern1063 (x2))
                {
                case 0:
                  if (
#line 3656 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_35 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 3656 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_37 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 3656 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_39 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (peep2_current_count < 2)
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern958 (x2, 
E_SImode) != 0
          || !
#line 3283 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], SImode)
       || (constm1_operand (operands[1], SImode)
	   && (4 > 1 || TARGET_AVX512DQ)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    case E_QImode:
      if (peep2_current_count < 2
          || !general_reg_operand (operands[0], E_QImode))
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern958 (x2, 
E_QImode) != 0
          || !
#line 3283 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], QImode)
       || (constm1_operand (operands[1], QImode)
	   && (1 > 1 || TARGET_AVX512DQ)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (operands[0]))
        {
        case MEM:
          if (push_operand (operands[0], E_DImode)
              && immediate_operand (operands[1], E_DImode)
              && 
#line 2223 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !symbolic_operand (operands[1], DImode)
   && !x86_64_immediate_operand (operands[1], DImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_3 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case REG:
        case SUBREG:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && const_int_operand (operands[1], E_HImode)
              && 
#line 2970 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((operands[1] == const0_rtx || operands[1] == constm1_rtx)
   && optimize_insn_for_size_p () && optimize_size > 1
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_8 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_SImode:
          if (memory_operand (operands[0], E_SImode)
              && const_int_operand (operands[1], E_SImode)
              && 
#line 2970 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((operands[1] == const0_rtx || operands[1] == constm1_rtx)
   && optimize_insn_for_size_p () && optimize_size > 1
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_DImode:
          if (memory_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && (
#line 2970 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((operands[1] == const0_rtx || operands[1] == constm1_rtx)
   && optimize_insn_for_size_p () && optimize_size > 1
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = peephole2_5 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[1] = x2;
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (memory_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 27818 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((QImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_259 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 27818 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((HImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_260 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case REG:
      res = peephole2_6 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case SUBREG:
    case MEM:
      res = peephole2_7 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count < 2)
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x3 = XEXP (x1, 0);
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (peep2_current_count >= 3
          && peep2_current_count >= 4)
        {
          operands[2] = x3;
          if (general_reg_operand (operands[2], E_HImode))
            {
              operands[3] = x2;
              if (general_gr_operand (operands[3], E_HImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[0] = x5;
                  if (general_reg_operand (operands[0], E_HImode))
                    {
                      x6 = XEXP (x4, 1);
                      if (pattern963 (x6, 
E_HImode) == 0
                          && 
#line 26525 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])))
                        {
                          *pmatch_len_ = 3;
                          res = gen_peephole2_206 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
      operands[0] = x3;
      operands[1] = x2;
      if (x86_64_general_operand (operands[1], E_HImode)
          && general_reg_operand (operands[0], E_HImode))
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (general_reg_operand (operands[2], E_HImode))
            {
              x6 = XEXP (x4, 1);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27122 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_230 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || pattern839 (x4, 
E_HImode) != 0)
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_HImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1865 (x9, 
E_HImode) != 0
              || !
#line 28383 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[4]) == REGNO (operands[0])
       || REGNO (operands[4]) == REGNO (operands[3]))
   && (rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
			     ? 3 : 0], operands[5])
       ? rtx_equal_p (operands[2], operands[6])
       : rtx_equal_p (operands[2], operands[5])
	 && rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
				  ? 3 : 0], operands[6]))
   && peep2_reg_dead_p (4, operands[4])
   && peep2_reg_dead_p (5, operands[REGNO (operands[4]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_326 (insn, operands);

        case E_SImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1866 (x9, 
E_HImode) != 0
              || !
#line 28427 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[5]) == REGNO (operands[0])
       || REGNO (operands[5]) == REGNO (operands[3]))
   && REGNO (operands[5]) == REGNO (operands[4])
   && (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
			     ? 3 : 0], operands[6])
       ? (REG_P (operands[2])
	  ? REG_P (operands[7]) && REGNO (operands[2]) == REGNO (operands[7])
	  : rtx_equal_p (operands[2], operands[7]))
       : (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
				? 3 : 0], operands[7])
	  && REG_P (operands[2])
	  && REGNO (operands[2]) == REGNO (operands[6])))
   && peep2_reg_dead_p (4, operands[5])
   && peep2_reg_dead_p (5, operands[REGNO (operands[5]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], SImode)
       || any_QIreg_operand (operands[2], SImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_330 (insn, operands);

        default:
          return NULL;
        }

    case E_QImode:
      operands[0] = x3;
      operands[1] = x2;
      if (x86_64_general_operand (operands[1], E_QImode)
          && general_reg_operand (operands[0], E_QImode))
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (general_reg_operand (operands[2], E_QImode))
            {
              x6 = XEXP (x4, 1);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27122 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_229 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || pattern839 (x4, 
E_QImode) != 0)
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1865 (x9, 
E_QImode) != 0
              || !
#line 28383 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[4]) == REGNO (operands[0])
       || REGNO (operands[4]) == REGNO (operands[3]))
   && (rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
			     ? 3 : 0], operands[5])
       ? rtx_equal_p (operands[2], operands[6])
       : rtx_equal_p (operands[2], operands[5])
	 && rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
				  ? 3 : 0], operands[6]))
   && peep2_reg_dead_p (4, operands[4])
   && peep2_reg_dead_p (5, operands[REGNO (operands[4]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_325 (insn, operands);

        case E_SImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1866 (x9, 
E_QImode) != 0
              || !
#line 28427 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[5]) == REGNO (operands[0])
       || REGNO (operands[5]) == REGNO (operands[3]))
   && REGNO (operands[5]) == REGNO (operands[4])
   && (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
			     ? 3 : 0], operands[6])
       ? (REG_P (operands[2])
	  ? REG_P (operands[7]) && REGNO (operands[2]) == REGNO (operands[7])
	  : rtx_equal_p (operands[2], operands[7]))
       : (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
				? 3 : 0], operands[7])
	  && REG_P (operands[2])
	  && REGNO (operands[2]) == REGNO (operands[6])))
   && peep2_reg_dead_p (4, operands[5])
   && peep2_reg_dead_p (5, operands[REGNO (operands[5]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], SImode)
       || any_QIreg_operand (operands[2], SImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_329 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (register_operand (operands[0], E_DImode))
    {
      res = peephole2_15 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], E_DImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) == PARALLEL
      && XVECLEN (x3, 0) == 2)
    {
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) == SET)
        {
          if (memory_operand (operands[1], E_DImode))
            {
              switch (pattern1194 (x3, 
E_DImode, 
E_TImode))
                {
                case 0:
                  if ((
#line 8701 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_71 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 9134 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_87 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 9621 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_99 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 9987 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_111 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 4:
                  if ((
#line 8818 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_79 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 5:
                  if ((
#line 8844 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_83 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 6:
                  if ((
#line 9302 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_93 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 7:
                  if ((
#line 9328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_97 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          if (peep2_current_count >= 4
              && pattern1196 (x3, 
E_DImode) == 0
              && (
#line 14286 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[2])
   && !reg_mentioned_p (operands[0], operands[1])
   && !reg_mentioned_p (operands[2], operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_152 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (general_reg_operand (operands[1], E_DImode))
            {
              x5 = PATTERN (peep2_next_insn (2));
              if (GET_CODE (x5) == SET)
                {
                  x6 = XEXP (x4, 1);
                  if (GET_CODE (x6) == NEG
                      && pattern1346 (x3, 
E_DImode) == 0
                      && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_158 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (peep2_current_count >= 4
                      && pattern1348 (x3, 
E_DImode) == 0
                      && (
#line 26491 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_205 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (!immediate_operand (operands[1], E_DImode)
      || GET_CODE (x3) != SET)
    return NULL;
  switch (pattern960 (x3, 
E_TImode, 
E_DImode))
    {
    case 0:
      if (!(
#line 11085 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == DX_REG
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_115 (insn, operands);

    case 1:
      if (!(
#line 11107 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[3]) != DX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[0]))
   && (REGNO (operands[2]) == REGNO (operands[4])
       || REGNO (operands[2]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[2]))) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_117 (insn, operands);

    case 2:
      if (!general_reg_operand (operands[4], E_DImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (2));
      x7 = XVECEXP (x5, 0, 0);
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode)
        return NULL;
      x9 = XVECEXP (x5, 0, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case SMUL_HIGHPART:
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return NULL;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[0])
              || !(
#line 11246 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_120 (insn, operands);

        case UMUL_HIGHPART:
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return NULL;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[0])
              || !(
#line 11246 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_121 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      switch (pattern241 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern1197 (x2, 
E_HImode) != 0
                  || !
#line 26423 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_199 (insn, operands);

            case E_SImode:
              if (pattern1197 (x2, 
E_SImode) != 0
                  || !
#line 26423 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_200 (insn, operands);

            case E_DImode:
              if (pattern1197 (x2, 
E_DImode) != 0
                  || !(
#line 26423 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_201 (insn, operands);

            case E_SFmode:
              if (!general_reg_operand (operands[0], E_SFmode)
                  || pattern1260 (x2, 
E_SFmode) != 0
                  || !
#line 26675 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((SFmode != DFmode || TARGET_64BIT)
   && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_209 (insn, operands);

            case E_DFmode:
              if (!general_reg_operand (operands[0], E_DFmode)
                  || pattern1260 (x2, 
E_DFmode) != 0
                  || !
#line 26675 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((DFmode != DFmode || TARGET_64BIT)
   && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_210 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !ix86_comparison_operator (operands[1], E_VOIDmode))
            return NULL;
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x2, 2);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!nonimmediate_operand (operands[3], E_SImode)
              || !
#line 26453 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_202 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!general_reg_operand (operands[0], E_QImode)
          || !general_reg_operand (operands[1], E_QImode))
        return NULL;
      if (
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_19 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 3407 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_23 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[0], E_HImode)
          || !general_reg_operand (operands[1], E_HImode))
        return NULL;
      if (
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_20 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 3407 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_24 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[0], E_SImode)
          || !general_reg_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_21 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 3407 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_25 (insn, operands);

    case E_DImode:
      if (!general_reg_operand (operands[0], E_DImode)
          || !general_reg_operand (operands[1], E_DImode))
        return NULL;
      if ((
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_22 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!(
#line 3407 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_26 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (pattern229 (x4, 
E_CCmode, 
17) != 0)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return NULL;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!nonimmediate_operand (operands[2], E_HImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = XEXP (x7, 1);
  switch (GET_CODE (x9))
    {
    case ZERO_EXTEND:
      if (peep2_current_count < 4)
        return NULL;
      x10 = XEXP (x7, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_VOIDmode))
        return NULL;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1])
          || pattern1753 (x8) != 0)
        return NULL;
      x12 = XEXP (x8, 1);
      x13 = XEXP (x12, 0);
      x14 = XEXP (x13, 0);
      operands[4] = x14;
      if (!register_operand (operands[4], E_QImode))
        return NULL;
      x15 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x15) != SET)
        return NULL;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != IF_THEN_ELSE)
        return NULL;
      x17 = XEXP (x16, 0);
      if (!bt_comparison_operator (x17, E_VOIDmode))
        return NULL;
      operands[5] = x17;
      if (pattern1867 (x15) != 0)
        return NULL;
      x18 = XEXP (x16, 1);
      x19 = XEXP (x18, 0);
      operands[6] = x19;
      if (!
#line 22866 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[3]) == REGNO (operands[4])
   && peep2_reg_dead_p (3, operands[1])
   && peep2_reg_dead_p (3, operands[3])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_195 (insn, operands);

    case COMPARE:
      if (GET_MODE (x9) != E_CCZmode)
        return NULL;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_QImode)
        return NULL;
      x20 = XEXP (x11, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x21 = XEXP (x9, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCZmode)
        return NULL;
      x22 = XEXP (x11, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x12 = XEXP (x8, 1);
      if (GET_CODE (x12) != IF_THEN_ELSE)
        return NULL;
      x13 = XEXP (x12, 0);
      if (!bt_comparison_operator (x13, E_VOIDmode))
        return NULL;
      operands[4] = x13;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 17
          || GET_MODE (x14) != E_CCZmode)
        return NULL;
      x23 = XEXP (x13, 1);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x24 = XEXP (x12, 1);
      if (GET_CODE (x24) != LABEL_REF)
        return NULL;
      x25 = XEXP (x12, 2);
      if (GET_CODE (x25) != PC)
        return NULL;
      x26 = XEXP (x8, 0);
      if (GET_CODE (x26) != PC)
        return NULL;
      x27 = XEXP (x24, 0);
      operands[5] = x27;
      if (!
#line 22899 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[1]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (2, operands[3])
   && peep2_regno_dead_p (3, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_196 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case UNSPEC:
          if (XVECLEN (x2, 0) == 1
              && XINT (x2, 1) == 41
              && pattern57 (x1, 
E_CCCmode) == 0
              && 
#line 2136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SLOW_STC && !optimize_insn_for_size_p ()))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case COMPARE:
          res = peephole2_1 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case FLOAT_EXTEND:
          if (GET_MODE (x2) == E_DFmode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (sse_reg_operand (operands[0], E_DFmode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (memory_operand (operands[1], E_SFmode)
                      && 
#line 5388 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SPLIT_MEM_OPND_FOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_54 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          break;

        case FLOAT_TRUNCATE:
          if (GET_MODE (x2) == E_SFmode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (sse_reg_operand (operands[0], E_SFmode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (memory_operand (operands[1], E_DFmode)
                      && 
#line 5618 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SPLIT_MEM_OPND_FOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_55 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          break;

        case FIX:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case NE:
        case EQ:
          res = peephole2_3 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          res = peephole2_8 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case VEC_SELECT:
          res = peephole2_9 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      x3 = XEXP (x1, 0);
      switch (GET_MODE (x3))
        {
        case E_SImode:
          res = peephole2_14 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case E_DImode:
          res = peephole2_18 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (peep2_current_count >= 2)
        {
          res = peephole2_22 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[0] = x3;
      res = peephole2_26 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x2))
        {
        case BSWAP:
          if (GET_MODE (x2) == E_HImode)
            {
              operands[0] = x3;
              if (general_reg_operand (operands[0], E_HImode))
                {
                  x4 = XEXP (x2, 0);
                  if (rtx_equal_p (x4, operands[0])
                      && 
#line 22626 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_190 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          break;

        case IOR:
          res = peephole2_27 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case ZERO_EXTEND:
          res = peephole2_28 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case IF_THEN_ELSE:
          res = peephole2_29 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = peephole2_31 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x2;
          if (immediate_operand (operands[1], E_SImode))
            {
              operands[0] = x3;
              if (memory_operand (operands[0], E_SImode)
                  && 
#line 27818 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((SImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_261 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x3) == REG)
        {
          res = peephole2_33 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count >= 2)
        {
          res = peephole2_35 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[0] = x3;
      return peephole2_37 (x1, insn, pmatch_len_);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return peephole2_49 (x1, insn, pmatch_len_);

        case 6:
          if (peep2_current_count < 2
              || peep2_current_count < 3
              || peep2_current_count < 4
              || pattern35 (x1) != 0
              || !register_operand (operands[4], E_VOIDmode))
            return NULL;
          x5 = XVECEXP (x1, 0, 0);
          x6 = XEXP (x5, 1);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!register_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[6] = x10;
          if (!register_operand (operands[6], E_VOIDmode))
            return NULL;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[3] = x12;
          if (!immediate_operand (operands[3], E_SImode))
            return NULL;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x15 = XVECEXP (x1, 0, 4);
          x16 = XEXP (x15, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x17 = XVECEXP (x1, 0, 5);
          x18 = XEXP (x17, 0);
          operands[2] = x18;
          if (!register_operand (operands[2], E_VOIDmode))
            return NULL;
          x19 = PATTERN (peep2_next_insn (1));
          if (pattern1856 (x19) != 0
              || !
#line 26158 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (4, operands[7]) && peep2_reg_dead_p (4, operands[8])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_197 (insn, operands);

        case 5:
          if (peep2_current_count < 2
              || peep2_current_count < 3
              || peep2_current_count < 4)
            return NULL;
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != IF_THEN_ELSE
              || pattern230 (x1) != 0
              || !register_operand (operands[6], E_VOIDmode))
            return NULL;
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 0);
          x20 = XEXP (x8, 0);
          operands[4] = x20;
          if (!register_operand (operands[4], E_VOIDmode))
            return NULL;
          x21 = XEXP (x7, 1);
          x22 = XEXP (x21, 0);
          operands[5] = x22;
          if (!register_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!immediate_operand (operands[3], E_SImode))
            return NULL;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x15 = XVECEXP (x1, 0, 4);
          x16 = XEXP (x15, 0);
          operands[2] = x16;
          if (!register_operand (operands[2], E_VOIDmode))
            return NULL;
          x19 = PATTERN (peep2_next_insn (1));
          if (pattern1856 (x19) != 0
              || !
#line 26189 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(peep2_reg_dead_p (4, operands[7]) && peep2_reg_dead_p (4, operands[8])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_198 (insn, operands);

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != CLOBBER)
            return NULL;
          x6 = XEXP (x5, 1);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (peep2_current_count < 2
                  || XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 92)
                return NULL;
              x9 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x9) != SET)
                return NULL;
              x23 = XEXP (x9, 1);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 17
                  || GET_MODE (x12) != E_CCmode)
                return NULL;
              x24 = XEXP (x5, 0);
              operands[0] = x24;
              x25 = XVECEXP (x6, 0, 0);
              operands[1] = x25;
              x10 = XEXP (x9, 0);
              operands[2] = x10;
              if (!general_reg_operand (operands[2], E_VOIDmode))
                return NULL;
              x19 = PATTERN (peep2_next_insn (1));
              if (GET_CODE (x19) != SET)
                return NULL;
              x26 = XEXP (x19, 0);
              operands[3] = x26;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!memory_operand (operands[0], E_SImode)
                      || GET_MODE (x6) != E_SImode
                      || !memory_operand (operands[1], E_SImode))
                    return NULL;
                  x27 = XEXP (x19, 1);
                  operands[4] = x27;
                  if (const0_operand (operands[4], E_VOIDmode)
                      && general_reg_operand (operands[3], E_VOIDmode)
                      && (
#line 27439 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && GET_MODE_SIZE (GET_MODE (operands[3])) <= UNITS_PER_WORD
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_233 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_gr_operand (operands[4], E_SImode)
                      && general_reg_operand (operands[3], E_SImode)
                      && (
#line 27500 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_235 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_gr_operand (operands[4], E_DImode)
                      && general_reg_operand (operands[3], E_DImode)
                      && (
#line 27500 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_236 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (address_no_seg_operand (operands[4], E_SImode)
                      && general_reg_operand (operands[3], E_SImode)
                      && (
#line 27555 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_243 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (address_no_seg_operand (operands[4], E_DImode)
                      && general_reg_operand (operands[3], E_DImode)
                      && (
#line 27555 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_244 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!general_reg_operand (operands[3], E_DImode))
                    return NULL;
                  switch (pattern1782 (x27))
                    {
                    case 0:
                      if (!(
#line 27604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_247 (insn, operands);

                    case 1:
                      if (!(
#line 27604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_248 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_DImode:
                  if (!memory_operand (operands[0], E_DImode)
                      || GET_MODE (x6) != E_DImode
                      || !memory_operand (operands[1], E_DImode))
                    return NULL;
                  x27 = XEXP (x19, 1);
                  operands[4] = x27;
                  if (const0_operand (operands[4], E_VOIDmode)
                      && general_reg_operand (operands[3], E_VOIDmode)
                      && (
#line 27439 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && GET_MODE_SIZE (GET_MODE (operands[3])) <= UNITS_PER_WORD
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_234 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_gr_operand (operands[4], E_SImode)
                      && general_reg_operand (operands[3], E_SImode)
                      && (
#line 27500 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_237 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_gr_operand (operands[4], E_DImode)
                      && general_reg_operand (operands[3], E_DImode)
                      && (
#line 27500 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_238 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (address_no_seg_operand (operands[4], E_SImode)
                      && general_reg_operand (operands[3], E_SImode)
                      && (
#line 27555 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_245 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (address_no_seg_operand (operands[4], E_DImode)
                      && general_reg_operand (operands[3], E_DImode)
                      && (
#line 27555 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_246 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!general_reg_operand (operands[3], E_DImode))
                    return NULL;
                  switch (pattern1782 (x27))
                    {
                    case 0:
                      if (!(
#line 27604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_249 (insn, operands);

                    case 1:
                      if (!(
#line 27604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_250 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case PLUS:
              if (pattern414 (x5) != 0)
                return NULL;
              x9 = XVECEXP (x1, 0, 1);
              if (pattern229 (x9, 
E_CCmode, 
17) != 0)
                return NULL;
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != MEM
                  || GET_MODE (x12) != E_BLKmode)
                return NULL;
              x28 = XEXP (x12, 0);
              if (GET_CODE (x28) != SCRATCH)
                return NULL;
              switch (pattern1446 (x5))
                {
                case 0:
                  if ((
#line 28605 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_347 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28605 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_348 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28619 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_351 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28619 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_352 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28661 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_363 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28661 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_364 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28676 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_367 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28676 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_368 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28689 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_371 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!(
#line 28689 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_372 (insn, operands);

                case 1:
                  if ((
#line 28605 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_349 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28605 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_350 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28619 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_353 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28619 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_354 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28661 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_365 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28661 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_366 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28676 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_369 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28676 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_370 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28689 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_373 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!(
#line 28689 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_374 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
